// By Martin Nilsson

// Updated 2017-03-05 from http://www.iana.org/domains/root/db/

#pike __REAL_VERSION__

//! A mapping between country TLDs and the name of the country.
constant cc = ([
  "ac": "Ascension Island",
  "ad": "Andorra",
  "ae": "United Arab Emirates",
  "af": "Afghanistan",
  "ag": "Antigua and Barbuda",
  "ai": "Anguilla",
  "al": "Albania",
  "am": "Armenia",
  "an": "Netherlands Antilles",
  "ao": "Angola",
  "aq": "Antarctica",
  "ar": "Argentina",
  "as": "American Samoa",
  "at": "Austria",
  "au": "Australia",
  "aw": "Aruba",
  "ax": "Aland Islands",
  "az": "Azerbaijan",
  "ba": "Bosnia and Herzegovina",
  "bb": "Barbados",
  "bd": "Bangladesh",
  "be": "Belgium",
  "bf": "Burkina Faso",
  "bg": "Bulgaria",
  "bh": "Bahrain",
  "bi": "Burundi",
  "bj": "Benin",
  "bl": "Saint Barthelemy",
  "bm": "Bermuda",
  "bn": "Brunei Darussalam",
  "bo": "Bolivia",
  "br": "Brazil",
  "bs": "Bahamas",
  "bt": "Bhutan",
  "bv": "Bouvet Island",
  "bw": "Botswana",
  "by": "Belarus",
  "bz": "Belize",
  "ca": "Canada",
  "cc": "Cocos (Keeling) Islands",
  "cd": "Congo, The Democratic Republic of the",
  "cf": "Central African Republic",
  "cg": "Congo, Republic of",
  "ch": "Switzerland",
  "ci": "Cote d'Ivoire",
  "ck": "Cook Islands",
  "cl": "Chile",
  "cm": "Cameroon",
  "cn": "China",
  "co": "Colombia",
  "cr": "Costa Rica",
  "cs": "Serbia and Montenegro", // Deprecated
  "cu": "Cuba",
  "cv": "Cape Verde",
  "cw": "Curacao",
  "cx": "Christmas Island",
  "cy": "Cyprus",
  "cz": "Czech Republic",
  "de": "Germany",
  "dj": "Djibouti",
  "dk": "Denmark",
  "dm": "Dominica",
  "do": "Dominican Republic",
  "dz": "Algeria",
  "ec": "Ecuador",
  "ee": "Estonia",
  "eg": "Egypt",
  "eh": "Western Sahara",
  "er": "Eritrea",
  "es": "Spain",
  "et": "Ethiopia",
  "eu": "European Union",
  "fi": "Finland",
  "fj": "Fiji",
  "fk": "Falkland Islands (Malvinas)",
  "fm": "Micronesia, Federal State of",
  "fo": "Faroe Islands",
  "fr": "France",
  "ga": "Gabon",
  "gb": "United Kingdom",
  "gd": "Grenada",
  "ge": "Georgia",
  "gf": "French Guiana",
  "gg": "Guernsey",
  "gh": "Ghana",
  "gi": "Gibraltar",
  "gl": "Greenland",
  "gm": "Gambia",
  "gn": "Guinea",
  "gp": "Guadeloupe",
  "gq": "Equatorial Guinea",
  "gr": "Greece",
  "gs": "South Georgia and the South Sandwich Islands",
  "gt": "Guatemala",
  "gu": "Guam",
  "gw": "Guinea-Bissau",
  "gy": "Guyana",
  "hk": "Hong Kong",
  "hm": "Heard and McDonald Islands",
  "hn": "Honduras",
  "hr": "Croatia/Hrvatska",
  "ht": "Haiti",
  "hu": "Hungary",
  "id": "Indonesia",
  "ie": "Ireland",
  "il": "Israel",
  "im": "Isle of Man",
  "in": "India",
  "io": "British Indian Ocean Territory",
  "iq": "Iraq",
  "ir": "Iran, Islamic Republic of",
  "is": "Iceland",
  "it": "Italy",
  "je": "Jersey",
  "jm": "Jamaica",
  "jo": "Jordan",
  "jp": "Japan",
  "ke": "Kenya",
  "kg": "Kyrgyzstan",
  "kh": "Cambodia",
  "ki": "Kiribati",
  "km": "Comoros",
  "kn": "Saint Kitts and Nevis",
  "kp": "Korea, Democratic People's Republic",
  "kr": "Korea, Republic of",
  "kw": "Kuwait",
  "ky": "Cayman Islands",
  "kz": "Kazakhstan",
  "la": "Lao People's Democratic Republic",
  "lb": "Lebanon",
  "lc": "Saint Lucia",
  "li": "Liechtenstein",
  "lk": "Sri Lanka",
  "lr": "Liberia",
  "ls": "Lesotho",
  "lt": "Lithuania",
  "lu": "Luxembourg",
  "lv": "Latvia",
  "ly": "Libyan Arab Jamahiriya",
  "ma": "Morocco",
  "mc": "Monaco",
  "md": "Moldova, Republic of",
  "me": "Montenegro",
  "mf": "Saint Martin",
  "mg": "Madagascar",
  "mh": "Marshall Islands",
  "mk": "Macedonia, The Former Yugoslav Republic of",
  "ml": "Mali",
  "mm": "Myanmar",
  "mn": "Mongolia",
  "mo": "Macau",
  "mp": "Northern Mariana Islands",
  "mq": "Martinique",
  "mr": "Mauritania",
  "ms": "Montserrat",
  "mt": "Malta",
  "mu": "Mauritius",
  "mv": "Maldives",
  "mw": "Malawi",
  "mx": "Mexico",
  "my": "Malaysia",
  "mz": "Mozambique",
  "na": "Namibia",
  "nc": "New Caledonia",
  "ne": "Niger",
  "nf": "Norfolk Island",
  "ng": "Nigeria",
  "ni": "Nicaragua",
  "nl": "Netherlands",
  "no": "Norway",
  "np": "Nepal",
  "nr": "Nauru",
  "nu": "Niue",
  "nz": "New Zealand",
  "om": "Oman",
  "pa": "Panama",
  "pe": "Peru",
  "pf": "French Polynesia",
  "pg": "Papua New Guinea",
  "ph": "Philippines",
  "pk": "Pakistan",
  "pl": "Poland",
  "pm": "Saint Pierre and Miquelon",
  "pn": "Pitcairn Island",
  "pr": "Puerto Rico",
  "ps": "Palestinian Territories",
  "pt": "Portugal",
  "pw": "Palau",
  "py": "Paraguay",
  "qa": "Qatar",
  "re": "Reunion Island",
  "ro": "Romania",
  "rs": "Serbia",
  "ru": "Russian Federation",
  "rw": "Rwanda",
  "sa": "Saudi Arabia",
  "sb": "Solomon Islands",
  "sc": "Seychelles",
  "sd": "Sudan",
  "se": "Sweden",
  "sg": "Singapore",
  "sh": "Saint Helena",
  "si": "Slovenia",
  "sj": "Svalbard and Jan Mayen Islands",
  "sk": "Slovak Republic",
  "sl": "Sierra Leone",
  "sm": "San Marino",
  "sn": "Senegal",
  "so": "Somalia",
  "sr": "Suriname",
  "st": "Sao Tome and Principe",
  "su": "Soviet Union", // Deprecated // Revived...
  "sv": "El Salvador",
  "sy": "Syrian Arab Republic",
  "sx": "Sint Maarten",
  "sz": "Swaziland",
  "tc": "Turks and Caicos Islands",
  "td": "Chad",
  "tf": "French Southern Territories",
  "tg": "Togo",
  "th": "Thailand",
  "tj": "Tajikistan",
  "tk": "Tokelau",
  "tl": "Timor-Leste",
  "tm": "Turkmenistan",
  "tn": "Tunisia",
  "to": "Tonga",
  "tp": "East Timor",
  "tr": "Turkey",
  "tt": "Trinidad and Tobago",
  "tv": "Tuvalu",
  "tw": "Taiwan",
  "tz": "Tanzania",
  "ua": "Ukraine",
  "ug": "Uganda",
  "uk": "United Kingdom",
  "um": "United States Minor Outlying Islands",
  "us": "United States",
  "uy": "Uruguay",
  "uz": "Uzbekistan",
  "va": "Holy See (Vatican City State)",
  "vc": "Saint Vincent and the Grenadines",
  "ve": "Venezuela",
  "vg": "Virgin Islands, British",
  "vi": "Virgin Islands, U.S.",
  "vn": "Vietnam",
  "vu": "Vanuatu",
  "wf": "Wallis and Futuna Islands",
  "ws": "Samoa",
  "ye": "Yemen",
  "yt": "Mayotte",
  "yu": "Yugoslavia", // Deprecated
  "za": "South Africa",
  "zm": "Zambia",
  "zw": "Zimbabwe"
]);

//! A multiset containing the generic TLDs, such as "com" and "info".
multiset generic = (<
  "aero",
  "arpa",
  "asia",
  "biz",
  "cat",
  "com",
  "coop",
  "edu",
  "gov",
  "info",
  "int",
  "jobs",
  "mil",
  "mobi",
  "museum",
  "name",
  "net",
  "org",
  "pro",
  "tel",
  "travel",
>);

#ifdef UPDATE
void main()
{
  multiset new_generic = (<>);
  mapping new_cctld = ([]);
  string page = Protocols.HTTP.get_url_nice("http://www.iana.org/domains/root/db")[1];
  Parser.HTML p = Parser.HTML();
  array tds = ({});
  p->add_tag("tr") {
    tds = ({});
  };
  p->add_container("td", lambda(Parser.HTML p, mapping m, string c)
    {
      tds += ({ c });
      if( sizeof(tds)==3 )
      {
        sscanf(tds[0], "%*s>.%s<", tds[0]);
        sscanf(tds[0], "%*s>&#x200f;.%s&#200e;<", tds[0]);

        switch(tds[1])
        {
        case "generic":
          new_generic[tds[0]]=1;
          break;
        case "country-code":
          new_cctld[tds[0]]=tds[2];
          break;
        }
      }
    });
  p->finish(page);

  //  foreach(new_cctld; string domain;)
  //    if(!cc[domain]) write("Missing cctld %O\n", domain);
  //  foreach(cc; string domain;)
  //    if(!new_cctld[domain]) write("Removed cctld %O\n", domain);
  //  foreach(new_generic; string domain;)
  //    if(!generic[domain]) write("Missing generic %O\n", domain);
}
#endif
