/* Generated from "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod" by precompile.pike running Pike v8.0 release 702
 *
 * Do NOT edit this file.
 */

#undef PRECOMPILE_API_VERSION
#define PRECOMPILE_API_VERSION 6



#undef cmod___CMOD__
#define cmod___CMOD__ 1
#line 1 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
#line 1 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
#line 1 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
#line 3581 "/space/www/pikefarm/out_work/master/lib/modules/Tools.pmod/Standalone.pmod/precompile.pike"








#line 3589 "/space/www/pikefarm/out_work/master/lib/modules/Tools.pmod/Standalone.pmod/precompile.pike"
#line 1 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
#line 1 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
/* -*- c -*-
|| This file is part of Pike. For copyright information see COPYRIGHT.
|| Pike is distributed under GPL, LGPL and MPL. See the file COPYING
|| for more information.
*/

/*! @module Oracle
 *!
 *! Pike interface to Oracle databases.
 *!
 *! @thanks
 *!   Original design by Marcus Comstedt.
 *!
 *!   Re-written for Oracle 8.x and later by Fredrik Hubinette.
 *!
 *!   Re-structured into a CMOD by Henrik Grubbstrm.
 */

/*
 * Includes
 */

#include "config.h"
#include "module.h"

#include "interpret.h"
#include "operators.h"
#include "pike_compiler.h"
#include "pike_types.h"
#include "threads.h"
#include "module_support.h"
#include "builtin_functions.h"
#include "pike_macros.h"
#include "version.h"
#include "pike_embed.h"


#ifdef HAVE_ORACLE

/* VERY VERY UGLY */
#define MOTIF

#ifdef HAVE_OCI_H
#include <oci.h>
#else /* !HAVE_OCI_H */
#include <ocidfn.h>
#include <ociapr.h>
#endif /* HAVE_OCI_H */

#include <math.h>

/* User-changable defines: */

#define BLOB_FETCH_CHUNK 16384

/* #define ORACLE_DEBUG */

/* Undefining this if you don't want pike
 * muexes protecting everything
 */
#define ORACLE_USE_THREADS

/* Define this to zero if you don't want
 * oracle internal mutexes
 */
#define ORACLE_INIT_FLAGS OCI_THREADED

/* This define puts a mutex around the connect calls */
#define SERIALIZE_CONNECT

/* Define This if you want one environment for each
 * database connection. (This crashes for me - Hubbe)
 */
/* #define LOCAL_ENV */

/* #define REUSE_DEFINES */

/*
 * This define cripples the Pike module to use static define buffers.
 * It may be required to work around bugs in some versions of the
 * oracle libraries - Hubbe
 *
 * Note: Some versions of Oracle fail with
 *   "ORA-03106: fatal two-task communication protocolerror"
 *   This seems to be due to having an invalid NLS_LANG on
 *   the server. -Grubba 2005-08-05
 */

/* For some reason this crashes if I make this larger than 8000
 * I suspect a static buffer somewhere in Oracle, but I have no proof.
 * -Hubbe
 *
 * One possible cause could be running out of stack in
 * f_TypedResult_create() due to the old struct bind_block
 * being huge. I haven't tried raising the limit since shrinking
 * struct bind_block.
 * -Grubba 2005-08-04
 */

#define STATIC_BUFFERS 8000

/* This define causes dynamically sized data to be fetched via the polling
 * API rather than by the callback API. Using the polling API has the
 * advantage of allowing the OCIStmtFetch call being run in a
 * THREADS_ALLOW() context.
 * NOTE: Ignored if STATIC_BUFFERS above is enabled.
 */

/* #define POLLING_FETCH */

/* End user-changable defines */


#ifndef ORACLE_USE_THREADS

#undef THREADS_ALLOW
#define THREADS_ALLOW()
#undef THREADS_DISALLOW
#define THREADS_DISALLOW()

#endif

#define BLOCKSIZE 8192

#define IS_SUCCESS(RES) ((RES == OCI_SUCCESS) || (RES == OCI_SUCCESS_WITH_INFO))

#if defined(SERIALIZE_CONNECT)
DEFINE_MUTEX(oracle_serialization_mutex);
#endif

#define ORACLE_UNICODE_ENCODE(X) do {		\
    if(X) {					\
      /* NB: X is usually owned by the stack.	\
       */					\
      ref_push_string(X);			\
      push_int(2);				\
      f_string_to_unicode(2);			\
      (X) = Pike_sp[-1].u.string;		\
      /* Note: The string is left on the stack	\
       *       to simplify error handling.	\
       */					\
      args++;					\
    }						\
  } while(0)
#define ORACLE_UNICODE_DECODE(X) do {		\
    if(X) {					\
      /* NB: Steals a reference to X. */	\
      push_string(X);				\
      X = NULL;					\
      push_int(2);				\
      f_unicode_to_string(2);			\
      add_ref((X) = Pike_sp[-1].u.string);	\
      pop_stack();				\
    }						\
  } while(0)

#ifdef ORACLE_DEBUG
#define LOCK(X) do { \
   fprintf(stderr,"Locking  " #X " ...  from %s:%d\n",__FUNCTION__,__LINE__); \
   mt_lock( & (X) ); \
   fprintf(stderr,"Locking  " #X " done from %s:%d\n",__FUNCTION__,__LINE__); \
}while(0)

#define UNLOCK(X) do { \
   fprintf(stderr,"unocking " #X "      from %s:%d\n",__FUNCTION__,__LINE__); \
   mt_unlock( & (X) ); \
}while(0)

#define OWERR(...) WERR(__VA_ARGS__)

#else
#define LOCK(X) mt_lock( & (X) );
#define UNLOCK(X) mt_unlock( & (X) );
#define OWERR(...)
#endif

#define STRING_BUILDER_STR(X) ((X).s)
#define STRING_BUILDER_LEN(X) ((X).s->len)
#include "bignum.h"

#ifndef Pike_thread_id
#define Pike_thread_id thread_id
#endif

#ifndef CHECK_INTERPRETER_LOCK
#define CHECK_INTERPRETER_LOCK()
#endif


#ifndef CURRENT_STORAGE
#define CURRENT_STORAGE (Pike_fp->current_storage)
#endif

#ifdef DEBUG_MALLOC
#define THISOBJ dmalloc_touch(struct pike_frame *,Pike_fp)->current_object
#else
#define THISOBJ (Pike_fp->current_object)
#endif


#ifdef PARENT_INFO
#define PARENTOF(X) PARENT_INFO(X)->parent
#else
#define PARENTOF(X) (X)->parent
#endif

#if 0

void *ocimalloc (void *ctx, size_t l)
{
return malloc (l);
}

void *ocirealloc (void *ctx, void *p, size_t l)
{
return realloc (p, l);
}

void ocifree (void *ctx, void *p)
{
free (p);
}

#else

#define ocimalloc NULL
#define ocirealloc NULL
#define ocifree NULL

#endif

#ifdef PIKE_DEBUG
void *low_check_storage(void *storage, unsigned long magic, char *prog)
{
if( storage && magic != *((unsigned long *)storage))
{
fprintf(stderr, "Wrong magic number! expected a %s\n",prog);
fprintf(stderr, "Expected %lx, got %lx\n",magic,*((unsigned long *)storage));
Pike_fatal("Wrong program, expected %s!\n",prog);
}
return storage;
}
#ifdef DEBUG_MALLOC
#define check_storage(X,Y,Z) (debug_malloc_touch(THISOBJ),low_check_storage((X),(Y),(Z)))
#else
#define check_storage(X,Y,Z) (X)
#endif
#else
#define check_storage(X,Y,Z) (X)
#endif

#define STORAGE(O) ((O)->storage + (O)->prog->inherits[0].storage_offset)
#define DBNULL_MAGIC	0xdb004711UL
#define DBCON_MAGIC	0xdbc04711UL
#define DBQUERY_MAGIC	0xdb994711UL
#define DBRESULT_MAGIC	0xdbe04711UL
#define DBRESINFO_MAGIC	0xdbe14711UL
#define DBLOB_MAGIC	0xdb104711UL
#define DBDATE_MAGIC	0xdbda4711UL
#define DBTS_MAGIC	0xdb754711UL
#define THIS_DBCON ((struct Oracle_oracle_struct *)check_storage(CURRENT_STORAGE,DBCON_MAGIC,"dbcon"))
#define THIS_QUERY_DBCON ((struct Oracle_oracle_struct *)check_storage(parent_storage(1, Oracle_oracle_program),DBCON_MAGIC,"dbcon"))
#define THIS_RESULT_DBCON ((struct Oracle_oracle_struct *)check_storage(parent_storage(2, Oracle_oracle_program),DBCON_MAGIC,"dbcon"))
#define THIS_QUERY ((struct Oracle_oracle_compile_query_struct *)check_storage(CURRENT_STORAGE,DBQUERY_MAGIC,"dbquery"))
#define THIS_RESULT_QUERY ((struct Oracle_oracle_compile_query_struct *)check_storage(parent_storage(1, Oracle_oracle_compile_query_program),DBQUERY_MAGIC,"dbquery"))
#define THIS_RESULT ((struct Oracle_oracle_compile_query_TypedResult_struct *)check_storage(CURRENT_STORAGE,DBRESULT_MAGIC,"dbresult"))
#define THIS_RESULTINFO ((struct Oracle_oracle_compile_query_dbresultinfo_struct *)check_storage(CURRENT_STORAGE,DBRESINFO_MAGIC,"dbresultinfo"))
#define THIS_DBLOB ((struct Oracle_oracle_LOB_struct *)check_storage(CURRENT_STORAGE,DBLOB_MAGIC,"dblob"))
#define THIS_DBDATE ((struct Oracle_oracle_Date_struct *)check_storage(CURRENT_STORAGE,DBDATE_MAGIC,"dbdate"))
#define THIS_DBNULL ((struct Oracle_oracle_NULL_struct *)check_storage(CURRENT_STORAGE,DBNULL_MAGIC,"dbnull"))

static struct object *nullstring_object;
static struct object *nullfloat_object;
static struct object *nullint_object;
static struct object *nulldate_object;



#ifndef PIKE_UNUSED_ATTRIBUTE
#define PIKE_UNUSED_ATTRIBUTE
#endif
#define CMOD_MAP_PROGRAM_IDS_DEFINED 1
static int ___cmod_map_program_ids(int id) PIKE_UNUSED_ATTRIBUTE;
#ifndef TYPEOF
/* Compat with older Pikes. */
#define TYPEOF(SVAL)	((SVAL).type)
#define SUBTYPEOF(SVAL)	((SVAL).subtype)
#define SET_SVAL_TYPE(SVAL, TYPE)	(TYPEOF(SVAL) = TYPE)
#define SET_SVAL_SUBTYPE(SVAL, TYPE)	(SUBTYPEOF(SVAL) = TYPE)
#define SET_SVAL(SVAL, TYPE, SUBTYPE, FIELD, EXPR) do {	\
    /* Set the type afterwards to avoid a clobbered	\
     * svalue in case EXPR throws. */			\
    (SVAL).u.FIELD = (EXPR);				\
    SET_SVAL_TYPE((SVAL), (TYPE));			\
    SET_SVAL_SUBTYPE((SVAL), (SUBTYPE));		\
  } while(0)
#endif /* !TYPEOF */
#ifndef PIKE_UNUSED
/* Compat with Pike 7.8 and earlier. */
/* NB: Not strictly correct; PIKE_UNUSED was added the
 *     day after set_program_id_to_id(), but good enough.
 */
#ifndef UNUSED
#define UNUSED(X)	X
#endif
#ifndef set_program_id_to_id
/* NB: Recent Pike 7.8 has a #define that conflicts with
 *     the following declaration.
 */
static void set_program_id_to_id(void*UNUSED(id)){}
#endif
#else /* */
PMOD_EXPORT void set_program_id_to_id( int (*to)(int) );
#endif /* !PIKE_UNUSED */
#if !defined(string_has_null) && !defined(STRING_CONTENT_CHECKED)
/* This symbol was added as a macro in Pike 7.7.20, and is an
 * inline function in Pike 7.9.4 and later, at which time the
 * flag STRING_CONTENT_CHECKED was added.
 */
#define string_has_null(X) (strlen((X)->str)!=(size_t)(X)->len)
#endif


#ifndef DEFAULT_CMOD_STORAGE
#define CMOD_COND_USED
#define DEFAULT_CMOD_STORAGE static
#endif
#define module_strings_declared
static struct pike_string *module_strings[2] = {
  NULL,
  NULL,
};
#define f_Oracle_oracle_Date_cq__sprintf_fun_num_used 1
#define f_Oracle_oracle_LOB_read_fun_num_used 1
#ifndef CMOD_COND_USED
# define Oracle_oracle_Date_program_fun_num_used 1
# define Oracle_oracle_LOB_program_fun_num_used 1
# define Oracle_oracle_NULL_program_fun_num_used 1
# define Oracle_oracle_compile_query_TypedResult_cq__22__builtin_2ESql_2EResult_22_inh_offset_used 1
# define Oracle_oracle_compile_query_TypedResult_cq__22__builtin_2ESql_2EResult_22_inh_storage_offset_used 1
# define Oracle_oracle_compile_query_TypedResult_program_fun_num_used 1
# define Oracle_oracle_compile_query_dbresultinfo_program_fun_num_used 1
# define Oracle_oracle_compile_query_program_fun_num_used 1
# define Oracle_oracle_cq__22__builtin_2ESql_2EConnection_22_inh_offset_used 1
# define Oracle_oracle_cq__22__builtin_2ESql_2EConnection_22_inh_storage_offset_used 1
# define Oracle_oracle_program_fun_num_used 1
# define f_Oracle_oracle_Date_cast_fun_num_used 1
# define f_Oracle_oracle_Date_create_fun_num_used 1
# define f_Oracle_oracle_LOB_cast_fun_num_used 1
# define f_Oracle_oracle_LOB_cq__sprintf_fun_num_used 1
# define f_Oracle_oracle_LOB_write_fun_num_used 1
# define f_Oracle_oracle_NULL_cq__backtick_eq_eq_fun_num_used 1
# define f_Oracle_oracle_NULL_cq__sprintf_fun_num_used 1
# define f_Oracle_oracle_NULL_create_fun_num_used 1
# define f_Oracle_oracle_commit_fun_num_used 1
# define f_Oracle_oracle_compile_query_TypedResult_create_fun_num_used 1
# define f_Oracle_oracle_compile_query_TypedResult_eof_fun_num_used 1
# define f_Oracle_oracle_compile_query_TypedResult_fetch_fields_fun_num_used 1
# define f_Oracle_oracle_compile_query_TypedResult_fetch_row_fun_num_used 1
# define f_Oracle_oracle_compile_query_TypedResult_num_fields_fun_num_used 1
# define f_Oracle_oracle_compile_query_TypedResult_num_rows_fun_num_used 1
# define f_Oracle_oracle_compile_query_create_fun_num_used 1
# define f_Oracle_oracle_create_fun_num_used 1
#else /* !CMOD_COND_USED */
# undef Oracle_oracle_Date_program_fun_num_used
# undef Oracle_oracle_LOB_program_fun_num_used
# undef Oracle_oracle_NULL_program_fun_num_used
# undef Oracle_oracle_compile_query_TypedResult_cq__22__builtin_2ESql_2EResult_22_inh_offset_used
# undef Oracle_oracle_compile_query_TypedResult_cq__22__builtin_2ESql_2EResult_22_inh_storage_offset_used
# undef Oracle_oracle_compile_query_TypedResult_program_fun_num_used
# undef Oracle_oracle_compile_query_dbresultinfo_program_fun_num_used
# undef Oracle_oracle_compile_query_program_fun_num_used
# undef Oracle_oracle_cq__22__builtin_2ESql_2EConnection_22_inh_offset_used
# undef Oracle_oracle_cq__22__builtin_2ESql_2EConnection_22_inh_storage_offset_used
# undef Oracle_oracle_program_fun_num_used
# undef f_Oracle_oracle_Date_cast_fun_num_used
# undef f_Oracle_oracle_Date_create_fun_num_used
# undef f_Oracle_oracle_LOB_cast_fun_num_used
# undef f_Oracle_oracle_LOB_cq__sprintf_fun_num_used
# undef f_Oracle_oracle_LOB_write_fun_num_used
# undef f_Oracle_oracle_NULL_cq__backtick_eq_eq_fun_num_used
# undef f_Oracle_oracle_NULL_cq__sprintf_fun_num_used
# undef f_Oracle_oracle_NULL_create_fun_num_used
# undef f_Oracle_oracle_commit_fun_num_used
# undef f_Oracle_oracle_compile_query_TypedResult_create_fun_num_used
# undef f_Oracle_oracle_compile_query_TypedResult_eof_fun_num_used
# undef f_Oracle_oracle_compile_query_TypedResult_fetch_fields_fun_num_used
# undef f_Oracle_oracle_compile_query_TypedResult_fetch_row_fun_num_used
# undef f_Oracle_oracle_compile_query_TypedResult_num_fields_fun_num_used
# undef f_Oracle_oracle_compile_query_TypedResult_num_rows_fun_num_used
# undef f_Oracle_oracle_compile_query_create_fun_num_used
# undef f_Oracle_oracle_create_fun_num_used
#endif /* !CMOD_COND_USED */

#ifdef f_Oracle_oracle_LOB_cq__sprintf_fun_num_used
DEFAULT_CMOD_STORAGE ptrdiff_t f_Oracle_oracle_LOB_cq__sprintf_fun_num = -1;

#endif /* f_Oracle_oracle_LOB_cq__sprintf_fun_num_used */

#ifdef f_Oracle_oracle_LOB_read_fun_num_used
DEFAULT_CMOD_STORAGE ptrdiff_t f_Oracle_oracle_LOB_read_fun_num = -1;

#endif /* f_Oracle_oracle_LOB_read_fun_num_used */

#ifdef f_Oracle_oracle_LOB_cast_fun_num_used
DEFAULT_CMOD_STORAGE ptrdiff_t f_Oracle_oracle_LOB_cast_fun_num = -1;

#endif /* f_Oracle_oracle_LOB_cast_fun_num_used */

#ifdef f_Oracle_oracle_LOB_write_fun_num_used
DEFAULT_CMOD_STORAGE ptrdiff_t f_Oracle_oracle_LOB_write_fun_num = -1;

#endif /* f_Oracle_oracle_LOB_write_fun_num_used */
DEFAULT_CMOD_STORAGE struct program *Oracle_oracle_LOB_program=NULL;

#ifdef Oracle_oracle_LOB_program_fun_num_used
DEFAULT_CMOD_STORAGE int Oracle_oracle_LOB_program_fun_num=-1;
#endif /* Oracle_oracle_LOB_program_fun_num_used */

#ifdef f_Oracle_oracle_Date_create_fun_num_used
DEFAULT_CMOD_STORAGE ptrdiff_t f_Oracle_oracle_Date_create_fun_num = -1;

#endif /* f_Oracle_oracle_Date_create_fun_num_used */

#ifdef f_Oracle_oracle_Date_cq__sprintf_fun_num_used
DEFAULT_CMOD_STORAGE ptrdiff_t f_Oracle_oracle_Date_cq__sprintf_fun_num = -1;

#endif /* f_Oracle_oracle_Date_cq__sprintf_fun_num_used */

#ifdef f_Oracle_oracle_Date_cast_fun_num_used
DEFAULT_CMOD_STORAGE ptrdiff_t f_Oracle_oracle_Date_cast_fun_num = -1;

#endif /* f_Oracle_oracle_Date_cast_fun_num_used */
DEFAULT_CMOD_STORAGE struct program *Oracle_oracle_Date_program=NULL;

#ifdef Oracle_oracle_Date_program_fun_num_used
DEFAULT_CMOD_STORAGE int Oracle_oracle_Date_program_fun_num=-1;
#endif /* Oracle_oracle_Date_program_fun_num_used */

#ifdef f_Oracle_oracle_NULL_create_fun_num_used
DEFAULT_CMOD_STORAGE ptrdiff_t f_Oracle_oracle_NULL_create_fun_num = -1;

#endif /* f_Oracle_oracle_NULL_create_fun_num_used */

#ifdef f_Oracle_oracle_NULL_cq__sprintf_fun_num_used
DEFAULT_CMOD_STORAGE ptrdiff_t f_Oracle_oracle_NULL_cq__sprintf_fun_num = -1;

#endif /* f_Oracle_oracle_NULL_cq__sprintf_fun_num_used */

#ifdef f_Oracle_oracle_NULL_cq__backtick_eq_eq_fun_num_used
DEFAULT_CMOD_STORAGE ptrdiff_t f_Oracle_oracle_NULL_cq__backtick_eq_eq_fun_num = -1;

#endif /* f_Oracle_oracle_NULL_cq__backtick_eq_eq_fun_num_used */
DEFAULT_CMOD_STORAGE struct program *Oracle_oracle_NULL_program=NULL;

#ifdef Oracle_oracle_NULL_program_fun_num_used
DEFAULT_CMOD_STORAGE int Oracle_oracle_NULL_program_fun_num=-1;
#endif /* Oracle_oracle_NULL_program_fun_num_used */
DEFAULT_CMOD_STORAGE struct program *Oracle_oracle_compile_query_dbresultinfo_program=NULL;

#ifdef Oracle_oracle_compile_query_dbresultinfo_program_fun_num_used
DEFAULT_CMOD_STORAGE int Oracle_oracle_compile_query_dbresultinfo_program_fun_num=-1;
#endif /* Oracle_oracle_compile_query_dbresultinfo_program_fun_num_used */

#ifdef f_Oracle_oracle_compile_query_TypedResult_num_rows_fun_num_used
DEFAULT_CMOD_STORAGE ptrdiff_t f_Oracle_oracle_compile_query_TypedResult_num_rows_fun_num = -1;

#endif /* f_Oracle_oracle_compile_query_TypedResult_num_rows_fun_num_used */

#ifdef f_Oracle_oracle_compile_query_TypedResult_num_fields_fun_num_used
DEFAULT_CMOD_STORAGE ptrdiff_t f_Oracle_oracle_compile_query_TypedResult_num_fields_fun_num = -1;

#endif /* f_Oracle_oracle_compile_query_TypedResult_num_fields_fun_num_used */

#ifdef f_Oracle_oracle_compile_query_TypedResult_fetch_fields_fun_num_used
DEFAULT_CMOD_STORAGE ptrdiff_t f_Oracle_oracle_compile_query_TypedResult_fetch_fields_fun_num = -1;

#endif /* f_Oracle_oracle_compile_query_TypedResult_fetch_fields_fun_num_used */

#ifdef f_Oracle_oracle_compile_query_TypedResult_eof_fun_num_used
DEFAULT_CMOD_STORAGE ptrdiff_t f_Oracle_oracle_compile_query_TypedResult_eof_fun_num = -1;

#endif /* f_Oracle_oracle_compile_query_TypedResult_eof_fun_num_used */

#ifdef f_Oracle_oracle_compile_query_TypedResult_fetch_row_fun_num_used
DEFAULT_CMOD_STORAGE ptrdiff_t f_Oracle_oracle_compile_query_TypedResult_fetch_row_fun_num = -1;

#endif /* f_Oracle_oracle_compile_query_TypedResult_fetch_row_fun_num_used */

#ifdef f_Oracle_oracle_compile_query_TypedResult_create_fun_num_used
DEFAULT_CMOD_STORAGE ptrdiff_t f_Oracle_oracle_compile_query_TypedResult_create_fun_num = -1;

#endif /* f_Oracle_oracle_compile_query_TypedResult_create_fun_num_used */
DEFAULT_CMOD_STORAGE struct program *Oracle_oracle_compile_query_TypedResult_program=NULL;

#ifdef Oracle_oracle_compile_query_TypedResult_program_fun_num_used
DEFAULT_CMOD_STORAGE int Oracle_oracle_compile_query_TypedResult_program_fun_num=-1;
#endif /* Oracle_oracle_compile_query_TypedResult_program_fun_num_used */

#ifdef f_Oracle_oracle_compile_query_create_fun_num_used
DEFAULT_CMOD_STORAGE ptrdiff_t f_Oracle_oracle_compile_query_create_fun_num = -1;

#endif /* f_Oracle_oracle_compile_query_create_fun_num_used */
DEFAULT_CMOD_STORAGE struct program *Oracle_oracle_compile_query_program=NULL;

#ifdef Oracle_oracle_compile_query_program_fun_num_used
DEFAULT_CMOD_STORAGE int Oracle_oracle_compile_query_program_fun_num=-1;
#endif /* Oracle_oracle_compile_query_program_fun_num_used */

#ifdef f_Oracle_oracle_create_fun_num_used
DEFAULT_CMOD_STORAGE ptrdiff_t f_Oracle_oracle_create_fun_num = -1;

#endif /* f_Oracle_oracle_create_fun_num_used */

#ifdef f_Oracle_oracle_commit_fun_num_used
DEFAULT_CMOD_STORAGE ptrdiff_t f_Oracle_oracle_commit_fun_num = -1;

#endif /* f_Oracle_oracle_commit_fun_num_used */
DEFAULT_CMOD_STORAGE struct program *Oracle_oracle_program=NULL;

#ifdef Oracle_oracle_program_fun_num_used
DEFAULT_CMOD_STORAGE int Oracle_oracle_program_fun_num=-1;
#endif /* Oracle_oracle_program_fun_num_used */
#line 277 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
;

static OCIEnv *oracle_environment=0;
static OCIEnv *low_get_oracle_environment(void)
{
sword rc;
if(!oracle_environment)
{
rc=OCIEnvInit(&oracle_environment, OCI_DEFAULT, 0, 0);
if(rc != OCI_SUCCESS)
Pike_error("Failed to initialize oracle environment, err=%d.\n",rc);
}
return oracle_environment;
}


#ifdef DEBUG_MALLOC
#define get_oracle_environment() dmalloc_touch(OCIEnv*,low_get_oracle_environment())
#else
#define get_oracle_environment() low_get_oracle_environment()
#endif

/* Mapping of Oracle datatypes to C and their SQLT_* symbols:
 * Taken from Table 3.2 of the OCI manual.
 *
 * 	SYMBOL[CODE]		EXTERNAL DATATYPE
 * 				C datatype
 * ----------------------------------------------------------------------------
 * 	SQLT_CHR[1]		VARCHAR2
 * 				char[n]
 *
 * 	SQLT_NUM[2]		NUMBER
 *				unsigned char[21]
 *
 * 	SQLT_INT[3]		8-bit signed INTEGER
 * 				signed char
 * 	SQLT_INT[3]		16-bit signed INTEGER
 *				signed short, signed int
 * 	SQLT_INT[3]		32-bit signed INTEGER
 *				signed int, signed long
 *
 * 	SQLT_FLT[4]		FLOAT
 *				float, double
 *
 * 	SQLT_STR[5]		NULL-terminated STRING
 *				char[n+1]
 *
 * 	SQLT_VNU[6]		VARNUM
 *				char[22]
 *
 * 	SQLT_LNG[8]		LONG
 *				char[n]
 *
 * 	SQLT_VCS[9]		VARCHAR
 *				char[n+sizeof(short integer)]
 *
 * 	SQLT_DAT[12]		DATE
 *				char[7]
 *
 * 	SQLT_VBI[15]		VARRAW
 *				unsigned char[n+sizeof(short integer)]
 *
 * 	SQLT_BFLOAT[21]		native float
 *				float
 *
 * 	SQLT_BDOUBLE[22]	native double
 *				double
 *
 * 	SQLT_BIN[23]		RAW
 *				unsigned char[n]
 *
 * 	SQLT_LBI[24]		LONG RAW
 *				unsigned char[n]
 *
 * 	SQLT_UIN[68]		UNSIGNED INT
 *				unsigned
 *
 * 	SQLT_LVC[94]		LONG VARCHAR
 *				char[n+sizeof(integer)]
 *
 * 	SQLT_LVB[95]		LONG VARRAW
 *				unsigned char[n+sizeof(integer)]
 *
 * 	SQLT_AFC[96]		CHAR
 *				char[n]
 *
 * 	SQLT_AVC[97]		CHARZ
 *				char[n+1]
 *
 * 	SQLT_RDD[104]		ROWID descriptor
 *				OCIRowid *
 *
 * 	SQLT_NTY[108]		NAMED DATATYPE
 *				struct
 *
 * 	SQLT_REF[110]		REF
 *				OCIRef
 *
 * 	SQLT_CLOB[112]		Character LOB descriptor
 *				OCILobLocator			(see note 2)
 *
 * 	SQLT_BLOB[113]		Binary LOB descriptor
 *				OCILobLocator			(see note 2)
 *
 * 	SQLT_FILE[114]		Binary FILE descriptor
 *				OCILobLocator
 *
 * 	SQLT_VST[155]		OCI STRING type
 *				OCIString			(see note 1)
 *
 * 	SQLT_ODT[156]		OCI DATE type
 *				OCIDate *			(see note 1)
 *
 * 	SQLT_DATE[184]		ANSI DATE descriptor
 *				OCIDateTime *
 *
 * 	SQLT_TIMESTAMP[187]	TIMESTAMP descriptor
 *				OCIDateTime *
 *
 * 	SQLT_TIMESTAMP_TZ[188]	TIMESTAMP WITH TIME ZONE descriptor
 *				OCIDateTime *
 *
 * 	SQLT_INTERVAL_YM[189]	INTERVAL YEAR TO MONTH descriptor
 *				OCIInterval *
 *
 * 	SQLT_INTERVAL_DS[190]	INTERVAL DAY TO SECOND descriptor
 *				OCIInterval *
 *
 * 	SQLT_TIMESTAMP_LTZ[232]	TIMESTAMP WITH LOCAL TIME ZONE descriptor
 *				OCIDateTime *
 *
 * Note:
 *
 * Where the length is shown as n, it is a variable, and depends on
 * the requirements of the program (or of the operating system in the
 * case of ROWID).
 *
 *     * For more information on the use of these datatypes, refer to
 *       Chapter 11, "Object-Relational Datatypes in OCI".
 *     * In applications using datatype mappings generated by OTT, CLOBs
 *       may be mapped as OCIClobLocator, and BLOBs may be mapped as
 *       OCIBlobLocator. For more information, refer to Chapter 14,
 *       "Using the Object Type Translator with OCI".
 */

struct inout
{
sb2 indicator;
ub2 rcode;
ub2 len; /* not really used? */
short has_output;
sword ftype;

sb4 xlen;
struct string_builder output;
ub4 curlen;

union dbunion
{
double f;
INT64 i;
char *buf;
char shortstr[32];
OCIDate date;
OCINumber num;
OCILobLocator *lob;
#ifdef STATIC_BUFFERS
 char str[STATIC_BUFFERS];
#endif
 } u;
};

static void free_inout(struct inout *i);
static void init_inout(struct inout *i);

/*! @class oracle
 *!
 *! Connection to an Oracle database server.
 *!
 *! @note
 *!   You probably don't want to access this class directly, but
 *!   rather via @[Sql.Sql].
 *!
 *! @seealso
 *!   @[Sql.Sql], @[Sql.oracle]
 */

#undef class_Oracle_oracle_defined
#define class_Oracle_oracle_defined
#line 465 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
#ifdef PIKE_DEBUG
 
#undef var_magic_Oracle_oracle_defined
#define var_magic_Oracle_oracle_defined
#line 467 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
#endif
 
#undef var_env_Oracle_oracle_defined
#define var_env_Oracle_oracle_defined

#undef var_error_handle_Oracle_oracle_defined
#define var_error_handle_Oracle_oracle_defined

#undef var_context_Oracle_oracle_defined
#define var_context_Oracle_oracle_defined

#undef var_DEFINE_MUTEX_Oracle_oracle_defined
#define var_DEFINE_MUTEX_Oracle_oracle_defined

#undef var_resultobject_busy_Oracle_oracle_defined
#define var_resultobject_busy_Oracle_oracle_defined

#undef THIS
#define THIS ((struct Oracle_oracle_struct *)(Pike_interpreter.frame_pointer->current_storage + Oracle_oracle_storage_offset))

#undef THIS_ORACLE_ORACLE
#define THIS_ORACLE_ORACLE ((struct Oracle_oracle_struct *)(Pike_interpreter.frame_pointer->current_storage + Oracle_oracle_storage_offset))

#undef OBJ2_ORACLE_ORACLE
#define OBJ2_ORACLE_ORACLE(o) ((struct Oracle_oracle_struct *)(o->storage+Oracle_oracle_storage_offset+Oracle_oracle_program->inherits[0].storage_offset))

#undef GET_ORACLE_ORACLE_STORAGE
#define GET_ORACLE_ORACLE_STORAGE(o) ((struct Oracle_oracle_struct *)(o->storage+Oracle_oracle_storage_offset+Oracle_oracle_program->inherits[0].storage_offset))
static ptrdiff_t Oracle_oracle_storage_offset;
struct Oracle_oracle_struct {

#ifdef var_magic_Oracle_oracle_defined
#line 466 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
unsigned long magic;
#endif /* var_magic_Oracle_oracle_defined */

#ifdef var_env_Oracle_oracle_defined
#line 468 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
OCIEnv *env;
#endif /* var_env_Oracle_oracle_defined */

#ifdef var_error_handle_Oracle_oracle_defined
#line 469 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
OCIError *error_handle;
#endif /* var_error_handle_Oracle_oracle_defined */

#ifdef var_context_Oracle_oracle_defined
#line 470 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
OCISvcCtx *context;
#endif /* var_context_Oracle_oracle_defined */

#ifdef var_DEFINE_MUTEX_Oracle_oracle_defined
#line 472 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
DEFINE_MUTEX(lock);
#endif /* var_DEFINE_MUTEX_Oracle_oracle_defined */

#ifdef var_resultobject_busy_Oracle_oracle_defined
#line 474 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
int resultobject_busy;
#endif /* var_resultobject_busy_Oracle_oracle_defined */
};
#ifdef PIKE_DEBUG
/* Ensure the struct is used in a variable declaration, or else gdb might not see it. */
static struct Oracle_oracle_struct *Oracle_oracle_gdb_dummy_ptr;
#endif
#line 476 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
;


#undef internal_init_Oracle_oracle_defined
#define internal_init_Oracle_oracle_defined

#undef Oracle_oracle_event_handler_defined
#define Oracle_oracle_event_handler_defined
static void init_Oracle_oracle_struct(void)
#line 479 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
{
OWERR("%s\n",__FUNCTION__);
#ifdef PIKE_DEBUG
 ((unsigned long *)(Pike_fp->current_storage))[0]=DBCON_MAGIC;
#endif
 THIS_DBCON->error_handle=0;
THIS_DBCON->context=0;
THIS_DBCON->resultobject_busy = 0;
#ifdef LOCAL_ENV
 THIS_DBCON->env=0;
#endif
 mt_init( & THIS_DBCON->lock );
}


#undef Oracle_oracle_gc_live_obj
#define Oracle_oracle_gc_live_obj

#undef internal_exit_Oracle_oracle_defined
#define internal_exit_Oracle_oracle_defined

#undef Oracle_oracle_event_handler_defined
#define Oracle_oracle_event_handler_defined
static void exit_Oracle_oracle_struct(void)
#line 494 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
{
OWERR("%s\n",__FUNCTION__);
debug_malloc_touch(THIS_DBCON->context);
OCILogoff(THIS_DBCON->context, THIS_DBCON->error_handle);

debug_malloc_touch(THIS_DBCON->error_handle);
OCIHandleFree(THIS_DBCON->error_handle, OCI_HTYPE_ERROR);

#ifdef LOCAL_ENV
 debug_malloc_touch(THIS_DBCON->env);
OCIHandleFree(THIS_DBCON->env, OCI_HTYPE_ENV);
#endif

mt_destroy( & THIS_DBCON->lock );
}

/*! @decl inherit __builtin.Sql.Connection
   */

#undef inherit_cq__22__builtin_2ESql_2EConnection_22_Oracle_oracle_defined
#define inherit_cq__22__builtin_2ESql_2EConnection_22_Oracle_oracle_defined
#line 512 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
static int Oracle_oracle_cq__22__builtin_2ESql_2EConnection_22_inh_num = -1;

#ifdef Oracle_oracle_cq__22__builtin_2ESql_2EConnection_22_inh_offset_used
#line 512 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
static int Oracle_oracle_cq__22__builtin_2ESql_2EConnection_22_inh_offset = -1;

#endif /* Oracle_oracle_cq__22__builtin_2ESql_2EConnection_22_inh_offset_used */

#ifdef Oracle_oracle_cq__22__builtin_2ESql_2EConnection_22_inh_storage_offset_used
#line 512 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
static int Oracle_oracle_cq__22__builtin_2ESql_2EConnection_22_inh_storage_offset = -1;

#endif /* Oracle_oracle_cq__22__builtin_2ESql_2EConnection_22_inh_storage_offset_used */
#line 514 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
#ifdef LOCAL_ENV
#define ENVOF(X) (X)->env
#else
#define ENVOF(X) get_oracle_environment()
#endif

/************/

static void ora_error_handler(OCIError *err, sword rc, char *func)
{
/* FIXME: we might need to do switch(rc) */
#ifdef OCI_UTF16ID
 static text msgbuf[1024];
int i;
#else
 static text msgbuf[512];
#endif
 sb4 errcode;

OWERR("%s\n",__FUNCTION__);

OCIErrorGet(err,1,0,&errcode,msgbuf,sizeof(msgbuf),OCI_HTYPE_ERROR);

OWERR("%s:code=%d:errcode=%d:%s\n",
func?func:"Oracle", rc, errcode, msgbuf);

#ifdef OCI_UTF16ID
 for (i = 0; msgbuf[i] || msgbuf[i+1]; i+= 2)
;
push_string(make_shared_binary_string((char *)msgbuf, i));
push_int(2);
f_unicode_to_string(2);
#else
 push_text(msgbuf);
#endif

/* Note that the error string as returned by Oracle ends with a linefeed,
   * and is prefixed with sprintf("ORA-%05d: ", errcode).
   */
if(func)
Pike_error("%s:code=%d:%pS",
func, rc, Pike_sp[-1].u.string);
else
Pike_error("Oracle:code=%d:%pS",
rc, Pike_sp[-1].u.string);
}


static OCIError *global_error_handle=0;

OCIError *get_global_error_handle(void)
{
if (!global_error_handle) {
sword rc;
rc=OCIHandleAlloc(get_oracle_environment(),
(void **)& global_error_handle,
OCI_HTYPE_ERROR,
0,
0);

if(rc != OCI_SUCCESS)
Pike_error("Failed to allocate error handle.\n");
}

return global_error_handle;
}

/*! @class LOB
   *!
   *! Large OBject.
   */

#undef class_Oracle_oracle_LOB_defined
#define class_Oracle_oracle_LOB_defined
#line 587 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
#ifdef PIKE_DEBUG
 
#undef var_magic_Oracle_oracle_LOB_defined
#define var_magic_Oracle_oracle_LOB_defined
#line 589 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
#endif
 
#undef var_is_clob_Oracle_oracle_LOB_defined
#define var_is_clob_Oracle_oracle_LOB_defined

#undef var_lob_Oracle_oracle_LOB_defined
#define var_lob_Oracle_oracle_LOB_defined

#undef var_dbcon_Oracle_oracle_LOB_defined
#define var_dbcon_Oracle_oracle_LOB_defined

#undef THIS
#define THIS ((struct Oracle_oracle_LOB_struct *)(Pike_interpreter.frame_pointer->current_storage + Oracle_oracle_LOB_storage_offset))

#undef THIS_ORACLE_ORACLE_LOB
#define THIS_ORACLE_ORACLE_LOB ((struct Oracle_oracle_LOB_struct *)(Pike_interpreter.frame_pointer->current_storage + Oracle_oracle_LOB_storage_offset))

#undef OBJ2_ORACLE_ORACLE_LOB
#define OBJ2_ORACLE_ORACLE_LOB(o) ((struct Oracle_oracle_LOB_struct *)(o->storage+Oracle_oracle_LOB_storage_offset+Oracle_oracle_LOB_program->inherits[0].storage_offset))

#undef GET_ORACLE_ORACLE_LOB_STORAGE
#define GET_ORACLE_ORACLE_LOB_STORAGE(o) ((struct Oracle_oracle_LOB_struct *)(o->storage+Oracle_oracle_LOB_storage_offset+Oracle_oracle_LOB_program->inherits[0].storage_offset))
static ptrdiff_t Oracle_oracle_LOB_storage_offset;
struct Oracle_oracle_LOB_struct {

#ifdef var_magic_Oracle_oracle_LOB_defined
#line 588 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
unsigned long magic;
#endif /* var_magic_Oracle_oracle_LOB_defined */

#ifdef var_is_clob_Oracle_oracle_LOB_defined
#line 590 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
int is_clob;
#endif /* var_is_clob_Oracle_oracle_LOB_defined */

#ifdef var_lob_Oracle_oracle_LOB_defined
#line 591 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
OCILobLocator *lob;
#endif /* var_lob_Oracle_oracle_LOB_defined */

#ifdef var_dbcon_Oracle_oracle_LOB_defined
#line 592 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
struct Oracle_oracle_struct *dbcon;
#endif /* var_dbcon_Oracle_oracle_LOB_defined */
};
#ifdef PIKE_DEBUG
/* Ensure the struct is used in a variable declaration, or else gdb might not see it. */
static struct Oracle_oracle_LOB_struct *Oracle_oracle_LOB_gdb_dummy_ptr;
#endif
#line 594 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
;


#undef internal_init_Oracle_oracle_LOB_defined
#define internal_init_Oracle_oracle_LOB_defined

#undef Oracle_oracle_LOB_event_handler_defined
#define Oracle_oracle_LOB_event_handler_defined
static void init_Oracle_oracle_LOB_struct(void)
#line 597 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
{
#ifdef PIKE_DEBUG
 ((unsigned long *)(Pike_fp->current_storage))[0]=DBLOB_MAGIC;
#endif
 }


#undef Oracle_oracle_LOB_gc_live_obj
#define Oracle_oracle_LOB_gc_live_obj

#undef internal_exit_Oracle_oracle_LOB_defined
#define internal_exit_Oracle_oracle_LOB_defined

#undef Oracle_oracle_LOB_event_handler_defined
#define Oracle_oracle_LOB_event_handler_defined
static void exit_Oracle_oracle_LOB_struct(void)
#line 604 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
{
if (THIS_DBLOB->lob) {
OCIDescriptorFree(THIS_DBLOB->lob, OCI_DTYPE_LOB);
THIS_DBLOB->lob = NULL;
}
}

#define f_Oracle_oracle_LOB_cq__sprintf_defined
DEFAULT_CMOD_STORAGE void f_Oracle_oracle_LOB_cq__sprintf(INT32 args) {
#line 611 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
INT_TYPE c;
#line 611 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
struct mapping * o;
#line 611 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
if(args != 2) wrong_number_of_args_error("_sprintf",args,2);
#line 611 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
if((TYPEOF(Pike_sp[0-2]) != PIKE_T_INT)) SIMPLE_ARG_TYPE_ERROR("_sprintf",1,"int");
#line 611 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
c=Pike_sp[0-2].u.integer;
#line 611 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
if(TYPEOF(Pike_sp[1-2]) != PIKE_T_MAPPING) SIMPLE_ARG_TYPE_ERROR("_sprintf",2,"mapping(mixed:mixed)");
#line 611 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
debug_malloc_pass(o=Pike_sp[1-2].u.mapping);
#line 613 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
{
char tmp[100];
sprintf(tmp, "Oracle.LOB(%p)", THIS_DBLOB->lob);
pop_n_elems(args);
push_text(tmp);
}

}
#define f_Oracle_oracle_LOB_read_defined
DEFAULT_CMOD_STORAGE void f_Oracle_oracle_LOB_read(INT32 args) {
#line 620 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
if(args != 0) wrong_number_of_args_error("read",args,0);
{
sword ret;
ub4 loblen = ~0;
char *bufp = NULL;
char *errfunc = NULL;
ub4 amtp = 0;
int is_clob = THIS_DBLOB->is_clob;
struct Oracle_oracle_struct *dbcon = THIS_DBLOB->dbcon;
ub2 charset = 0;

if (!THIS_DBLOB->lob) {
Pike_error("Attempt to read from an uninitialized LOB.\n");
}

if((ret = OCILobGetLength(dbcon->context, dbcon->error_handle,
THIS_DBLOB->lob, &loblen)) != OCI_SUCCESS) {
OWERR("OCILobGetLength failed.\n");
errfunc = "OCILobGetLength";
} else {
if(loblen) {
amtp = loblen;
#ifdef OCI_UTF16ID
 if (is_clob) {
loblen *= 2;
charset = OCI_UTF16ID;
}
#endif
 /* FIXME: Use begin_shared_string() + end_and_resize_shared_string(). */
if((bufp = malloc(loblen))) {
if((ret = OCILobRead(dbcon->context,
dbcon->error_handle,
THIS_DBLOB->lob,
&amtp,
1,
(dvoid *) bufp,
loblen,
(dvoid *) NULL,
(sb4 (*)(dvoid *, CONST dvoid *, ub4, ub1)) NULL,
charset,
(ub1) SQLCS_IMPLICIT)) != OCI_SUCCESS) {
OWERR("OCILobRead failed\n");
errfunc = "OCILobRead";
}
} else {
ret = 1;
errfunc = "malloc";
}
}
}
OWERR("LOB length: %d bytes, is_clob: %d\n", loblen, is_clob);
if(!loblen) {
push_empty_string();
} else {
if(ret != OCI_SUCCESS) {
if(bufp)
free(bufp);
ora_error_handler(dbcon->error_handle, ret, errfunc);
}

push_string(make_shared_binary_string(bufp, loblen));
#ifdef OCI_UTF16ID
 if(is_clob) {
push_int(2);
f_unicode_to_string(2);
}
#endif
 if(bufp)
free(bufp);
}
}

}
#define f_Oracle_oracle_LOB_cast_defined
DEFAULT_CMOD_STORAGE void f_Oracle_oracle_LOB_cast(INT32 args) {
#line 692 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
struct pike_string * s;
#line 692 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
if(args != 1) wrong_number_of_args_error("cast",args,1);
#line 692 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
if(TYPEOF(Pike_sp[0-1]) != PIKE_T_STRING) SIMPLE_ARG_TYPE_ERROR("cast",1,"string");
#line 692 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
debug_malloc_pass(s=Pike_sp[0-1].u.string);
#line 694 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
{
if(s == literal_string_string) {
apply_current(f_Oracle_oracle_LOB_read_fun_num, 0);
return;
}

Pike_error("Cannot cast Oracle.LOB to %pS\n", s);
}

}
#define f_Oracle_oracle_LOB_write_defined
DEFAULT_CMOD_STORAGE void f_Oracle_oracle_LOB_write(INT32 args) {
#line 703 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
struct pike_string * data;
#line 703 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
if(args != 1) wrong_number_of_args_error("write",args,1);
#line 703 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
if((TYPEOF(Pike_sp[0-1]) != PIKE_T_STRING) || Pike_sp[0-1].u.string->size_shift) SIMPLE_ARG_TYPE_ERROR("write",1,"string(8bit)");
#line 703 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
debug_malloc_pass(data=Pike_sp[0-1].u.string);
{
sword ret;
char *bufp;
char *errfunc = NULL;
ub4 amtp = 0;
int is_clob = THIS_DBLOB->is_clob;
struct Oracle_oracle_struct *dbcon = THIS_DBLOB->dbcon;

if (!THIS_DBLOB->lob) {
Pike_error("Attempt to write to an uninitialized LOB.\n");
}

#ifdef OCI_UTF16ID
 if (is_clob && args) {
push_int(2);
f_string_to_unicode(2);
}
#endif

/* Number of bytes. */
amtp = data->len;

#ifdef OCI_UTF16ID
 if (is_clob) {
/* Number of characters for CLOBs and fixed width character sets. */
amtp /= 2;
}
#endif

ret = OCILobWrite(dbcon->context,
dbcon->error_handle,
THIS_DBLOB->lob,
&amtp,
1, /* offset */
data->str,
data->len, /* buflen */
OCI_ONE_PIECE,
NULL, /* *ctxp */
NULL, /* OCICallbackLobWrite */
0, /* csid */
0 /* csfrm */ );

if(!IS_SUCCESS(ret))
ora_error_handler(dbcon->error_handle, ret, "OCILobWrite");

ret = OCILobTrim( dbcon->context,
dbcon->error_handle,
THIS_DBLOB->lob,
amtp);

if(!IS_SUCCESS(ret))
ora_error_handler(dbcon->error_handle, ret, "OCILobTrim");

pop_stack();

push_int(0);
}
}

#ifdef Oracle_oracle_LOB_event_handler_defined
static void Oracle_oracle_LOB_event_handler(int ev) {
  switch(ev) {

#ifdef internal_init_Oracle_oracle_LOB_defined
  case PROG_EVENT_INIT: init_Oracle_oracle_LOB_struct(); break;

#endif /* internal_init_Oracle_oracle_LOB_defined */

#ifdef internal_exit_Oracle_oracle_LOB_defined
  case PROG_EVENT_EXIT: exit_Oracle_oracle_LOB_struct(); break;

#endif /* internal_exit_Oracle_oracle_LOB_defined */
  default: break; 
  }
}

#endif /* Oracle_oracle_LOB_event_handler_defined */

#ifdef THIS_ORACLE_ORACLE

#undef THIS
#define THIS THIS_ORACLE_ORACLE

#endif /* THIS_ORACLE_ORACLE */
/*! @endclass LOB
   */

/*! @class Date
   */

#undef class_Oracle_oracle_Date_defined
#define class_Oracle_oracle_Date_defined
#line 769 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
#ifdef PIKE_DEBUG
 
#undef var_magic_Oracle_oracle_Date_defined
#define var_magic_Oracle_oracle_Date_defined
#line 771 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
#endif
 
#undef var_date_Oracle_oracle_Date_defined
#define var_date_Oracle_oracle_Date_defined

#undef THIS
#define THIS ((struct Oracle_oracle_Date_struct *)(Pike_interpreter.frame_pointer->current_storage + Oracle_oracle_Date_storage_offset))

#undef THIS_ORACLE_ORACLE_DATE
#define THIS_ORACLE_ORACLE_DATE ((struct Oracle_oracle_Date_struct *)(Pike_interpreter.frame_pointer->current_storage + Oracle_oracle_Date_storage_offset))

#undef OBJ2_ORACLE_ORACLE_DATE
#define OBJ2_ORACLE_ORACLE_DATE(o) ((struct Oracle_oracle_Date_struct *)(o->storage+Oracle_oracle_Date_storage_offset+Oracle_oracle_Date_program->inherits[0].storage_offset))

#undef GET_ORACLE_ORACLE_DATE_STORAGE
#define GET_ORACLE_ORACLE_DATE_STORAGE(o) ((struct Oracle_oracle_Date_struct *)(o->storage+Oracle_oracle_Date_storage_offset+Oracle_oracle_Date_program->inherits[0].storage_offset))
static ptrdiff_t Oracle_oracle_Date_storage_offset;
struct Oracle_oracle_Date_struct {

#ifdef var_magic_Oracle_oracle_Date_defined
#line 770 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
unsigned long magic;
#endif /* var_magic_Oracle_oracle_Date_defined */

#ifdef var_date_Oracle_oracle_Date_defined
#line 772 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
OCIDate date;
#endif /* var_date_Oracle_oracle_Date_defined */
};
#ifdef PIKE_DEBUG
/* Ensure the struct is used in a variable declaration, or else gdb might not see it. */
static struct Oracle_oracle_Date_struct *Oracle_oracle_Date_gdb_dummy_ptr;
#endif
#line 774 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
;


#undef internal_init_Oracle_oracle_Date_defined
#define internal_init_Oracle_oracle_Date_defined

#undef Oracle_oracle_Date_event_handler_defined
#define Oracle_oracle_Date_event_handler_defined
static void init_Oracle_oracle_Date_struct(void)
#line 777 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
{
#ifdef PIKE_DEBUG
 ((unsigned long *)(Pike_fp->current_storage))[0]=DBDATE_MAGIC;
#endif
 }

#define f_Oracle_oracle_Date_create_defined
DEFAULT_CMOD_STORAGE void f_Oracle_oracle_Date_create(INT32 args) {
#line 783 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
struct svalue * date;
#line 783 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
if(args != 1) wrong_number_of_args_error("create",args,1);
#line 783 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
date=Pike_sp+0-1; dmalloc_touch_svalue(Pike_sp+0-1);
#line 785 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
{
struct tm *tm;
time_t t;
sword rc;

check_all_args(NULL,args,BIT_INT|BIT_STRING,0);
switch(TYPEOF(*date))
{
case T_STRING:
rc=OCIDateFromText(get_global_error_handle(),
(oratext *)date->u.string->str,
date->u.string->len,
0,
0,
0,
0,
& THIS_DBDATE->date);
if(rc != OCI_SUCCESS)
ora_error_handler(get_global_error_handle(), rc,"OCIDateFromText");
break;

case T_INT:
t = date->u.integer;
tm=localtime(&t);
if (!tm) Pike_error ("localtime() failed to convert %ld\n", (long) t);
OCIDateSetDate(&THIS_DBDATE->date, tm->tm_year, tm->tm_mon, tm->tm_mday);
OCIDateSetTime(&THIS_DBDATE->date, tm->tm_hour, tm->tm_min, tm->tm_sec);
break;
}
}

}
#define f_Oracle_oracle_Date_cq__sprintf_defined
DEFAULT_CMOD_STORAGE void f_Oracle_oracle_Date_cq__sprintf(INT32 args) {
#line 816 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
INT_TYPE mode;
#line 816 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
struct mapping * m;
#line 816 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
if(args != 2) wrong_number_of_args_error("_sprintf",args,2);
#line 816 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
if((TYPEOF(Pike_sp[0-2]) != PIKE_T_INT)) SIMPLE_ARG_TYPE_ERROR("_sprintf",1,"int");
#line 816 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
mode=Pike_sp[0-2].u.integer;
#line 816 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
if(TYPEOF(Pike_sp[1-2]) != PIKE_T_MAPPING) SIMPLE_ARG_TYPE_ERROR("_sprintf",2,"mapping(mixed:mixed)");
#line 816 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
debug_malloc_pass(m=Pike_sp[1-2].u.mapping);
#line 818 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
{
char buffer[200];
sword rc;
ub4 bsize=200;

if(mode != 'O' && mode != 's') {
pop_n_elems(args);
push_undefined();
return;
}
rc=OCIDateToText(get_global_error_handle(),
&THIS_DBDATE->date,
0,
0,
0,
0,
&bsize,
(oratext *)buffer);

if(!IS_SUCCESS(rc)) {
if (mode == 'O') {
/* Be fault tolerant in debug mode. */
pop_n_elems (args);
push_undefined();
return;
}
ora_error_handler(get_global_error_handle(), rc,"OCIDateToText");
}

pop_n_elems(args);
push_string(make_shared_binary_string(buffer, bsize));
#ifdef OCI_UTF16ID
 push_int(2);
f_unicode_to_string(2);
#endif
 }

}
#define f_Oracle_oracle_Date_cast_defined
DEFAULT_CMOD_STORAGE void f_Oracle_oracle_Date_cast(INT32 args) {
#line 855 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
struct pike_string * type;
#line 855 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
if(args != 1) wrong_number_of_args_error("cast",args,1);
#line 855 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
if(TYPEOF(Pike_sp[0-1]) != PIKE_T_STRING) SIMPLE_ARG_TYPE_ERROR("cast",1,"string");
#line 855 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
debug_malloc_pass(type=Pike_sp[0-1].u.string);
#line 857 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
{
if(type == literal_int_string)
{
ub1 hour, min, sec, month,day;
sb2 year;

extern void f_mktime(INT32 args);

OCIDateGetDate(&THIS_DBDATE->date, &year, &month, &day);
OCIDateGetTime(&THIS_DBDATE->date, &hour, &min, &sec);

push_int(sec);
push_int(min);
push_int(hour);
push_int(day);
push_int(month);
push_int(year);
f_mktime(6);
}
else if(type == literal_string_string)
{
push_int('s');
apply_current(f_Oracle_oracle_Date_cq__sprintf_fun_num, 1);
}
else
push_undefined();
}
}

#ifdef Oracle_oracle_Date_event_handler_defined
static void Oracle_oracle_Date_event_handler(int ev) {
  switch(ev) {

#ifdef internal_init_Oracle_oracle_Date_defined
  case PROG_EVENT_INIT: init_Oracle_oracle_Date_struct(); break;

#endif /* internal_init_Oracle_oracle_Date_defined */
  default: break; 
  }
}

#endif /* Oracle_oracle_Date_event_handler_defined */

#ifdef THIS_ORACLE_ORACLE

#undef THIS
#define THIS THIS_ORACLE_ORACLE

#endif /* THIS_ORACLE_ORACLE */
/*! @endclass Date
   */

/*! @class NULL
   */

#undef class_Oracle_oracle_NULL_defined
#define class_Oracle_oracle_NULL_defined
#line 892 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
#ifdef PIKE_DEBUG
 
#undef var_magic_Oracle_oracle_NULL_defined
#define var_magic_Oracle_oracle_NULL_defined
#line 894 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
#endif
 
#undef var_type_Oracle_oracle_NULL_defined
#define var_type_Oracle_oracle_NULL_defined

#undef THIS
#define THIS ((struct Oracle_oracle_NULL_struct *)(Pike_interpreter.frame_pointer->current_storage + Oracle_oracle_NULL_storage_offset))

#undef THIS_ORACLE_ORACLE_NULL
#define THIS_ORACLE_ORACLE_NULL ((struct Oracle_oracle_NULL_struct *)(Pike_interpreter.frame_pointer->current_storage + Oracle_oracle_NULL_storage_offset))

#undef OBJ2_ORACLE_ORACLE_NULL
#define OBJ2_ORACLE_ORACLE_NULL(o) ((struct Oracle_oracle_NULL_struct *)(o->storage+Oracle_oracle_NULL_storage_offset+Oracle_oracle_NULL_program->inherits[0].storage_offset))

#undef GET_ORACLE_ORACLE_NULL_STORAGE
#define GET_ORACLE_ORACLE_NULL_STORAGE(o) ((struct Oracle_oracle_NULL_struct *)(o->storage+Oracle_oracle_NULL_storage_offset+Oracle_oracle_NULL_program->inherits[0].storage_offset))
static ptrdiff_t Oracle_oracle_NULL_storage_offset;
struct Oracle_oracle_NULL_struct {

#ifdef var_magic_Oracle_oracle_NULL_defined
#line 893 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
unsigned long magic;
#endif /* var_magic_Oracle_oracle_NULL_defined */

#ifdef var_type_Oracle_oracle_NULL_defined
#line 895 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
  struct svalue type;

#endif /* var_type_Oracle_oracle_NULL_defined */
};
#ifdef PIKE_DEBUG
/* Ensure the struct is used in a variable declaration, or else gdb might not see it. */
static struct Oracle_oracle_NULL_struct *Oracle_oracle_NULL_gdb_dummy_ptr;
#endif
#line 897 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
;


#undef internal_init_Oracle_oracle_NULL_defined
#define internal_init_Oracle_oracle_NULL_defined

#undef Oracle_oracle_NULL_event_handler_defined
#define Oracle_oracle_NULL_event_handler_defined
static void init_Oracle_oracle_NULL_struct(void)
#line 900 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
{
#ifdef PIKE_DEBUG
 ((unsigned long *)(Pike_fp->current_storage))[0]=DBNULL_MAGIC;
#endif
 }

/*! @decl inherit Val.Null
     */
/*! @decl constant is_oracle_null
     */

#undef extra_Oracle_oracle_NULL_defined
#define extra_Oracle_oracle_NULL_defined
#define f_Oracle_oracle_NULL_create_defined
DEFAULT_CMOD_STORAGE void f_Oracle_oracle_NULL_create(INT32 args) {
#line 918 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
struct svalue * type;
#line 918 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
if(args != 1) wrong_number_of_args_error("create",args,1);
#line 918 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
type=Pike_sp+0-1; dmalloc_touch_svalue(Pike_sp+0-1);
#line 920 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
{
assign_svalue(& THIS_DBNULL->type, type);
}

}
#define f_Oracle_oracle_NULL_cq__sprintf_defined
DEFAULT_CMOD_STORAGE void f_Oracle_oracle_NULL_cq__sprintf(INT32 args) {
#line 924 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
INT_TYPE mode;
#line 924 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
struct mapping * o;
#line 924 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
if(args != 2) wrong_number_of_args_error("_sprintf",args,2);
#line 924 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
if((TYPEOF(Pike_sp[0-2]) != PIKE_T_INT)) SIMPLE_ARG_TYPE_ERROR("_sprintf",1,"int");
#line 924 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
mode=Pike_sp[0-2].u.integer;
#line 924 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
if(TYPEOF(Pike_sp[1-2]) != PIKE_T_MAPPING) SIMPLE_ARG_TYPE_ERROR("_sprintf",2,"mapping(mixed:mixed)");
#line 924 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
debug_malloc_pass(o=Pike_sp[1-2].u.mapping);
#line 926 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
{
if(mode != 'O') {
push_undefined();
return;
}
switch(TYPEOF(THIS_DBNULL->type))
{
case T_INT: push_static_text("Oracle.NULLint"); break;
case T_STRING: push_static_text("Oracle.NULLstring"); break;
case T_FLOAT: push_static_text("Oracle.NULLfloat"); break;
case T_OBJECT: push_static_text("Oracle.NULLdate"); break;
}
}

}
#define f_Oracle_oracle_NULL_cq__backtick_eq_eq_defined
DEFAULT_CMOD_STORAGE void f_Oracle_oracle_NULL_cq__backtick_eq_eq(INT32 args) {
#line 940 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
struct svalue * other;
#line 940 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
if(args != 1) wrong_number_of_args_error("`==",args,1);
#line 940 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
other=Pike_sp+0-1; dmalloc_touch_svalue(Pike_sp+0-1);
#line 942 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
{
if (TYPEOF(*other) != T_OBJECT) {
push_int(0);
return;
}
/* Check if it's an Oracle-NULL. */
stack_dup();
push_constant_text("is_oracle_null");
o_index();
if ((TYPEOF(Pike_sp[-1]) != T_INT) || !Pike_sp[-1].u.integer) {
/* No - is it the generic Val.null? */
pop_stack();
push_constant_text("is_val_null");
o_index();
return;
}
pop_stack();
/* Yes - are the types the same? */
ref_push_string(literal_type_string);
o_index();
push_svalue(&THIS_DBNULL->type);
f_eq(2);
}
}

#ifdef Oracle_oracle_NULL_event_handler_defined
static void Oracle_oracle_NULL_event_handler(int ev) {
  switch(ev) {

#ifdef internal_init_Oracle_oracle_NULL_defined
  case PROG_EVENT_INIT: init_Oracle_oracle_NULL_struct(); break;

#endif /* internal_init_Oracle_oracle_NULL_defined */
  default: break; 
  }
}

#endif /* Oracle_oracle_NULL_event_handler_defined */

#ifdef THIS_ORACLE_ORACLE

#undef THIS
#define THIS THIS_ORACLE_ORACLE

#endif /* THIS_ORACLE_ORACLE */
/*! @endclass NULL
   */

/*! @class compile_query
   */

#undef class_Oracle_oracle_compile_query_defined
#define class_Oracle_oracle_compile_query_defined
#line 974 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
#ifdef PIKE_DEBUG
 
#undef var_magic_Oracle_oracle_compile_query_defined
#define var_magic_Oracle_oracle_compile_query_defined
#line 976 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
#endif
 
#undef var_statement_Oracle_oracle_compile_query_defined
#define var_statement_Oracle_oracle_compile_query_defined

#undef var_query_type_Oracle_oracle_compile_query_defined
#define var_query_type_Oracle_oracle_compile_query_defined

#undef var_DEFINE_MUTEX_Oracle_oracle_compile_query_defined
#define var_DEFINE_MUTEX_Oracle_oracle_compile_query_defined
#line 979 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
/* FIXME: Probably ought to be an IMUTEX_T. */


#undef var_cols_Oracle_oracle_compile_query_defined
#define var_cols_Oracle_oracle_compile_query_defined

#undef var_field_info_Oracle_oracle_compile_query_defined
#define var_field_info_Oracle_oracle_compile_query_defined

#undef var_output_variables_Oracle_oracle_compile_query_defined
#define var_output_variables_Oracle_oracle_compile_query_defined

#undef THIS
#define THIS ((struct Oracle_oracle_compile_query_struct *)(Pike_interpreter.frame_pointer->current_storage + Oracle_oracle_compile_query_storage_offset))

#undef THIS_ORACLE_ORACLE_COMPILE_QUERY
#define THIS_ORACLE_ORACLE_COMPILE_QUERY ((struct Oracle_oracle_compile_query_struct *)(Pike_interpreter.frame_pointer->current_storage + Oracle_oracle_compile_query_storage_offset))

#undef OBJ2_ORACLE_ORACLE_COMPILE_QUERY
#define OBJ2_ORACLE_ORACLE_COMPILE_QUERY(o) ((struct Oracle_oracle_compile_query_struct *)(o->storage+Oracle_oracle_compile_query_storage_offset+Oracle_oracle_compile_query_program->inherits[0].storage_offset))

#undef GET_ORACLE_ORACLE_COMPILE_QUERY_STORAGE
#define GET_ORACLE_ORACLE_COMPILE_QUERY_STORAGE(o) ((struct Oracle_oracle_compile_query_struct *)(o->storage+Oracle_oracle_compile_query_storage_offset+Oracle_oracle_compile_query_program->inherits[0].storage_offset))
static ptrdiff_t Oracle_oracle_compile_query_storage_offset;
struct Oracle_oracle_compile_query_struct {

#ifdef var_magic_Oracle_oracle_compile_query_defined
#line 975 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
unsigned long magic;
#endif /* var_magic_Oracle_oracle_compile_query_defined */

#ifdef var_statement_Oracle_oracle_compile_query_defined
#line 977 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
OCIStmt *statement;
#endif /* var_statement_Oracle_oracle_compile_query_defined */

#ifdef var_query_type_Oracle_oracle_compile_query_defined
#line 978 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
INT_TYPE query_type;
#endif /* var_query_type_Oracle_oracle_compile_query_defined */

#ifdef var_DEFINE_MUTEX_Oracle_oracle_compile_query_defined
#line 979 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
DEFINE_MUTEX(lock);
#endif /* var_DEFINE_MUTEX_Oracle_oracle_compile_query_defined */

#ifdef var_cols_Oracle_oracle_compile_query_defined
#line 981 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
INT_TYPE cols;
#endif /* var_cols_Oracle_oracle_compile_query_defined */

#ifdef var_field_info_Oracle_oracle_compile_query_defined
#line 982 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
struct array *field_info;
#endif /* var_field_info_Oracle_oracle_compile_query_defined */

#ifdef var_output_variables_Oracle_oracle_compile_query_defined
#line 983 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
  struct mapping * output_variables;

#endif /* var_output_variables_Oracle_oracle_compile_query_defined */
};
#ifdef PIKE_DEBUG
/* Ensure the struct is used in a variable declaration, or else gdb might not see it. */
static struct Oracle_oracle_compile_query_struct *Oracle_oracle_compile_query_gdb_dummy_ptr;
#endif
#line 985 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
;


#undef internal_init_Oracle_oracle_compile_query_defined
#define internal_init_Oracle_oracle_compile_query_defined

#undef Oracle_oracle_compile_query_event_handler_defined
#define Oracle_oracle_compile_query_event_handler_defined
static void init_Oracle_oracle_compile_query_struct(void)
#line 988 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
{
OWERR("%s\n",__FUNCTION__);
#ifdef PIKE_DEBUG
 ((unsigned long *)(Pike_fp->current_storage))[0]=DBQUERY_MAGIC;
#endif
 THIS_QUERY->cols=-2;
THIS_QUERY->statement=0;
mt_init(& THIS_QUERY->lock);
}


#undef Oracle_oracle_compile_query_gc_live_obj
#define Oracle_oracle_compile_query_gc_live_obj

#undef internal_exit_Oracle_oracle_compile_query_defined
#define internal_exit_Oracle_oracle_compile_query_defined

#undef Oracle_oracle_compile_query_event_handler_defined
#define Oracle_oracle_compile_query_event_handler_defined
static void exit_Oracle_oracle_compile_query_struct(void)
#line 999 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
{
OWERR("%s\n",__FUNCTION__);
debug_malloc_touch(THIS_QUERY->statement);
OCIHandleFree(THIS_QUERY->statement, OCI_HTYPE_STMT);
mt_destroy(& THIS_QUERY->lock);
}


#undef extra_Oracle_oracle_compile_query_defined
#define extra_Oracle_oracle_compile_query_defined
/*! @class dbresultinfo
     */

#undef class_Oracle_oracle_compile_query_dbresultinfo_defined
#define class_Oracle_oracle_compile_query_dbresultinfo_defined
#line 1021 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
#ifdef PIKE_DEBUG
 
#undef var_magic_Oracle_oracle_compile_query_dbresultinfo_defined
#define var_magic_Oracle_oracle_compile_query_dbresultinfo_defined
#line 1023 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
#endif
 
#undef var_length_Oracle_oracle_compile_query_dbresultinfo_defined
#define var_length_Oracle_oracle_compile_query_dbresultinfo_defined

#undef var_decimals_Oracle_oracle_compile_query_dbresultinfo_defined
#define var_decimals_Oracle_oracle_compile_query_dbresultinfo_defined

#undef var_real_type_Oracle_oracle_compile_query_dbresultinfo_defined
#define var_real_type_Oracle_oracle_compile_query_dbresultinfo_defined

#undef var_name_Oracle_oracle_compile_query_dbresultinfo_defined
#define var_name_Oracle_oracle_compile_query_dbresultinfo_defined

#undef var_type_Oracle_oracle_compile_query_dbresultinfo_defined
#define var_type_Oracle_oracle_compile_query_dbresultinfo_defined

#undef var_define_handle_Oracle_oracle_compile_query_dbresultinfo_defined
#define var_define_handle_Oracle_oracle_compile_query_dbresultinfo_defined

#undef var_data_Oracle_oracle_compile_query_dbresultinfo_defined
#define var_data_Oracle_oracle_compile_query_dbresultinfo_defined

#undef THIS
#define THIS ((struct Oracle_oracle_compile_query_dbresultinfo_struct *)(Pike_interpreter.frame_pointer->current_storage + Oracle_oracle_compile_query_dbresultinfo_storage_offset))

#undef THIS_ORACLE_ORACLE_COMPILE_QUERY_DBRESULTINFO
#define THIS_ORACLE_ORACLE_COMPILE_QUERY_DBRESULTINFO ((struct Oracle_oracle_compile_query_dbresultinfo_struct *)(Pike_interpreter.frame_pointer->current_storage + Oracle_oracle_compile_query_dbresultinfo_storage_offset))

#undef OBJ2_ORACLE_ORACLE_COMPILE_QUERY_DBRESULTINFO
#define OBJ2_ORACLE_ORACLE_COMPILE_QUERY_DBRESULTINFO(o) ((struct Oracle_oracle_compile_query_dbresultinfo_struct *)(o->storage+Oracle_oracle_compile_query_dbresultinfo_storage_offset+Oracle_oracle_compile_query_dbresultinfo_program->inherits[0].storage_offset))

#undef GET_ORACLE_ORACLE_COMPILE_QUERY_DBRESULTINFO_STORAGE
#define GET_ORACLE_ORACLE_COMPILE_QUERY_DBRESULTINFO_STORAGE(o) ((struct Oracle_oracle_compile_query_dbresultinfo_struct *)(o->storage+Oracle_oracle_compile_query_dbresultinfo_storage_offset+Oracle_oracle_compile_query_dbresultinfo_program->inherits[0].storage_offset))
static ptrdiff_t Oracle_oracle_compile_query_dbresultinfo_storage_offset;
struct Oracle_oracle_compile_query_dbresultinfo_struct {

#ifdef var_magic_Oracle_oracle_compile_query_dbresultinfo_defined
#line 1022 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
unsigned long magic;
#endif /* var_magic_Oracle_oracle_compile_query_dbresultinfo_defined */

#ifdef var_length_Oracle_oracle_compile_query_dbresultinfo_defined
#line 1024 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
  INT_TYPE length;

#endif /* var_length_Oracle_oracle_compile_query_dbresultinfo_defined */

#ifdef var_decimals_Oracle_oracle_compile_query_dbresultinfo_defined
#line 1025 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
  INT_TYPE decimals;

#endif /* var_decimals_Oracle_oracle_compile_query_dbresultinfo_defined */

#ifdef var_real_type_Oracle_oracle_compile_query_dbresultinfo_defined
#line 1026 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
INT_TYPE real_type;
#endif /* var_real_type_Oracle_oracle_compile_query_dbresultinfo_defined */

#ifdef var_name_Oracle_oracle_compile_query_dbresultinfo_defined
#line 1027 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
  struct pike_string * name;

#endif /* var_name_Oracle_oracle_compile_query_dbresultinfo_defined */

#ifdef var_type_Oracle_oracle_compile_query_dbresultinfo_defined
#line 1028 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
  struct pike_string * type;

#endif /* var_type_Oracle_oracle_compile_query_dbresultinfo_defined */

#ifdef var_define_handle_Oracle_oracle_compile_query_dbresultinfo_defined
#line 1030 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
OCIDefine *define_handle;
#endif /* var_define_handle_Oracle_oracle_compile_query_dbresultinfo_defined */

#ifdef var_data_Oracle_oracle_compile_query_dbresultinfo_defined
#line 1032 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
struct inout data;
#endif /* var_data_Oracle_oracle_compile_query_dbresultinfo_defined */
};
#ifdef PIKE_DEBUG
/* Ensure the struct is used in a variable declaration, or else gdb might not see it. */
static struct Oracle_oracle_compile_query_dbresultinfo_struct *Oracle_oracle_compile_query_dbresultinfo_gdb_dummy_ptr;
#endif
#line 1034 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
;


#undef internal_init_Oracle_oracle_compile_query_dbresultinfo_defined
#define internal_init_Oracle_oracle_compile_query_dbresultinfo_defined

#undef Oracle_oracle_compile_query_dbresultinfo_event_handler_defined
#define Oracle_oracle_compile_query_dbresultinfo_event_handler_defined
static void init_Oracle_oracle_compile_query_dbresultinfo_struct(void)
#line 1037 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
{
OWERR("%s\n",__FUNCTION__);
#ifdef PIKE_DEBUG
 ((unsigned long *)(Pike_fp->current_storage))[0]=DBRESINFO_MAGIC;
#endif
 THIS_RESULTINFO->define_handle=0;
init_inout(& THIS_RESULTINFO->data);
}


#undef Oracle_oracle_compile_query_dbresultinfo_gc_live_obj
#define Oracle_oracle_compile_query_dbresultinfo_gc_live_obj

#undef internal_exit_Oracle_oracle_compile_query_dbresultinfo_defined
#define internal_exit_Oracle_oracle_compile_query_dbresultinfo_defined

#undef Oracle_oracle_compile_query_dbresultinfo_event_handler_defined
#define Oracle_oracle_compile_query_dbresultinfo_event_handler_defined
static void exit_Oracle_oracle_compile_query_dbresultinfo_struct(void)
#line 1047 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
{
OWERR("%s\n",__FUNCTION__);
if(THIS_RESULTINFO->define_handle) {
debug_malloc_touch(THIS_RESULTINFO->define_handle);
OCIHandleFree(THIS_RESULTINFO->define_handle, OCI_HTYPE_DEFINE);
}
free_inout( & THIS_RESULTINFO->data);
}


#undef extra_Oracle_oracle_compile_query_dbresultinfo_defined
#define extra_Oracle_oracle_compile_query_dbresultinfo_defined
#line 1066 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
#ifdef ORACLE_DEBUG
 
#undef internal_gc_check_Oracle_oracle_compile_query_dbresultinfo_defined
#define internal_gc_check_Oracle_oracle_compile_query_dbresultinfo_defined

#undef Oracle_oracle_compile_query_dbresultinfo_event_handler_defined
#define Oracle_oracle_compile_query_dbresultinfo_event_handler_defined
static void gc_check_Oracle_oracle_compile_query_dbresultinfo_struct(void)
#line 1068 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
{
THIS_RESULTINFO;
}
#endif

static void protect_dbresultinfo(INT32 UNUSED(args))
{
Pike_error("You may not change variables in dbresultinfo objects.\n");
}

#ifdef Oracle_oracle_compile_query_dbresultinfo_event_handler_defined
static void Oracle_oracle_compile_query_dbresultinfo_event_handler(int ev) {
  switch(ev) {

#ifdef internal_init_Oracle_oracle_compile_query_dbresultinfo_defined
  case PROG_EVENT_INIT: init_Oracle_oracle_compile_query_dbresultinfo_struct(); break;

#endif /* internal_init_Oracle_oracle_compile_query_dbresultinfo_defined */

#ifdef internal_exit_Oracle_oracle_compile_query_dbresultinfo_defined
  case PROG_EVENT_EXIT: exit_Oracle_oracle_compile_query_dbresultinfo_struct(); break;

#endif /* internal_exit_Oracle_oracle_compile_query_dbresultinfo_defined */

#ifdef internal_gc_check_Oracle_oracle_compile_query_dbresultinfo_defined
  case PROG_EVENT_GC_CHECK: gc_check_Oracle_oracle_compile_query_dbresultinfo_struct(); break;

#endif /* internal_gc_check_Oracle_oracle_compile_query_dbresultinfo_defined */
  default: break; 
  }
}

#endif /* Oracle_oracle_compile_query_dbresultinfo_event_handler_defined */

#ifdef THIS_ORACLE_ORACLE_COMPILE_QUERY

#undef THIS
#define THIS THIS_ORACLE_ORACLE_COMPILE_QUERY

#endif /* THIS_ORACLE_ORACLE_COMPILE_QUERY */
/*! @endclass dbresultinfo
     */

/*! @class TypedResult
     */

#undef class_Oracle_oracle_compile_query_TypedResult_defined
#define class_Oracle_oracle_compile_query_TypedResult_defined
#line 1086 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
#ifdef PIKE_DEBUG
 
#undef var_magic_Oracle_oracle_compile_query_TypedResult_defined
#define var_magic_Oracle_oracle_compile_query_TypedResult_defined
#line 1088 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
#endif
 
#undef var_dbcon_lock_Oracle_oracle_compile_query_TypedResult_defined
#define var_dbcon_lock_Oracle_oracle_compile_query_TypedResult_defined

#undef var_dbquery_lock_Oracle_oracle_compile_query_TypedResult_defined
#define var_dbquery_lock_Oracle_oracle_compile_query_TypedResult_defined

#undef THIS
#define THIS ((struct Oracle_oracle_compile_query_TypedResult_struct *)(Pike_interpreter.frame_pointer->current_storage + Oracle_oracle_compile_query_TypedResult_storage_offset))

#undef THIS_ORACLE_ORACLE_COMPILE_QUERY_TYPEDRESULT
#define THIS_ORACLE_ORACLE_COMPILE_QUERY_TYPEDRESULT ((struct Oracle_oracle_compile_query_TypedResult_struct *)(Pike_interpreter.frame_pointer->current_storage + Oracle_oracle_compile_query_TypedResult_storage_offset))

#undef OBJ2_ORACLE_ORACLE_COMPILE_QUERY_TYPEDRESULT
#define OBJ2_ORACLE_ORACLE_COMPILE_QUERY_TYPEDRESULT(o) ((struct Oracle_oracle_compile_query_TypedResult_struct *)(o->storage+Oracle_oracle_compile_query_TypedResult_storage_offset+Oracle_oracle_compile_query_TypedResult_program->inherits[0].storage_offset))

#undef GET_ORACLE_ORACLE_COMPILE_QUERY_TYPEDRESULT_STORAGE
#define GET_ORACLE_ORACLE_COMPILE_QUERY_TYPEDRESULT_STORAGE(o) ((struct Oracle_oracle_compile_query_TypedResult_struct *)(o->storage+Oracle_oracle_compile_query_TypedResult_storage_offset+Oracle_oracle_compile_query_TypedResult_program->inherits[0].storage_offset))
static ptrdiff_t Oracle_oracle_compile_query_TypedResult_storage_offset;
struct Oracle_oracle_compile_query_TypedResult_struct {

#ifdef var_magic_Oracle_oracle_compile_query_TypedResult_defined
#line 1087 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
unsigned long magic;
#endif /* var_magic_Oracle_oracle_compile_query_TypedResult_defined */

#ifdef var_dbcon_lock_Oracle_oracle_compile_query_TypedResult_defined
#line 1089 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
char dbcon_lock;
#endif /* var_dbcon_lock_Oracle_oracle_compile_query_TypedResult_defined */

#ifdef var_dbquery_lock_Oracle_oracle_compile_query_TypedResult_defined
#line 1090 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
char dbquery_lock;
#endif /* var_dbquery_lock_Oracle_oracle_compile_query_TypedResult_defined */
};
#ifdef PIKE_DEBUG
/* Ensure the struct is used in a variable declaration, or else gdb might not see it. */
static struct Oracle_oracle_compile_query_TypedResult_struct *Oracle_oracle_compile_query_TypedResult_gdb_dummy_ptr;
#endif
#line 1092 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
;


#undef internal_init_Oracle_oracle_compile_query_TypedResult_defined
#define internal_init_Oracle_oracle_compile_query_TypedResult_defined

#undef Oracle_oracle_compile_query_TypedResult_event_handler_defined
#define Oracle_oracle_compile_query_TypedResult_event_handler_defined
static void init_Oracle_oracle_compile_query_TypedResult_struct(void)
#line 1095 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
{
OWERR("%s\n",__FUNCTION__);
#ifdef PIKE_DEBUG
 ((unsigned long *)(Pike_fp->current_storage))[0]=DBRESULT_MAGIC;
#endif
 THIS_RESULT->dbcon_lock=0;
THIS_RESULT->dbquery_lock=0;
THIS_RESULT_DBCON->resultobject_busy = 1;
}


#undef Oracle_oracle_compile_query_TypedResult_gc_live_obj
#define Oracle_oracle_compile_query_TypedResult_gc_live_obj

#undef internal_exit_Oracle_oracle_compile_query_TypedResult_defined
#define internal_exit_Oracle_oracle_compile_query_TypedResult_defined

#undef Oracle_oracle_compile_query_TypedResult_event_handler_defined
#define Oracle_oracle_compile_query_TypedResult_event_handler_defined
static void exit_Oracle_oracle_compile_query_TypedResult_struct(void)
#line 1106 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
{
struct Oracle_oracle_compile_query_struct *dbquery = THIS_RESULT_QUERY;
OWERR("%s\n",__FUNCTION__);
/* Variables are freed automatically */
if(THIS_RESULT->dbquery_lock && dbquery)
{
struct Oracle_oracle_struct *dbcon = THIS_RESULT_DBCON;
dbcon->resultobject_busy = 0;
UNLOCK( dbquery->lock );
if(THIS_RESULT->dbcon_lock && dbcon)
{
UNLOCK( dbcon->lock );
}
}
else
{
OWERR("exit_dbresult_struct %p %p\n",
PARENTOF(THISOBJ),
PARENTOF(THISOBJ)?PARENTOF(THISOBJ)->prog:0);
}
}

/*! @decl inherit __builtin.Sql.Result
       */

#undef inherit_cq__22__builtin_2ESql_2EResult_22_Oracle_oracle_compile_query_TypedResult_defined
#define inherit_cq__22__builtin_2ESql_2EResult_22_Oracle_oracle_compile_query_TypedResult_defined
#line 1130 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
static int Oracle_oracle_compile_query_TypedResult_cq__22__builtin_2ESql_2EResult_22_inh_num = -1;

#ifdef Oracle_oracle_compile_query_TypedResult_cq__22__builtin_2ESql_2EResult_22_inh_offset_used
#line 1130 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
static int Oracle_oracle_compile_query_TypedResult_cq__22__builtin_2ESql_2EResult_22_inh_offset = -1;

#endif /* Oracle_oracle_compile_query_TypedResult_cq__22__builtin_2ESql_2EResult_22_inh_offset_used */

#ifdef Oracle_oracle_compile_query_TypedResult_cq__22__builtin_2ESql_2EResult_22_inh_storage_offset_used
#line 1130 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
static int Oracle_oracle_compile_query_TypedResult_cq__22__builtin_2ESql_2EResult_22_inh_storage_offset = -1;

#endif /* Oracle_oracle_compile_query_TypedResult_cq__22__builtin_2ESql_2EResult_22_inh_storage_offset_used */
#define f_Oracle_oracle_compile_query_TypedResult_num_rows_defined
DEFAULT_CMOD_STORAGE void f_Oracle_oracle_compile_query_TypedResult_num_rows(INT32 args) {
#line 1132 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
if(args != 0) wrong_number_of_args_error("num_rows",args,0);
{
struct Oracle_oracle_compile_query_struct *dbquery = THIS_RESULT_QUERY;
struct Oracle_oracle_struct *dbcon = THIS_RESULT_DBCON;

OWERR("%s\n",__FUNCTION__);

sword rc;
ub4 rows;

THREADS_ALLOW();

/*  LOCK(dbcon->lock);  */

rc=OCIAttrGet(dbquery->statement,
OCI_HTYPE_STMT,
&rows,
0,
OCI_ATTR_ROW_COUNT,
dbcon->error_handle); /* <- FIXME */

THREADS_DISALLOW();
/*  UNLOCK(dbcon->lock); */

if(rc != OCI_SUCCESS)
ora_error_handler(dbcon->error_handle, rc, "OCIAttrGet");

push_int(rows);
}

}
#define f_Oracle_oracle_compile_query_TypedResult_num_fields_defined
DEFAULT_CMOD_STORAGE void f_Oracle_oracle_compile_query_TypedResult_num_fields(INT32 args) {
#line 1162 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
if(args != 0) wrong_number_of_args_error("num_fields",args,0);
{
struct Oracle_oracle_compile_query_TypedResult_struct *dbresult = THIS_RESULT;
struct Oracle_oracle_compile_query_struct *dbquery = THIS_RESULT_QUERY;
struct Oracle_oracle_struct *dbcon = THIS_RESULT_DBCON;

OWERR("%s\n",__FUNCTION__);

if(dbquery->cols == -2)
{
sword rc;
ub4 columns;

THREADS_ALLOW();

/*    LOCK(dbcon->lock);  */

rc=OCIAttrGet(dbquery->statement,
OCI_HTYPE_STMT,
&columns,
0,
OCI_ATTR_PARAM_COUNT,
dbcon->error_handle); /* <- FIXME */


THREADS_DISALLOW();
/*    UNLOCK(dbcon->lock); */

if(rc != OCI_SUCCESS)
ora_error_handler(dbcon->error_handle, rc,"OCIAttrGet");

dbquery->cols = columns; /* -1 ? */
}
push_int(dbquery->cols);
}

}
#line 1198 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
static sb4 output_callback(struct inout *inout,
ub4 UNUSED(index),
void **bufpp,
ub4 **alenpp,
ub1 *piecep,
dvoid **indpp,
ub2 **rcodepp)
{
OWERR("%s(inout %p[%d], index %d, bufpp %p[%p], alenpp %p[%p[%d]], piecep %p[%d], indpp %p[%p], rcodepp %p[%d])\n",
__FUNCTION__, inout, inout->ftype, index, bufpp, *bufpp,
alenpp, *alenpp, (*alenpp)?(**alenpp):0,
piecep, *piecep, indpp, *indpp, rcodepp, *rcodepp);

CHECK_INTERPRETER_LOCK();

debug_malloc_touch(bufpp);
debug_malloc_touch(*bufpp);
debug_malloc_touch(alenpp);
debug_malloc_touch(*alenpp);
debug_malloc_touch(indpp);
debug_malloc_touch(*indpp);
debug_malloc_touch(rcodepp);
debug_malloc_touch(*rcodepp);

inout->has_output=1;
*indpp = (dvoid *) &inout->indicator;
*rcodepp=&inout->rcode;
*alenpp= (ub4 *) &inout->xlen;

OWERR("  indicator:%p (%p), rcode: %d (%p), xlen: %d (%p)\n",
inout->indicator, *indpp, inout->rcode, *rcodepp, inout->xlen, *alenpp);

switch(inout->ftype)
{
default:
OWERR("Unhandled data type in %s: %d\n",__FUNCTION__,inout->ftype);

case SQLT_CHR:
case SQLT_STR:
case SQLT_LBI:
case SQLT_LNG:
if(!STRING_BUILDER_STR(inout->output))
{
OWERR("New string builder.\n");
init_string_builder(& inout->output,0);
}else{
OWERR("Grow string builder (%d + %d).\n",
STRING_BUILDER_LEN(inout->output), inout->xlen);
STRING_BUILDER_LEN(inout->output)+=inout->xlen;
}

inout->xlen = BLOCKSIZE;
*bufpp = string_builder_allocate (&inout->output, inout->xlen, 0);
STRING_BUILDER_LEN(inout->output) -= inout->xlen;
OWERR("Grown string builder: %d (malloced: %d).\n",
STRING_BUILDER_LEN(inout->output),
inout->output.malloced);
*piecep = OCI_NEXT_PIECE;
#ifdef ORACLE_DEBUG
 memset(*bufpp, '#', inout->xlen);
((char *)*bufpp)[inout->xlen-1]=0;
#endif
 return OCI_CONTINUE;

case SQLT_CLOB:
case SQLT_BLOB:
inout->u.lob = 0;
if (OCIDescriptorAlloc((dvoid *) get_oracle_environment(),
(dvoid **) &inout->u.lob,
(ub4)OCI_DTYPE_LOB,
(size_t) 0,
(dvoid **) 0)) {
OWERR("OCIDescriptorAlloc failed!\n");
inout->u.lob = 0;
}
*bufpp = inout->u.lob;
inout->xlen = -1;
*piecep = OCI_ONE_PIECE;
return OCI_CONTINUE;

case SQLT_FLT:
*bufpp=&inout->u.f;
inout->xlen=sizeof(inout->u.f);
*piecep = OCI_ONE_PIECE;
return OCI_CONTINUE;

case SQLT_INT:
*bufpp=&inout->u.i;
inout->xlen=sizeof(inout->u.i);
*piecep = OCI_ONE_PIECE;
return OCI_CONTINUE;

case SQLT_VNU:
*bufpp=&inout->u.num;
inout->xlen=sizeof(inout->u.num);
*piecep = OCI_ONE_PIECE;
return OCI_CONTINUE;

case SQLT_ODT:
*bufpp=&inout->u.date;
inout->xlen=sizeof(inout->u.date);
*piecep = OCI_ONE_PIECE;
return OCI_CONTINUE;

}
return 0;
}

/* NOTE: May be called by OCIStmtFetch() in a THREADS_ALLOW context. */
static sb4 define_callback(dvoid *dbresultinfo,
OCIDefine *UNUSED(def),
ub4 iter,
dvoid **bufpp,
ub4 **alenpp,
ub1 *piecep,
dvoid **indpp,
ub2 **rcodep)
{
sb4 res;
OWERR("%s ..",__FUNCTION__);

res =
output_callback( &((struct Oracle_oracle_compile_query_dbresultinfo_struct *)dbresultinfo)->data,
iter,
bufpp,
alenpp,
piecep,
indpp,
rcodep);

OWERR("  ==> %d (buf: %p[%d])\n", res, *bufpp, **alenpp);
return res;
}

#define f_Oracle_oracle_compile_query_TypedResult_fetch_fields_defined
DEFAULT_CMOD_STORAGE void f_Oracle_oracle_compile_query_TypedResult_fetch_fields(INT32 args) {
#line 1332 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
if(args != 0) wrong_number_of_args_error("fetch_fields",args,0);
{
struct Oracle_oracle_compile_query_TypedResult_struct *dbresult = THIS_RESULT;
struct Oracle_oracle_compile_query_struct *dbquery = THIS_RESULT_QUERY;
struct Oracle_oracle_struct *dbcon = THIS_RESULT_DBCON;
INT32 i;
sword rc;

OWERR("%s\n",__FUNCTION__);

if(!dbquery->field_info)
{
/* Get the number of rows */
if(dbquery->cols == -2)
{
f_Oracle_oracle_compile_query_TypedResult_num_fields(0);
pop_stack();
}

check_stack(dbquery->cols);

for(i=0; i<dbquery->cols; i++)
{
char *errfunc=0;
OCIParam *column_parameter;
ub2 type;
ub2 size;
sb1 scale;
char *name;
ub4 namelen;
struct object *o;
struct Oracle_oracle_compile_query_dbresultinfo_struct *info;
char *type_name;
int data_size;
char *addr;

/*      pike_gdb_breakpoint(); */
THREADS_ALLOW();
/*      LOCK(dbcon->lock); */

do {
rc=OCIParamGet(dbquery->statement,OCI_HTYPE_STMT,
dbcon->error_handle,
(void **)&column_parameter,
i+1);

if(!IS_SUCCESS(rc)) { errfunc="OciParamGet"; break; }

rc=OCIAttrGet((void *)column_parameter,
OCI_DTYPE_PARAM,
&type,
(ub4*)NULL,
OCI_ATTR_DATA_TYPE,
dbcon->error_handle);

if(!IS_SUCCESS(rc)) { errfunc="OCIAttrGet, OCI_ATTR_DATA_TYPE"; break;}

rc=OCIAttrGet((void *)column_parameter,
OCI_DTYPE_PARAM,
&size,
(ub4*)NULL,
OCI_ATTR_DATA_SIZE,
dbcon->error_handle);

if(!IS_SUCCESS(rc)) { errfunc="OCIAttrGet, OCI_ATTR_DATA_SIZE"; break;}

rc=OCIAttrGet((void *)column_parameter,
OCI_DTYPE_PARAM,
&scale,
(ub4*)NULL,
OCI_ATTR_SCALE,
dbcon->error_handle);

if(!IS_SUCCESS(rc)) { errfunc="OCIAttrGet, OCI_ATTR_SCALE"; break;}

rc=OCIAttrGet((void *)column_parameter,
OCI_DTYPE_PARAM,
&name,
&namelen,
OCI_ATTR_NAME,
dbcon->error_handle);

if(!IS_SUCCESS(rc)) { errfunc="OCIAttrGet, OCI_ATTR_NAME"; break;}

}while(0);

THREADS_DISALLOW();
/*      UNLOCK(dbcon->lock); */

if(!IS_SUCCESS(rc))
ora_error_handler(dbcon->error_handle, rc, errfunc);

/* name[namelen]=0; */
OWERR("FIELD: name=%.*s length=%d type=%d\n",
namelen,name,size,type);

push_object( o=clone_object(Oracle_oracle_compile_query_dbresultinfo_program,0) );
info= (struct Oracle_oracle_compile_query_dbresultinfo_struct *)STORAGE(o);

info->name=make_shared_binary_string(name, namelen);
#ifdef OCI_UTF16ID
 ORACLE_UNICODE_DECODE(info->name);
#endif
 info->length=size;
info->decimals=scale;
info->real_type=type;

addr = (char *)&info->data.u;

data_size=0;

switch(type)
{
case SQLT_INT:
type_name="int";
data_size=sizeof(info->data.u.i);
type=SQLT_INT;
break;

case SQLT_NUM:
type_name="number";
if(scale>0)
{
data_size=sizeof(info->data.u.f);
type=SQLT_FLT;
}else{
#if 0
 data_size=sizeof(info->data.u.i);
type=SQLT_INT;
#else

data_size=sizeof(info->data.u.num);
#ifdef ORACLE_DEBUG
 /* 	    OCINumberSetZero(dbcon->error_handle, &info->data.u.num); */
memset(&info->data.u.num, 0, data_size);
#endif
 type=SQLT_VNU;
#endif
 }
break;

case SQLT_FLT:
type_name="float";
data_size=sizeof(info->data.u.f);
type=SQLT_FLT;
break;

case SQLT_INTERVAL_YM:
case SQLT_INTERVAL_DS:
case SQLT_TIMESTAMP:
case SQLT_TIMESTAMP_TZ:
case SQLT_TIMESTAMP_LTZ:
/* Assume a reasonable expansion. */
size *= 10;
/* FALLTHRU */
case SQLT_STR: /* string */
case SQLT_AFC: /* char */
case SQLT_AVC: /* charz */

case SQLT_CHR: /* varchar2 */
case SQLT_VCS: /* varchar */
case SQLT_LNG: /* long */
case SQLT_LVC: /* long varchar */
type_name="string";

if (size > 0) {
type = SQLT_CHR;
data_size = size;
#ifdef OCI_UTF16ID
 data_size *= sizeof(utext);
size *= sizeof(utext);
#endif
 addr = info->data.u.buf = xalloc(size);
OWERR("Allocated %ld bytes at %p for field.\n", (long)size, addr);
} else {
/* Unknown size. */
type = SQLT_LNG;
data_size = -1;
addr = NULL;
}
break;

case SQLT_CLOB:
case SQLT_BLOB:
if(type == SQLT_BLOB)
type_name = "blob";
else
type_name="clob";
data_size=-1;
break;

case SQLT_RID:
case SQLT_RDD:
type_name="rowid";
data_size=-1;
type=SQLT_LNG;
break;

case SQLT_DATE:
case SQLT_DAT:
case SQLT_ODT:
type_name="date";
data_size=sizeof(info->data.u.date);
type=SQLT_ODT;
break;

case SQLT_BIN: /* raw */
case SQLT_VBI: /* varraw */
case SQLT_LBI: /* long raw */
type_name="raw";
data_size=-1;
type=SQLT_LBI;
/*** dynamic ****/
break;

case SQLT_LAB:
type_name="mslabel";
type=SQLT_LBI;
data_size=-1;
break;


default:
type_name="unknown";
type=SQLT_LBI;
data_size=-1;
break;
}

info->data.ftype=type;

if(type_name)
info->type=make_shared_string(type_name);

rc=OCIDefineByPos(dbquery->statement,
&info->define_handle,
dbcon->error_handle,
i+1,
/* NOTE: valuep is ignored in
			       * OCI_DYNAMIC_FETCH mode. */
addr,
#ifdef STATIC_BUFFERS
 data_size<0? STATIC_BUFFERS :data_size,
#else
 /* But value_sz is used as the maximum piece
			       * size if OCIDefineDynamic() is used. */
data_size<0? BLOCKSIZE :data_size,
#endif
 type,
& info->data.indicator,
& info->data.len,
& info->data.rcode,
#ifdef STATIC_BUFFERS
 (type == SQLT_CLOB || type == SQLT_BLOB )? OCI_DYNAMIC_FETCH : 0
#else
 /* No need to use callbacks for fixed-length fields. */
data_size<0? OCI_DYNAMIC_FETCH :0
#endif
 );

OWERR("data_size=%d type=%d SQLT_INT=%d\n",
data_size, type, SQLT_INT);

if(!IS_SUCCESS(rc))
ora_error_handler(dbcon->error_handle, rc, "OCIDefineByPos");

#if !defined(STATIC_BUFFERS) && !defined(POLLING_FETCH)
 if (data_size < 0) {
rc=OCIDefineDynamic(info->define_handle,
dbcon->error_handle,
info,
define_callback);
if(!IS_SUCCESS(rc))
ora_error_handler(dbcon->error_handle, rc, "OCIDefineDynamic");
}
#endif
#if defined(STATIC_BUFFERS)
 if (type == SQLT_CLOB || type == SQLT_BLOB) {
rc=OCIDefineDynamic(info->define_handle,
dbcon->error_handle,
info,
define_callback);
if(!IS_SUCCESS(rc))
ora_error_handler(dbcon->error_handle, rc, "OCIDefineDynamic");
}
#endif
 debug_malloc_touch(dbcon->error_handle);
debug_malloc_touch(dbquery->statement);
debug_malloc_touch(info->define_handle);
}
f_aggregate(dbquery->cols);
add_ref( dbquery->field_info=Pike_sp[-1].u.array );
}else{
ref_push_array( dbquery->field_info);
}
}

}
#line 1629 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
static void push_inout_value(struct inout *inout,
struct Oracle_oracle_struct *dbcon)
{
ub4 loblen = 0;
ub1 *bufp = 0;
ub4 amtp = 0;
char buffer[100];
sword rc;
sb4 bsize=100;
int rslt;
char *errfunc=0;
sword ret;

OWERR("%s .. (type = %d, indicator = %d, len= %d)\n",
__FUNCTION__,inout->ftype,inout->indicator, inout->xlen);

if(inout->indicator)
{
switch(inout->ftype)
{
case SQLT_INTERVAL_YM:
case SQLT_INTERVAL_DS:
case SQLT_TIMESTAMP:
case SQLT_TIMESTAMP_TZ:
case SQLT_TIMESTAMP_LTZ:
case SQLT_CLOB:
case SQLT_BLOB:
case SQLT_BIN:
case SQLT_LBI:
case SQLT_AFC:
case SQLT_LAB:
case SQLT_LNG:
case SQLT_CHR:
case SQLT_STR:
ref_push_object(nullstring_object);
break;

case SQLT_DATE:
case SQLT_ODT:
case SQLT_DAT:
ref_push_object(nulldate_object);
break;

case SQLT_NUM:
case SQLT_VNU:
case SQLT_INT:
ref_push_object(nullint_object);
break;

case SQLT_FLT:
ref_push_object(nullfloat_object);
break;

default:
Pike_error("Unknown data type.\n");
break;
}
return;
}

switch(inout->ftype)
{
case SQLT_CHR:
OWERR("Buffer is %p (%ld bytes)\n", inout->u.buf, inout->len);
push_string(make_shared_binary_string(inout->u.buf,inout->len));
#ifdef OCI_UTF16ID
 push_int(2);
f_unicode_to_string(2);
#endif
 break;
case SQLT_BIN:
case SQLT_LBI:
case SQLT_AFC:
case SQLT_LAB:
case SQLT_LNG:
case SQLT_STR:

#ifdef STATIC_BUFFERS
 if(!STRING_BUILDER_STR(inout->output))
{
push_string(make_shared_binary_string(inout->u.str,inout->len));
#ifdef OCI_UTF16ID
 if(inout->ftype != SQLT_LBI && inout->ftype != SQLT_BIN) {
push_int(2);
f_unicode_to_string(2);
}
#endif
 break;
}
#endif
 STRING_BUILDER_LEN(inout->output) += inout->xlen;
if(inout->ftype == SQLT_STR)
STRING_BUILDER_LEN(inout->output)--;

#if 0
 for(ret=0;ret<STRING_BUILDER_LEN(inout->output);ret++)
fprintf(stderr,"%02x ",((unsigned char *)inout->output.s->str)[ret]);
fprintf(stderr,"\n");
#endif

inout->xlen=0;
OWERR("  STRING_BUILDER_LEN(inout->output): %d\n",
STRING_BUILDER_LEN(inout->output));
push_string(finish_string_builder(& inout->output));
#ifdef OCI_UTF16ID
 if(inout->ftype != SQLT_LBI && inout->ftype != SQLT_BIN) {
push_int(2);
f_unicode_to_string(2);
}
#endif
 STRING_BUILDER_STR(inout->output)=0;;
break;

case SQLT_CLOB:
case SQLT_BLOB:
/* FIXME: Consider using parent pointers? */
push_object(fast_clone_object(Oracle_oracle_LOB_program));
((struct Oracle_oracle_LOB_struct *)STORAGE(Pike_sp[-1].u.object))->is_clob =
(inout->ftype == SQLT_CLOB);
((struct Oracle_oracle_LOB_struct *)STORAGE(Pike_sp[-1].u.object))->lob =
inout->u.lob;
((struct Oracle_oracle_LOB_struct *)STORAGE(Pike_sp[-1].u.object))->dbcon =
dbcon;
break;

case SQLT_DATE:
case SQLT_ODT:
case SQLT_DAT:
#if 0
 for(ret=0;ret<sizeof(inout->u.date);ret++)
fprintf(stderr,"%02x ",((unsigned char *)&inout->u.date)[ret]);
fprintf(stderr,"\n");
#endif

push_object(fast_clone_object(Oracle_oracle_Date_program));
((struct Oracle_oracle_Date_struct *)STORAGE(Pike_sp[-1].u.object))->date =
inout->u.date;
break;

case SQLT_NUM:
/* Kluge -- Convert it to a VNU. */
memmove(inout->u.shortstr+1,inout->u.shortstr,inout->xlen);
inout->u.shortstr[0]=inout->xlen;

/* FALLTHRU */
case SQLT_VNU:
{
INT64 integer;

#if 0
 for(ret=0;ret<22;ret++)
fprintf(stderr,"%02x ",((unsigned char *)&inout->u.num)[ret]);
fprintf(stderr,"\n");
#endif

ret=OCINumberToInt(dbcon->error_handle,
&inout->u.num,
sizeof(integer),
OCI_NUMBER_SIGNED,
&integer);

if(IS_SUCCESS(ret))
{
push_int64(integer);
}else{
unsigned char buffer[80];
ub4 buf_size=sizeof(buffer)-1;
#ifdef OCI_UTF16ID
 /* NB: UTF16 in native byte-order. */
static const utext FMT[] = {
'F', 'M',
'9', '9', '9', '9', '9', '9', '9', '9', '9', '9',
'9', '9', '9', '9', '9', '9', '9', '9', '9', '9',
'9', '9', '9', '9', '9', '9', '9', '9', '9', '9',
'9', '9', '9', '9', '9', '9', '9', '9',
};
#define FMT_LEN	sizeof(FMT)
#else
#define FMT "FM99999999999999999999999999999999999999"
#define FMT_LEN	(sizeof(FMT) - sizeof(""))
#endif
 /* There should be no more than 38 '9':s in the FMT string. Oracle only
	       * allows 38 digits of precision, and can cause an "ORA-22061: invalid
	       * format text" if the format string requests more digits than this.
	       */

ret=OCINumberToText(dbcon->error_handle,
&inout->u.num,
(oratext *)FMT,
FMT_LEN,
0,
0,
&buf_size,
buffer);
if(IS_SUCCESS(ret))
{
push_string(make_shared_binary_string((char *)buffer, buf_size));
#ifdef OCI_UTF16ID
 push_int(2);
f_unicode_to_string(2);
#endif
 convert_stack_top_to_bignum();
}
else
ora_error_handler(dbcon->error_handle, ret, "OCINumberToInt");
}
}
break;

case SQLT_INT:
push_int64(inout->u.i);
break;

case SQLT_FLT:
/* We might need to push a Matrix here */
push_float((FLOAT_TYPE)inout->u.f);
break;

default:
Pike_error("Unknown data type.\n");
break;
}
/* free_inout(inout); */
}

static void init_inout(struct inout *i)
{
STRING_BUILDER_STR(i->output)=0;
i->has_output=0;
i->xlen=0;
i->len=0;
i->indicator=0;
OWERR("Zapping inout buf: %p\n", i->u.buf);
i->u.buf = NULL;
}

static void free_inout(struct inout *i)
{
if (i->ftype == SQLT_CHR) {
if (i->u.buf) {
OWERR("Freeing inout buf: %p\n", i->u.buf);
free(i->u.buf);
i->u.buf = NULL;
}
}
if(STRING_BUILDER_STR(i->output))
{
free_string_builder(& i->output);
init_inout(i);
}
}


#define f_Oracle_oracle_compile_query_TypedResult_eof_defined
DEFAULT_CMOD_STORAGE void f_Oracle_oracle_compile_query_TypedResult_eof(INT32 args) {
#line 1882 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
if(args != 0) wrong_number_of_args_error("eof",args,0);
{
struct Oracle_oracle_compile_query_struct *dbquery = THIS_RESULT_QUERY;
/* Note: Valid OCI statement types start at 1.
	 *       We use 0 to indicate EOF.
	 */
push_int(!dbquery->query_type);
}

}
#define f_Oracle_oracle_compile_query_TypedResult_fetch_row_defined
DEFAULT_CMOD_STORAGE void f_Oracle_oracle_compile_query_TypedResult_fetch_row(INT32 args) {
#line 1891 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
if(args != 0) wrong_number_of_args_error("fetch_row",args,0);
{
int i = 0;
sword rc;
struct Oracle_oracle_compile_query_TypedResult_struct *dbresult = THIS_RESULT;
struct Oracle_oracle_compile_query_struct *dbquery = THIS_RESULT_QUERY;
struct Oracle_oracle_struct *dbcon = THIS_RESULT_DBCON;

OWERR("%s ..",__FUNCTION__);

if (!dbquery->query_type) {
/* EOF already reached. */
OWERR(" EOF already reached.\n", rc);
push_undefined();
return;
}

if(!dbquery->field_info)
{
f_Oracle_oracle_compile_query_TypedResult_fetch_fields(0);
pop_stack();
}

do {
#if defined(STATIC_BUFFERS) || defined(POLLING_FETCH)
 /* NOTE: output_callback() is currently not safe to run
	   *       in a THREADS_ALLOW() context.
	   */
THREADS_ALLOW();
#endif
#ifdef ORACLE_DEBUG
 WERR("OCIStmtFetch\n");
{
static text msgbuf[512];
ub4 errcode;
OCIErrorGet(dbcon->error_handle,1,0,&errcode,
msgbuf,sizeof(msgbuf),OCI_HTYPE_ERROR);
WERR("  Before: errcode=%d:%s\n", errcode, msgbuf);
}
#endif
 rc=OCIStmtFetch(dbquery->statement,
dbcon->error_handle,
1,
OCI_FETCH_NEXT,
OCI_DEFAULT);
OWERR("OCIStmtFetch done rc=%d\n", rc);
#if defined(STATIC_BUFFERS) || defined(POLLING_FETCH)
 THREADS_DISALLOW();
#endif

if(rc==OCI_NO_DATA)
{
/* No more rows int the result.
	     * NB: Oracle will complain with:
	     *       ORA-01002: fetch out of sequence
	     *     if any further attempts to fetch rows are performed.
	     */
dbquery->query_type = 0;
push_undefined();
return;
}
#ifdef POLLING_FETCH
 if (rc == OCI_NEED_DATA) {
OCIDefine *define;
ub4 htype;
ub1 direction;
ub4 iter;
ub4 index;
ub1 piece;
ub4 ret = OCIStmtGetPieceInfo(dbquery->statement,
dbcon->error_handle,
(void **)&define,
&htype,
&direction,
&iter,
&index,
&piece);
struct Oracle_oracle_compile_query_dbresultinfo_struct *info = NULL;
struct inout *inout;
char *buf;

if (!IS_SUCCESS(ret))
ora_error_handler(dbcon->error_handle, ret, "OCIStmtGetPieceInfo");
OWERR("OCIStmtGetPieceInfo ==>\n"
"  define: %p\n"
"  htype: %d\n"
"  direction: %d\n"
"  iter: %d\n"
"  index: %d\n"
"  piece: %d\n",
define, htype, direction, iter, index, piece);
if (htype != OCI_HTYPE_DEFINE)
break; /* Not supported. */
/* NOTE: Columns come in order, so there's no need to
	     *       rescan the first columns in every pass.
	     */
for (; i < dbquery->field_info->size; i++) {
if (TYPEOF(dbquery->field_info->item[i]) == T_OBJECT) {
struct object *o = dbquery->field_info->item[i].u.object;
if (o->prog == Oracle_oracle_compile_query_dbresultinfo_program) {
struct Oracle_oracle_compile_query_dbresultinfo_struct *in =
(struct Oracle_oracle_compile_query_dbresultinfo_struct *)STORAGE(o);
if (in->define_handle == define) {
info = in;
OWERR("Found info %p for define %p (i:%d)\n", in, define, i);
break;
}
}
}
}
if (!info) {
/* Not found! */
OWERR("Failed to find info for define %p\n", define);
break;
}
inout = &info->data;
if ((inout->ftype != SQLT_LNG) && (inout->ftype != SQLT_LBI)) {
/* Unsupported */
OWERR("Piecewise access for ftype %d not supported.\n", inout->ftype);
break;
}
if(!STRING_BUILDER_STR(inout->output))
{
OWERR("New string builder.\n");
init_string_builder(& inout->output,0);
}else{
OWERR("Grow string builder (%d + %d).\n",
STRING_BUILDER_LEN(inout->output), inout->xlen);
STRING_BUILDER_LEN(inout->output)+=inout->xlen;
}

inout->xlen = BLOCKSIZE;
buf = string_builder_allocate (&inout->output, inout->xlen, 0);
STRING_BUILDER_LEN(inout->output) -= inout->xlen;
OWERR("Grown string builder: %d (malloced: %d).\n",
STRING_BUILDER_LEN(inout->output),
inout->output.malloced);
/* piece = OCI_NEXT_PIECE; */
#ifdef ORACLE_DEBUG
 memset(buf, '#', inout->xlen);
buf[inout->xlen-1]=0;
#endif
 ret = OCIStmtSetPieceInfo(define, htype, dbcon->error_handle,
buf, &inout->xlen, piece,
&inout->indicator,
&inout->rcode);
if(!IS_SUCCESS(ret))
ora_error_handler(dbcon->error_handle, rc, "OCIStmtSetPieceInfo");
}
#else /* !POLLING_FETCH */
 break;
#endif /* POLLING_FETCH */
 } while (rc == OCI_NEED_DATA);

if(!IS_SUCCESS(rc))
ora_error_handler(dbcon->error_handle, rc, "OCIStmtFetch");

check_stack(dbquery->cols);

for(i=0;i<dbquery->cols;i++)
{
if(TYPEOF(dbquery->field_info->item[i]) == T_OBJECT &&
dbquery->field_info->item[i].u.object->prog == Oracle_oracle_compile_query_dbresultinfo_program)
{
struct Oracle_oracle_compile_query_dbresultinfo_struct *info;
info=(struct Oracle_oracle_compile_query_dbresultinfo_struct *)STORAGE(dbquery->field_info->item[i].u.object);

/* Extract data from 'info' */
push_inout_value(& info->data, dbcon);
}
}
f_aggregate(dbquery->cols);
}

}
#line 2065 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
struct bind
{
OCIBind *bind;
struct svalue ind; /* The name of the input/output variable */

struct svalue val; /* The input value */
void *addr;
int len;
sb2 indicator;

struct inout data;
};

struct bind_block
{
struct bind *bind;
int bindnum;
};

static sb4 input_callback(void *vbind_struct,
OCIBind *UNUSED(bindp),
ub4 UNUSED(iter),
ub4 UNUSED(index),
void **bufpp,
ub4 *alenp,
ub1 *piecep,
dvoid **indpp)
{
struct bind * bind = (struct bind *)vbind_struct;
OWERR("%s: bind{addr:%p, len:%d}",
__FUNCTION__, bind->addr, bind->len);

*bufpp = bind->addr;
*alenp = bind->len;
*indpp = (dvoid *) &bind->ind;
*piecep = OCI_ONE_PIECE;

return OCI_CONTINUE;
}

static sb4 bind_output_callback(void *vbind_struct,
OCIBind *UNUSED(bindp),
ub4 iter,
ub4 UNUSED(index),
void **bufpp,
ub4 **alenpp,
ub1 *piecep,
dvoid **indpp,
ub2 **rcodepp)
{
struct bind * bind = (struct bind *)vbind_struct;
OWERR("Output... %ld\n",(long)bind->data.xlen);

output_callback( &bind->data,
iter,
bufpp,
alenpp,
piecep,
indpp,
rcodepp);

return OCI_CONTINUE;
}

static void free_bind_block(struct bind_block *bind)
{

OWERR("%s\n",__FUNCTION__);

while(bind->bindnum>=0)
{
free_svalue( & bind->bind[bind->bindnum].ind);
if (TYPEOF(bind->bind[bind->bindnum].val) == T_MULTISET) {
sub_msnode_ref(bind->bind[bind->bindnum].val.u.multiset);
}
free_svalue( & bind->bind[bind->bindnum].val);
free_inout(& bind->bind[bind->bindnum].data);
bind->bindnum--;
}
if (bind->bind) {
free(bind->bind);
bind->bind = NULL;
}
}

/*
       * FIXME: This function should probably lock the statement
       * handle until it is freed...
       */
#define f_Oracle_oracle_compile_query_TypedResult_create_defined
DEFAULT_CMOD_STORAGE void f_Oracle_oracle_compile_query_TypedResult_create(INT32 args) {
#line 2154 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
struct mapping * bnds;
struct svalue * autocommit_sval;
struct object * new_parent;
#line 2156 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
int new_parent_inh_num;
#ifdef PIKE_DEBUG
if(args < 0) Pike_fatal("CMOD function argument negative.\n");
#else
STATIC_ASSUME(args >= 0);
#endif
#line 2154 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
if(args > 3) wrong_number_of_args_error("create",args,3);
#line 2154 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
if (args > 0 &&
    (TYPEOF(Pike_sp[0-args]) != PIKE_T_INT ||
     Pike_sp[0-args].u.integer)) {
#line 2154 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
if(TYPEOF(Pike_sp[0-args]) != PIKE_T_MAPPING) SIMPLE_ARG_TYPE_ERROR("create",1,"mapping(string:mixed)|void");
#line 2154 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
debug_malloc_pass(bnds=Pike_sp[0-args].u.mapping);
#line 2154 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
} else bnds = NULL;
if ((args > 1) &&
    ((TYPEOF(Pike_sp[1-args]) != PIKE_T_INT) ||
     (SUBTYPEOF(Pike_sp[1-args]) != NUMBER_UNDEFINED))) {
#line 2155 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
if((TYPEOF(Pike_sp[1-args]) != PIKE_T_INT) || (Pike_sp[1-args].u.integer & ~0x1) ) SIMPLE_ARG_TYPE_ERROR("create",2,"int(1bit)|void");
#line 2155 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
autocommit_sval=Pike_sp+1-args; dmalloc_touch_svalue(Pike_sp+1-args);
#line 2155 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
} else autocommit_sval = NULL;
if (args > 2 &&
    (TYPEOF(Pike_sp[2-args]) != PIKE_T_INT ||
     Pike_sp[2-args].u.integer)) {
#line 2156 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
if(TYPEOF(Pike_sp[2-args]) != PIKE_T_OBJECT) SIMPLE_ARG_TYPE_ERROR("create",3,"object|void");
#line 2156 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
debug_malloc_pass(new_parent=Pike_sp[2-args].u.object);
#line 2156 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
new_parent_inh_num = SUBTYPEOF(Pike_sp[2-args]);
#line 2156 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
} else new_parent = NULL;
#line 2158 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
{
sword rc;
struct Oracle_oracle_compile_query_TypedResult_struct *dbresult = THIS_RESULT;
struct Oracle_oracle_compile_query_struct *dbquery = THIS_RESULT_QUERY;
struct Oracle_oracle_struct *dbcon = THIS_RESULT_DBCON;
ONERROR err;
INT32 autocommit=0;
int i,num;
struct bind_block bind;

OWERR("%s\n",__FUNCTION__);

#ifdef _REENTRANT
 if(d_flag)
{
CHECK_INTERPRETER_LOCK();
DEBUG_CHECK_THREAD();
}
#endif

if (autocommit_sval) {
autocommit = autocommit_sval->u.integer;
}

bind.bindnum=-1;
bind.bind = NULL;

SET_ONERROR(err, free_bind_block, &bind);

if (bnds && m_sizeof(bnds)) {
bind.bind = xalloc(sizeof(struct bind) * m_sizeof(bnds));
memset(bind.bind, 0, sizeof(struct bind) * m_sizeof(bnds));
}

destruct_objects_to_destruct();

/* Optimize me with trylock! */
THREADS_ALLOW();
LOCK(dbquery->lock);
dbresult->dbquery_lock=1;
THREADS_DISALLOW();

/* Time to re-parent if required */
if(new_parent &&
PARENTOF(PARENTOF(THISOBJ)) != new_parent)
{
if(new_parent->prog != PARENTOF(PARENTOF(PARENTOF(THISOBJ)))->prog)
Pike_error("Bad argument 3 to TypedResult.\n");

/* We might need to check that there are no locks held here
	   * but I don't beleive that could happen, so just go with it...
	   */
free_object(PARENTOF(PARENTOF(THISOBJ)));
add_ref( PARENTOF(PARENTOF(THISOBJ)) = new_parent );
}

#ifdef _REENTRANT
 if(d_flag)
{
CHECK_INTERPRETER_LOCK();
DEBUG_CHECK_THREAD();
}
#endif

if(bnds && m_sizeof(bnds))
{
INT32 e;
struct keypair *k;
struct mapping_data *md = bnds->data;
OWERR("Binding %d variables...\n", m_sizeof(bnds));

NEW_MAPPING_LOOP(md)
{
struct svalue *value=&k->val;
sword rc = 0;
void *addr;
sword len, fty;
int mode=OCI_DATA_AT_EXEC;
long rlen=4000;

#ifdef OCI_UTF16ID
 int pushed_string = 0;

bind.bindnum++;
if(TYPEOF(k->ind) == T_STRING) {
push_svalue(&k->ind);
push_int(2);
f_string_to_unicode(2);
assign_svalue_no_free(& bind.bind[bind.bindnum].ind, &Pike_sp[-1]);
pop_stack();
}
else
assign_svalue_no_free(& bind.bind[bind.bindnum].ind, & k->ind );
#else
 bind.bindnum++;
assign_svalue_no_free(& bind.bind[bind.bindnum].ind, & k->ind);
#endif
 bind.bind[bind.bindnum].indicator=0;

init_inout(& bind.bind[bind.bindnum].data);

retry:
switch(TYPEOF(*value))
{
case T_OBJECT:
if(value->u.object->prog == Oracle_oracle_Date_program)
{
bind.bind[bind.bindnum].data.u.date =
((struct Oracle_oracle_Date_struct *)STORAGE(value->u.object))->date;
addr = &bind.bind[bind.bindnum].data.u.date;
rlen = len = sizeof(bind.bind[bind.bindnum].data.u.date);
fty=SQLT_ODT;
break;
}
if(value->u.object->prog == Oracle_oracle_NULL_program)
{
bind.bind[bind.bindnum].indicator=-1;
value =
&((struct Oracle_oracle_NULL_struct *)STORAGE(value->u.object))->type;
goto retry;
}
{
size_t buf_len;
if( get_memory_object_memory(value->u.object, &addr,
&buf_len, NULL) != MEMOBJ_NONE )
{
len = buf_len;
fty = SQLT_LBI;
break;
}
}
Pike_error("Bad value type in argument 2 to "
"Oracle.oracle->TypedResult()\n");
break;

case T_STRING:
#ifdef OCI_UTF16ID
 ref_push_string(value->u.string);
push_int(2);
f_string_to_unicode(2);
value = Pike_sp - 1;
pushed_string = 1;
#endif
 addr = (ub1 *)value->u.string->str;
len = value->u.string->len;
if (len < 4000)
{
rlen = 4000;
fty = SQLT_CHR;
}
else
fty = SQLT_LNG;
break;

case T_FLOAT:
addr = &value->u.float_number;
rlen = len = sizeof(value->u.float_number);
fty = SQLT_FLT;
break;

case T_INT:
if(SUBTYPEOF(*value))
{
OWERR("NULL IN\n");
bind.bind[bind.bindnum].indicator=-1;
addr = 0;
len = 0;
fty = SQLT_LNG;
}else{
bind.bind[bind.bindnum].data.u.i=value->u.integer;
addr = &bind.bind[bind.bindnum].data.u.i;
rlen = len = sizeof(bind.bind[bind.bindnum].data.u.i);
fty = SQLT_INT;
}
break;

case T_MULTISET:
if(multiset_sizeof(value->u.multiset) == 1) {
struct pike_string *s;
{
struct svalue tmp;
if (TYPEOF(*use_multiset_index (value->u.multiset,
multiset_first (value->u.multiset),
tmp)) == T_STRING)
s = tmp.u.string;
else
s = NULL;
}
if (s) {
addr = (ub1 *)s->str;
len = s->len;
fty = SQLT_LBI;
break;
}
}
/* Fallthrough */

default:
Pike_error("Bad value type in argument 2 to "
"Oracle.oracle->TypedResult()\n");
}

assign_svalue_no_free(& bind.bind[bind.bindnum].val, value);
#ifdef OCI_UTF16ID
 if(pushed_string)
pop_stack();
#endif

bind.bind[bind.bindnum].addr=addr;
bind.bind[bind.bindnum].len=len;
bind.bind[bind.bindnum].data.ftype=fty;
bind.bind[bind.bindnum].bind=0;
bind.bind[bind.bindnum].data.curlen=1;

OWERR("BINDING... rlen=%ld\n"
"addr: %p, len:%ld, ftype: %d\n",
(long)rlen,
addr, (long)len, fty);
if(TYPEOF(k->ind) == T_INT)
{
rc = OCIBindByPos(dbquery->statement,
& bind.bind[bind.bindnum].bind,
dbcon->error_handle,
bind.bind[bind.bindnum].ind.u.integer,
addr,
rlen,
fty,
& bind.bind[bind.bindnum].data.indicator,
& bind.bind[bind.bindnum].data.len,
& bind.bind[bind.bindnum].data.rcode,
0,
0,
mode);
}
else if(TYPEOF(k->ind) == T_STRING)
{
rc = OCIBindByName(dbquery->statement,
& bind.bind[bind.bindnum].bind,
dbcon->error_handle,
(oratext *)bind.bind[bind.bindnum].ind.u.string->str,
bind.bind[bind.bindnum].ind.u.string->len,
addr,
rlen,
fty,
& bind.bind[bind.bindnum].data.indicator,
& bind.bind[bind.bindnum].data.len,
& bind.bind[bind.bindnum].data.rcode,
0,
0,
mode);
}
else
{
Pike_error("Bad index type in argument 2 to "
"Oracle.oracle->TypedResult()\n");
}
if(rc)
{
UNLOCK(dbcon->lock);
ora_error_handler(dbcon->error_handle, rc, "OCiBindByName/Pos");
}

if(mode == OCI_DATA_AT_EXEC)
{
rc=OCIBindDynamic(bind.bind[bind.bindnum].bind,
dbcon->error_handle,
(void *)(bind.bind + bind.bindnum),
input_callback,
(void *)(bind.bind + bind.bindnum),
bind_output_callback);
if(rc)
{
UNLOCK(dbcon->lock);
ora_error_handler(dbcon->error_handle, rc, "OCiBindDynamic");
}
}
}
}
debug_malloc_touch(dbcon->context);
#ifndef REUSE_DEFINES
 if(dbquery->field_info)
{
free_array(dbquery->field_info);
dbquery->field_info=0;
}
#endif
 THREADS_ALLOW();
LOCK(dbcon->lock);
dbresult->dbcon_lock=1;

OWERR("OCIExec query_type=%d\n", dbquery->query_type);
rc = OCIStmtExecute(dbcon->context,
dbquery->statement,
dbcon->error_handle,
dbquery->query_type == OCI_STMT_SELECT ? 0 : 1,
0,
0,0,
autocommit?OCI_DEFAULT:OCI_COMMIT_ON_SUCCESS);

OWERR("OCIExec done\n");
THREADS_DISALLOW();

#ifdef _REENTRANT
 if(d_flag)
{
CHECK_INTERPRETER_LOCK();
DEBUG_CHECK_THREAD();
}
#endif

if(!IS_SUCCESS(rc))
ora_error_handler(dbcon->error_handle, rc, 0);

pop_n_elems(args);


for(num=i=0;i<=bind.bindnum;i++)
if(bind.bind[i].data.has_output)
num++;

if(!num)
{
/* This will probably never happen, but better safe than sorry */
if(dbquery->output_variables)
{
free_mapping(dbquery->output_variables);
dbquery->output_variables=0;
}
}else{
if(!dbquery->output_variables)
dbquery->output_variables=allocate_mapping(num);

for(num=i=0;i<=bind.bindnum;i++)
{
if(bind.bind[i].data.has_output)
{
push_svalue(&bind.bind[i].ind);
#ifdef OCI_UTF16ID
 if (TYPEOF(Pike_sp[-1]) == PIKE_T_STRING) {
push_int(2);
f_unicode_to_string(2);
}
#endif
 push_inout_value(&bind.bind[i].data, dbcon);
mapping_insert(dbquery->output_variables, Pike_sp-2, Pike_sp-1);
pop_n_elems(2);
}
}
}

/* Free the bindings. */
CALL_AND_UNSET_ONERROR(err);

#ifdef _REENTRANT
 if(d_flag)
{
CHECK_INTERPRETER_LOCK();
DEBUG_CHECK_THREAD();
}
#endif
 }
}

#ifdef Oracle_oracle_compile_query_TypedResult_event_handler_defined
static void Oracle_oracle_compile_query_TypedResult_event_handler(int ev) {
  switch(ev) {

#ifdef internal_init_Oracle_oracle_compile_query_TypedResult_defined
  case PROG_EVENT_INIT: init_Oracle_oracle_compile_query_TypedResult_struct(); break;

#endif /* internal_init_Oracle_oracle_compile_query_TypedResult_defined */

#ifdef internal_exit_Oracle_oracle_compile_query_TypedResult_defined
  case PROG_EVENT_EXIT: exit_Oracle_oracle_compile_query_TypedResult_struct(); break;

#endif /* internal_exit_Oracle_oracle_compile_query_TypedResult_defined */
  default: break; 
  }
}

#endif /* Oracle_oracle_compile_query_TypedResult_event_handler_defined */

#ifdef THIS_ORACLE_ORACLE_COMPILE_QUERY

#undef THIS
#define THIS THIS_ORACLE_ORACLE_COMPILE_QUERY

#endif /* THIS_ORACLE_ORACLE_COMPILE_QUERY */
/*! @endclass TypedResult
     */

#define f_Oracle_oracle_compile_query_create_defined
DEFAULT_CMOD_STORAGE void f_Oracle_oracle_compile_query_create(INT32 args) {
#line 2523 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
struct pike_string * query;
#line 2523 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
if(args != 1) wrong_number_of_args_error("create",args,1);
#line 2523 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
if(TYPEOF(Pike_sp[0-1]) != PIKE_T_STRING) SIMPLE_ARG_TYPE_ERROR("create",1,"string");
#line 2523 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
debug_malloc_pass(query=Pike_sp[0-1].u.string);
#line 2525 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
{
int rc;
struct Oracle_oracle_compile_query_struct *dbquery = THIS_QUERY;
struct Oracle_oracle_struct *dbcon = THIS_QUERY_DBCON;
char *errfunc=0;

OWERR("%s\n",__FUNCTION__);

#ifndef OCI_UTF16ID
 if (query->size_shift) {
SIMPLE_ARG_ERROR("compile_query", 1, "Expected string(8bit).");
}
#endif

OWERR("f_compile_query_create: dbquery: %p\n",dbquery);
OWERR("         dbcon:   %p\n",dbcon);
OWERR("  error_handle: %p\n",dbcon->error_handle);
OWERR("resultobject_busy: %d\n", dbcon->resultobject_busy);

if (dbcon->resultobject_busy)
{
Pike_error("Oracle connection busy; previous result object "
"still active.\n");
}

#ifdef OCI_UTF16ID
 ORACLE_UNICODE_ENCODE(query);
#endif

THREADS_ALLOW();
LOCK(dbcon->lock);

rc=OCIHandleAlloc(ENVOF(dbcon),
(void **)&dbquery->statement,
OCI_HTYPE_STMT,
0,0);

if(rc == OCI_SUCCESS)
{
rc=OCIStmtPrepare(dbquery->statement,
dbcon->error_handle,
(oratext *)query->str,
query->len,
OCI_NTV_SYNTAX,
OCI_DEFAULT);

if(rc == OCI_SUCCESS)
{
ub2 query_type;
rc=OCIAttrGet(dbquery->statement,
OCI_HTYPE_STMT,
&query_type,
0,
OCI_ATTR_STMT_TYPE,
dbcon->error_handle);
if(rc == OCI_SUCCESS)
{
OWERR("     query_type: %d\n",query_type);
dbquery->query_type = query_type;
}else{
errfunc="OCIAttrGet";
}
}else{
errfunc="OCIStmtPrepare";
}
}else{
errfunc="OCIHandleAlloc";
}

THREADS_DISALLOW();
UNLOCK(dbcon->lock);

if(rc != OCI_SUCCESS)
ora_error_handler(dbcon->error_handle, rc, 0);
}
}

#ifdef Oracle_oracle_compile_query_event_handler_defined
static void Oracle_oracle_compile_query_event_handler(int ev) {
  switch(ev) {

#ifdef internal_init_Oracle_oracle_compile_query_defined
  case PROG_EVENT_INIT: init_Oracle_oracle_compile_query_struct(); break;

#endif /* internal_init_Oracle_oracle_compile_query_defined */

#ifdef internal_exit_Oracle_oracle_compile_query_defined
  case PROG_EVENT_EXIT: exit_Oracle_oracle_compile_query_struct(); break;

#endif /* internal_exit_Oracle_oracle_compile_query_defined */
  default: break; 
  }
}

#endif /* Oracle_oracle_compile_query_event_handler_defined */

#ifdef THIS_ORACLE_ORACLE

#undef THIS
#define THIS THIS_ORACLE_ORACLE

#endif /* THIS_ORACLE_ORACLE */
/*! @endclass compile_query
   */

#define f_Oracle_oracle_create_defined
DEFAULT_CMOD_STORAGE void f_Oracle_oracle_create(INT32 args) {
#line 2604 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
struct pike_string * host;
#line 2604 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
struct pike_string * database;
struct pike_string * uid;
#line 2605 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
struct pike_string * passwd;
#ifdef PIKE_DEBUG
if(args < 0) Pike_fatal("CMOD function argument negative.\n");
#else
STATIC_ASSUME(args >= 0);
#endif
#line 2604 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
if(args > 4) wrong_number_of_args_error("create",args,4);
#line 2604 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
if (args > 0 &&
    (TYPEOF(Pike_sp[0-args]) != PIKE_T_INT ||
     Pike_sp[0-args].u.integer)) {
#line 2604 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
if(TYPEOF(Pike_sp[0-args]) != PIKE_T_STRING) SIMPLE_ARG_TYPE_ERROR("create",1,"string|void");
#line 2604 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
debug_malloc_pass(host=Pike_sp[0-args].u.string);
#line 2604 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
} else host = NULL;
#line 2604 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
if (args > 1 &&
    (TYPEOF(Pike_sp[1-args]) != PIKE_T_INT ||
     Pike_sp[1-args].u.integer)) {
#line 2604 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
if(TYPEOF(Pike_sp[1-args]) != PIKE_T_STRING) SIMPLE_ARG_TYPE_ERROR("create",2,"string|void");
#line 2604 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
debug_malloc_pass(database=Pike_sp[1-args].u.string);
#line 2604 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
} else database = NULL;
if (args > 2 &&
    (TYPEOF(Pike_sp[2-args]) != PIKE_T_INT ||
     Pike_sp[2-args].u.integer)) {
#line 2605 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
if(TYPEOF(Pike_sp[2-args]) != PIKE_T_STRING) SIMPLE_ARG_TYPE_ERROR("create",3,"string|void");
#line 2605 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
debug_malloc_pass(uid=Pike_sp[2-args].u.string);
#line 2605 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
} else uid = NULL;
#line 2605 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
if (args > 3 &&
    (TYPEOF(Pike_sp[3-args]) != PIKE_T_INT ||
     Pike_sp[3-args].u.integer)) {
#line 2605 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
if(TYPEOF(Pike_sp[3-args]) != PIKE_T_STRING) SIMPLE_ARG_TYPE_ERROR("create",4,"string|void");
#line 2605 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
debug_malloc_pass(passwd=Pike_sp[3-args].u.string);
#line 2605 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
} else passwd = NULL;
#line 2607 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
{
char *err=0;
struct Oracle_oracle_struct *dbcon = THIS_DBCON;
sword rc;

#ifdef OCI_UTF16ID
 ORACLE_UNICODE_ENCODE(host);
ORACLE_UNICODE_ENCODE(database);
ORACLE_UNICODE_ENCODE(uid);
ORACLE_UNICODE_ENCODE(passwd);
#endif

#ifdef LOCAL_ENV
 if(!dbcon->env)
{
OWERR("%s: creating new environment\n",__FUNCTION__);
LOCK(dbcon->lock);
rc=OCIEnvInit(&dbcon->env, OCI_DEFAULT,0,0);
UNLOCK(dbcon->lock);
if(rc != OCI_SUCCESS)
Pike_error("Failed to initialize oracle environment, err=%d.\n",rc);
} else {
OWERR("%s: environment exists\n",__FUNCTION__);
}
#endif

debug_malloc_touch(ENVOF(dbcon));

THREADS_ALLOW();

LOCK(dbcon->lock);
#ifdef SERIALIZE_CONNECT
 LOCK(oracle_serialization_mutex);
#endif

do {
rc=OCIHandleAlloc(ENVOF(dbcon),
(void **)& dbcon->error_handle,
OCI_HTYPE_ERROR,
0,
0);
if(rc != OCI_SUCCESS) break;

OWERR("OCIHandleAlloc -> %p\n",dbcon->error_handle);

#if 0
 if(OCIHandleAlloc(ENVOF(dbcon),
&THIS_DBCON->srvhp,
OCI_HTYPE_SERVER, 0,0)!=OCI_SUCCESS)
Pike_error("Failed to allocate server handle.\n");

if(OCIHandleAlloc(ENVOF(dbcon),
&THIS_DBCON->srchp,
OCI_HTYPE_SVCCTX, 0,0)!=OCI_SUCCESS)
Pike_error("Failed to allocate service context.\n");
#endif

rc=OCILogon(ENVOF(dbcon),
dbcon->error_handle,
&dbcon->context,
(oratext *)uid->str, uid->len,
(passwd? (oratext *)passwd->str:NULL), (passwd? passwd->len:-1),
(host? (oratext *)host->str:NULL), (host? host->len:-1));

}while(0);

#ifdef SERIALIZE_CONNECT
 UNLOCK(oracle_serialization_mutex);
#endif
 UNLOCK(dbcon->lock);

THREADS_DISALLOW();


if(rc != OCI_SUCCESS)
ora_error_handler(dbcon->error_handle, rc, 0);

debug_malloc_touch(dbcon->error_handle);
debug_malloc_touch(dbcon->context);

OWERR("oracle.create error_handle -> %p\n", dbcon->error_handle);
}

}
#define f_Oracle_oracle_commit_defined
DEFAULT_CMOD_STORAGE void f_Oracle_oracle_commit(INT32 args) {
#line 2690 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
if(args != 0) wrong_number_of_args_error("commit",args,0);
{
sword ret = 0;
struct Oracle_oracle_struct *dbcon = THIS_DBCON;
ret = OCITransCommit(dbcon->context, dbcon->error_handle, 0);
if(ret != OCI_SUCCESS)
ora_error_handler(dbcon->error_handle, ret, "OCITransCommit");
}
}

#ifdef Oracle_oracle_event_handler_defined
static void Oracle_oracle_event_handler(int ev) {
  switch(ev) {

#ifdef internal_init_Oracle_oracle_defined
  case PROG_EVENT_INIT: init_Oracle_oracle_struct(); break;

#endif /* internal_init_Oracle_oracle_defined */

#ifdef internal_exit_Oracle_oracle_defined
  case PROG_EVENT_EXIT: exit_Oracle_oracle_struct(); break;

#endif /* internal_exit_Oracle_oracle_defined */
  default: break; 
  }
}

#endif /* Oracle_oracle_event_handler_defined */

#ifdef THIS_ORACLE

#undef THIS
#define THIS THIS_ORACLE

#endif /* THIS_ORACLE */
/*! @endclass oracle
 */

#line 2702 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
PIKE_MODULE_INIT
{
long offset=0;
sword ret;

#ifdef ORACLE_HOME
 if(getenv("ORACLE_HOME")==NULL)
putenv("ORACLE_HOME="ORACLE_HOME);
#endif
#ifdef ORACLE_SID
 if(getenv("ORACLE_SID")==NULL)
putenv("ORACLE_SID="ORACLE_SID);
#endif

OWERR("%s\n",__FUNCTION__);

if ((ret =
#ifdef OCI_UTF16ID
 /* Oracle 9 */
OCIEnvNlsCreate( &oracle_environment,
OCI_OBJECT | ORACLE_INIT_FLAGS,
NULL,
ocimalloc, ocirealloc, ocifree,
0, NULL,
OCI_UTF16ID, OCI_UTF16ID)
#else
 /* Oracle 8 */
OCIInitialize( OCI_OBJECT | ORACLE_INIT_FLAGS,
0, ocimalloc, ocirealloc, ocifree)
#endif
 ) != OCI_SUCCESS)
{
OWERR("OCIInitialize/OCIEnvNlsCreate failed: %d\n", ret);
return;
}

if(Oracle_oracle_program)
Pike_fatal("Oracle module initiated twice!\n");


#ifdef module_strings_declared
module_strings[0] = 
  make_shared_binary_string("__builtin.Sql.Connection",
                            CONSTANT_STRLEN("__builtin.Sql.Connection"));
module_strings[1] = 
  make_shared_binary_string("__builtin.Sql.Result",
                            CONSTANT_STRLEN("__builtin.Sql.Result"));
#endif

#ifdef CMOD_MAP_PROGRAM_IDS_DEFINED
set_program_id_to_id( ___cmod_map_program_ids );

#endif /* CMOD_MAP_PROGRAM_IDS_DEFINED */

#ifdef class_Oracle_oracle_defined

#ifdef PROG_ORACLE_ORACLE_ID
#line 463 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
  START_NEW_PROGRAM_ID(ORACLE_ORACLE);
#else
#line 463 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
  start_new_program();

#endif /* PROG_ORACLE_ORACLE_ID */
#line 463 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
  Oracle_oracle_program = Pike_compiler->new_program;

#ifndef tObjImpl_ORACLE_ORACLE

#undef tObjIs_ORACLE_ORACLE
#define tObjIs_ORACLE_ORACLE "\3\1\177\0\0\2"

#undef tObjImpl_ORACLE_ORACLE
#define tObjImpl_ORACLE_ORACLE "\3\0\177\0\0\2"

#endif /* tObjImpl_ORACLE_ORACLE */

#ifdef THIS_ORACLE_ORACLE
  Oracle_oracle_storage_offset = ADD_STORAGE(struct Oracle_oracle_struct);
#endif /* THIS_ORACLE_ORACLE */

#ifdef inherit_cq__22__builtin_2ESql_2EConnection_22_Oracle_oracle_defined
#line 512 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
  Oracle_oracle_cq__22__builtin_2ESql_2EConnection_22_inh_num = Pike_compiler->new_program->num_inherits;
  do {
#line 512 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
    struct program *p = resolve_program(module_strings[0] /* "__builtin.Sql.Connection" */);
    if (p) {

#ifdef module_strings_declared
#line 512 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
      low_inherit(p, NULL, -1, 0, 0, NULL
#ifdef tGeneric
, NULL
#endif
);

#else /* module_strings_declared */
#line 512 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
      low_inherit(p, NULL, -1, 0, 0, NULL
#ifdef tGeneric
, NULL
#endif
);

#endif /* module_strings_declared */

#ifdef Oracle_oracle_cq__22__builtin_2ESql_2EConnection_22_inh_offset_used
#line 512 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
      Oracle_oracle_cq__22__builtin_2ESql_2EConnection_22_inh_offset = Pike_compiler->new_program->inherits[Oracle_oracle_cq__22__builtin_2ESql_2EConnection_22_inh_num].identifier_level;

#endif /* Oracle_oracle_cq__22__builtin_2ESql_2EConnection_22_inh_offset_used */

#ifdef Oracle_oracle_cq__22__builtin_2ESql_2EConnection_22_inh_storage_offset_used
#line 512 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
      Oracle_oracle_cq__22__builtin_2ESql_2EConnection_22_inh_storage_offset = Pike_compiler->new_program->inherits[Oracle_oracle_cq__22__builtin_2ESql_2EConnection_22_inh_num].storage_offset;

#endif /* Oracle_oracle_cq__22__builtin_2ESql_2EConnection_22_inh_storage_offset_used */
#line 512 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
      free_program(p);
    } else {
#line 512 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
      yyerror("Inherit failed.");
    }
  } while(0);
#endif /* inherit_cq__22__builtin_2ESql_2EConnection_22_Oracle_oracle_defined */

#ifdef class_Oracle_oracle_LOB_defined

#ifdef PROG_ORACLE_ORACLE_LOB_ID
#line 585 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
  START_NEW_PROGRAM_ID(ORACLE_ORACLE_LOB);
#else
#line 585 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
  start_new_program();

#endif /* PROG_ORACLE_ORACLE_LOB_ID */
#line 585 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
  Oracle_oracle_LOB_program = Pike_compiler->new_program;

#ifndef tObjImpl_ORACLE_ORACLE_LOB

#undef tObjIs_ORACLE_ORACLE_LOB
#define tObjIs_ORACLE_ORACLE_LOB "\3\1\177\0\0\3"

#undef tObjImpl_ORACLE_ORACLE_LOB
#define tObjImpl_ORACLE_ORACLE_LOB "\3\0\177\0\0\3"

#endif /* tObjImpl_ORACLE_ORACLE_LOB */

#ifdef THIS_ORACLE_ORACLE_LOB
  Oracle_oracle_LOB_storage_offset = ADD_STORAGE(struct Oracle_oracle_LOB_struct);
#endif /* THIS_ORACLE_ORACLE_LOB */

#ifdef Oracle_oracle_LOB_event_handler_defined
  pike_set_prog_event_callback(Oracle_oracle_LOB_event_handler);

#ifndef Oracle_oracle_LOB_gc_live_obj
  Pike_compiler->new_program->flags &= ~PROGRAM_LIVE_OBJ;

#endif /* Oracle_oracle_LOB_gc_live_obj */

#endif /* Oracle_oracle_LOB_event_handler_defined */

#ifdef f_Oracle_oracle_LOB_cq__sprintf_defined

#ifdef f_Oracle_oracle_LOB_cq__sprintf_fun_num_used
  f_Oracle_oracle_LOB_cq__sprintf_fun_num =
#endif /* f_Oracle_oracle_LOB_cq__sprintf_fun_num_used */
#line 611 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
    ADD_FUNCTION2("_sprintf", f_Oracle_oracle_LOB_cq__sprintf, tFunc("\10\200\0\0\0\177\377\377\377" tMapping,tStr), ID_PROTECTED, OPT_EXTERNAL_DEPEND|OPT_SIDE_EFFECT);

#endif /* f_Oracle_oracle_LOB_cq__sprintf_defined */

#ifdef f_Oracle_oracle_LOB_read_defined

#ifdef f_Oracle_oracle_LOB_read_fun_num_used
  f_Oracle_oracle_LOB_read_fun_num =
#endif /* f_Oracle_oracle_LOB_read_fun_num_used */
    ADD_FUNCTION2("read", f_Oracle_oracle_LOB_read, tFunc(tNone,tStr), 0, OPT_EXTERNAL_DEPEND|OPT_SIDE_EFFECT);

#endif /* f_Oracle_oracle_LOB_read_defined */

#ifdef f_Oracle_oracle_LOB_cast_defined

#ifdef f_Oracle_oracle_LOB_cast_fun_num_used
  f_Oracle_oracle_LOB_cast_fun_num =
#endif /* f_Oracle_oracle_LOB_cast_fun_num_used */
#line 692 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
    ADD_FUNCTION2("cast", f_Oracle_oracle_LOB_cast, tFunc(tStr,tMix), ID_PROTECTED, OPT_EXTERNAL_DEPEND|OPT_SIDE_EFFECT);

#endif /* f_Oracle_oracle_LOB_cast_defined */

#ifdef f_Oracle_oracle_LOB_write_defined

#ifdef f_Oracle_oracle_LOB_write_fun_num_used
  f_Oracle_oracle_LOB_write_fun_num =
#endif /* f_Oracle_oracle_LOB_write_fun_num_used */
#line 703 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
    ADD_FUNCTION2("write", f_Oracle_oracle_LOB_write, tFunc(tStr8,"\10\200\0\0\0\177\377\377\377"), 0, OPT_EXTERNAL_DEPEND|OPT_SIDE_EFFECT);

#endif /* f_Oracle_oracle_LOB_write_defined */
#line 585 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
  Oracle_oracle_LOB_program=end_program();
#line 585 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
#ifdef Oracle_oracle_LOB_program_fun_num_used
Oracle_oracle_LOB_program_fun_num=
#endif
 add_program_constant("LOB",Oracle_oracle_LOB_program,0);

#endif /* class_Oracle_oracle_LOB_defined */

#ifdef class_Oracle_oracle_Date_defined

#ifdef PROG_ORACLE_ORACLE_DATE_ID
#line 767 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
  START_NEW_PROGRAM_ID(ORACLE_ORACLE_DATE);
#else
#line 767 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
  start_new_program();

#endif /* PROG_ORACLE_ORACLE_DATE_ID */
#line 767 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
  Oracle_oracle_Date_program = Pike_compiler->new_program;

#ifndef tObjImpl_ORACLE_ORACLE_DATE

#undef tObjIs_ORACLE_ORACLE_DATE
#define tObjIs_ORACLE_ORACLE_DATE "\3\1\177\0\0\4"

#undef tObjImpl_ORACLE_ORACLE_DATE
#define tObjImpl_ORACLE_ORACLE_DATE "\3\0\177\0\0\4"

#endif /* tObjImpl_ORACLE_ORACLE_DATE */

#ifdef THIS_ORACLE_ORACLE_DATE
  Oracle_oracle_Date_storage_offset = ADD_STORAGE(struct Oracle_oracle_Date_struct);
#endif /* THIS_ORACLE_ORACLE_DATE */

#ifdef Oracle_oracle_Date_event_handler_defined
  pike_set_prog_event_callback(Oracle_oracle_Date_event_handler);

#ifndef Oracle_oracle_Date_gc_live_obj
  Pike_compiler->new_program->flags &= ~PROGRAM_LIVE_OBJ;

#endif /* Oracle_oracle_Date_gc_live_obj */

#endif /* Oracle_oracle_Date_event_handler_defined */

#ifdef f_Oracle_oracle_Date_create_defined

#ifdef f_Oracle_oracle_Date_create_fun_num_used
  f_Oracle_oracle_Date_create_fun_num =
#endif /* f_Oracle_oracle_Date_create_fun_num_used */
#line 783 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
    ADD_FUNCTION2("create", f_Oracle_oracle_Date_create, tFunc(tOr(tStr,"\10\200\0\0\0\177\377\377\377"),tVoid), ID_PROTECTED, OPT_EXTERNAL_DEPEND|OPT_SIDE_EFFECT);

#endif /* f_Oracle_oracle_Date_create_defined */

#ifdef f_Oracle_oracle_Date_cq__sprintf_defined

#ifdef f_Oracle_oracle_Date_cq__sprintf_fun_num_used
  f_Oracle_oracle_Date_cq__sprintf_fun_num =
#endif /* f_Oracle_oracle_Date_cq__sprintf_fun_num_used */
#line 816 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
    ADD_FUNCTION2("_sprintf", f_Oracle_oracle_Date_cq__sprintf, tFunc("\10\200\0\0\0\177\377\377\377" tMapping,tStr), ID_PROTECTED, OPT_EXTERNAL_DEPEND|OPT_SIDE_EFFECT);

#endif /* f_Oracle_oracle_Date_cq__sprintf_defined */

#ifdef f_Oracle_oracle_Date_cast_defined

#ifdef f_Oracle_oracle_Date_cast_fun_num_used
  f_Oracle_oracle_Date_cast_fun_num =
#endif /* f_Oracle_oracle_Date_cast_fun_num_used */
#line 855 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
    ADD_FUNCTION2("cast", f_Oracle_oracle_Date_cast, tFunc(tStr,tMix), ID_PROTECTED, OPT_EXTERNAL_DEPEND|OPT_SIDE_EFFECT);

#endif /* f_Oracle_oracle_Date_cast_defined */
#line 767 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
  Oracle_oracle_Date_program=end_program();
#line 767 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
#ifdef Oracle_oracle_Date_program_fun_num_used
Oracle_oracle_Date_program_fun_num=
#endif
 add_program_constant("Date",Oracle_oracle_Date_program,0);

#endif /* class_Oracle_oracle_Date_defined */

#ifdef class_Oracle_oracle_NULL_defined

#ifdef PROG_ORACLE_ORACLE_NULL_ID
#line 890 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
  START_NEW_PROGRAM_ID(ORACLE_ORACLE_NULL);
#else
#line 890 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
  start_new_program();

#endif /* PROG_ORACLE_ORACLE_NULL_ID */
#line 890 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
  Oracle_oracle_NULL_program = Pike_compiler->new_program;

#ifndef tObjImpl_ORACLE_ORACLE_NULL

#undef tObjIs_ORACLE_ORACLE_NULL
#define tObjIs_ORACLE_ORACLE_NULL "\3\1\177\0\0\5"

#undef tObjImpl_ORACLE_ORACLE_NULL
#define tObjImpl_ORACLE_ORACLE_NULL "\3\0\177\0\0\5"

#endif /* tObjImpl_ORACLE_ORACLE_NULL */

#ifdef THIS_ORACLE_ORACLE_NULL
  Oracle_oracle_NULL_storage_offset = ADD_STORAGE(struct Oracle_oracle_NULL_struct);
#endif /* THIS_ORACLE_ORACLE_NULL */

#ifdef var_type_Oracle_oracle_NULL_defined
#line 895 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
  PIKE_MAP_VARIABLE("type", Oracle_oracle_NULL_storage_offset + OFFSETOF(Oracle_oracle_NULL_struct, type),
                    tMix, PIKE_T_MIXED, 0);
#endif /* var_type_Oracle_oracle_NULL_defined */

#ifdef extra_Oracle_oracle_NULL_defined
#line 911 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
{
struct pike_string *null_string = make_shared_string("Null");
low_inherit(get_sql_null_prog(), NULL, -1, 0, 0, null_string, NULL);
free_string(null_string);
add_integer_constant("is_oracle_null", 1, 0);
}


#endif /* extra_Oracle_oracle_NULL_defined */

#ifdef Oracle_oracle_NULL_event_handler_defined
  pike_set_prog_event_callback(Oracle_oracle_NULL_event_handler);

#ifndef Oracle_oracle_NULL_gc_live_obj
  Pike_compiler->new_program->flags &= ~PROGRAM_LIVE_OBJ;

#endif /* Oracle_oracle_NULL_gc_live_obj */

#endif /* Oracle_oracle_NULL_event_handler_defined */

#ifdef f_Oracle_oracle_NULL_create_defined

#ifdef f_Oracle_oracle_NULL_create_fun_num_used
  f_Oracle_oracle_NULL_create_fun_num =
#endif /* f_Oracle_oracle_NULL_create_fun_num_used */
#line 918 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
    ADD_FUNCTION2("create", f_Oracle_oracle_NULL_create, tFunc(tOr(tStr,"\10\200\0\0\0\177\377\377\377"),tVoid), ID_PROTECTED, OPT_EXTERNAL_DEPEND|OPT_SIDE_EFFECT);

#endif /* f_Oracle_oracle_NULL_create_defined */

#ifdef f_Oracle_oracle_NULL_cq__sprintf_defined

#ifdef f_Oracle_oracle_NULL_cq__sprintf_fun_num_used
  f_Oracle_oracle_NULL_cq__sprintf_fun_num =
#endif /* f_Oracle_oracle_NULL_cq__sprintf_fun_num_used */
#line 924 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
    ADD_FUNCTION2("_sprintf", f_Oracle_oracle_NULL_cq__sprintf, tFunc("\10\200\0\0\0\177\377\377\377" tMapping,tStr), ID_PROTECTED, OPT_EXTERNAL_DEPEND|OPT_SIDE_EFFECT);

#endif /* f_Oracle_oracle_NULL_cq__sprintf_defined */

#ifdef f_Oracle_oracle_NULL_cq__backtick_eq_eq_defined

#ifdef f_Oracle_oracle_NULL_cq__backtick_eq_eq_fun_num_used
  f_Oracle_oracle_NULL_cq__backtick_eq_eq_fun_num =
#endif /* f_Oracle_oracle_NULL_cq__backtick_eq_eq_fun_num_used */
#line 940 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
    ADD_FUNCTION2("`==", f_Oracle_oracle_NULL_cq__backtick_eq_eq, tFunc(tMix,"\10\0\0\0\0\0\0\0\1"), ID_PROTECTED, OPT_EXTERNAL_DEPEND|OPT_SIDE_EFFECT);

#endif /* f_Oracle_oracle_NULL_cq__backtick_eq_eq_defined */
#line 890 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
  Oracle_oracle_NULL_program=end_program();
#line 890 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
#ifdef Oracle_oracle_NULL_program_fun_num_used
Oracle_oracle_NULL_program_fun_num=
#endif
 add_program_constant("NULL",Oracle_oracle_NULL_program,0);

#endif /* class_Oracle_oracle_NULL_defined */

#ifdef class_Oracle_oracle_compile_query_defined

#ifdef PROG_ORACLE_ORACLE_COMPILE_QUERY_ID
#line 971 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
  START_NEW_PROGRAM_ID(ORACLE_ORACLE_COMPILE_QUERY);
#else
#line 971 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
  start_new_program();

#endif /* PROG_ORACLE_ORACLE_COMPILE_QUERY_ID */
#line 971 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
  Oracle_oracle_compile_query_program = Pike_compiler->new_program;

#ifndef tObjImpl_ORACLE_ORACLE_COMPILE_QUERY

#undef tObjIs_ORACLE_ORACLE_COMPILE_QUERY
#define tObjIs_ORACLE_ORACLE_COMPILE_QUERY "\3\1\177\0\0\6"

#undef tObjImpl_ORACLE_ORACLE_COMPILE_QUERY
#define tObjImpl_ORACLE_ORACLE_COMPILE_QUERY "\3\0\177\0\0\6"

#endif /* tObjImpl_ORACLE_ORACLE_COMPILE_QUERY */

#ifdef THIS_ORACLE_ORACLE_COMPILE_QUERY
  Oracle_oracle_compile_query_storage_offset = ADD_STORAGE(struct Oracle_oracle_compile_query_struct);
#endif /* THIS_ORACLE_ORACLE_COMPILE_QUERY */

#ifdef var_output_variables_Oracle_oracle_compile_query_defined
#line 983 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
  PIKE_MAP_VARIABLE("output_variables", Oracle_oracle_compile_query_storage_offset + OFFSETOF(Oracle_oracle_compile_query_struct, output_variables),
                    tMap(tStr,tMix), PIKE_T_MAPPING, 0);
#endif /* var_output_variables_Oracle_oracle_compile_query_defined */

#ifdef extra_Oracle_oracle_compile_query_defined
#line 1007 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
{
PIKE_MAP_VARIABLE("_type",offset+OFFSETOF(Oracle_oracle_compile_query_struct,query_type),tInt,T_INT,0);
PIKE_MAP_VARIABLE("_cols",offset+OFFSETOF(Oracle_oracle_compile_query_struct, cols),tInt,T_INT,0);
PIKE_MAP_VARIABLE("_field_info",offset+OFFSETOF(Oracle_oracle_compile_query_struct, field_info),
tArr(tObj), T_ARRAY, 0);

/*      ADD_FUNCTION("query_type",f_query_type,tFunc(tNone,tInt),0); */

}


#endif /* extra_Oracle_oracle_compile_query_defined */

#ifdef class_Oracle_oracle_compile_query_dbresultinfo_defined

#ifdef PROG_ORACLE_ORACLE_COMPILE_QUERY_DBRESULTINFO_ID
#line 1019 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
  START_NEW_PROGRAM_ID(ORACLE_ORACLE_COMPILE_QUERY_DBRESULTINFO);
#else
#line 1019 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
  start_new_program();

#endif /* PROG_ORACLE_ORACLE_COMPILE_QUERY_DBRESULTINFO_ID */
#line 1019 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
  Oracle_oracle_compile_query_dbresultinfo_program = Pike_compiler->new_program;

#ifndef tObjImpl_ORACLE_ORACLE_COMPILE_QUERY_DBRESULTINFO

#undef tObjIs_ORACLE_ORACLE_COMPILE_QUERY_DBRESULTINFO
#define tObjIs_ORACLE_ORACLE_COMPILE_QUERY_DBRESULTINFO "\3\1\177\0\0\a"

#undef tObjImpl_ORACLE_ORACLE_COMPILE_QUERY_DBRESULTINFO
#define tObjImpl_ORACLE_ORACLE_COMPILE_QUERY_DBRESULTINFO "\3\0\177\0\0\a"

#endif /* tObjImpl_ORACLE_ORACLE_COMPILE_QUERY_DBRESULTINFO */

#ifdef THIS_ORACLE_ORACLE_COMPILE_QUERY_DBRESULTINFO
  Oracle_oracle_compile_query_dbresultinfo_storage_offset = ADD_STORAGE(struct Oracle_oracle_compile_query_dbresultinfo_struct);
#endif /* THIS_ORACLE_ORACLE_COMPILE_QUERY_DBRESULTINFO */

#ifdef var_length_Oracle_oracle_compile_query_dbresultinfo_defined
#line 1024 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
  PIKE_MAP_VARIABLE("length", Oracle_oracle_compile_query_dbresultinfo_storage_offset + OFFSETOF(Oracle_oracle_compile_query_dbresultinfo_struct, length),
                    "\10\200\0\0\0\177\377\377\377", PIKE_T_INT, 0);
#endif /* var_length_Oracle_oracle_compile_query_dbresultinfo_defined */

#ifdef var_decimals_Oracle_oracle_compile_query_dbresultinfo_defined
#line 1025 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
  PIKE_MAP_VARIABLE("decimals", Oracle_oracle_compile_query_dbresultinfo_storage_offset + OFFSETOF(Oracle_oracle_compile_query_dbresultinfo_struct, decimals),
                    "\10\200\0\0\0\177\377\377\377", PIKE_T_INT, 0);
#endif /* var_decimals_Oracle_oracle_compile_query_dbresultinfo_defined */

#ifdef var_name_Oracle_oracle_compile_query_dbresultinfo_defined
#line 1027 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
  PIKE_MAP_VARIABLE("name", Oracle_oracle_compile_query_dbresultinfo_storage_offset + OFFSETOF(Oracle_oracle_compile_query_dbresultinfo_struct, name),
                    tStr, PIKE_T_STRING, 0);
#endif /* var_name_Oracle_oracle_compile_query_dbresultinfo_defined */

#ifdef var_type_Oracle_oracle_compile_query_dbresultinfo_defined
#line 1028 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
  PIKE_MAP_VARIABLE("type", Oracle_oracle_compile_query_dbresultinfo_storage_offset + OFFSETOF(Oracle_oracle_compile_query_dbresultinfo_struct, type),
                    tStr, PIKE_T_STRING, 0);
#endif /* var_type_Oracle_oracle_compile_query_dbresultinfo_defined */

#ifdef extra_Oracle_oracle_compile_query_dbresultinfo_defined
#line 1057 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
{
PIKE_MAP_VARIABLE("_type",offset+OFFSETOF(Oracle_oracle_compile_query_dbresultinfo_struct, real_type),tInt,T_INT,0);

ADD_FUNCTION("`->=",protect_dbresultinfo,
tFunc(tStr tMix,tVoid), ID_PROTECTED);
ADD_FUNCTION("`[]=",protect_dbresultinfo,
tFunc(tStr tMix,tVoid), ID_PROTECTED);
}


#endif /* extra_Oracle_oracle_compile_query_dbresultinfo_defined */

#ifdef Oracle_oracle_compile_query_dbresultinfo_event_handler_defined
  pike_set_prog_event_callback(Oracle_oracle_compile_query_dbresultinfo_event_handler);

#ifndef Oracle_oracle_compile_query_dbresultinfo_gc_live_obj
  Pike_compiler->new_program->flags &= ~PROGRAM_LIVE_OBJ;

#endif /* Oracle_oracle_compile_query_dbresultinfo_gc_live_obj */

#endif /* Oracle_oracle_compile_query_dbresultinfo_event_handler_defined */
#line 1019 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
  Oracle_oracle_compile_query_dbresultinfo_program=end_program();
#line 1019 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
#ifdef Oracle_oracle_compile_query_dbresultinfo_program_fun_num_used
Oracle_oracle_compile_query_dbresultinfo_program_fun_num=
#endif
 add_program_constant("dbresultinfo",Oracle_oracle_compile_query_dbresultinfo_program,0);

#endif /* class_Oracle_oracle_compile_query_dbresultinfo_defined */

#ifdef class_Oracle_oracle_compile_query_TypedResult_defined

#ifdef PROG_ORACLE_ORACLE_COMPILE_QUERY_TYPEDRESULT_ID
#line 1083 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
  START_NEW_PROGRAM_ID(ORACLE_ORACLE_COMPILE_QUERY_TYPEDRESULT);
#else
#line 1083 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
  start_new_program();

#endif /* PROG_ORACLE_ORACLE_COMPILE_QUERY_TYPEDRESULT_ID */
#line 1083 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
  Oracle_oracle_compile_query_TypedResult_program = Pike_compiler->new_program;

#ifndef tObjImpl_ORACLE_ORACLE_COMPILE_QUERY_TYPEDRESULT

#undef tObjIs_ORACLE_ORACLE_COMPILE_QUERY_TYPEDRESULT
#define tObjIs_ORACLE_ORACLE_COMPILE_QUERY_TYPEDRESULT "\3\1\177\0\0\b"

#undef tObjImpl_ORACLE_ORACLE_COMPILE_QUERY_TYPEDRESULT
#define tObjImpl_ORACLE_ORACLE_COMPILE_QUERY_TYPEDRESULT "\3\0\177\0\0\b"

#endif /* tObjImpl_ORACLE_ORACLE_COMPILE_QUERY_TYPEDRESULT */

#ifdef THIS_ORACLE_ORACLE_COMPILE_QUERY_TYPEDRESULT
  Oracle_oracle_compile_query_TypedResult_storage_offset = ADD_STORAGE(struct Oracle_oracle_compile_query_TypedResult_struct);
#endif /* THIS_ORACLE_ORACLE_COMPILE_QUERY_TYPEDRESULT */

#ifdef inherit_cq__22__builtin_2ESql_2EResult_22_Oracle_oracle_compile_query_TypedResult_defined
#line 1130 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
  Oracle_oracle_compile_query_TypedResult_cq__22__builtin_2ESql_2EResult_22_inh_num = Pike_compiler->new_program->num_inherits;
  do {
#line 1130 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
    struct program *p = resolve_program(module_strings[1] /* "__builtin.Sql.Result" */);
    if (p) {

#ifdef module_strings_declared
#line 1130 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
      low_inherit(p, NULL, -1, 0, 0, NULL
#ifdef tGeneric
, NULL
#endif
);

#else /* module_strings_declared */
#line 1130 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
      low_inherit(p, NULL, -1, 0, 0, NULL
#ifdef tGeneric
, NULL
#endif
);

#endif /* module_strings_declared */

#ifdef Oracle_oracle_compile_query_TypedResult_cq__22__builtin_2ESql_2EResult_22_inh_offset_used
#line 1130 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
      Oracle_oracle_compile_query_TypedResult_cq__22__builtin_2ESql_2EResult_22_inh_offset = Pike_compiler->new_program->inherits[Oracle_oracle_compile_query_TypedResult_cq__22__builtin_2ESql_2EResult_22_inh_num].identifier_level;

#endif /* Oracle_oracle_compile_query_TypedResult_cq__22__builtin_2ESql_2EResult_22_inh_offset_used */

#ifdef Oracle_oracle_compile_query_TypedResult_cq__22__builtin_2ESql_2EResult_22_inh_storage_offset_used
#line 1130 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
      Oracle_oracle_compile_query_TypedResult_cq__22__builtin_2ESql_2EResult_22_inh_storage_offset = Pike_compiler->new_program->inherits[Oracle_oracle_compile_query_TypedResult_cq__22__builtin_2ESql_2EResult_22_inh_num].storage_offset;

#endif /* Oracle_oracle_compile_query_TypedResult_cq__22__builtin_2ESql_2EResult_22_inh_storage_offset_used */
#line 1130 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
      free_program(p);
    } else {
#line 1130 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
      yyerror("Inherit failed.");
    }
  } while(0);
#endif /* inherit_cq__22__builtin_2ESql_2EResult_22_Oracle_oracle_compile_query_TypedResult_defined */

#ifdef Oracle_oracle_compile_query_TypedResult_event_handler_defined
  pike_set_prog_event_callback(Oracle_oracle_compile_query_TypedResult_event_handler);

#ifndef Oracle_oracle_compile_query_TypedResult_gc_live_obj
  Pike_compiler->new_program->flags &= ~PROGRAM_LIVE_OBJ;

#endif /* Oracle_oracle_compile_query_TypedResult_gc_live_obj */

#endif /* Oracle_oracle_compile_query_TypedResult_event_handler_defined */

#ifdef f_Oracle_oracle_compile_query_TypedResult_num_rows_defined

#ifdef f_Oracle_oracle_compile_query_TypedResult_num_rows_fun_num_used
  f_Oracle_oracle_compile_query_TypedResult_num_rows_fun_num =
#endif /* f_Oracle_oracle_compile_query_TypedResult_num_rows_fun_num_used */
#line 1132 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
    ADD_FUNCTION2("num_rows", f_Oracle_oracle_compile_query_TypedResult_num_rows, tFunc(tNone,"\10\200\0\0\0\177\377\377\377"), 0, OPT_EXTERNAL_DEPEND|OPT_SIDE_EFFECT);

#endif /* f_Oracle_oracle_compile_query_TypedResult_num_rows_defined */

#ifdef f_Oracle_oracle_compile_query_TypedResult_num_fields_defined

#ifdef f_Oracle_oracle_compile_query_TypedResult_num_fields_fun_num_used
  f_Oracle_oracle_compile_query_TypedResult_num_fields_fun_num =
#endif /* f_Oracle_oracle_compile_query_TypedResult_num_fields_fun_num_used */
#line 1162 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
    ADD_FUNCTION2("num_fields", f_Oracle_oracle_compile_query_TypedResult_num_fields, tFunc(tNone,"\10\200\0\0\0\177\377\377\377"), 0, OPT_EXTERNAL_DEPEND|OPT_SIDE_EFFECT);

#endif /* f_Oracle_oracle_compile_query_TypedResult_num_fields_defined */

#ifdef f_Oracle_oracle_compile_query_TypedResult_fetch_fields_defined

#ifdef f_Oracle_oracle_compile_query_TypedResult_fetch_fields_fun_num_used
  f_Oracle_oracle_compile_query_TypedResult_fetch_fields_fun_num =
#endif /* f_Oracle_oracle_compile_query_TypedResult_fetch_fields_fun_num_used */
#line 1332 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
    ADD_FUNCTION2("fetch_fields", f_Oracle_oracle_compile_query_TypedResult_fetch_fields, tFunc(tNone,tArr(tMap(tStr,tMix))), 0, OPT_EXTERNAL_DEPEND|OPT_SIDE_EFFECT);

#endif /* f_Oracle_oracle_compile_query_TypedResult_fetch_fields_defined */

#ifdef f_Oracle_oracle_compile_query_TypedResult_eof_defined

#ifdef f_Oracle_oracle_compile_query_TypedResult_eof_fun_num_used
  f_Oracle_oracle_compile_query_TypedResult_eof_fun_num =
#endif /* f_Oracle_oracle_compile_query_TypedResult_eof_fun_num_used */
#line 1882 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
    ADD_FUNCTION2("eof", f_Oracle_oracle_compile_query_TypedResult_eof, tFunc(tNone,"\10\200\0\0\0\177\377\377\377"), 0, OPT_EXTERNAL_DEPEND|OPT_SIDE_EFFECT);

#endif /* f_Oracle_oracle_compile_query_TypedResult_eof_defined */

#ifdef f_Oracle_oracle_compile_query_TypedResult_fetch_row_defined

#ifdef f_Oracle_oracle_compile_query_TypedResult_fetch_row_fun_num_used
  f_Oracle_oracle_compile_query_TypedResult_fetch_row_fun_num =
#endif /* f_Oracle_oracle_compile_query_TypedResult_fetch_row_fun_num_used */
    ADD_FUNCTION2("fetch_row", f_Oracle_oracle_compile_query_TypedResult_fetch_row, tFunc(tNone,tOr("\10\200\0\0\0\177\377\377\377",tArr(tOr(tStr,"\10\200\0\0\0\177\377\377\377")))), 0, OPT_EXTERNAL_DEPEND|OPT_SIDE_EFFECT);

#endif /* f_Oracle_oracle_compile_query_TypedResult_fetch_row_defined */

#ifdef f_Oracle_oracle_compile_query_TypedResult_create_defined

#ifdef f_Oracle_oracle_compile_query_TypedResult_create_fun_num_used
  f_Oracle_oracle_compile_query_TypedResult_create_fun_num =
#endif /* f_Oracle_oracle_compile_query_TypedResult_create_fun_num_used */
#line 2154 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
    ADD_FUNCTION2("create", f_Oracle_oracle_compile_query_TypedResult_create, tFunc(tOr(tMap(tStr,tMix),tVoid) tOr("\10\0\0\0\0\0\0\0\1",tVoid) tOr(tObj,tVoid),tVoid), ID_PROTECTED, OPT_EXTERNAL_DEPEND|OPT_SIDE_EFFECT);

#endif /* f_Oracle_oracle_compile_query_TypedResult_create_defined */
#line 1084 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
  Pike_compiler->new_program->flags |= PROGRAM_USES_PARENT|PROGRAM_NEEDS_PARENT|PROGRAM_DESTRUCT_IMMEDIATE;
#line 1083 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
  Oracle_oracle_compile_query_TypedResult_program=end_program();
#line 1083 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
#ifdef Oracle_oracle_compile_query_TypedResult_program_fun_num_used
Oracle_oracle_compile_query_TypedResult_program_fun_num=
#endif
 add_program_constant("TypedResult",Oracle_oracle_compile_query_TypedResult_program,0);

#endif /* class_Oracle_oracle_compile_query_TypedResult_defined */

#ifdef Oracle_oracle_compile_query_event_handler_defined
  pike_set_prog_event_callback(Oracle_oracle_compile_query_event_handler);

#ifndef Oracle_oracle_compile_query_gc_live_obj
  Pike_compiler->new_program->flags &= ~PROGRAM_LIVE_OBJ;

#endif /* Oracle_oracle_compile_query_gc_live_obj */

#endif /* Oracle_oracle_compile_query_event_handler_defined */

#ifdef f_Oracle_oracle_compile_query_create_defined

#ifdef f_Oracle_oracle_compile_query_create_fun_num_used
  f_Oracle_oracle_compile_query_create_fun_num =
#endif /* f_Oracle_oracle_compile_query_create_fun_num_used */
#line 2523 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
    ADD_FUNCTION2("create", f_Oracle_oracle_compile_query_create, tFunc(tStr,tVoid), ID_PROTECTED, OPT_EXTERNAL_DEPEND|OPT_SIDE_EFFECT);

#endif /* f_Oracle_oracle_compile_query_create_defined */
#line 972 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
  Pike_compiler->new_program->flags |= PROGRAM_USES_PARENT|PROGRAM_NEEDS_PARENT;
#line 971 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
  Oracle_oracle_compile_query_program=end_program();
#line 971 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
#ifdef Oracle_oracle_compile_query_program_fun_num_used
Oracle_oracle_compile_query_program_fun_num=
#endif
 add_program_constant("compile_query",Oracle_oracle_compile_query_program,0);

#endif /* class_Oracle_oracle_compile_query_defined */

#ifdef Oracle_oracle_event_handler_defined
  pike_set_prog_event_callback(Oracle_oracle_event_handler);

#ifndef Oracle_oracle_gc_live_obj
  Pike_compiler->new_program->flags &= ~PROGRAM_LIVE_OBJ;

#endif /* Oracle_oracle_gc_live_obj */

#endif /* Oracle_oracle_event_handler_defined */

#ifdef f_Oracle_oracle_create_defined

#ifdef f_Oracle_oracle_create_fun_num_used
  f_Oracle_oracle_create_fun_num =
#endif /* f_Oracle_oracle_create_fun_num_used */
#line 2604 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
    ADD_FUNCTION2("create", f_Oracle_oracle_create, tFunc(tOr(tStr,tVoid) tOr(tStr,tVoid) tOr(tStr,tVoid) tOr(tStr,tVoid),tVoid), ID_PROTECTED, OPT_EXTERNAL_DEPEND|OPT_SIDE_EFFECT);

#endif /* f_Oracle_oracle_create_defined */

#ifdef f_Oracle_oracle_commit_defined

#ifdef f_Oracle_oracle_commit_fun_num_used
  f_Oracle_oracle_commit_fun_num =
#endif /* f_Oracle_oracle_commit_fun_num_used */
#line 2690 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
    ADD_FUNCTION2("commit", f_Oracle_oracle_commit, tFunc(tNone,tVoid), 0, OPT_EXTERNAL_DEPEND|OPT_SIDE_EFFECT);

#endif /* f_Oracle_oracle_commit_defined */
#line 463 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
  Oracle_oracle_program=end_program();
#line 463 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
#ifdef Oracle_oracle_program_fun_num_used
Oracle_oracle_program_fun_num=
#endif
 add_program_constant("oracle",Oracle_oracle_program,0);

#endif /* class_Oracle_oracle_defined */

#ifdef CMOD_MAP_PROGRAM_IDS_DEFINED
set_program_id_to_id( 0 );
#endif /* CMOD_MAP_PROGRAM_IDS_DEFINED */
#line 2741 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
;

/* FIXME: These NULL objects should be derived from push_undefined */

push_empty_string();
add_object_constant("NULLstring", nullstring_object =
clone_object(Oracle_oracle_NULL_program, 1), 0);

push_int(0);
add_object_constant("NULLint", nullint_object =
clone_object(Oracle_oracle_NULL_program, 1), 0);

push_float(0.0);
add_object_constant("NULLfloat", nullfloat_object =
clone_object(Oracle_oracle_NULL_program, 1), 0);

push_object(fast_clone_object(Oracle_oracle_Date_program));
add_object_constant("NULLdate", nulldate_object =
clone_object(Oracle_oracle_NULL_program, 1), 0);
#ifdef OCI_UTF16ID
 add_integer_constant("UNICODE_SUPPORTED", 1, 0);
#endif
}

static void call_atexits(void);

PIKE_MODULE_EXIT
{
OWERR("%s\n",__FUNCTION__);


#ifdef class_Oracle_oracle_defined

#ifdef class_Oracle_oracle_LOB_defined
  if(Oracle_oracle_LOB_program) {
#line 585 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
    free_program(Oracle_oracle_LOB_program);
    Oracle_oracle_LOB_program=0;
  }

#endif /* class_Oracle_oracle_LOB_defined */

#ifdef class_Oracle_oracle_Date_defined
  if(Oracle_oracle_Date_program) {
#line 767 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
    free_program(Oracle_oracle_Date_program);
    Oracle_oracle_Date_program=0;
  }

#endif /* class_Oracle_oracle_Date_defined */

#ifdef class_Oracle_oracle_NULL_defined
  if(Oracle_oracle_NULL_program) {
#line 890 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
    free_program(Oracle_oracle_NULL_program);
    Oracle_oracle_NULL_program=0;
  }

#endif /* class_Oracle_oracle_NULL_defined */

#ifdef class_Oracle_oracle_compile_query_defined

#ifdef class_Oracle_oracle_compile_query_dbresultinfo_defined
  if(Oracle_oracle_compile_query_dbresultinfo_program) {
#line 1019 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
    free_program(Oracle_oracle_compile_query_dbresultinfo_program);
    Oracle_oracle_compile_query_dbresultinfo_program=0;
  }

#endif /* class_Oracle_oracle_compile_query_dbresultinfo_defined */

#ifdef class_Oracle_oracle_compile_query_TypedResult_defined
  if(Oracle_oracle_compile_query_TypedResult_program) {
#line 1083 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
    free_program(Oracle_oracle_compile_query_TypedResult_program);
    Oracle_oracle_compile_query_TypedResult_program=0;
  }

#endif /* class_Oracle_oracle_compile_query_TypedResult_defined */
  if(Oracle_oracle_compile_query_program) {
#line 971 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
    free_program(Oracle_oracle_compile_query_program);
    Oracle_oracle_compile_query_program=0;
  }

#endif /* class_Oracle_oracle_compile_query_defined */
  if(Oracle_oracle_program) {
#line 463 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
    free_program(Oracle_oracle_program);
    Oracle_oracle_program=0;
  }

#endif /* class_Oracle_oracle_defined */

#ifdef module_strings_declared
{
  int i;
  for(i=0; i < 2; i++) {
    if (module_strings[i]) free_string(module_strings[i]);
    module_strings[i] = NULL;
  }
}
#endif
#line 2771 "/space/www/pikefarm/out_work/master/src/modules/Oracle/oracle.cmod"
;

if(global_error_handle)
{
OCIHandleFree(global_error_handle, OCI_HTYPE_ERROR);
global_error_handle=0;
}

if(oracle_environment)
{
OCIHandleFree(oracle_environment, OCI_HTYPE_ENV);
oracle_environment=0;
}

#define FREE_PROG(X) if(X) { free_program(X) ; X=NULL; }
#define FREE_OBJ(X) if(X) { free_object(X) ; X=NULL; }

FREE_OBJ(nullstring_object);
FREE_OBJ(nullint_object);
FREE_OBJ(nullfloat_object);
FREE_OBJ(nulldate_object);

call_atexits();
}

/*! @endmodule Oracle
 */

#ifdef DYNAMIC_MODULE

static int atexit_cnt=0;
static void (*atexit_fnc[32])(void);

int atexit(void (*func)(void))
{
if(atexit_cnt==32)
return -1;
atexit_fnc[atexit_cnt++]=func;
return 0;
}

static void call_atexits(void)
{
OWERR("%s\n",__FUNCTION__);

while(atexit_cnt)
(*atexit_fnc[--atexit_cnt])();
}

#else /* DYNAMIC_MODULE */

static void call_atexits(void)
{
}

#endif /* DYNAMIC_MODULE */

#else /* HAVE_ORACLE */

PIKE_MODULE_INIT {}
PIKE_MODULE_EXIT {}

#endif


#ifdef CMOD_MAP_PROGRAM_IDS_DEFINED
static int ___cmod_map_program_ids(int id)
{
  if( (id&0x7f000000) != 0x7f000000 ) return id;
  id = id&0x00ffffff;
  switch(id) {
#ifdef class_Oracle_oracle_defined
  case 2:
    return Oracle_oracle_program->id;
    break;
#endif
#ifdef class_Oracle_oracle_LOB_defined
  case 3:
    return Oracle_oracle_LOB_program->id;
    break;
#endif
#ifdef class_Oracle_oracle_Date_defined
  case 4:
    return Oracle_oracle_Date_program->id;
    break;
#endif
#ifdef class_Oracle_oracle_NULL_defined
  case 5:
    return Oracle_oracle_NULL_program->id;
    break;
#endif
#ifdef class_Oracle_oracle_compile_query_defined
  case 6:
    return Oracle_oracle_compile_query_program->id;
    break;
#endif
#ifdef class_Oracle_oracle_compile_query_dbresultinfo_defined
  case 7:
    return Oracle_oracle_compile_query_dbresultinfo_program->id;
    break;
#endif
#ifdef class_Oracle_oracle_compile_query_TypedResult_defined
  case 8:
    return Oracle_oracle_compile_query_TypedResult_program->id;
    break;
#endif
  };

  return 0;
}
#endif /* CMOD_MAP_PROGRAM_IDS_DEFINED */
