/* Generated from "/space/www/pikefarm/out_work/master/src/modules/sybase/sybase.cmod" by precompile.pike running Pike v8.0 release 702
 *
 * Do NOT edit this file.
 */

#undef PRECOMPILE_API_VERSION
#define PRECOMPILE_API_VERSION 6



#undef cmod___CMOD__
#define cmod___CMOD__ 1
#line 1 "/space/www/pikefarm/out_work/master/src/modules/sybase/sybase.cmod"
#line 1 "/space/www/pikefarm/out_work/master/src/modules/sybase/sybase.cmod"
#line 1 "/space/www/pikefarm/out_work/master/src/modules/sybase/sybase.cmod"
#line 3581 "/space/www/pikefarm/out_work/master/lib/modules/Tools.pmod/Standalone.pmod/precompile.pike"








#line 3589 "/space/www/pikefarm/out_work/master/lib/modules/Tools.pmod/Standalone.pmod/precompile.pike"
#line 1 "/space/www/pikefarm/out_work/master/src/modules/sybase/sybase.cmod"
#line 1 "/space/www/pikefarm/out_work/master/src/modules/sybase/sybase.cmod"
/* -*- c -*-
|| This file is part of Pike. For copyright information see COPYRIGHT.
|| Pike is distributed under GPL, LGPL and MPL. See the file COPYING
|| for more information.
*/

/*
 * Sybase driver for the Pike programming language.
 *
 * By Francesco Chemolli <kinkie@roxen.com> 10/12/1999
 *
 */

/* The sybase libraries are thread-safe, and very well-documented
 * about that (page 2-131)
 * For simplicity's sake, for now I'll use a per-connection (== per-object)
 * lock to serialize connection-related calls, and a program-level lock
 * for context-related operations. I could use more locks, to have a
 * more fine-grained locking, but since I now aim to generic SQL-interface
 * compliancy, this should do nicely.
 */

/*
 * wishlist/todolist:
 * - have an asynchronous messages reporter
 * - solve the signals-related problems
 */

#include "sybase_config.h"
#include "module.h"

#ifdef HAVE_SYBASE

#include "pike_error.h"
#include "las.h"
#include "threads.h"
#include "module_support.h"
#include "builtin_functions.h"

#include "sybase.h"


#define sp Pike_sp

/* define this to enable debugging */
/* #define SYBDEBUG */

/* define this to cancel pending results instead of retrieving them */
#define FLUSH_BY_CANCELING

/* the sybase libraries are not particularly clever in letting the user
 * know how much memory space he'll need to allocate in order to completely
 * fit a column. They _will_ notify him if an overflow occurs, but then
 * it's too late, isn't it? Some complex strategies, involving re-fetching
 * an offending row (if an overflow occurs, ct_fetch will return CS_ROW_FAIL),
 * or trying to query sybase about the needed sizes for each fetched row.
 * For now it's just easier to reserve more space than actually necessary
 * This define marks how much extra memory is to be reserved for each
 * column.
 */
#define EXTRA_COLUMN_SPACE 10240

/* big. VERY big. (2^31) */
#define MAX_RESULTS_SIZE 0x7FFFFFFF

#ifdef SYBDEBUG
#define sybdebug(...) fprintf(stderr,__VA_ARGS__)
#define errdebug(err) if(err) sybdebug(err)
#else
#define sybdebug(...)
#define errdebug(err)
#endif


/* Actual code */
#ifdef _REENTRANT
/* note to self. Whenever the mainlock is needed and there is an
 * object involved, always acquire the object's lock first.
 * post scriptum. Override this: if the main lock is needed, acquire
 * only that. However, if anybody experiences deadlocks, restore this
 * behaviour.
 */
static PIKE_MUTEX_T mainlock;
#define SYB_LOCK(X) sybdebug("locking %s\n",#X);mt_lock(&(X))
#define SYB_UNLOCK(X) sybdebug("unlocking %s\n",#X);mt_unlock(&(X))
#define SYB_MT_INIT(X) mt_init(&(X))
#define SYB_MT_EXIT(X) mt_destroy(&(X))
#else
#define SYB_LOCK(lock)
#define SYB_UNLOCK(lock)
#define SYB_MT_INIT(lock)
#define SYB_MT_EXIT(lock)
#endif

#define FAILED(status) (status!=CS_SUCCEED)
#define OK(status) (status==CS_SUCCEED)



#ifndef PIKE_UNUSED_ATTRIBUTE
#define PIKE_UNUSED_ATTRIBUTE
#endif
#define CMOD_MAP_PROGRAM_IDS_DEFINED 1
static int ___cmod_map_program_ids(int id) PIKE_UNUSED_ATTRIBUTE;
#ifndef TYPEOF
/* Compat with older Pikes. */
#define TYPEOF(SVAL)	((SVAL).type)
#define SUBTYPEOF(SVAL)	((SVAL).subtype)
#define SET_SVAL_TYPE(SVAL, TYPE)	(TYPEOF(SVAL) = TYPE)
#define SET_SVAL_SUBTYPE(SVAL, TYPE)	(SUBTYPEOF(SVAL) = TYPE)
#define SET_SVAL(SVAL, TYPE, SUBTYPE, FIELD, EXPR) do {	\
    /* Set the type afterwards to avoid a clobbered	\
     * svalue in case EXPR throws. */			\
    (SVAL).u.FIELD = (EXPR);				\
    SET_SVAL_TYPE((SVAL), (TYPE));			\
    SET_SVAL_SUBTYPE((SVAL), (SUBTYPE));		\
  } while(0)
#endif /* !TYPEOF */
#ifndef PIKE_UNUSED
/* Compat with Pike 7.8 and earlier. */
/* NB: Not strictly correct; PIKE_UNUSED was added the
 *     day after set_program_id_to_id(), but good enough.
 */
#ifndef UNUSED
#define UNUSED(X)	X
#endif
#ifndef set_program_id_to_id
/* NB: Recent Pike 7.8 has a #define that conflicts with
 *     the following declaration.
 */
static void set_program_id_to_id(void*UNUSED(id)){}
#endif
#else /* */
PMOD_EXPORT void set_program_id_to_id( int (*to)(int) );
#endif /* !PIKE_UNUSED */
#if !defined(string_has_null) && !defined(STRING_CONTENT_CHECKED)
/* This symbol was added as a macro in Pike 7.7.20, and is an
 * inline function in Pike 7.9.4 and later, at which time the
 * flag STRING_CONTENT_CHECKED was added.
 */
#define string_has_null(X) (strlen((X)->str)!=(size_t)(X)->len)
#endif


#ifndef DEFAULT_CMOD_STORAGE
#define CMOD_COND_USED
#define DEFAULT_CMOD_STORAGE static
#endif
#define module_strings_declared
static struct pike_string *module_strings[1] = {
  NULL,
};
#ifndef CMOD_COND_USED
# define f_sybase_sybase_affected_rows_fun_num_used 1
# define f_sybase_sybase_big_query_fun_num_used 1
# define f_sybase_sybase_connect_fun_num_used 1
# define f_sybase_sybase_create_fun_num_used 1
# define f_sybase_sybase_error_fun_num_used 1
# define f_sybase_sybase_fetch_fields_fun_num_used 1
# define f_sybase_sybase_fetch_row_fun_num_used 1
# define f_sybase_sybase_num_fields_fun_num_used 1
# define sybase_sybase_cq__22__builtin_2ESql_2EConnection_22_inh_offset_used 1
# define sybase_sybase_cq__22__builtin_2ESql_2EConnection_22_inh_storage_offset_used 1
# define sybase_sybase_program_fun_num_used 1
#else /* !CMOD_COND_USED */
# undef f_sybase_sybase_affected_rows_fun_num_used
# undef f_sybase_sybase_big_query_fun_num_used
# undef f_sybase_sybase_connect_fun_num_used
# undef f_sybase_sybase_create_fun_num_used
# undef f_sybase_sybase_error_fun_num_used
# undef f_sybase_sybase_fetch_fields_fun_num_used
# undef f_sybase_sybase_fetch_row_fun_num_used
# undef f_sybase_sybase_num_fields_fun_num_used
# undef sybase_sybase_cq__22__builtin_2ESql_2EConnection_22_inh_offset_used
# undef sybase_sybase_cq__22__builtin_2ESql_2EConnection_22_inh_storage_offset_used
# undef sybase_sybase_program_fun_num_used
#endif /* !CMOD_COND_USED */

#ifdef f_sybase_sybase_error_fun_num_used
DEFAULT_CMOD_STORAGE ptrdiff_t f_sybase_sybase_error_fun_num = -1;

#endif /* f_sybase_sybase_error_fun_num_used */

#ifdef f_sybase_sybase_connect_fun_num_used
DEFAULT_CMOD_STORAGE ptrdiff_t f_sybase_sybase_connect_fun_num = -1;

#endif /* f_sybase_sybase_connect_fun_num_used */

#ifdef f_sybase_sybase_create_fun_num_used
DEFAULT_CMOD_STORAGE ptrdiff_t f_sybase_sybase_create_fun_num = -1;

#endif /* f_sybase_sybase_create_fun_num_used */

#ifdef f_sybase_sybase_big_query_fun_num_used
DEFAULT_CMOD_STORAGE ptrdiff_t f_sybase_sybase_big_query_fun_num = -1;

#endif /* f_sybase_sybase_big_query_fun_num_used */

#ifdef f_sybase_sybase_fetch_row_fun_num_used
DEFAULT_CMOD_STORAGE ptrdiff_t f_sybase_sybase_fetch_row_fun_num = -1;

#endif /* f_sybase_sybase_fetch_row_fun_num_used */

#ifdef f_sybase_sybase_num_fields_fun_num_used
DEFAULT_CMOD_STORAGE ptrdiff_t f_sybase_sybase_num_fields_fun_num = -1;

#endif /* f_sybase_sybase_num_fields_fun_num_used */

#ifdef f_sybase_sybase_affected_rows_fun_num_used
DEFAULT_CMOD_STORAGE ptrdiff_t f_sybase_sybase_affected_rows_fun_num = -1;

#endif /* f_sybase_sybase_affected_rows_fun_num_used */

#ifdef f_sybase_sybase_fetch_fields_fun_num_used
DEFAULT_CMOD_STORAGE ptrdiff_t f_sybase_sybase_fetch_fields_fun_num = -1;

#endif /* f_sybase_sybase_fetch_fields_fun_num_used */
DEFAULT_CMOD_STORAGE struct program *sybase_sybase_program=NULL;

#ifdef sybase_sybase_program_fun_num_used
DEFAULT_CMOD_STORAGE int sybase_sybase_program_fun_num=-1;
#endif /* sybase_sybase_program_fun_num_used */
#line 98 "/space/www/pikefarm/out_work/master/src/modules/sybase/sybase.cmod"
;

/*************/
/* Utilities */
/*************/

#ifdef SYBDEBUG

/* just a small thing. see f_fetch_row to understand how it's used */
#define SHOW_STATUS(Y,X) case X:sybdebug("\t%s is %s\n",Y,#X);break

static void show_status(CS_RETCODE ret) {
switch(ret) {
SHOW_STATUS("status",CS_SUCCEED);
SHOW_STATUS("status",CS_PENDING);
SHOW_STATUS("status",CS_BUSY);
SHOW_STATUS("status",CS_END_RESULTS);
SHOW_STATUS("status",CS_FAIL);
SHOW_STATUS("status",CS_END_DATA);
default:
sybdebug("Unknown status: %d\n",(int)ret);
break;
}
}
static void show_results_type (CS_INT rtype) {
switch(rtype) {
SHOW_STATUS("type",CS_ROW_RESULT);
SHOW_STATUS("type",CS_CURSOR_RESULT);
SHOW_STATUS("type",CS_PARAM_RESULT);
SHOW_STATUS("type",CS_STATUS_RESULT);
SHOW_STATUS("type",CS_COMPUTE_RESULT);
SHOW_STATUS("type",CS_MSG_RESULT);
SHOW_STATUS("type",CS_DESCRIBE_RESULT);
SHOW_STATUS("type",CS_ROWFMT_RESULT);
SHOW_STATUS("type",CS_COMPUTEFMT_RESULT);
SHOW_STATUS("type",CS_CMD_DONE);
SHOW_STATUS("type",CS_CMD_SUCCEED);
SHOW_STATUS("type",CS_CMD_FAIL);
default:
sybdebug("Unknown type: %d\n",(int)rtype);
break;
}
}
static void show_severity(CS_INT severity) {
switch (severity) {
SHOW_STATUS("severity",CS_SV_INFORM);
SHOW_STATUS("severity",CS_SV_CONFIG_FAIL);
SHOW_STATUS("severity",CS_SV_RETRY_FAIL);
SHOW_STATUS("severity",CS_SV_API_FAIL);
SHOW_STATUS("severity",CS_SV_RESOURCE_FAIL);
SHOW_STATUS("severity",CS_SV_COMM_FAIL);
SHOW_STATUS("severity",CS_SV_INTERNAL_FAIL);
SHOW_STATUS("severity",CS_SV_FATAL);
}
}
#else /* SYBDEBUG */
#define show_status(X)
#define show_results_type(X)
#define show_severity(X)
#endif

/*! @module Sybase
 */

/*! @class sybase
 */

#undef class_sybase_sybase_defined
#define class_sybase_sybase_defined

#undef var_context_sybase_sybase_defined
#define var_context_sybase_sybase_defined

#undef var_connection_sybase_sybase_defined
#define var_connection_sybase_sybase_defined

#undef var_cmd_sybase_sybase_defined
#define var_cmd_sybase_sybase_defined

#undef var_busy_sybase_sybase_defined
#define var_busy_sybase_sybase_defined
#line 169 "/space/www/pikefarm/out_work/master/src/modules/sybase/sybase.cmod"
/* only one pending command per connection */


#undef var_had_error_sybase_sybase_defined
#define var_had_error_sybase_sybase_defined
#line 171 "/space/www/pikefarm/out_work/master/src/modules/sybase/sybase.cmod"
/* non-zero if had error */

#undef var_error_sybase_sybase_defined
#define var_error_sybase_sybase_defined
#line 172 "/space/www/pikefarm/out_work/master/src/modules/sybase/sybase.cmod"
/* The last error string. The size is determined by the */
/* sybase API */


#undef var_results_sybase_sybase_defined
#define var_results_sybase_sybase_defined

#undef var_results_lengths_sybase_sybase_defined
#define var_results_lengths_sybase_sybase_defined

#undef var_nulls_sybase_sybase_defined
#define var_nulls_sybase_sybase_defined

#undef var_numcols_sybase_sybase_defined
#define var_numcols_sybase_sybase_defined
#line 179 "/space/www/pikefarm/out_work/master/src/modules/sybase/sybase.cmod"
/* the number of columns */

#ifdef _REENTRANT
 
#undef var_lock_sybase_sybase_defined
#define var_lock_sybase_sybase_defined
#line 183 "/space/www/pikefarm/out_work/master/src/modules/sybase/sybase.cmod"
#endif


#undef THIS
#define THIS ((struct sybase_sybase_struct *)(Pike_interpreter.frame_pointer->current_storage + sybase_sybase_storage_offset))

#undef THIS_SYBASE_SYBASE
#define THIS_SYBASE_SYBASE ((struct sybase_sybase_struct *)(Pike_interpreter.frame_pointer->current_storage + sybase_sybase_storage_offset))

#undef OBJ2_SYBASE_SYBASE
#define OBJ2_SYBASE_SYBASE(o) ((struct sybase_sybase_struct *)(o->storage+sybase_sybase_storage_offset+sybase_sybase_program->inherits[0].storage_offset))

#undef GET_SYBASE_SYBASE_STORAGE
#define GET_SYBASE_SYBASE_STORAGE(o) ((struct sybase_sybase_struct *)(o->storage+sybase_sybase_storage_offset+sybase_sybase_program->inherits[0].storage_offset))
static ptrdiff_t sybase_sybase_storage_offset;
struct sybase_sybase_struct {

#ifdef var_context_sybase_sybase_defined
#line 166 "/space/www/pikefarm/out_work/master/src/modules/sybase/sybase.cmod"
CS_CONTEXT *context;
#endif /* var_context_sybase_sybase_defined */

#ifdef var_connection_sybase_sybase_defined
#line 167 "/space/www/pikefarm/out_work/master/src/modules/sybase/sybase.cmod"
CS_CONNECTION *connection;
#endif /* var_connection_sybase_sybase_defined */

#ifdef var_cmd_sybase_sybase_defined
#line 168 "/space/www/pikefarm/out_work/master/src/modules/sybase/sybase.cmod"
CS_COMMAND *cmd;
#endif /* var_cmd_sybase_sybase_defined */

#ifdef var_busy_sybase_sybase_defined
#line 169 "/space/www/pikefarm/out_work/master/src/modules/sybase/sybase.cmod"
char busy;
#endif /* var_busy_sybase_sybase_defined */

#ifdef var_had_error_sybase_sybase_defined
#line 171 "/space/www/pikefarm/out_work/master/src/modules/sybase/sybase.cmod"
char had_error;
#endif /* var_had_error_sybase_sybase_defined */

#ifdef var_error_sybase_sybase_defined
#line 172 "/space/www/pikefarm/out_work/master/src/modules/sybase/sybase.cmod"
char error[256];
#endif /* var_error_sybase_sybase_defined */

#ifdef var_results_sybase_sybase_defined
#line 175 "/space/www/pikefarm/out_work/master/src/modules/sybase/sybase.cmod"
char **results;
#endif /* var_results_sybase_sybase_defined */

#ifdef var_results_lengths_sybase_sybase_defined
#line 176 "/space/www/pikefarm/out_work/master/src/modules/sybase/sybase.cmod"
CS_INT *results_lengths;
#endif /* var_results_lengths_sybase_sybase_defined */

#ifdef var_nulls_sybase_sybase_defined
#line 177 "/space/www/pikefarm/out_work/master/src/modules/sybase/sybase.cmod"
CS_SMALLINT *nulls;
#endif /* var_nulls_sybase_sybase_defined */

#ifdef var_numcols_sybase_sybase_defined
#line 179 "/space/www/pikefarm/out_work/master/src/modules/sybase/sybase.cmod"
int numcols;
#endif /* var_numcols_sybase_sybase_defined */

#ifdef var_lock_sybase_sybase_defined
#line 182 "/space/www/pikefarm/out_work/master/src/modules/sybase/sybase.cmod"
PIKE_MUTEX_T lock;
#endif /* var_lock_sybase_sybase_defined */
};
#ifdef PIKE_DEBUG
/* Ensure the struct is used in a variable declaration, or else gdb might not see it. */
static struct sybase_sybase_struct *sybase_sybase_gdb_dummy_ptr;
#endif
#line 185 "/space/www/pikefarm/out_work/master/src/modules/sybase/sybase.cmod"
;

/*! @decl inherit __builtin.Sql.Connection
   */

#undef inherit_cq__22__builtin_2ESql_2EConnection_22_sybase_sybase_defined
#define inherit_cq__22__builtin_2ESql_2EConnection_22_sybase_sybase_defined
#line 189 "/space/www/pikefarm/out_work/master/src/modules/sybase/sybase.cmod"
static int sybase_sybase_cq__22__builtin_2ESql_2EConnection_22_inh_num = -1;

#ifdef sybase_sybase_cq__22__builtin_2ESql_2EConnection_22_inh_offset_used
#line 189 "/space/www/pikefarm/out_work/master/src/modules/sybase/sybase.cmod"
static int sybase_sybase_cq__22__builtin_2ESql_2EConnection_22_inh_offset = -1;

#endif /* sybase_sybase_cq__22__builtin_2ESql_2EConnection_22_inh_offset_used */

#ifdef sybase_sybase_cq__22__builtin_2ESql_2EConnection_22_inh_storage_offset_used
#line 189 "/space/www/pikefarm/out_work/master/src/modules/sybase/sybase.cmod"
static int sybase_sybase_cq__22__builtin_2ESql_2EConnection_22_inh_storage_offset = -1;

#endif /* sybase_sybase_cq__22__builtin_2ESql_2EConnection_22_inh_storage_offset_used */
#line 191 "/space/www/pikefarm/out_work/master/src/modules/sybase/sybase.cmod"
typedef struct sybase_sybase_struct pike_sybase_connection;

/*
 * Must be called in a MT-safe fashion
 */
static INT32 guess_column_length (CS_COMMAND *cmd, int column_number) {
CS_DATAFMT description;

ct_describe(cmd,column_number,&description);
return (INT32)description.maxlength;
}

/* this function does _NOT_ involve any pike processing
 * If run in MT-enabled sections, locking is to be insured by the caller
 * on a per-command-structure basis.
 */
static void flush_results_queue(pike_sybase_connection *this) {
CS_INT rtype;
CS_RETCODE ret;
int j;
CS_COMMAND *cmd;


sybdebug("Flushing the results queue\n");
#ifdef FLUSH_BY_CANCELING
 ct_cancel(this->connection,NULL,CS_CANCEL_ALL);
#else
 cmd=this->cmd;
for (j=0;j<100;j++) { /* safety valve, I don't want to loop forever */

sybdebug("Getting results #%d\n",j);
ret=ct_results(cmd,&rtype);
show_status(ret);
show_results_type(rtype);

switch(ret) {
case CS_END_RESULTS:
sybdebug("Finished flushing results\n");
return;
case CS_FAIL:
ret=ct_cancel(this->connection,NULL,CS_CANCEL_ALL);
continue;
}

/* I'd probably be getting a result back here. I don't need it, so
     * I'll just cancel */
switch(rtype) {
case CS_ROW_RESULT:
case CS_STATUS_RESULT:
case CS_PARAM_RESULT:
sybdebug("Unexpected result. Cancel-ing\n");
ret=ct_cancel(NULL,this->cmd,CS_CANCEL_CURRENT);
show_status(ret);
break;
}
}
#endif
}

/*
 * returns 1 if there's any Pike_error
 * the same thread-safety rules as flush_results_queue apply
 * QUESTION:
 * Should I explore all messages, and leave in this->error the
 * last one with an error-level severity?
 * or should we maybe only consider server messages?
 */
static int handle_errors (pike_sybase_connection *this) {
SQLCA message;
CS_INT num,j, severity;
CS_RETCODE ret;

sybdebug("Handling errors\n");
ret=ct_diag(this->connection,CS_STATUS,CS_ALLMSG_TYPE,CS_UNUSED,&num);
show_status(ret);
if (FAILED(ret)) {
sybdebug("Error while retrieving errors number");
return 1;
}
sybdebug ("I have %d messages in queue\n",(int)num);

if (!num) /* no need to go through the moves */
return 0;

for (j=1;j<=num;j++) {
ct_diag(this->connection, CS_GET, SQLCA_TYPE, j, &message);
if (FAILED(ret)) {
sybdebug("Error while retrieving last message\n");
return 1;
}
sybdebug("\nMessage %d length: %ld; text:\n%s\n",j,
((int)message.sqlerrm.sqlerrml),message.sqlerrm.sqlerrmc);
/* If it's severe enough? */
severity=CS_SEVERITY(message.sqlcode);
show_severity(severity);
}

memcpy(this->error,message.sqlerrm.sqlerrmc,
message.sqlerrm.sqlerrml+1);

this->had_error=1;
ct_diag(this->connection,CS_CLEAR,SQLCA_TYPE,CS_UNUSED,NULL);

return 0;
}


/*******************/
/* low_level stuff */
/*******************/


#undef internal_init_sybase_sybase_defined
#define internal_init_sybase_sybase_defined

#undef sybase_sybase_event_handler_defined
#define sybase_sybase_event_handler_defined
static void init_sybase_sybase_struct(void)
#line 303 "/space/www/pikefarm/out_work/master/src/modules/sybase/sybase.cmod"
{
pike_sybase_connection *this=THIS;

sybdebug("sybase_create()\n");
this->context=NULL;
this->connection=NULL;
this->cmd=NULL;
this->busy=0;
this->results=NULL;
this->results_lengths=NULL;
this->nulls=NULL;
this->numcols=0;
this->had_error=0;
SYB_MT_INIT(THIS->lock);
}



#undef sybase_sybase_gc_live_obj
#define sybase_sybase_gc_live_obj

#undef internal_exit_sybase_sybase_defined
#define internal_exit_sybase_sybase_defined

#undef sybase_sybase_event_handler_defined
#define sybase_sybase_event_handler_defined
static void exit_sybase_sybase_struct(void)
#line 321 "/space/www/pikefarm/out_work/master/src/modules/sybase/sybase.cmod"
{
pike_sybase_connection *this=THIS;
CS_RETCODE ret;
int j;

sybdebug("sybase_destroy()\n");
THREADS_ALLOW();
SYB_LOCK(this->lock);


if (this->busy > 0) {
sybdebug("We're busy while destroying. Trying to cancel\n");
ret=ct_cancel(this->connection,NULL,CS_CANCEL_ALL);
show_status(ret);
/* we only have one active command, but what the hell.. */
if (FAILED(ret)) {
sybdebug("\tUh oh... failed\n");
}
this->busy--;
sybdebug("Busy status: %d\n",this->busy);
/* if we fail, it's useless anyways. Maybe we should Pike_fatal() */
}

if (this->cmd) {
sybdebug("this->cmd still active. Dropping\n");
ret=ct_cmd_drop(this->cmd);
show_status(ret);
if (FAILED(ret)) {
sybdebug("\tHm... failed\n");
}
this->cmd=NULL;
/* if we fail, it's useless anyways. Maybe we should Pike_fatal() */
}

if (this->results) {
sybdebug("Freeing results buffers\n");
for (j=0;j<this->numcols;j++) {
free(this->results[j]);
}
free (this->results);
free (this->results_lengths);
free (this->nulls);
this->results=NULL;
this->results_lengths=NULL;
this->nulls=NULL;
this->numcols=0;
}

if (this->connection) {
sybdebug("this->connection still active. Closing\n");
ret=ct_close(this->connection,CS_UNUSED);
show_status(ret);
if (FAILED(ret)) {
sybdebug("\tArgh! Failed!\n");
}
sybdebug("Dropping connection\n");
ret=ct_con_drop(this->connection);
show_status(ret);
if (FAILED(ret)) {
sybdebug("Gasp! Failed!\n");
}
this->connection=NULL;
/* if we fail, it's useless anyways. Maybe we should Pike_fatal() */
}

SYB_LOCK(mainlock); /* this is really needed only here */

if (this->context) {
sybdebug("this->context still active. Exiting\n");
ret = ct_exit(this->context, CS_UNUSED);
show_status(ret);
if (FAILED(ret)) {
sybdebug("\tGosh Batman! We failed!\n");
}
ret = cs_ctx_drop(this->context);
show_status(ret);
if (FAILED(ret)) {
sybdebug("\tGosh Robin! You're right!\n");
}
this->context=NULL;
/* if we fail, it's useless anyways. Maybe we should Pike_fatal() */
}

SYB_UNLOCK(mainlock);
SYB_UNLOCK(this->lock);

THREADS_DISALLOW();
SYB_MT_EXIT(THIS->lock);
}

/**********************/
/* exported functions */
/**********************/

#define f_sybase_sybase_error_defined
DEFAULT_CMOD_STORAGE void f_sybase_sybase_error(INT32 args) {
#line 415 "/space/www/pikefarm/out_work/master/src/modules/sybase/sybase.cmod"
struct svalue * clear;
#ifdef PIKE_DEBUG
if(args < 0) Pike_fatal("CMOD function argument negative.\n");
#else
STATIC_ASSUME(args >= 0);
#endif
#line 415 "/space/www/pikefarm/out_work/master/src/modules/sybase/sybase.cmod"
if(args > 1) wrong_number_of_args_error("error",args,1);
#line 415 "/space/www/pikefarm/out_work/master/src/modules/sybase/sybase.cmod"
if ((args > 0) &&
    ((TYPEOF(Pike_sp[0-args]) != PIKE_T_INT) ||
     (SUBTYPEOF(Pike_sp[0-args]) != NUMBER_UNDEFINED))) {
#line 415 "/space/www/pikefarm/out_work/master/src/modules/sybase/sybase.cmod"
if((TYPEOF(Pike_sp[0-args]) != PIKE_T_INT)) SIMPLE_ARG_TYPE_ERROR("error",1,"void|int");
#line 415 "/space/www/pikefarm/out_work/master/src/modules/sybase/sybase.cmod"
clear=Pike_sp+0-args; dmalloc_touch_svalue(Pike_sp+0-args);
#line 415 "/space/www/pikefarm/out_work/master/src/modules/sybase/sybase.cmod"
} else clear = NULL;
{
int clearit = clear && clear->u.integer;
pike_sybase_connection *this=THIS;

pop_n_elems(args);

if (this->had_error) {
push_text(this->error);
if (clearit)
this->had_error = 0;
} else
push_int(0);
}


}
#line 431 "/space/www/pikefarm/out_work/master/src/modules/sybase/sybase.cmod"
/* void connect(host, database, username, password, port) */
/*  The port and database arguments are silently ignored  */
#define f_sybase_sybase_connect_defined
DEFAULT_CMOD_STORAGE void f_sybase_sybase_connect(INT32 args) {
#line 433 "/space/www/pikefarm/out_work/master/src/modules/sybase/sybase.cmod"
struct pike_string * hostname_;
#line 433 "/space/www/pikefarm/out_work/master/src/modules/sybase/sybase.cmod"
struct pike_string * database_;
struct pike_string * username_;
#line 434 "/space/www/pikefarm/out_work/master/src/modules/sybase/sybase.cmod"
struct pike_string * pass_;
struct svalue * port_;
#ifdef PIKE_DEBUG
if(args < 0) Pike_fatal("CMOD function argument negative.\n");
#else
STATIC_ASSUME(args >= 0);
#endif
#line 433 "/space/www/pikefarm/out_work/master/src/modules/sybase/sybase.cmod"
if(args > 5) wrong_number_of_args_error("connect",args,5);
#line 433 "/space/www/pikefarm/out_work/master/src/modules/sybase/sybase.cmod"
if (args > 0 &&
    (TYPEOF(Pike_sp[0-args]) != PIKE_T_INT ||
     Pike_sp[0-args].u.integer)) {
#line 433 "/space/www/pikefarm/out_work/master/src/modules/sybase/sybase.cmod"
if(TYPEOF(Pike_sp[0-args]) != PIKE_T_STRING) SIMPLE_ARG_TYPE_ERROR("connect",1,"string|void");
#line 433 "/space/www/pikefarm/out_work/master/src/modules/sybase/sybase.cmod"
debug_malloc_pass(hostname_=Pike_sp[0-args].u.string);
#line 433 "/space/www/pikefarm/out_work/master/src/modules/sybase/sybase.cmod"
} else hostname_ = NULL;
#line 433 "/space/www/pikefarm/out_work/master/src/modules/sybase/sybase.cmod"
if (args > 1 &&
    (TYPEOF(Pike_sp[1-args]) != PIKE_T_INT ||
     Pike_sp[1-args].u.integer)) {
#line 433 "/space/www/pikefarm/out_work/master/src/modules/sybase/sybase.cmod"
if(TYPEOF(Pike_sp[1-args]) != PIKE_T_STRING) SIMPLE_ARG_TYPE_ERROR("connect",2,"string|void");
#line 433 "/space/www/pikefarm/out_work/master/src/modules/sybase/sybase.cmod"
debug_malloc_pass(database_=Pike_sp[1-args].u.string);
#line 433 "/space/www/pikefarm/out_work/master/src/modules/sybase/sybase.cmod"
} else database_ = NULL;
if (args > 2 &&
    (TYPEOF(Pike_sp[2-args]) != PIKE_T_INT ||
     Pike_sp[2-args].u.integer)) {
#line 434 "/space/www/pikefarm/out_work/master/src/modules/sybase/sybase.cmod"
if(TYPEOF(Pike_sp[2-args]) != PIKE_T_STRING) SIMPLE_ARG_TYPE_ERROR("connect",3,"string|void");
#line 434 "/space/www/pikefarm/out_work/master/src/modules/sybase/sybase.cmod"
debug_malloc_pass(username_=Pike_sp[2-args].u.string);
#line 434 "/space/www/pikefarm/out_work/master/src/modules/sybase/sybase.cmod"
} else username_ = NULL;
#line 434 "/space/www/pikefarm/out_work/master/src/modules/sybase/sybase.cmod"
if (args > 3 &&
    (TYPEOF(Pike_sp[3-args]) != PIKE_T_INT ||
     Pike_sp[3-args].u.integer)) {
#line 434 "/space/www/pikefarm/out_work/master/src/modules/sybase/sybase.cmod"
if(TYPEOF(Pike_sp[3-args]) != PIKE_T_STRING) SIMPLE_ARG_TYPE_ERROR("connect",4,"string|void");
#line 434 "/space/www/pikefarm/out_work/master/src/modules/sybase/sybase.cmod"
debug_malloc_pass(pass_=Pike_sp[3-args].u.string);
#line 434 "/space/www/pikefarm/out_work/master/src/modules/sybase/sybase.cmod"
} else pass_ = NULL;
if ((args > 4) &&
    ((TYPEOF(Pike_sp[4-args]) != PIKE_T_INT) ||
     (SUBTYPEOF(Pike_sp[4-args]) != NUMBER_UNDEFINED))) {
#line 435 "/space/www/pikefarm/out_work/master/src/modules/sybase/sybase.cmod"
if((TYPEOF(Pike_sp[4-args]) != PIKE_T_INT)) SIMPLE_ARG_TYPE_ERROR("connect",5,"int|void");
#line 435 "/space/www/pikefarm/out_work/master/src/modules/sybase/sybase.cmod"
port_=Pike_sp+4-args; dmalloc_touch_svalue(Pike_sp+4-args);
#line 435 "/space/www/pikefarm/out_work/master/src/modules/sybase/sybase.cmod"
} else port_ = NULL;
{
CS_RETCODE ret;
CS_CONTEXT *context;
CS_CONNECTION *connection;
char *username=NULL, *pass=NULL, *hostname=NULL, *err=NULL;
int usernamelen=0, passlen=0, hostnamelen=CS_UNUSED;
pike_sybase_connection *this=THIS;

sybdebug("sybase::connect(args=%d)\n",args);

/* fetch arguments, so that we can enable threads */
if (TYPEOF(sp[2-args]) == T_STRING && sp[2-args].u.string->len) { /*username*/
username=sp[2-args].u.string->str;
usernamelen=sp[2-args].u.string->len;
sybdebug("\tgot username: %s\n",username);
}
if (TYPEOF(sp[3-args]) == T_STRING && sp[2-args].u.string->len) { /*password*/
pass=sp[3-args].u.string->str;
passlen=sp[3-args].u.string->len;
sybdebug("\tgot password: %s\n",pass);
}
if (TYPEOF(sp[-args]) == T_STRING && sp[-args].u.string->len) { /*hostname*/
hostname=sp[-args].u.string->str;
hostnamelen=sp[-args].u.string->len;
sybdebug("\tgot hostname: %s\n",hostname);
}

THREADS_ALLOW();
SYB_LOCK(mainlock);

/* It's OK not to lock here. It's just a check that should never happen.
   * if it happens, we're in deep sh*t already.*/
if (!(context=this->context)) {
err="Internal error: connection attempted, but no context available\n";
}

if (!err) {
sybdebug("\tallocating context\n");
ret=ct_con_alloc(context,&connection); /*sybase says it's thread-safe..*/
show_status(ret);
if (FAILED(ret)) {
err="Cannot initialize connection\n";
}
}
errdebug(err);

if (!err) { /* initialize error-handling code */
ret=ct_diag(connection,CS_INIT,CS_UNUSED,CS_UNUSED,NULL);
show_status(ret);
if (FAILED(ret)) {
err="Can't initialize error-handling code\n";
}
}
errdebug(err);

/* if there already was an error, we just locked uselessly.
   * No big deal, it should never happen anyways... */

/* username */
if (!err && usernamelen) {
sybdebug("\tsetting username to \"%s\"\n",username);
ret=ct_con_props(connection,CS_SET,CS_USERNAME,
username,usernamelen,NULL);
show_status(ret);
if (FAILED(ret)) {
err="Can't set username\n";
}
}
errdebug(err);

/* password */
if (!err && passlen) {
sybdebug("\tsetting password to \"%s\"\n",pass);
ret=ct_con_props(connection,CS_SET,CS_PASSWORD,
pass,passlen,NULL);
show_status(ret);
if (FAILED(ret)) {
err="Can't set password\n";
}
}
errdebug(err);

/* connect, finally */
if (!err) {
if (hostname) {
sybdebug("\tconnecting to hostname is \"%s\"\n",hostname);
}
ret=ct_connect(connection,(CS_CHAR *)hostname, hostnamelen);
show_status(ret);
if (FAILED(ret)) {
err="Can't connect\n";
} else {
this->connection=connection;
}
}
errdebug(err);

if (err) ct_con_drop(connection);

SYB_UNLOCK(mainlock);
THREADS_DISALLOW();

if (err) {
handle_errors(this); /* let's centralize */
Pike_error(err);
}

sybdebug("sybase::connect exiting\n");
}

}
#line 546 "/space/www/pikefarm/out_work/master/src/modules/sybase/sybase.cmod"
/* create (host,database,username,password,port|options) */
#define f_sybase_sybase_create_defined
DEFAULT_CMOD_STORAGE void f_sybase_sybase_create(INT32 args) {
#line 547 "/space/www/pikefarm/out_work/master/src/modules/sybase/sybase.cmod"
struct pike_string * host_;
#line 547 "/space/www/pikefarm/out_work/master/src/modules/sybase/sybase.cmod"
struct pike_string * db_;
struct pike_string * user_;
#line 548 "/space/www/pikefarm/out_work/master/src/modules/sybase/sybase.cmod"
struct pike_string * pass_;
struct svalue * options_;
#ifdef PIKE_DEBUG
if(args < 0) Pike_fatal("CMOD function argument negative.\n");
#else
STATIC_ASSUME(args >= 0);
#endif
#line 547 "/space/www/pikefarm/out_work/master/src/modules/sybase/sybase.cmod"
if(args > 5) wrong_number_of_args_error("create",args,5);
#line 547 "/space/www/pikefarm/out_work/master/src/modules/sybase/sybase.cmod"
if (args > 0 &&
    (TYPEOF(Pike_sp[0-args]) != PIKE_T_INT ||
     Pike_sp[0-args].u.integer)) {
#line 547 "/space/www/pikefarm/out_work/master/src/modules/sybase/sybase.cmod"
if(TYPEOF(Pike_sp[0-args]) != PIKE_T_STRING) SIMPLE_ARG_TYPE_ERROR("create",1,"string|void");
#line 547 "/space/www/pikefarm/out_work/master/src/modules/sybase/sybase.cmod"
debug_malloc_pass(host_=Pike_sp[0-args].u.string);
#line 547 "/space/www/pikefarm/out_work/master/src/modules/sybase/sybase.cmod"
} else host_ = NULL;
#line 547 "/space/www/pikefarm/out_work/master/src/modules/sybase/sybase.cmod"
if (args > 1 &&
    (TYPEOF(Pike_sp[1-args]) != PIKE_T_INT ||
     Pike_sp[1-args].u.integer)) {
#line 547 "/space/www/pikefarm/out_work/master/src/modules/sybase/sybase.cmod"
if(TYPEOF(Pike_sp[1-args]) != PIKE_T_STRING) SIMPLE_ARG_TYPE_ERROR("create",2,"string|void");
#line 547 "/space/www/pikefarm/out_work/master/src/modules/sybase/sybase.cmod"
debug_malloc_pass(db_=Pike_sp[1-args].u.string);
#line 547 "/space/www/pikefarm/out_work/master/src/modules/sybase/sybase.cmod"
} else db_ = NULL;
if (args > 2 &&
    (TYPEOF(Pike_sp[2-args]) != PIKE_T_INT ||
     Pike_sp[2-args].u.integer)) {
#line 548 "/space/www/pikefarm/out_work/master/src/modules/sybase/sybase.cmod"
if(TYPEOF(Pike_sp[2-args]) != PIKE_T_STRING) SIMPLE_ARG_TYPE_ERROR("create",3,"string|void");
#line 548 "/space/www/pikefarm/out_work/master/src/modules/sybase/sybase.cmod"
debug_malloc_pass(user_=Pike_sp[2-args].u.string);
#line 548 "/space/www/pikefarm/out_work/master/src/modules/sybase/sybase.cmod"
} else user_ = NULL;
#line 548 "/space/www/pikefarm/out_work/master/src/modules/sybase/sybase.cmod"
if (args > 3 &&
    (TYPEOF(Pike_sp[3-args]) != PIKE_T_INT ||
     Pike_sp[3-args].u.integer)) {
#line 548 "/space/www/pikefarm/out_work/master/src/modules/sybase/sybase.cmod"
if(TYPEOF(Pike_sp[3-args]) != PIKE_T_STRING) SIMPLE_ARG_TYPE_ERROR("create",4,"string|void");
#line 548 "/space/www/pikefarm/out_work/master/src/modules/sybase/sybase.cmod"
debug_malloc_pass(pass_=Pike_sp[3-args].u.string);
#line 548 "/space/www/pikefarm/out_work/master/src/modules/sybase/sybase.cmod"
} else pass_ = NULL;
if ((args > 4) &&
    ((TYPEOF(Pike_sp[4-args]) != PIKE_T_INT) ||
     (SUBTYPEOF(Pike_sp[4-args]) != NUMBER_UNDEFINED))) {
#line 549 "/space/www/pikefarm/out_work/master/src/modules/sybase/sybase.cmod"
options_=Pike_sp+4-args; dmalloc_touch_svalue(Pike_sp+4-args);
#line 549 "/space/www/pikefarm/out_work/master/src/modules/sybase/sybase.cmod"
} else options_ = NULL;
{
char *host,*db,*user,*pass;
CS_RETCODE ret;
CS_CONTEXT *context;
char* err=NULL;
pike_sybase_connection *this=THIS;

sybdebug("sybase::create(args=%d)\n",args);

/* if connected, disconnect */
if (this->context)
sybase_destroy(Pike_fp->current_object);

THREADS_ALLOW();
SYB_LOCK(mainlock);

/* allocate context */
ret=cs_ctx_alloc(CS_VERSION_110,&(this->context));
show_status(ret);
if (FAILED(ret))
err = "Cannot allocate context!\n";

context=this->context;

/* initialize open client-library emulation */
if (!err) {
ret=ct_init(context,CS_VERSION_110);
if (FAILED(ret)) {
ct_exit(context,CS_UNUSED);
err="Cannot initialize library version 1.11.X!\n";
}
}

/* if there was no error, we can try to connect. Since f_connect
   * will do its own threads meddling, we must disable threads first
   */

if (err) { /* there was an error. bail out */
cs_ctx_drop(context);
this->context=NULL;
}

SYB_UNLOCK(mainlock);
THREADS_DISALLOW();

if (err) Pike_error(err); /* throw the exception if appropriate */

/* now connect */
if (args)
f_connect(args);

sybdebug("sybase::create exiting\n");
}

}
#line 604 "/space/www/pikefarm/out_work/master/src/modules/sybase/sybase.cmod"
/* TODO: should I cancel a pending query instead of throwing errors?
 *
 * object(sybase.sybase_result)|string big_query(string q)
 *
 * NOTICE: the string return value is an extension to the standard API.
 *  It will returned ONLY if it is the return status from a stored procedure
 */

#define PS_NORESULT 1
#define PS_RESULT_THIS 2
#define PS_RESULT_STATUS 3
/* if function_result == PS_RESULT_STATUS, the value to be returned
   is *function_result */

#define f_sybase_sybase_big_query_defined
DEFAULT_CMOD_STORAGE void f_sybase_sybase_big_query(INT32 args) {
#line 618 "/space/www/pikefarm/out_work/master/src/modules/sybase/sybase.cmod"
struct pike_string * query_;
#line 618 "/space/www/pikefarm/out_work/master/src/modules/sybase/sybase.cmod"
if(args != 1) wrong_number_of_args_error("big_query",args,1);
#line 618 "/space/www/pikefarm/out_work/master/src/modules/sybase/sybase.cmod"
if(TYPEOF(Pike_sp[0-1]) != PIKE_T_STRING) SIMPLE_ARG_TYPE_ERROR("big_query",1,"string");
#line 618 "/space/www/pikefarm/out_work/master/src/modules/sybase/sybase.cmod"
debug_malloc_pass(query_=Pike_sp[0-1].u.string);
#line 620 "/space/www/pikefarm/out_work/master/src/modules/sybase/sybase.cmod"
{
pike_sybase_connection *this=THIS;
char *query, *err=NULL, *function_result=NULL;
int querylen, numcols,j, done=0;
CS_COMMAND *cmd=this->cmd;
CS_RETCODE ret;
CS_DATAFMT description, got_desc;
CS_INT rtype;
char ** results;
CS_INT *results_lengths;
CS_SMALLINT *nulls;
int toreturn=PS_NORESULT; /* one of the #defines here above */

/* check, get and pop args */
check_all_args(NULL,args,BIT_STRING,0);
query=sp[-args].u.string->str;
querylen=sp[-args].u.string->len;
sybdebug("query: '%s'\n",query);
/* pop_n_elems(args); Let's try moving it later */

sybdebug("Busy status: %d\n",this->busy);

/* verify that we're not busy handing out results */
if (this->busy > 0)
Pike_error("Busy\n");

THREADS_ALLOW();
SYB_LOCK(this->lock);

if (cmd==NULL) {
/* no sense in alloc-ing everytime */
sybdebug("Allocating command structure\n");
ret=ct_cmd_alloc(this->connection, &cmd);
show_status(ret);

if (FAILED(ret)) {
sybdebug("\tUh oh... problems\n");
err="Error allocating command\n";
}

this->cmd=cmd;
}

if (this->results) {
sybdebug("Freeing previous results DMA memory\n");
for (j=0;j<(this->numcols);j++) {
sybdebug("Column %d (%p)\n",j,this->results[j]);
free(this->results[j]);
}
sybdebug("Freeing main results array\n");
free(this->results);
free(this->results_lengths);
free(this->nulls);
this->results=NULL;
this->results_lengths=NULL;
this->nulls=NULL;
this->numcols=0;
}

if (!err) { /* we can't be done yet */
sybdebug("issung command\n");
ret=ct_command(cmd,CS_LANG_CMD,query,querylen,CS_UNUSED);
show_status(ret);
if (FAILED(ret)) {
sybdebug("\tUh oh... something wrong here\n");
err="Error while setting command\n";
}
}

if (!err) { /* we can't be done yet */
sybdebug("Sending command\n");
ret=ct_send(cmd);
show_status(ret);
this->busy++;
sybdebug("Busy status: %d\n",this->busy);
if (FAILED(ret)) {
sybdebug("\thm... I don't like what I'm seeing\n");
err="Error while sending command\n";
}
}

if (err) { /* we can't be done yet */
sybdebug("Problems. Dropping command\n");
ct_cmd_drop(cmd);
this->cmd=NULL;
/*     this->busy--; */
/*     sybdebug("Busy status: %d\n",this->busy); */
}


/* let's move the first part of a process here.
   */

while (!err && !done) {
/* okay, let's see what we got */
sybdebug("Issuing results\n");
ret=ct_results(cmd,&rtype);
show_status(ret);
show_results_type(rtype);

switch(ret) {
case CS_PENDING:
case CS_BUSY:
sybdebug("Got strange stuff\n");
err="Async operations are not supported\n";
break;
case CS_END_RESULTS:
sybdebug("No more results\n");
/*       this->busy--; */
/*       sybdebug("Busy status: %d\n",this->busy); */
done=1;/* we return 0 from a query. Sounds good.. */
break;
case CS_FAIL: /* uh oh, something's terribly wrong */
sybdebug("Command failed. Canceling\n");
ct_cancel(this->connection,NULL,CS_CANCEL_ALL);/* try to cancel result */
/*       this->busy--; */
/*       sybdebug("Busy status: %d\n",this->busy); */
/* we should really check the return code here.. */
err="Canceled\n";
flush_results_queue(this);
break;
case CS_CANCELED:
sybdebug("Results canceled\n");
/*       this->busy--; */
flush_results_queue(this);
break;
default:; /* Ok */
}

if (err||done) break; /* get out of the while cycle */

/* We should probably put this in a do..while cycle, so that we can
   * ignore STATUS results and such: only the first three carry useful
   * information..
   */
/* we need to set the fetch-cycle up. It really looks like DMA to me.. */
switch (rtype) {
case CS_ROW_RESULT:
case CS_CURSOR_RESULT:
case CS_PARAM_RESULT:
sybdebug("Got useful results\n");
/* we're getting rows of data here. Also, I'm skipping a few command
         results, for command which should be pretty safe */
ct_res_info(cmd,CS_NUMDATA,&numcols,CS_UNUSED,NULL);
this->numcols=numcols;
sybdebug("I have %d columns' worth of data\n",numcols);
sybdebug("Allocating results**\n");
/* it looks like xalloc can't be used here. Hubbe? */
results=calloc(numcols, sizeof(char*));
results_lengths=calloc(numcols, sizeof(CS_INT));
nulls=calloc(numcols, sizeof(CS_SMALLINT));
this->results=results;
this->results_lengths=results_lengths;
this->nulls=nulls;

/* these values are set for each column, since we're fetching
       * one row per cycle in fetch_row */
/*       description.datatype=CS_TEXT_TYPE; */
description.datatype=CS_CHAR_TYPE; /* let's see if this works better */
description.format=CS_FMT_NULLTERM;
description.maxlength=MAX_RESULTS_SIZE-1;
description.scale=CS_SRC_VALUE;
description.precision=CS_SRC_VALUE;
description.count=1;
description.locale=NULL;

for(j=0;j<numcols;j++) {
INT32 length=guess_column_length(cmd,j+1);
sybdebug("beginning work on column %d (index %d)\n",j+1,j);
sybdebug("Allocating %ld+%d+1 bytes\n",length,EXTRA_COLUMN_SPACE);
/* it looks like xalloc can't be used here. Hubbe? */
results[j]=calloc(length+EXTRA_COLUMN_SPACE+1,
sizeof(char));
if (results[j]==NULL) {
sybdebug("PANIC! COULDN'T ALLOCATE MEMORY!");
}

sybdebug("Binding column %d\n",j+1);
description.maxlength=length+EXTRA_COLUMN_SPACE;
/* maxlength used to be MAX_RESULTS_SIZE-1. Let's make sure we don't
         * goof*/
ret=ct_bind(cmd,j+1,&description,results[j],
&(results_lengths[j]),&(nulls[j]));
/* TODO: replace the first NULL with the length indicator */
/* TODO: replace the second NULL with (SQL)NULL indicators */
/* see page 3-10 */
show_status(ret);
if (FAILED(ret)) {
err="Failed to bind column\n";
break;
}
}
toreturn=PS_RESULT_THIS;
done=1;
break;
case CS_STATUS_RESULT:
sybdebug("Got status result. Retrieving\n");
do {
INT32 length;
CS_DATAFMT description;
CS_INT rows_read;

length=guess_column_length(cmd,1);

sybdebug("Guessed length of %d\n",length);
function_result=calloc(length+EXTRA_COLUMN_SPACE+1,
sizeof(char));

description.datatype=CS_CHAR_TYPE;
description.format=CS_FMT_NULLTERM;
description.maxlength=length+EXTRA_COLUMN_SPACE;
description.scale=CS_SRC_VALUE;
description.precision=CS_SRC_VALUE;
description.count=1;
description.locale=NULL;


sybdebug("Binding...\n");
ret=ct_bind(cmd,1,&description,function_result,NULL,NULL);
/* TODO: use binary strings */

do {
sybdebug("Fetching\n");
ret=ct_fetch(cmd,CS_UNUSED,CS_UNUSED,CS_UNUSED,&rows_read);
show_status(ret);
sybdebug("Got: %s\n",function_result);
} while (OK(ret));



toreturn=PS_RESULT_STATUS;

} while (0);
/* flush_results_queue(this); No need to. We'll loop in the while
       * cycle, and if there's some result we'll catch it elsewhere.
       */
break;
case CS_COMPUTE_RESULT:
/*       this->busy--; */
err="Compute result is not supported\n";
flush_results_queue(this);
break;
case CS_MSG_RESULT:
/*       this->busy--; */
err="Message result is not supported\n";
flush_results_queue(this);
break;
case CS_DESCRIBE_RESULT:
/*       this->busy--; */
err="Describe result is not supported\n";
flush_results_queue(this);
break;
case CS_ROWFMT_RESULT:
/*       this->busy--; */
err="Row Format result is not supported\n";
flush_results_queue(this);
break;
case CS_COMPUTEFMT_RESULT:
/*       this->busy--; */
err="Compute Format result is not supported\n";
flush_results_queue(this);
break;
case CS_CMD_DONE:
/*       this->busy--; */
flush_results_queue(this);
done=1;
break;
case CS_CMD_SUCCEED:
/*       this->busy--; */
flush_results_queue(this);
done=1;
break;
case CS_CMD_FAIL:
/*       this->busy--; */
err="Command failed\n";
flush_results_queue(this);
break;
}
}

sybdebug("Busy status: %d\n",this->busy);

SYB_UNLOCK(this->lock);
THREADS_DISALLOW();

if (err) {
handle_errors(this);
this->busy--;
Pike_error(err);
}

pop_n_elems(args); /* moved from earlier. */

/* we're surely done */
switch (toreturn) {
case PS_NORESULT:
this->busy--;
push_int(0);
break;
case PS_RESULT_THIS:
ref_push_object(Pike_fp->current_object);
break;
case PS_RESULT_STATUS:
this->busy--;
push_text(function_result);
free(function_result);
function_result=NULL;
break;
default:
Pike_fatal("Internal error! Wrong result in big_query\n");
break;
}
/* extra safety check. Paranoia. */
if (function_result) {
sybdebug("Internal error! Function_result!=NULL");
free(function_result);
}
}


}
#line 940 "/space/www/pikefarm/out_work/master/src/modules/sybase/sybase.cmod"
/*
 * The while cycle is supposed to be outside this function call, in the pike
 * code.
 */
/* void|array(mix) fetch_row() */
#define f_sybase_sybase_fetch_row_defined
DEFAULT_CMOD_STORAGE void f_sybase_sybase_fetch_row(INT32 args) {
#line 945 "/space/www/pikefarm/out_work/master/src/modules/sybase/sybase.cmod"
if(args != 0) wrong_number_of_args_error("fetch_row",args,0);
{
pike_sybase_connection *this=THIS;
CS_RETCODE ret;
CS_COMMAND *cmd=this->cmd;
CS_INT numread,j;
char **results=this->results;
CS_INT *results_lengths=this->results_lengths;
CS_SMALLINT *nulls=this->nulls;
int numcols=this->numcols;

pop_n_elems(args);

if (this->busy<=0)
Pike_error("No pending results\n");

THREADS_ALLOW();
SYB_LOCK(this->lock);

sybdebug("Fetching row\n");
ret=ct_fetch(cmd,CS_UNUSED,CS_UNUSED,CS_UNUSED,&numread);
show_status(ret);

SYB_UNLOCK(this->lock);
THREADS_DISALLOW();

switch(ret) {
case CS_SUCCEED:
sybdebug("Got row\n");
for(j=0;j<numcols;j++) {
if (nulls[j] != -1) {
/* !null */
push_string(make_shared_binary_string(results[j],
results_lengths[j]-1));
} else {
/* null */
push_int(0);
}
}
f_aggregate(numcols);
return;
case CS_END_DATA:
sybdebug("Got end of data\n");
flush_results_queue(this);
push_int(0);
this->busy--;
sybdebug("Busy status: %d\n",this->busy);
return;
case CS_ROW_FAIL:
handle_errors(this);
Pike_error("Recoverable error while fetching row\n");
break;
case CS_FAIL:
handle_errors(this);
ct_cancel(this->connection,cmd,CS_CANCEL_ALL);
this->busy--;
sybdebug("Busy status: %d\n",this->busy);
Pike_error("Unrecoverable error while fetching row\n");
break;
case CS_CANCELED:
sybdebug("Canceled\n");
push_int(0);
this->busy--;
sybdebug("Busy status: %d\n",this->busy);
return;
case CS_PENDING:
case CS_BUSY:
Pike_error("Asynchronous operations are not supported\n");
break;
}
Pike_error("Internal error. We shouldn't get here\n");
}

}
#line 1018 "/space/www/pikefarm/out_work/master/src/modules/sybase/sybase.cmod"
/* int num_fields() */
#define f_sybase_sybase_num_fields_defined
DEFAULT_CMOD_STORAGE void f_sybase_sybase_num_fields(INT32 args) {
#line 1019 "/space/www/pikefarm/out_work/master/src/modules/sybase/sybase.cmod"
if(args != 0) wrong_number_of_args_error("num_fields",args,0);
{
CS_INT cols;
CS_RETCODE ret;
char* err=NULL;
pike_sybase_connection *this=THIS;

pop_n_elems(args);
if (this->busy<=0) {
Pike_error("Issue a command first!\n");
}

THREADS_ALLOW();
SYB_LOCK(this->lock);

ret=ct_res_info(this->cmd,CS_NUMDATA,&cols,CS_UNUSED,NULL);
if (FAILED(ret)) {
err="Can't retrieve columns number information\n";
handle_errors(this);
}

SYB_UNLOCK(this->lock);
THREADS_DISALLOW();

if (err) Pike_error(err);

push_int(cols);
}

}
#line 1048 "/space/www/pikefarm/out_work/master/src/modules/sybase/sybase.cmod"
/* int affected_rows() */
#define f_sybase_sybase_affected_rows_defined
DEFAULT_CMOD_STORAGE void f_sybase_sybase_affected_rows(INT32 args) {
#line 1049 "/space/www/pikefarm/out_work/master/src/modules/sybase/sybase.cmod"
if(args != 0) wrong_number_of_args_error("affected_rows",args,0);
{
CS_INT rows;
CS_RETCODE ret;
char *err=NULL;
pike_sybase_connection *this=THIS;

pop_n_elems(args);

THREADS_ALLOW();
SYB_LOCK(this->lock);

ret=ct_res_info(this->cmd,CS_ROW_COUNT,&rows,CS_UNUSED,NULL);
if (FAILED(ret)) {
err="Can't retrieve affected rows information\n";
handle_errors(this);
}

SYB_UNLOCK(this->lock);
THREADS_DISALLOW();

if (err) Pike_error(err);

push_int(rows);
}


}
#line 1076 "/space/www/pikefarm/out_work/master/src/modules/sybase/sybase.cmod"
#define desc_type(X,Y) case X: push_static_text(#Y);sybdebug("type is %s\n",#Y); break
#define f_sybase_sybase_fetch_fields_defined
DEFAULT_CMOD_STORAGE void f_sybase_sybase_fetch_fields(INT32 args) {
#line 1077 "/space/www/pikefarm/out_work/master/src/modules/sybase/sybase.cmod"
if(args != 0) wrong_number_of_args_error("fetch_fields",args,0);
{
pike_sybase_connection *this=THIS;
int j, nflags, numcols=this->numcols;
CS_DATAFMT descs[numcols], *desc;
CS_RETCODE ret;
char* err=NULL;

if (this->busy<=0)
Pike_error("You must issue a command first\n");

pop_n_elems(args);

THREADS_ALLOW();
SYB_LOCK(this->lock);

for (j=0;j<numcols;j++) {
sybdebug("Describing column %d\n",j+1);
ret=ct_describe(this->cmd,j+1,&descs[j]);
show_status(ret);
if (FAILED(ret)) {
err="Error while fetching descriptions\n";
break;
}
}

SYB_UNLOCK(this->lock);
THREADS_DISALLOW();

for(j=0;j<numcols;j++) {
nflags=0;
desc=&descs[j];
push_static_text("name");
push_text(desc->name);
sybdebug("name is %s\n",desc->name);
ref_push_string(literal_type_string);
switch(desc->datatype) {
desc_type(CS_ILLEGAL_TYPE,illegal);
desc_type(CS_CHAR_TYPE,char);
desc_type(CS_BINARY_TYPE,bynary);
desc_type(CS_LONGCHAR_TYPE,longchar);
desc_type(CS_LONGBINARY_TYPE,longbinary);
desc_type(CS_TEXT_TYPE,text);
desc_type(CS_IMAGE_TYPE,image);
desc_type(CS_TINYINT_TYPE,tinyint);
desc_type(CS_SMALLINT_TYPE,smallint);
desc_type(CS_INT_TYPE,integer);
desc_type(CS_REAL_TYPE,real);
desc_type(CS_FLOAT_TYPE,float);
desc_type(CS_BIT_TYPE,bit);
desc_type(CS_DATETIME_TYPE,datetime);
desc_type(CS_DATETIME4_TYPE,datetime4);
desc_type(CS_MONEY_TYPE,money);
desc_type(CS_MONEY4_TYPE,money4);
desc_type(CS_NUMERIC_TYPE,numeric);
desc_type(CS_DECIMAL_TYPE,decimal);
desc_type(CS_VARCHAR_TYPE,varchar);
desc_type(CS_VARBINARY_TYPE,varbinary);
desc_type(CS_LONG_TYPE,long);
desc_type(CS_SENSITIVITY_TYPE,sensitivity);
desc_type(CS_BOUNDARY_TYPE,boundary);
desc_type(CS_VOID_TYPE,void);
desc_type(CS_USHORT_TYPE,ushort);
default:
push_static_text("unknown");
}
push_static_text("max_length");
push_int(desc->maxlength);
sybdebug("max_length is %d\n",desc->maxlength);

push_static_text("flags");
if (!(desc->status & CS_CANBENULL)) {
sybdebug("Flag: not null\n");
push_static_text("not_null");
nflags++;
}
if (desc->status & CS_HIDDEN) {
sybdebug("Flag: hidden\n");
push_static_text("hidden");
nflags++;
}
if (desc->status & CS_IDENTITY) {
sybdebug("Flag: identity\n");
push_static_text("identity");
nflags++;
}
if (desc->status & CS_KEY) {
sybdebug("Flag: key\n");
push_static_text("key");
nflags++;
}
if (desc->status & CS_VERSION_KEY) {
sybdebug("Flag: version_key\n");
push_static_text("version_key");
nflags++;
}
if (desc->status & CS_TIMESTAMP) {
sybdebug("Flag: timestamp\n");
push_static_text("timestamp");
nflags++;
}
if (desc->status & CS_UPDATABLE) {
sybdebug("Flag: updatable\n");
push_static_text("updatable");
nflags++;
}
if (nflags) {
sybdebug("Aggregating flags: %d members\n",nflags);
f_aggregate_multiset(nflags);
} else {
sybdebug("No flags");
push_int(0);
}

f_aggregate_mapping(2*4);
}

sybdebug("Aggregating columns: %d members\n",numcols);
f_aggregate(numcols);

}

}
#line 1199 "/space/www/pikefarm/out_work/master/src/modules/sybase/sybase.cmod"
/* TODO */
/* int num_rows() */ /* looks like sybase doesn't support this one.. */
/* void seek(int skip) */ /*implemented in pike. Inefficient but simple */
/* mapping* fetch_fields() */

#ifdef sybase_sybase_event_handler_defined
static void sybase_sybase_event_handler(int ev) {
  switch(ev) {

#ifdef internal_init_sybase_sybase_defined
  case PROG_EVENT_INIT: init_sybase_sybase_struct(); break;

#endif /* internal_init_sybase_sybase_defined */

#ifdef internal_exit_sybase_sybase_defined
  case PROG_EVENT_EXIT: exit_sybase_sybase_struct(); break;

#endif /* internal_exit_sybase_sybase_defined */
  default: break; 
  }
}

#endif /* sybase_sybase_event_handler_defined */

#ifdef THIS_SYBASE

#undef THIS
#define THIS THIS_SYBASE

#endif /* THIS_SYBASE */
/*! @endclass sybase
 */

/*! @endmodule Sybase
 */

#line 1210 "/space/www/pikefarm/out_work/master/src/modules/sybase/sybase.cmod"
/********/
/* Glue */
/********/

PIKE_MODULE_EXIT {

#ifdef class_sybase_sybase_defined
  if(sybase_sybase_program) {
#line 164 "/space/www/pikefarm/out_work/master/src/modules/sybase/sybase.cmod"
    free_program(sybase_sybase_program);
    sybase_sybase_program=0;
  }

#endif /* class_sybase_sybase_defined */

#ifdef module_strings_declared
{
  int i;
  for(i=0; i < 1; i++) {
    if (module_strings[i]) free_string(module_strings[i]);
    module_strings[i] = NULL;
  }
}
#endif
#line 1215 "/space/www/pikefarm/out_work/master/src/modules/sybase/sybase.cmod"
;

SYB_MT_EXIT(mainlock);
}

PIKE_MODULE_INIT {

sybdebug("sybase driver release " SYBASE_DRIVER_VERSION "\n");


#ifdef module_strings_declared
module_strings[0] = 
  make_shared_binary_string("__builtin.Sql.Connection",
                            CONSTANT_STRLEN("__builtin.Sql.Connection"));
#endif

#ifdef CMOD_MAP_PROGRAM_IDS_DEFINED
set_program_id_to_id( ___cmod_map_program_ids );

#endif /* CMOD_MAP_PROGRAM_IDS_DEFINED */

#ifdef class_sybase_sybase_defined

#ifdef PROG_SYBASE_SYBASE_ID
#line 164 "/space/www/pikefarm/out_work/master/src/modules/sybase/sybase.cmod"
  START_NEW_PROGRAM_ID(SYBASE_SYBASE);
#else
#line 164 "/space/www/pikefarm/out_work/master/src/modules/sybase/sybase.cmod"
  start_new_program();

#endif /* PROG_SYBASE_SYBASE_ID */
#line 164 "/space/www/pikefarm/out_work/master/src/modules/sybase/sybase.cmod"
  sybase_sybase_program = Pike_compiler->new_program;

#ifndef tObjImpl_SYBASE_SYBASE

#undef tObjIs_SYBASE_SYBASE
#define tObjIs_SYBASE_SYBASE "\3\1\177\0\0\2"

#undef tObjImpl_SYBASE_SYBASE
#define tObjImpl_SYBASE_SYBASE "\3\0\177\0\0\2"

#endif /* tObjImpl_SYBASE_SYBASE */

#ifdef THIS_SYBASE_SYBASE
  sybase_sybase_storage_offset = ADD_STORAGE(struct sybase_sybase_struct);
#endif /* THIS_SYBASE_SYBASE */

#ifdef inherit_cq__22__builtin_2ESql_2EConnection_22_sybase_sybase_defined
#line 189 "/space/www/pikefarm/out_work/master/src/modules/sybase/sybase.cmod"
  sybase_sybase_cq__22__builtin_2ESql_2EConnection_22_inh_num = Pike_compiler->new_program->num_inherits;
  do {
#line 189 "/space/www/pikefarm/out_work/master/src/modules/sybase/sybase.cmod"
    struct program *p = resolve_program(module_strings[0] /* "__builtin.Sql.Connection" */);
    if (p) {

#ifdef module_strings_declared
#line 189 "/space/www/pikefarm/out_work/master/src/modules/sybase/sybase.cmod"
      low_inherit(p, NULL, -1, 0, 0, NULL
#ifdef tGeneric
, NULL
#endif
);

#else /* module_strings_declared */
#line 189 "/space/www/pikefarm/out_work/master/src/modules/sybase/sybase.cmod"
      low_inherit(p, NULL, -1, 0, 0, NULL
#ifdef tGeneric
, NULL
#endif
);

#endif /* module_strings_declared */

#ifdef sybase_sybase_cq__22__builtin_2ESql_2EConnection_22_inh_offset_used
#line 189 "/space/www/pikefarm/out_work/master/src/modules/sybase/sybase.cmod"
      sybase_sybase_cq__22__builtin_2ESql_2EConnection_22_inh_offset = Pike_compiler->new_program->inherits[sybase_sybase_cq__22__builtin_2ESql_2EConnection_22_inh_num].identifier_level;

#endif /* sybase_sybase_cq__22__builtin_2ESql_2EConnection_22_inh_offset_used */

#ifdef sybase_sybase_cq__22__builtin_2ESql_2EConnection_22_inh_storage_offset_used
#line 189 "/space/www/pikefarm/out_work/master/src/modules/sybase/sybase.cmod"
      sybase_sybase_cq__22__builtin_2ESql_2EConnection_22_inh_storage_offset = Pike_compiler->new_program->inherits[sybase_sybase_cq__22__builtin_2ESql_2EConnection_22_inh_num].storage_offset;

#endif /* sybase_sybase_cq__22__builtin_2ESql_2EConnection_22_inh_storage_offset_used */
#line 189 "/space/www/pikefarm/out_work/master/src/modules/sybase/sybase.cmod"
      free_program(p);
    } else {
#line 189 "/space/www/pikefarm/out_work/master/src/modules/sybase/sybase.cmod"
      yyerror("Inherit failed.");
    }
  } while(0);
#endif /* inherit_cq__22__builtin_2ESql_2EConnection_22_sybase_sybase_defined */

#ifdef sybase_sybase_event_handler_defined
  pike_set_prog_event_callback(sybase_sybase_event_handler);

#ifndef sybase_sybase_gc_live_obj
  Pike_compiler->new_program->flags &= ~PROGRAM_LIVE_OBJ;

#endif /* sybase_sybase_gc_live_obj */

#endif /* sybase_sybase_event_handler_defined */

#ifdef f_sybase_sybase_error_defined

#ifdef f_sybase_sybase_error_fun_num_used
  f_sybase_sybase_error_fun_num =
#endif /* f_sybase_sybase_error_fun_num_used */
#line 415 "/space/www/pikefarm/out_work/master/src/modules/sybase/sybase.cmod"
    ADD_FUNCTION2("error", f_sybase_sybase_error, tFunc(tOr(tVoid,"\10\200\0\0\0\177\377\377\377"),tStr), 0, OPT_EXTERNAL_DEPEND|OPT_SIDE_EFFECT);

#endif /* f_sybase_sybase_error_defined */

#ifdef f_sybase_sybase_connect_defined

#ifdef f_sybase_sybase_connect_fun_num_used
  f_sybase_sybase_connect_fun_num =
#endif /* f_sybase_sybase_connect_fun_num_used */
#line 433 "/space/www/pikefarm/out_work/master/src/modules/sybase/sybase.cmod"
    ADD_FUNCTION2("connect", f_sybase_sybase_connect, tFunc(tOr(tStr,tVoid) tOr(tStr,tVoid) tOr(tStr,tVoid) tOr(tStr,tVoid) tOr("\10\200\0\0\0\177\377\377\377",tVoid),tVoid), 0, OPT_EXTERNAL_DEPEND|OPT_SIDE_EFFECT);

#endif /* f_sybase_sybase_connect_defined */

#ifdef f_sybase_sybase_create_defined

#ifdef f_sybase_sybase_create_fun_num_used
  f_sybase_sybase_create_fun_num =
#endif /* f_sybase_sybase_create_fun_num_used */
#line 547 "/space/www/pikefarm/out_work/master/src/modules/sybase/sybase.cmod"
    ADD_FUNCTION2("create", f_sybase_sybase_create, tFunc(tOr(tStr,tVoid) tOr(tStr,tVoid) tOr(tStr,tVoid) tOr(tStr,tVoid) tOr3("\10\200\0\0\0\177\377\377\377",tMap(tStr,tMix),tVoid),tVoid), 0, OPT_EXTERNAL_DEPEND|OPT_SIDE_EFFECT);

#endif /* f_sybase_sybase_create_defined */

#ifdef f_sybase_sybase_big_query_defined

#ifdef f_sybase_sybase_big_query_fun_num_used
  f_sybase_sybase_big_query_fun_num =
#endif /* f_sybase_sybase_big_query_fun_num_used */
#line 618 "/space/www/pikefarm/out_work/master/src/modules/sybase/sybase.cmod"
    ADD_FUNCTION2("big_query", f_sybase_sybase_big_query, tFunc(tStr,tOr(tObj,tStr)), ID_VARIANT, OPT_EXTERNAL_DEPEND|OPT_SIDE_EFFECT);

#endif /* f_sybase_sybase_big_query_defined */

#ifdef f_sybase_sybase_fetch_row_defined

#ifdef f_sybase_sybase_fetch_row_fun_num_used
  f_sybase_sybase_fetch_row_fun_num =
#endif /* f_sybase_sybase_fetch_row_fun_num_used */
#line 945 "/space/www/pikefarm/out_work/master/src/modules/sybase/sybase.cmod"
    ADD_FUNCTION2("fetch_row", f_sybase_sybase_fetch_row, tFunc(tNone,tArray), 0, OPT_EXTERNAL_DEPEND|OPT_SIDE_EFFECT);

#endif /* f_sybase_sybase_fetch_row_defined */

#ifdef f_sybase_sybase_num_fields_defined

#ifdef f_sybase_sybase_num_fields_fun_num_used
  f_sybase_sybase_num_fields_fun_num =
#endif /* f_sybase_sybase_num_fields_fun_num_used */
#line 1019 "/space/www/pikefarm/out_work/master/src/modules/sybase/sybase.cmod"
    ADD_FUNCTION2("num_fields", f_sybase_sybase_num_fields, tFunc(tNone,"\10\200\0\0\0\177\377\377\377"), 0, OPT_EXTERNAL_DEPEND|OPT_SIDE_EFFECT);

#endif /* f_sybase_sybase_num_fields_defined */

#ifdef f_sybase_sybase_affected_rows_defined

#ifdef f_sybase_sybase_affected_rows_fun_num_used
  f_sybase_sybase_affected_rows_fun_num =
#endif /* f_sybase_sybase_affected_rows_fun_num_used */
#line 1049 "/space/www/pikefarm/out_work/master/src/modules/sybase/sybase.cmod"
    ADD_FUNCTION2("affected_rows", f_sybase_sybase_affected_rows, tFunc(tNone,"\10\200\0\0\0\177\377\377\377"), 0, OPT_EXTERNAL_DEPEND|OPT_SIDE_EFFECT);

#endif /* f_sybase_sybase_affected_rows_defined */

#ifdef f_sybase_sybase_fetch_fields_defined

#ifdef f_sybase_sybase_fetch_fields_fun_num_used
  f_sybase_sybase_fetch_fields_fun_num =
#endif /* f_sybase_sybase_fetch_fields_fun_num_used */
#line 1077 "/space/www/pikefarm/out_work/master/src/modules/sybase/sybase.cmod"
    ADD_FUNCTION2("fetch_fields", f_sybase_sybase_fetch_fields, tFunc(tNone,tArr(tMap(tStr,tMix))), 0, OPT_EXTERNAL_DEPEND|OPT_SIDE_EFFECT);

#endif /* f_sybase_sybase_fetch_fields_defined */
#line 164 "/space/www/pikefarm/out_work/master/src/modules/sybase/sybase.cmod"
  sybase_sybase_program=end_program();
#line 164 "/space/www/pikefarm/out_work/master/src/modules/sybase/sybase.cmod"
#ifdef sybase_sybase_program_fun_num_used
sybase_sybase_program_fun_num=
#endif
 add_program_constant("sybase",sybase_sybase_program,0);

#endif /* class_sybase_sybase_defined */

#ifdef CMOD_MAP_PROGRAM_IDS_DEFINED
set_program_id_to_id( 0 );
#endif /* CMOD_MAP_PROGRAM_IDS_DEFINED */
#line 1224 "/space/www/pikefarm/out_work/master/src/modules/sybase/sybase.cmod"
;

SYB_MT_INIT(mainlock);
}


#else /* HAVE_SYBASE */
PIKE_MODULE_INIT {}
PIKE_MODULE_EXIT {}
#endif /* HAVE_SYBASE */


#ifdef CMOD_MAP_PROGRAM_IDS_DEFINED
static int ___cmod_map_program_ids(int id)
{
  if( (id&0x7f000000) != 0x7f000000 ) return id;
  id = id&0x00ffffff;
  switch(id) {
#ifdef class_sybase_sybase_defined
  case 2:
    return sybase_sybase_program->id;
    break;
#endif
  };

  return 0;
}
#endif /* CMOD_MAP_PROGRAM_IDS_DEFINED */
