/* A Bison parser, made by GNU Bison 3.7.6.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30706

/* Bison version string.  */
#define YYBISON_VERSION "3.7.6"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* First part of user prologue.  */
#line 150 "language.yacc"

/* This is the grammar definition of Pike. */

#include "global.h"
#ifdef HAVE_MEMORY_H
#include <memory.h>
#endif

#include "interpret.h"
#include "array.h"
#include "object.h"
#include "mapping.h"
#include "stralloc.h"
#include "las.h"
#include "interpret.h"
#include "program.h"
#include "pike_types.h"
#include "constants.h"
#include "pike_macros.h"
#include "pike_error.h"
#include "docode.h"
#include "pike_embed.h"
#include "opcodes.h"
#include "operators.h"
#include "builtin_functions.h"
#include "bignum.h"

#define YYMAXDEPTH	1000

#ifdef PIKE_DEBUG
#ifndef YYDEBUG
/* May also be defined by machine.h */
#define YYDEBUG 1
#endif /* YYDEBUG */
#endif

/* Get verbose parse error reporting. */
#define YYERROR_VERBOSE	1

/* #define LAMBDA_DEBUG	1 */

/*
 * Prototypes for static functions.
 * NB: Other functions have their prototypes in las.h.
 */
static void yyerror_reserved(const char *keyword);
static void compiler_add_generic(struct pike_string *name,
                                 struct pike_type *type,
                                 struct pike_type *default_type);
static void compiler_define_implicit___create__(void);
static void compiler_end_class(int has___create__, int parent_constant_id);
static int compiler_declare_prototype(int modifiers,
                                      struct pike_string *identifier,
                                      int num_args, int num_create_args,
                                      int opt_flags);
static void add_parent_local_function(struct pike_string *identifier, int id);
static int compiler_define_function(int modifiers,
                                    struct pike_string *identifier,
                                    struct pike_type *fun_type,
                                    node *block,
                                    int num_args, int num_create_args,
                                    int opt_flags);
static void redefine_local(struct compiler_frame *frame, int var,
                           node *def, node *init);
static void mark_lvalue_as_used(node *n);
static void mark_lvalues_as_used(node *n);
static node *lexical_islocal(struct pike_string *);
static node *safe_inc_enum(node *n);
static node *find_versioned_identifier(struct pike_string *identifier,
				       int major, int minor);
static node *set_default_value(int e);
static int call_handle_import(void);
static void update_current_type(void);

static int inherit_depth;
static struct program_state *inherit_state = NULL;

/*
 * Kludge for Bison not using prototypes.
 */
#ifndef __GNUC__
#ifndef __cplusplus
static void __yy_memcpy(char *to, const char *from,
			unsigned int count);
#endif /* !__cplusplus */
#endif /* !__GNUC__ */


#line 160 "y.tab.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

/* Use api.header.include to #include this header
   instead of duplicating it here.  */
#ifndef YY_YY_Y_TAB_H_INCLUDED
# define YY_YY_Y_TAB_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token kinds.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    YYEMPTY = -2,
    YYEOF = 0,                     /* "end of file"  */
    YYerror = 256,                 /* error  */
    YYUNDEF = 257,                 /* "invalid token"  */
    TOK_ARROW = 258,               /* "->"  */
    TOK_CONSTANT = 259,            /* "constant"  */
    TOK_FLOAT = 260,               /* "float literal"  */
    TOK_STRING = 261,              /* "string literal"  */
    TOK_NUMBER = 262,              /* "integer literal"  */
    TOK_INC = 263,                 /* "++"  */
    TOK_DEC = 264,                 /* "--"  */
    TOK_RETURN = 265,              /* "return"  */
    TOK_EQ = 266,                  /* "=="  */
    TOK_GE = 267,                  /* ">="  */
    TOK_LE = 268,                  /* "<="  */
    TOK_NE = 269,                  /* "!="  */
    TOK_NOT = 270,                 /* "!"  */
    TOK_LSH = 271,                 /* "<<"  */
    TOK_RSH = 272,                 /* ">>"  */
    TOK_LAND = 273,                /* "&&"  */
    TOK_LOR = 274,                 /* "||"  */
    TOK_SWITCH = 275,              /* "switch"  */
    TOK_SSCANF = 276,              /* "sscanf"  */
    TOK_CATCH = 277,               /* "catch"  */
    TOK_FOREACH = 278,             /* "foreach"  */
    TOK_LEX_EOF = 279,             /* "end of file"  */
    TOK_ADD_EQ = 280,              /* "+="  */
    TOK_AND_EQ = 281,              /* "&="  */
    TOK_ARRAY_ID = 282,            /* "array"  */
    TOK_ASYNC = 283,               /* "__async__"  */
    TOK_ATTRIBUTE_ID = 284,        /* "__attribute__"  */
    TOK_BREAK = 285,               /* "break"  */
    TOK_CASE = 286,                /* "case"  */
    TOK_CLASS = 287,               /* "class"  */
    TOK_COLON_COLON = 288,         /* "::"  */
    TOK_CONTINUE = 289,            /* "continue"  */
    TOK_DEFAULT = 290,             /* "default"  */
    TOK_DEPRECATED_ID = 291,       /* "__deprecated__"  */
    TOK_DIV_EQ = 292,              /* "/="  */
    TOK_DO = 293,                  /* "do"  */
    TOK_DOT_DOT = 294,             /* ".."  */
    TOK_DOT_DOT_DOT = 295,         /* "..."  */
    TOK_ELSE = 296,                /* "else"  */
    TOK_ENUM = 297,                /* "enum"  */
    TOK_EXPERIMENTAL_ID = 298,     /* "__experimental__"  */
    TOK_EXTERN = 299,              /* "extern"  */
    TOK_FLOAT_ID = 300,            /* "float"  */
    TOK_FOR = 301,                 /* "for"  */
    TOK_FUNCTION_ID = 302,         /* "function"  */
    TOK_GAUGE = 303,               /* "gauge"  */
    TOK_GENERIC = 304,             /* "__generic__"  */
    TOK_GENERATOR = 305,           /* "__generator__"  */
    TOK_GLOBAL = 306,              /* "global"  */
    TOK_IDENTIFIER = 307,          /* "identifier"  */
    TOK_RESERVED = 308,            /* "reserved identifier"  */
    TOK_IF = 309,                  /* "if"  */
    TOK_IMPORT = 310,              /* "import"  */
    TOK_INHERIT = 311,             /* "inherit"  */
    TOK_INLINE = 312,              /* "inline"  */
    TOK_LOCAL_ID = 313,            /* "local"  */
    TOK_FINAL_ID = 314,            /* "final"  */
    TOK_FUNCTION_NAME = 315,       /* "__func__"  */
    TOK_INT_ID = 316,              /* "int"  */
    TOK_LAMBDA = 317,              /* "lambda"  */
    TOK_MULTISET_ID = 318,         /* "multiset"  */
    TOK_MULTISET_END = 319,        /* ">)"  */
    TOK_MULTISET_START = 320,      /* "(<"  */
    TOK_LSH_EQ = 321,              /* "<<="  */
    TOK_MAPPING_ID = 322,          /* "mapping"  */
    TOK_MIXED_ID = 323,            /* "mixed"  */
    TOK_MOD_EQ = 324,              /* "%="  */
    TOK_MULT_EQ = 325,             /* "*="  */
    TOK_OBJECT_ID = 326,           /* "object"  */
    TOK_OR_EQ = 327,               /* "|="  */
    TOK_POW = 328,                 /* "**"  */
    TOK_POW_EQ = 329,              /* "**="  */
    TOK_PRIVATE = 330,             /* "private"  */
    TOK_PROGRAM_ID = 331,          /* "program"  */
    TOK_PROTECTED = 332,           /* "protected"  */
    TOK_PREDEF = 333,              /* "predef"  */
    TOK_PUBLIC = 334,              /* "public"  */
    TOK_RSH_EQ = 335,              /* ">>="  */
    TOK_STATIC = 336,              /* "static"  */
    TOK_STATIC_ASSERT = 337,       /* "_Static_assert"  */
    TOK_STRING_ID = 338,           /* "string"  */
    TOK_SUB_EQ = 339,              /* "-="  */
    TOK_TYPEDEF = 340,             /* "typedef"  */
    TOK_TYPEOF = 341,              /* "typeof"  */
    TOK_UNKNOWN = 342,             /* "__unknown__"  */
    TOK_UNUSED = 343,              /* "__unused__"  */
    TOK_VARIANT = 344,             /* "variant"  */
    TOK_VERSION = 345,             /* "version prefix"  */
    TOK_VOID_ID = 346,             /* "void"  */
    TOK_WEAK = 347,                /* "__weak__"  */
    TOK_WHILE = 348,               /* "while"  */
    TOK_XOR_EQ = 349,              /* "^="  */
    TOK_OPTIONAL = 350,            /* "optional"  */
    TOK_SAFE_INDEX = 351,          /* "->?"  */
    TOK_SAFE_START_INDEX = 352,    /* "[?"  */
    TOK_SAFE_APPLY = 353,          /* "(?"  */
    TOK_BITS = 354,                /* "bits"  */
    TOK_AUTO_ID = 355,             /* "auto"  */
    TOK_ATOMIC_GET_SET = 356       /* "?="  */
  };
  typedef enum yytokentype yytoken_kind_t;
#endif
/* Token kinds.  */
#define YYEMPTY -2
#define YYEOF 0
#define YYerror 256
#define YYUNDEF 257
#define TOK_ARROW 258
#define TOK_CONSTANT 259
#define TOK_FLOAT 260
#define TOK_STRING 261
#define TOK_NUMBER 262
#define TOK_INC 263
#define TOK_DEC 264
#define TOK_RETURN 265
#define TOK_EQ 266
#define TOK_GE 267
#define TOK_LE 268
#define TOK_NE 269
#define TOK_NOT 270
#define TOK_LSH 271
#define TOK_RSH 272
#define TOK_LAND 273
#define TOK_LOR 274
#define TOK_SWITCH 275
#define TOK_SSCANF 276
#define TOK_CATCH 277
#define TOK_FOREACH 278
#define TOK_LEX_EOF 279
#define TOK_ADD_EQ 280
#define TOK_AND_EQ 281
#define TOK_ARRAY_ID 282
#define TOK_ASYNC 283
#define TOK_ATTRIBUTE_ID 284
#define TOK_BREAK 285
#define TOK_CASE 286
#define TOK_CLASS 287
#define TOK_COLON_COLON 288
#define TOK_CONTINUE 289
#define TOK_DEFAULT 290
#define TOK_DEPRECATED_ID 291
#define TOK_DIV_EQ 292
#define TOK_DO 293
#define TOK_DOT_DOT 294
#define TOK_DOT_DOT_DOT 295
#define TOK_ELSE 296
#define TOK_ENUM 297
#define TOK_EXPERIMENTAL_ID 298
#define TOK_EXTERN 299
#define TOK_FLOAT_ID 300
#define TOK_FOR 301
#define TOK_FUNCTION_ID 302
#define TOK_GAUGE 303
#define TOK_GENERIC 304
#define TOK_GENERATOR 305
#define TOK_GLOBAL 306
#define TOK_IDENTIFIER 307
#define TOK_RESERVED 308
#define TOK_IF 309
#define TOK_IMPORT 310
#define TOK_INHERIT 311
#define TOK_INLINE 312
#define TOK_LOCAL_ID 313
#define TOK_FINAL_ID 314
#define TOK_FUNCTION_NAME 315
#define TOK_INT_ID 316
#define TOK_LAMBDA 317
#define TOK_MULTISET_ID 318
#define TOK_MULTISET_END 319
#define TOK_MULTISET_START 320
#define TOK_LSH_EQ 321
#define TOK_MAPPING_ID 322
#define TOK_MIXED_ID 323
#define TOK_MOD_EQ 324
#define TOK_MULT_EQ 325
#define TOK_OBJECT_ID 326
#define TOK_OR_EQ 327
#define TOK_POW 328
#define TOK_POW_EQ 329
#define TOK_PRIVATE 330
#define TOK_PROGRAM_ID 331
#define TOK_PROTECTED 332
#define TOK_PREDEF 333
#define TOK_PUBLIC 334
#define TOK_RSH_EQ 335
#define TOK_STATIC 336
#define TOK_STATIC_ASSERT 337
#define TOK_STRING_ID 338
#define TOK_SUB_EQ 339
#define TOK_TYPEDEF 340
#define TOK_TYPEOF 341
#define TOK_UNKNOWN 342
#define TOK_UNUSED 343
#define TOK_VARIANT 344
#define TOK_VERSION 345
#define TOK_VOID_ID 346
#define TOK_WEAK 347
#define TOK_WHILE 348
#define TOK_XOR_EQ 349
#define TOK_OPTIONAL 350
#define TOK_SAFE_INDEX 351
#define TOK_SAFE_START_INDEX 352
#define TOK_SAFE_APPLY 353
#define TOK_BITS 354
#define TOK_AUTO_ID 355
#define TOK_ATOMIC_GET_SET 356

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
union YYSTYPE
{
#line 240 "language.yacc"

  int number;
  FLOAT_TYPE fnum;
  struct node_s *n;
  char *str;
  void *ptr;

#line 423 "y.tab.c"

};
typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif



int yyparse (void);

#endif /* !YY_YY_Y_TAB_H_INCLUDED  */
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_TOK_ARROW = 3,                  /* "->"  */
  YYSYMBOL_TOK_CONSTANT = 4,               /* "constant"  */
  YYSYMBOL_TOK_FLOAT = 5,                  /* "float literal"  */
  YYSYMBOL_TOK_STRING = 6,                 /* "string literal"  */
  YYSYMBOL_TOK_NUMBER = 7,                 /* "integer literal"  */
  YYSYMBOL_TOK_INC = 8,                    /* "++"  */
  YYSYMBOL_TOK_DEC = 9,                    /* "--"  */
  YYSYMBOL_TOK_RETURN = 10,                /* "return"  */
  YYSYMBOL_TOK_EQ = 11,                    /* "=="  */
  YYSYMBOL_TOK_GE = 12,                    /* ">="  */
  YYSYMBOL_TOK_LE = 13,                    /* "<="  */
  YYSYMBOL_TOK_NE = 14,                    /* "!="  */
  YYSYMBOL_TOK_NOT = 15,                   /* "!"  */
  YYSYMBOL_TOK_LSH = 16,                   /* "<<"  */
  YYSYMBOL_TOK_RSH = 17,                   /* ">>"  */
  YYSYMBOL_TOK_LAND = 18,                  /* "&&"  */
  YYSYMBOL_TOK_LOR = 19,                   /* "||"  */
  YYSYMBOL_TOK_SWITCH = 20,                /* "switch"  */
  YYSYMBOL_TOK_SSCANF = 21,                /* "sscanf"  */
  YYSYMBOL_TOK_CATCH = 22,                 /* "catch"  */
  YYSYMBOL_TOK_FOREACH = 23,               /* "foreach"  */
  YYSYMBOL_TOK_LEX_EOF = 24,               /* "end of file"  */
  YYSYMBOL_TOK_ADD_EQ = 25,                /* "+="  */
  YYSYMBOL_TOK_AND_EQ = 26,                /* "&="  */
  YYSYMBOL_TOK_ARRAY_ID = 27,              /* "array"  */
  YYSYMBOL_TOK_ASYNC = 28,                 /* "__async__"  */
  YYSYMBOL_TOK_ATTRIBUTE_ID = 29,          /* "__attribute__"  */
  YYSYMBOL_TOK_BREAK = 30,                 /* "break"  */
  YYSYMBOL_TOK_CASE = 31,                  /* "case"  */
  YYSYMBOL_TOK_CLASS = 32,                 /* "class"  */
  YYSYMBOL_TOK_COLON_COLON = 33,           /* "::"  */
  YYSYMBOL_TOK_CONTINUE = 34,              /* "continue"  */
  YYSYMBOL_TOK_DEFAULT = 35,               /* "default"  */
  YYSYMBOL_TOK_DEPRECATED_ID = 36,         /* "__deprecated__"  */
  YYSYMBOL_TOK_DIV_EQ = 37,                /* "/="  */
  YYSYMBOL_TOK_DO = 38,                    /* "do"  */
  YYSYMBOL_TOK_DOT_DOT = 39,               /* ".."  */
  YYSYMBOL_TOK_DOT_DOT_DOT = 40,           /* "..."  */
  YYSYMBOL_TOK_ELSE = 41,                  /* "else"  */
  YYSYMBOL_TOK_ENUM = 42,                  /* "enum"  */
  YYSYMBOL_TOK_EXPERIMENTAL_ID = 43,       /* "__experimental__"  */
  YYSYMBOL_TOK_EXTERN = 44,                /* "extern"  */
  YYSYMBOL_TOK_FLOAT_ID = 45,              /* "float"  */
  YYSYMBOL_TOK_FOR = 46,                   /* "for"  */
  YYSYMBOL_TOK_FUNCTION_ID = 47,           /* "function"  */
  YYSYMBOL_TOK_GAUGE = 48,                 /* "gauge"  */
  YYSYMBOL_TOK_GENERIC = 49,               /* "__generic__"  */
  YYSYMBOL_TOK_GENERATOR = 50,             /* "__generator__"  */
  YYSYMBOL_TOK_GLOBAL = 51,                /* "global"  */
  YYSYMBOL_TOK_IDENTIFIER = 52,            /* "identifier"  */
  YYSYMBOL_TOK_RESERVED = 53,              /* "reserved identifier"  */
  YYSYMBOL_TOK_IF = 54,                    /* "if"  */
  YYSYMBOL_TOK_IMPORT = 55,                /* "import"  */
  YYSYMBOL_TOK_INHERIT = 56,               /* "inherit"  */
  YYSYMBOL_TOK_INLINE = 57,                /* "inline"  */
  YYSYMBOL_TOK_LOCAL_ID = 58,              /* "local"  */
  YYSYMBOL_TOK_FINAL_ID = 59,              /* "final"  */
  YYSYMBOL_TOK_FUNCTION_NAME = 60,         /* "__func__"  */
  YYSYMBOL_TOK_INT_ID = 61,                /* "int"  */
  YYSYMBOL_TOK_LAMBDA = 62,                /* "lambda"  */
  YYSYMBOL_TOK_MULTISET_ID = 63,           /* "multiset"  */
  YYSYMBOL_TOK_MULTISET_END = 64,          /* ">)"  */
  YYSYMBOL_TOK_MULTISET_START = 65,        /* "(<"  */
  YYSYMBOL_TOK_LSH_EQ = 66,                /* "<<="  */
  YYSYMBOL_TOK_MAPPING_ID = 67,            /* "mapping"  */
  YYSYMBOL_TOK_MIXED_ID = 68,              /* "mixed"  */
  YYSYMBOL_TOK_MOD_EQ = 69,                /* "%="  */
  YYSYMBOL_TOK_MULT_EQ = 70,               /* "*="  */
  YYSYMBOL_TOK_OBJECT_ID = 71,             /* "object"  */
  YYSYMBOL_TOK_OR_EQ = 72,                 /* "|="  */
  YYSYMBOL_TOK_POW = 73,                   /* "**"  */
  YYSYMBOL_TOK_POW_EQ = 74,                /* "**="  */
  YYSYMBOL_TOK_PRIVATE = 75,               /* "private"  */
  YYSYMBOL_TOK_PROGRAM_ID = 76,            /* "program"  */
  YYSYMBOL_TOK_PROTECTED = 77,             /* "protected"  */
  YYSYMBOL_TOK_PREDEF = 78,                /* "predef"  */
  YYSYMBOL_TOK_PUBLIC = 79,                /* "public"  */
  YYSYMBOL_TOK_RSH_EQ = 80,                /* ">>="  */
  YYSYMBOL_TOK_STATIC = 81,                /* "static"  */
  YYSYMBOL_TOK_STATIC_ASSERT = 82,         /* "_Static_assert"  */
  YYSYMBOL_TOK_STRING_ID = 83,             /* "string"  */
  YYSYMBOL_TOK_SUB_EQ = 84,                /* "-="  */
  YYSYMBOL_TOK_TYPEDEF = 85,               /* "typedef"  */
  YYSYMBOL_TOK_TYPEOF = 86,                /* "typeof"  */
  YYSYMBOL_TOK_UNKNOWN = 87,               /* "__unknown__"  */
  YYSYMBOL_TOK_UNUSED = 88,                /* "__unused__"  */
  YYSYMBOL_TOK_VARIANT = 89,               /* "variant"  */
  YYSYMBOL_TOK_VERSION = 90,               /* "version prefix"  */
  YYSYMBOL_TOK_VOID_ID = 91,               /* "void"  */
  YYSYMBOL_TOK_WEAK = 92,                  /* "__weak__"  */
  YYSYMBOL_TOK_WHILE = 93,                 /* "while"  */
  YYSYMBOL_TOK_XOR_EQ = 94,                /* "^="  */
  YYSYMBOL_TOK_OPTIONAL = 95,              /* "optional"  */
  YYSYMBOL_TOK_SAFE_INDEX = 96,            /* "->?"  */
  YYSYMBOL_TOK_SAFE_START_INDEX = 97,      /* "[?"  */
  YYSYMBOL_TOK_SAFE_APPLY = 98,            /* "(?"  */
  YYSYMBOL_TOK_BITS = 99,                  /* "bits"  */
  YYSYMBOL_TOK_AUTO_ID = 100,              /* "auto"  */
  YYSYMBOL_TOK_ATOMIC_GET_SET = 101,       /* "?="  */
  YYSYMBOL_102_ = 102,                     /* '='  */
  YYSYMBOL_103_ = 103,                     /* '?'  */
  YYSYMBOL_104_ = 104,                     /* '|'  */
  YYSYMBOL_105_ = 105,                     /* '^'  */
  YYSYMBOL_106_ = 106,                     /* '&'  */
  YYSYMBOL_107_ = 107,                     /* '>'  */
  YYSYMBOL_108_ = 108,                     /* '<'  */
  YYSYMBOL_109_ = 109,                     /* '+'  */
  YYSYMBOL_110_ = 110,                     /* '-'  */
  YYSYMBOL_111_ = 111,                     /* '*'  */
  YYSYMBOL_112_ = 112,                     /* '%'  */
  YYSYMBOL_113_ = 113,                     /* '/'  */
  YYSYMBOL_114_ = 114,                     /* '~'  */
  YYSYMBOL_115_ = 115,                     /* ';'  */
  YYSYMBOL_116_ = 116,                     /* ':'  */
  YYSYMBOL_117_ = 117,                     /* '}'  */
  YYSYMBOL_118_ = 118,                     /* ','  */
  YYSYMBOL_119_ = 119,                     /* '('  */
  YYSYMBOL_120_ = 120,                     /* '['  */
  YYSYMBOL_121_ = 121,                     /* ']'  */
  YYSYMBOL_122_ = 122,                     /* ')'  */
  YYSYMBOL_123_ = 123,                     /* '@'  */
  YYSYMBOL_124_ = 124,                     /* '{'  */
  YYSYMBOL_125_ = 125,                     /* '.'  */
  YYSYMBOL_YYACCEPT = 126,                 /* $accept  */
  YYSYMBOL_all = 127,                      /* all  */
  YYSYMBOL_program = 128,                  /* program  */
  YYSYMBOL_real_string_or_identifier = 129, /* real_string_or_identifier  */
  YYSYMBOL_optional_rename_inherit = 130,  /* optional_rename_inherit  */
  YYSYMBOL_low_program_ref = 131,          /* low_program_ref  */
  YYSYMBOL_inherit_ref = 132,              /* inherit_ref  */
  YYSYMBOL_133_1 = 133,                    /* @1  */
  YYSYMBOL_inheritance = 134,              /* inheritance  */
  YYSYMBOL_import = 135,                   /* import  */
  YYSYMBOL_generic = 136,                  /* generic  */
  YYSYMBOL_constant_name = 137,            /* constant_name  */
  YYSYMBOL_constant_list = 138,            /* constant_list  */
  YYSYMBOL_139_2 = 139,                    /* @2  */
  YYSYMBOL_optional_type = 140,            /* optional_type  */
  YYSYMBOL_constant = 141,                 /* constant  */
  YYSYMBOL_function_block = 142,           /* function_block  */
  YYSYMBOL_block_or_semi = 143,            /* block_or_semi  */
  YYSYMBOL_open_paren_with_line_info = 144, /* open_paren_with_line_info  */
  YYSYMBOL_safe_apply_with_line_info = 145, /* safe_apply_with_line_info  */
  YYSYMBOL_open_paren_or_safe_apply_with_line_info = 146, /* open_paren_or_safe_apply_with_line_info  */
  YYSYMBOL_close_brace_or_missing = 147,   /* close_brace_or_missing  */
  YYSYMBOL_close_brace_or_eof = 148,       /* close_brace_or_eof  */
  YYSYMBOL_open_bracket_with_line_info = 149, /* open_bracket_with_line_info  */
  YYSYMBOL_close_bracket_or_missing = 150, /* close_bracket_or_missing  */
  YYSYMBOL_start_function = 151,           /* start_function  */
  YYSYMBOL_optional_constant = 152,        /* optional_constant  */
  YYSYMBOL_def = 153,                      /* def  */
  YYSYMBOL_154_3 = 154,                    /* @3  */
  YYSYMBOL_155_4 = 155,                    /* @4  */
  YYSYMBOL_156_5 = 156,                    /* $@5  */
  YYSYMBOL_157_6 = 157,                    /* @6  */
  YYSYMBOL_static_assertion = 158,         /* static_assertion  */
  YYSYMBOL_optional_dot_dot_dot = 159,     /* optional_dot_dot_dot  */
  YYSYMBOL_optional_identifier = 160,      /* optional_identifier  */
  YYSYMBOL_optional_default_value = 161,   /* optional_default_value  */
  YYSYMBOL_optional_default_type = 162,    /* optional_default_type  */
  YYSYMBOL_163_7 = 163,                    /* $@7  */
  YYSYMBOL_new_arg_name = 164,             /* new_arg_name  */
  YYSYMBOL_165_8 = 165,                    /* $@8  */
  YYSYMBOL_166_9 = 166,                    /* @9  */
  YYSYMBOL_func_args = 167,                /* func_args  */
  YYSYMBOL_arguments = 168,                /* arguments  */
  YYSYMBOL_arguments2 = 169,               /* arguments2  */
  YYSYMBOL_local_modifier = 170,           /* local_modifier  */
  YYSYMBOL_modifier = 171,                 /* modifier  */
  YYSYMBOL_magic_identifiers1 = 172,       /* magic_identifiers1  */
  YYSYMBOL_magic_identifiers2 = 173,       /* magic_identifiers2  */
  YYSYMBOL_magic_identifiers3 = 174,       /* magic_identifiers3  */
  YYSYMBOL_magic_identifiers = 175,        /* magic_identifiers  */
  YYSYMBOL_magic_identifier = 176,         /* magic_identifier  */
  YYSYMBOL_annotation = 177,               /* annotation  */
  YYSYMBOL_annotation_list = 178,          /* annotation_list  */
  YYSYMBOL_modifiers = 179,                /* modifiers  */
  YYSYMBOL_modifier_list = 180,            /* modifier_list  */
  YYSYMBOL_attribute = 181,                /* attribute  */
  YYSYMBOL_optional_attributes = 182,      /* optional_attributes  */
  YYSYMBOL_cast = 183,                     /* cast  */
  YYSYMBOL_soft_cast = 184,                /* soft_cast  */
  YYSYMBOL_type2 = 185,                    /* type2  */
  YYSYMBOL_simple_type = 186,              /* simple_type  */
  YYSYMBOL_simple_type2 = 187,             /* simple_type2  */
  YYSYMBOL_full_type = 188,                /* full_type  */
  YYSYMBOL_type = 189,                     /* type  */
  YYSYMBOL_type3 = 190,                    /* type3  */
  YYSYMBOL_basic_type = 191,               /* basic_type  */
  YYSYMBOL_identifier_type = 192,          /* identifier_type  */
  YYSYMBOL_number = 193,                   /* number  */
  YYSYMBOL_number_or_maxint = 194,         /* number_or_maxint  */
  YYSYMBOL_number_or_minint = 195,         /* number_or_minint  */
  YYSYMBOL_expected_dot_dot = 196,         /* expected_dot_dot  */
  YYSYMBOL_safe_int_range_type_low = 197,  /* safe_int_range_type_low  */
  YYSYMBOL_safe_int_range_type = 198,      /* safe_int_range_type  */
  YYSYMBOL_opt_int_range = 199,            /* opt_int_range  */
  YYSYMBOL_opt_string_width = 200,         /* opt_string_width  */
  YYSYMBOL_opt_program_type = 201,         /* opt_program_type  */
  YYSYMBOL_opt_function_type = 202,        /* opt_function_type  */
  YYSYMBOL_203_10 = 203,                   /* $@10  */
  YYSYMBOL_204_11 = 204,                   /* $@11  */
  YYSYMBOL_function_type_list = 205,       /* function_type_list  */
  YYSYMBOL_function_type_list2 = 206,      /* function_type_list2  */
  YYSYMBOL_207_12 = 207,                   /* $@12  */
  YYSYMBOL_opt_generic_bindings = 208,     /* opt_generic_bindings  */
  YYSYMBOL_209_13 = 209,                   /* @13  */
  YYSYMBOL_210_14 = 210,                   /* $@14  */
  YYSYMBOL_opt_multiset_type = 211,        /* opt_multiset_type  */
  YYSYMBOL_opt_array_type = 212,           /* opt_array_type  */
  YYSYMBOL_opt_mapping_type = 213,         /* opt_mapping_type  */
  YYSYMBOL_214_15 = 214,                   /* $@15  */
  YYSYMBOL_215_16 = 215,                   /* $@16  */
  YYSYMBOL_216_17 = 216,                   /* $@17  */
  YYSYMBOL_name_list = 217,                /* name_list  */
  YYSYMBOL_new_name = 218,                 /* new_name  */
  YYSYMBOL_219_18 = 219,                   /* @18  */
  YYSYMBOL_new_local_name = 220,           /* new_local_name  */
  YYSYMBOL_221_19 = 221,                   /* $@19  */
  YYSYMBOL_222_20 = 222,                   /* $@20  */
  YYSYMBOL_223_21 = 223,                   /* $@21  */
  YYSYMBOL_224_22 = 224,                   /* $@22  */
  YYSYMBOL_line_number_info = 225,         /* line_number_info  */
  YYSYMBOL_block = 226,                    /* block  */
  YYSYMBOL_227_23 = 227,                   /* @23  */
  YYSYMBOL_228_24 = 228,                   /* @24  */
  YYSYMBOL_229_25 = 229,                   /* @25  */
  YYSYMBOL_end_block = 230,                /* end_block  */
  YYSYMBOL_failsafe_block = 231,           /* failsafe_block  */
  YYSYMBOL_local_name_list = 232,          /* local_name_list  */
  YYSYMBOL_constant_expr = 233,            /* constant_expr  */
  YYSYMBOL_local_constant_name = 234,      /* local_constant_name  */
  YYSYMBOL_local_constant_list = 235,      /* local_constant_list  */
  YYSYMBOL_local_constant = 236,           /* local_constant  */
  YYSYMBOL_statements = 237,               /* statements  */
  YYSYMBOL_statement_with_semicolon = 238, /* statement_with_semicolon  */
  YYSYMBOL_normal_label_statement = 239,   /* normal_label_statement  */
  YYSYMBOL_statement = 240,                /* statement  */
  YYSYMBOL_labeled_statement = 241,        /* labeled_statement  */
  YYSYMBOL_242_26 = 242,                   /* $@26  */
  YYSYMBOL_optional_label = 243,           /* optional_label  */
  YYSYMBOL_break = 244,                    /* break  */
  YYSYMBOL_default = 245,                  /* default  */
  YYSYMBOL_continue = 246,                 /* continue  */
  YYSYMBOL_start_lambda = 247,             /* start_lambda  */
  YYSYMBOL_optional_local_modifier = 248,  /* optional_local_modifier  */
  YYSYMBOL_implicit_identifier = 249,      /* implicit_identifier  */
  YYSYMBOL_lambda = 250,                   /* lambda  */
  YYSYMBOL_251_27 = 251,                   /* @27  */
  YYSYMBOL_local_function = 252,           /* local_function  */
  YYSYMBOL_253_28 = 253,                   /* @28  */
  YYSYMBOL_local_restartable_function = 254, /* local_restartable_function  */
  YYSYMBOL_255_29 = 255,                   /* @29  */
  YYSYMBOL_create_arg = 256,               /* create_arg  */
  YYSYMBOL_create_arguments2 = 257,        /* create_arguments2  */
  YYSYMBOL_create_arguments = 258,         /* create_arguments  */
  YYSYMBOL_generic_type_decl = 259,        /* generic_type_decl  */
  YYSYMBOL_generic_type_decl_list = 260,   /* generic_type_decl_list  */
  YYSYMBOL_optional_generic_types = 261,   /* optional_generic_types  */
  YYSYMBOL_262_30 = 262,                   /* $@30  */
  YYSYMBOL_optional_create_arguments = 263, /* optional_create_arguments  */
  YYSYMBOL_failsafe_program = 264,         /* failsafe_program  */
  YYSYMBOL_265_31 = 265,                   /* @31  */
  YYSYMBOL_anon_class = 266,               /* anon_class  */
  YYSYMBOL_267_32 = 267,                   /* @32  */
  YYSYMBOL_268_33 = 268,                   /* @33  */
  YYSYMBOL_269_34 = 269,                   /* @34  */
  YYSYMBOL_named_class = 270,              /* named_class  */
  YYSYMBOL_271_35 = 271,                   /* @35  */
  YYSYMBOL_272_36 = 272,                   /* @36  */
  YYSYMBOL_simple_identifier = 273,        /* simple_identifier  */
  YYSYMBOL_enum_value = 274,               /* enum_value  */
  YYSYMBOL_enum_def = 275,                 /* enum_def  */
  YYSYMBOL_propagated_enum_value = 276,    /* propagated_enum_value  */
  YYSYMBOL_enum_list = 277,                /* enum_list  */
  YYSYMBOL_enum = 278,                     /* enum  */
  YYSYMBOL_279_37 = 279,                   /* $@37  */
  YYSYMBOL_280_38 = 280,                   /* @38  */
  YYSYMBOL_281_39 = 281,                   /* @39  */
  YYSYMBOL_typedef = 282,                  /* typedef  */
  YYSYMBOL_save_locals = 283,              /* save_locals  */
  YYSYMBOL_save_block_level = 284,         /* save_block_level  */
  YYSYMBOL_cond = 285,                     /* cond  */
  YYSYMBOL_end_cond = 286,                 /* end_cond  */
  YYSYMBOL_optional_else_part = 287,       /* optional_else_part  */
  YYSYMBOL_safe_lvalue = 288,              /* safe_lvalue  */
  YYSYMBOL_safe_assignment_expr = 289,     /* safe_assignment_expr  */
  YYSYMBOL_foreach_optional_lvalue = 290,  /* foreach_optional_lvalue  */
  YYSYMBOL_foreach_lvalues = 291,          /* foreach_lvalues  */
  YYSYMBOL_foreach = 292,                  /* foreach  */
  YYSYMBOL_293_40 = 293,                   /* $@40  */
  YYSYMBOL_do = 294,                       /* do  */
  YYSYMBOL_expected_semicolon = 295,       /* expected_semicolon  */
  YYSYMBOL_for = 296,                      /* for  */
  YYSYMBOL_while = 297,                    /* while  */
  YYSYMBOL_for_expr = 298,                 /* for_expr  */
  YYSYMBOL_switch = 299,                   /* switch  */
  YYSYMBOL_case = 300,                     /* case  */
  YYSYMBOL_expected_colon = 301,           /* expected_colon  */
  YYSYMBOL_optional_continue = 302,        /* optional_continue  */
  YYSYMBOL_return = 303,                   /* return  */
  YYSYMBOL_splice_expr = 304,              /* splice_expr  */
  YYSYMBOL_optional_comma = 305,           /* optional_comma  */
  YYSYMBOL_expr_list = 306,                /* expr_list  */
  YYSYMBOL_expr_list2 = 307,               /* expr_list2  */
  YYSYMBOL_m_expr_list = 308,              /* m_expr_list  */
  YYSYMBOL_m_expr_list2 = 309,             /* m_expr_list2  */
  YYSYMBOL_assoc_pair = 310,               /* assoc_pair  */
  YYSYMBOL_literal_expr = 311,             /* literal_expr  */
  YYSYMBOL_unqualified_id_expr = 312,      /* unqualified_id_expr  */
  YYSYMBOL_qualified_ident = 313,          /* qualified_ident  */
  YYSYMBOL_qualified_id_expr = 314,        /* qualified_id_expr  */
  YYSYMBOL_id_expr = 315,                  /* id_expr  */
  YYSYMBOL_safe_chain_var = 316,           /* safe_chain_var  */
  YYSYMBOL_safe_chain_expr = 317,          /* safe_chain_expr  */
  YYSYMBOL_primary_expr = 318,             /* primary_expr  */
  YYSYMBOL_postfix_expr = 319,             /* postfix_expr  */
  YYSYMBOL_chain_expr = 320,               /* chain_expr  */
  YYSYMBOL_prefix_expr = 321,              /* prefix_expr  */
  YYSYMBOL_pow_expr = 322,                 /* pow_expr  */
  YYSYMBOL_unary_expr = 323,               /* unary_expr  */
  YYSYMBOL_cast_expr = 324,                /* cast_expr  */
  YYSYMBOL_mul_expr = 325,                 /* mul_expr  */
  YYSYMBOL_add_expr = 326,                 /* add_expr  */
  YYSYMBOL_shift_expr = 327,               /* shift_expr  */
  YYSYMBOL_rel_expr = 328,                 /* rel_expr  */
  YYSYMBOL_eq_expr = 329,                  /* eq_expr  */
  YYSYMBOL_and_expr = 330,                 /* and_expr  */
  YYSYMBOL_xor_expr = 331,                 /* xor_expr  */
  YYSYMBOL_or_expr = 332,                  /* or_expr  */
  YYSYMBOL_land_expr = 333,                /* land_expr  */
  YYSYMBOL_lor_expr = 334,                 /* lor_expr  */
  YYSYMBOL_cond_expr = 335,                /* cond_expr  */
  YYSYMBOL_assignment_expr = 336,          /* assignment_expr  */
  YYSYMBOL_low_assign = 337,               /* low_assign  */
  YYSYMBOL_assign = 338,                   /* assign  */
  YYSYMBOL_comma_expr = 339,               /* comma_expr  */
  YYSYMBOL_init_expr = 340,                /* init_expr  */
  YYSYMBOL_safe_init_expr = 341,           /* safe_init_expr  */
  YYSYMBOL_optional_init_expr = 342,       /* optional_init_expr  */
  YYSYMBOL_void_expr = 343,                /* void_expr  */
  YYSYMBOL_optional_void_expr = 344,       /* optional_void_expr  */
  YYSYMBOL_optional_block = 345,           /* optional_block  */
  YYSYMBOL_346_41 = 346,                   /* @41  */
  YYSYMBOL_apply = 347,                    /* apply  */
  YYSYMBOL_implicit_modifiers = 348,       /* implicit_modifiers  */
  YYSYMBOL_string_or_identifier = 349,     /* string_or_identifier  */
  YYSYMBOL_inherit_specifier = 350,        /* inherit_specifier  */
  YYSYMBOL_low_id_expr = 351,              /* low_id_expr  */
  YYSYMBOL_range_bound = 352,              /* range_bound  */
  YYSYMBOL_gauge = 353,                    /* gauge  */
  YYSYMBOL_typeof = 354,                   /* typeof  */
  YYSYMBOL_catch_arg = 355,                /* catch_arg  */
  YYSYMBOL_catch = 356,                    /* catch  */
  YYSYMBOL_357_42 = 357,                   /* $@42  */
  YYSYMBOL_sscanf = 358,                   /* sscanf  */
  YYSYMBOL_lvalue = 359,                   /* lvalue  */
  YYSYMBOL_low_lvalue_list = 360,          /* low_lvalue_list  */
  YYSYMBOL_lvalue_list = 361,              /* lvalue_list  */
  YYSYMBOL_string_segment = 362,           /* string_segment  */
  YYSYMBOL_string = 363,                   /* string  */
  YYSYMBOL_string_constant = 364,          /* string_constant  */
  YYSYMBOL_real_string_constant = 365,     /* real_string_constant  */
  YYSYMBOL_bad_identifier = 366,           /* bad_identifier  */
  YYSYMBOL_bad_inherit = 367,              /* bad_inherit  */
  YYSYMBOL_bad_const_expr_ident = 368,     /* bad_const_expr_ident  */
  YYSYMBOL_bad_expr_ident = 369            /* bad_expr_ident  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;


/* Second part of user prologue.  */
#line 248 "language.yacc"

/* Need to be included after YYSTYPE is defined. */
#define INCLUDED_FROM_LANGUAGE_YACC
#include "lex.h"
#include "pike_compiler.h"
#line 255 "language.yacc"

/* Include <stdio.h> our selves, so that we can do our magic
 * without being disturbed... */
#include <stdio.h>
int yylex(YYSTYPE *yylval);
/* Bison is stupid, and tries to optimize for space... */
#ifdef YYBISON
#define short int
#endif /* YYBISON */


#line 833 "y.tab.c"


#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

#if defined __GNUC__ && ! defined __ICC && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                            \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  3
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   10563

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  126
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  244
/* YYNRULES -- Number of rules.  */
#define YYNRULES  746
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  1125

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   356


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,   112,   106,     2,
     119,   122,   111,   109,   118,   110,   125,   113,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   116,   115,
     108,   102,   107,   103,   123,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   120,     2,   121,   105,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   124,   104,   117,   114,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   468,   468,   469,   473,   474,   475,   478,   479,   482,
     483,   484,   485,   491,   596,   596,   606,   629,   635,   642,
     650,   661,   664,   754,   755,   758,   759,   759,   762,   763,
     771,   775,   780,   786,   793,   800,   801,   802,   803,   807,
     814,   821,   825,   827,   832,   833,   839,   846,   848,   868,
     887,   890,   899,   940,   896,   967,   983,   982,   990,   991,
     992,   993,   994,   995,   996,   997,  1005,  1009,  1010,  1011,
    1017,  1023,  1031,  1029,  1045,  1054,  1055,  1060,  1063,  1064,
    1065,  1068,  1069,  1070,  1073,  1075,  1074,  1087,  1086,  1152,
    1151,  1191,  1197,  1198,  1201,  1202,  1203,  1211,  1212,  1215,
    1216,  1217,  1224,  1225,  1226,  1227,  1228,  1229,  1230,  1231,
    1232,  1233,  1237,  1238,  1239,  1240,  1241,  1242,  1243,  1244,
    1245,  1246,  1247,  1248,  1249,  1250,  1251,  1255,  1256,  1257,
    1258,  1259,  1260,  1261,  1262,  1263,  1264,  1265,  1266,  1267,
    1268,  1269,  1270,  1271,  1272,  1277,  1278,  1279,  1280,  1281,
    1282,  1283,  1284,  1285,  1286,  1287,  1288,  1289,  1290,  1291,
    1292,  1293,  1294,  1295,  1296,  1297,  1298,  1299,  1302,  1302,
    1302,  1304,  1304,  1305,  1313,  1319,  1320,  1326,  1335,  1336,
    1339,  1343,  1349,  1355,  1361,  1370,  1379,  1388,  1398,  1411,
    1411,  1416,  1425,  1435,  1436,  1442,  1443,  1447,  1447,  1451,
    1452,  1453,  1454,  1455,  1456,  1457,  1458,  1459,  1460,  1461,
    1462,  1463,  1464,  1469,  1475,  1479,  1485,  1492,  1498,  1511,
    1561,  1573,  1574,  1587,  1590,  1593,  1596,  1598,  1599,  1605,
    1610,  1645,  1665,  1672,  1673,  1680,  1683,  1686,  1690,  1694,
    1699,  1705,  1706,  1707,  1713,  1721,  1725,  1720,  1752,  1782,
    1783,  1786,  1788,  1787,  1793,  1795,  1807,  1794,  1834,  1835,
    1838,  1841,  1842,  1844,  1846,  1848,  1856,  1859,  1862,  1855,
    1867,  1875,  1876,  1879,  1913,  1915,  1914,  1995,  1999,  2004,
    2011,  2050,  2052,  2051,  2082,  2081,  2094,  2093,  2107,  2106,
    2123,  2130,  2135,  2144,  2129,  2171,  2172,  2183,  2184,  2185,
    2189,  2190,  2195,  2226,  2256,  2257,  2260,  2261,  2264,  2265,
    2266,  2271,  2275,  2276,  2282,  2285,  2286,  2287,  2288,  2289,
    2290,  2291,  2292,  2293,  2294,  2301,  2308,  2311,  2315,  2316,
    2317,  2318,  2319,  2320,  2321,  2322,  2323,  2324,  2325,  2329,
    2328,  2345,  2346,  2349,  2350,  2351,  2357,  2364,  2377,  2378,
    2382,  2391,  2389,  2523,  2543,  2542,  2602,  2623,  2621,  2682,
    2697,  2758,  2759,  2765,  2766,  2767,  2774,  2775,  2778,  2779,
    2788,  2797,  2798,  2801,  2803,  2802,  2810,  2811,  2833,  2833,
    2834,  2835,  2843,  2855,  2919,  2842,  2939,  3017,  2938,  3035,
    3036,  3039,  3040,  3044,  3045,  3110,  3116,  3117,  3118,  3123,
    3133,  3138,  3122,  3154,  3175,  3182,  3188,  3204,  3205,  3206,
    3213,  3214,  3217,  3223,  3226,  3227,  3228,  3232,  3233,  3236,
    3237,  3243,  3241,  3263,  3271,  3278,  3287,  3288,  3295,  3309,
    3321,  3322,  3325,  3336,  3340,  3344,  3350,  3351,  3355,  3359,
    3366,  3367,  3368,  3371,  3382,  3398,  3399,  3401,  3401,  3403,
    3404,  3408,  3409,  3412,  3413,  3416,  3417,  3426,  3429,  3433,
    3436,  3437,  3438,  3439,  3446,  3456,  3463,  3470,  3471,  3475,
    3480,  3481,  3484,  3485,  3493,  3497,  3515,  3519,  3526,  3531,
    3542,  3569,  3570,  3571,  3589,  3595,  3596,  3604,  3607,  3615,
    3627,  3662,  3669,  3678,  3685,  3692,  3699,  3708,  3715,  3724,
    3725,  3726,  3727,  3728,  3729,  3730,  3731,  3732,  3733,  3734,
    3742,  3748,  3754,  3761,  3767,  3773,  3775,  3777,  3779,  3787,
    3788,  3793,  3794,  3795,  3801,  3804,  3805,  3816,  3820,  3821,
    3824,  3825,  3842,  3843,  3844,  3847,  3848,  3849,  3852,  3853,
    3854,  3855,  3864,  3876,  3877,  3882,  3889,  3890,  3891,  3892,
    3893,  3894,  3895,  3898,  3899,  3900,  3901,  3902,  3905,  3906,
    3907,  3908,  3909,  3912,  3913,  3914,  3915,  3916,  3917,  3918,
    3919,  3920,  3923,  3924,  3925,  3926,  3927,  3930,  3931,  3932,
    3935,  3936,  3937,  3940,  3941,  3942,  3945,  3946,  3947,  3950,
    3951,  3952,  3955,  3956,  3962,  3963,  3964,  3965,  3974,  3981,
    3983,  3984,  3985,  3986,  3987,  3988,  3989,  3990,  3991,  3992,
    3993,  3994,  3995,  3998,  3999,  4005,  4006,  4009,  4010,  4013,
    4014,  4017,  4019,  4020,  4021,  4043,  4047,  4044,  4146,  4152,
    4158,  4165,  4171,  4180,  4188,  4189,  4198,  4305,  4311,  4319,
    4328,  4382,  4385,  4413,  4430,  4437,  4449,  4450,  4452,  4454,
    4459,  4466,  4481,  4485,  4486,  4487,  4492,  4495,  4496,  4497,
    4502,  4503,  4504,  4505,  4509,  4508,  4519,  4530,  4537,  4545,
    4552,  4559,  4565,  4572,  4578,  4584,  4585,  4590,  4591,  4594,
    4598,  4605,  4626,  4632,  4633,  4639,  4640,  4671,  4672,  4685,
    4686,  4700,  4701,  4712,  4731,  4732,  4736,  4737,  4739,  4741,
    4743,  4745,  4747,  4749,  4751,  4753,  4755,  4757,  4759,  4761,
    4763,  4765,  4769,  4770,  4772,  4774,  4776,  4778,  4780,  4782,
    4784,  4786,  4788,  4790,  4792,  4794,  4796,  4798,  4800,  4802,
    4804,  4806,  4808,  4810,  4820,  4822,  4824,  4826,  4828,  4830,
    4832,  4834,  4836,  4838,  4840,  4842,  4844
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if YYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "\"->\"",
  "\"constant\"", "\"float literal\"", "\"string literal\"",
  "\"integer literal\"", "\"++\"", "\"--\"", "\"return\"", "\"==\"",
  "\">=\"", "\"<=\"", "\"!=\"", "\"!\"", "\"<<\"", "\">>\"", "\"&&\"",
  "\"||\"", "\"switch\"", "\"sscanf\"", "\"catch\"", "\"foreach\"",
  "\"end of file\"", "\"+=\"", "\"&=\"", "\"array\"", "\"__async__\"",
  "\"__attribute__\"", "\"break\"", "\"case\"", "\"class\"", "\"::\"",
  "\"continue\"", "\"default\"", "\"__deprecated__\"", "\"/=\"", "\"do\"",
  "\"..\"", "\"...\"", "\"else\"", "\"enum\"", "\"__experimental__\"",
  "\"extern\"", "\"float\"", "\"for\"", "\"function\"", "\"gauge\"",
  "\"__generic__\"", "\"__generator__\"", "\"global\"", "\"identifier\"",
  "\"reserved identifier\"", "\"if\"", "\"import\"", "\"inherit\"",
  "\"inline\"", "\"local\"", "\"final\"", "\"__func__\"", "\"int\"",
  "\"lambda\"", "\"multiset\"", "\">)\"", "\"(<\"", "\"<<=\"",
  "\"mapping\"", "\"mixed\"", "\"%=\"", "\"*=\"", "\"object\"", "\"|=\"",
  "\"**\"", "\"**=\"", "\"private\"", "\"program\"", "\"protected\"",
  "\"predef\"", "\"public\"", "\">>=\"", "\"static\"",
  "\"_Static_assert\"", "\"string\"", "\"-=\"", "\"typedef\"",
  "\"typeof\"", "\"__unknown__\"", "\"__unused__\"", "\"variant\"",
  "\"version prefix\"", "\"void\"", "\"__weak__\"", "\"while\"", "\"^=\"",
  "\"optional\"", "\"->?\"", "\"[?\"", "\"(?\"", "\"bits\"", "\"auto\"",
  "\"?=\"", "'='", "'?'", "'|'", "'^'", "'&'", "'>'", "'<'", "'+'", "'-'",
  "'*'", "'%'", "'/'", "'~'", "';'", "':'", "'}'", "','", "'('", "'['",
  "']'", "')'", "'@'", "'{'", "'.'", "$accept", "all", "program",
  "real_string_or_identifier", "optional_rename_inherit",
  "low_program_ref", "inherit_ref", "@1", "inheritance", "import",
  "generic", "constant_name", "constant_list", "@2", "optional_type",
  "constant", "function_block", "block_or_semi",
  "open_paren_with_line_info", "safe_apply_with_line_info",
  "open_paren_or_safe_apply_with_line_info", "close_brace_or_missing",
  "close_brace_or_eof", "open_bracket_with_line_info",
  "close_bracket_or_missing", "start_function", "optional_constant", "def",
  "@3", "@4", "$@5", "@6", "static_assertion", "optional_dot_dot_dot",
  "optional_identifier", "optional_default_value", "optional_default_type",
  "$@7", "new_arg_name", "$@8", "@9", "func_args", "arguments",
  "arguments2", "local_modifier", "modifier", "magic_identifiers1",
  "magic_identifiers2", "magic_identifiers3", "magic_identifiers",
  "magic_identifier", "annotation", "annotation_list", "modifiers",
  "modifier_list", "attribute", "optional_attributes", "cast", "soft_cast",
  "type2", "simple_type", "simple_type2", "full_type", "type", "type3",
  "basic_type", "identifier_type", "number", "number_or_maxint",
  "number_or_minint", "expected_dot_dot", "safe_int_range_type_low",
  "safe_int_range_type", "opt_int_range", "opt_string_width",
  "opt_program_type", "opt_function_type", "$@10", "$@11",
  "function_type_list", "function_type_list2", "$@12",
  "opt_generic_bindings", "@13", "$@14", "opt_multiset_type",
  "opt_array_type", "opt_mapping_type", "$@15", "$@16", "$@17",
  "name_list", "new_name", "@18", "new_local_name", "$@19", "$@20", "$@21",
  "$@22", "line_number_info", "block", "@23", "@24", "@25", "end_block",
  "failsafe_block", "local_name_list", "constant_expr",
  "local_constant_name", "local_constant_list", "local_constant",
  "statements", "statement_with_semicolon", "normal_label_statement",
  "statement", "labeled_statement", "$@26", "optional_label", "break",
  "default", "continue", "start_lambda", "optional_local_modifier",
  "implicit_identifier", "lambda", "@27", "local_function", "@28",
  "local_restartable_function", "@29", "create_arg", "create_arguments2",
  "create_arguments", "generic_type_decl", "generic_type_decl_list",
  "optional_generic_types", "$@30", "optional_create_arguments",
  "failsafe_program", "@31", "anon_class", "@32", "@33", "@34",
  "named_class", "@35", "@36", "simple_identifier", "enum_value",
  "enum_def", "propagated_enum_value", "enum_list", "enum", "$@37", "@38",
  "@39", "typedef", "save_locals", "save_block_level", "cond", "end_cond",
  "optional_else_part", "safe_lvalue", "safe_assignment_expr",
  "foreach_optional_lvalue", "foreach_lvalues", "foreach", "$@40", "do",
  "expected_semicolon", "for", "while", "for_expr", "switch", "case",
  "expected_colon", "optional_continue", "return", "splice_expr",
  "optional_comma", "expr_list", "expr_list2", "m_expr_list",
  "m_expr_list2", "assoc_pair", "literal_expr", "unqualified_id_expr",
  "qualified_ident", "qualified_id_expr", "id_expr", "safe_chain_var",
  "safe_chain_expr", "primary_expr", "postfix_expr", "chain_expr",
  "prefix_expr", "pow_expr", "unary_expr", "cast_expr", "mul_expr",
  "add_expr", "shift_expr", "rel_expr", "eq_expr", "and_expr", "xor_expr",
  "or_expr", "land_expr", "lor_expr", "cond_expr", "assignment_expr",
  "low_assign", "assign", "comma_expr", "init_expr", "safe_init_expr",
  "optional_init_expr", "void_expr", "optional_void_expr",
  "optional_block", "@41", "apply", "implicit_modifiers",
  "string_or_identifier", "inherit_specifier", "low_id_expr",
  "range_bound", "gauge", "typeof", "catch_arg", "catch", "$@42", "sscanf",
  "lvalue", "low_lvalue_list", "lvalue_list", "string_segment", "string",
  "string_constant", "real_string_constant", "bad_identifier",
  "bad_inherit", "bad_const_expr_ident", "bad_expr_ident", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_int16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,    61,    63,   124,    94,    38,    62,    60,    43,
      45,    42,    37,    47,   126,    59,    58,   125,    44,    40,
      91,    93,    41,    64,   123,    46
};
#endif

#define YYPACT_NINF (-987)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-684)

#define yytable_value_is_error(Yyn) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
    -987,    66,  1425,  -987,   118,  -987,  8484,  4089,    -7,  -987,
    3871,  -987,  -987,  -987,  -987,  -987,    83,   424,  -987,   234,
    -987,  -987,  -987,  -987,  -987,   125,    45,  9532,   249,   236,
     244,  -987,   257,    56,   477,  -987,   263,  -987,   311,   321,
     330,  -987,   378,   378,   357,   389,   432,  -987,   470,  -987,
    -987,   425,    23,  -987,  -987,  -987,  -987,   206,   213,  -987,
     276,  -987,   529,  8962,  -987,  -987,  -987,   224,  -987,  -987,
    -987,  7998,  7998,  7904,   454,  -987,  -987,  -987,  -987,  -987,
      36,  -987,   556,  -987,  -987,  -987,  -987,  -987,  -987,   357,
    -987,  -987,  -987,  -987,  -987,  7904,  7904,  7904,  -987,  -987,
    2964,  7520,  -987,  -987,  7904,  7904,   505,   575,  -987,  -987,
    -987,  -987,   294,   136,   594,   581,  -987,  -987,  -987,   592,
     436,   595,   111,   576,   552,   559,   566,   658,   544,  -987,
    -987,  -987,   332,  -987,  -987,  -987,  -987,   466,  -987,  7904,
     572,  -987,  -987,  -987,  -987,  -987,   551,  1085,   650,  -987,
    -987,  -987,  8552,  -987,  8620,  -987,  -987,  6609,  -987,  -987,
     224,  -987,  -987,  -987,  -987,  -987,  -987,  -987,  -987,  -987,
    -987,  -987,  -987,  -987,  -987,  -987,  -987,  -987,  -987,  -987,
    -987,  -987,  -987,  -987,  -987,  -987,  -987,  -987,  -987,  -987,
    -987,  -987,  -987,  -987,  -987,  -987,  -987,  -987,  -987,  -987,
    -987,  -987,  -987,  -987,   642,  6813,  6881,  -987,  -987,  -987,
     646,  -987,  -987,  -987,   386,  -987,  8552,  -987,  -987,  -987,
    6949,  -987,  -987,  9610,   342,  -987,  -987,  4402,  9688,  -987,
     605,  8552,  -987,  8484,  -987,  9766,  -987,  9844,  -987,  -987,
    -987,   679,   698,  -987,   706,  -987,  4185,   594,   594,   650,
    -987,  4498,    36,  -987,  3206,  -987,  -987,  -987,  3748,  -987,
    -987,  -987,    18,  7616,  7278,   -14,  -987,  -987,   351,  7520,
     688,    15,  -987,  8088,  -987,  9922,   626,   624,  -987,  -987,
    -987,  -987,  -987,  -987,  -987,  -987,  -987,  4594,   745,  1698,
     618,  1888,  4690,  4786,  4882,  4978,  5074,  5170,  5266,  5362,
    5458,  5554,  5650,  5746,  5842,  5938,  6034,  6130,  6226,  6322,
    -987,  -987,  -987,  -987,  -987,  -987,  -987,  -987,  -987,  -987,
    -987,  -987,  -987,  7904,  -987,  6418,  -987,  -987,  -987,   630,
    -987,  4089,   635,  -987,  -987,  -987,  -987,  -987,  -987,  -987,
    -987,  -987,  -987,  -987,  -987,  -987,  -987,  -987,  9293,   648,
   10000, 10078,    46,  4089,  9040,  -987,    61,   634,   636,  -987,
     752,   657,  -987,  -987,  -987,   753,  8552,   137,   609,   622,
    -987,   298,   224,    32,  -987,   640,   142,   643,   407,  8272,
    -987,  8552,   427,   430,  8552,   645,   444,   466,   282,  -987,
    -987,   386,   334,   262,   651,  -987,  -987,  -987,  -987,  -987,
    8272,  -987,  -987,  -987,  -987,  -987,  -987,  -987,    15,   293,
     110,  -987,   312,  -987, 10156,   648,   652,   654,  -987,   208,
    7904,  -987,     9,   659,  -987,  -987,  -987,  -987,  -987,   647,
     653,   662,  -987,   440,  8552,  -987,  7904,  -987,   660,   666,
    -987,  7520,  -987,    35,  -987,   720,  8786,   663,   376,   225,
    -987,  7399,   661,   667,  -987,   622,  -987,  -987,  -987,  7712,
      85,  -987,  -987,  -987,  -987,  -987,  -987,  -987,  -987,  -987,
     592,  -987,   592,  -987,   436,  -987,   436,  -987,   595,  -987,
     595,  -987,   595,  -987,   595,  -987,   111,  -987,   111,  -987,
     576,  -987,   552,  -987,   559,  -987,   566,  -987,   658,   295,
    -987,  -987,  -987,  7904,   399,   682,  -987,   491,   685,  -987,
    -987,  -987,  -987,   668,  -987,   150,  8879,   675,  -987,  -987,
     680,  3548,   224,  6677,  6745,  -987, 10234,  -987,   446,  -987,
    -987,  -987,    28,   386,  8340,  -987,   672,   224,  8552,  -987,
    -987,  -987,  -987,  -987,   657,   670,   678,  -987,   657,  -987,
    -987,   171,  -987,  -987,  -987,   472,    86,  -987,  -987,  -987,
    -987,  -987,  -987,  -987,  -987,  -987,  -987,   398,  7904,  -987,
    -987,  -987,  -987,   697,  -987,   683,   700,  -987,  -987,  -987,
    -987,  -987,  -987,  -987,  -987,  -987,  -987,  7616,  -987,  -987,
     686,  -987,   687,  3967,  -987,  -987,  -987,  -987,  -987,  6514,
    -987,  -987,   361,  7808,  -987,   626,  -987,  7904,  -987,  -987,
    -987,  -987,  -987,  -987,  -987,  -987,  -987,  -987,  -987,  -987,
    -987,  -987,  -987,  -987,  -987,  -987,  -987,  -987,  -987,  -987,
    -987,  -987,  -987,  -987,  -987,  -987,  -987,  -987,  -987,  -987,
    -987,  -987,  -987,  -987,  -987,  -987,  -987,  -987,  -987,  -987,
    -987,  -987,  -987,  -987,  -987,  -987,  -987,  -987,  -987,  -987,
    -987,  -987,  -987,  -987,  -987,  -987,  -987,  -987,  -987,  -987,
    -987,  -987,  -987,  -987,   676,  -987,  -987,  -987,   676,  -987,
    -987,  -987,  -987,  -987,  -987,  -987,  -987,  -987,  7157,  9452,
    7036,   689,  -987,  7712,  7036,  7904,  -987,   690,  -987,  4089,
    -987,  -987,  4089,  -987,  -987,  4089,  -987,  -987,  -987,  -987,
    -987,  -987,  -987,  -987,  -987,    88,  -987,  -987,  -987,  -987,
    -987,  -987,   102,  -987,  -987,   281,   504,  -987,   166,  -987,
    -987,  -987,  -987,  -987,   474,  -987,   224,   479,  -987,  -987,
     691,   254,  -987,  -987,  -987,  -987,   480,   740,  -987,  -987,
    -987,  -987,    48,    98, 10156,  -987,  -987,  -987,  -987,  -987,
    -987,  -987,   440,  -987,  -987,  -987,  -987,  -987,    63,  -987,
    -987,  -987,   684,  -987,   692,   622,   676,  9452,   694,   696,
     622,  -987,  -987,  -987,  -987,  -987,  9374,  -987,   754,  8694,
    -987,   812,  8552,   701,  4306,    67,  -987, 10312,  7904,   703,
    -987,  -987,  -987,  8552,  8552,  -987,  -987,   420,   704,  7904,
     824,   803,  -987,  7904,  -987,  -987,  8196,  -987,  -987,  -987,
    -987,  7157,  -987,  -987,   676,  -987,  7157,   754,   726,  -987,
    8484,   711,    33,  -987,   730,  -987,   715,  -987,  -987,  -987,
    -987,  7904,  -987,  -987,   734,  -987,   737,  -987,  8196,  8552,
     657,   657,  -987,  -987,  -987,  -987,  -987,  -987,  -987,  -987,
    -987,  1577,  -987,  -987,   722,   509,   358,  -987,    39,  -987,
     724,  -987,   725,    33,   729,   731,  -987,  -987,  -987,  -987,
    4089,  -987,  -987,    92,  -987,  8196,   727,   481,   732,   271,
    9127,  -987,  -987,  -987,   221,  2480,   414,   736,  -987,  -987,
     238,  -987,  -987,  -987,  -987,  -987,  8552, 10390,  -987,  -987,
    -987,  -987,  -987,  -987,  -987,    83,  -987,    83,  -987,  -987,
    -987,  -987,  -987,  -987,  -987,  -987,   838,  -987,  -987,    83,
     448,  7520,  -987,  8408,  8408,  -987,  -987,  -987,  -987,  -987,
    -987,  -987,  -987,  -987,  -987,  -987,   792,   384,  3650,  -987,
   10000,  -987,   735,    97,  -987,  -987,  -987,  -987,  -987,   457,
     756,  -987,   526,   757,  -987,  -987,  -987,  -987,  -987,  3327,
    -987,   514,  -987,  -987,  1994,  -987,   744,  -987,  -987,   809,
      30,  -987,  -987,  -987,  2601,  -987,  -987,  -987,   743,  -987,
    -987, 10078,  1577,  -987,  8552,  -987,   517,   748,  -987,    92,
    -987,  -987,  -987,  -987,  -987,  -987,  -987,  -987,  4089,  -987,
    -987,  4089,  -987,  9210,  4089,  -987,  -987,   440,  2115,  -987,
     199,  -987,  1994,  -987,  -987,  -987,    71,  -987,    83, 10000,
     666,   666,  -987,   670,   551,   597,  -987,  -987,  -987,    97,
    -987,  -987,   763,  -987,  -987,   747,   755,  -987,  -987,   440,
    -987,    24,   761,  -987,   762,   764,    76,  -987,  -987,  -987,
    -987,  -987, 10468,  -987,  -987,  -987,  3327,  7904,  -987,  -987,
    3327,  2722,  3327,  3327,  -987,  -987,    39,   666,  -987,   215,
     541,   215,  -987,  -987,    83,   215,   215,    39,  -987,  -987,
    -987,  -987,  -987,  1994,  3085,  3448,   215,    83,  2843,  1994,
    1994,  -987,  -987,  -987,  -987,   760,  -987,  -987,  -987,  -987,
      83,  -987,   830,  -987,  2236,  1994,  2358,  1994,  -987,  -987,
    -987,   215,  -987,  1994,  -987
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_int16 yydefact[] =
{
       6,     0,     0,     1,     0,     3,   368,     0,     0,     5,
       0,    59,    60,    62,    61,     4,     0,     0,   178,   185,
      67,    69,    70,    71,   685,   261,     0,     0,     0,     0,
       0,   199,   248,     0,   642,   645,     0,   686,   235,   259,
     270,   201,   241,   241,     0,   235,     0,   202,     0,   200,
     203,     0,     0,   194,   197,   198,   371,     0,   254,   485,
     254,   219,     0,     0,   472,   220,   687,   635,   416,   462,
     461,   633,   633,   633,     0,   664,   415,    98,   745,   743,
       0,    97,   642,   746,   734,   744,   290,   736,   737,   735,
     738,   742,   740,   741,   739,   633,   633,   633,    39,    46,
       0,   633,   504,   349,   633,   633,     0,     0,   505,   302,
     499,   525,   254,   530,   532,   535,   538,   543,   546,   553,
     558,   563,   572,   577,   580,   583,   586,   589,   592,   594,
     414,   508,     0,   501,   502,   500,   503,   460,   527,   633,
       0,   174,   427,   426,    68,    65,   175,   177,    28,   290,
     399,    14,     0,    72,     0,    63,    64,     0,   210,   214,
       0,   728,   730,   729,   715,   722,   697,   698,   713,   714,
     716,   717,   718,   699,   719,   720,   700,   701,   721,   702,
     724,   483,   733,   725,   726,   695,   723,   703,   727,   706,
     704,   705,   707,   708,   735,   709,   731,   732,   710,   711,
     484,   694,   696,   712,     0,     0,     0,   245,   207,   638,
       0,    85,   370,   637,     0,   205,     0,   211,   266,   206,
       0,   208,   209,     0,     0,   237,   204,     0,     0,   643,
      84,     0,    21,   368,   255,     0,   488,     0,   489,   636,
     482,   480,   695,   481,   694,   688,     0,   533,   534,     0,
     539,     0,     0,   663,     0,   291,   662,   651,     0,   540,
     542,   541,     0,   449,   453,     0,   196,   613,     0,   633,
       0,   189,   190,   219,   679,   502,   683,     0,   544,   545,
      20,   290,   290,   526,   290,   528,   529,   633,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     606,   601,   611,   604,   610,   608,   602,   609,   605,   607,
     603,   612,   599,   633,   600,     0,   290,   506,   507,     0,
      66,     0,     0,   176,   102,   108,   105,   100,   104,   107,
     106,   101,   111,   109,   110,   103,    99,   179,     0,    29,
       0,    80,     0,     0,     0,     6,     0,   182,   184,   186,
      50,   191,   232,   221,   229,     0,     0,     0,   231,     0,
     233,     0,   689,     0,   479,     0,     0,     0,     0,   447,
     644,     0,     0,     0,     0,     0,     0,   689,     0,   475,
     476,     0,     0,     0,     0,   477,   478,   369,   193,   372,
     447,   473,   474,   486,   487,   640,   639,   641,     0,     0,
       0,   665,     0,   192,     0,   189,   615,     0,   290,     0,
     633,   451,     0,   447,   445,   520,   521,   522,   519,    43,
      48,   447,   455,   679,     0,   187,   633,   518,     0,    83,
     188,   633,   682,     0,   350,     0,     0,     0,     0,     0,
     649,   633,     0,   613,   647,     0,   290,   290,    40,   633,
     531,   537,   536,   550,   547,   551,   548,   552,   549,   556,
     554,   557,   555,   561,   559,   562,   560,   569,   565,   571,
     567,   568,   564,   570,   566,   575,   573,   576,   574,   579,
     578,   582,   581,   585,   584,   588,   587,   591,   590,     0,
     596,   595,   382,   633,     0,     0,    25,     0,     0,   389,
     386,   390,    78,     0,    79,     0,     0,     0,    15,    13,
       0,     0,     0,     0,     0,    51,     0,   222,     0,   260,
     227,   228,   223,     0,     0,   265,     0,     0,     0,   216,
     215,   218,   217,   448,   251,    77,   447,   249,    86,   236,
     258,     0,   244,   242,   243,     0,     0,   655,   656,   654,
     653,   652,   256,   676,   678,   677,   675,     0,   633,   659,
     661,   660,   658,   280,   300,   616,   281,   657,   292,   469,
     467,   470,   471,   468,   446,   465,   466,   448,   450,    42,
       0,    47,     0,     0,   454,   439,   437,   436,   438,     0,
     195,   614,     0,    82,   681,   683,   598,   633,   347,   509,
     524,   156,   163,   165,   164,   151,   150,   129,   122,   130,
     154,   155,   153,   157,   158,   131,   146,   149,   142,   132,
     114,   140,   147,   136,   152,   123,   167,   171,   172,   145,
     159,   160,   119,   116,   112,   137,   141,   161,   134,   133,
     128,   135,   115,   138,   118,   162,   117,   113,   126,   139,
     143,   166,   144,   125,   121,   127,   124,   148,   120,   168,
     169,   170,   173,   523,   625,   630,   631,   632,   625,   514,
     515,   516,   513,   517,   650,   648,   510,   511,   633,     0,
     633,     0,   290,   633,   633,   633,   383,     0,    32,     0,
      31,    33,     0,    30,    26,     0,   387,   400,    18,    17,
      19,    11,   691,     7,     9,     8,    10,    16,   403,    45,
      44,    73,     0,   181,   183,    49,     0,   271,   274,   263,
     224,   230,   234,   264,     0,   213,   690,     0,    76,    75,
       0,   252,   250,   267,   240,   239,     0,     0,   672,   674,
     673,   671,     0,   282,     0,   284,   293,   452,   463,   464,
     457,   456,     0,   459,   458,    81,   684,   597,     0,   290,
     628,   629,     0,   493,   613,     0,   625,     0,     0,   613,
       0,   593,   384,    74,    24,    22,     0,    23,   373,     0,
     692,     0,   448,     0,     0,     0,    58,     0,   633,     0,
     262,   212,   246,     0,     0,   238,   257,     0,     0,   633,
       0,     0,   301,   633,   312,   353,   447,   351,   347,   512,
     491,   633,   494,   497,   625,   495,   633,   373,     0,    27,
     368,   376,     0,   398,   391,   396,   401,   693,   180,   277,
     278,   633,    55,    52,   273,   272,   274,   279,   447,     0,
     253,   268,   668,   670,   669,   667,   666,   283,   287,   289,
     285,     0,    89,    94,     0,   447,    77,    92,     0,   626,
       0,   498,     0,     0,   374,     0,   380,   381,     6,   388,
       0,   394,   395,     0,   276,   447,     0,     0,     0,     0,
       0,   405,   405,   296,   342,     0,   342,   345,   290,   405,
     642,   405,   405,   326,   295,   316,   349,     0,   320,   294,
     319,   315,   327,   313,   335,     0,   334,     0,   337,   317,
     331,   329,   330,   328,   332,   333,     0,   318,   621,     0,
       0,   633,    91,     0,   448,    93,    87,   298,   299,   297,
      34,   352,   312,   492,   496,   385,     0,   175,     0,   392,
     393,   402,     0,     0,   247,   269,   324,   323,   325,     0,
       0,   306,     0,     0,   404,   404,   341,   343,   618,     0,
     617,     0,   346,   344,     0,   404,     0,   404,   404,     0,
     280,   336,   321,   322,     0,   314,   290,   338,     0,    96,
      95,    80,     0,   375,     0,   363,   447,     0,   366,     0,
     397,    53,    38,    37,    36,    35,    57,   310,     0,   309,
     311,     0,   308,     0,     0,   290,   290,     0,     0,   433,
       0,   290,     0,   290,   290,    49,     0,   443,     0,   382,
      83,    83,   627,    77,   175,   175,   367,   377,   379,     0,
     305,   303,     0,   307,   304,     0,     0,   435,   620,     0,
     425,     0,     0,   340,     0,     0,     0,   356,   354,   444,
      90,    88,   362,   365,   364,    54,     0,   633,   434,   424,
       0,     0,     0,     0,   359,   357,     0,    83,   361,     0,
       0,     0,   624,   623,     0,     0,     0,     0,   355,   360,
     409,   408,   407,     0,     0,     0,     0,     0,     0,     0,
       0,   358,   432,   413,   418,     0,   412,   419,   421,   423,
       0,   431,   410,   429,     0,     0,     0,     0,   406,   420,
     422,     0,   411,     0,   428
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -987,  -987,  -342,  -987,  -987,  -987,  -987,  -987,  -987,     0,
    -987,    96,  -987,  -987,  -987,  -987,  -691,  -167,   -55,  -987,
    -987,  -987,  -987,     5,  -987,  -911,  -987,  -987,  -987,  -987,
    -987,  -987,     4,  -840,  -107,  -588,   664,  -987,  -211,  -987,
    -987,  -676,  -789,  -987,  -123,  -987,  -987,  -987,  -987,  -987,
    -660,     6,   742,  -602,  -987,  -987,  -987,  -987,  -987,   -97,
    -103,  -500,    37,   -62,  -208,  1000,  1039,   355,  -987,  -987,
    -441,   359,  -199,   851,  -987,   854,  -987,  -987,  -987,   502,
    -987,  -987,   177,  -987,  -987,  -987,  -987,  -987,  -987,  -987,
    -987,  -987,   106,  -987,   152,  -987,  -987,  -987,  -987,   186,
     -77,  -987,  -987,  -987,  -770,  -799,  -987,   897,  -105,  -987,
    -987,   -33,  -987,  -987,  -946,  -987,  -987,    14,  -987,  -987,
    -987,  -703,  -987,  -987,  -987,  -987,  -987,  -987,  -987,  -987,
    -310,  -987,  -987,   681,    81,  -987,  -987,    89,    40,  -987,
    -987,  -987,  -987,  -987,   -18,  -987,  -987,  -353,  -987,   -35,
    -987,  -987,   898,  -987,  -987,  -987,  -987,  -325,  -294,  -987,
    -413,  -987,  -177,  -333,  -195,  -987,  -987,  -987,  -987,  -850,
    -987,  -987,  -987,  -987,  -987,  -920,  -987,  -987,   333,  -370,
    -242,  -987,  -987,  -987,   328,  -987,  -987,  -987,  -987,    -6,
    -987,  -987,  -987,  -987,   656,  -987,   631,  -987,   -13,   434,
     438,   400,   439,   621,   617,   623,   625,   620,  -987,  -987,
      64,   804,  -987,   -73,  -235,  -914,  -987,  -986,  -185,  -656,
    -987,  -987,  -535,  -987,  -987,  -987,  -638,  -987,   255,   699,
    -987,  -987,  -987,  -429,  -262,  -573,   -56,   741,  -202,  -987,
     -22,   871,  -338,    17
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
       0,     1,     2,   714,   517,   518,   352,   353,    11,   905,
      13,   506,   507,   786,   348,    14,   939,  1006,   100,   459,
     288,   590,   721,   101,   592,   795,   526,    15,   885,  1039,
     799,   355,   102,   740,   513,   604,   212,   381,   863,   991,
     931,   817,   864,   865,   103,   347,   669,   670,   671,   672,
     673,   332,    18,    19,   147,   359,   154,   104,   105,   413,
     360,   414,   866,   415,    53,   266,   272,   368,   731,   369,
     532,   370,   371,   215,   226,   221,   208,   379,   849,   545,
     546,   803,   236,   400,   747,   217,   158,   219,   384,   804,
     888,   726,   727,   841,   574,   809,   813,   810,   811,   258,
     908,   418,   756,   814,   909,   941,   575,   141,   961,   962,
     910,   861,   911,   912,   913,   914,   976,   967,   915,   916,
     917,   768,   107,   608,   108,   868,   981,  1076,   918,  1087,
     995,   996,   997,    56,    57,   831,   946,   832,   879,   999,
     327,   696,   782,   827,   155,   706,   788,   510,   881,   835,
     950,   836,   328,   351,   789,   883,    20,  1015,   964,   919,
    1093,  1118,  1104,   109,  1105,  1096,   920,  1115,   921,   144,
     922,   923,  1110,   924,   925,   599,   926,   927,   421,   867,
     422,   423,   430,   431,   432,   110,    58,    59,    60,   111,
     290,   460,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     267,   607,   325,   416,   928,   971,  1049,   929,  1084,   770,
     942,   131,   132,    62,    63,    64,   455,   133,   134,   257,
     135,   252,   136,   276,   277,   442,    66,   137,   373,   715,
     511,   201,   202,   138
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      61,   520,    12,   256,   270,   200,    16,   438,    17,   547,
     508,   245,   605,   521,   688,   382,   246,   246,   388,   417,
     519,   429,   771,   398,   346,   392,   936,   268,  1020,   773,
     547,   -49,   766,   536,   876,   363,   606,   253,   265,   271,
     937,   243,   425,    52,   203,   447,   159,   515,  1069,   807,
     772,  1019,   775,   588,   454,  1017,   780,   877,   287,   886,
     250,   594,   159,   938,   815,   982,     3,   983,   842,  1026,
    1028,   130,  1057,   585,   130,   230,  1053,  1074,   249,   985,
     203,   245,   259,   260,   261,  1083,   349,   362,   692,   209,
     434,   278,   279,   363,   790,   273,   952,  1047,  1002,  -286,
     249,   249,   249,   536,  1048,   264,   269,   142,   435,   249,
     249,   567,   139,   951,  1056,   869,   893,   823,   289,   434,
     822,  1003,  -288,   299,   300,  -225,  -225,   231,   875,  1068,
    1083,   586,   753,   426,  1027,   427,   440,   322,   365,   284,
     428,   537,    21,  1070,   285,   286,    61,  1102,    61,   -49,
     538,    61,  1079,  1112,  1113,   254,  1081,   878,  1085,  1086,
     255,   -12,   516,   255,   160,   274,   441,   270,   871,  1120,
    -683,  1122,   270,   268,   708,   256,   742,  1124,  1059,   808,
     522,   210,   816,   870,  1111,   364,   843,   408,   872,   354,
     816,   361,   555,  1062,   367,   816,   365,   791,   143,    61,
      61,   390,   271,   329,    98,    99,   396,   271,   745,   904,
      61,   537,  1004,   402,    61,   404,   685,   691,   301,   302,
     792,   255,  1032,  1050,  -447,    61,   600,    61,   568,  1038,
      24,  -442,   579,    22,  1098,    23,   246,   238,   148,  1090,
     203,   231,   376,   378,   157,   203,   231,  1109,   273,   679,
     499,   264,   203,   383,   203,    98,    99,   386,   273,   529,
    1116,    65,  1005,   273,   540,   709,   149,   710,   798,   269,
      52,  -634,   580,   966,   269,   231,   150,  1088,   234,   464,
     466,   468,   204,   273,    37,   -56,   557,   743,  1101,   283,
     151,   394,  1051,  -448,  -448,   956,   213,   249,   249,   249,
     249,   249,   249,   249,   249,   249,   249,   249,   249,   249,
     249,   249,   249,   249,   249,   410,   245,   563,  -448,   152,
     722,   232,   424,   581,   233,   582,   930,   424,   433,   514,
     583,   245,  1091,   274,   821,   350,   569,  1092,   235,   826,
     680,   234,   681,   362,   270,   994,   682,   683,  1005,   363,
    1058,   424,   793,   453,  -339,   205,   275,   746,   153,   234,
      61,   907,   606,   206,   326,   203,   784,   203,   203,   785,
    -448,   203,   787,    61,   150,    61,   207,   558,    61,   559,
    1075,  -225,  -225,   794,   560,  -680,   957,   362,   958,   501,
     223,   537,   576,   363,    61,   130,  -273,   738,   739,  -273,
     675,   237,   533,   528,   554,   693,   979,    65,   564,    65,
     565,   695,    65,   436,   534,   566,   544,   130,   548,   282,
     535,   551,   748,   698,  -441,  -225,  -225,   570,    61,   571,
     214,   203,   994,   994,   572,   273,   834,   544,   533,   930,
     216,   364,  1060,  1061,   852,   273,   269,   204,   508,   218,
     556,   778,   365,   454,   969,   454,   549,   930,   391,   454,
      65,    65,   231,   322,   595,   694,   966,   444,   445,   436,
     446,    65,    24,   437,   907,    65,  -680,   229,  -680,  -680,
     986,  1007,  -680,  -680,   584,   364,    65,   930,    65,  1089,
     150,   676,   907,   677,   716,   935,   365,   220,   678,  -635,
     601,   699,   543,   228,   728,   274,  -447,   331,   224,   275,
    -634,   231,   502,   749,   700,   750,   701,    61,    61,   275,
     751,    12,   907,   424,   275,    16,    37,    17,    61,   542,
    1018,   533,    61,   203,   231,   853,   948,   854,   595,   145,
     146,   -84,   855,   203,   275,   295,   296,   949,   231,   549,
     231,   227,   550,   530,   531,   596,   597,   598,   930,  1008,
     376,   378,   239,   309,   930,   930,   553,   697,   729,   310,
     311,   734,  1009,   251,  1010,   737,   533,   998,   231,   211,
     930,   312,   930,   231,   533,   231,   454,   303,   930,  -634,
     304,   454,   -84,   907,   744,   -84,   800,   834,   965,   907,
     907,   801,   805,   954,   578,   975,   703,   977,   978,   704,
     313,   297,   298,   314,   315,   907,   316,   907,   317,   796,
     280,    65,   797,   907,   318,   933,  1036,   934,   319,   596,
     597,   598,   752,  1034,    65,  1035,    65,   281,   320,    65,
    1016,  1012,   689,   690,  1013,   321,   322,   323,  -226,  -226,
    1021,   424,  1023,  1024,   291,    65,  1094,   762,   305,  1095,
     970,   530,   531,   764,   306,  1106,  1106,   765,  1097,   988,
     307,   767,  1099,  1100,   331,  1040,   308,    25,  1041,    26,
     245,  1044,   273,  1108,   273,  1106,    29,   330,   273,    65,
    -490,  -490,  -490,    30,   374,    31,   275,    32,   380,   478,
     480,   482,   484,   292,   293,   294,   275,   211,  1123,   738,
     739,    38,   405,    39,   456,   457,   458,    40,    41,  -448,
     331,    42,   989,   990,  1063,  1064,    43,   247,   248,   470,
     472,   406,   576,    45,   970,   474,   476,    47,   906,   407,
     439,    49,   486,   488,   441,   443,   448,    67,   503,   970,
      50,   146,   434,   523,   774,   524,   525,   424,   779,   781,
     527,   231,   539,   130,   589,   541,   130,   552,   603,   130,
     436,   203,   609,   561,   591,   846,   577,   587,    65,    65,
     593,   602,   686,   970,   702,   674,    61,   705,   687,    65,
     717,   940,   707,    65,   735,   718,   741,    61,    61,   753,
     769,   754,   755,   203,   806,   819,   203,   802,   758,   759,
      61,   776,   783,   820,   203,   273,   824,   825,   837,   830,
     273,   862,   848,   838,    61,   858,   856,   859,   699,   737,
    -347,   970,   880,   882,   270,   970,   794,   970,   970,   798,
     850,   851,    61,    61,   932,   943,   944,   233,   984,   953,
     947,   906,   973,   862,   955,   273,   993,  1001,  1011,  1014,
    1022,  1025,   847,   970,  1030,  1008,  1066,    52,   963,   906,
    1037,  1117,  1065,   857,  1067,  1114,   940,   860,   777,    61,
    1071,  1072,   829,  1073,  1031,   576,   887,   730,   333,   273,
     862,  1033,   732,    67,   397,    67,   225,   222,    67,   906,
      61,   372,   562,   845,   106,   884,   812,   203,  1043,   992,
     972,   874,   987,   945,   399,  1000,   873,   156,  1107,  1119,
     757,   761,   462,   492,   203,   273,   490,    61,    61,   498,
     494,  1121,   324,   496,   244,     0,   269,     0,   862,   862,
       0,     0,     0,   275,   130,   275,    67,    67,    12,   275,
       0,   411,    16,     0,    17,   818,     0,    67,     0,     0,
       0,   387,   940,   273,     0,     0,     0,   203,   273,   514,
     906,     0,    67,     0,    67,     0,   906,   906,   273,     0,
       0,     0,     0,     0,     0,     0,   273,     0,    61,     0,
       0,   963,   906,     0,   906,   274,     0,   270,   270,   940,
     906,     0,     0,     0,     0,     0,    54,     0,   203,     0,
     940,     0,   273,     0,     0,     0,   273,   270,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     203,   361,     0,     0,     0,     0,     0,     0,     0,     0,
    1078,     0,     0,     0,     0,    55,   203,    65,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    65,    65,
     273,     0,     0,     0,   273,   273,   273,   273,     0,     0,
       0,    65,   130,     0,     0,   130,   275,     0,   130,   203,
       0,   275,     0,     0,   974,    65,     0,   273,   273,   273,
       0,     0,   273,   273,   273,     0,     0,     0,     0,   269,
     269,     0,     0,    65,    65,     0,     0,    67,   273,   273,
     273,   273,     0,    77,     0,     0,   275,   273,     0,   269,
      67,     0,    67,     0,     0,    67,     0,     0,     0,   334,
       0,  1080,     0,     0,     0,    81,     0,     0,     0,     0,
      65,    67,   335,   336,   337,     0,     0,     0,     0,     0,
     275,     0,    54,     0,    54,     0,     0,    54,   274,   274,
     338,    65,   339,     0,   340,     0,   341,     0,     0,     0,
       0,     0,  1029,   342,   343,    67,     0,   344,   274,     0,
     345,     0,     0,     0,     0,     0,   275,     0,    65,    65,
       0,    55,     0,    55,     0,     0,    55,     0,     0,     0,
       0,  1045,  1046,     0,     0,    54,    54,  1052,     0,  1054,
    1055,     0,     0,     0,     0,     0,    54,     0,     0,     0,
      54,     0,     0,     0,   275,     0,     0,     0,     0,   275,
       0,    54,     0,    54,     0,     0,     0,     0,     0,   275,
       0,     0,     0,     0,    55,    55,     0,   275,     0,    65,
       0,     0,     0,     0,     0,    55,     0,     0,     0,    55,
       0,     0,     0,   372,    67,    67,     0,     0,     0,     0,
      55,     0,    55,   275,     0,    67,     0,   275,   736,    67,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   275,     0,     0,     0,   275,   275,   275,   275,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   275,   275,
     275,     0,     0,   275,   275,   275,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    54,     0,     0,   275,
     275,   275,   275,     0,     0,     0,     0,     0,   275,    54,
       0,    54,     0,     0,    54,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      54,     0,     0,     0,     0,    55,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    55,     0,
      55,     0,     0,    55,     0,    -2,     4,     0,     0,  -175,
       0,  -175,     0,     0,    54,     0,     0,     0,     0,    55,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     5,
       0,     0,  -175,  -175,  -175,     0,     0,  -175,  -175,  -175,
       0,  -175,     0,     0,     0,     0,     0,  -175,  -175,  -175,
    -175,     0,  -175,    55,     6,  -175,  -175,  -175,  -175,     0,
       7,  -175,  -175,  -175,  -175,  -175,  -175,     0,  -175,     0,
       0,     0,  -175,  -175,     0,     0,  -175,     0,     0,     0,
    -175,  -175,  -175,  -175,  -175,     0,  -175,     8,  -175,     0,
    -175,  -175,  -175,  -175,  -175,  -175,  -175,  -175,     0,     0,
    -175,     0,     0,    54,    54,  -175,     0,     0,     0,     0,
       0,     0,     0,    67,    54,     0,     0,     0,    54,     0,
       9,     0,     0,     0,    67,    67,     0,     0,    10,  -175,
    -175,     0,     0,     0,     0,     0,     0,    67,     0,     0,
       0,     0,    55,    55,     0,     0,     0,     0,     0,     0,
       0,    67,     0,    55,     0,     0,     0,    55,   889,     0,
       0,   890,    69,    24,    70,    71,    72,  -440,     0,    67,
      67,     0,    73,     0,     0,     0,     0,   891,    74,    75,
     892,   893,     0,     0,    25,    77,    26,   894,   895,  -633,
      27,   896,   897,    29,     0,   898,     0,     0,    78,  -633,
      30,    79,    31,   899,    32,    80,    67,    81,    33,   900,
      35,   901,     7,    83,    84,    36,    85,    37,    38,  -348,
      39,     0,    86,     0,    40,    41,     0,    67,    42,     0,
       0,     0,    87,    43,    88,    89,    90,     0,    91,     8,
      45,     0,     0,    46,    47,     0,    92,    48,    49,    93,
     902,     0,    94,     0,    67,    67,     0,    50,     0,     0,
       0,     0,     0,     0,     0,     0,    95,    96,     0,     0,
       0,    97,   903,     0,   904,     0,    98,    99,     0,   449,
       0,   255,    51,    69,    24,    70,    71,    72,     0,     0,
       0,     0,     0,    73,     0,     0,     0,     0,     0,    74,
      75,     0,   450,     0,     0,    25,    77,    26,     0,     0,
    -633,    27,    28,     0,    29,    67,     0,  -646,  -646,    78,
    -633,    30,    79,    31,     0,    32,    80,     0,    81,    33,
      82,    35,     0,     0,    83,    84,    36,    85,    37,    38,
    -348,    39,     0,    86,     0,    40,    41,     0,     0,    42,
       0,     0,     0,    87,    43,    88,    89,    90,     0,    91,
       8,    45,     0,     0,    46,    47,     0,    92,    48,    49,
      93,     0,    54,    94,     0,     0,     0,     0,    50,     0,
       0,     0,     0,    54,    54,     0,   451,    95,    96,   452,
       0,     0,    97,     0,     0,     0,    54,    98,    99,     0,
       0,     0,     0,    51,     0,     0,     0,     0,     0,     0,
      54,    55,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    55,    55,     0,     0,     0,     0,    54,    54,
       0,     0,     0,     0,     0,    55,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    55,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    54,     0,    55,    55,   461,
       0,     0,     0,    69,    24,    70,    71,    72,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    74,
      75,     0,     0,     0,     0,     0,    77,     0,     0,     0,
    -633,    27,    28,     0,    55,     0,     0,     0,     0,    78,
    -633,     0,    79,    54,    54,     0,    80,     0,    81,    33,
      82,    35,     0,     0,    83,    84,    36,    85,    37,     0,
    -348,     0,     0,    86,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    87,     0,    88,    89,    90,     0,    91,
       8,     0,    55,    55,    46,     0,     0,    92,    48,     0,
      93,     0,     0,    94,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    54,   889,     0,     0,   890,    69,
      24,    70,    71,    72,  -440,     0,     0,    98,     0,    73,
       0,     0,     0,    51,   891,    74,    75,   892,     0,     0,
       0,    25,    77,    26,   894,   895,  -633,    27,   896,   897,
      29,     0,   898,    55,     0,    78,  -633,    30,    79,    31,
     899,    32,    80,     0,    81,    33,   900,    35,   901,     7,
      83,    84,    36,    85,    37,    38,  -348,    39,     0,    86,
       0,    40,    41,     0,     0,    42,     0,     0,     0,    87,
      43,    88,    89,    90,     0,    91,     8,    45,     0,     0,
      46,    47,     0,    92,    48,    49,    93,   902,     0,    94,
       0,     0,     0,     0,    50,     0,     0,     0,     0,     0,
       0,     0,     0,    95,    96,     0,     0,     0,    97,   903,
       0,     0,     0,    98,    99,     0,   968,     0,   255,    51,
      69,    24,    70,    71,    72,     0,     0,     0,     0,     0,
      73,     0,     0,     0,     0,     0,    74,    75,     0,  -619,
       0,     0,    25,    77,    26,     0,     0,  -633,    27,    28,
       0,    29,     0,     0,     0,     0,    78,  -633,    30,    79,
      31,     0,    32,    80,     0,    81,    33,    82,    35,     0,
       0,    83,    84,    36,    85,    37,    38,  -348,    39,     0,
      86,     0,    40,    41,     0,     0,    42,     0,     0,     0,
      87,    43,    88,    89,    90,     0,    91,     8,    45,     0,
       0,    46,    47,     0,    92,    48,    49,    93,     0,     0,
      94,     0,     0,     0,     0,    50,     0,     0,     0,     0,
       0,     0,     0,     0,    95,    96,     0,     0,     0,    97,
    -619,  -619,  -619,     0,    98,    99,     0,  1103,     0,     0,
      51,    69,    24,    70,    71,    72,     0,     0,     0,     0,
       0,    73,     0,     0,     0,     0,     0,    74,    75,     0,
    -417,     0,     0,    25,    77,    26,     0,     0,  -633,    27,
      28,     0,    29,     0,     0,     0,     0,    78,  -633,    30,
      79,    31,     0,    32,    80,     0,    81,    33,    82,    35,
       0,     0,    83,    84,    36,    85,    37,    38,  -348,    39,
       0,    86,     0,    40,    41,     0,     0,    42,     0,     0,
       0,    87,    43,    88,    89,    90,     0,    91,     8,    45,
       0,     0,    46,    47,     0,    92,    48,    49,    93,     0,
       0,    94,     0,     0,     0,     0,    50,     0,     0,     0,
       0,     0,     0,     0,     0,    95,    96,     0,     0,     0,
      97,     0,     0,  -417,     0,    98,    99,     0,  -417,  1082,
       0,    51,     0,    69,    24,    70,    71,    72,     0,     0,
       0,     0,     0,    73,     0,     0,     0,     0,     0,    74,
      75,     0,  -622,     0,     0,    25,    77,    26,     0,     0,
    -633,    27,    28,     0,    29,     0,     0,     0,     0,    78,
    -633,    30,    79,    31,     0,    32,    80,     0,    81,    33,
      82,    35,     0,     0,    83,    84,    36,    85,    37,    38,
    -348,    39,     0,    86,     0,    40,    41,     0,     0,    42,
       0,     0,     0,    87,    43,    88,    89,    90,     0,    91,
       8,    45,     0,     0,    46,    47,     0,    92,    48,    49,
      93,     0,     0,    94,     0,     0,     0,     0,    50,     0,
       0,     0,     0,     0,     0,     0,     0,    95,    96,     0,
       0,     0,    97,     0,     0,  -622,     0,    98,    99,     0,
    -622,   968,     0,    51,     0,    69,    24,    70,    71,    72,
       0,     0,     0,     0,     0,    73,     0,     0,     0,     0,
       0,    74,    75,     0,     0,     0,     0,    25,    77,    26,
       0,     0,  -633,    27,    28,     0,    29,     0,     0,   530,
     531,    78,  -633,    30,    79,    31,     0,    32,    80,     0,
      81,    33,    82,    35,     0,     0,    83,    84,    36,    85,
      37,    38,  -348,    39,     0,    86,     0,    40,    41,     0,
       0,    42,     0,     0,     0,    87,    43,    88,    89,    90,
       0,    91,     8,    45,     0,     0,    46,    47,     0,    92,
      48,    49,    93,     0,     0,    94,     0,     0,     0,     0,
      50,     0,     0,     0,     0,     0,     0,     0,     0,    95,
      96,     0,     0,     0,    97,     0,     0,     0,     0,    98,
      99,     0,   968,     0,     0,    51,    69,    24,    70,    71,
      72,     0,     0,     0,     0,     0,    73,     0,     0,     0,
       0,     0,    74,    75,     0,   142,     0,     0,    25,    77,
      26,     0,     0,  -633,    27,    28,     0,    29,     0,     0,
       0,     0,    78,  -633,    30,    79,    31,     0,    32,    80,
       0,    81,    33,    82,    35,     0,     0,    83,    84,    36,
      85,    37,    38,  -348,    39,     0,    86,     0,    40,    41,
       0,     0,    42,     0,     0,     0,    87,    43,    88,    89,
      90,     0,    91,     8,    45,     0,     0,    46,    47,     0,
      92,    48,    49,    93,     0,     0,    94,     0,     0,     0,
       0,    50,     0,     0,     0,     0,     0,     0,     0,     0,
      95,    96,     0,     0,     0,    97,   143,     0,     0,     0,
      98,    99,     0,  1082,     0,     0,    51,    69,    24,    70,
      71,    72,     0,     0,     0,     0,     0,    73,     0,     0,
       0,     0,     0,    74,    75,     0,  -622,     0,     0,    25,
      77,    26,     0,     0,  -633,    27,    28,     0,    29,     0,
       0,     0,     0,    78,  -633,    30,    79,    31,     0,    32,
      80,     0,    81,    33,    82,    35,     0,     0,    83,    84,
      36,    85,    37,    38,  -348,    39,     0,    86,     0,    40,
      41,     0,     0,    42,     0,     0,     0,    87,    43,    88,
      89,    90,     0,    91,     8,    45,     0,     0,    46,    47,
       0,    92,    48,    49,    93,     0,     0,    94,     0,     0,
       0,     0,    50,     0,     0,     0,     0,     0,     0,     0,
       0,    95,    96,     0,     0,     0,    97,  -622,     0,     0,
       0,    98,    99,     0,   968,     0,     0,    51,    69,    24,
      70,    71,    72,     0,     0,     0,     0,     0,    73,     0,
       0,     0,     0,     0,    74,    75,     0,  -430,     0,     0,
      25,    77,    26,     0,     0,  -633,    27,    28,     0,    29,
       0,     0,     0,     0,    78,  -633,    30,    79,    31,     0,
      32,    80,     0,    81,    33,    82,    35,     0,     0,    83,
      84,    36,    85,    37,    38,  -348,    39,     0,    86,     0,
      40,    41,     0,     0,    42,     0,     0,     0,    87,    43,
      88,    89,    90,     0,    91,     8,    45,     0,     0,    46,
      47,     0,    92,    48,    49,    93,     0,     0,    94,     0,
       0,     0,     0,    50,     0,     0,     0,     0,     0,     0,
       0,     0,    95,    96,     0,     0,     0,    97,  -430,     0,
       0,     0,    98,    99,     0,   262,     0,     0,    51,    69,
      24,    70,    71,    72,     0,     0,     0,     0,     0,    73,
       0,     0,     0,     0,     0,    74,    75,     0,     0,     0,
       0,    25,    77,    26,     0,     0,  -633,    27,    28,     0,
      29,     0,     0,     0,     0,    78,  -633,    30,    79,    31,
       0,    32,    80,     0,    81,    33,    82,    35,     0,     0,
      83,    84,    36,    85,    37,    38,  -348,    39,     0,    86,
       0,    40,    41,     0,     0,    42,     0,     0,     0,    87,
      43,    88,    89,    90,     0,    91,     8,    45,     0,     0,
      46,    47,     0,    92,    48,    49,    93,     0,     0,    94,
       0,     0,     0,     0,    50,     0,     0,     0,     0,     0,
       0,     0,     0,    95,    96,     0,     0,     0,    97,     0,
       0,     0,     0,    98,    99,     0,  1103,     0,   263,    51,
      69,    24,    70,    71,    72,     0,     0,     0,     0,     0,
      73,     0,     0,     0,     0,     0,    74,    75,     0,     0,
       0,     0,    25,    77,    26,     0,     0,  -633,    27,    28,
       0,    29,     0,     0,     0,     0,    78,  -633,    30,    79,
      31,     0,    32,    80,     0,    81,    33,    82,    35,     0,
       0,    83,    84,    36,    85,    37,    38,  -348,    39,     0,
      86,     0,    40,    41,     0,     0,    42,     0,     0,     0,
      87,    43,    88,    89,    90,     0,    91,     8,    45,     0,
       0,    46,    47,     0,    92,    48,    49,    93,     0,     0,
      94,     0,     0,     0,     0,    50,     0,     0,     0,     0,
       0,     0,     0,     0,    95,    96,     0,     0,     0,    97,
    -417,     0,     0,     0,    98,    99,     0,   412,     0,     0,
      51,    69,    24,    70,    71,    72,     0,     0,     0,     0,
       0,    73,     0,     0,     0,     0,     0,    74,    75,     0,
       0,     0,     0,    25,    77,    26,     0,     0,  -633,    27,
      28,     0,    29,     0,     0,     0,     0,    78,  -633,    30,
      79,    31,     0,    32,    80,     0,    81,    33,    82,    35,
       0,     0,    83,    84,    36,    85,    37,    38,  -348,    39,
       0,    86,     0,    40,    41,     0,     0,    42,     0,     0,
       0,    87,    43,    88,    89,    90,     0,    91,     8,    45,
       0,     0,    46,    47,     0,    92,    48,    49,    93,     0,
       0,    94,     0,     0,     0,     0,    50,     0,     0,     0,
       0,     0,     0,     0,     0,    95,    96,     0,     0,     0,
      97,     0,     0,     0,     0,    98,    99,     0,   968,     0,
       0,    51,    69,    24,    70,    71,    72,     0,     0,     0,
       0,     0,    73,     0,     0,     0,     0,     0,    74,    75,
       0,     0,     0,     0,    25,    77,    26,     0,     0,  -633,
      27,    28,     0,    29,     0,     0,     0,     0,    78,  -633,
      30,    79,    31,     0,    32,    80,     0,    81,    33,    82,
      35,     0,     0,    83,    84,    36,    85,    37,    38,  -348,
      39,     0,    86,     0,    40,    41,     0,     0,    42,     0,
       0,     0,    87,    43,    88,    89,    90,     0,    91,     8,
      45,     0,     0,    46,    47,     0,    92,    48,    49,    93,
       0,     0,    94,     0,     0,     0,     0,    50,     0,     0,
       0,     0,     0,     0,     0,     0,    95,    96,     0,     0,
       0,    97,     0,     0,     0,     0,    98,    99,     0,  1103,
       0,     0,    51,    69,    24,    70,    71,    72,     0,     0,
       0,     0,     0,    73,     0,     0,     0,     0,     0,    74,
      75,     0,     0,     0,     0,    25,    77,    26,     0,     0,
    -633,    27,    28,     0,    29,     0,     0,     0,     0,    78,
    -633,    30,    79,    31,     0,    32,    80,     0,    81,    33,
      82,    35,     0,     0,    83,    84,    36,    85,    37,    38,
    -348,    39,     0,    86,     0,    40,    41,     0,     0,    42,
       0,     0,     0,    87,    43,    88,    89,    90,     0,    91,
       8,    45,     0,     0,    46,    47,     0,    92,    48,    49,
      93,     0,     0,    94,     0,     0,     0,     0,    50,     4,
       0,     0,  -175,     0,  -175,     0,     0,    95,    96,     0,
       0,     0,    97,     0,     0,     0,     0,    98,    99,     0,
       0,     0,   719,    51,     0,  -175,  -175,  -175,     0,     0,
    -175,  -175,  -175,     0,  -175,     0,     0,     0,     0,     0,
    -175,  -175,  -175,  -175,     0,  -175,     0,     6,  -175,  -175,
    -175,  -175,     0,     7,  -175,  -175,  -175,  -175,  -175,  -175,
       0,  -175,     0,     0,     0,  -175,  -175,     0,     0,  -175,
       0,     0,     0,  -175,  -175,  -175,  -175,  -175,     0,  -175,
       8,  -175,     0,  -175,  -175,  -175,  -175,  -175,  -175,  -175,
    -175,     0,     0,  -175,     0,     0,     0,     0,  -175,     0,
       0,     4,     0,     0,  -175,     0,  -175,     0,     0,     0,
       0,     0,     0,     9,     0,   720,     0,     0,     0,     0,
       0,    10,  -175,  -175,  -378,     0,     0,  -175,  -175,  -175,
       0,     0,  -175,  -175,  -175,     0,  -175,     0,     0,     0,
       0,     0,  -175,  -175,  -175,  -175,     0,  -175,     0,     6,
    -175,  -175,  -175,  -175,     0,     7,  -175,  -175,  -175,  -175,
    -175,  -175,     0,  -175,     0,     0,     0,  -175,  -175,     0,
       0,  -175,     0,     0,     0,  -175,  -175,  -175,  -175,  -175,
       0,  -175,     8,  -175,     0,  -175,  -175,  -175,  -175,  -175,
    -175,  -175,  -175,     0,     0,  -175,     0,     0,     0,   419,
    -175,     0,     0,    69,    24,    70,    71,    72,     0,     0,
       0,     0,     0,    73,     0,     9,     0,  -378,     0,    74,
      75,     0,     0,    10,  -175,  -175,    77,     0,     0,     0,
    -633,    27,    28,     0,     0,     0,     0,     0,     0,    78,
    -633,     0,    79,     0,     0,     0,    80,     0,    81,    33,
      82,    35,     0,     0,    83,    84,    36,    85,    37,     0,
    -348,     0,  -449,    86,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    87,     0,    88,    89,    90,     0,    91,
       8,     0,     0,     0,    46,     0,     0,    92,    48,     0,
      93,     0,     0,    94,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    95,    96,     0,
       0,     0,    97,     0,     0,     0,     0,    98,    99,     0,
    -449,   420,    68,    51,     0,   140,    69,    24,    70,    71,
      72,     0,     0,     0,     0,     0,    73,     0,     0,     0,
       0,     0,    74,    75,     0,    76,     0,     0,     0,    77,
       0,     0,     0,  -633,    27,    28,     0,     0,     0,     0,
       0,     0,    78,  -633,     0,    79,     0,     0,     0,    80,
       0,    81,    33,    82,    35,     0,     0,    83,    84,    36,
      85,    37,     0,  -348,     0,     0,    86,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    87,     0,    88,    89,
      90,     0,    91,     8,     0,     0,     0,    46,     0,     0,
      92,    48,     0,    93,     0,     0,    94,     0,   760,     0,
       0,     0,    69,    24,    70,    71,    72,     0,     0,     0,
      95,    96,    73,     0,     0,    97,     0,     0,    74,    75,
      98,    99,     0,     0,     0,    77,    51,     0,     0,  -633,
      27,    28,     0,     0,     0,     0,     0,     0,    78,  -633,
       0,    79,     0,     0,     0,    80,     0,    81,    33,    82,
      35,     0,     0,    83,    84,    36,    85,    37,     0,  -348,
       0,     0,    86,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    87,     0,    88,    89,    90,     0,    91,     8,
       0,     0,     0,    46,     0,     0,    92,    48,     0,    93,
       0,     0,    94,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    95,    96,     0,     0,
       0,    97,     0,     0,     0,     0,    98,    99,  -448,  -448,
      68,     0,    51,     0,    69,    24,    70,    71,    72,     0,
       0,     0,     0,     0,    73,     0,     0,     0,     0,     0,
      74,    75,     0,    76,     0,     0,     0,    77,     0,     0,
       0,  -633,    27,    28,     0,     0,     0,     0,     0,     0,
      78,  -633,     0,    79,     0,     0,     0,    80,     0,    81,
      33,    82,    35,     0,     0,    83,    84,    36,    85,    37,
       0,  -348,     0,     0,    86,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    87,     0,    88,    89,    90,     0,
      91,     8,     0,     0,     0,    46,     0,     0,    92,    48,
       0,    93,     0,     0,    94,     0,   262,     0,     0,     0,
      69,    24,    70,    71,    72,     0,     0,     0,    95,    96,
      73,     0,     0,    97,     0,     0,    74,    75,    98,    99,
       0,     0,     0,    77,    51,     0,     0,  -633,    27,    28,
       0,     0,     0,     0,     0,     0,    78,  -633,     0,    79,
       0,     0,     0,    80,     0,    81,    33,    82,    35,     0,
       0,    83,    84,    36,    85,    37,     0,  -348,     0,     0,
      86,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      87,     0,    88,    89,    90,     0,    91,     8,     0,     0,
       0,    46,     0,     0,    92,    48,     0,    93,     0,     0,
      94,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    95,    96,     0,     0,     0,    97,
       0,     0,     0,     0,    98,    99,     0,   839,     0,   263,
      51,  -275,  -275,  -275,  -275,  -275,     0,     0,     0,     0,
       0,  -275,     0,     0,     0,     0,     0,  -275,  -275,     0,
     840,     0,     0,     0,  -275,     0,     0,     0,  -275,  -275,
    -275,     0,     0,     0,     0,     0,     0,  -275,  -275,     0,
    -275,     0,     0,     0,  -275,     0,  -275,  -275,  -275,  -275,
       0,     0,  -275,  -275,  -275,  -275,  -275,     0,  -275,     0,
       0,  -275,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  -275,     0,  -275,  -275,  -275,     0,  -275,  -275,     0,
       0,     0,  -275,     0,     0,  -275,  -275,     0,  -275,     0,
       0,  -275,     0,   393,     0,     0,     0,    69,    24,    70,
      71,    72,     0,     0,     0,  -275,  -275,    73,     0,     0,
    -275,     0,     0,    74,    75,  -275,  -275,     0,     0,     0,
      77,  -275,     0,     0,  -633,    27,    28,     0,     0,     0,
       0,     0,     0,    78,  -633,     0,    79,     0,     0,     0,
      80,     0,    81,    33,    82,    35,     0,     0,    83,    84,
      36,    85,    37,     0,  -348,     0,     0,    86,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    87,     0,    88,
      89,    90,     0,    91,     8,     0,     0,     0,    46,     0,
       0,    92,    48,     0,    93,     0,     0,    94,     0,   409,
       0,     0,     0,    69,    24,    70,    71,    72,     0,     0,
       0,    95,    96,    73,     0,     0,    97,     0,     0,    74,
      75,    98,    99,     0,     0,     0,    77,    51,     0,     0,
    -633,    27,    28,     0,     0,     0,     0,     0,     0,    78,
    -633,     0,    79,     0,     0,     0,    80,     0,    81,    33,
      82,    35,     0,     0,    83,    84,    36,    85,    37,     0,
    -348,     0,     0,    86,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    87,     0,    88,    89,    90,     0,    91,
       8,     0,     0,     0,    46,     0,     0,    92,    48,     0,
      93,     0,     0,    94,     0,   -41,     0,     0,     0,    69,
      24,    70,    71,    72,     0,     0,     0,    95,    96,    73,
       0,     0,    97,     0,     0,    74,    75,    98,    99,     0,
       0,     0,    77,    51,     0,     0,     0,    27,    28,     0,
       0,     0,     0,     0,     0,    78,     0,     0,    79,     0,
       0,     0,    80,     0,    81,    33,    82,    35,     0,     0,
      83,    84,    36,    85,    37,     0,  -348,     0,     0,    86,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    87,
       0,    88,    89,    90,     0,    91,     8,     0,     0,     0,
      46,     0,     0,    92,    48,     0,    93,     0,     0,    94,
       0,   463,     0,     0,     0,    69,    24,    70,    71,    72,
       0,     0,     0,    95,    96,    73,     0,     0,    97,     0,
       0,    74,    75,    98,    99,     0,  -449,   420,    77,    51,
       0,     0,  -633,    27,    28,     0,     0,     0,     0,     0,
       0,    78,  -633,     0,    79,     0,     0,     0,    80,     0,
      81,    33,    82,    35,     0,     0,    83,    84,    36,    85,
      37,     0,  -348,     0,     0,    86,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    87,     0,    88,    89,    90,
       0,    91,     8,     0,     0,     0,    46,     0,     0,    92,
      48,     0,    93,     0,     0,    94,     0,   465,     0,     0,
       0,    69,    24,    70,    71,    72,     0,     0,     0,    95,
      96,    73,     0,     0,    97,     0,     0,    74,    75,    98,
      99,     0,     0,     0,    77,    51,     0,     0,  -633,    27,
      28,     0,     0,     0,     0,     0,     0,    78,  -633,     0,
      79,     0,     0,     0,    80,     0,    81,    33,    82,    35,
       0,     0,    83,    84,    36,    85,    37,     0,  -348,     0,
       0,    86,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    87,     0,    88,    89,    90,     0,    91,     8,     0,
       0,     0,    46,     0,     0,    92,    48,     0,    93,     0,
       0,    94,     0,   467,     0,     0,     0,    69,    24,    70,
      71,    72,     0,     0,     0,    95,    96,    73,     0,     0,
      97,     0,     0,    74,    75,    98,    99,     0,     0,     0,
      77,    51,     0,     0,  -633,    27,    28,     0,     0,     0,
       0,     0,     0,    78,  -633,     0,    79,     0,     0,     0,
      80,     0,    81,    33,    82,    35,     0,     0,    83,    84,
      36,    85,    37,     0,  -348,     0,     0,    86,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    87,     0,    88,
      89,    90,     0,    91,     8,     0,     0,     0,    46,     0,
       0,    92,    48,     0,    93,     0,     0,    94,     0,   469,
       0,     0,     0,    69,    24,    70,    71,    72,     0,     0,
       0,    95,    96,    73,     0,     0,    97,     0,     0,    74,
      75,    98,    99,     0,     0,     0,    77,    51,     0,     0,
    -633,    27,    28,     0,     0,     0,     0,     0,     0,    78,
    -633,     0,    79,     0,     0,     0,    80,     0,    81,    33,
      82,    35,     0,     0,    83,    84,    36,    85,    37,     0,
    -348,     0,     0,    86,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    87,     0,    88,    89,    90,     0,    91,
       8,     0,     0,     0,    46,     0,     0,    92,    48,     0,
      93,     0,     0,    94,     0,   471,     0,     0,     0,    69,
      24,    70,    71,    72,     0,     0,     0,    95,    96,    73,
       0,     0,    97,     0,     0,    74,    75,    98,    99,     0,
       0,     0,    77,    51,     0,     0,  -633,    27,    28,     0,
       0,     0,     0,     0,     0,    78,  -633,     0,    79,     0,
       0,     0,    80,     0,    81,    33,    82,    35,     0,     0,
      83,    84,    36,    85,    37,     0,  -348,     0,     0,    86,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    87,
       0,    88,    89,    90,     0,    91,     8,     0,     0,     0,
      46,     0,     0,    92,    48,     0,    93,     0,     0,    94,
       0,   473,     0,     0,     0,    69,    24,    70,    71,    72,
       0,     0,     0,    95,    96,    73,     0,     0,    97,     0,
       0,    74,    75,    98,    99,     0,     0,     0,    77,    51,
       0,     0,  -633,    27,    28,     0,     0,     0,     0,     0,
       0,    78,  -633,     0,    79,     0,     0,     0,    80,     0,
      81,    33,    82,    35,     0,     0,    83,    84,    36,    85,
      37,     0,  -348,     0,     0,    86,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    87,     0,    88,    89,    90,
       0,    91,     8,     0,     0,     0,    46,     0,     0,    92,
      48,     0,    93,     0,     0,    94,     0,   475,     0,     0,
       0,    69,    24,    70,    71,    72,     0,     0,     0,    95,
      96,    73,     0,     0,    97,     0,     0,    74,    75,    98,
      99,     0,     0,     0,    77,    51,     0,     0,  -633,    27,
      28,     0,     0,     0,     0,     0,     0,    78,  -633,     0,
      79,     0,     0,     0,    80,     0,    81,    33,    82,    35,
       0,     0,    83,    84,    36,    85,    37,     0,  -348,     0,
       0,    86,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    87,     0,    88,    89,    90,     0,    91,     8,     0,
       0,     0,    46,     0,     0,    92,    48,     0,    93,     0,
       0,    94,     0,   477,     0,     0,     0,    69,    24,    70,
      71,    72,     0,     0,     0,    95,    96,    73,     0,     0,
      97,     0,     0,    74,    75,    98,    99,     0,     0,     0,
      77,    51,     0,     0,  -633,    27,    28,     0,     0,     0,
       0,     0,     0,    78,  -633,     0,    79,     0,     0,     0,
      80,     0,    81,    33,    82,    35,     0,     0,    83,    84,
      36,    85,    37,     0,  -348,     0,     0,    86,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    87,     0,    88,
      89,    90,     0,    91,     8,     0,     0,     0,    46,     0,
       0,    92,    48,     0,    93,     0,     0,    94,     0,   479,
       0,     0,     0,    69,    24,    70,    71,    72,     0,     0,
       0,    95,    96,    73,     0,     0,    97,     0,     0,    74,
      75,    98,    99,     0,     0,     0,    77,    51,     0,     0,
    -633,    27,    28,     0,     0,     0,     0,     0,     0,    78,
    -633,     0,    79,     0,     0,     0,    80,     0,    81,    33,
      82,    35,     0,     0,    83,    84,    36,    85,    37,     0,
    -348,     0,     0,    86,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    87,     0,    88,    89,    90,     0,    91,
       8,     0,     0,     0,    46,     0,     0,    92,    48,     0,
      93,     0,     0,    94,     0,   481,     0,     0,     0,    69,
      24,    70,    71,    72,     0,     0,     0,    95,    96,    73,
       0,     0,    97,     0,     0,    74,    75,    98,    99,     0,
       0,     0,    77,    51,     0,     0,  -633,    27,    28,     0,
       0,     0,     0,     0,     0,    78,  -633,     0,    79,     0,
       0,     0,    80,     0,    81,    33,    82,    35,     0,     0,
      83,    84,    36,    85,    37,     0,  -348,     0,     0,    86,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    87,
       0,    88,    89,    90,     0,    91,     8,     0,     0,     0,
      46,     0,     0,    92,    48,     0,    93,     0,     0,    94,
       0,   483,     0,     0,     0,    69,    24,    70,    71,    72,
       0,     0,     0,    95,    96,    73,     0,     0,    97,     0,
       0,    74,    75,    98,    99,     0,     0,     0,    77,    51,
       0,     0,  -633,    27,    28,     0,     0,     0,     0,     0,
       0,    78,  -633,     0,    79,     0,     0,     0,    80,     0,
      81,    33,    82,    35,     0,     0,    83,    84,    36,    85,
      37,     0,  -348,     0,     0,    86,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    87,     0,    88,    89,    90,
       0,    91,     8,     0,     0,     0,    46,     0,     0,    92,
      48,     0,    93,     0,     0,    94,     0,   485,     0,     0,
       0,    69,    24,    70,    71,    72,     0,     0,     0,    95,
      96,    73,     0,     0,    97,     0,     0,    74,    75,    98,
      99,     0,     0,     0,    77,    51,     0,     0,  -633,    27,
      28,     0,     0,     0,     0,     0,     0,    78,  -633,     0,
      79,     0,     0,     0,    80,     0,    81,    33,    82,    35,
       0,     0,    83,    84,    36,    85,    37,     0,  -348,     0,
       0,    86,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    87,     0,    88,    89,    90,     0,    91,     8,     0,
       0,     0,    46,     0,     0,    92,    48,     0,    93,     0,
       0,    94,     0,   487,     0,     0,     0,    69,    24,    70,
      71,    72,     0,     0,     0,    95,    96,    73,     0,     0,
      97,     0,     0,    74,    75,    98,    99,     0,     0,     0,
      77,    51,     0,     0,  -633,    27,    28,     0,     0,     0,
       0,     0,     0,    78,  -633,     0,    79,     0,     0,     0,
      80,     0,    81,    33,    82,    35,     0,     0,    83,    84,
      36,    85,    37,     0,  -348,     0,     0,    86,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    87,     0,    88,
      89,    90,     0,    91,     8,     0,     0,     0,    46,     0,
       0,    92,    48,     0,    93,     0,     0,    94,     0,   489,
       0,     0,     0,    69,    24,    70,    71,    72,     0,     0,
       0,    95,    96,    73,     0,     0,    97,     0,     0,    74,
      75,    98,    99,     0,     0,     0,    77,    51,     0,     0,
    -633,    27,    28,     0,     0,     0,     0,     0,     0,    78,
    -633,     0,    79,     0,     0,     0,    80,     0,    81,    33,
      82,    35,     0,     0,    83,    84,    36,    85,    37,     0,
    -348,     0,     0,    86,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    87,     0,    88,    89,    90,     0,    91,
       8,     0,     0,     0,    46,     0,     0,    92,    48,     0,
      93,     0,     0,    94,     0,   491,     0,     0,     0,    69,
      24,    70,    71,    72,     0,     0,     0,    95,    96,    73,
       0,     0,    97,     0,     0,    74,    75,    98,    99,     0,
       0,     0,    77,    51,     0,     0,  -633,    27,    28,     0,
       0,     0,     0,     0,     0,    78,  -633,     0,    79,     0,
       0,     0,    80,     0,    81,    33,    82,    35,     0,     0,
      83,    84,    36,    85,    37,     0,  -348,     0,     0,    86,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    87,
       0,    88,    89,    90,     0,    91,     8,     0,     0,     0,
      46,     0,     0,    92,    48,     0,    93,     0,     0,    94,
       0,   493,     0,     0,     0,    69,    24,    70,    71,    72,
       0,     0,     0,    95,    96,    73,     0,     0,    97,     0,
       0,    74,    75,    98,    99,     0,     0,     0,    77,    51,
       0,     0,  -633,    27,    28,     0,     0,     0,     0,     0,
       0,    78,  -633,     0,    79,     0,     0,     0,    80,     0,
      81,    33,    82,    35,     0,     0,    83,    84,    36,    85,
      37,     0,  -348,     0,     0,    86,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    87,     0,    88,    89,    90,
       0,    91,     8,     0,     0,     0,    46,     0,     0,    92,
      48,     0,    93,     0,     0,    94,     0,   495,     0,     0,
       0,    69,    24,    70,    71,    72,     0,     0,     0,    95,
      96,    73,     0,     0,    97,     0,     0,    74,    75,    98,
      99,     0,     0,     0,    77,    51,     0,     0,  -633,    27,
      28,     0,     0,     0,     0,     0,     0,    78,  -633,     0,
      79,     0,     0,     0,    80,     0,    81,    33,    82,    35,
       0,     0,    83,    84,    36,    85,    37,     0,  -348,     0,
       0,    86,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    87,     0,    88,    89,    90,     0,    91,     8,     0,
       0,     0,    46,     0,     0,    92,    48,     0,    93,     0,
       0,    94,     0,   497,     0,     0,     0,    69,    24,    70,
      71,    72,     0,     0,     0,    95,    96,    73,     0,     0,
      97,     0,     0,    74,    75,    98,    99,     0,     0,     0,
      77,    51,     0,     0,  -633,    27,    28,     0,     0,     0,
       0,     0,     0,    78,  -633,     0,    79,     0,     0,     0,
      80,     0,    81,    33,    82,    35,     0,     0,    83,    84,
      36,    85,    37,     0,  -348,     0,     0,    86,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    87,     0,    88,
      89,    90,     0,    91,     8,     0,     0,     0,    46,     0,
       0,    92,    48,     0,    93,     0,     0,    94,     0,   500,
       0,     0,     0,    69,    24,    70,    71,    72,     0,     0,
       0,    95,    96,    73,     0,     0,    97,     0,     0,    74,
      75,    98,    99,     0,     0,     0,    77,    51,     0,     0,
    -633,    27,    28,     0,     0,     0,     0,     0,     0,    78,
    -633,     0,    79,     0,     0,     0,    80,     0,    81,    33,
      82,    35,     0,     0,    83,    84,    36,    85,    37,     0,
    -348,     0,     0,    86,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    87,     0,    88,    89,    90,     0,    91,
       8,     0,     0,     0,    46,     0,     0,    92,    48,     0,
      93,     0,     0,    94,     0,   763,     0,     0,     0,    69,
      24,    70,    71,    72,     0,     0,     0,    95,    96,    73,
       0,     0,    97,     0,     0,    74,    75,    98,    99,     0,
       0,     0,    77,    51,     0,     0,  -633,    27,    28,     0,
       0,     0,     0,     0,     0,    78,  -633,     0,    79,     0,
       0,     0,    80,     0,    81,    33,    82,    35,     0,     0,
      83,    84,    36,    85,    37,     0,  -348,     0,     0,    86,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    87,
       0,    88,    89,    90,     0,    91,     8,     0,     0,     0,
      46,     0,     0,    92,    48,     0,    93,     0,     0,    94,
     362,     0,     0,     0,     0,    24,   363,     0,     0,     0,
       0,     0,     0,    95,    96,     0,     0,     0,    97,     0,
       0,     0,     0,    98,    99,     0,    25,     0,    26,    51,
       0,     0,    27,    28,     0,    29,     0,     0,  -225,  -225,
       0,     0,    30,     0,    31,     0,    32,     0,     0,     0,
      33,    82,    35,     0,     0,     0,     0,    36,     0,    37,
      38,     0,    39,     0,     0,     0,    40,    41,   375,     0,
      42,     0,     0,    24,     0,    43,     0,    44,     0,     0,
       0,     0,    45,     0,     0,    46,    47,     0,     0,    48,
      49,     0,     0,     0,    25,     0,    26,     0,   364,    50,
      27,    28,     0,    29,     0,     0,     0,     0,     0,   365,
      30,     0,    31,     0,    32,   366,     0,     0,    33,    82,
      35,     0,     0,     0,    51,    36,     0,    37,    38,     0,
      39,     0,     0,     0,    40,    41,   377,     0,    42,     0,
       0,    24,     0,    43,     0,    44,     0,     0,     0,     0,
      45,     0,     0,    46,    47,     0,     0,    48,    49,     0,
       0,     0,    25,     0,    26,     0,     0,    50,    27,    28,
       0,    29,     0,     0,     0,     0,     0,     0,    30,     0,
      31,     0,    32,     0,     0,     0,    33,    82,    35,   723,
       0,     0,    51,    36,     0,    37,    38,     0,    39,     0,
       0,     0,    40,    41,   375,     0,    42,     0,     0,    24,
       0,    43,     0,    44,     0,     0,     0,     0,    45,     0,
       0,    46,    47,     0,     0,    48,    49,     0,     0,     0,
      25,     0,    26,     0,     0,    50,    27,    28,     0,    29,
       0,     0,     0,     0,     0,     0,    30,     0,    31,     0,
      32,     0,     0,     0,    33,    82,    35,   724,     0,     0,
      51,    36,     0,    37,    38,     0,    39,     0,     0,     0,
      40,    41,   377,     0,    42,     0,     0,    24,     0,    43,
       0,    44,     0,     0,     0,     0,    45,     0,     0,    46,
      47,     0,     0,    48,    49,     0,     0,     0,    25,     0,
      26,     0,     0,    50,    27,    28,     0,    29,     0,     0,
       0,     0,     0,     0,    30,     0,    31,     0,    32,     0,
       0,     0,    33,    82,    35,     0,     0,     0,    51,    36,
       0,    37,    38,     0,    39,     0,     0,     0,    40,    41,
     385,     0,    42,     0,     0,    24,     0,    43,     0,    44,
       0,     0,     0,     0,    45,     0,     0,    46,    47,     0,
       0,    48,    49,     0,     0,     0,    25,     0,    26,     0,
       0,    50,    27,    28,     0,    29,     0,     0,     0,     0,
       0,     0,    30,     0,    31,     0,    32,     0,     0,     0,
      33,    82,    35,     0,     0,     0,    51,    36,     0,    37,
      38,     0,    39,     0,     0,     0,    40,    41,     0,     0,
      42,     0,     0,     0,     0,    43,     0,    44,     0,     0,
       0,     0,    45,     0,     0,    46,    47,     0,     0,    48,
      49,    69,    24,    70,    71,    72,     0,     0,     0,    50,
       0,    73,     0,     0,     0,     0,     0,    74,    75,     0,
     450,     0,     0,    25,    77,    26,     0,     0,     0,    27,
      28,     0,    29,     0,    51,  -646,  -646,    78,     0,    30,
      79,    31,     0,    32,    80,     0,    81,    33,    82,    35,
       0,     0,    83,    84,    36,    85,    37,    38,  -348,    39,
       0,    86,     0,    40,    41,     0,     0,    42,     0,     0,
       0,    87,    43,    88,    89,    90,     0,    91,     8,    45,
       0,     0,    46,    47,     0,    92,    48,    49,    93,     0,
       0,    94,     0,     0,     0,     0,    50,     0,     0,     0,
       0,     0,     0,     0,   451,    95,    96,     0,     0,     0,
      97,     0,     0,     0,     0,    98,    99,     0,     0,     0,
       0,    51,    69,    24,    70,    71,    72,     0,     0,     0,
       0,     0,    73,     0,     0,     0,     0,     0,    74,    75,
       0,   450,     0,     0,    25,    77,    26,     0,     0,     0,
      27,    28,     0,    29,     0,     0,     0,     0,    78,     0,
      30,    79,    31,     0,    32,    80,     0,    81,    33,    82,
      35,     0,     0,    83,    84,    36,    85,    37,    38,  -348,
      39,     0,    86,     0,    40,    41,     0,     0,    42,     0,
       0,     0,    87,    43,    88,    89,    90,     0,    91,     8,
      45,     0,     0,    46,    47,     0,    92,    48,    49,    93,
       0,     0,    94,     0,     0,     0,     0,    50,     0,     0,
       0,     0,     0,     0,     0,   451,    95,    96,     0,     0,
       0,    97,     0,     0,     0,     0,    98,    99,  -646,     0,
       0,     0,    51,    69,    24,    70,    71,    72,     0,     0,
       0,     0,     0,    73,     0,     0,     0,     0,     0,    74,
      75,     0,     0,     0,     0,    25,    77,    26,     0,     0,
    -633,    27,    28,     0,    29,     0,     0,     0,     0,    78,
    -633,    30,    79,    31,     0,    32,    80,     0,    81,    33,
      82,    35,     0,     0,    83,    84,    36,    85,    37,    38,
    -348,    39,     0,    86,     0,    40,    41,     0,     0,    42,
       0,     0,     0,    87,    43,    88,    89,    90,     0,    91,
       8,    45,     0,     0,    46,    47,     0,    92,    48,    49,
      93,     0,     0,    94,     0,     0,     0,     0,    50,     0,
       0,     0,     0,     0,     0,     0,     0,    95,    96,     0,
       0,     0,    97,     0,     0,     0,     0,    98,    99,     0,
       0,     0,     0,    51,    69,    24,    70,    71,    72,     0,
       0,     0,     0,     0,    73,     0,     0,     0,     0,     0,
      74,    75,     0,   684,     0,     0,    25,    77,    26,     0,
       0,     0,    27,    28,     0,    29,     0,     0,     0,     0,
      78,     0,    30,    79,    31,     0,    32,    80,     0,    81,
      33,    82,    35,     0,     0,    83,    84,    36,    85,    37,
      38,  -348,    39,     0,    86,     0,    40,    41,     0,     0,
      42,     0,     0,     0,    87,    43,    88,    89,    90,     0,
      91,     8,    45,     0,     0,    46,    47,     0,    92,    48,
      49,    93,     0,     0,    94,     0,     0,     0,     0,    50,
       0,     0,     0,     0,     0,     0,     0,     0,    95,    96,
       0,     0,     0,    97,     0,     0,     0,     0,    98,    99,
       0,     0,     0,     0,    51,    69,    24,    70,    71,    72,
       0,     0,     0,     0,     0,    73,     0,     0,     0,     0,
       0,    74,    75,     0,     0,     0,     0,    25,    77,    26,
       0,     0,     0,    27,    28,     0,    29,     0,     0,     0,
       0,    78,     0,    30,    79,    31,     0,    32,    80,     0,
      81,    33,    82,    35,     0,     0,    83,    84,    36,    85,
      37,    38,  -348,    39,     0,    86,     0,    40,    41,     0,
       0,    42,     0,     0,     0,    87,    43,    88,    89,    90,
       0,    91,     8,    45,     0,     0,    46,    47,     0,    92,
      48,    49,    93,     0,     0,    94,     0,     0,     0,     0,
      50,    69,    24,    70,    71,    72,     0,     0,     0,    95,
      96,    73,     0,     0,    97,     0,     0,    74,    75,    98,
      99,     0,     0,     0,    77,    51,     0,     0,  -633,    27,
      28,     0,     0,     0,     0,     0,     0,    78,  -633,     0,
      79,     0,     0,     0,    80,     0,    81,    33,    82,    35,
       0,     0,    83,    84,    36,    85,    37,     0,  -348,     0,
       0,    86,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    87,     0,    88,    89,    90,     0,    91,     8,     0,
       0,     0,    46,     0,     0,    92,    48,     0,    93,     0,
       0,    94,     0,     0,     0,     0,     0,    69,    24,    70,
      71,    72,     0,     0,     0,    95,    96,    73,     0,     0,
      97,     0,     0,    74,    75,    98,    99,     0,     0,   420,
      77,    51,     0,     0,     0,    27,    28,     0,     0,     0,
       0,     0,     0,    78,     0,     0,    79,     0,     0,     0,
      80,     0,    81,    33,    82,    35,     0,     0,    83,    84,
      36,    85,    37,     0,  -348,     0,     0,    86,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    87,     0,    88,
      89,    90,     0,    91,     8,     0,     0,     0,    46,     0,
       0,    92,    48,     0,    93,     0,     0,    94,     0,     0,
       0,     0,     0,    69,    24,    70,    71,    72,     0,     0,
       0,    95,    96,    73,     0,     0,    97,     0,     0,    74,
      75,    98,    99,     0,  -449,   420,    77,    51,     0,     0,
    -633,    27,    28,     0,     0,     0,     0,     0,     0,    78,
    -633,     0,    79,     0,     0,     0,    80,     0,    81,    33,
      82,    35,     0,     0,    83,    84,    36,    85,    37,     0,
    -348,     0,     0,    86,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    87,     0,    88,    89,    90,     0,    91,
       8,     0,     0,     0,    46,     0,     0,    92,    48,     0,
      93,     0,     0,    94,     0,     0,     0,     0,     0,    69,
      24,    70,    71,    72,     0,     0,     0,    95,    96,    73,
       0,     0,    97,     0,     0,    74,    75,    98,    99,     0,
       0,     0,    77,    51,     0,     0,     0,    27,    28,     0,
       0,     0,     0,     0,     0,    78,     0,     0,    79,     0,
       0,     0,    80,     0,    81,    33,    82,    35,     0,     0,
      83,    84,    36,    85,    37,     0,  -348,     0,     0,    86,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    87,
       0,    88,    89,    90,     0,    91,     8,     0,     0,     0,
      46,     0,     0,    92,    48,     0,    93,     0,     0,    94,
       0,     0,     0,    69,    24,    70,     0,     0,     0,     0,
       0,     0,     0,    95,    96,     0,     0,     0,    97,    74,
      75,     0,     0,    98,    99,     0,    77,     0,     0,    51,
       0,    27,    28,     0,     0,     0,     0,     0,     0,    78,
       0,     0,    79,     0,     0,     0,    80,     0,    81,    33,
      82,    35,     0,     0,    83,    84,    36,    85,    37,     0,
    -348,     0,     0,    86,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    87,     0,    88,    89,    90,     0,    91,
       8,     0,     0,     0,    46,     0,     0,    92,    48,     0,
      93,  -525,     0,    94,     0,     0,  -525,  -525,     0,  -525,
    -525,  -525,  -525,     0,  -525,  -525,  -525,  -525,     0,     0,
       0,     0,  -525,  -525,  -525,     0,     0,    98,     0,     0,
       0,     0,     0,    51,     0,  -525,     0,  -525,  -525,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  -525,     0,     0,  -525,  -525,     0,
    -525,  -525,  -525,     0,     0,     0,     0,     0,  -525,     0,
       0,     0,  -525,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  -525,     0,  -525,  -525,  -525,     0,     0,  -525,
    -525,  -525,  -525,  -525,  -525,  -525,  -525,  -525,  -525,  -525,
    -525,  -525,    24,  -525,  -525,  -525,  -525,  -525,  -525,  -525,
    -525,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    25,     0,    26,     0,     0,     0,    27,
      28,     0,    29,     0,     0,     0,     0,     0,     0,    30,
       0,    31,     0,    32,     0,     0,     0,    33,    82,    35,
       0,     0,     0,     0,    36,     0,    37,    38,     0,    39,
       0,     0,     0,    40,    41,     0,     0,    42,     0,     0,
       0,     0,    43,     0,    44,     0,     0,     0,    24,    45,
       0,     0,    46,    47,     0,     0,    48,    49,     0,     0,
       0,     0,     0,     0,     0,     0,    50,     0,     0,    25,
       0,    26,     0,     0,     0,    27,    28,     0,    29,     0,
       0,     0,     0,     0,   543,    30,    99,    31,     0,    32,
       0,    51,     0,    33,    82,    35,     0,     0,     0,     0,
      36,     0,    37,    38,     0,    39,     0,     0,     0,    40,
      41,     0,     0,    42,     0,     0,    24,     0,    43,     0,
      44,     0,     0,     0,     0,    45,     0,     0,    46,    47,
       0,     0,    48,    49,     0,     0,     0,    25,     0,    26,
       0,     0,    50,    27,    28,     0,    29,     0,     0,     0,
       0,     0,     0,    30,     0,    31,     0,    32,     0,     0,
     543,    33,    82,    35,     0,     0,     0,    51,    36,     0,
      37,    38,     0,    39,     0,     0,     0,    40,    41,     0,
       0,    42,     0,     0,    24,     0,    43,     0,    44,     0,
       0,     0,     0,    45,     0,     0,    46,    47,     0,     0,
      48,    49,     0,     0,     0,    25,     0,    26,     0,     0,
      50,    27,    28,     0,    29,     0,     0,     0,     0,     0,
       0,    30,     0,    31,     0,    32,     0,     0,     0,    33,
      82,    35,   733,     0,     0,    51,    36,     0,    37,    38,
       0,    39,     0,     0,     0,    40,    41,     0,     0,    42,
       0,     0,     0,     0,    43,     0,    44,     0,     0,     0,
      24,    45,     0,     0,    46,    47,     0,     0,    48,    49,
       0,     0,     0,     0,     0,     0,     0,     0,    50,     0,
       0,    25,     0,    26,     0,     0,     0,    27,    28,     0,
      29,     0,     0,     0,     0,     0,     0,    30,    99,    31,
       0,    32,     0,    51,     0,    33,    34,    35,     0,     0,
       0,     0,    36,     0,    37,    38,     0,    39,     0,     0,
       0,    40,    41,     0,     0,    42,     0,     0,    24,     0,
      43,     0,    44,     0,     0,     0,     0,    45,     0,     0,
      46,    47,     0,     0,    48,    49,     0,     0,     0,    25,
       0,    26,     0,     0,    50,    27,    28,     0,    29,     0,
       0,     0,     0,     0,     0,    30,     0,    31,     0,    32,
       0,     0,     0,    33,    82,    35,     0,     0,     0,    51,
      36,     0,    37,    38,     0,    39,     0,     0,     0,    40,
      41,     0,     0,    42,     0,     0,    24,     0,    43,     0,
      44,     0,     0,     0,     0,    45,     0,     0,    46,    47,
       0,     0,    48,    49,     0,     0,     0,    25,     0,   356,
       0,     0,    50,    27,    28,     0,   357,     0,     0,     0,
       0,     0,     0,   358,     0,    31,     0,    32,     0,     0,
       0,    33,    82,    35,     0,     0,     0,    51,    36,     0,
      37,    38,     0,    39,     0,     0,     0,    40,    41,     0,
       0,    42,     0,     0,     0,   833,    43,     0,    44,     0,
       0,     0,     0,    45,   161,     0,    46,    47,     0,     0,
      48,    49,     0,     0,   162,   163,   164,   165,  -393,     0,
      50,   166,     0,   167,   168,   169,   170,     0,   171,   172,
     173,     0,   174,     0,     0,    78,   175,   176,    79,   177,
     178,   179,   180,     0,     0,    51,   509,   182,   183,   184,
      83,    84,   185,    85,   186,   187,   188,   189,     0,     0,
       0,   190,   191,     0,     0,   192,     0,     0,     0,    87,
     193,    88,   194,    90,     0,    91,     0,   195,     0,   196,
     197,   198,     0,    92,     0,   199,    93,   610,     0,    94,
     611,     0,     0,     0,     0,     0,   612,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   613,   614,   615,   616,
       0,  -393,  -393,   617,   618,   619,   620,   621,   622,     0,
     623,   624,   625,     0,   626,     0,     0,   627,   628,   629,
     630,   631,   632,   633,   634,     0,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
       0,     0,     0,   649,   650,     0,     0,   651,     0,     0,
       0,   652,   653,   654,   655,   656,     0,   657,   658,   659,
       0,   660,   661,   662,   663,   664,     0,   665,   666,   667,
     711,   668,     0,     0,     0,   712,     0,     0,     0,   161,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   162,
     163,   164,   165,     0,     0,     0,   166,     0,   167,   168,
     169,   170,     0,   171,   172,   173,     0,   174,     0,     0,
      78,   175,   176,    79,   177,   178,   179,   180,     0,     0,
       0,   713,   182,   183,   184,    83,    84,   185,    85,   186,
     187,   188,   189,     0,     0,     0,   190,   191,     0,     0,
     192,     0,     0,     0,    87,   193,    88,   194,    90,     0,
      91,     0,   195,   240,   196,   197,   198,     0,    92,     0,
     199,    93,   161,     0,    94,     0,     0,     0,     0,     0,
       0,     0,   162,   163,   164,   165,     0,     0,     0,   166,
       0,   167,   168,   169,   170,     0,   171,   172,   173,     0,
     174,     0,     0,    78,   175,   176,    79,   177,   178,   179,
     180,     0,     0,     0,   241,   182,   183,   184,    83,    84,
     242,    85,   186,   187,   188,   189,     0,     0,     0,   190,
     191,     0,     0,   192,     0,     0,     0,    87,   193,    88,
     194,    90,     0,    91,     0,   195,     0,   196,   197,   198,
     161,    92,     0,   199,    93,     0,     0,    94,     0,     0,
     162,   163,   164,   165,     0,     0,     0,   166,     0,   167,
     168,   169,   170,     0,   171,   172,   173,     0,   174,     0,
       0,    78,   175,   176,    79,   177,   178,   179,   180,     0,
       0,     0,   509,   182,   183,   184,    83,    84,   185,    85,
     186,   187,   188,   189,     0,     0,     0,   190,   191,     0,
       0,   192,     0,     0,     0,    87,   193,    88,   194,    90,
       0,    91,     0,   195,     0,   196,   197,   198,   959,    92,
       0,   199,    93,     0,     0,    94,     0,   161,     0,     0,
       0,     0,     0,     0,   231,     0,     0,   162,   163,   164,
     165,     0,     0,     0,   166,     0,   167,   168,   169,   170,
       0,   171,   172,   173,     0,   174,     0,     0,    78,   175,
     176,    79,   177,   178,   179,   180,     0,     0,     0,   960,
     182,   183,   184,    83,    84,   185,    85,   186,   187,   188,
     189,     0,     0,     0,   190,   191,     0,     0,   192,     0,
       0,     0,    87,   193,    88,   194,    90,     0,    91,     0,
     195,  1042,   196,   197,   198,     0,    92,     0,   199,    93,
     161,     0,    94,     0,     0,     0,     0,     0,     0,     0,
     162,   163,   164,   165,     0,     0,     0,   166,     0,   167,
     168,   169,   170,     0,   171,   172,   173,     0,   174,     0,
       0,    78,   175,   176,    79,   177,   178,   179,   180,     0,
       0,     0,   960,   182,   183,   184,    83,    84,   185,    85,
     186,   187,   188,   189,     0,     0,     0,   190,   191,     0,
       0,   192,     0,     0,     0,    87,   193,    88,   194,    90,
       0,    91,     0,   195,   504,   196,   197,   198,     0,    92,
       0,   199,    93,   161,     0,    94,     0,     0,     0,     0,
       0,     0,     0,   162,   163,   164,   165,     0,     0,     0,
       0,     0,     0,   168,   169,   170,     0,   171,   172,     0,
       0,   174,     0,     0,    78,   175,     0,    79,     0,   178,
       0,   180,     0,     0,     0,   505,   182,   183,   184,    83,
      84,     0,    85,   186,     0,   188,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    87,     0,
      88,   194,    90,     0,    91,   828,     0,     0,   196,   197,
       0,     0,    92,     0,   161,    93,     0,     0,    94,     0,
       0,     0,     0,     0,   162,   163,   164,   165,     0,     0,
       0,     0,     0,     0,   168,   169,   170,     0,   171,   172,
       0,     0,   174,     0,     0,    78,   175,     0,    79,     0,
     178,     0,   180,     0,     0,     0,   505,   182,   183,   184,
      83,    84,     0,    85,   186,     0,   188,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    87,
       0,    88,   194,    90,     0,    91,   611,     0,     0,   196,
     197,     0,   612,    92,     0,     0,    93,     0,     0,    94,
       0,     0,   613,   614,   615,   616,     0,     0,     0,   617,
     618,   619,   620,   621,   622,     0,   623,   624,   625,     0,
     626,     0,     0,   627,   628,   629,   630,   631,   632,   633,
     634,     0,   635,   636,   637,   638,   639,   640,   641,   642,
     643,   644,   645,   646,   647,   648,     0,     0,     0,   649,
     650,     0,     0,   651,     0,     0,     0,   652,   653,   654,
     655,   656,     0,   657,   658,   659,     0,   660,   661,   662,
     663,   664,   161,   665,   666,   667,     0,   668,     0,     0,
       0,     0,   162,   163,   164,   165,     0,     0,     0,   166,
       0,   167,   168,   169,   170,     0,   171,   172,   173,     0,
     174,     0,     0,    78,   175,   176,    79,   177,   178,   179,
     180,     0,     0,     0,   181,   182,   183,   184,    83,    84,
     185,    85,   186,   187,   188,   189,     0,     0,     0,   190,
     191,     0,     0,   192,     0,     0,     0,    87,   193,    88,
     194,    90,     0,    91,     0,   195,     0,   196,   197,   198,
     161,    92,     0,   199,    93,     0,     0,    94,     0,     0,
     162,   163,   164,   165,     0,     0,     0,   166,     0,   167,
     168,   169,   170,     0,   171,   172,   173,     0,   174,     0,
       0,    78,   175,   176,    79,   177,   178,   179,   180,     0,
       0,     0,   389,   182,   183,   184,    83,    84,   185,    85,
     186,   187,   188,   189,     0,     0,     0,   190,   191,     0,
       0,   192,     0,     0,     0,    87,   193,    88,   194,    90,
       0,    91,     0,   195,     0,   196,   197,   198,   161,    92,
       0,   199,    93,     0,     0,    94,     0,     0,   162,   163,
     164,   165,     0,     0,     0,   166,     0,   167,   168,   169,
     170,     0,   171,   172,   173,     0,   174,     0,     0,    78,
     175,   176,    79,   177,   178,   179,   180,     0,     0,     0,
     395,   182,   183,   184,    83,    84,   185,    85,   186,   187,
     188,   189,     0,     0,     0,   190,   191,     0,     0,   192,
       0,     0,     0,    87,   193,    88,   194,    90,     0,    91,
       0,   195,     0,   196,   197,   198,   161,    92,     0,   199,
      93,     0,     0,    94,     0,     0,   162,   163,   164,   165,
       0,     0,     0,   166,     0,   167,   168,   169,   170,     0,
     171,   172,   173,     0,   174,     0,     0,    78,   175,   176,
      79,   177,   178,   179,   180,     0,     0,     0,   401,   182,
     183,   184,    83,    84,   185,    85,   186,   187,   188,   189,
       0,     0,     0,   190,   191,     0,     0,   192,     0,     0,
       0,    87,   193,    88,   194,    90,     0,    91,     0,   195,
       0,   196,   197,   198,   161,    92,     0,   199,    93,     0,
       0,    94,     0,     0,   162,   163,   164,   165,     0,     0,
       0,   166,     0,   167,   168,   169,   170,     0,   171,   172,
     173,     0,   174,     0,     0,    78,   175,   176,    79,   177,
     178,   179,   180,     0,     0,     0,   403,   182,   183,   184,
      83,    84,   185,    85,   186,   187,   188,   189,     0,     0,
       0,   190,   191,     0,     0,   192,     0,     0,     0,    87,
     193,    88,   194,    90,     0,    91,     0,   195,     0,   196,
     197,   198,  -220,    92,     0,   199,    93,     0,     0,    94,
       0,     0,  -220,  -220,  -220,  -220,     0,     0,     0,  -220,
       0,  -220,  -220,  -220,  -220,     0,  -220,  -220,  -220,     0,
    -220,     0,     0,  -220,  -220,  -220,  -220,  -220,  -220,  -220,
    -220,     0,     0,     0,  -220,  -220,  -220,  -220,  -220,  -220,
    -220,  -220,  -220,  -220,  -220,  -220,     0,     0,     0,  -220,
    -220,     0,     0,  -220,     0,     0,     0,  -220,  -220,  -220,
    -220,  -220,     0,  -220,     0,  -220,     0,  -220,  -220,  -220,
     161,  -220,     0,  -220,  -220,     0,     0,  -220,     0,     0,
     162,   163,   164,   165,     0,     0,     0,   166,     0,   167,
     168,   169,   170,     0,   171,   172,   173,     0,   174,     0,
       0,    78,   175,   176,    79,   177,   178,   179,   180,     0,
       0,     0,   509,   182,   183,   184,    83,    84,   185,    85,
     186,   187,   188,   189,     0,     0,     0,   190,   191,     0,
       0,   192,     0,     0,     0,    87,   193,    88,   194,    90,
       0,    91,     0,   195,     0,   196,   197,   198,   161,    92,
       0,   199,    93,     0,     0,    94,     0,     0,   162,   163,
     164,   165,     0,     0,     0,   166,     0,   167,   168,   169,
     170,     0,   171,   172,   173,     0,   174,     0,     0,    78,
     175,   176,    79,   177,   178,   179,   180,     0,     0,     0,
     512,   182,   183,   184,    83,    84,   185,    85,   186,   187,
     188,   189,     0,     0,     0,   190,   191,     0,     0,   192,
       0,     0,     0,    87,   193,    88,   194,    90,     0,    91,
       0,   195,     0,   196,   197,   198,   161,    92,     0,   199,
      93,     0,     0,    94,     0,     0,   162,   163,   164,   165,
       0,     0,     0,   166,     0,   167,   168,   169,   170,     0,
     171,   172,   173,     0,   174,     0,     0,    78,   175,   176,
      79,   177,   178,   179,   180,     0,     0,     0,   573,   182,
     183,   184,    83,    84,   185,    85,   186,   187,   188,   189,
       0,     0,     0,   190,   191,     0,     0,   192,     0,     0,
       0,    87,   193,    88,   194,    90,     0,    91,     0,   195,
       0,   196,   197,   198,   161,    92,     0,   199,    93,     0,
       0,    94,     0,     0,   162,   163,   164,   165,     0,     0,
       0,   166,     0,   167,   168,   169,   170,     0,   171,   172,
     173,     0,   174,     0,     0,    78,   175,   176,    79,   177,
     178,   179,   180,     0,     0,     0,   725,   182,   183,   184,
      83,    84,   185,    85,   186,   187,   188,   189,     0,     0,
       0,   190,   191,     0,     0,   192,     0,     0,     0,    87,
     193,    88,   194,    90,     0,    91,     0,   195,     0,   196,
     197,   198,   161,    92,     0,   199,    93,     0,     0,    94,
       0,     0,   162,   163,   164,   165,     0,     0,     0,   166,
       0,   167,   168,   169,   170,     0,   171,   172,   173,     0,
     174,     0,     0,    78,   175,   176,    79,   177,   178,   179,
     180,     0,     0,     0,   844,   182,   183,   184,    83,    84,
     185,    85,   186,   187,   188,   189,     0,     0,     0,   190,
     191,     0,     0,   192,     0,     0,     0,    87,   193,    88,
     194,    90,     0,    91,     0,   195,     0,   196,   197,   198,
     161,    92,     0,   199,    93,     0,     0,    94,     0,     0,
     162,   163,   164,   165,     0,     0,     0,   166,     0,   167,
     168,   169,   170,     0,   171,   172,   173,     0,   174,     0,
       0,    78,   175,   176,    79,   177,   178,   179,   180,     0,
       0,     0,   980,   182,   183,   184,    83,    84,   185,    85,
     186,   187,   188,   189,     0,     0,     0,   190,   191,     0,
       0,   192,     0,     0,     0,    87,   193,    88,   194,    90,
       0,    91,     0,   195,     0,   196,   197,   198,   161,    92,
       0,   199,    93,     0,     0,    94,     0,     0,   162,   163,
     164,   165,     0,     0,     0,   166,     0,   167,   168,   169,
     170,     0,   171,   172,   173,     0,   174,     0,     0,    78,
     175,   176,    79,   177,   178,   179,   180,     0,     0,     0,
    1077,   182,   183,   184,    83,    84,   185,    85,   186,   187,
     188,   189,     0,     0,     0,   190,   191,     0,     0,   192,
       0,     0,     0,    87,   193,    88,   194,    90,     0,    91,
       0,   195,     0,   196,   197,   198,     0,    92,     0,   199,
      93,     0,     0,    94
};

static const yytype_int16 yycheck[] =
{
       6,   354,     2,    80,   101,    27,     2,   269,     2,   379,
     348,    67,   441,   355,   455,   214,    71,    72,   220,   254,
     353,   263,   678,   231,   147,   224,   866,   100,   974,   689,
     400,     1,   605,     1,     1,     7,     1,     1,   100,   101,
       1,    63,    24,     6,    27,   287,     1,     1,    24,     1,
     688,   971,   690,   423,   289,   969,   694,    24,   113,   848,
      73,   431,     1,    24,     1,   915,     0,   917,     1,   980,
     984,     7,     1,    64,    10,    52,  1022,     1,    73,   929,
      63,   137,    95,    96,    97,  1071,   148,     1,     3,    33,
     104,   104,   105,     7,     6,   101,   885,  1017,     1,     1,
      95,    96,    97,     1,  1018,   100,   101,    24,   122,   104,
     105,     1,   119,   883,  1025,   818,    24,   777,   113,   104,
     776,    24,    24,    12,    13,    39,    40,   104,   831,  1049,
    1116,   122,   102,   115,   984,   117,   121,   102,   110,     3,
     122,   109,    24,   119,     8,     9,   152,  1093,   154,   119,
     118,   157,  1066,  1099,  1100,   119,  1070,   124,  1072,  1073,
     124,   115,   116,   124,   119,   101,   118,   264,   824,  1115,
     122,  1117,   269,   246,    24,   252,   546,  1123,  1028,   752,
     119,   125,   119,   821,  1098,    99,   119,   249,   826,   152,
     119,   154,   391,  1033,   157,   119,   110,   109,   115,   205,
     206,   223,   264,   139,   119,   120,   228,   269,   122,   117,
     216,   109,   115,   235,   220,   237,   451,   459,   107,   108,
     118,   124,   992,    24,   122,   231,   434,   233,   118,   999,
       6,    10,    24,   115,  1084,   117,   291,    60,     4,    24,
     223,   104,   205,   206,   119,   228,   104,  1097,   254,    24,
     323,   246,   235,   216,   237,   119,   120,   220,   264,   122,
    1110,     6,   953,   269,   122,   115,    32,   117,   102,   264,
     233,    33,    64,    52,   269,   104,    42,  1076,    65,   292,
     293,   294,    33,   289,    60,   119,    24,   116,  1087,   112,
      56,   227,    93,    39,    40,    24,    33,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   251,   372,    24,    64,    85,
     522,   115,   258,   115,   118,   117,   861,   263,   264,   351,
     122,   387,   117,   269,   775,   149,    24,   122,   125,   780,
     115,    65,   117,     1,   441,   947,   121,   122,  1039,     7,
    1026,   287,   722,   289,   116,   119,   101,   556,   124,    65,
     366,   861,     1,   119,    32,   348,   699,   350,   351,   702,
     116,   354,   705,   379,    42,   381,   119,   115,   384,   117,
    1056,    39,    40,   102,   122,    24,   115,     1,   117,   325,
      33,   109,   414,     7,   400,   331,   115,    39,    40,   118,
      24,   125,   104,   366,   122,   460,   906,   152,   115,   154,
     117,   116,   157,   118,   116,   122,   379,   353,   381,   125,
     122,   384,    24,    24,    10,    39,    40,   115,   434,   117,
     119,   414,  1034,  1035,   122,   441,   789,   400,   104,   974,
     119,    99,  1030,  1031,    24,   451,   441,    33,   786,   119,
     116,   693,   110,   688,   895,   690,   122,   992,   116,   694,
     205,   206,   104,   102,    24,   460,    52,   281,   282,   118,
     284,   216,     6,   122,   974,   220,   115,    52,   117,   118,
      32,    24,   121,   122,   420,    99,   231,  1022,   233,  1077,
      42,   115,   992,   117,   516,   865,   110,   119,   122,    33,
     436,   102,   118,    33,   526,   441,   122,   123,   119,   254,
      33,   104,   326,   115,   115,   117,   117,   523,   524,   264,
     122,   521,  1022,   459,   269,   521,    60,   521,   534,   122,
     971,   104,   538,   516,   104,   115,   878,   117,    24,   115,
     116,    64,   122,   526,   289,   109,   110,   880,   104,   122,
     104,   119,   122,    39,    40,   115,   116,   117,  1093,   102,
     523,   524,    33,    19,  1099,  1100,   122,   503,   122,    25,
      26,   534,   115,   119,   117,   538,   104,   947,   104,   102,
    1115,    37,  1117,   104,   104,   104,   821,    11,  1123,    33,
      14,   826,   115,  1093,   122,   118,   122,   950,   892,  1099,
    1100,   122,   122,   122,   418,   899,   115,   901,   902,   118,
      66,    16,    17,    69,    70,  1115,    72,  1117,    74,   115,
     115,   366,   118,  1123,    80,   116,   996,   118,    84,   115,
     116,   117,   568,   116,   379,   118,   381,    62,    94,   384,
     965,   115,   456,   457,   118,   101,   102,   103,    39,    40,
     975,   587,   977,   978,    73,   400,   115,   593,   106,   118,
     895,    39,    40,   599,   105,  1094,  1095,   603,  1081,   931,
     104,   607,  1085,  1086,   123,  1008,    18,    27,  1011,    29,
     736,  1014,   688,  1096,   690,  1114,    36,   115,   694,   434,
      96,    97,    98,    43,    52,    45,   441,    47,    52,   299,
     300,   301,   302,   111,   112,   113,   451,   102,  1121,    39,
      40,    61,    33,    63,    96,    97,    98,    67,    68,   122,
     123,    71,   933,   934,  1034,  1035,    76,    71,    72,   295,
     296,    33,   754,    83,   969,   297,   298,    87,   861,    33,
      52,    91,   303,   304,   118,   121,     1,     6,   118,   984,
     100,   116,   104,   119,   690,   119,     4,   693,   694,   695,
       7,   104,   122,   699,   117,   122,   702,   122,   102,   705,
     118,   754,    52,   122,   121,   797,   122,   118,   523,   524,
     118,   121,   121,  1018,   102,   122,   792,   102,   121,   534,
     115,   868,   124,   538,   122,   115,   118,   803,   804,   102,
     124,   118,   102,   786,    64,   121,   789,   116,   122,   122,
     816,   122,   122,   121,   797,   821,   122,   121,     6,    65,
     826,   816,   119,   122,   830,     1,   122,    24,   102,   792,
     119,  1066,   102,   118,   931,  1070,   102,  1072,  1073,   102,
     803,   804,   848,   849,   122,   121,   121,   118,    10,   122,
     119,   974,   116,   848,   122,   861,    64,   122,   102,   102,
     116,    52,   798,  1098,   121,   102,   119,   830,   890,   992,
     122,    41,  1039,   809,   119,   115,   953,   813,   692,   885,
     119,   119,   786,   119,   991,   907,   849,   532,   146,   895,
     885,   994,   533,   152,   230,   154,    45,    43,   157,  1022,
     906,   160,   400,   797,     7,   841,   754,   890,  1013,   942,
     896,   830,   930,   873,   233,   950,   827,    19,  1095,  1114,
     587,   593,   291,   306,   907,   931,   305,   933,   934,   309,
     307,  1116,   128,   308,    63,    -1,   931,    -1,   933,   934,
      -1,    -1,    -1,   688,   880,   690,   205,   206,   948,   694,
      -1,   252,   948,    -1,   948,   769,    -1,   216,    -1,    -1,
      -1,   220,  1039,   969,    -1,    -1,    -1,   950,   974,   991,
    1093,    -1,   231,    -1,   233,    -1,  1099,  1100,   984,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   992,    -1,   994,    -1,
      -1,  1013,  1115,    -1,  1117,   931,    -1,  1094,  1095,  1076,
    1123,    -1,    -1,    -1,    -1,    -1,     6,    -1,   991,    -1,
    1087,    -1,  1018,    -1,    -1,    -1,  1022,  1114,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1013,   994,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1062,    -1,    -1,    -1,    -1,     6,  1029,   792,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   803,   804,
    1066,    -1,    -1,    -1,  1070,  1071,  1072,  1073,    -1,    -1,
      -1,   816,  1008,    -1,    -1,  1011,   821,    -1,  1014,  1062,
      -1,   826,    -1,    -1,   898,   830,    -1,  1093,  1094,  1095,
      -1,    -1,  1098,  1099,  1100,    -1,    -1,    -1,    -1,  1094,
    1095,    -1,    -1,   848,   849,    -1,    -1,   366,  1114,  1115,
    1116,  1117,    -1,    28,    -1,    -1,   861,  1123,    -1,  1114,
     379,    -1,   381,    -1,    -1,   384,    -1,    -1,    -1,    44,
      -1,  1067,    -1,    -1,    -1,    50,    -1,    -1,    -1,    -1,
     885,   400,    57,    58,    59,    -1,    -1,    -1,    -1,    -1,
     895,    -1,   152,    -1,   154,    -1,    -1,   157,  1094,  1095,
      75,   906,    77,    -1,    79,    -1,    81,    -1,    -1,    -1,
      -1,    -1,   986,    88,    89,   434,    -1,    92,  1114,    -1,
      95,    -1,    -1,    -1,    -1,    -1,   931,    -1,   933,   934,
      -1,   152,    -1,   154,    -1,    -1,   157,    -1,    -1,    -1,
      -1,  1015,  1016,    -1,    -1,   205,   206,  1021,    -1,  1023,
    1024,    -1,    -1,    -1,    -1,    -1,   216,    -1,    -1,    -1,
     220,    -1,    -1,    -1,   969,    -1,    -1,    -1,    -1,   974,
      -1,   231,    -1,   233,    -1,    -1,    -1,    -1,    -1,   984,
      -1,    -1,    -1,    -1,   205,   206,    -1,   992,    -1,   994,
      -1,    -1,    -1,    -1,    -1,   216,    -1,    -1,    -1,   220,
      -1,    -1,    -1,   522,   523,   524,    -1,    -1,    -1,    -1,
     231,    -1,   233,  1018,    -1,   534,    -1,  1022,   537,   538,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1066,    -1,    -1,    -1,  1070,  1071,  1072,  1073,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1093,  1094,
    1095,    -1,    -1,  1098,  1099,  1100,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   366,    -1,    -1,  1114,
    1115,  1116,  1117,    -1,    -1,    -1,    -1,    -1,  1123,   379,
      -1,   381,    -1,    -1,   384,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     400,    -1,    -1,    -1,    -1,   366,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   379,    -1,
     381,    -1,    -1,   384,    -1,     0,     1,    -1,    -1,     4,
      -1,     6,    -1,    -1,   434,    -1,    -1,    -1,    -1,   400,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    24,
      -1,    -1,    27,    28,    29,    -1,    -1,    32,    33,    34,
      -1,    36,    -1,    -1,    -1,    -1,    -1,    42,    43,    44,
      45,    -1,    47,   434,    49,    50,    51,    52,    53,    -1,
      55,    56,    57,    58,    59,    60,    61,    -1,    63,    -1,
      -1,    -1,    67,    68,    -1,    -1,    71,    -1,    -1,    -1,
      75,    76,    77,    78,    79,    -1,    81,    82,    83,    -1,
      85,    86,    87,    88,    89,    90,    91,    92,    -1,    -1,
      95,    -1,    -1,   523,   524,   100,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   792,   534,    -1,    -1,    -1,   538,    -1,
     115,    -1,    -1,    -1,   803,   804,    -1,    -1,   123,   124,
     125,    -1,    -1,    -1,    -1,    -1,    -1,   816,    -1,    -1,
      -1,    -1,   523,   524,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   830,    -1,   534,    -1,    -1,    -1,   538,     1,    -1,
      -1,     4,     5,     6,     7,     8,     9,    10,    -1,   848,
     849,    -1,    15,    -1,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    -1,    -1,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    -1,    38,    -1,    -1,    41,    42,
      43,    44,    45,    46,    47,    48,   885,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    -1,    65,    -1,    67,    68,    -1,   906,    71,    -1,
      -1,    -1,    75,    76,    77,    78,    79,    -1,    81,    82,
      83,    -1,    -1,    86,    87,    -1,    89,    90,    91,    92,
      93,    -1,    95,    -1,   933,   934,    -1,   100,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   109,   110,    -1,    -1,
      -1,   114,   115,    -1,   117,    -1,   119,   120,    -1,     1,
      -1,   124,   125,     5,     6,     7,     8,     9,    -1,    -1,
      -1,    -1,    -1,    15,    -1,    -1,    -1,    -1,    -1,    21,
      22,    -1,    24,    -1,    -1,    27,    28,    29,    -1,    -1,
      32,    33,    34,    -1,    36,   994,    -1,    39,    40,    41,
      42,    43,    44,    45,    -1,    47,    48,    -1,    50,    51,
      52,    53,    -1,    -1,    56,    57,    58,    59,    60,    61,
      62,    63,    -1,    65,    -1,    67,    68,    -1,    -1,    71,
      -1,    -1,    -1,    75,    76,    77,    78,    79,    -1,    81,
      82,    83,    -1,    -1,    86,    87,    -1,    89,    90,    91,
      92,    -1,   792,    95,    -1,    -1,    -1,    -1,   100,    -1,
      -1,    -1,    -1,   803,   804,    -1,   108,   109,   110,   111,
      -1,    -1,   114,    -1,    -1,    -1,   816,   119,   120,    -1,
      -1,    -1,    -1,   125,    -1,    -1,    -1,    -1,    -1,    -1,
     830,   792,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   803,   804,    -1,    -1,    -1,    -1,   848,   849,
      -1,    -1,    -1,    -1,    -1,   816,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   830,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   885,    -1,   848,   849,     1,
      -1,    -1,    -1,     5,     6,     7,     8,     9,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    21,
      22,    -1,    -1,    -1,    -1,    -1,    28,    -1,    -1,    -1,
      32,    33,    34,    -1,   885,    -1,    -1,    -1,    -1,    41,
      42,    -1,    44,   933,   934,    -1,    48,    -1,    50,    51,
      52,    53,    -1,    -1,    56,    57,    58,    59,    60,    -1,
      62,    -1,    -1,    65,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    75,    -1,    77,    78,    79,    -1,    81,
      82,    -1,   933,   934,    86,    -1,    -1,    89,    90,    -1,
      92,    -1,    -1,    95,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   994,     1,    -1,    -1,     4,     5,
       6,     7,     8,     9,    10,    -1,    -1,   119,    -1,    15,
      -1,    -1,    -1,   125,    20,    21,    22,    23,    -1,    -1,
      -1,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    -1,    38,   994,    -1,    41,    42,    43,    44,    45,
      46,    47,    48,    -1,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    -1,    65,
      -1,    67,    68,    -1,    -1,    71,    -1,    -1,    -1,    75,
      76,    77,    78,    79,    -1,    81,    82,    83,    -1,    -1,
      86,    87,    -1,    89,    90,    91,    92,    93,    -1,    95,
      -1,    -1,    -1,    -1,   100,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   109,   110,    -1,    -1,    -1,   114,   115,
      -1,    -1,    -1,   119,   120,    -1,     1,    -1,   124,   125,
       5,     6,     7,     8,     9,    -1,    -1,    -1,    -1,    -1,
      15,    -1,    -1,    -1,    -1,    -1,    21,    22,    -1,    24,
      -1,    -1,    27,    28,    29,    -1,    -1,    32,    33,    34,
      -1,    36,    -1,    -1,    -1,    -1,    41,    42,    43,    44,
      45,    -1,    47,    48,    -1,    50,    51,    52,    53,    -1,
      -1,    56,    57,    58,    59,    60,    61,    62,    63,    -1,
      65,    -1,    67,    68,    -1,    -1,    71,    -1,    -1,    -1,
      75,    76,    77,    78,    79,    -1,    81,    82,    83,    -1,
      -1,    86,    87,    -1,    89,    90,    91,    92,    -1,    -1,
      95,    -1,    -1,    -1,    -1,   100,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   109,   110,    -1,    -1,    -1,   114,
     115,   116,   117,    -1,   119,   120,    -1,     1,    -1,    -1,
     125,     5,     6,     7,     8,     9,    -1,    -1,    -1,    -1,
      -1,    15,    -1,    -1,    -1,    -1,    -1,    21,    22,    -1,
      24,    -1,    -1,    27,    28,    29,    -1,    -1,    32,    33,
      34,    -1,    36,    -1,    -1,    -1,    -1,    41,    42,    43,
      44,    45,    -1,    47,    48,    -1,    50,    51,    52,    53,
      -1,    -1,    56,    57,    58,    59,    60,    61,    62,    63,
      -1,    65,    -1,    67,    68,    -1,    -1,    71,    -1,    -1,
      -1,    75,    76,    77,    78,    79,    -1,    81,    82,    83,
      -1,    -1,    86,    87,    -1,    89,    90,    91,    92,    -1,
      -1,    95,    -1,    -1,    -1,    -1,   100,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   109,   110,    -1,    -1,    -1,
     114,    -1,    -1,   117,    -1,   119,   120,    -1,   122,     1,
      -1,   125,    -1,     5,     6,     7,     8,     9,    -1,    -1,
      -1,    -1,    -1,    15,    -1,    -1,    -1,    -1,    -1,    21,
      22,    -1,    24,    -1,    -1,    27,    28,    29,    -1,    -1,
      32,    33,    34,    -1,    36,    -1,    -1,    -1,    -1,    41,
      42,    43,    44,    45,    -1,    47,    48,    -1,    50,    51,
      52,    53,    -1,    -1,    56,    57,    58,    59,    60,    61,
      62,    63,    -1,    65,    -1,    67,    68,    -1,    -1,    71,
      -1,    -1,    -1,    75,    76,    77,    78,    79,    -1,    81,
      82,    83,    -1,    -1,    86,    87,    -1,    89,    90,    91,
      92,    -1,    -1,    95,    -1,    -1,    -1,    -1,   100,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,   110,    -1,
      -1,    -1,   114,    -1,    -1,   117,    -1,   119,   120,    -1,
     122,     1,    -1,   125,    -1,     5,     6,     7,     8,     9,
      -1,    -1,    -1,    -1,    -1,    15,    -1,    -1,    -1,    -1,
      -1,    21,    22,    -1,    -1,    -1,    -1,    27,    28,    29,
      -1,    -1,    32,    33,    34,    -1,    36,    -1,    -1,    39,
      40,    41,    42,    43,    44,    45,    -1,    47,    48,    -1,
      50,    51,    52,    53,    -1,    -1,    56,    57,    58,    59,
      60,    61,    62,    63,    -1,    65,    -1,    67,    68,    -1,
      -1,    71,    -1,    -1,    -1,    75,    76,    77,    78,    79,
      -1,    81,    82,    83,    -1,    -1,    86,    87,    -1,    89,
      90,    91,    92,    -1,    -1,    95,    -1,    -1,    -1,    -1,
     100,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,
     110,    -1,    -1,    -1,   114,    -1,    -1,    -1,    -1,   119,
     120,    -1,     1,    -1,    -1,   125,     5,     6,     7,     8,
       9,    -1,    -1,    -1,    -1,    -1,    15,    -1,    -1,    -1,
      -1,    -1,    21,    22,    -1,    24,    -1,    -1,    27,    28,
      29,    -1,    -1,    32,    33,    34,    -1,    36,    -1,    -1,
      -1,    -1,    41,    42,    43,    44,    45,    -1,    47,    48,
      -1,    50,    51,    52,    53,    -1,    -1,    56,    57,    58,
      59,    60,    61,    62,    63,    -1,    65,    -1,    67,    68,
      -1,    -1,    71,    -1,    -1,    -1,    75,    76,    77,    78,
      79,    -1,    81,    82,    83,    -1,    -1,    86,    87,    -1,
      89,    90,    91,    92,    -1,    -1,    95,    -1,    -1,    -1,
      -1,   100,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     109,   110,    -1,    -1,    -1,   114,   115,    -1,    -1,    -1,
     119,   120,    -1,     1,    -1,    -1,   125,     5,     6,     7,
       8,     9,    -1,    -1,    -1,    -1,    -1,    15,    -1,    -1,
      -1,    -1,    -1,    21,    22,    -1,    24,    -1,    -1,    27,
      28,    29,    -1,    -1,    32,    33,    34,    -1,    36,    -1,
      -1,    -1,    -1,    41,    42,    43,    44,    45,    -1,    47,
      48,    -1,    50,    51,    52,    53,    -1,    -1,    56,    57,
      58,    59,    60,    61,    62,    63,    -1,    65,    -1,    67,
      68,    -1,    -1,    71,    -1,    -1,    -1,    75,    76,    77,
      78,    79,    -1,    81,    82,    83,    -1,    -1,    86,    87,
      -1,    89,    90,    91,    92,    -1,    -1,    95,    -1,    -1,
      -1,    -1,   100,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   109,   110,    -1,    -1,    -1,   114,   115,    -1,    -1,
      -1,   119,   120,    -1,     1,    -1,    -1,   125,     5,     6,
       7,     8,     9,    -1,    -1,    -1,    -1,    -1,    15,    -1,
      -1,    -1,    -1,    -1,    21,    22,    -1,    24,    -1,    -1,
      27,    28,    29,    -1,    -1,    32,    33,    34,    -1,    36,
      -1,    -1,    -1,    -1,    41,    42,    43,    44,    45,    -1,
      47,    48,    -1,    50,    51,    52,    53,    -1,    -1,    56,
      57,    58,    59,    60,    61,    62,    63,    -1,    65,    -1,
      67,    68,    -1,    -1,    71,    -1,    -1,    -1,    75,    76,
      77,    78,    79,    -1,    81,    82,    83,    -1,    -1,    86,
      87,    -1,    89,    90,    91,    92,    -1,    -1,    95,    -1,
      -1,    -1,    -1,   100,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   109,   110,    -1,    -1,    -1,   114,   115,    -1,
      -1,    -1,   119,   120,    -1,     1,    -1,    -1,   125,     5,
       6,     7,     8,     9,    -1,    -1,    -1,    -1,    -1,    15,
      -1,    -1,    -1,    -1,    -1,    21,    22,    -1,    -1,    -1,
      -1,    27,    28,    29,    -1,    -1,    32,    33,    34,    -1,
      36,    -1,    -1,    -1,    -1,    41,    42,    43,    44,    45,
      -1,    47,    48,    -1,    50,    51,    52,    53,    -1,    -1,
      56,    57,    58,    59,    60,    61,    62,    63,    -1,    65,
      -1,    67,    68,    -1,    -1,    71,    -1,    -1,    -1,    75,
      76,    77,    78,    79,    -1,    81,    82,    83,    -1,    -1,
      86,    87,    -1,    89,    90,    91,    92,    -1,    -1,    95,
      -1,    -1,    -1,    -1,   100,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   109,   110,    -1,    -1,    -1,   114,    -1,
      -1,    -1,    -1,   119,   120,    -1,     1,    -1,   124,   125,
       5,     6,     7,     8,     9,    -1,    -1,    -1,    -1,    -1,
      15,    -1,    -1,    -1,    -1,    -1,    21,    22,    -1,    -1,
      -1,    -1,    27,    28,    29,    -1,    -1,    32,    33,    34,
      -1,    36,    -1,    -1,    -1,    -1,    41,    42,    43,    44,
      45,    -1,    47,    48,    -1,    50,    51,    52,    53,    -1,
      -1,    56,    57,    58,    59,    60,    61,    62,    63,    -1,
      65,    -1,    67,    68,    -1,    -1,    71,    -1,    -1,    -1,
      75,    76,    77,    78,    79,    -1,    81,    82,    83,    -1,
      -1,    86,    87,    -1,    89,    90,    91,    92,    -1,    -1,
      95,    -1,    -1,    -1,    -1,   100,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   109,   110,    -1,    -1,    -1,   114,
     115,    -1,    -1,    -1,   119,   120,    -1,     1,    -1,    -1,
     125,     5,     6,     7,     8,     9,    -1,    -1,    -1,    -1,
      -1,    15,    -1,    -1,    -1,    -1,    -1,    21,    22,    -1,
      -1,    -1,    -1,    27,    28,    29,    -1,    -1,    32,    33,
      34,    -1,    36,    -1,    -1,    -1,    -1,    41,    42,    43,
      44,    45,    -1,    47,    48,    -1,    50,    51,    52,    53,
      -1,    -1,    56,    57,    58,    59,    60,    61,    62,    63,
      -1,    65,    -1,    67,    68,    -1,    -1,    71,    -1,    -1,
      -1,    75,    76,    77,    78,    79,    -1,    81,    82,    83,
      -1,    -1,    86,    87,    -1,    89,    90,    91,    92,    -1,
      -1,    95,    -1,    -1,    -1,    -1,   100,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   109,   110,    -1,    -1,    -1,
     114,    -1,    -1,    -1,    -1,   119,   120,    -1,     1,    -1,
      -1,   125,     5,     6,     7,     8,     9,    -1,    -1,    -1,
      -1,    -1,    15,    -1,    -1,    -1,    -1,    -1,    21,    22,
      -1,    -1,    -1,    -1,    27,    28,    29,    -1,    -1,    32,
      33,    34,    -1,    36,    -1,    -1,    -1,    -1,    41,    42,
      43,    44,    45,    -1,    47,    48,    -1,    50,    51,    52,
      53,    -1,    -1,    56,    57,    58,    59,    60,    61,    62,
      63,    -1,    65,    -1,    67,    68,    -1,    -1,    71,    -1,
      -1,    -1,    75,    76,    77,    78,    79,    -1,    81,    82,
      83,    -1,    -1,    86,    87,    -1,    89,    90,    91,    92,
      -1,    -1,    95,    -1,    -1,    -1,    -1,   100,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   109,   110,    -1,    -1,
      -1,   114,    -1,    -1,    -1,    -1,   119,   120,    -1,     1,
      -1,    -1,   125,     5,     6,     7,     8,     9,    -1,    -1,
      -1,    -1,    -1,    15,    -1,    -1,    -1,    -1,    -1,    21,
      22,    -1,    -1,    -1,    -1,    27,    28,    29,    -1,    -1,
      32,    33,    34,    -1,    36,    -1,    -1,    -1,    -1,    41,
      42,    43,    44,    45,    -1,    47,    48,    -1,    50,    51,
      52,    53,    -1,    -1,    56,    57,    58,    59,    60,    61,
      62,    63,    -1,    65,    -1,    67,    68,    -1,    -1,    71,
      -1,    -1,    -1,    75,    76,    77,    78,    79,    -1,    81,
      82,    83,    -1,    -1,    86,    87,    -1,    89,    90,    91,
      92,    -1,    -1,    95,    -1,    -1,    -1,    -1,   100,     1,
      -1,    -1,     4,    -1,     6,    -1,    -1,   109,   110,    -1,
      -1,    -1,   114,    -1,    -1,    -1,    -1,   119,   120,    -1,
      -1,    -1,    24,   125,    -1,    27,    28,    29,    -1,    -1,
      32,    33,    34,    -1,    36,    -1,    -1,    -1,    -1,    -1,
      42,    43,    44,    45,    -1,    47,    -1,    49,    50,    51,
      52,    53,    -1,    55,    56,    57,    58,    59,    60,    61,
      -1,    63,    -1,    -1,    -1,    67,    68,    -1,    -1,    71,
      -1,    -1,    -1,    75,    76,    77,    78,    79,    -1,    81,
      82,    83,    -1,    85,    86,    87,    88,    89,    90,    91,
      92,    -1,    -1,    95,    -1,    -1,    -1,    -1,   100,    -1,
      -1,     1,    -1,    -1,     4,    -1,     6,    -1,    -1,    -1,
      -1,    -1,    -1,   115,    -1,   117,    -1,    -1,    -1,    -1,
      -1,   123,   124,   125,    24,    -1,    -1,    27,    28,    29,
      -1,    -1,    32,    33,    34,    -1,    36,    -1,    -1,    -1,
      -1,    -1,    42,    43,    44,    45,    -1,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    57,    58,    59,
      60,    61,    -1,    63,    -1,    -1,    -1,    67,    68,    -1,
      -1,    71,    -1,    -1,    -1,    75,    76,    77,    78,    79,
      -1,    81,    82,    83,    -1,    85,    86,    87,    88,    89,
      90,    91,    92,    -1,    -1,    95,    -1,    -1,    -1,     1,
     100,    -1,    -1,     5,     6,     7,     8,     9,    -1,    -1,
      -1,    -1,    -1,    15,    -1,   115,    -1,   117,    -1,    21,
      22,    -1,    -1,   123,   124,   125,    28,    -1,    -1,    -1,
      32,    33,    34,    -1,    -1,    -1,    -1,    -1,    -1,    41,
      42,    -1,    44,    -1,    -1,    -1,    48,    -1,    50,    51,
      52,    53,    -1,    -1,    56,    57,    58,    59,    60,    -1,
      62,    -1,    64,    65,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    75,    -1,    77,    78,    79,    -1,    81,
      82,    -1,    -1,    -1,    86,    -1,    -1,    89,    90,    -1,
      92,    -1,    -1,    95,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,   110,    -1,
      -1,    -1,   114,    -1,    -1,    -1,    -1,   119,   120,    -1,
     122,   123,     1,   125,    -1,     4,     5,     6,     7,     8,
       9,    -1,    -1,    -1,    -1,    -1,    15,    -1,    -1,    -1,
      -1,    -1,    21,    22,    -1,    24,    -1,    -1,    -1,    28,
      -1,    -1,    -1,    32,    33,    34,    -1,    -1,    -1,    -1,
      -1,    -1,    41,    42,    -1,    44,    -1,    -1,    -1,    48,
      -1,    50,    51,    52,    53,    -1,    -1,    56,    57,    58,
      59,    60,    -1,    62,    -1,    -1,    65,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    75,    -1,    77,    78,
      79,    -1,    81,    82,    -1,    -1,    -1,    86,    -1,    -1,
      89,    90,    -1,    92,    -1,    -1,    95,    -1,     1,    -1,
      -1,    -1,     5,     6,     7,     8,     9,    -1,    -1,    -1,
     109,   110,    15,    -1,    -1,   114,    -1,    -1,    21,    22,
     119,   120,    -1,    -1,    -1,    28,   125,    -1,    -1,    32,
      33,    34,    -1,    -1,    -1,    -1,    -1,    -1,    41,    42,
      -1,    44,    -1,    -1,    -1,    48,    -1,    50,    51,    52,
      53,    -1,    -1,    56,    57,    58,    59,    60,    -1,    62,
      -1,    -1,    65,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    75,    -1,    77,    78,    79,    -1,    81,    82,
      -1,    -1,    -1,    86,    -1,    -1,    89,    90,    -1,    92,
      -1,    -1,    95,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   109,   110,    -1,    -1,
      -1,   114,    -1,    -1,    -1,    -1,   119,   120,   121,   122,
       1,    -1,   125,    -1,     5,     6,     7,     8,     9,    -1,
      -1,    -1,    -1,    -1,    15,    -1,    -1,    -1,    -1,    -1,
      21,    22,    -1,    24,    -1,    -1,    -1,    28,    -1,    -1,
      -1,    32,    33,    34,    -1,    -1,    -1,    -1,    -1,    -1,
      41,    42,    -1,    44,    -1,    -1,    -1,    48,    -1,    50,
      51,    52,    53,    -1,    -1,    56,    57,    58,    59,    60,
      -1,    62,    -1,    -1,    65,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    75,    -1,    77,    78,    79,    -1,
      81,    82,    -1,    -1,    -1,    86,    -1,    -1,    89,    90,
      -1,    92,    -1,    -1,    95,    -1,     1,    -1,    -1,    -1,
       5,     6,     7,     8,     9,    -1,    -1,    -1,   109,   110,
      15,    -1,    -1,   114,    -1,    -1,    21,    22,   119,   120,
      -1,    -1,    -1,    28,   125,    -1,    -1,    32,    33,    34,
      -1,    -1,    -1,    -1,    -1,    -1,    41,    42,    -1,    44,
      -1,    -1,    -1,    48,    -1,    50,    51,    52,    53,    -1,
      -1,    56,    57,    58,    59,    60,    -1,    62,    -1,    -1,
      65,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      75,    -1,    77,    78,    79,    -1,    81,    82,    -1,    -1,
      -1,    86,    -1,    -1,    89,    90,    -1,    92,    -1,    -1,
      95,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   109,   110,    -1,    -1,    -1,   114,
      -1,    -1,    -1,    -1,   119,   120,    -1,     1,    -1,   124,
     125,     5,     6,     7,     8,     9,    -1,    -1,    -1,    -1,
      -1,    15,    -1,    -1,    -1,    -1,    -1,    21,    22,    -1,
      24,    -1,    -1,    -1,    28,    -1,    -1,    -1,    32,    33,
      34,    -1,    -1,    -1,    -1,    -1,    -1,    41,    42,    -1,
      44,    -1,    -1,    -1,    48,    -1,    50,    51,    52,    53,
      -1,    -1,    56,    57,    58,    59,    60,    -1,    62,    -1,
      -1,    65,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    75,    -1,    77,    78,    79,    -1,    81,    82,    -1,
      -1,    -1,    86,    -1,    -1,    89,    90,    -1,    92,    -1,
      -1,    95,    -1,     1,    -1,    -1,    -1,     5,     6,     7,
       8,     9,    -1,    -1,    -1,   109,   110,    15,    -1,    -1,
     114,    -1,    -1,    21,    22,   119,   120,    -1,    -1,    -1,
      28,   125,    -1,    -1,    32,    33,    34,    -1,    -1,    -1,
      -1,    -1,    -1,    41,    42,    -1,    44,    -1,    -1,    -1,
      48,    -1,    50,    51,    52,    53,    -1,    -1,    56,    57,
      58,    59,    60,    -1,    62,    -1,    -1,    65,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    75,    -1,    77,
      78,    79,    -1,    81,    82,    -1,    -1,    -1,    86,    -1,
      -1,    89,    90,    -1,    92,    -1,    -1,    95,    -1,     1,
      -1,    -1,    -1,     5,     6,     7,     8,     9,    -1,    -1,
      -1,   109,   110,    15,    -1,    -1,   114,    -1,    -1,    21,
      22,   119,   120,    -1,    -1,    -1,    28,   125,    -1,    -1,
      32,    33,    34,    -1,    -1,    -1,    -1,    -1,    -1,    41,
      42,    -1,    44,    -1,    -1,    -1,    48,    -1,    50,    51,
      52,    53,    -1,    -1,    56,    57,    58,    59,    60,    -1,
      62,    -1,    -1,    65,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    75,    -1,    77,    78,    79,    -1,    81,
      82,    -1,    -1,    -1,    86,    -1,    -1,    89,    90,    -1,
      92,    -1,    -1,    95,    -1,     1,    -1,    -1,    -1,     5,
       6,     7,     8,     9,    -1,    -1,    -1,   109,   110,    15,
      -1,    -1,   114,    -1,    -1,    21,    22,   119,   120,    -1,
      -1,    -1,    28,   125,    -1,    -1,    -1,    33,    34,    -1,
      -1,    -1,    -1,    -1,    -1,    41,    -1,    -1,    44,    -1,
      -1,    -1,    48,    -1,    50,    51,    52,    53,    -1,    -1,
      56,    57,    58,    59,    60,    -1,    62,    -1,    -1,    65,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    75,
      -1,    77,    78,    79,    -1,    81,    82,    -1,    -1,    -1,
      86,    -1,    -1,    89,    90,    -1,    92,    -1,    -1,    95,
      -1,     1,    -1,    -1,    -1,     5,     6,     7,     8,     9,
      -1,    -1,    -1,   109,   110,    15,    -1,    -1,   114,    -1,
      -1,    21,    22,   119,   120,    -1,   122,   123,    28,   125,
      -1,    -1,    32,    33,    34,    -1,    -1,    -1,    -1,    -1,
      -1,    41,    42,    -1,    44,    -1,    -1,    -1,    48,    -1,
      50,    51,    52,    53,    -1,    -1,    56,    57,    58,    59,
      60,    -1,    62,    -1,    -1,    65,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    75,    -1,    77,    78,    79,
      -1,    81,    82,    -1,    -1,    -1,    86,    -1,    -1,    89,
      90,    -1,    92,    -1,    -1,    95,    -1,     1,    -1,    -1,
      -1,     5,     6,     7,     8,     9,    -1,    -1,    -1,   109,
     110,    15,    -1,    -1,   114,    -1,    -1,    21,    22,   119,
     120,    -1,    -1,    -1,    28,   125,    -1,    -1,    32,    33,
      34,    -1,    -1,    -1,    -1,    -1,    -1,    41,    42,    -1,
      44,    -1,    -1,    -1,    48,    -1,    50,    51,    52,    53,
      -1,    -1,    56,    57,    58,    59,    60,    -1,    62,    -1,
      -1,    65,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    75,    -1,    77,    78,    79,    -1,    81,    82,    -1,
      -1,    -1,    86,    -1,    -1,    89,    90,    -1,    92,    -1,
      -1,    95,    -1,     1,    -1,    -1,    -1,     5,     6,     7,
       8,     9,    -1,    -1,    -1,   109,   110,    15,    -1,    -1,
     114,    -1,    -1,    21,    22,   119,   120,    -1,    -1,    -1,
      28,   125,    -1,    -1,    32,    33,    34,    -1,    -1,    -1,
      -1,    -1,    -1,    41,    42,    -1,    44,    -1,    -1,    -1,
      48,    -1,    50,    51,    52,    53,    -1,    -1,    56,    57,
      58,    59,    60,    -1,    62,    -1,    -1,    65,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    75,    -1,    77,
      78,    79,    -1,    81,    82,    -1,    -1,    -1,    86,    -1,
      -1,    89,    90,    -1,    92,    -1,    -1,    95,    -1,     1,
      -1,    -1,    -1,     5,     6,     7,     8,     9,    -1,    -1,
      -1,   109,   110,    15,    -1,    -1,   114,    -1,    -1,    21,
      22,   119,   120,    -1,    -1,    -1,    28,   125,    -1,    -1,
      32,    33,    34,    -1,    -1,    -1,    -1,    -1,    -1,    41,
      42,    -1,    44,    -1,    -1,    -1,    48,    -1,    50,    51,
      52,    53,    -1,    -1,    56,    57,    58,    59,    60,    -1,
      62,    -1,    -1,    65,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    75,    -1,    77,    78,    79,    -1,    81,
      82,    -1,    -1,    -1,    86,    -1,    -1,    89,    90,    -1,
      92,    -1,    -1,    95,    -1,     1,    -1,    -1,    -1,     5,
       6,     7,     8,     9,    -1,    -1,    -1,   109,   110,    15,
      -1,    -1,   114,    -1,    -1,    21,    22,   119,   120,    -1,
      -1,    -1,    28,   125,    -1,    -1,    32,    33,    34,    -1,
      -1,    -1,    -1,    -1,    -1,    41,    42,    -1,    44,    -1,
      -1,    -1,    48,    -1,    50,    51,    52,    53,    -1,    -1,
      56,    57,    58,    59,    60,    -1,    62,    -1,    -1,    65,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    75,
      -1,    77,    78,    79,    -1,    81,    82,    -1,    -1,    -1,
      86,    -1,    -1,    89,    90,    -1,    92,    -1,    -1,    95,
      -1,     1,    -1,    -1,    -1,     5,     6,     7,     8,     9,
      -1,    -1,    -1,   109,   110,    15,    -1,    -1,   114,    -1,
      -1,    21,    22,   119,   120,    -1,    -1,    -1,    28,   125,
      -1,    -1,    32,    33,    34,    -1,    -1,    -1,    -1,    -1,
      -1,    41,    42,    -1,    44,    -1,    -1,    -1,    48,    -1,
      50,    51,    52,    53,    -1,    -1,    56,    57,    58,    59,
      60,    -1,    62,    -1,    -1,    65,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    75,    -1,    77,    78,    79,
      -1,    81,    82,    -1,    -1,    -1,    86,    -1,    -1,    89,
      90,    -1,    92,    -1,    -1,    95,    -1,     1,    -1,    -1,
      -1,     5,     6,     7,     8,     9,    -1,    -1,    -1,   109,
     110,    15,    -1,    -1,   114,    -1,    -1,    21,    22,   119,
     120,    -1,    -1,    -1,    28,   125,    -1,    -1,    32,    33,
      34,    -1,    -1,    -1,    -1,    -1,    -1,    41,    42,    -1,
      44,    -1,    -1,    -1,    48,    -1,    50,    51,    52,    53,
      -1,    -1,    56,    57,    58,    59,    60,    -1,    62,    -1,
      -1,    65,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    75,    -1,    77,    78,    79,    -1,    81,    82,    -1,
      -1,    -1,    86,    -1,    -1,    89,    90,    -1,    92,    -1,
      -1,    95,    -1,     1,    -1,    -1,    -1,     5,     6,     7,
       8,     9,    -1,    -1,    -1,   109,   110,    15,    -1,    -1,
     114,    -1,    -1,    21,    22,   119,   120,    -1,    -1,    -1,
      28,   125,    -1,    -1,    32,    33,    34,    -1,    -1,    -1,
      -1,    -1,    -1,    41,    42,    -1,    44,    -1,    -1,    -1,
      48,    -1,    50,    51,    52,    53,    -1,    -1,    56,    57,
      58,    59,    60,    -1,    62,    -1,    -1,    65,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    75,    -1,    77,
      78,    79,    -1,    81,    82,    -1,    -1,    -1,    86,    -1,
      -1,    89,    90,    -1,    92,    -1,    -1,    95,    -1,     1,
      -1,    -1,    -1,     5,     6,     7,     8,     9,    -1,    -1,
      -1,   109,   110,    15,    -1,    -1,   114,    -1,    -1,    21,
      22,   119,   120,    -1,    -1,    -1,    28,   125,    -1,    -1,
      32,    33,    34,    -1,    -1,    -1,    -1,    -1,    -1,    41,
      42,    -1,    44,    -1,    -1,    -1,    48,    -1,    50,    51,
      52,    53,    -1,    -1,    56,    57,    58,    59,    60,    -1,
      62,    -1,    -1,    65,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    75,    -1,    77,    78,    79,    -1,    81,
      82,    -1,    -1,    -1,    86,    -1,    -1,    89,    90,    -1,
      92,    -1,    -1,    95,    -1,     1,    -1,    -1,    -1,     5,
       6,     7,     8,     9,    -1,    -1,    -1,   109,   110,    15,
      -1,    -1,   114,    -1,    -1,    21,    22,   119,   120,    -1,
      -1,    -1,    28,   125,    -1,    -1,    32,    33,    34,    -1,
      -1,    -1,    -1,    -1,    -1,    41,    42,    -1,    44,    -1,
      -1,    -1,    48,    -1,    50,    51,    52,    53,    -1,    -1,
      56,    57,    58,    59,    60,    -1,    62,    -1,    -1,    65,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    75,
      -1,    77,    78,    79,    -1,    81,    82,    -1,    -1,    -1,
      86,    -1,    -1,    89,    90,    -1,    92,    -1,    -1,    95,
      -1,     1,    -1,    -1,    -1,     5,     6,     7,     8,     9,
      -1,    -1,    -1,   109,   110,    15,    -1,    -1,   114,    -1,
      -1,    21,    22,   119,   120,    -1,    -1,    -1,    28,   125,
      -1,    -1,    32,    33,    34,    -1,    -1,    -1,    -1,    -1,
      -1,    41,    42,    -1,    44,    -1,    -1,    -1,    48,    -1,
      50,    51,    52,    53,    -1,    -1,    56,    57,    58,    59,
      60,    -1,    62,    -1,    -1,    65,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    75,    -1,    77,    78,    79,
      -1,    81,    82,    -1,    -1,    -1,    86,    -1,    -1,    89,
      90,    -1,    92,    -1,    -1,    95,    -1,     1,    -1,    -1,
      -1,     5,     6,     7,     8,     9,    -1,    -1,    -1,   109,
     110,    15,    -1,    -1,   114,    -1,    -1,    21,    22,   119,
     120,    -1,    -1,    -1,    28,   125,    -1,    -1,    32,    33,
      34,    -1,    -1,    -1,    -1,    -1,    -1,    41,    42,    -1,
      44,    -1,    -1,    -1,    48,    -1,    50,    51,    52,    53,
      -1,    -1,    56,    57,    58,    59,    60,    -1,    62,    -1,
      -1,    65,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    75,    -1,    77,    78,    79,    -1,    81,    82,    -1,
      -1,    -1,    86,    -1,    -1,    89,    90,    -1,    92,    -1,
      -1,    95,    -1,     1,    -1,    -1,    -1,     5,     6,     7,
       8,     9,    -1,    -1,    -1,   109,   110,    15,    -1,    -1,
     114,    -1,    -1,    21,    22,   119,   120,    -1,    -1,    -1,
      28,   125,    -1,    -1,    32,    33,    34,    -1,    -1,    -1,
      -1,    -1,    -1,    41,    42,    -1,    44,    -1,    -1,    -1,
      48,    -1,    50,    51,    52,    53,    -1,    -1,    56,    57,
      58,    59,    60,    -1,    62,    -1,    -1,    65,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    75,    -1,    77,
      78,    79,    -1,    81,    82,    -1,    -1,    -1,    86,    -1,
      -1,    89,    90,    -1,    92,    -1,    -1,    95,    -1,     1,
      -1,    -1,    -1,     5,     6,     7,     8,     9,    -1,    -1,
      -1,   109,   110,    15,    -1,    -1,   114,    -1,    -1,    21,
      22,   119,   120,    -1,    -1,    -1,    28,   125,    -1,    -1,
      32,    33,    34,    -1,    -1,    -1,    -1,    -1,    -1,    41,
      42,    -1,    44,    -1,    -1,    -1,    48,    -1,    50,    51,
      52,    53,    -1,    -1,    56,    57,    58,    59,    60,    -1,
      62,    -1,    -1,    65,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    75,    -1,    77,    78,    79,    -1,    81,
      82,    -1,    -1,    -1,    86,    -1,    -1,    89,    90,    -1,
      92,    -1,    -1,    95,    -1,     1,    -1,    -1,    -1,     5,
       6,     7,     8,     9,    -1,    -1,    -1,   109,   110,    15,
      -1,    -1,   114,    -1,    -1,    21,    22,   119,   120,    -1,
      -1,    -1,    28,   125,    -1,    -1,    32,    33,    34,    -1,
      -1,    -1,    -1,    -1,    -1,    41,    42,    -1,    44,    -1,
      -1,    -1,    48,    -1,    50,    51,    52,    53,    -1,    -1,
      56,    57,    58,    59,    60,    -1,    62,    -1,    -1,    65,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    75,
      -1,    77,    78,    79,    -1,    81,    82,    -1,    -1,    -1,
      86,    -1,    -1,    89,    90,    -1,    92,    -1,    -1,    95,
      -1,     1,    -1,    -1,    -1,     5,     6,     7,     8,     9,
      -1,    -1,    -1,   109,   110,    15,    -1,    -1,   114,    -1,
      -1,    21,    22,   119,   120,    -1,    -1,    -1,    28,   125,
      -1,    -1,    32,    33,    34,    -1,    -1,    -1,    -1,    -1,
      -1,    41,    42,    -1,    44,    -1,    -1,    -1,    48,    -1,
      50,    51,    52,    53,    -1,    -1,    56,    57,    58,    59,
      60,    -1,    62,    -1,    -1,    65,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    75,    -1,    77,    78,    79,
      -1,    81,    82,    -1,    -1,    -1,    86,    -1,    -1,    89,
      90,    -1,    92,    -1,    -1,    95,    -1,     1,    -1,    -1,
      -1,     5,     6,     7,     8,     9,    -1,    -1,    -1,   109,
     110,    15,    -1,    -1,   114,    -1,    -1,    21,    22,   119,
     120,    -1,    -1,    -1,    28,   125,    -1,    -1,    32,    33,
      34,    -1,    -1,    -1,    -1,    -1,    -1,    41,    42,    -1,
      44,    -1,    -1,    -1,    48,    -1,    50,    51,    52,    53,
      -1,    -1,    56,    57,    58,    59,    60,    -1,    62,    -1,
      -1,    65,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    75,    -1,    77,    78,    79,    -1,    81,    82,    -1,
      -1,    -1,    86,    -1,    -1,    89,    90,    -1,    92,    -1,
      -1,    95,    -1,     1,    -1,    -1,    -1,     5,     6,     7,
       8,     9,    -1,    -1,    -1,   109,   110,    15,    -1,    -1,
     114,    -1,    -1,    21,    22,   119,   120,    -1,    -1,    -1,
      28,   125,    -1,    -1,    32,    33,    34,    -1,    -1,    -1,
      -1,    -1,    -1,    41,    42,    -1,    44,    -1,    -1,    -1,
      48,    -1,    50,    51,    52,    53,    -1,    -1,    56,    57,
      58,    59,    60,    -1,    62,    -1,    -1,    65,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    75,    -1,    77,
      78,    79,    -1,    81,    82,    -1,    -1,    -1,    86,    -1,
      -1,    89,    90,    -1,    92,    -1,    -1,    95,    -1,     1,
      -1,    -1,    -1,     5,     6,     7,     8,     9,    -1,    -1,
      -1,   109,   110,    15,    -1,    -1,   114,    -1,    -1,    21,
      22,   119,   120,    -1,    -1,    -1,    28,   125,    -1,    -1,
      32,    33,    34,    -1,    -1,    -1,    -1,    -1,    -1,    41,
      42,    -1,    44,    -1,    -1,    -1,    48,    -1,    50,    51,
      52,    53,    -1,    -1,    56,    57,    58,    59,    60,    -1,
      62,    -1,    -1,    65,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    75,    -1,    77,    78,    79,    -1,    81,
      82,    -1,    -1,    -1,    86,    -1,    -1,    89,    90,    -1,
      92,    -1,    -1,    95,    -1,     1,    -1,    -1,    -1,     5,
       6,     7,     8,     9,    -1,    -1,    -1,   109,   110,    15,
      -1,    -1,   114,    -1,    -1,    21,    22,   119,   120,    -1,
      -1,    -1,    28,   125,    -1,    -1,    32,    33,    34,    -1,
      -1,    -1,    -1,    -1,    -1,    41,    42,    -1,    44,    -1,
      -1,    -1,    48,    -1,    50,    51,    52,    53,    -1,    -1,
      56,    57,    58,    59,    60,    -1,    62,    -1,    -1,    65,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    75,
      -1,    77,    78,    79,    -1,    81,    82,    -1,    -1,    -1,
      86,    -1,    -1,    89,    90,    -1,    92,    -1,    -1,    95,
       1,    -1,    -1,    -1,    -1,     6,     7,    -1,    -1,    -1,
      -1,    -1,    -1,   109,   110,    -1,    -1,    -1,   114,    -1,
      -1,    -1,    -1,   119,   120,    -1,    27,    -1,    29,   125,
      -1,    -1,    33,    34,    -1,    36,    -1,    -1,    39,    40,
      -1,    -1,    43,    -1,    45,    -1,    47,    -1,    -1,    -1,
      51,    52,    53,    -1,    -1,    -1,    -1,    58,    -1,    60,
      61,    -1,    63,    -1,    -1,    -1,    67,    68,     1,    -1,
      71,    -1,    -1,     6,    -1,    76,    -1,    78,    -1,    -1,
      -1,    -1,    83,    -1,    -1,    86,    87,    -1,    -1,    90,
      91,    -1,    -1,    -1,    27,    -1,    29,    -1,    99,   100,
      33,    34,    -1,    36,    -1,    -1,    -1,    -1,    -1,   110,
      43,    -1,    45,    -1,    47,   116,    -1,    -1,    51,    52,
      53,    -1,    -1,    -1,   125,    58,    -1,    60,    61,    -1,
      63,    -1,    -1,    -1,    67,    68,     1,    -1,    71,    -1,
      -1,     6,    -1,    76,    -1,    78,    -1,    -1,    -1,    -1,
      83,    -1,    -1,    86,    87,    -1,    -1,    90,    91,    -1,
      -1,    -1,    27,    -1,    29,    -1,    -1,   100,    33,    34,
      -1,    36,    -1,    -1,    -1,    -1,    -1,    -1,    43,    -1,
      45,    -1,    47,    -1,    -1,    -1,    51,    52,    53,   122,
      -1,    -1,   125,    58,    -1,    60,    61,    -1,    63,    -1,
      -1,    -1,    67,    68,     1,    -1,    71,    -1,    -1,     6,
      -1,    76,    -1,    78,    -1,    -1,    -1,    -1,    83,    -1,
      -1,    86,    87,    -1,    -1,    90,    91,    -1,    -1,    -1,
      27,    -1,    29,    -1,    -1,   100,    33,    34,    -1,    36,
      -1,    -1,    -1,    -1,    -1,    -1,    43,    -1,    45,    -1,
      47,    -1,    -1,    -1,    51,    52,    53,   122,    -1,    -1,
     125,    58,    -1,    60,    61,    -1,    63,    -1,    -1,    -1,
      67,    68,     1,    -1,    71,    -1,    -1,     6,    -1,    76,
      -1,    78,    -1,    -1,    -1,    -1,    83,    -1,    -1,    86,
      87,    -1,    -1,    90,    91,    -1,    -1,    -1,    27,    -1,
      29,    -1,    -1,   100,    33,    34,    -1,    36,    -1,    -1,
      -1,    -1,    -1,    -1,    43,    -1,    45,    -1,    47,    -1,
      -1,    -1,    51,    52,    53,    -1,    -1,    -1,   125,    58,
      -1,    60,    61,    -1,    63,    -1,    -1,    -1,    67,    68,
       1,    -1,    71,    -1,    -1,     6,    -1,    76,    -1,    78,
      -1,    -1,    -1,    -1,    83,    -1,    -1,    86,    87,    -1,
      -1,    90,    91,    -1,    -1,    -1,    27,    -1,    29,    -1,
      -1,   100,    33,    34,    -1,    36,    -1,    -1,    -1,    -1,
      -1,    -1,    43,    -1,    45,    -1,    47,    -1,    -1,    -1,
      51,    52,    53,    -1,    -1,    -1,   125,    58,    -1,    60,
      61,    -1,    63,    -1,    -1,    -1,    67,    68,    -1,    -1,
      71,    -1,    -1,    -1,    -1,    76,    -1,    78,    -1,    -1,
      -1,    -1,    83,    -1,    -1,    86,    87,    -1,    -1,    90,
      91,     5,     6,     7,     8,     9,    -1,    -1,    -1,   100,
      -1,    15,    -1,    -1,    -1,    -1,    -1,    21,    22,    -1,
      24,    -1,    -1,    27,    28,    29,    -1,    -1,    -1,    33,
      34,    -1,    36,    -1,   125,    39,    40,    41,    -1,    43,
      44,    45,    -1,    47,    48,    -1,    50,    51,    52,    53,
      -1,    -1,    56,    57,    58,    59,    60,    61,    62,    63,
      -1,    65,    -1,    67,    68,    -1,    -1,    71,    -1,    -1,
      -1,    75,    76,    77,    78,    79,    -1,    81,    82,    83,
      -1,    -1,    86,    87,    -1,    89,    90,    91,    92,    -1,
      -1,    95,    -1,    -1,    -1,    -1,   100,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   108,   109,   110,    -1,    -1,    -1,
     114,    -1,    -1,    -1,    -1,   119,   120,    -1,    -1,    -1,
      -1,   125,     5,     6,     7,     8,     9,    -1,    -1,    -1,
      -1,    -1,    15,    -1,    -1,    -1,    -1,    -1,    21,    22,
      -1,    24,    -1,    -1,    27,    28,    29,    -1,    -1,    -1,
      33,    34,    -1,    36,    -1,    -1,    -1,    -1,    41,    -1,
      43,    44,    45,    -1,    47,    48,    -1,    50,    51,    52,
      53,    -1,    -1,    56,    57,    58,    59,    60,    61,    62,
      63,    -1,    65,    -1,    67,    68,    -1,    -1,    71,    -1,
      -1,    -1,    75,    76,    77,    78,    79,    -1,    81,    82,
      83,    -1,    -1,    86,    87,    -1,    89,    90,    91,    92,
      -1,    -1,    95,    -1,    -1,    -1,    -1,   100,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   108,   109,   110,    -1,    -1,
      -1,   114,    -1,    -1,    -1,    -1,   119,   120,   121,    -1,
      -1,    -1,   125,     5,     6,     7,     8,     9,    -1,    -1,
      -1,    -1,    -1,    15,    -1,    -1,    -1,    -1,    -1,    21,
      22,    -1,    -1,    -1,    -1,    27,    28,    29,    -1,    -1,
      32,    33,    34,    -1,    36,    -1,    -1,    -1,    -1,    41,
      42,    43,    44,    45,    -1,    47,    48,    -1,    50,    51,
      52,    53,    -1,    -1,    56,    57,    58,    59,    60,    61,
      62,    63,    -1,    65,    -1,    67,    68,    -1,    -1,    71,
      -1,    -1,    -1,    75,    76,    77,    78,    79,    -1,    81,
      82,    83,    -1,    -1,    86,    87,    -1,    89,    90,    91,
      92,    -1,    -1,    95,    -1,    -1,    -1,    -1,   100,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,   110,    -1,
      -1,    -1,   114,    -1,    -1,    -1,    -1,   119,   120,    -1,
      -1,    -1,    -1,   125,     5,     6,     7,     8,     9,    -1,
      -1,    -1,    -1,    -1,    15,    -1,    -1,    -1,    -1,    -1,
      21,    22,    -1,    24,    -1,    -1,    27,    28,    29,    -1,
      -1,    -1,    33,    34,    -1,    36,    -1,    -1,    -1,    -1,
      41,    -1,    43,    44,    45,    -1,    47,    48,    -1,    50,
      51,    52,    53,    -1,    -1,    56,    57,    58,    59,    60,
      61,    62,    63,    -1,    65,    -1,    67,    68,    -1,    -1,
      71,    -1,    -1,    -1,    75,    76,    77,    78,    79,    -1,
      81,    82,    83,    -1,    -1,    86,    87,    -1,    89,    90,
      91,    92,    -1,    -1,    95,    -1,    -1,    -1,    -1,   100,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,   110,
      -1,    -1,    -1,   114,    -1,    -1,    -1,    -1,   119,   120,
      -1,    -1,    -1,    -1,   125,     5,     6,     7,     8,     9,
      -1,    -1,    -1,    -1,    -1,    15,    -1,    -1,    -1,    -1,
      -1,    21,    22,    -1,    -1,    -1,    -1,    27,    28,    29,
      -1,    -1,    -1,    33,    34,    -1,    36,    -1,    -1,    -1,
      -1,    41,    -1,    43,    44,    45,    -1,    47,    48,    -1,
      50,    51,    52,    53,    -1,    -1,    56,    57,    58,    59,
      60,    61,    62,    63,    -1,    65,    -1,    67,    68,    -1,
      -1,    71,    -1,    -1,    -1,    75,    76,    77,    78,    79,
      -1,    81,    82,    83,    -1,    -1,    86,    87,    -1,    89,
      90,    91,    92,    -1,    -1,    95,    -1,    -1,    -1,    -1,
     100,     5,     6,     7,     8,     9,    -1,    -1,    -1,   109,
     110,    15,    -1,    -1,   114,    -1,    -1,    21,    22,   119,
     120,    -1,    -1,    -1,    28,   125,    -1,    -1,    32,    33,
      34,    -1,    -1,    -1,    -1,    -1,    -1,    41,    42,    -1,
      44,    -1,    -1,    -1,    48,    -1,    50,    51,    52,    53,
      -1,    -1,    56,    57,    58,    59,    60,    -1,    62,    -1,
      -1,    65,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    75,    -1,    77,    78,    79,    -1,    81,    82,    -1,
      -1,    -1,    86,    -1,    -1,    89,    90,    -1,    92,    -1,
      -1,    95,    -1,    -1,    -1,    -1,    -1,     5,     6,     7,
       8,     9,    -1,    -1,    -1,   109,   110,    15,    -1,    -1,
     114,    -1,    -1,    21,    22,   119,   120,    -1,    -1,   123,
      28,   125,    -1,    -1,    -1,    33,    34,    -1,    -1,    -1,
      -1,    -1,    -1,    41,    -1,    -1,    44,    -1,    -1,    -1,
      48,    -1,    50,    51,    52,    53,    -1,    -1,    56,    57,
      58,    59,    60,    -1,    62,    -1,    -1,    65,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    75,    -1,    77,
      78,    79,    -1,    81,    82,    -1,    -1,    -1,    86,    -1,
      -1,    89,    90,    -1,    92,    -1,    -1,    95,    -1,    -1,
      -1,    -1,    -1,     5,     6,     7,     8,     9,    -1,    -1,
      -1,   109,   110,    15,    -1,    -1,   114,    -1,    -1,    21,
      22,   119,   120,    -1,   122,   123,    28,   125,    -1,    -1,
      32,    33,    34,    -1,    -1,    -1,    -1,    -1,    -1,    41,
      42,    -1,    44,    -1,    -1,    -1,    48,    -1,    50,    51,
      52,    53,    -1,    -1,    56,    57,    58,    59,    60,    -1,
      62,    -1,    -1,    65,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    75,    -1,    77,    78,    79,    -1,    81,
      82,    -1,    -1,    -1,    86,    -1,    -1,    89,    90,    -1,
      92,    -1,    -1,    95,    -1,    -1,    -1,    -1,    -1,     5,
       6,     7,     8,     9,    -1,    -1,    -1,   109,   110,    15,
      -1,    -1,   114,    -1,    -1,    21,    22,   119,   120,    -1,
      -1,    -1,    28,   125,    -1,    -1,    -1,    33,    34,    -1,
      -1,    -1,    -1,    -1,    -1,    41,    -1,    -1,    44,    -1,
      -1,    -1,    48,    -1,    50,    51,    52,    53,    -1,    -1,
      56,    57,    58,    59,    60,    -1,    62,    -1,    -1,    65,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    75,
      -1,    77,    78,    79,    -1,    81,    82,    -1,    -1,    -1,
      86,    -1,    -1,    89,    90,    -1,    92,    -1,    -1,    95,
      -1,    -1,    -1,     5,     6,     7,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   109,   110,    -1,    -1,    -1,   114,    21,
      22,    -1,    -1,   119,   120,    -1,    28,    -1,    -1,   125,
      -1,    33,    34,    -1,    -1,    -1,    -1,    -1,    -1,    41,
      -1,    -1,    44,    -1,    -1,    -1,    48,    -1,    50,    51,
      52,    53,    -1,    -1,    56,    57,    58,    59,    60,    -1,
      62,    -1,    -1,    65,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    75,    -1,    77,    78,    79,    -1,    81,
      82,    -1,    -1,    -1,    86,    -1,    -1,    89,    90,    -1,
      92,     3,    -1,    95,    -1,    -1,     8,     9,    -1,    11,
      12,    13,    14,    -1,    16,    17,    18,    19,    -1,    -1,
      -1,    -1,    24,    25,    26,    -1,    -1,   119,    -1,    -1,
      -1,    -1,    -1,   125,    -1,    37,    -1,    39,    40,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    66,    -1,    -1,    69,    70,    -1,
      72,    73,    74,    -1,    -1,    -1,    -1,    -1,    80,    -1,
      -1,    -1,    84,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    94,    -1,    96,    97,    98,    -1,    -1,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,     6,   115,   116,   117,   118,   119,   120,   121,
     122,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    27,    -1,    29,    -1,    -1,    -1,    33,
      34,    -1,    36,    -1,    -1,    -1,    -1,    -1,    -1,    43,
      -1,    45,    -1,    47,    -1,    -1,    -1,    51,    52,    53,
      -1,    -1,    -1,    -1,    58,    -1,    60,    61,    -1,    63,
      -1,    -1,    -1,    67,    68,    -1,    -1,    71,    -1,    -1,
      -1,    -1,    76,    -1,    78,    -1,    -1,    -1,     6,    83,
      -1,    -1,    86,    87,    -1,    -1,    90,    91,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   100,    -1,    -1,    27,
      -1,    29,    -1,    -1,    -1,    33,    34,    -1,    36,    -1,
      -1,    -1,    -1,    -1,   118,    43,   120,    45,    -1,    47,
      -1,   125,    -1,    51,    52,    53,    -1,    -1,    -1,    -1,
      58,    -1,    60,    61,    -1,    63,    -1,    -1,    -1,    67,
      68,    -1,    -1,    71,    -1,    -1,     6,    -1,    76,    -1,
      78,    -1,    -1,    -1,    -1,    83,    -1,    -1,    86,    87,
      -1,    -1,    90,    91,    -1,    -1,    -1,    27,    -1,    29,
      -1,    -1,   100,    33,    34,    -1,    36,    -1,    -1,    -1,
      -1,    -1,    -1,    43,    -1,    45,    -1,    47,    -1,    -1,
     118,    51,    52,    53,    -1,    -1,    -1,   125,    58,    -1,
      60,    61,    -1,    63,    -1,    -1,    -1,    67,    68,    -1,
      -1,    71,    -1,    -1,     6,    -1,    76,    -1,    78,    -1,
      -1,    -1,    -1,    83,    -1,    -1,    86,    87,    -1,    -1,
      90,    91,    -1,    -1,    -1,    27,    -1,    29,    -1,    -1,
     100,    33,    34,    -1,    36,    -1,    -1,    -1,    -1,    -1,
      -1,    43,    -1,    45,    -1,    47,    -1,    -1,    -1,    51,
      52,    53,   122,    -1,    -1,   125,    58,    -1,    60,    61,
      -1,    63,    -1,    -1,    -1,    67,    68,    -1,    -1,    71,
      -1,    -1,    -1,    -1,    76,    -1,    78,    -1,    -1,    -1,
       6,    83,    -1,    -1,    86,    87,    -1,    -1,    90,    91,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,    -1,
      -1,    27,    -1,    29,    -1,    -1,    -1,    33,    34,    -1,
      36,    -1,    -1,    -1,    -1,    -1,    -1,    43,   120,    45,
      -1,    47,    -1,   125,    -1,    51,    52,    53,    -1,    -1,
      -1,    -1,    58,    -1,    60,    61,    -1,    63,    -1,    -1,
      -1,    67,    68,    -1,    -1,    71,    -1,    -1,     6,    -1,
      76,    -1,    78,    -1,    -1,    -1,    -1,    83,    -1,    -1,
      86,    87,    -1,    -1,    90,    91,    -1,    -1,    -1,    27,
      -1,    29,    -1,    -1,   100,    33,    34,    -1,    36,    -1,
      -1,    -1,    -1,    -1,    -1,    43,    -1,    45,    -1,    47,
      -1,    -1,    -1,    51,    52,    53,    -1,    -1,    -1,   125,
      58,    -1,    60,    61,    -1,    63,    -1,    -1,    -1,    67,
      68,    -1,    -1,    71,    -1,    -1,     6,    -1,    76,    -1,
      78,    -1,    -1,    -1,    -1,    83,    -1,    -1,    86,    87,
      -1,    -1,    90,    91,    -1,    -1,    -1,    27,    -1,    29,
      -1,    -1,   100,    33,    34,    -1,    36,    -1,    -1,    -1,
      -1,    -1,    -1,    43,    -1,    45,    -1,    47,    -1,    -1,
      -1,    51,    52,    53,    -1,    -1,    -1,   125,    58,    -1,
      60,    61,    -1,    63,    -1,    -1,    -1,    67,    68,    -1,
      -1,    71,    -1,    -1,    -1,     1,    76,    -1,    78,    -1,
      -1,    -1,    -1,    83,    10,    -1,    86,    87,    -1,    -1,
      90,    91,    -1,    -1,    20,    21,    22,    23,    24,    -1,
     100,    27,    -1,    29,    30,    31,    32,    -1,    34,    35,
      36,    -1,    38,    -1,    -1,    41,    42,    43,    44,    45,
      46,    47,    48,    -1,    -1,   125,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    -1,    -1,
      -1,    67,    68,    -1,    -1,    71,    -1,    -1,    -1,    75,
      76,    77,    78,    79,    -1,    81,    -1,    83,    -1,    85,
      86,    87,    -1,    89,    -1,    91,    92,     1,    -1,    95,
       4,    -1,    -1,    -1,    -1,    -1,    10,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      -1,   117,   118,    27,    28,    29,    30,    31,    32,    -1,
      34,    35,    36,    -1,    38,    -1,    -1,    41,    42,    43,
      44,    45,    46,    47,    48,    -1,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      -1,    -1,    -1,    67,    68,    -1,    -1,    71,    -1,    -1,
      -1,    75,    76,    77,    78,    79,    -1,    81,    82,    83,
      -1,    85,    86,    87,    88,    89,    -1,    91,    92,    93,
       1,    95,    -1,    -1,    -1,     6,    -1,    -1,    -1,    10,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    -1,    -1,    -1,    27,    -1,    29,    30,
      31,    32,    -1,    34,    35,    36,    -1,    38,    -1,    -1,
      41,    42,    43,    44,    45,    46,    47,    48,    -1,    -1,
      -1,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    -1,    -1,    -1,    67,    68,    -1,    -1,
      71,    -1,    -1,    -1,    75,    76,    77,    78,    79,    -1,
      81,    -1,    83,     1,    85,    86,    87,    -1,    89,    -1,
      91,    92,    10,    -1,    95,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    -1,    -1,    -1,    27,
      -1,    29,    30,    31,    32,    -1,    34,    35,    36,    -1,
      38,    -1,    -1,    41,    42,    43,    44,    45,    46,    47,
      48,    -1,    -1,    -1,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    -1,    -1,    -1,    67,
      68,    -1,    -1,    71,    -1,    -1,    -1,    75,    76,    77,
      78,    79,    -1,    81,    -1,    83,    -1,    85,    86,    87,
      10,    89,    -1,    91,    92,    -1,    -1,    95,    -1,    -1,
      20,    21,    22,    23,    -1,    -1,    -1,    27,    -1,    29,
      30,    31,    32,    -1,    34,    35,    36,    -1,    38,    -1,
      -1,    41,    42,    43,    44,    45,    46,    47,    48,    -1,
      -1,    -1,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    -1,    -1,    -1,    67,    68,    -1,
      -1,    71,    -1,    -1,    -1,    75,    76,    77,    78,    79,
      -1,    81,    -1,    83,    -1,    85,    86,    87,     1,    89,
      -1,    91,    92,    -1,    -1,    95,    -1,    10,    -1,    -1,
      -1,    -1,    -1,    -1,   104,    -1,    -1,    20,    21,    22,
      23,    -1,    -1,    -1,    27,    -1,    29,    30,    31,    32,
      -1,    34,    35,    36,    -1,    38,    -1,    -1,    41,    42,
      43,    44,    45,    46,    47,    48,    -1,    -1,    -1,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    -1,    -1,    -1,    67,    68,    -1,    -1,    71,    -1,
      -1,    -1,    75,    76,    77,    78,    79,    -1,    81,    -1,
      83,     1,    85,    86,    87,    -1,    89,    -1,    91,    92,
      10,    -1,    95,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    -1,    -1,    -1,    27,    -1,    29,
      30,    31,    32,    -1,    34,    35,    36,    -1,    38,    -1,
      -1,    41,    42,    43,    44,    45,    46,    47,    48,    -1,
      -1,    -1,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    -1,    -1,    -1,    67,    68,    -1,
      -1,    71,    -1,    -1,    -1,    75,    76,    77,    78,    79,
      -1,    81,    -1,    83,     1,    85,    86,    87,    -1,    89,
      -1,    91,    92,    10,    -1,    95,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    20,    21,    22,    23,    -1,    -1,    -1,
      -1,    -1,    -1,    30,    31,    32,    -1,    34,    35,    -1,
      -1,    38,    -1,    -1,    41,    42,    -1,    44,    -1,    46,
      -1,    48,    -1,    -1,    -1,    52,    53,    54,    55,    56,
      57,    -1,    59,    60,    -1,    62,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    75,    -1,
      77,    78,    79,    -1,    81,     1,    -1,    -1,    85,    86,
      -1,    -1,    89,    -1,    10,    92,    -1,    -1,    95,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    -1,    -1,
      -1,    -1,    -1,    -1,    30,    31,    32,    -1,    34,    35,
      -1,    -1,    38,    -1,    -1,    41,    42,    -1,    44,    -1,
      46,    -1,    48,    -1,    -1,    -1,    52,    53,    54,    55,
      56,    57,    -1,    59,    60,    -1,    62,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    75,
      -1,    77,    78,    79,    -1,    81,     4,    -1,    -1,    85,
      86,    -1,    10,    89,    -1,    -1,    92,    -1,    -1,    95,
      -1,    -1,    20,    21,    22,    23,    -1,    -1,    -1,    27,
      28,    29,    30,    31,    32,    -1,    34,    35,    36,    -1,
      38,    -1,    -1,    41,    42,    43,    44,    45,    46,    47,
      48,    -1,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    -1,    -1,    -1,    67,
      68,    -1,    -1,    71,    -1,    -1,    -1,    75,    76,    77,
      78,    79,    -1,    81,    82,    83,    -1,    85,    86,    87,
      88,    89,    10,    91,    92,    93,    -1,    95,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    -1,    -1,    -1,    27,
      -1,    29,    30,    31,    32,    -1,    34,    35,    36,    -1,
      38,    -1,    -1,    41,    42,    43,    44,    45,    46,    47,
      48,    -1,    -1,    -1,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    -1,    -1,    -1,    67,
      68,    -1,    -1,    71,    -1,    -1,    -1,    75,    76,    77,
      78,    79,    -1,    81,    -1,    83,    -1,    85,    86,    87,
      10,    89,    -1,    91,    92,    -1,    -1,    95,    -1,    -1,
      20,    21,    22,    23,    -1,    -1,    -1,    27,    -1,    29,
      30,    31,    32,    -1,    34,    35,    36,    -1,    38,    -1,
      -1,    41,    42,    43,    44,    45,    46,    47,    48,    -1,
      -1,    -1,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    -1,    -1,    -1,    67,    68,    -1,
      -1,    71,    -1,    -1,    -1,    75,    76,    77,    78,    79,
      -1,    81,    -1,    83,    -1,    85,    86,    87,    10,    89,
      -1,    91,    92,    -1,    -1,    95,    -1,    -1,    20,    21,
      22,    23,    -1,    -1,    -1,    27,    -1,    29,    30,    31,
      32,    -1,    34,    35,    36,    -1,    38,    -1,    -1,    41,
      42,    43,    44,    45,    46,    47,    48,    -1,    -1,    -1,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    -1,    -1,    -1,    67,    68,    -1,    -1,    71,
      -1,    -1,    -1,    75,    76,    77,    78,    79,    -1,    81,
      -1,    83,    -1,    85,    86,    87,    10,    89,    -1,    91,
      92,    -1,    -1,    95,    -1,    -1,    20,    21,    22,    23,
      -1,    -1,    -1,    27,    -1,    29,    30,    31,    32,    -1,
      34,    35,    36,    -1,    38,    -1,    -1,    41,    42,    43,
      44,    45,    46,    47,    48,    -1,    -1,    -1,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      -1,    -1,    -1,    67,    68,    -1,    -1,    71,    -1,    -1,
      -1,    75,    76,    77,    78,    79,    -1,    81,    -1,    83,
      -1,    85,    86,    87,    10,    89,    -1,    91,    92,    -1,
      -1,    95,    -1,    -1,    20,    21,    22,    23,    -1,    -1,
      -1,    27,    -1,    29,    30,    31,    32,    -1,    34,    35,
      36,    -1,    38,    -1,    -1,    41,    42,    43,    44,    45,
      46,    47,    48,    -1,    -1,    -1,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    -1,    -1,
      -1,    67,    68,    -1,    -1,    71,    -1,    -1,    -1,    75,
      76,    77,    78,    79,    -1,    81,    -1,    83,    -1,    85,
      86,    87,    10,    89,    -1,    91,    92,    -1,    -1,    95,
      -1,    -1,    20,    21,    22,    23,    -1,    -1,    -1,    27,
      -1,    29,    30,    31,    32,    -1,    34,    35,    36,    -1,
      38,    -1,    -1,    41,    42,    43,    44,    45,    46,    47,
      48,    -1,    -1,    -1,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    -1,    -1,    -1,    67,
      68,    -1,    -1,    71,    -1,    -1,    -1,    75,    76,    77,
      78,    79,    -1,    81,    -1,    83,    -1,    85,    86,    87,
      10,    89,    -1,    91,    92,    -1,    -1,    95,    -1,    -1,
      20,    21,    22,    23,    -1,    -1,    -1,    27,    -1,    29,
      30,    31,    32,    -1,    34,    35,    36,    -1,    38,    -1,
      -1,    41,    42,    43,    44,    45,    46,    47,    48,    -1,
      -1,    -1,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    -1,    -1,    -1,    67,    68,    -1,
      -1,    71,    -1,    -1,    -1,    75,    76,    77,    78,    79,
      -1,    81,    -1,    83,    -1,    85,    86,    87,    10,    89,
      -1,    91,    92,    -1,    -1,    95,    -1,    -1,    20,    21,
      22,    23,    -1,    -1,    -1,    27,    -1,    29,    30,    31,
      32,    -1,    34,    35,    36,    -1,    38,    -1,    -1,    41,
      42,    43,    44,    45,    46,    47,    48,    -1,    -1,    -1,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    -1,    -1,    -1,    67,    68,    -1,    -1,    71,
      -1,    -1,    -1,    75,    76,    77,    78,    79,    -1,    81,
      -1,    83,    -1,    85,    86,    87,    10,    89,    -1,    91,
      92,    -1,    -1,    95,    -1,    -1,    20,    21,    22,    23,
      -1,    -1,    -1,    27,    -1,    29,    30,    31,    32,    -1,
      34,    35,    36,    -1,    38,    -1,    -1,    41,    42,    43,
      44,    45,    46,    47,    48,    -1,    -1,    -1,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      -1,    -1,    -1,    67,    68,    -1,    -1,    71,    -1,    -1,
      -1,    75,    76,    77,    78,    79,    -1,    81,    -1,    83,
      -1,    85,    86,    87,    10,    89,    -1,    91,    92,    -1,
      -1,    95,    -1,    -1,    20,    21,    22,    23,    -1,    -1,
      -1,    27,    -1,    29,    30,    31,    32,    -1,    34,    35,
      36,    -1,    38,    -1,    -1,    41,    42,    43,    44,    45,
      46,    47,    48,    -1,    -1,    -1,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    -1,    -1,
      -1,    67,    68,    -1,    -1,    71,    -1,    -1,    -1,    75,
      76,    77,    78,    79,    -1,    81,    -1,    83,    -1,    85,
      86,    87,    10,    89,    -1,    91,    92,    -1,    -1,    95,
      -1,    -1,    20,    21,    22,    23,    -1,    -1,    -1,    27,
      -1,    29,    30,    31,    32,    -1,    34,    35,    36,    -1,
      38,    -1,    -1,    41,    42,    43,    44,    45,    46,    47,
      48,    -1,    -1,    -1,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    -1,    -1,    -1,    67,
      68,    -1,    -1,    71,    -1,    -1,    -1,    75,    76,    77,
      78,    79,    -1,    81,    -1,    83,    -1,    85,    86,    87,
      10,    89,    -1,    91,    92,    -1,    -1,    95,    -1,    -1,
      20,    21,    22,    23,    -1,    -1,    -1,    27,    -1,    29,
      30,    31,    32,    -1,    34,    35,    36,    -1,    38,    -1,
      -1,    41,    42,    43,    44,    45,    46,    47,    48,    -1,
      -1,    -1,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    -1,    -1,    -1,    67,    68,    -1,
      -1,    71,    -1,    -1,    -1,    75,    76,    77,    78,    79,
      -1,    81,    -1,    83,    -1,    85,    86,    87,    10,    89,
      -1,    91,    92,    -1,    -1,    95,    -1,    -1,    20,    21,
      22,    23,    -1,    -1,    -1,    27,    -1,    29,    30,    31,
      32,    -1,    34,    35,    36,    -1,    38,    -1,    -1,    41,
      42,    43,    44,    45,    46,    47,    48,    -1,    -1,    -1,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    -1,    -1,    -1,    67,    68,    -1,    -1,    71,
      -1,    -1,    -1,    75,    76,    77,    78,    79,    -1,    81,
      -1,    83,    -1,    85,    86,    87,    -1,    89,    -1,    91,
      92,    -1,    -1,    95
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_int16 yystos[] =
{
       0,   127,   128,     0,     1,    24,    49,    55,    82,   115,
     123,   134,   135,   136,   141,   153,   158,   177,   178,   179,
     282,    24,   115,   117,     6,    27,    29,    33,    34,    36,
      43,    45,    47,    51,    52,    53,    58,    60,    61,    63,
      67,    68,    71,    76,    78,    83,    86,    87,    90,    91,
     100,   125,   188,   190,   191,   192,   259,   260,   312,   313,
     314,   315,   349,   350,   351,   354,   362,   363,     1,     5,
       7,     8,     9,    15,    21,    22,    24,    28,    41,    44,
      48,    50,    52,    56,    57,    59,    65,    75,    77,    78,
      79,    81,    89,    92,    95,   109,   110,   114,   119,   120,
     144,   149,   158,   170,   183,   184,   233,   248,   250,   289,
     311,   315,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   347,   348,   353,   354,   356,   358,   363,   369,   119,
       4,   233,    24,   115,   295,   115,   116,   180,     4,    32,
      42,    56,    85,   124,   182,   270,   278,   119,   212,     1,
     119,    10,    20,    21,    22,    23,    27,    29,    30,    31,
      32,    34,    35,    36,    38,    42,    43,    45,    46,    47,
      48,    52,    53,    54,    55,    58,    60,    61,    62,    63,
      67,    68,    71,    76,    78,    83,    85,    86,    87,    91,
     366,   367,   368,   369,    33,   119,   119,   119,   202,    33,
     125,   102,   162,    33,   119,   199,   119,   211,   119,   213,
     119,   201,   201,    33,   119,   199,   200,   119,    33,    52,
      52,   104,   115,   118,    65,   125,   208,   125,   208,    33,
       1,    52,    58,   366,   367,   362,   144,   320,   320,   149,
     324,   119,   357,     1,   119,   124,   226,   355,   225,   324,
     324,   324,     1,   124,   149,   189,   191,   336,   339,   149,
     185,   189,   192,   315,   336,   354,   359,   360,   324,   324,
     115,    62,   125,   208,     3,     8,     9,   144,   146,   149,
     316,    73,   111,   112,   113,   109,   110,    16,    17,    12,
      13,   107,   108,    11,    14,   106,   105,   104,    18,    19,
      25,    26,    37,    66,    69,    70,    72,    74,    80,    84,
      94,   101,   102,   103,   337,   338,    32,   266,   278,   336,
     115,   123,   177,   178,    44,    57,    58,    59,    75,    77,
      79,    81,    88,    89,    92,    95,   170,   171,   140,   189,
     225,   279,   132,   133,   188,   157,    29,    36,    43,   181,
     186,   188,     1,     7,    99,   110,   116,   188,   193,   195,
     197,   198,   363,   364,    52,     1,   188,     1,   188,   203,
      52,   163,   198,   188,   214,     1,   188,   363,   364,    52,
     366,   116,   198,     1,   336,    52,   366,   162,   190,   259,
     209,    52,   366,    52,   366,    33,    33,    33,   189,     1,
     336,   355,     1,   185,   187,   189,   339,   340,   227,     1,
     123,   304,   306,   307,   336,    24,   115,   117,   122,   306,
     308,   309,   310,   336,   104,   122,   118,   122,   360,    52,
     121,   118,   361,   121,   225,   225,   225,   306,     1,     1,
      24,   108,   111,   336,   340,   352,    96,    97,    98,   145,
     317,     1,   322,     1,   324,     1,   324,     1,   324,     1,
     325,     1,   325,     1,   326,     1,   326,     1,   327,     1,
     327,     1,   327,     1,   327,     1,   328,     1,   328,     1,
     329,     1,   330,     1,   331,     1,   332,     1,   333,   339,
       1,   336,   225,   118,     1,    52,   137,   138,   368,    52,
     273,   366,    52,   160,   366,     1,   116,   130,   131,   289,
     273,   128,   119,   119,   119,     4,   152,     7,   188,   122,
      39,    40,   196,   104,   116,   122,     1,   109,   118,   122,
     122,   122,   122,   118,   188,   205,   206,   305,   188,   122,
     122,   188,   122,   122,   122,   198,   116,    24,   115,   117,
     122,   122,   205,    24,   115,   117,   122,     1,   118,    24,
     115,   117,   122,    52,   220,   232,   366,   122,   225,    24,
      64,   115,   117,   122,   336,    64,   122,   118,   305,   117,
     147,   121,   150,   118,   305,    24,   115,   116,   117,   301,
     190,   336,   121,   102,   161,   359,     1,   337,   249,    52,
       1,     4,    10,    20,    21,    22,    23,    27,    28,    29,
      30,    31,    32,    34,    35,    36,    38,    41,    42,    43,
      44,    45,    46,    47,    48,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    67,
      68,    71,    75,    76,    77,    78,    79,    81,    82,    83,
      85,    86,    87,    88,    89,    91,    92,    93,    95,   172,
     173,   174,   175,   176,   122,    24,   115,   117,   122,    24,
     115,   117,   121,   122,    24,   340,   121,   121,   196,   225,
     225,   306,     3,   144,   149,   116,   267,   336,    24,   102,
     115,   117,   102,   115,   118,   102,   271,   124,    24,   115,
     117,     1,     6,    52,   129,   365,   366,   115,   115,    24,
     117,   148,   364,   122,   122,    52,   217,   218,   366,   122,
     193,   194,   197,   122,   188,   122,   363,   188,    39,    40,
     159,   118,   305,   116,   122,   122,   198,   210,    24,   115,
     117,   122,   336,   102,   118,   102,   228,   304,   122,   122,
       1,   310,   336,     1,   336,   336,   361,   336,   247,   124,
     345,   345,   352,   176,   336,   352,   122,   225,   306,   336,
     352,   336,   268,   122,   289,   289,   139,   289,   272,   280,
       6,   109,   118,   305,   102,   151,   115,   118,   102,   156,
     122,   122,   116,   207,   215,   122,    64,     1,   361,   221,
     223,   224,   220,   222,   229,     1,   119,   167,   225,   121,
     121,   196,   345,   176,   122,   121,   196,   269,     1,   137,
      65,   261,   263,     1,   273,   275,   277,     6,   122,     1,
      24,   219,     1,   119,    52,   218,   366,   336,   119,   204,
     188,   188,    24,   115,   117,   122,   122,   336,     1,    24,
     336,   237,   149,   164,   168,   169,   188,   305,   251,   247,
     352,   345,   352,   263,   260,   247,     1,    24,   124,   264,
     102,   274,   118,   281,   336,   154,   168,   188,   216,     1,
       4,    20,    23,    24,    30,    31,    34,    35,    38,    46,
      52,    54,    93,   115,   117,   135,   170,   187,   226,   230,
     236,   238,   239,   240,   241,   244,   245,   246,   254,   285,
     292,   294,   296,   297,   299,   300,   302,   303,   340,   343,
     348,   166,   122,   116,   118,   305,   159,     1,    24,   142,
     226,   231,   346,   121,   121,   264,   262,   119,   128,   289,
     276,   230,   168,   122,   122,   122,    24,   115,   117,     1,
      52,   234,   235,   366,   284,   284,    52,   243,     1,   196,
     340,   341,   243,   116,   225,   284,   242,   284,   284,   187,
      52,   252,   295,   295,    10,   295,    32,   270,   360,   164,
     164,   165,   237,    64,   179,   256,   257,   258,   305,   265,
     275,   122,     1,    24,   115,   142,   143,    24,   102,   115,
     117,   102,   115,   118,   102,   283,   283,   341,   196,   301,
     240,   283,   116,   283,   283,    52,   151,   295,   341,   225,
     121,   160,   230,   186,   116,   118,   305,   122,   230,   155,
     289,   289,     1,   234,   289,   225,   225,   301,   341,   342,
      24,    93,   225,   240,   225,   225,   151,     1,   167,   295,
     161,   161,   159,   256,   256,   143,   119,   119,   301,    24,
     119,   119,   119,   119,     1,   167,   253,    52,   366,   341,
     336,   341,     1,   343,   344,   341,   341,   255,   231,   161,
      24,   117,   122,   286,   115,   118,   291,   286,   295,   286,
     286,   231,   240,     1,   288,   290,   359,   288,   286,   295,
     298,   341,   240,   240,   115,   293,   295,    41,   287,   290,
     240,   344,   240,   286,   240
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_int16 yyr1[] =
{
       0,   126,   127,   127,   128,   128,   128,   129,   129,   130,
     130,   130,   130,   131,   133,   132,   134,   134,   134,   134,
     135,   136,   137,   137,   137,   138,   139,   138,   140,   140,
     141,   141,   141,   141,   142,   143,   143,   143,   143,   144,
     145,   146,   147,   147,   148,   148,   149,   150,   150,   151,
     152,   152,   154,   155,   153,   153,   156,   153,   153,   153,
     153,   153,   153,   153,   153,   153,   153,   153,   153,   153,
     153,   153,   157,   153,   158,   159,   159,   159,   160,   160,
     160,   161,   161,   161,   162,   163,   162,   165,   164,   166,
     164,   167,   168,   168,   169,   169,   169,   170,   170,   171,
     171,   171,   171,   171,   171,   171,   171,   171,   171,   171,
     171,   171,   172,   172,   172,   172,   172,   172,   172,   172,
     172,   172,   172,   172,   172,   172,   172,   173,   173,   173,
     173,   173,   173,   173,   173,   173,   173,   173,   173,   173,
     173,   173,   173,   173,   173,   174,   174,   174,   174,   174,
     174,   174,   174,   174,   174,   174,   174,   174,   174,   174,
     174,   174,   174,   174,   174,   174,   174,   174,   175,   175,
     175,   176,   176,   176,   177,   178,   178,   179,   180,   180,
     181,   181,   181,   181,   181,   182,   182,   183,   184,   185,
     185,   186,   187,   188,   188,   189,   189,   190,   190,   191,
     191,   191,   191,   191,   191,   191,   191,   191,   191,   191,
     191,   191,   191,   191,   191,   191,   191,   191,   191,   192,
     192,   193,   193,   194,   194,   195,   195,   196,   196,   197,
     197,   197,   197,   198,   198,   199,   199,   200,   200,   200,
     200,   201,   201,   201,   201,   203,   204,   202,   202,   205,
     205,   206,   207,   206,   208,   209,   210,   208,   211,   211,
     212,   212,   212,   212,   212,   212,   214,   215,   216,   213,
     213,   217,   217,   218,   218,   219,   218,   218,   218,   218,
     220,   220,   221,   220,   222,   220,   223,   220,   224,   220,
     225,   227,   228,   229,   226,   230,   230,   231,   231,   231,
     232,   232,   233,   234,   234,   234,   235,   235,   236,   236,
     236,   236,   237,   237,   238,   239,   239,   239,   239,   239,
     239,   239,   239,   239,   239,   239,   239,   240,   240,   240,
     240,   240,   240,   240,   240,   240,   240,   240,   240,   242,
     241,   243,   243,   244,   245,   245,   246,   247,   248,   248,
     249,   251,   250,   250,   253,   252,   252,   255,   254,   254,
     256,   256,   256,   257,   257,   257,   258,   258,   259,   259,
     259,   260,   260,   261,   262,   261,   263,   263,   265,   264,
     264,   264,   267,   268,   269,   266,   271,   272,   270,   273,
     273,   274,   274,   275,   275,   276,   277,   277,   277,   279,
     280,   281,   278,   282,   283,   284,   285,   286,   286,   286,
     287,   287,   288,   288,   289,   289,   289,   290,   290,   291,
     291,   293,   292,   294,   294,   294,   295,   295,   296,   297,
     298,   298,   299,   300,   300,   300,   301,   301,   301,   301,
     302,   302,   302,   303,   303,   304,   304,   305,   305,   306,
     306,   307,   307,   308,   308,   309,   309,   309,   310,   310,
     311,   311,   311,   311,   311,   311,   311,   311,   311,   311,
     311,   311,   312,   312,   312,   313,   313,   313,   313,   313,
     313,   313,   313,   313,   313,   314,   314,   314,   315,   315,
     316,   317,   317,   317,   317,   317,   317,   317,   317,   318,
     318,   318,   318,   318,   318,   318,   318,   318,   318,   318,
     318,   318,   318,   318,   318,   318,   318,   318,   318,   318,
     318,   318,   318,   318,   318,   319,   319,   319,   319,   319,
     320,   320,   321,   321,   321,   322,   322,   322,   323,   323,
     323,   323,   323,   324,   324,   324,   325,   325,   325,   325,
     325,   325,   325,   326,   326,   326,   326,   326,   327,   327,
     327,   327,   327,   328,   328,   328,   328,   328,   328,   328,
     328,   328,   329,   329,   329,   329,   329,   330,   330,   330,
     331,   331,   331,   332,   332,   332,   333,   333,   333,   334,
     334,   334,   335,   335,   336,   336,   336,   336,   336,   337,
     338,   338,   338,   338,   338,   338,   338,   338,   338,   338,
     338,   338,   338,   339,   339,   340,   340,   341,   341,   342,
     342,   343,   344,   344,   344,   345,   346,   345,   347,   347,
     347,   347,   347,   348,   349,   349,   350,   350,   350,   350,
     350,   350,   351,   351,   351,   351,   352,   352,   352,   352,
     352,   353,   354,   354,   354,   354,   354,   355,   355,   355,
     355,   355,   355,   355,   357,   356,   358,   358,   358,   358,
     358,   358,   358,   358,   358,   358,   358,   358,   358,   359,
     359,   359,   360,   361,   361,   362,   362,   363,   363,   364,
     364,   365,   365,   365,   366,   366,   367,   367,   367,   367,
     367,   367,   367,   367,   367,   367,   367,   367,   367,   367,
     367,   367,   368,   368,   368,   368,   368,   368,   368,   368,
     368,   368,   368,   368,   368,   368,   368,   368,   368,   368,
     368,   368,   368,   368,   369,   369,   369,   369,   369,   369,
     369,   369,   369,   369,   369,   369,   369
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     1,     2,     2,     2,     0,     1,     1,     2,
       2,     2,     0,     1,     0,     2,     5,     5,     5,     5,
       3,     3,     3,     3,     3,     1,     0,     4,     0,     1,
       5,     5,     5,     5,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     0,     1,     1,     1,     1,     0,     0,
       0,     1,     0,     0,    12,     7,     0,    10,     6,     1,
       1,     1,     1,     2,     2,     2,     3,     1,     2,     2,
       2,     2,     0,     5,     6,     1,     1,     0,     1,     1,
       0,     2,     1,     0,     0,     0,     3,     0,     5,     0,
       5,     3,     1,     2,     1,     3,     3,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     2,     0,     3,     2,     0,     2,
       5,     3,     1,     3,     1,     0,     2,     3,     3,     1,
       1,     1,     1,     3,     1,     3,     1,     1,     1,     1,
       1,     1,     1,     1,     2,     2,     2,     2,     2,     2,
       2,     2,     6,     5,     2,     4,     4,     4,     4,     1,
       1,     1,     2,     0,     1,     0,     1,     1,     1,     1,
       3,     1,     1,     1,     3,     0,     3,     1,     5,     4,
       4,     0,     3,     3,     3,     0,     0,     8,     0,     1,
       2,     1,     0,     4,     0,     0,     0,     5,     3,     0,
       3,     0,     5,     4,     4,     3,     0,     0,     0,     8,
       0,     1,     3,     1,     1,     0,     4,     3,     3,     3,
       1,     1,     0,     4,     0,     4,     0,     4,     0,     4,
       0,     0,     0,     0,     7,     1,     1,     1,     1,     1,
       1,     3,     1,     3,     3,     3,     1,     3,     3,     3,
       3,     3,     0,     2,     2,     1,     1,     1,     1,     1,
       1,     2,     2,     2,     2,     2,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     2,     1,     2,     0,
       4,     1,     0,     2,     2,     1,     2,     0,     0,     1,
       0,     0,     8,     6,     0,     5,     3,     0,     7,     5,
       5,     4,     3,     1,     3,     3,     1,     2,     0,     3,
       2,     1,     3,     0,     0,     4,     1,     5,     0,     4,
       1,     1,     0,     0,     0,     7,     0,     0,     7,     1,
       1,     0,     2,     0,     2,     0,     1,     4,     1,     0,
       0,     0,     8,     5,     0,     0,     9,     1,     1,     1,
       0,     2,     1,     1,     1,     1,     1,     0,     1,     2,
       4,     0,    10,     8,     5,     4,     1,     1,    12,     8,
       0,     1,     8,     3,     5,     4,     1,     1,     1,     1,
       0,     1,     1,     3,     4,     1,     2,     0,     1,     0,
       2,     1,     3,     0,     2,     1,     3,     3,     3,     3,
       1,     1,     1,     5,     5,     4,     4,     4,     4,     4,
       4,     4,     1,     3,     3,     3,     3,     3,     3,     3,
       2,     2,     2,     2,     2,     1,     3,     3,     2,     2,
       0,     4,     6,     3,     4,     4,     6,     4,     5,     1,
       1,     1,     1,     1,     1,     1,     2,     2,     1,     4,
       4,     4,     6,     4,     4,     4,     4,     4,     3,     3,
       3,     3,     3,     4,     4,     1,     2,     1,     2,     2,
       1,     3,     1,     2,     2,     1,     3,     3,     1,     2,
       2,     2,     2,     1,     2,     2,     1,     3,     3,     3,
       3,     3,     3,     1,     3,     3,     3,     3,     1,     3,
       3,     3,     3,     1,     3,     3,     3,     3,     3,     3,
       3,     3,     1,     3,     3,     3,     3,     1,     3,     3,
       1,     3,     3,     1,     3,     3,     1,     3,     3,     1,
       3,     3,     1,     5,     1,     3,     3,     5,     4,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     3,     1,     2,     1,     1,     0,
       1,     1,     0,     1,     1,     0,     0,     6,     5,     5,
       4,     4,     4,     0,     1,     1,     2,     2,     2,     3,
       3,     3,     1,     2,     3,     1,     0,     1,     2,     1,
       2,     2,     4,     4,     4,     4,     4,     3,     3,     3,
       3,     3,     1,     1,     0,     3,     7,     7,     7,     7,
       7,     5,     5,     5,     5,     4,     4,     4,     4,     1,
       3,     3,     2,     0,     3,     1,     1,     1,     2,     1,
       3,     1,     2,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
# ifndef YY_LOCATION_PRINT
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif


# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yykind < YYNTOKENS)
    YYPRINT (yyo, yytoknum[yykind], *yyvaluep);
# endif
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)]);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep)
{
  YY_USE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}






/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
/* Lookahead token kind.  */
int yychar;


/* The semantic value of the lookahead symbol.  */
/* Default value used for initialization, for pacifying older GCCs
   or non-GCC compilers.  */
YY_INITIAL_VALUE (static YYSTYPE yyval_default;)
YYSTYPE yylval YY_INITIAL_VALUE (= yyval_default);

    /* Number of syntax errors so far.  */
    int yynerrs = 0;

    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    goto yyexhaustedlab;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex (&yylval);
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 2: /* all: program  */
#line 468 "language.yacc"
             { YYACCEPT; }
#line 4606 "y.tab.c"
    break;

  case 3: /* all: program "end of file"  */
#line 469 "language.yacc"
                        { YYACCEPT; }
#line 4612 "y.tab.c"
    break;

  case 9: /* optional_rename_inherit: ':' real_string_or_identifier  */
#line 482 "language.yacc"
                                                       { (yyval.n)=(yyvsp[0].n); }
#line 4618 "y.tab.c"
    break;

  case 10: /* optional_rename_inherit: ':' bad_identifier  */
#line 483 "language.yacc"
                       { (yyval.n)=0; }
#line 4624 "y.tab.c"
    break;

  case 11: /* optional_rename_inherit: ':' error  */
#line 484 "language.yacc"
              { (yyval.n)=0; }
#line 4630 "y.tab.c"
    break;

  case 12: /* optional_rename_inherit: %empty  */
#line 485 "language.yacc"
    { (yyval.n)=0; }
#line 4636 "y.tab.c"
    break;

  case 13: /* low_program_ref: safe_assignment_expr  */
#line 492 "language.yacc"
  {
    node *n = (yyvsp[0].n);
    node *bindings = NULL;

    STACK_LEVEL_START(0);

    while (n) {
      switch (n->token) {
      case F_BIND_GENERICS:
        if (!bindings) {
          bindings = CDR(n);
          add_ref(bindings);
        }
        n = CAR(n);
        continue;
      case F_EXTERNAL:
      case F_GET_SET:
	(yyval.n) = n;
	add_ref(n);
	free_node((yyvsp[0].n));
	goto got_program_ref;
      case F_APPLY:
	{
	  if ((CAR(n)->token == F_CONSTANT) &&
	      (TYPEOF(CAR(n)->u.sval) == T_FUNCTION) &&
	      (SUBTYPEOF(CAR(n)->u.sval) == FUNCTION_BUILTIN) &&
	      (CAR(n)->u.sval.u.efun->function == debug_f_aggregate)) {
	    /* Disambiguate multiple inherit ::-reference. */
	    node *arg;
	    while(1) {
	      while ((arg = CDR(n))) {
		n = arg;
		if (n->token != F_ARG_LIST) goto found_program_ref;
	      }
	      /* Paranoia. */
	      if ((arg = CAR(n))) {
		n = arg;
		continue;
	      }
	      /* FIXME: Ought to go up a level and try the car there...
	       *        But as this code probably won't be reached, we
	       *        just fail.
	       */
	      yyerror("Failed to get last argument from empty array.");
	      n = NULL;
	      break;
	    }
	  found_program_ref:
	    /* NB: The traditional C grammar requires a statement
	     *     after a label.
	     */
	    continue;
	  }
	}
	/* FALLTHRU */
      default:
	/* Evaluate the expression. */
	break;
      }
      break;
    }

    resolv_constant(n);
    free_node((yyvsp[0].n));

    if (TYPEOF(Pike_sp[-1]) == T_STRING) {
      if (call_handle_inherit(Pike_sp[-1].u.string)) {
	STACK_LEVEL_CHECK(2);
	(yyval.n) = mksvaluenode(Pike_sp-1);
	pop_stack();
      }
      else
	(yyval.n) = mknewintnode(0);
      STACK_LEVEL_CHECK(1);
      if((yyval.n)->name) free_string((yyval.n)->name);
#ifdef PIKE_DEBUG
      if (TYPEOF(Pike_sp[-1]) != T_STRING) {
	Pike_fatal("Compiler lost track of program name.\n");
      }
#endif /* PIKE_DEBUG */

      add_ref( (yyval.n)->name=Pike_sp[-1].u.string );
    } else {
      (yyval.n) = mksvaluenode(Pike_sp-1);
      pop_stack();

    got_program_ref:
      STACK_LEVEL_CHECK(0);
      if (Pike_compiler->last_identifier) {
	ref_push_string(Pike_compiler->last_identifier);
      } else {
	push_empty_string();
      }
    }

    if (bindings) {
      (yyval.n) = mknode(F_BIND_GENERICS, (yyval.n), bindings);
    }

    STACK_LEVEL_DONE(1);
  }
#line 4742 "y.tab.c"
    break;

  case 14: /* @1: %empty  */
#line 596 "language.yacc"
  {
    SET_FORCE_RESOLVE((yyval.number));
  }
#line 4750 "y.tab.c"
    break;

  case 15: /* inherit_ref: @1 low_program_ref  */
#line 600 "language.yacc"
  {
    UNSET_FORCE_RESOLVE((yyvsp[-1].number));
    (yyval.n) = (yyvsp[0].n);
  }
#line 4759 "y.tab.c"
    break;

  case 16: /* inheritance: modifiers "inherit" inherit_ref optional_rename_inherit ';'  */
#line 607 "language.yacc"
  {
    if (((yyvsp[-4].number) & ID_EXTERN) &&
	(Pike_compiler->compiler_pass == COMPILER_PASS_FIRST)) {
      yywarning("Extern declared inherit.");
    }

    if((yyvsp[-2].n))
    {
      struct pike_string *s=Pike_sp[-1].u.string;
      if((yyvsp[-1].n)) s = (yyvsp[-1].n)->u.sval.u.string;

      if ((yyvsp[-2].n)->token == F_BIND_GENERICS) {
        compiler_do_inherit(CAR((yyvsp[-2].n)), (yyvsp[-4].number), s, CDR((yyvsp[-2].n))->u.sval.u.array);
      } else {
        compiler_do_inherit((yyvsp[-2].n), (yyvsp[-4].number), s, NULL);
      }
    }

    if((yyvsp[-1].n)) free_node((yyvsp[-1].n));
    pop_stack();
    if ((yyvsp[-2].n)) free_node((yyvsp[-2].n));
  }
#line 4786 "y.tab.c"
    break;

  case 17: /* inheritance: modifiers "inherit" inherit_ref error ';'  */
#line 630 "language.yacc"
  {
    if ((yyvsp[-2].n)) free_node((yyvsp[-2].n));
    pop_stack();
    yyerrok;
  }
#line 4796 "y.tab.c"
    break;

  case 18: /* inheritance: modifiers "inherit" inherit_ref error "end of file"  */
#line 636 "language.yacc"
  {
    if ((yyvsp[-2].n)) free_node((yyvsp[-2].n));
    pop_stack();
    yyerror("Missing ';'.");
    yyerror("Unexpected end of file.");
  }
#line 4807 "y.tab.c"
    break;

  case 19: /* inheritance: modifiers "inherit" inherit_ref error '}'  */
#line 643 "language.yacc"
  {
    if ((yyvsp[-2].n)) free_node((yyvsp[-2].n));
    pop_stack();
    yyerror("Missing ';'.");
  }
#line 4817 "y.tab.c"
    break;

  case 20: /* import: "import" constant_expr ';'  */
#line 651 "language.yacc"
  {
    resolv_constant((yyvsp[-1].n));
    free_node((yyvsp[-1].n));
    if (TYPEOF(Pike_sp[-1]) != PIKE_T_STRING || call_handle_import()) {
      use_module(Pike_sp-1);
      pop_stack();
    }
  }
#line 4830 "y.tab.c"
    break;

  case 22: /* constant_name: "identifier" '=' safe_assignment_expr  */
#line 665 "language.yacc"
  {
    /* This can be made more lenient in the future */

    /* Ugly hack to make sure that $3 is optimized */
    {
      int tmp=Pike_compiler->compiler_pass;
      (yyvsp[0].n)=mknode(F_COMMA_EXPR,(yyvsp[0].n),0);
      Pike_compiler->compiler_pass=tmp;
    }

    if (Pike_compiler->current_modifiers & ID_EXTERN) {
      int depth = 0;
      struct program_state *state = Pike_compiler;
      node *n = (yyvsp[0].n);
      while (((n->token == F_COMMA_EXPR) || (n->token == F_ARG_LIST)) &&
	     ((!CAR(n)) ^ (!CDR(n)))) {
	if (CAR(n)) n = CAR(n);
	else n = CDR(n);
      }
      if (n->token == F_EXTERNAL) {
	while (state && (state->new_program->id != n->u.integer.a)) {
	  depth++;
	  state = state->previous;
	}
      }
      if (depth && state) {
	/* Alias for a symbol in a surrounding scope. */
	int id = really_low_reference_inherited_identifier(state, 0,
							   n->u.integer.b);
	define_alias((yyvsp[-2].n)->u.sval.u.string, n->type,
		     Pike_compiler->current_modifiers & ~ID_EXTERN,
		     depth, id);
      } else if (Pike_compiler->compiler_pass == COMPILER_PASS_FIRST) {
	yyerror("Invalid extern declared constant.");
	add_constant((yyvsp[-2].n)->u.sval.u.string, &svalue_undefined,
		     Pike_compiler->current_modifiers & ~ID_EXTERN);
      }
    } else {
      if(!is_const((yyvsp[0].n))) {
        yyerror_not_constant("Constant", (yyvsp[0].n));
	add_constant((yyvsp[-2].n)->u.sval.u.string, 0,
		     Pike_compiler->current_modifiers & ~ID_EXTERN);
      } else {
	if(!Pike_compiler->num_parse_error)
	{
	  ptrdiff_t tmp=eval_low((yyvsp[0].n),1);
	  if(tmp < 1)
	  {
	    yyerror("Error in constant definition.");
	    push_undefined();
	  }else{
            pop_n_elems((INT32)(tmp - 1));
	  }
	} else {
	  push_undefined();
	}
        if ((yyvsp[-3].n)) {
          /* New-style syntax for typed constants. */
          struct pike_type *t = (yyvsp[-3].n)->u.sval.u.type;
          if (!pike_types_le((yyvsp[0].n)->type, t, 0, 0)) {
            yytype_report(REPORT_ERROR, NULL, 0, t, NULL, 0, (yyvsp[0].n)->type,
                          0, "Bad value for constant.");
            t = NULL;
          }
          add_typed_constant((yyvsp[-2].n)->u.sval.u.string, t, Pike_sp-1,
                             Pike_compiler->current_modifiers & ~ID_EXTERN);
        } else if ((Pike_compiler->current_modifiers & ID_LOCAL) ||
                   ((yyvsp[0].n)->token == F_SOFT_CAST) ||
                   (((yyvsp[0].n)->token == F_COMMA_EXPR) &&
                    (CAR((yyvsp[0].n))->token == F_SOFT_CAST))) {
          /* Node type set intentionally via a soft-cast,
           * or value is not overridable via inherit.
           */
          add_typed_constant((yyvsp[-2].n)->u.sval.u.string, (yyvsp[0].n)->type, Pike_sp-1,
                             Pike_compiler->current_modifiers & ~ID_EXTERN);
        } else {
          /* Compat: Derive the type from the value.
           *
           * Cf LysLysKOM 16630665.
           */
          add_typed_constant((yyvsp[-2].n)->u.sval.u.string, NULL, Pike_sp-1,
                             Pike_compiler->current_modifiers & ~ID_EXTERN);
        }
	pop_stack();
      }
    }
    if((yyvsp[0].n)) free_node((yyvsp[0].n));
    free_node((yyvsp[-2].n));
  }
#line 4924 "y.tab.c"
    break;

  case 23: /* constant_name: bad_const_expr_ident '=' safe_assignment_expr  */
#line 754 "language.yacc"
                                                  { if ((yyvsp[0].n)) free_node((yyvsp[0].n)); }
#line 4930 "y.tab.c"
    break;

  case 24: /* constant_name: error '=' safe_assignment_expr  */
#line 755 "language.yacc"
                                   { if ((yyvsp[0].n)) free_node((yyvsp[0].n)); }
#line 4936 "y.tab.c"
    break;

  case 26: /* @2: %empty  */
#line 759 "language.yacc"
                      { (yyval.n) = (yyvsp[-2].n); }
#line 4942 "y.tab.c"
    break;

  case 28: /* optional_type: %empty  */
#line 762 "language.yacc"
                           { (yyval.n) = NULL; }
#line 4948 "y.tab.c"
    break;

  case 29: /* optional_type: type  */
#line 764 "language.yacc"
  {
    struct pike_type *t = compiler_pop_type();
    (yyval.n) = mktypenode(t);
    free_type(t);
  }
#line 4958 "y.tab.c"
    break;

  case 30: /* constant: modifiers "constant" optional_type constant_list ';'  */
#line 772 "language.yacc"
  {
    free_node((yyvsp[-2].n));
  }
#line 4966 "y.tab.c"
    break;

  case 31: /* constant: modifiers "constant" optional_type error ';'  */
#line 776 "language.yacc"
  {
    free_node((yyvsp[-2].n));
    yyerrok;
  }
#line 4975 "y.tab.c"
    break;

  case 32: /* constant: modifiers "constant" optional_type error "end of file"  */
#line 781 "language.yacc"
  {
    free_node((yyvsp[-2].n));
    yyerror("Missing ';'.");
    yyerror("Unexpected end of file.");
  }
#line 4985 "y.tab.c"
    break;

  case 33: /* constant: modifiers "constant" optional_type error '}'  */
#line 787 "language.yacc"
  {
    free_node((yyvsp[-2].n));
    yyerror("Missing ';'.");
  }
#line 4994 "y.tab.c"
    break;

  case 34: /* function_block: block  */
#line 794 "language.yacc"
  {
    (yyval.n) = mknode(F_COMMA_EXPR,(yyvsp[0].n),mknode(F_RETURN,mkintnode(0),0));
    COPY_LINE_NUMBER_INFO((yyval.n), (yyvsp[0].n));
  }
#line 5003 "y.tab.c"
    break;

  case 36: /* block_or_semi: ';'  */
#line 801 "language.yacc"
        { (yyval.n) = NULL; }
#line 5009 "y.tab.c"
    break;

  case 37: /* block_or_semi: "end of file"  */
#line 802 "language.yacc"
                { yyerror("Expected ';'."); (yyval.n) = NULL; }
#line 5015 "y.tab.c"
    break;

  case 38: /* block_or_semi: error  */
#line 803 "language.yacc"
          { (yyval.n) = NULL; }
#line 5021 "y.tab.c"
    break;

  case 39: /* open_paren_with_line_info: '('  */
#line 808 "language.yacc"
  {
    /* Used to hold line-number info */
    (yyval.n) = mkintnode(0);
  }
#line 5030 "y.tab.c"
    break;

  case 40: /* safe_apply_with_line_info: "(?"  */
#line 815 "language.yacc"
  {
    /* Used to hold line-number info */
    (yyval.n) = mkintnode(0);
  }
#line 5039 "y.tab.c"
    break;

  case 43: /* close_brace_or_missing: %empty  */
#line 827 "language.yacc"
  {
    yyerror("Missing '}'.");
  }
#line 5047 "y.tab.c"
    break;

  case 45: /* close_brace_or_eof: "end of file"  */
#line 834 "language.yacc"
  {
    yyerror("Missing '}'.");
  }
#line 5055 "y.tab.c"
    break;

  case 46: /* open_bracket_with_line_info: '['  */
#line 840 "language.yacc"
  {
    /* Used to hold line-number info */
    (yyval.n) = mkintnode(0);
  }
#line 5064 "y.tab.c"
    break;

  case 48: /* close_bracket_or_missing: %empty  */
#line 848 "language.yacc"
  {
    yyerror("Missing ']'.");
  }
#line 5072 "y.tab.c"
    break;

  case 49: /* start_function: %empty  */
#line 868 "language.yacc"
  {
    push_compiler_frame(SCOPE_LOCAL);

    if(!Pike_compiler->compiler_frame->previous ||
       !Pike_compiler->compiler_frame->previous->current_type)
    {
      yyerror("Internal compiler error (start_function).");
      copy_pike_type(Pike_compiler->compiler_frame->current_return_type,
                     any_type_string);
    }else{
      copy_pike_type(Pike_compiler->compiler_frame->current_return_type,
		     Pike_compiler->compiler_frame->previous->current_type);
    }

    (yyval.ptr) = Pike_compiler->compiler_frame;
  }
#line 5093 "y.tab.c"
    break;

  case 50: /* optional_constant: %empty  */
#line 887 "language.yacc"
  {
    (yyval.number) = OPT_EXTERNAL_DEPEND|OPT_SIDE_EFFECT;
  }
#line 5101 "y.tab.c"
    break;

  case 51: /* optional_constant: "constant"  */
#line 891 "language.yacc"
  {
    (yyval.number) = 0;
  }
#line 5109 "y.tab.c"
    break;

  case 52: /* @3: %empty  */
#line 899 "language.yacc"
  {
    (yyval.number) = 0;
    /* Check for the (very special) case of create and create_args. */
    if (Pike_compiler->num_create_args) {
      struct pike_string *create_string = NULL;
      int e;
      MAKE_CONST_STRING(create_string, "create");
      if ((yyvsp[-2].n)->u.sval.u.string == create_string) {
	/* Prepend the create arguments. */
	if (Pike_compiler->num_create_args < 0) {
	  /* __create__() has varargs.
	   * Inhibit further arguments in the explicit create().
	   */
          Pike_compiler->compiler_frame->varargs = 1;
	  for (e = 0; e < -Pike_compiler->num_create_args; e++) {
	    struct identifier *id =
              Pike_compiler->new_program->identifiers + e;
	    add_ref(id->type);
	    add_local_name(empty_pike_string, id->type, 0);
	    /* Note: add_local_name() above will return e. */
            bind_local(NULL, e);
	    Pike_compiler->compiler_frame->local_names[e].flags |=
	      LOCAL_VAR_IS_USED;
	  }
	} else {
	  for (e = 0; e < Pike_compiler->num_create_args; e++) {
	    struct identifier *id =
              Pike_compiler->new_program->identifiers + e;
	    add_ref(id->type);
	    add_local_name(empty_pike_string, id->type, 0);
	    /* Note: add_local_name() above will return e. */
            bind_local(NULL, e);
	    Pike_compiler->compiler_frame->local_names[e].flags |=
	      LOCAL_VAR_IS_USED;
	  }
	}
	(yyval.number) = e;
      }
    }
  }
#line 5154 "y.tab.c"
    break;

  case 53: /* @4: %empty  */
#line 940 "language.yacc"
  {
    int id;

    /* Adjust opt_flags in case we've got an optional_constant. */
    Pike_compiler->compiler_frame->opt_flags = (yyvsp[-6].number);

    id = compiler_declare_prototype((yyvsp[-9].number) & (~ID_EXTERN), (yyvsp[-5].n)->u.sval.u.string,
                                    (yyvsp[-1].number), (yyvsp[-2].number), (yyvsp[-6].number));

    (yyval.n) = mktypenode(ID_FROM_INT(Pike_compiler->new_program, id)->type);
  }
#line 5170 "y.tab.c"
    break;

  case 54: /* def: modifiers optional_attributes simple_type optional_constant "identifier" start_function '(' @3 arguments ')' @4 block_or_semi  */
#line 952 "language.yacc"
  {
    compiler_define_function((yyvsp[-11].number), (yyvsp[-7].n)->u.sval.u.string, (yyvsp[-1].n)->u.sval.u.type,
                             (yyvsp[0].n), (yyvsp[-3].number), (yyvsp[-4].number), (yyvsp[-8].number));
#ifdef PIKE_DEBUG
    if (Pike_compiler->compiler_frame != (yyvsp[-6].ptr)) {
      Pike_fatal("Lost track of compiler_frame!\n"
		 "  Got: %p (Expected: %p) Previous: %p\n",
		 Pike_compiler->compiler_frame, (yyvsp[-6].ptr),
		 Pike_compiler->compiler_frame->previous);
    }
#endif
    pop_compiler_frame();
    free_node((yyvsp[-7].n));
    free_node((yyvsp[-1].n));
  }
#line 5190 "y.tab.c"
    break;

  case 55: /* def: modifiers optional_attributes simple_type optional_constant "identifier" start_function error  */
#line 970 "language.yacc"
  {
#ifdef PIKE_DEBUG
    if (Pike_compiler->compiler_frame != (yyvsp[-1].ptr)) {
      Pike_fatal("Lost track of compiler_frame!\n"
		 "  Got: %p (Expected: %p) Previous: %p\n",
		 Pike_compiler->compiler_frame, (yyvsp[-1].ptr),
		 Pike_compiler->compiler_frame->previous);
    }
#endif
    pop_compiler_frame();
    free_node((yyvsp[-2].n));
  }
#line 5207 "y.tab.c"
    break;

  case 56: /* $@5: %empty  */
#line 983 "language.yacc"
  {
    compiler_discard_type();
  }
#line 5215 "y.tab.c"
    break;

  case 57: /* def: modifiers optional_attributes simple_type optional_constant bad_identifier $@5 '(' arguments ')' block_or_semi  */
#line 987 "language.yacc"
  {
    if ((yyvsp[0].n)) free_node((yyvsp[0].n));
  }
#line 5223 "y.tab.c"
    break;

  case 59: /* def: inheritance  */
#line 991 "language.yacc"
                {}
#line 5229 "y.tab.c"
    break;

  case 60: /* def: import  */
#line 992 "language.yacc"
           {}
#line 5235 "y.tab.c"
    break;

  case 61: /* def: constant  */
#line 993 "language.yacc"
             {}
#line 5241 "y.tab.c"
    break;

  case 62: /* def: generic  */
#line 994 "language.yacc"
            {}
#line 5247 "y.tab.c"
    break;

  case 63: /* def: modifiers named_class  */
#line 995 "language.yacc"
                          { free_node((yyvsp[0].n)); }
#line 5253 "y.tab.c"
    break;

  case 64: /* def: modifiers enum  */
#line 996 "language.yacc"
                   { free_node((yyvsp[0].n)); }
#line 5259 "y.tab.c"
    break;

  case 65: /* def: annotation ';'  */
#line 998 "language.yacc"
  {
    if (Pike_compiler->compiler_pass == COMPILER_PASS_FIRST) {
      (yyvsp[-1].n) = mknode(F_COMMA_EXPR, (yyvsp[-1].n), NULL);
      compiler_add_program_annotations(0, (yyvsp[-1].n));
    }
    free_node((yyvsp[-1].n));
  }
#line 5271 "y.tab.c"
    break;

  case 66: /* def: '@' "constant" ';'  */
#line 1006 "language.yacc"
  {
    Pike_compiler->new_program->flags |= PROGRAM_CONSTANT;
  }
#line 5279 "y.tab.c"
    break;

  case 67: /* def: typedef  */
#line 1009 "language.yacc"
            {}
#line 5285 "y.tab.c"
    break;

  case 68: /* def: static_assertion expected_semicolon  */
#line 1010 "language.yacc"
                                        {}
#line 5291 "y.tab.c"
    break;

  case 69: /* def: error "end of file"  */
#line 1012 "language.yacc"
  {
    reset_type_stack();
    yyerror("Missing ';'.");
    yyerror("Unexpected end of file");
  }
#line 5301 "y.tab.c"
    break;

  case 70: /* def: error ';'  */
#line 1018 "language.yacc"
  {
    reset_type_stack();
    yyerrok;
/*     if(Pike_compiler->num_parse_error>5) YYACCEPT; */
  }
#line 5311 "y.tab.c"
    break;

  case 71: /* def: error '}'  */
#line 1024 "language.yacc"
  {
    reset_type_stack();
    yyerror("Missing ';'.");
   /* yychar = '}';	*/ /* Put the '}' back on the input stream */
  }
#line 5321 "y.tab.c"
    break;

  case 72: /* @6: %empty  */
#line 1031 "language.yacc"
    {
      (yyval.number)=THIS_COMPILATION->lex.pragmas;
      THIS_COMPILATION->lex.pragmas|=(yyvsp[-1].number);
      if (Pike_compiler->current_annotations) {
	yywarning("Annotation blocks are not supported.");
      }
    }
#line 5333 "y.tab.c"
    break;

  case 73: /* def: modifiers '{' @6 program close_brace_or_eof  */
#line 1040 "language.yacc"
    {
      THIS_COMPILATION->lex.pragmas=(yyvsp[-2].number);
    }
#line 5341 "y.tab.c"
    break;

  case 74: /* static_assertion: "_Static_assert" '(' assignment_expr ',' assignment_expr ')'  */
#line 1046 "language.yacc"
  {
    Pike_compiler->init_node =
      mknode(F_COMMA_EXPR, Pike_compiler->init_node,
	     mkefuncallnode("_Static_assert",
			    mknode(F_ARG_LIST, (yyvsp[-3].n), (yyvsp[-1].n))));
  }
#line 5352 "y.tab.c"
    break;

  case 75: /* optional_dot_dot_dot: "..."  */
#line 1054 "language.yacc"
                                      { (yyval.number)=1; }
#line 5358 "y.tab.c"
    break;

  case 76: /* optional_dot_dot_dot: ".."  */
#line 1056 "language.yacc"
  {
    yyerror("Range indicator ('..') where elipsis ('...') expected.");
    (yyval.number)=1;
  }
#line 5367 "y.tab.c"
    break;

  case 77: /* optional_dot_dot_dot: %empty  */
#line 1060 "language.yacc"
                { (yyval.number)=0; }
#line 5373 "y.tab.c"
    break;

  case 79: /* optional_identifier: bad_identifier  */
#line 1064 "language.yacc"
                   { (yyval.n)=0; }
#line 5379 "y.tab.c"
    break;

  case 80: /* optional_identifier: %empty  */
#line 1065 "language.yacc"
                { (yyval.n)=0; }
#line 5385 "y.tab.c"
    break;

  case 81: /* optional_default_value: '=' assignment_expr  */
#line 1068 "language.yacc"
                                            { (yyval.n) = (yyvsp[0].n); }
#line 5391 "y.tab.c"
    break;

  case 82: /* optional_default_value: '='  */
#line 1069 "language.yacc"
                    { yyerror("Missing default value expression."); (yyval.n) = NULL; }
#line 5397 "y.tab.c"
    break;

  case 83: /* optional_default_value: %empty  */
#line 1070 "language.yacc"
                { (yyval.n) = NULL; }
#line 5403 "y.tab.c"
    break;

  case 84: /* optional_default_type: %empty  */
#line 1073 "language.yacc"
                                   { (yyval.n) = 0; }
#line 5409 "y.tab.c"
    break;

  case 85: /* $@7: %empty  */
#line 1075 "language.yacc"
  {
    type_stack_mark();
  }
#line 5417 "y.tab.c"
    break;

  case 86: /* optional_default_type: '=' $@7 full_type  */
#line 1079 "language.yacc"
  {
    struct pike_type *t = pop_unfinished_type();
    (yyval.n) = mktypenode(t);
    free_type(t);
  }
#line 5427 "y.tab.c"
    break;

  case 87: /* $@8: %empty  */
#line 1087 "language.yacc"
  {
    /* This is needed in order to avoid issues with eg using cast
     * in the optional_default_value.
     *
     * An alternative could be to use simple_type instead of full_type.
     */
    type_stack_mark();
  }
#line 5440 "y.tab.c"
    break;

  case 88: /* new_arg_name: full_type optional_dot_dot_dot $@8 optional_identifier optional_default_value  */
#line 1096 "language.yacc"
  {
    int i;

    /* Pop the mark form above. */
    pop_stack_mark();

    if(Pike_compiler->compiler_frame->varargs) {
      yyerror("Can't define more arguments after ...");
    }

    if (TEST_COMPAT(8, 0) &&
	!pike_types_le(zero_type_string, peek_type_stack(), 0, 0)) {
      push_type(PIKE_T_ZERO);
      push_type(T_OR);
    }

    if((yyvsp[-3].number))
    {
      push_unlimited_array_type(T_ARRAY);

      Pike_compiler->compiler_frame->varargs=1;
    }

    if ((yyvsp[0].n)) {
      if ((yyvsp[-3].number)) {
	yyerror("Varargs variable with default value.");
	free_node((yyvsp[0].n));
	(yyvsp[0].n) = NULL;
      } else if (!(yyvsp[-1].n)) {
	yywarning("Unnamed variable with default value.");
      }
    }

    if(!(yyvsp[-1].n))
    {
      (yyvsp[-1].n) = mkstrnode(empty_pike_string);
    }

    if((yyvsp[-1].n)->u.sval.u.string->len &&
       islocal((yyvsp[-1].n)->u.sval.u.string) >= 0)
      my_yyerror("Variable %pS appears twice in argument list.",
		 (yyvsp[-1].n)->u.sval.u.string);

    i = add_local_name((yyvsp[-1].n)->u.sval.u.string, compiler_pop_type(), (yyvsp[0].n));
    if (i >= 0) {
      /* Don't warn about unused arguments. */
      Pike_compiler->compiler_frame->local_names[i].flags |= LOCAL_VAR_IS_USED;
      if ((yyvsp[0].n)) {
	Pike_compiler->compiler_frame->local_names[i].flags |=
	  LOCAL_VAR_IS_ARGUMENT;
      }
      bind_local(NULL, i);
    }
    free_node((yyvsp[-1].n));
  }
#line 5500 "y.tab.c"
    break;

  case 89: /* @9: %empty  */
#line 1152 "language.yacc"
  {
    int i = add_local_name(empty_pike_string, array_type_string, NULL);
    add_ref(array_type_string);
    Pike_compiler->compiler_frame->local_names[i].flags |= LOCAL_VAR_IS_USED;
    bind_local(NULL, i);
    (yyval.number) = i;
  }
#line 5512 "y.tab.c"
    break;

  case 90: /* new_arg_name: open_bracket_with_line_info @9 low_lvalue_list ']' optional_default_value  */
#line 1160 "language.yacc"
  {
    node *n = mknode(F_ARRAY_LVALUE, (yyvsp[-2].n), 0);
    node *init;
    int i = (yyvsp[-3].number);

    /* Update the type for argument #i. */
    type_stack_mark();
    fix_type_field(n);
    push_finished_type(n->type);
    if ((yyvsp[0].n)) {
      push_type(T_VOID);
      push_type(T_OR);
      free_type(n->type);
      copy_pike_type(n->type, peek_type_stack());
    }
    free_type(Pike_compiler->compiler_frame->local_names[i].def->type);
    Pike_compiler->compiler_frame->local_names[i].def->type =
      pop_unfinished_type();
    init = mklocalnode(i, 0);

    if ((yyvsp[0].n)) {
      init = mknode(F_LOR, init, (yyvsp[0].n));
    }
    /* Redefine local #i as [ $3 ] with an initializer of
     * orig_i || $5.
     */
    redefine_local(NULL, i, n, init);
    free_node((yyvsp[-4].n));
  }
#line 5546 "y.tab.c"
    break;

  case 91: /* func_args: '(' arguments ')'  */
#line 1192 "language.yacc"
  {
    (yyval.number)=(yyvsp[-1].number);
  }
#line 5554 "y.tab.c"
    break;

  case 92: /* arguments: optional_comma  */
#line 1197 "language.yacc"
                                      { (yyval.number)=0; }
#line 5560 "y.tab.c"
    break;

  case 94: /* arguments2: new_arg_name  */
#line 1201 "language.yacc"
                         { (yyval.number) = 1; }
#line 5566 "y.tab.c"
    break;

  case 95: /* arguments2: arguments2 ',' new_arg_name  */
#line 1202 "language.yacc"
                                { (yyval.number) = (yyvsp[-2].number) + 1; }
#line 5572 "y.tab.c"
    break;

  case 96: /* arguments2: arguments2 ':' new_arg_name  */
#line 1204 "language.yacc"
  {
    yyerror("Unexpected ':' in argument list.");
    (yyval.number) = (yyvsp[-2].number) + 1;
  }
#line 5581 "y.tab.c"
    break;

  case 97: /* local_modifier: "__generator__"  */
#line 1211 "language.yacc"
                        { (yyval.number) = ID_GENERATOR; }
#line 5587 "y.tab.c"
    break;

  case 98: /* local_modifier: "__async__"  */
#line 1212 "language.yacc"
                        { (yyval.number) = ID_ASYNC; }
#line 5593 "y.tab.c"
    break;

  case 100: /* modifier: "final"  */
#line 1216 "language.yacc"
                   { (yyval.number) = ID_FINAL | ID_INLINE; }
#line 5599 "y.tab.c"
    break;

  case 101: /* modifier: "static"  */
#line 1217 "language.yacc"
                   {
    (yyval.number) = ID_PROTECTED;
    if( !(THIS_COMPILATION->lex.pragmas & ID_NO_DEPRECATION_WARNINGS) &&
        !TEST_COMPAT(7, 8) &&
	(Pike_compiler->compiler_pass == COMPILER_PASS_FIRST) )
      yywarning("Keyword static is deprecated in favour of 'protected'.");
    }
#line 5611 "y.tab.c"
    break;

  case 102: /* modifier: "extern"  */
#line 1224 "language.yacc"
                   { (yyval.number) = ID_EXTERN | ID_OPTIONAL; }
#line 5617 "y.tab.c"
    break;

  case 103: /* modifier: "optional"  */
#line 1225 "language.yacc"
                   { (yyval.number) = ID_OPTIONAL; }
#line 5623 "y.tab.c"
    break;

  case 104: /* modifier: "private"  */
#line 1226 "language.yacc"
                   { (yyval.number) = ID_PRIVATE | ID_PROTECTED | ID_INLINE; }
#line 5629 "y.tab.c"
    break;

  case 105: /* modifier: "local"  */
#line 1227 "language.yacc"
                   { (yyval.number) = ID_INLINE; }
#line 5635 "y.tab.c"
    break;

  case 106: /* modifier: "public"  */
#line 1228 "language.yacc"
                   { (yyval.number) = ID_PUBLIC; }
#line 5641 "y.tab.c"
    break;

  case 107: /* modifier: "protected"  */
#line 1229 "language.yacc"
                   { (yyval.number) = ID_PROTECTED; }
#line 5647 "y.tab.c"
    break;

  case 108: /* modifier: "inline"  */
#line 1230 "language.yacc"
                   { (yyval.number) = ID_INLINE; }
#line 5653 "y.tab.c"
    break;

  case 109: /* modifier: "variant"  */
#line 1231 "language.yacc"
                   { (yyval.number) = ID_VARIANT; }
#line 5659 "y.tab.c"
    break;

  case 110: /* modifier: "__weak__"  */
#line 1232 "language.yacc"
                   { (yyval.number) = ID_WEAK; }
#line 5665 "y.tab.c"
    break;

  case 111: /* modifier: "__unused__"  */
#line 1233 "language.yacc"
                   { (yyval.number) = ID_USED; }
#line 5671 "y.tab.c"
    break;

  case 112: /* magic_identifiers1: "final"  */
#line 1237 "language.yacc"
                   { (yyval.str) = "final"; }
#line 5677 "y.tab.c"
    break;

  case 113: /* magic_identifiers1: "static"  */
#line 1238 "language.yacc"
                   { (yyval.str) = "static"; }
#line 5683 "y.tab.c"
    break;

  case 114: /* magic_identifiers1: "extern"  */
#line 1239 "language.yacc"
                   { (yyval.str) = "extern"; }
#line 5689 "y.tab.c"
    break;

  case 115: /* magic_identifiers1: "private"  */
#line 1240 "language.yacc"
                   { (yyval.str) = "private"; }
#line 5695 "y.tab.c"
    break;

  case 116: /* magic_identifiers1: "local"  */
#line 1241 "language.yacc"
                   { (yyval.str) = "local"; }
#line 5701 "y.tab.c"
    break;

  case 117: /* magic_identifiers1: "public"  */
#line 1242 "language.yacc"
                   { (yyval.str) = "public"; }
#line 5707 "y.tab.c"
    break;

  case 118: /* magic_identifiers1: "protected"  */
#line 1243 "language.yacc"
                   { (yyval.str) = "protected"; }
#line 5713 "y.tab.c"
    break;

  case 119: /* magic_identifiers1: "inline"  */
#line 1244 "language.yacc"
                   { (yyval.str) = "inline"; }
#line 5719 "y.tab.c"
    break;

  case 120: /* magic_identifiers1: "optional"  */
#line 1245 "language.yacc"
                   { (yyval.str) = "optional"; }
#line 5725 "y.tab.c"
    break;

  case 121: /* magic_identifiers1: "variant"  */
#line 1246 "language.yacc"
                   { (yyval.str) = "variant"; }
#line 5731 "y.tab.c"
    break;

  case 122: /* magic_identifiers1: "__async__"  */
#line 1247 "language.yacc"
                   { (yyval.str) = "__async__"; }
#line 5737 "y.tab.c"
    break;

  case 123: /* magic_identifiers1: "__generator__"  */
#line 1248 "language.yacc"
                   { (yyval.str) = "__generator__"; }
#line 5743 "y.tab.c"
    break;

  case 124: /* magic_identifiers1: "__weak__"  */
#line 1249 "language.yacc"
                   { (yyval.str) = "__weak__"; }
#line 5749 "y.tab.c"
    break;

  case 125: /* magic_identifiers1: "__unused__"  */
#line 1250 "language.yacc"
                   { (yyval.str) = "__unused__"; }
#line 5755 "y.tab.c"
    break;

  case 126: /* magic_identifiers1: "_Static_assert"  */
#line 1251 "language.yacc"
                        { (yyval.str) = "_Static_assert"; }
#line 5761 "y.tab.c"
    break;

  case 127: /* magic_identifiers2: "void"  */
#line 1255 "language.yacc"
                      { (yyval.str) = "void"; }
#line 5767 "y.tab.c"
    break;

  case 128: /* magic_identifiers2: "mixed"  */
#line 1256 "language.yacc"
                      { (yyval.str) = "mixed"; }
#line 5773 "y.tab.c"
    break;

  case 129: /* magic_identifiers2: "array"  */
#line 1257 "language.yacc"
                      { (yyval.str) = "array"; }
#line 5779 "y.tab.c"
    break;

  case 130: /* magic_identifiers2: "__attribute__"  */
#line 1258 "language.yacc"
                      { (yyval.str) = "__attribute__"; }
#line 5785 "y.tab.c"
    break;

  case 131: /* magic_identifiers2: "__deprecated__"  */
#line 1259 "language.yacc"
                      { (yyval.str) = "__deprecated__"; }
#line 5791 "y.tab.c"
    break;

  case 132: /* magic_identifiers2: "__experimental__"  */
#line 1260 "language.yacc"
                        { (yyval.str) = "__experimental__"; }
#line 5797 "y.tab.c"
    break;

  case 133: /* magic_identifiers2: "mapping"  */
#line 1261 "language.yacc"
                      { (yyval.str) = "mapping"; }
#line 5803 "y.tab.c"
    break;

  case 134: /* magic_identifiers2: "multiset"  */
#line 1262 "language.yacc"
                      { (yyval.str) = "multiset"; }
#line 5809 "y.tab.c"
    break;

  case 135: /* magic_identifiers2: "object"  */
#line 1263 "language.yacc"
                      { (yyval.str) = "object"; }
#line 5815 "y.tab.c"
    break;

  case 136: /* magic_identifiers2: "function"  */
#line 1264 "language.yacc"
                      { (yyval.str) = "function"; }
#line 5821 "y.tab.c"
    break;

  case 137: /* magic_identifiers2: "__func__"  */
#line 1265 "language.yacc"
                      { (yyval.str) = "__func__"; }
#line 5827 "y.tab.c"
    break;

  case 138: /* magic_identifiers2: "program"  */
#line 1266 "language.yacc"
                      { (yyval.str) = "program"; }
#line 5833 "y.tab.c"
    break;

  case 139: /* magic_identifiers2: "string"  */
#line 1267 "language.yacc"
                      { (yyval.str) = "string"; }
#line 5839 "y.tab.c"
    break;

  case 140: /* magic_identifiers2: "float"  */
#line 1268 "language.yacc"
                      { (yyval.str) = "float"; }
#line 5845 "y.tab.c"
    break;

  case 141: /* magic_identifiers2: "int"  */
#line 1269 "language.yacc"
                      { (yyval.str) = "int"; }
#line 5851 "y.tab.c"
    break;

  case 142: /* magic_identifiers2: "enum"  */
#line 1270 "language.yacc"
                      { (yyval.str) = "enum"; }
#line 5857 "y.tab.c"
    break;

  case 143: /* magic_identifiers2: "typedef"  */
#line 1271 "language.yacc"
                      { (yyval.str) = "typedef"; }
#line 5863 "y.tab.c"
    break;

  case 144: /* magic_identifiers2: "__unknown__"  */
#line 1272 "language.yacc"
                      { (yyval.str) = "__unknown__"; }
#line 5869 "y.tab.c"
    break;

  case 145: /* magic_identifiers3: "if"  */
#line 1277 "language.yacc"
                   { (yyval.str) = "if"; }
#line 5875 "y.tab.c"
    break;

  case 146: /* magic_identifiers3: "do"  */
#line 1278 "language.yacc"
                   { (yyval.str) = "do"; }
#line 5881 "y.tab.c"
    break;

  case 147: /* magic_identifiers3: "for"  */
#line 1279 "language.yacc"
                   { (yyval.str) = "for"; }
#line 5887 "y.tab.c"
    break;

  case 148: /* magic_identifiers3: "while"  */
#line 1280 "language.yacc"
                   { (yyval.str) = "while"; }
#line 5893 "y.tab.c"
    break;

  case 149: /* magic_identifiers3: "else"  */
#line 1281 "language.yacc"
                   { (yyval.str) = "else"; }
#line 5899 "y.tab.c"
    break;

  case 150: /* magic_identifiers3: "foreach"  */
#line 1282 "language.yacc"
                   { (yyval.str) = "foreach"; }
#line 5905 "y.tab.c"
    break;

  case 151: /* magic_identifiers3: "catch"  */
#line 1283 "language.yacc"
                   { (yyval.str) = "catch"; }
#line 5911 "y.tab.c"
    break;

  case 152: /* magic_identifiers3: "gauge"  */
#line 1284 "language.yacc"
                   { (yyval.str) = "gauge"; }
#line 5917 "y.tab.c"
    break;

  case 153: /* magic_identifiers3: "class"  */
#line 1285 "language.yacc"
                   { (yyval.str) = "class"; }
#line 5923 "y.tab.c"
    break;

  case 154: /* magic_identifiers3: "break"  */
#line 1286 "language.yacc"
                   { (yyval.str) = "break"; }
#line 5929 "y.tab.c"
    break;

  case 155: /* magic_identifiers3: "case"  */
#line 1287 "language.yacc"
                   { (yyval.str) = "case"; }
#line 5935 "y.tab.c"
    break;

  case 156: /* magic_identifiers3: "constant"  */
#line 1288 "language.yacc"
                   { (yyval.str) = "constant"; }
#line 5941 "y.tab.c"
    break;

  case 157: /* magic_identifiers3: "continue"  */
#line 1289 "language.yacc"
                   { (yyval.str) = "continue"; }
#line 5947 "y.tab.c"
    break;

  case 158: /* magic_identifiers3: "default"  */
#line 1290 "language.yacc"
                   { (yyval.str) = "default"; }
#line 5953 "y.tab.c"
    break;

  case 159: /* magic_identifiers3: "import"  */
#line 1291 "language.yacc"
                   { (yyval.str) = "import"; }
#line 5959 "y.tab.c"
    break;

  case 160: /* magic_identifiers3: "inherit"  */
#line 1292 "language.yacc"
                   { (yyval.str) = "inherit"; }
#line 5965 "y.tab.c"
    break;

  case 161: /* magic_identifiers3: "lambda"  */
#line 1293 "language.yacc"
                   { (yyval.str) = "lambda"; }
#line 5971 "y.tab.c"
    break;

  case 162: /* magic_identifiers3: "predef"  */
#line 1294 "language.yacc"
                   { (yyval.str) = "predef"; }
#line 5977 "y.tab.c"
    break;

  case 163: /* magic_identifiers3: "return"  */
#line 1295 "language.yacc"
                   { (yyval.str) = "return"; }
#line 5983 "y.tab.c"
    break;

  case 164: /* magic_identifiers3: "sscanf"  */
#line 1296 "language.yacc"
                   { (yyval.str) = "sscanf"; }
#line 5989 "y.tab.c"
    break;

  case 165: /* magic_identifiers3: "switch"  */
#line 1297 "language.yacc"
                   { (yyval.str) = "switch"; }
#line 5995 "y.tab.c"
    break;

  case 166: /* magic_identifiers3: "typeof"  */
#line 1298 "language.yacc"
                   { (yyval.str) = "typeof"; }
#line 6001 "y.tab.c"
    break;

  case 167: /* magic_identifiers3: "global"  */
#line 1299 "language.yacc"
                   { (yyval.str) = "global"; }
#line 6007 "y.tab.c"
    break;

  case 173: /* magic_identifier: magic_identifiers  */
#line 1306 "language.yacc"
  {
    struct pike_string *tmp=make_shared_string((yyvsp[0].str));
    (yyval.n)=mkstrnode(tmp);
    free_string(tmp);
  }
#line 6017 "y.tab.c"
    break;

  case 174: /* annotation: '@' constant_expr  */
#line 1314 "language.yacc"
  {
    (yyval.n) = (yyvsp[0].n);
  }
#line 6025 "y.tab.c"
    break;

  case 175: /* annotation_list: %empty  */
#line 1319 "language.yacc"
                             { (yyval.n) = NULL; }
#line 6031 "y.tab.c"
    break;

  case 176: /* annotation_list: annotation ':' annotation_list  */
#line 1321 "language.yacc"
  {
    (yyval.n) = mknode(F_COMMA_EXPR, (yyvsp[-2].n), (yyvsp[0].n));
  }
#line 6039 "y.tab.c"
    break;

  case 177: /* modifiers: annotation_list modifier_list  */
#line 1327 "language.yacc"
  {
    free_node(Pike_compiler->current_annotations);
    Pike_compiler->current_annotations = (yyvsp[-1].n);
    (yyval.number) = Pike_compiler->current_modifiers = (yyvsp[0].number) |
      (THIS_COMPILATION->lex.pragmas & ID_MODIFIER_MASK);
  }
#line 6050 "y.tab.c"
    break;

  case 178: /* modifier_list: %empty  */
#line 1335 "language.yacc"
                           { (yyval.number) = 0; }
#line 6056 "y.tab.c"
    break;

  case 179: /* modifier_list: modifier_list modifier  */
#line 1336 "language.yacc"
                           { (yyval.number) = (yyvsp[-1].number) | (yyvsp[0].number); }
#line 6062 "y.tab.c"
    break;

  case 180: /* attribute: "__attribute__" '(' string_constant optional_comma ')'  */
#line 1340 "language.yacc"
  {
    (yyval.n) = (yyvsp[-2].n);
  }
#line 6070 "y.tab.c"
    break;

  case 181: /* attribute: "__deprecated__" '(' ')'  */
#line 1344 "language.yacc"
  {
    struct pike_string *deprecated_string;
    MAKE_CONST_STRING(deprecated_string, "deprecated");
    (yyval.n) = mkstrnode(deprecated_string);
  }
#line 6080 "y.tab.c"
    break;

  case 182: /* attribute: "__deprecated__"  */
#line 1350 "language.yacc"
  {
    struct pike_string *deprecated_string;
    MAKE_CONST_STRING(deprecated_string, "deprecated");
    (yyval.n) = mkstrnode(deprecated_string);
  }
#line 6090 "y.tab.c"
    break;

  case 183: /* attribute: "__experimental__" '(' ')'  */
#line 1356 "language.yacc"
  {
    struct pike_string *experimental_string;
    MAKE_CONST_STRING(experimental_string, "experimental");
    (yyval.n) = mkstrnode(experimental_string);
  }
#line 6100 "y.tab.c"
    break;

  case 184: /* attribute: "__experimental__"  */
#line 1362 "language.yacc"
  {
    struct pike_string *experimental_string;
    MAKE_CONST_STRING(experimental_string, "experimental");
    (yyval.n) = mkstrnode(experimental_string);
  }
#line 6110 "y.tab.c"
    break;

  case 185: /* optional_attributes: %empty  */
#line 1370 "language.yacc"
  {
    if (Pike_compiler->current_attributes) {
      free_node(Pike_compiler->current_attributes);
    }
    if ((Pike_compiler->current_attributes =
	 THIS_COMPILATION->lex.attributes)) {
      add_ref(Pike_compiler->current_attributes);
    }
  }
#line 6124 "y.tab.c"
    break;

  case 186: /* optional_attributes: optional_attributes attribute  */
#line 1380 "language.yacc"
  {
    if ((yyvsp[0].n)) {
      Pike_compiler->current_attributes =
	mknode(F_ARG_LIST, Pike_compiler->current_attributes, (yyvsp[0].n));
    }
  }
#line 6135 "y.tab.c"
    break;

  case 187: /* cast: open_paren_with_line_info type ')'  */
#line 1389 "language.yacc"
    {
      struct pike_type *s = compiler_pop_type();
      (yyval.n) = mktypenode(s);
      free_type(s);
      COPY_LINE_NUMBER_INFO((yyval.n), (yyvsp[-2].n));
      free_node ((yyvsp[-2].n));
    }
#line 6147 "y.tab.c"
    break;

  case 188: /* soft_cast: open_bracket_with_line_info type ']'  */
#line 1399 "language.yacc"
    {
      struct pike_type *s = compiler_pop_type();
      (yyval.n) = mktypenode(s);
      free_type(s);
      COPY_LINE_NUMBER_INFO((yyval.n), (yyvsp[-2].n));
      free_node ((yyvsp[-2].n));
    }
#line 6159 "y.tab.c"
    break;

  case 191: /* simple_type: full_type  */
#line 1417 "language.yacc"
  {
    update_current_type();
  }
#line 6167 "y.tab.c"
    break;

  case 192: /* simple_type2: type2  */
#line 1426 "language.yacc"
  {
    update_current_type();
  }
#line 6175 "y.tab.c"
    break;

  case 193: /* full_type: full_type '|' type3  */
#line 1435 "language.yacc"
                               { push_type(T_OR); }
#line 6181 "y.tab.c"
    break;

  case 195: /* type: type '|' type3  */
#line 1442 "language.yacc"
                     { push_type(T_OR); }
#line 6187 "y.tab.c"
    break;

  case 199: /* basic_type: "float"  */
#line 1451 "language.yacc"
                                      { push_type(T_FLOAT); }
#line 6193 "y.tab.c"
    break;

  case 200: /* basic_type: "void"  */
#line 1452 "language.yacc"
                                      { push_type(T_VOID); }
#line 6199 "y.tab.c"
    break;

  case 201: /* basic_type: "mixed"  */
#line 1453 "language.yacc"
                                      { push_type(T_MIXED); }
#line 6205 "y.tab.c"
    break;

  case 202: /* basic_type: "__unknown__"  */
#line 1454 "language.yacc"
                                      { push_type(PIKE_T_UNKNOWN); }
#line 6211 "y.tab.c"
    break;

  case 203: /* basic_type: "auto"  */
#line 1455 "language.yacc"
                                { push_type(T_ZERO); push_type(PIKE_T_AUTO); }
#line 6217 "y.tab.c"
    break;

  case 204: /* basic_type: "string" opt_string_width  */
#line 1456 "language.yacc"
                                      {}
#line 6223 "y.tab.c"
    break;

  case 205: /* basic_type: "int" opt_int_range  */
#line 1457 "language.yacc"
                                      {}
#line 6229 "y.tab.c"
    break;

  case 206: /* basic_type: "mapping" opt_mapping_type  */
#line 1458 "language.yacc"
                                      {}
#line 6235 "y.tab.c"
    break;

  case 207: /* basic_type: "function" opt_function_type  */
#line 1459 "language.yacc"
                                      {}
#line 6241 "y.tab.c"
    break;

  case 208: /* basic_type: "object" opt_program_type  */
#line 1460 "language.yacc"
                                      {}
#line 6247 "y.tab.c"
    break;

  case 209: /* basic_type: "program" opt_program_type  */
#line 1461 "language.yacc"
                                      { push_type(T_PROGRAM); }
#line 6253 "y.tab.c"
    break;

  case 210: /* basic_type: "array" opt_array_type  */
#line 1462 "language.yacc"
                                      {}
#line 6259 "y.tab.c"
    break;

  case 211: /* basic_type: "multiset" opt_multiset_type  */
#line 1463 "language.yacc"
                                      { push_type(T_MULTISET); }
#line 6265 "y.tab.c"
    break;

  case 212: /* basic_type: "__attribute__" '(' string_constant ',' full_type ')'  */
#line 1465 "language.yacc"
  {
    push_type_attribute((yyvsp[-3].n)->u.sval.u.string);
    free_node((yyvsp[-3].n));
  }
#line 6274 "y.tab.c"
    break;

  case 213: /* basic_type: "__attribute__" '(' string_constant error ')'  */
#line 1470 "language.yacc"
  {
    push_type(T_MIXED);
    push_type_attribute((yyvsp[-2].n)->u.sval.u.string);
    free_node((yyvsp[-2].n));
  }
#line 6284 "y.tab.c"
    break;

  case 214: /* basic_type: "__attribute__" error  */
#line 1476 "language.yacc"
  {
    push_type(T_MIXED);
  }
#line 6292 "y.tab.c"
    break;

  case 215: /* basic_type: "__deprecated__" '(' full_type ')'  */
#line 1480 "language.yacc"
  {
    struct pike_string *deprecated_string;
    MAKE_CONST_STRING(deprecated_string, "deprecated");
    push_type_attribute(deprecated_string);
  }
#line 6302 "y.tab.c"
    break;

  case 216: /* basic_type: "__deprecated__" '(' error ')'  */
#line 1486 "language.yacc"
  {
    struct pike_string *deprecated_string;
    MAKE_CONST_STRING(deprecated_string, "deprecated");
    push_type(T_MIXED);
    push_type_attribute(deprecated_string);
  }
#line 6313 "y.tab.c"
    break;

  case 217: /* basic_type: "__experimental__" '(' full_type ')'  */
#line 1493 "language.yacc"
  {
    struct pike_string *experimental_string;
    MAKE_CONST_STRING(experimental_string, "experimental");
    push_type_attribute(experimental_string);
  }
#line 6323 "y.tab.c"
    break;

  case 218: /* basic_type: "__experimental__" '(' error ')'  */
#line 1499 "language.yacc"
  {
    struct pike_string *experimental_string;
    MAKE_CONST_STRING(experimental_string, "experimental");
    push_type(T_MIXED);
    push_type_attribute(experimental_string);
  }
#line 6334 "y.tab.c"
    break;

  case 219: /* identifier_type: id_expr  */
#line 1512 "language.yacc"
  {
    node *expr = (yyvsp[0].n);
    struct array *bindings = NULL;
    struct pike_type *obj_type;

    if (expr && (expr->token == F_BIND_GENERICS)) {
      bindings = CDR(expr)->u.sval.u.array;
      expr = CAR(expr);
    }

    if (expr) {
      fix_type_field(expr);

      if ((Pike_compiler->compiler_pass == COMPILER_PASS_LAST) &&
          !pike_types_le(expr->type, typeable_type_string, 0, 0) &&
	  (THIS_COMPILATION->lex.pragmas & ID_STRICT_TYPES)) {
	yytype_report(REPORT_WARNING,
                      expr->current_file, expr->line_number,
                      typeable_type_string,
                      expr->current_file, expr->line_number, expr->type,
		      0, "Invalid type.");
      }
    }

    resolv_type(expr);

    /* Attempt to name the type. */
    if (Pike_compiler->last_identifier) {
      push_type_name(Pike_compiler->last_identifier);
    }

    obj_type = get_obj_type(peek_type_stack());
    if (obj_type && (obj_type->flags & PT_FLAG_GOBJECT)) {
      struct program *p = low_id_to_program(CDR_TO_INT(obj_type), 1);
      struct mapping *bind = mkbindings(p, bindings, 0);
      struct pike_type *t = compiler_apply_bindings(peek_type_stack(), bind);

      compiler_discard_top_type();
      push_finished_type(t);

      free_type(t);
      do_free_mapping(bind);
    } else if ((Pike_compiler->compiler_pass == COMPILER_PASS_LAST) && bindings) {
      yywarning("Bindings specified for non-generic type %pT.",
                peek_type_stack());
    }

    free_node((yyvsp[0].n));
  }
#line 6388 "y.tab.c"
    break;

  case 220: /* identifier_type: typeof  */
#line 1562 "language.yacc"
  {
    if ((yyvsp[0].n) && CAR((yyvsp[0].n))) {
      fix_type_field((yyvsp[0].n));
      push_finished_type(CAR((yyvsp[0].n))->type);
      free_node((yyvsp[0].n));
    } else {
      push_finished_type(mixed_type_string);
    }
  }
#line 6402 "y.tab.c"
    break;

  case 222: /* number: '-' "integer literal"  */
#line 1575 "language.yacc"
  {
#ifdef PIKE_DEBUG
    if (((yyvsp[0].n)->token != F_CONSTANT) || (TYPEOF((yyvsp[0].n)->u.sval) != T_INT)) {
      Pike_fatal("Unexpected number in negative int-range.\n");
    }
#endif /* PIKE_DEBUG */
    (yyval.n) = mkintnode(-((yyvsp[0].n)->u.sval.u.integer));
    free_node((yyvsp[0].n));
  }
#line 6416 "y.tab.c"
    break;

  case 223: /* number_or_maxint: %empty  */
#line 1587 "language.yacc"
  {
    (yyval.n) = mkintnode(MAX_INT_TYPE);
  }
#line 6424 "y.tab.c"
    break;

  case 225: /* number_or_minint: %empty  */
#line 1593 "language.yacc"
  {
    (yyval.n) = mkintnode(MIN_INT_TYPE);
  }
#line 6432 "y.tab.c"
    break;

  case 228: /* expected_dot_dot: "..."  */
#line 1600 "language.yacc"
  {
    yyerror("Elipsis ('...') where range indicator ('..') expected.");
  }
#line 6440 "y.tab.c"
    break;

  case 229: /* safe_int_range_type_low: "bits"  */
#line 1606 "language.yacc"
  {
    push_int_type( 0, (1<<(yyvsp[0].n)->u.sval.u.integer)-1 );
    free_node( (yyvsp[0].n) );
  }
#line 6449 "y.tab.c"
    break;

  case 230: /* safe_int_range_type_low: number_or_minint expected_dot_dot number_or_maxint  */
#line 1611 "language.yacc"
  {
    INT_TYPE min = MIN_INT_TYPE;
    INT_TYPE max = MAX_INT_TYPE;

    /* FIXME: Check that $3 is >= $1. */
    if((yyvsp[0].n)->token == F_CONSTANT) {
      if (TYPEOF((yyvsp[0].n)->u.sval) == T_INT) {
	max = (yyvsp[0].n)->u.sval.u.integer;
      } else if (is_bignum_object_in_svalue(&(yyvsp[0].n)->u.sval)) {
	push_int(0);
	if (is_lt(&(yyvsp[0].n)->u.sval, Pike_sp-1)) {
	  max = MIN_INT_TYPE;
	}
	pop_stack();
      }
    }

    if((yyvsp[-2].n)->token == F_CONSTANT) {
      if (TYPEOF((yyvsp[-2].n)->u.sval) == T_INT) {
	min = (yyvsp[-2].n)->u.sval.u.integer;
      } else if (is_bignum_object_in_svalue(&(yyvsp[-2].n)->u.sval)) {
	push_int(0);
	if (is_lt(Pike_sp-1, &(yyvsp[-2].n)->u.sval)) {
	  min = MAX_INT_TYPE;
	}
	pop_stack();
      }
    }

    push_int_type(min, max);

    free_node((yyvsp[-2].n));
    free_node((yyvsp[0].n));
  }
#line 6488 "y.tab.c"
    break;

  case 231: /* safe_int_range_type_low: number  */
#line 1646 "language.yacc"
  {
    INT_TYPE val = MAX_INT_TYPE;

    if((yyvsp[0].n)->token == F_CONSTANT) {
      if (TYPEOF((yyvsp[0].n)->u.sval) == T_INT) {
	val = (yyvsp[0].n)->u.sval.u.integer;
      } else if (is_bignum_object_in_svalue(&(yyvsp[0].n)->u.sval)) {
	push_int(0);
	if (is_lt(&(yyvsp[0].n)->u.sval, Pike_sp-1)) {
	  val = MIN_INT_TYPE;
	}
	pop_stack();
      }
    }

    push_int_type(val, val);

    free_node((yyvsp[0].n));
  }
#line 6512 "y.tab.c"
    break;

  case 232: /* safe_int_range_type_low: error  */
#line 1666 "language.yacc"
  {
    push_int_type(MIN_INT32, MAX_INT32);
    yyerror("Expected integer range.");
  }
#line 6521 "y.tab.c"
    break;

  case 234: /* safe_int_range_type: safe_int_range_type '|' safe_int_range_type_low  */
#line 1674 "language.yacc"
  {
    push_type(PIKE_T_OR);
  }
#line 6529 "y.tab.c"
    break;

  case 235: /* opt_int_range: %empty  */
#line 1680 "language.yacc"
  {
    push_int_type(MIN_INT_TYPE, MAX_INT_TYPE);
  }
#line 6537 "y.tab.c"
    break;

  case 237: /* opt_string_width: opt_int_range  */
#line 1687 "language.yacc"
  {
    push_unlimited_array_type(T_STRING);
  }
#line 6545 "y.tab.c"
    break;

  case 238: /* opt_string_width: '(' safe_int_range_type ':' safe_int_range_type ')'  */
#line 1691 "language.yacc"
  {
    push_reverse_type(T_STRING);
  }
#line 6553 "y.tab.c"
    break;

  case 239: /* opt_string_width: '(' safe_int_range_type ':' ')'  */
#line 1695 "language.yacc"
  {
    push_finished_type(int_type_string);
    push_reverse_type(T_STRING);
  }
#line 6562 "y.tab.c"
    break;

  case 240: /* opt_string_width: '(' ':' safe_int_range_type ')'  */
#line 1700 "language.yacc"
  {
    push_unlimited_array_type(T_STRING);
  }
#line 6570 "y.tab.c"
    break;

  case 241: /* opt_program_type: %empty  */
#line 1705 "language.yacc"
                               { push_object_type(0, 0); }
#line 6576 "y.tab.c"
    break;

  case 243: /* opt_program_type: '(' string_constant ')'  */
#line 1708 "language.yacc"
  {
    resolv_type((yyvsp[-1].n));
    push_type_name((yyvsp[-1].n)->u.sval.u.string);
    free_node((yyvsp[-1].n));
  }
#line 6586 "y.tab.c"
    break;

  case 244: /* opt_program_type: '(' error ')'  */
#line 1714 "language.yacc"
  {
    push_object_type(0, 0);
    yyerror("Invalid program subtype.");
  }
#line 6595 "y.tab.c"
    break;

  case 245: /* $@10: %empty  */
#line 1721 "language.yacc"
  {
    type_stack_mark();
  }
#line 6603 "y.tab.c"
    break;

  case 246: /* $@11: %empty  */
#line 1725 "language.yacc"
  {
    /* Add the many type if there is none. */
    if ((yyvsp[-1].number))
    {
      if (!(yyvsp[-2].number)) {
	/* function_type_list ends with a comma, or is empty.
	 * FIXME: Should this be a syntax error or not?
	 */
	if (Pike_compiler->compiler_pass == COMPILER_PASS_FIRST) {
	  yyerror("Missing type before ... .");
	}
	push_type(T_MIXED);
      }
    }else{
      push_type(T_VOID);
    }
  }
#line 6625 "y.tab.c"
    break;

  case 247: /* opt_function_type: '(' $@10 function_type_list optional_dot_dot_dot ':' $@11 full_type ')'  */
#line 1743 "language.yacc"
  {
    push_reverse_type(T_MANY);
    Pike_compiler->pike_type_mark_stackp--;
    while (*Pike_compiler->pike_type_mark_stackp+1 <
	   Pike_compiler->type_stackp) {
      push_reverse_type(T_FUNCTION);
    }
  }
#line 6638 "y.tab.c"
    break;

  case 248: /* opt_function_type: %empty  */
#line 1752 "language.yacc"
  {
   push_type(T_MIXED);
   push_type(T_VOID);
   push_type(T_OR);

   push_type(PIKE_T_UNKNOWN);

   push_type(T_MANY);

   if (!(THIS_COMPILATION->lex.pragmas & ID_STRICT_TYPES) ||
       TEST_COMPAT(8, 0)) {
     /* For type validation we also need this.
      * Otherwise code like
      *
      *   function foo;
      *   function(string:void) bar = foo;
      *
      * will fail.
      */
     push_type(PIKE_T_UNKNOWN);

     push_type(T_MIXED);

     push_type(T_MANY);

     push_type(T_OR);
   }
  }
#line 6671 "y.tab.c"
    break;

  case 249: /* function_type_list: optional_comma  */
#line 1782 "language.yacc"
                                               { (yyval.number)=0; }
#line 6677 "y.tab.c"
    break;

  case 250: /* function_type_list: function_type_list2 optional_comma  */
#line 1783 "language.yacc"
                                       { (yyval.number)=!(yyvsp[0].number); }
#line 6683 "y.tab.c"
    break;

  case 251: /* function_type_list2: full_type  */
#line 1786 "language.yacc"
                               { (yyval.number)=1; }
#line 6689 "y.tab.c"
    break;

  case 252: /* $@12: %empty  */
#line 1788 "language.yacc"
  {
  }
#line 6696 "y.tab.c"
    break;

  case 254: /* opt_generic_bindings: %empty  */
#line 1793 "language.yacc"
                                  { (yyval.n) = NULL; }
#line 6702 "y.tab.c"
    break;

  case 255: /* @13: %empty  */
#line 1795 "language.yacc"
  {
    /* Save the last identifier for later.
     *
     * NOTE: Uses a node here in order to be able
     *       to clean up on syntax errors.
     */
    (yyval.n) = Pike_compiler->last_identifier?
      mkstrnode(Pike_compiler->last_identifier):NULL;

    type_stack_mark();
  }
#line 6718 "y.tab.c"
    break;

  case 256: /* $@14: %empty  */
#line 1807 "language.yacc"
  {
    /* Restore the last identifier. */
    free_string(Pike_compiler->last_identifier);
    Pike_compiler->last_identifier = NULL;
    if ((yyvsp[-1].n)) {
      copy_shared_string(Pike_compiler->last_identifier,
                         (yyvsp[-1].n)->u.sval.u.string);
      free_node((yyvsp[-1].n));
    }
  }
#line 6733 "y.tab.c"
    break;

  case 257: /* opt_generic_bindings: "(<" @13 function_type_list $@14 ">)"  */
#line 1818 "language.yacc"
  {
    int cnt = pop_stack_mark();
    struct array *ret = allocate_array(cnt);

    push_array(ret);

    while (cnt--) {
      SET_SVAL(ITEM(ret)[cnt], PIKE_T_TYPE, 0, type, low_pop_type());
    }
    ret->type_field = BIT_TYPE;

    (yyval.n) = mkconstantsvaluenode(Pike_sp - 1);
    pop_stack();
  }
#line 6752 "y.tab.c"
    break;

  case 259: /* opt_multiset_type: %empty  */
#line 1835 "language.yacc"
     { push_type(T_MIXED); }
#line 6758 "y.tab.c"
    break;

  case 260: /* opt_array_type: '(' full_type ')'  */
#line 1839 "language.yacc"
  { push_unlimited_array_type(T_ARRAY); }
#line 6764 "y.tab.c"
    break;

  case 261: /* opt_array_type: %empty  */
#line 1841 "language.yacc"
  { push_type(T_MIXED); push_unlimited_array_type(T_ARRAY); }
#line 6770 "y.tab.c"
    break;

  case 262: /* opt_array_type: '(' safe_int_range_type ':' full_type ')'  */
#line 1843 "language.yacc"
  { push_reverse_type(T_ARRAY); }
#line 6776 "y.tab.c"
    break;

  case 263: /* opt_array_type: '(' ':' full_type ')'  */
#line 1845 "language.yacc"
  { push_unlimited_array_type(T_ARRAY); }
#line 6782 "y.tab.c"
    break;

  case 264: /* opt_array_type: '(' safe_int_range_type ':' ')'  */
#line 1847 "language.yacc"
  { push_type(T_MIXED); push_reverse_type(T_ARRAY); }
#line 6788 "y.tab.c"
    break;

  case 265: /* opt_array_type: '(' safe_int_range_type ')'  */
#line 1849 "language.yacc"
  {
    yyerror("Missing ':' after length in array type.");
    push_type(T_MIXED); push_reverse_type(T_ARRAY);
  }
#line 6797 "y.tab.c"
    break;

  case 266: /* $@15: %empty  */
#line 1856 "language.yacc"
  {
  }
#line 6804 "y.tab.c"
    break;

  case 267: /* $@16: %empty  */
#line 1859 "language.yacc"
  {
  }
#line 6811 "y.tab.c"
    break;

  case 268: /* $@17: %empty  */
#line 1862 "language.yacc"
  {
    push_reverse_type(T_MAPPING);
  }
#line 6819 "y.tab.c"
    break;

  case 270: /* opt_mapping_type: %empty  */
#line 1867 "language.yacc"
  {
    push_type(T_MIXED);
    push_type(T_MIXED);
    push_type(T_MAPPING);
  }
#line 6829 "y.tab.c"
    break;

  case 273: /* new_name: "identifier"  */
#line 1880 "language.yacc"
  {
    struct pike_type *type;
    node *n;

    type = Pike_compiler->compiler_frame->current_type;
    push_finished_type(type);
    if ((Pike_compiler->compiler_pass == COMPILER_PASS_LAST) &&
	(!type || ((type->type != PIKE_T_AUTO) && (type->type != T_FLOAT)))) {
      /* NB: Global variables of type float are initialized to 0.0. */
      if (!pike_types_le(zero_type_string, type, 0, 0)) {
	if (!TEST_COMPAT(8,0) &&
	    (THIS_COMPILATION->lex.pragmas & ID_STRICT_TYPES)) {
	  ref_push_string((yyvsp[0].n)->u.sval.u.string);
	  yytype_report(REPORT_WARNING, NULL, 0, zero_type_string,
			NULL, 0, type,
			1, "Type does not contain zero for variable without "
			"initializer %s. Type adjusted.");
	}
	push_type(PIKE_T_ZERO);
	push_type(T_OR);
      }
    }
    n = Pike_compiler->current_attributes;
    while(n) {
      push_type_attribute(CDR(n)->u.sval.u.string);
      n = CAR(n);
    }
    type=compiler_pop_type();
    define_variable((yyvsp[0].n)->u.sval.u.string, type,
		    Pike_compiler->current_modifiers);
    free_type(type);
    free_node((yyvsp[0].n));
  }
#line 6867 "y.tab.c"
    break;

  case 274: /* new_name: bad_identifier  */
#line 1913 "language.yacc"
                   {}
#line 6873 "y.tab.c"
    break;

  case 275: /* @18: %empty  */
#line 1915 "language.yacc"
  {
    struct pike_type *type;
    node *n;

    push_finished_type(Pike_compiler->compiler_frame->current_type);
    n = Pike_compiler->current_attributes;
    while(n) {
      push_type_attribute(CDR(n)->u.sval.u.string);
      n = CAR(n);
    }
    type=compiler_pop_type();
    if ((Pike_compiler->current_modifiers & ID_EXTERN) &&
	(Pike_compiler->compiler_pass == COMPILER_PASS_FIRST)) {
      yywarning("Extern declared variable has initializer.");
    }
    (yyval.number)=define_variable((yyvsp[-1].n)->u.sval.u.string, type,
			       Pike_compiler->current_modifiers & (~ID_EXTERN));
    free_type(type);
  }
#line 6897 "y.tab.c"
    break;

  case 276: /* new_name: "identifier" '=' @18 assignment_expr  */
#line 1935 "language.yacc"
  {
    if ((Pike_compiler->compiler_pass == COMPILER_PASS_LAST) &&
	!TEST_COMPAT(7, 8) && ((yyvsp[0].n)) && ((yyvsp[0].n)->token == F_CONSTANT) &&
	!Pike_compiler->num_parse_error) {
      /* Check if it is zero, in which case we can throw it away.
       *
       * NB: The compat test is due to that this changes the semantics
       *     of calling __INIT() by hand.
       */
      if ((TYPEOF((yyvsp[0].n)->u.sval) == PIKE_T_INT) && !SUBTYPEOF((yyvsp[0].n)->u.sval) &&
	  !(yyvsp[0].n)->u.sval.u.integer &&
	  !IDENTIFIER_IS_ALIAS(ID_FROM_INT(Pike_compiler->new_program,
					   (yyvsp[-1].number))->identifier_flags)) {
	/* NB: Inherited variables get converted into aliases by
	 *     define_variable, and we need to support clearing
	 *     of inherited variables.
	 */
#ifdef PIKE_DEBUG
	if (l_flag > 5) {
	  fprintf(stderr,
		  "Ignoring initialization to zero for variable %s.\n",
		  (yyvsp[-3].n)->u.sval.u.string->str);
	}
#endif /* PIKE_DEBUG */
        if(Pike_compiler->compiler_frame->current_type->type == PIKE_T_AUTO)
        {
          // auto variable type needs to be updated.
          fix_type_field( (yyvsp[0].n) );
          fix_auto_variable_type( (yyvsp[-1].number), (yyvsp[0].n)->type );
        }
	free_node((yyvsp[0].n));
	(yyvsp[0].n) = NULL;
      }
    }
    if ((yyvsp[0].n)) {
      node *n;
      // this is done in both passes to get somewhat better handling
      // of auto types.
      //
      // an example is: auto a  = typeof(b); auto b = (["foo":"bar"]);
      // if this is only done in the second pass the type of a will be
      // type(auto), not type(mapping(..))
      if( Pike_compiler->compiler_frame->current_type->type == PIKE_T_AUTO )
      {
        fix_type_field( (yyvsp[0].n) );
        fix_auto_variable_type( (yyvsp[-1].number), (yyvsp[0].n)->type );
      }
      n = mkcastnode(void_type_string,
		     mknode(F_ASSIGN,
			    mkidentifiernode((yyvsp[-1].number)), (yyvsp[0].n)));
      if (Pike_compiler->compiler_pass == COMPILER_PASS_LAST) {
	// This makes sure that #pragma {no_,}deprecation_warnings
	// works as expected.
	optimize_node(n);
      }
      Pike_compiler->init_node=mknode(F_COMMA_EXPR,Pike_compiler->init_node,
				      n);
    }
    free_node((yyvsp[-3].n));
  }
#line 6962 "y.tab.c"
    break;

  case 277: /* new_name: "identifier" '=' error  */
#line 1996 "language.yacc"
  {
    free_node((yyvsp[-2].n));
  }
#line 6970 "y.tab.c"
    break;

  case 278: /* new_name: "identifier" '=' "end of file"  */
#line 2000 "language.yacc"
  {
    yyerror("Unexpected end of file in variable definition.");
    free_node((yyvsp[-2].n));
  }
#line 6979 "y.tab.c"
    break;

  case 279: /* new_name: bad_identifier '=' assignment_expr  */
#line 2005 "language.yacc"
  {
    free_node((yyvsp[0].n));
  }
#line 6987 "y.tab.c"
    break;

  case 280: /* new_local_name: "identifier"  */
#line 2012 "language.yacc"
  {
    int id;
    struct pike_type *type;
    if (pike_types_le(zero_type_string,
		      Pike_compiler->compiler_frame->current_type, 0, 0)) {
      copy_pike_type(type, Pike_compiler->compiler_frame->current_type);
    } else {
      struct compilation *c = THIS_COMPILATION;

      type_stack_mark();
      push_finished_type(Pike_compiler->compiler_frame->current_type);
      push_type(PIKE_T_ZERO);
      push_type(T_OR);
      type = pop_unfinished_type();

      if ((Pike_compiler->compiler_pass == COMPILER_PASS_LAST) &&
	  (c->lex.pragmas & ID_STRICT_TYPES) && !TEST_COMPAT(8, 0)) {
	ref_push_string((yyvsp[0].n)->u.sval.u.string);
	yytype_report(REPORT_WARNING, NULL, 0, zero_type_string,
		      NULL, 0, Pike_compiler->compiler_frame->current_type,
		      1, "Type does not contain zero for variable without "
		      "initializer %s. Type adjusted.");
      }
    }
    id = add_local_name((yyvsp[0].n)->u.sval.u.string, type, 0);
    if( type->type == PIKE_T_AUTO )
    {
      /* FIXME: Update type on assign instead! */
      yyerror("auto only valid when the variable is assigned in definition.");
    }

    if (id >= 0) {
      /* FIXME: Consider using mklocalnode(id, -1). */
      (yyval.n)=mknode(F_ASSIGN, mklocalnode(id,0), mkintnode(0));
    } else
      (yyval.n) = 0;
    free_node((yyvsp[0].n));
  }
#line 7030 "y.tab.c"
    break;

  case 281: /* new_local_name: bad_identifier  */
#line 2050 "language.yacc"
                   { (yyval.n)=0; }
#line 7036 "y.tab.c"
    break;

  case 282: /* $@19: %empty  */
#line 2052 "language.yacc"
  {
    push_finished_type(Pike_compiler->compiler_frame->current_type);
    type_stack_mark();
  }
#line 7045 "y.tab.c"
    break;

  case 283: /* new_local_name: "identifier" '=' $@19 assignment_expr  */
#line 2057 "language.yacc"
  {
    int id;
    struct pike_type *type;
    pop_stack_mark();
    update_current_type();
    copy_pike_type(type, Pike_compiler->compiler_frame->current_type);
    if( type->type == PIKE_T_AUTO &&
	Pike_compiler->compiler_pass == COMPILER_PASS_LAST)
    {
        free_type( type );
        fix_type_field( (yyvsp[0].n) );
        copy_pike_type( type, (yyvsp[0].n)->type );
    }
    id = add_local_name((yyvsp[-3].n)->u.sval.u.string, type, 0);
    if (id >= 0) {
      if (!(THIS_COMPILATION->lex.pragmas & ID_STRICT_TYPES)) {
	/* Only warn about unused initialized variables in strict types mode. */
	Pike_compiler->compiler_frame->local_names[id].flags |= LOCAL_VAR_IS_USED;
      }
      (yyval.n) = mknode(F_INITIALIZE, mklocalnode(id, 0), (yyvsp[0].n));
    } else
      (yyval.n) = 0;
    free_node((yyvsp[-3].n));
  }
#line 7074 "y.tab.c"
    break;

  case 284: /* $@20: %empty  */
#line 2082 "language.yacc"
  {
    push_finished_type(Pike_compiler->compiler_frame->current_type);
    type_stack_mark();
  }
#line 7083 "y.tab.c"
    break;

  case 285: /* new_local_name: bad_identifier '=' $@20 assignment_expr  */
#line 2087 "language.yacc"
  {
    pop_stack_mark();
    update_current_type();
    free_node((yyvsp[0].n));
    (yyval.n)=0;
  }
#line 7094 "y.tab.c"
    break;

  case 286: /* $@21: %empty  */
#line 2094 "language.yacc"
  {
    push_finished_type(Pike_compiler->compiler_frame->current_type);
    type_stack_mark();
  }
#line 7103 "y.tab.c"
    break;

  case 287: /* new_local_name: "identifier" '=' $@21 error  */
#line 2099 "language.yacc"
  {
    pop_stack_mark();
    update_current_type();
    free_node((yyvsp[-3].n));
    /* No yyerok here since we aren't done yet. */
    (yyval.n)=0;
  }
#line 7115 "y.tab.c"
    break;

  case 288: /* $@22: %empty  */
#line 2107 "language.yacc"
  {
    push_finished_type(Pike_compiler->compiler_frame->current_type);
    type_stack_mark();
  }
#line 7124 "y.tab.c"
    break;

  case 289: /* new_local_name: "identifier" '=' $@22 "end of file"  */
#line 2112 "language.yacc"
  {
    pop_stack_mark();
    update_current_type();
    yyerror("Unexpected end of file in local variable definition.");
    free_node((yyvsp[-3].n));
    /* No yyerok here since we aren't done yet. */
    (yyval.n)=0;
  }
#line 7137 "y.tab.c"
    break;

  case 290: /* line_number_info: %empty  */
#line 2123 "language.yacc"
  {
    /* Used to hold line-number info */
    (yyval.n) = mkintnode(0);
  }
#line 7146 "y.tab.c"
    break;

  case 291: /* @23: %empty  */
#line 2130 "language.yacc"
  {
    (yyvsp[0].number)=Pike_compiler->num_used_modules;
    (yyval.number)=Pike_compiler->compiler_frame->current_number_of_locals;
  }
#line 7155 "y.tab.c"
    break;

  case 292: /* @24: %empty  */
#line 2135 "language.yacc"
  {
    /* Trick to store more than one number on compiler stack - Hubbe */
    (yyval.number)=Pike_compiler->compiler_frame->last_block_level;

    if((yyval.number) == -1) /* if 'first block' */
      Pike_compiler->compiler_frame->last_block_level=0; /* all variables */
    else
      Pike_compiler->compiler_frame->last_block_level=(yyvsp[-1].number);
  }
#line 7169 "y.tab.c"
    break;

  case 293: /* @25: %empty  */
#line 2144 "language.yacc"
  {
    (yyval.ptr) = Pike_compiler;
  }
#line 7177 "y.tab.c"
    break;

  case 294: /* block: '{' @23 line_number_info @24 @25 statements end_block  */
#line 2148 "language.yacc"
  {
    /* Recover compilation context on syntax errors. */
    while (Pike_compiler != (yyvsp[-2].ptr)) {
      struct program *p;
      /* fprintf(stderr, "Compiler context out of sync. Attempting to recover...\n"); */
      if(Pike_compiler->compiler_pass != COMPILER_PASS_LAST)
	p = end_first_pass(0);
      else
	p=end_first_pass(1);

      if (p) free_program(p);
    }

    unuse_modules(Pike_compiler->num_used_modules - (yyvsp[-6].number));
    (yyvsp[-1].n) = pop_local_variables((yyvsp[-5].number), (yyvsp[-1].n));
    Pike_compiler->compiler_frame->last_block_level=(yyvsp[-3].number);
    if ((yyvsp[-1].n)) COPY_LINE_NUMBER_INFO((yyvsp[-1].n), (yyvsp[-4].n));
    free_node ((yyvsp[-4].n));
    (yyval.n)=(yyvsp[-1].n);
  }
#line 7202 "y.tab.c"
    break;

  case 296: /* end_block: "end of file"  */
#line 2173 "language.yacc"
  {
    yyerror("Missing '}'.");
    if ((yyvsp[-1].n)) {
      low_yyreport(REPORT_ERROR, (yyvsp[-1].n)->current_file, (yyvsp[-1].n)->line_number,
		   parser_system_string, 0, "Opening '{' was here.");
    }
    yyerror("Unexpected end of file.");
  }
#line 7215 "y.tab.c"
    break;

  case 298: /* failsafe_block: error  */
#line 2184 "language.yacc"
                      { (yyval.n)=0; }
#line 7221 "y.tab.c"
    break;

  case 299: /* failsafe_block: "end of file"  */
#line 2185 "language.yacc"
                            { yyerror("Unexpected end of file."); (yyval.n)=0; }
#line 7227 "y.tab.c"
    break;

  case 301: /* local_name_list: local_name_list ',' new_local_name  */
#line 2191 "language.yacc"
    { (yyval.n) = mknode(F_COMMA_EXPR, mkcastnode(void_type_string, (yyvsp[-2].n)), (yyvsp[0].n)); }
#line 7233 "y.tab.c"
    break;

  case 302: /* constant_expr: safe_assignment_expr  */
#line 2196 "language.yacc"
  {
    /* Ugly hack to make sure that $1 is optimized */
    {
      int tmp = Pike_compiler->compiler_pass;
      (yyval.n) = mknode(F_COMMA_EXPR, (yyvsp[0].n), 0);
      optimize_node((yyval.n));
      Pike_compiler->compiler_pass = tmp;
    }

    if(!is_const((yyval.n))) {
      if(Pike_compiler->compiler_pass == COMPILER_PASS_LAST)
	yyerror("Expected constant expression.");
      push_int(0);
    } else {
      ptrdiff_t tmp = eval_low((yyval.n), 1);
      if(tmp < 1)
      {
	if(Pike_compiler->compiler_pass == COMPILER_PASS_LAST)
	  yyerror("Error evaluating constant expression.");
	push_int(0);
      } else {
        pop_n_elems((INT32)(tmp - 1));
      }
    }
    free_node((yyval.n));
    (yyval.n) = mkconstantsvaluenode(Pike_sp - 1);
    pop_stack();
  }
#line 7266 "y.tab.c"
    break;

  case 303: /* local_constant_name: "identifier" '=' safe_assignment_expr  */
#line 2227 "language.yacc"
  {
    /* Ugly hack to make sure that $3 is optimized */
    {
      int tmp=Pike_compiler->compiler_pass;
      (yyvsp[0].n)=mknode(F_COMMA_EXPR,(yyvsp[0].n),0);
      optimize_node((yyvsp[0].n));
      Pike_compiler->compiler_pass=tmp;
    }

    if(!is_const((yyvsp[0].n)))
    {
      yyerror_not_constant("Constant", (yyvsp[0].n));
    }else{
      ptrdiff_t tmp=eval_low((yyvsp[0].n),1);
      if(tmp < 1)
      {
	yyerror("Error in constant definition.");
      }else{
        pop_n_elems((INT32)(tmp - 1));
	if((yyvsp[0].n)) free_node((yyvsp[0].n));
	(yyvsp[0].n)=mksvaluenode(Pike_sp-1);
	pop_stack();
      }
    }
    low_add_local_name(NULL, (yyvsp[-2].n)->u.sval.u.string, NULL,
		       (yyvsp[0].n)?(yyvsp[0].n):mknode(F_UNDEFINED, 0, 0), NULL);
    /* Note: Intentionally not marked as used. */
    free_node((yyvsp[-2].n));
  }
#line 7300 "y.tab.c"
    break;

  case 304: /* local_constant_name: bad_identifier '=' safe_assignment_expr  */
#line 2256 "language.yacc"
                                            { if ((yyvsp[0].n)) free_node((yyvsp[0].n)); }
#line 7306 "y.tab.c"
    break;

  case 305: /* local_constant_name: error '=' safe_assignment_expr  */
#line 2257 "language.yacc"
                                   { if ((yyvsp[0].n)) free_node((yyvsp[0].n)); }
#line 7312 "y.tab.c"
    break;

  case 309: /* local_constant: "constant" error ';'  */
#line 2265 "language.yacc"
                           { yyerrok; }
#line 7318 "y.tab.c"
    break;

  case 310: /* local_constant: "constant" error "end of file"  */
#line 2267 "language.yacc"
  {
    yyerror("Missing ';'.");
    yyerror("Unexpected end of file.");
  }
#line 7327 "y.tab.c"
    break;

  case 311: /* local_constant: "constant" error '}'  */
#line 2271 "language.yacc"
                           { yyerror("Missing ';'."); }
#line 7333 "y.tab.c"
    break;

  case 312: /* statements: %empty  */
#line 2275 "language.yacc"
            { (yyval.n)=0; }
#line 7339 "y.tab.c"
    break;

  case 313: /* statements: statements statement  */
#line 2277 "language.yacc"
  {
    (yyval.n) = mknode(F_COMMA_EXPR, (yyvsp[-1].n), mkcastnode(void_type_string, (yyvsp[0].n)));
  }
#line 7347 "y.tab.c"
    break;

  case 316: /* normal_label_statement: import  */
#line 2286 "language.yacc"
           { (yyval.n)=0; }
#line 7353 "y.tab.c"
    break;

  case 319: /* normal_label_statement: local_constant  */
#line 2289 "language.yacc"
                   { (yyval.n)=0; }
#line 7359 "y.tab.c"
    break;

  case 323: /* normal_label_statement: error ';'  */
#line 2293 "language.yacc"
              { reset_type_stack(); (yyval.n)=0; yyerrok; }
#line 7365 "y.tab.c"
    break;

  case 324: /* normal_label_statement: error "end of file"  */
#line 2295 "language.yacc"
  {
    reset_type_stack();
    yyerror("Missing ';'.");
    yyerror("Unexpected end of file.");
    (yyval.n)=0;
  }
#line 7376 "y.tab.c"
    break;

  case 325: /* normal_label_statement: error '}'  */
#line 2302 "language.yacc"
  {
    reset_type_stack();
    yyerror("Missing ';'.");
/*    yychar = '}'; */	/* Put the '}' back on the input stream. */
    (yyval.n)=0;
  }
#line 7387 "y.tab.c"
    break;

  case 326: /* normal_label_statement: ';'  */
#line 2308 "language.yacc"
        { (yyval.n)=0; }
#line 7393 "y.tab.c"
    break;

  case 327: /* statement: normal_label_statement  */
#line 2312 "language.yacc"
  {
    Pike_compiler->compiler_frame->opt_flags &= ~OPT_CUSTOM_LABELS;
  }
#line 7401 "y.tab.c"
    break;

  case 336: /* statement: simple_type2 local_function  */
#line 2323 "language.yacc"
                                { (yyval.n)=mkcastnode(void_type_string, (yyvsp[0].n)); }
#line 7407 "y.tab.c"
    break;

  case 337: /* statement: local_restartable_function  */
#line 2324 "language.yacc"
                               { (yyval.n)=mkcastnode(void_type_string, (yyvsp[0].n)); }
#line 7413 "y.tab.c"
    break;

  case 338: /* statement: implicit_modifiers named_class  */
#line 2325 "language.yacc"
                                   { (yyval.n)=mkcastnode(void_type_string, (yyvsp[0].n)); }
#line 7419 "y.tab.c"
    break;

  case 339: /* $@26: %empty  */
#line 2329 "language.yacc"
  {
    Pike_compiler->compiler_frame->opt_flags &= ~OPT_CUSTOM_LABELS;
  }
#line 7427 "y.tab.c"
    break;

  case 340: /* labeled_statement: "identifier" $@26 ':' statement  */
#line 2333 "language.yacc"
  {
    (yyval.n) = mknode(Pike_compiler->compiler_frame->opt_flags & OPT_CUSTOM_LABELS ?
		F_CUSTOM_STMT_LABEL : F_NORMAL_STMT_LABEL,
		(yyvsp[-3].n), (yyvsp[0].n));

    /* FIXME: This won't be correct if the node happens to be shared.
     * That's an issue to be solved with shared nodes in general,
     * though. */
    COPY_LINE_NUMBER_INFO((yyval.n), (yyvsp[-3].n));
  }
#line 7442 "y.tab.c"
    break;

  case 342: /* optional_label: %empty  */
#line 2346 "language.yacc"
                {(yyval.n) = 0;}
#line 7448 "y.tab.c"
    break;

  case 343: /* break: "break" optional_label  */
#line 2349 "language.yacc"
                                { (yyval.n)=mknode(F_BREAK,(yyvsp[0].n),0); }
#line 7454 "y.tab.c"
    break;

  case 344: /* default: "default" ':'  */
#line 2350 "language.yacc"
                          { (yyval.n)=mknode(F_DEFAULT,0,0); }
#line 7460 "y.tab.c"
    break;

  case 345: /* default: "default"  */
#line 2352 "language.yacc"
  {
    (yyval.n)=mknode(F_DEFAULT,0,0); yyerror("Expected ':' after default.");
  }
#line 7468 "y.tab.c"
    break;

  case 346: /* continue: "continue" optional_label  */
#line 2357 "language.yacc"
                                      { (yyval.n)=mknode(F_CONTINUE,(yyvsp[0].n),0); }
#line 7474 "y.tab.c"
    break;

  case 347: /* start_lambda: %empty  */
#line 2364 "language.yacc"
  {
    push_compiler_frame(SCOPE_LOCAL);

    debug_malloc_touch(Pike_compiler->compiler_frame->current_return_type);
    if(Pike_compiler->compiler_frame->current_return_type)
      free_type(Pike_compiler->compiler_frame->current_return_type);
    copy_pike_type(Pike_compiler->compiler_frame->current_return_type,
		   any_type_string);

    (yyval.ptr) = Pike_compiler->compiler_frame;
  }
#line 7490 "y.tab.c"
    break;

  case 348: /* optional_local_modifier: %empty  */
#line 2377 "language.yacc"
                                     { (yyval.number) = 0; }
#line 7496 "y.tab.c"
    break;

  case 350: /* implicit_identifier: %empty  */
#line 2382 "language.yacc"
  {
    struct pike_string *name;
    (yyval.n)=mkstrnode(name = get_new_name(NULL));
    free_string(name);
  }
#line 7506 "y.tab.c"
    break;

  case 351: /* @27: %empty  */
#line 2391 "language.yacc"
  {
    struct pike_string *name = (yyvsp[-2].n)->u.sval.u.string;
    node *save_attrs;

    /* Define a tentative prototype for the lambda. */
    save_attrs = Pike_compiler->current_attributes;
    Pike_compiler->current_attributes = NULL;
    (yyval.number) =
      compiler_declare_prototype((yyvsp[-5].number) | ID_PROTECTED | ID_PRIVATE |
                                 ID_INLINE | ID_USED,
                                 name, (yyvsp[0].number), 0,
                                 Pike_compiler->compiler_frame->opt_flags);
#ifdef PIKE_DEBUG
    if (Pike_compiler->current_attributes) {
      Pike_fatal("Unexpected attribute scope.\n");
    }
#endif
    Pike_compiler->current_attributes = save_attrs;
  }
#line 7530 "y.tab.c"
    break;

  case 352: /* lambda: optional_local_modifier "lambda" line_number_info implicit_identifier start_lambda func_args @27 failsafe_block  */
#line 2411 "language.yacc"
  {
    struct pike_type *type;
    int f, e, ee;
    struct pike_string *name = (yyvsp[-4].n)->u.sval.u.string;
    struct compilation *c = THIS_COMPILATION;
    struct pike_string *save_file = c->lex.current_file;
    int save_line = c->lex.current_line;
    node *save_attrs;

    c->lex.current_file = (yyvsp[-5].n)->current_file;
    c->lex.current_line = (yyvsp[-5].n)->line_number;

    /*
     * Fixup return type.
     */
    if (Pike_compiler->compiler_pass == COMPILER_PASS_LAST) {
      /* Doing this in pass 1 might induce too strict checks on types
       * in cases where we got placeholders. */
      type = find_return_type((yyvsp[0].n));
      if (!type) {
	yywarning("Failed to determine return type for lambda.");
        type = zero_type_string;
        add_ref(type);
      }

      free_type(Pike_compiler->compiler_frame->current_return_type);
      Pike_compiler->compiler_frame->current_return_type = type;

      /* Redefine the prototype for the lambda. */
      save_attrs = Pike_compiler->current_attributes;
      Pike_compiler->current_attributes = NULL;
      f = compiler_declare_prototype((yyvsp[-7].number) | ID_PROTECTED | ID_PRIVATE |
                                     ID_INLINE | ID_USED,
                                     name, (yyvsp[-2].number), 0,
                                     Pike_compiler->compiler_frame->opt_flags);
#ifdef PIKE_DEBUG
      if (Pike_compiler->current_attributes) {
        Pike_fatal("Unexpected attribute scope.\n");
      }
      if (f != (yyvsp[-1].number)) {
        Pike_fatal("Reference for lambda changed. %d != %d\n",
                   f, (yyvsp[-1].number));
      }
#endif
      Pike_compiler->current_attributes = save_attrs;
    } else {
      f = (yyvsp[-1].number);
    }

    e=(yyvsp[-2].number)-1;
    if (Pike_compiler->compiler_frame->varargs) {
      e--;
    }
    for(; e>=0; e--) {
      ee = Pike_compiler->compiler_frame->local_variables[e] - 1;

      (yyvsp[0].n) = mknode(F_COMMA_EXPR, set_default_value(ee), (yyvsp[0].n));
    }

    type = ID_FROM_INT(Pike_compiler->new_program, f)->type;
    add_ref(type);	/* Avoid free_type() followed by add_ref()... */

    name = (yyvsp[-4].n)->u.sval.u.string;

#ifdef LAMBDA_DEBUG
    fprintf(stderr, "%d: LAMBDA: %s 0x%08lx 0x%08lx\n%d:   type: ",
	    Pike_compiler->compiler_pass, name->str,
	    (long)Pike_compiler->new_program->id,
	    Pike_compiler->local_class_counter-1,
	    Pike_compiler->compiler_pass);
    simple_describe_type(type);
    fprintf(stderr, "\n");
#endif /* LAMBDA_DEBUG */

    f = compiler_define_function((yyvsp[-7].number) | ID_PROTECTED | ID_PRIVATE |
                                 ID_INLINE | ID_USED,
                                 name, type, (yyvsp[0].n), (yyvsp[-2].number), 0,
                                 Pike_compiler->compiler_frame->opt_flags);

#ifdef PIKE_DEBUG
    if (f != Pike_compiler->compiler_frame->current_function_number) {
      Pike_fatal("Lost track of lambda %s.\n", name->str);
    }
#endif /* PIKE_DEBUG */

#ifdef LAMBDA_DEBUG
    fprintf(stderr, "%d:   lexical_scope: 0x%08x\n",
	    Pike_compiler->compiler_pass,
	    Pike_compiler->compiler_frame->lexical_scope);
#endif /* LAMBDA_DEBUG */

    if(Pike_compiler->compiler_frame->lexical_scope & SCOPE_SCOPED) {
      (yyval.n) = mktrampolinenode(f, Pike_compiler->compiler_frame->previous);
    } else {
      (yyval.n) = mkidentifiernode(f);
    }
    free_type(type);

    c->lex.current_line = save_line;
    c->lex.current_file = save_file;
    free_node((yyvsp[-4].n));
    free_node ((yyvsp[-5].n));
#ifdef PIKE_DEBUG
    if (Pike_compiler->compiler_frame != (yyvsp[-3].ptr)) {
      Pike_fatal("Lost track of compiler_frame!\n"
		 "  Got: %p (Expected: %p) Previous: %p\n",
                 Pike_compiler->compiler_frame, (yyvsp[-3].ptr),
		 Pike_compiler->compiler_frame->previous);
    }
#endif
    pop_compiler_frame();
  }
#line 7647 "y.tab.c"
    break;

  case 353: /* lambda: optional_local_modifier "lambda" line_number_info implicit_identifier start_lambda error  */
#line 2525 "language.yacc"
  {
#ifdef PIKE_DEBUG
    if (Pike_compiler->compiler_frame != (yyvsp[-1].ptr)) {
      Pike_fatal("Lost track of compiler_frame!\n"
		 "  Got: %p (Expected: %p) Previous: %p\n",
                 Pike_compiler->compiler_frame, (yyvsp[-1].ptr),
		 Pike_compiler->compiler_frame->previous);
    }
#endif
    pop_compiler_frame();
    (yyval.n) = mkintnode(0);
    COPY_LINE_NUMBER_INFO((yyval.n), (yyvsp[-3].n));
    free_node((yyvsp[-2].n));
    free_node((yyvsp[-3].n));
  }
#line 7667 "y.tab.c"
    break;

  case 354: /* @28: %empty  */
#line 2543 "language.yacc"
  {
    struct pike_string *name = get_new_name((yyvsp[-2].n)->u.sval.u.string);
    node *save_attrs = Pike_compiler->current_attributes;
    Pike_compiler->current_attributes = NULL;

    (yyval.number) =
      compiler_declare_prototype(ID_PROTECTED | ID_PRIVATE |
                                 ID_INLINE | ID_USED,
                                 name, (yyvsp[0].number), 0,
                                 OPT_SIDE_EFFECT|OPT_EXTERNAL_DEPEND);
    free_string(name);
#ifdef PIKE_DEBUG
    if (Pike_compiler->current_attributes) {
      Pike_fatal("Unexpected attribute scope.\n");
    }
#endif
    Pike_compiler->current_attributes = save_attrs;

    add_parent_local_function((yyvsp[-2].n)->u.sval.u.string, (yyval.number));
  }
#line 7692 "y.tab.c"
    break;

  case 355: /* local_function: "identifier" start_function func_args @28 failsafe_block  */
#line 2564 "language.yacc"
  {
    int localid;
    struct identifier *i=ID_FROM_INT(Pike_compiler->new_program,(yyvsp[-1].number));
    int f = compiler_define_function(ID_PROTECTED | ID_PRIVATE |
                                     ID_INLINE | ID_USED,
                                     i->name, i->type, (yyvsp[0].n),
                                     (yyvsp[-2].number), 0,
                                     OPT_SIDE_EFFECT|OPT_EXTERNAL_DEPEND);
#ifdef PIKE_DEBUG
    if (Pike_compiler->compiler_frame != (yyvsp[-3].ptr)) {
      Pike_fatal("Lost track of compiler_frame!\n"
		 "  Got: %p (Expected: %p) Previous: %p\n",
		 Pike_compiler->compiler_frame, (yyvsp[-3].ptr),
		 Pike_compiler->compiler_frame->previous);
    }
#endif
    pop_compiler_frame();
    free_node((yyvsp[-4].n));

    /* WARNING: If the local function adds more variables we are screwed */
    /* WARNING2: if add_local_name stops adding local variables at the end,
     *           this has to be fixed.
     */

    localid=Pike_compiler->compiler_frame->current_number_of_locals-1;
    if(Pike_compiler->compiler_frame->local_names[localid].def)
    {
      (yyval.n)=copy_node(Pike_compiler->compiler_frame->local_names[localid].def);
    }else{
      if(Pike_compiler->compiler_frame->lexical_scope &
	 (SCOPE_SCOPE_USED | SCOPE_SCOPED))
      {
        (yyval.n) = mktrampolinenode(f, Pike_compiler->compiler_frame);
      }else{
        (yyval.n) = mkidentifiernode(f);
      }
    }
  }
#line 7735 "y.tab.c"
    break;

  case 356: /* local_function: "identifier" start_function error  */
#line 2603 "language.yacc"
  {
#ifdef PIKE_DEBUG
    if (Pike_compiler->compiler_frame != (yyvsp[-1].ptr)) {
      Pike_fatal("Lost track of compiler_frame!\n"
		 "  Got: %p (Expected: %p) Previous: %p\n",
		 Pike_compiler->compiler_frame, (yyvsp[-1].ptr),
		 Pike_compiler->compiler_frame->previous);
    }
#endif
    pop_compiler_frame();
    (yyval.n)=mkintnode(0);
  }
#line 7752 "y.tab.c"
    break;

  case 357: /* @29: %empty  */
#line 2623 "language.yacc"
  {
    struct pike_string *name = get_new_name((yyvsp[-2].n)->u.sval.u.string);
    node *save_attrs = Pike_compiler->current_attributes;
    Pike_compiler->current_attributes = NULL;

    (yyval.number) =
      compiler_declare_prototype((yyvsp[-4].number) | ID_PROTECTED | ID_PRIVATE |
                                 ID_INLINE | ID_USED,
                                 name, (yyvsp[0].number), 0,
                                 OPT_SIDE_EFFECT|OPT_EXTERNAL_DEPEND);
    free_string(name);
#ifdef PIKE_DEBUG
    if (Pike_compiler->current_attributes) {
      Pike_fatal("Unexpected attribute scope.\n");
    }
#endif
    Pike_compiler->current_attributes = save_attrs;

    add_parent_local_function((yyvsp[-2].n)->u.sval.u.string, (yyval.number));
  }
#line 7777 "y.tab.c"
    break;

  case 358: /* local_restartable_function: local_modifier simple_type2 "identifier" start_function func_args @29 failsafe_block  */
#line 2644 "language.yacc"
  {
    int localid;
    struct identifier *i = ID_FROM_INT(Pike_compiler->new_program, (yyvsp[-1].number));
    int f = compiler_define_function((yyvsp[-6].number) | ID_PROTECTED | ID_PRIVATE |
                                     ID_INLINE | ID_USED,
                                     i->name, i->type, (yyvsp[0].n),
                                     (yyvsp[-2].number), 0,
                                     OPT_SIDE_EFFECT|OPT_EXTERNAL_DEPEND);
#ifdef PIKE_DEBUG
    if (Pike_compiler->compiler_frame != (yyvsp[-3].ptr)) {
      Pike_fatal("Lost track of compiler_frame!\n"
		 "  Got: %p (Expected: %p) Previous: %p\n",
                 Pike_compiler->compiler_frame, (yyvsp[-3].ptr),
		 Pike_compiler->compiler_frame->previous);
    }
#endif
    pop_compiler_frame();
    free_node((yyvsp[-4].n));

    /* WARNING: If the local function adds more variables we are screwed */
    /* WARNING2: if add_local_name stops adding local variables at the end,
     *           this has to be fixed.
     */

    localid=Pike_compiler->compiler_frame->current_number_of_locals-1;
    if(Pike_compiler->compiler_frame->local_names[localid].def)
    {
      (yyval.n)=copy_node(Pike_compiler->compiler_frame->local_names[localid].def);
    }else{
      if(Pike_compiler->compiler_frame->lexical_scope &
	 (SCOPE_SCOPE_USED | SCOPE_SCOPED))
      {
	(yyval.n) = mktrampolinenode(f, Pike_compiler->compiler_frame);
      }else{
	(yyval.n) = mkidentifiernode(f);
      }
    }
  }
#line 7820 "y.tab.c"
    break;

  case 359: /* local_restartable_function: local_modifier simple_type2 "identifier" start_function error  */
#line 2683 "language.yacc"
  {
#ifdef PIKE_DEBUG
    if (Pike_compiler->compiler_frame != (yyvsp[-1].ptr)) {
      Pike_fatal("Lost track of compiler_frame!\n"
		 "  Got: %p (Expected: %p) Previous: %p\n",
                 Pike_compiler->compiler_frame, (yyvsp[-1].ptr),
		 Pike_compiler->compiler_frame->previous);
    }
#endif
    pop_compiler_frame();
    (yyval.n)=mkintnode(0);
  }
#line 7837 "y.tab.c"
    break;

  case 360: /* create_arg: modifiers simple_type optional_dot_dot_dot "identifier" optional_default_value  */
#line 2699 "language.yacc"
  {
    struct pike_type *type;
    int ref_no;
    int l_no;

    if (Pike_compiler->num_create_args < 0) {
      yyerror("Can't define more variables after ...");
    }

    if ((yyvsp[-2].number)) {
      push_finished_type(Pike_compiler->compiler_frame->current_type);
      push_unlimited_array_type(T_ARRAY);
      type = compiler_pop_type();
    } else {
      copy_pike_type(type, Pike_compiler->compiler_frame->current_type);
    }

    /* Add the identifier globally.
     * Note: Since these are the first identifiers (and references)
     *       to be added to the program, they will be numbered in
     *       sequence. This means that the counter num_create_args
     *       is sufficient extra information to be able to keep
     *       track of them.
     */
    ref_no = define_variable((yyvsp[-1].n)->u.sval.u.string, type,
			     Pike_compiler->current_modifiers);

    if ((Pike_compiler->num_create_args != ref_no) &&
	(Pike_compiler->num_create_args != -ref_no)) {
      my_yyerror("Multiple definitions of create variable %pS (%d != %d).",
		 (yyvsp[-1].n)->u.sval.u.string,
		 Pike_compiler->num_create_args, ref_no);
    }
    if ((yyvsp[-2].number)) {
      /* Encode varargs marker as negative number of args. */
      Pike_compiler->num_create_args = -(ref_no + 1);

      if ((yyvsp[0].n)) {
	yyerror("Varargs variable with default value.");
	free_node((yyvsp[0].n));
	(yyvsp[0].n) = NULL;
      }
    } else {
      Pike_compiler->num_create_args = ref_no + 1;
    }

    l_no = add_local_name((yyvsp[-1].n)->u.sval.u.string, type, (yyvsp[0].n));
    bind_local(NULL, l_no);
    Pike_compiler->compiler_frame->local_names[l_no].flags |=
      LOCAL_VAR_IS_ARGUMENT | LOCAL_VAR_IS_USED;

    if (ref_no != l_no) {
      my_yyerror("Variables out of sync for __create__().");
    }

    /* free_type(type); */
    free_node((yyvsp[-1].n));
    (yyval.number)=0;
  }
#line 7901 "y.tab.c"
    break;

  case 361: /* create_arg: modifiers simple_type optional_dot_dot_dot bad_identifier  */
#line 2758 "language.yacc"
                                                              { (yyval.number)=0; }
#line 7907 "y.tab.c"
    break;

  case 362: /* create_arg: modifiers simple_type optional_dot_dot_dot  */
#line 2759 "language.yacc"
                                               {
    yyerror("Missing identifier.");
    (yyval.number)=0;
  }
#line 7916 "y.tab.c"
    break;

  case 363: /* create_arguments2: create_arg  */
#line 2765 "language.yacc"
                              { (yyval.number) = 1; }
#line 7922 "y.tab.c"
    break;

  case 364: /* create_arguments2: create_arguments2 ',' create_arg  */
#line 2766 "language.yacc"
                                     { (yyval.number) = (yyvsp[-2].number) + 1; }
#line 7928 "y.tab.c"
    break;

  case 365: /* create_arguments2: create_arguments2 ':' create_arg  */
#line 2768 "language.yacc"
  {
    yyerror("Unexpected ':' in create argument list.");
    (yyval.number) = (yyvsp[-2].number) + 1;
  }
#line 7937 "y.tab.c"
    break;

  case 366: /* create_arguments: optional_comma  */
#line 2774 "language.yacc"
                                             { (yyval.number)=0; }
#line 7943 "y.tab.c"
    break;

  case 369: /* generic_type_decl: full_type "identifier" optional_default_type  */
#line 2780 "language.yacc"
  {
    struct pike_type *t = compiler_pop_type();
    compiler_add_generic((yyvsp[-1].n)->u.sval.u.string, t,
                         (yyvsp[0].n)?(yyvsp[0].n)->u.sval.u.type:NULL);
    free_type(t);
    free_node((yyvsp[0].n));
    free_node((yyvsp[-1].n));
  }
#line 7956 "y.tab.c"
    break;

  case 370: /* generic_type_decl: "identifier" optional_default_type  */
#line 2789 "language.yacc"
  {
    compiler_add_generic((yyvsp[-1].n)->u.sval.u.string, NULL,
                         (yyvsp[0].n)?(yyvsp[0].n)->u.sval.u.type:NULL);
    free_node((yyvsp[0].n));
    free_node((yyvsp[-1].n));
  }
#line 7967 "y.tab.c"
    break;

  case 374: /* $@30: %empty  */
#line 2803 "language.yacc"
  {
    /* Make sure that mk_type() can detect that we use generics. */
    Pike_compiler->new_program->num_generics = Pike_compiler->num_generics;
  }
#line 7976 "y.tab.c"
    break;

  case 376: /* optional_create_arguments: optional_generic_types  */
#line 2810 "language.yacc"
                                                  { (yyval.number) = 0; }
#line 7982 "y.tab.c"
    break;

  case 377: /* optional_create_arguments: optional_generic_types start_lambda '(' create_arguments ')'  */
#line 2812 "language.yacc"
  {
    compiler_define_implicit___create__();

#ifdef PIKE_DEBUG
    if (Pike_compiler->compiler_frame != (yyvsp[-3].ptr)) {
      Pike_fatal("Lost track of compiler_frame!\n"
		 "  Got: %p (Expected: %p) Previous: %p\n",
                 Pike_compiler->compiler_frame, (yyvsp[-3].ptr),
		 Pike_compiler->compiler_frame->previous);
    }
#endif
    pop_compiler_frame();

    /* NOTE: One more than the number of arguments, so that we
     *       can detect the case of no parenthesis below when
     *       we define the user lfun::create() function.
     */
    (yyval.number) = (yyvsp[-1].number) + 1;
  }
#line 8006 "y.tab.c"
    break;

  case 378: /* @31: %empty  */
#line 2833 "language.yacc"
                              { (yyval.n) = NULL; }
#line 8012 "y.tab.c"
    break;

  case 380: /* failsafe_program: error  */
#line 2834 "language.yacc"
                        { yyerrok; }
#line 8018 "y.tab.c"
    break;

  case 381: /* failsafe_program: "end of file"  */
#line 2836 "language.yacc"
                {
		  yyerror("End of file where program definition expected.");
		}
#line 8026 "y.tab.c"
    break;

  case 382: /* @32: %empty  */
#line 2843 "language.yacc"
  {
    struct pike_string *s;
    char buffer[42];
    sprintf(buffer,"__class_%ld_%ld_line_%d",
	    (long)Pike_compiler->new_program->id,
	    (long)Pike_compiler->local_class_counter++,
	    (int) (yyvsp[0].n)->line_number);
    s = make_shared_string(buffer);
    (yyval.n) = mkstrnode(s);
    free_string(s);
    (yyvsp[-2].number) |= ID_PROTECTED | ID_PRIVATE | ID_INLINE;
  }
#line 8043 "y.tab.c"
    break;

  case 383: /* @33: %empty  */
#line 2855 "language.yacc"
  {
    /* fprintf(stderr, "LANGUAGE.YACC: ANON CLASS start\n"); */
    if(Pike_compiler->compiler_pass == COMPILER_PASS_FIRST)
    {
      if ((yyvsp[-3].number) & ID_EXTERN) {
	yywarning("Extern declared class definition.");
      }
      low_start_new_program(0, COMPILER_PASS_FIRST, (yyvsp[0].n)->u.sval.u.string,
			    (yyvsp[-3].number),
			    &(yyval.number));

      /* fprintf(stderr, "Pass 1: Program %s has id %d\n",
	 $3->u.sval.u.string->str, Pike_compiler->new_program->id); */

      store_linenumber((yyvsp[-1].n)->line_number, (yyvsp[-1].n)->current_file);
      debug_malloc_name(Pike_compiler->new_program,
			(yyvsp[-1].n)->current_file->str,
			(yyvsp[-1].n)->line_number);
    }else{
      int i;
      struct identifier *id;
      int tmp=Pike_compiler->compiler_pass;
      i=isidentifier((yyvsp[0].n)->u.sval.u.string);
      if(i<0)
      {
	/* Seriously broken... */
	yyerror("Pass 2: program not defined!");
	low_start_new_program(0, COMPILER_PASS_LAST, 0,
			      (yyvsp[-3].number),
			      &(yyval.number));
      }else{
	id=ID_FROM_INT(Pike_compiler->new_program, i);
	if(IDENTIFIER_IS_CONSTANT(id->identifier_flags))
	{
	  struct svalue *s;
	  if ((id->func.const_info.offset >= 0) &&
	      (TYPEOF(*(s = &PROG_FROM_INT(Pike_compiler->new_program,i)->
			constants[id->func.const_info.offset].sval)) ==
	       T_PROGRAM))
	  {
	    low_start_new_program(s->u.program, COMPILER_PASS_LAST,
				  (yyvsp[0].n)->u.sval.u.string,
				  (yyvsp[-3].number),
				  &(yyval.number));

	    /* fprintf(stderr, "Pass 2: Program %s has id %d\n",
	       $3->u.sval.u.string->str, Pike_compiler->new_program->id); */

	  }else{
	    yyerror("Pass 2: constant redefined!");
	    low_start_new_program(0, COMPILER_PASS_LAST, 0,
				  (yyvsp[-3].number),
				  &(yyval.number));
	  }
	}else{
	  yyerror("Pass 2: class constant no longer constant!");
	  low_start_new_program(0, COMPILER_PASS_LAST, 0,
				(yyvsp[-3].number),
				&(yyval.number));
	}
      }
      Pike_compiler->compiler_pass=tmp;
    }
  }
#line 8112 "y.tab.c"
    break;

  case 384: /* @34: %empty  */
#line 2919 "language.yacc"
  {
    /* Clear scoped modifiers. */
    (yyval.number) = THIS_COMPILATION->lex.pragmas;
    THIS_COMPILATION->lex.pragmas &= ~ID_MODIFIER_MASK;
  }
#line 8122 "y.tab.c"
    break;

  case 385: /* anon_class: "class" line_number_info @32 @33 @34 optional_create_arguments failsafe_program  */
#line 2925 "language.yacc"
  {
    compiler_end_class((yyvsp[-1].number), (yyvsp[-3].number));

    (yyval.n)=mkidentifiernode((yyvsp[-3].number));

    free_node((yyvsp[-5].n));
    free_node((yyvsp[-4].n));
    check_tree((yyval.n),0);
    THIS_COMPILATION->lex.pragmas = (yyvsp[-2].number);
  }
#line 8137 "y.tab.c"
    break;

  case 386: /* @35: %empty  */
#line 2939 "language.yacc"
  {
    if(!(yyvsp[0].n))
    {
      struct pike_string *s;
      char buffer[42];
      sprintf(buffer,"__class_%ld_%ld_line_%d",
	      (long)Pike_compiler->new_program->id,
	      (long)Pike_compiler->local_class_counter++,
	      (int) (yyvsp[-1].n)->line_number);
      s=make_shared_string(buffer);
      (yyvsp[0].n)=mkstrnode(s);
      free_string(s);
      (yyvsp[-3].number)|=ID_PROTECTED | ID_PRIVATE | ID_INLINE;
    }

    /* fprintf(stderr, "LANGUAGE.YACC: CLASS start\n"); */
    if(Pike_compiler->compiler_pass == COMPILER_PASS_FIRST)
    {
      if ((yyvsp[-3].number) & ID_EXTERN) {
	yywarning("Extern declared class definition.");
      }
      low_start_new_program(0, COMPILER_PASS_FIRST, (yyvsp[0].n)->u.sval.u.string,
			    (yyvsp[-3].number),
			    &(yyval.number));

      /* fprintf(stderr, "Pass 1: Program %s has id %d\n",
	 $3->u.sval.u.string->str, Pike_compiler->new_program->id); */

      store_linenumber((yyvsp[-1].n)->line_number, (yyvsp[-1].n)->current_file);
      debug_malloc_name(Pike_compiler->new_program,
			(yyvsp[-1].n)->current_file->str,
			(yyvsp[-1].n)->line_number);
    }else{
      int i;
      struct identifier *id;
      int tmp=Pike_compiler->compiler_pass;
      i=isidentifier((yyvsp[0].n)->u.sval.u.string);
      if(i<0)
      {
	/* Seriously broken... */
	yyerror("Pass 2: program not defined!");
	low_start_new_program(0, COMPILER_PASS_LAST, 0,
			      (yyvsp[-3].number),
			      &(yyval.number));
      }else{
	id=ID_FROM_INT(Pike_compiler->new_program, i);
	if(IDENTIFIER_IS_CONSTANT(id->identifier_flags))
	{
	  struct svalue *s;
	  if ((id->func.const_info.offset >= 0) &&
	      (TYPEOF(*(s = &PROG_FROM_INT(Pike_compiler->new_program,i)->
			constants[id->func.const_info.offset].sval)) ==
	       T_PROGRAM))
	  {
	    low_start_new_program(s->u.program, COMPILER_PASS_LAST,
				  (yyvsp[0].n)->u.sval.u.string,
				  (yyvsp[-3].number),
				  &(yyval.number));

	    /* fprintf(stderr, "Pass 2: Program %s has id %d\n",
	       $3->u.sval.u.string->str, Pike_compiler->new_program->id); */

	  }else{
	    yyerror("Pass 2: constant redefined!");
	    low_start_new_program(0, COMPILER_PASS_LAST, 0,
				  (yyvsp[-3].number),
				  &(yyval.number));
	  }
	}else{
	  yyerror("Pass 2: class constant no longer constant!");
	  low_start_new_program(0, COMPILER_PASS_LAST, 0,
				(yyvsp[-3].number),
				&(yyval.number));
	}
      }
      Pike_compiler->compiler_pass=tmp;
    }
  }
#line 8220 "y.tab.c"
    break;

  case 387: /* @36: %empty  */
#line 3017 "language.yacc"
  {
    /* Clear scoped modifiers. */
    (yyval.number) = THIS_COMPILATION->lex.pragmas;
    THIS_COMPILATION->lex.pragmas &= ~ID_MODIFIER_MASK;
  }
#line 8230 "y.tab.c"
    break;

  case 388: /* named_class: "class" line_number_info simple_identifier @35 @36 optional_create_arguments failsafe_program  */
#line 3023 "language.yacc"
  {
    compiler_end_class((yyvsp[-1].number), (yyvsp[-3].number));

    (yyval.n)=mkidentifiernode((yyvsp[-3].number));

    free_node((yyvsp[-5].n));
    free_node((yyvsp[-4].n));
    check_tree((yyval.n),0);
    THIS_COMPILATION->lex.pragmas = (yyvsp[-2].number);
  }
#line 8245 "y.tab.c"
    break;

  case 390: /* simple_identifier: bad_identifier  */
#line 3036 "language.yacc"
                   { (yyval.n) = 0; }
#line 8251 "y.tab.c"
    break;

  case 391: /* enum_value: %empty  */
#line 3039 "language.yacc"
                        { (yyval.n) = 0; }
#line 8257 "y.tab.c"
    break;

  case 392: /* enum_value: '=' safe_assignment_expr  */
#line 3040 "language.yacc"
                             { (yyval.n) = (yyvsp[0].n); }
#line 8263 "y.tab.c"
    break;

  case 394: /* enum_def: simple_identifier enum_value  */
#line 3046 "language.yacc"
  {
    if ((yyvsp[-1].n)) {
      if ((yyvsp[0].n)) {
	/* Explicit enum value. */

	/* This can be made more lenient in the future */

	/* Ugly hack to make sure that $2 is optimized */
	{
	  int tmp=Pike_compiler->compiler_pass;
	  (yyvsp[0].n)=mknode(F_COMMA_EXPR,(yyvsp[0].n),0);
	  Pike_compiler->compiler_pass=tmp;
	}

	if(!is_const((yyvsp[0].n)))
	{
          yyerror_not_constant("Enum", (yyvsp[0].n));
	  push_int(0);
	} else {
	  if(!Pike_compiler->num_parse_error)
	  {
	    ptrdiff_t tmp=eval_low((yyvsp[0].n),1);
	    if(tmp < 1)
	    {
	      yyerror("Error in enum definition.");
	      push_int(0);
	    }else{
              pop_n_elems((INT32)(tmp - 1));
	    }
	  } else {
	    push_int(0);
	  }
	}
	free_node((yyvsp[0].n));
	free_node((yyvsp[-2].n));
	(yyvsp[-2].n) = mkconstantsvaluenode(Pike_sp-1);
      } else {
	/* Implicit enum value. */
	(yyvsp[-2].n) = safe_inc_enum((yyvsp[-2].n));
	push_svalue(&(yyvsp[-2].n)->u.sval);
      }
      add_typed_constant((yyvsp[-1].n)->u.sval.u.string, (yyvsp[-2].n)->type, Pike_sp-1,
                         (Pike_compiler->current_modifiers & ~ID_EXTERN) | ID_INLINE);
      /* Update the type. */
      {
	struct pike_type *current = pop_unfinished_type();
	struct pike_type *new = get_type_of_svalue(Pike_sp-1);
	struct pike_type *res = or_pike_types(new, current, 2);
	free_type(current);
	free_type(new);
	type_stack_mark();
	push_finished_type(res);
	free_type(res);
      }
      pop_stack();
      free_node((yyvsp[-1].n));
    } else if ((yyvsp[0].n)) {
      free_node((yyvsp[0].n));
    }
  }
#line 8328 "y.tab.c"
    break;

  case 395: /* propagated_enum_value: %empty  */
#line 3110 "language.yacc"
  {
    (yyval.n) = (yyvsp[(-2) - (0)].n);
  }
#line 8336 "y.tab.c"
    break;

  case 397: /* enum_list: enum_list ',' propagated_enum_value enum_def  */
#line 3117 "language.yacc"
                                                 { (yyvsp[-4].n) = (yyvsp[-1].n); }
#line 8342 "y.tab.c"
    break;

  case 399: /* $@37: %empty  */
#line 3123 "language.yacc"
  {
    if ((Pike_compiler->current_modifiers & ID_EXTERN) &&
	(Pike_compiler->compiler_pass == COMPILER_PASS_FIRST)) {
      yywarning("Extern declared enum.");
    }

    type_stack_mark();
    push_type(T_ZERO);	/* Joined type so far. */
  }
#line 8356 "y.tab.c"
    break;

  case 400: /* @38: %empty  */
#line 3133 "language.yacc"
  {
    push_int(-1);	/* Previous value. */
    (yyval.n) = mkconstantsvaluenode(Pike_sp-1);
    pop_stack();
  }
#line 8366 "y.tab.c"
    break;

  case 401: /* @39: %empty  */
#line 3138 "language.yacc"
            { (yyval.n) = NULL; }
#line 8372 "y.tab.c"
    break;

  case 402: /* enum: "enum" $@37 optional_identifier '{' @38 enum_list @39 end_block  */
#line 3139 "language.yacc"
  {
    struct pike_type *t = pop_unfinished_type();
    free_node((yyvsp[-3].n));
    if ((yyvsp[-5].n)) {
      ref_push_type_value(t);
      add_constant((yyvsp[-5].n)->u.sval.u.string, Pike_sp-1,
		   (Pike_compiler->current_modifiers & ~ID_EXTERN) | ID_INLINE);
      pop_stack();
      free_node((yyvsp[-5].n));
    }
    (yyval.n) = mktypenode(t);
    free_type(t);
  }
#line 8390 "y.tab.c"
    break;

  case 403: /* typedef: modifiers "typedef" full_type simple_identifier ';'  */
#line 3155 "language.yacc"
  {
    struct pike_type *t = compiler_pop_type();

    if ((Pike_compiler->current_modifiers & ID_EXTERN) &&
	(Pike_compiler->compiler_pass == COMPILER_PASS_FIRST)) {
      yywarning("Extern declared typedef.");
    }

    if ((yyvsp[-1].n)) {
      ref_push_type_value(t);
      add_constant((yyvsp[-1].n)->u.sval.u.string, Pike_sp-1,
		   (Pike_compiler->current_modifiers & ~ID_EXTERN) | ID_INLINE);
      pop_stack();
      free_node((yyvsp[-1].n));
    }
    free_type(t);
  }
#line 8412 "y.tab.c"
    break;

  case 404: /* save_locals: %empty  */
#line 3175 "language.yacc"
  {
    Pike_compiler->compiler_frame->last_block_level =
      (yyval.number) = Pike_compiler->compiler_frame->current_number_of_locals;
  }
#line 8421 "y.tab.c"
    break;

  case 405: /* save_block_level: %empty  */
#line 3182 "language.yacc"
  {
    /* Trick to store more than one number on compiler stack - Hubbe */
    (yyval.number) = Pike_compiler->compiler_frame->last_block_level;
  }
#line 8430 "y.tab.c"
    break;

  case 406: /* cond: "if" save_block_level save_locals line_number_info '(' safe_init_expr end_cond statement optional_else_part  */
#line 3190 "language.yacc"
  {
    (yyval.n) = mknode('?', (yyvsp[-3].n),
		mknode(':',
		       mkcastnode(void_type_string, (yyvsp[-1].n)),
		       mkcastnode(void_type_string, (yyvsp[0].n))));
    COPY_LINE_NUMBER_INFO((yyval.n), (yyvsp[-5].n));
    (yyval.n) = mkcastnode(void_type_string, (yyval.n));
    COPY_LINE_NUMBER_INFO((yyval.n), (yyvsp[-5].n));
    free_node((yyvsp[-5].n));
    (yyval.n) = pop_local_variables((yyvsp[-6].number), (yyval.n));
    Pike_compiler->compiler_frame->last_block_level = (yyvsp[-7].number);
  }
#line 8447 "y.tab.c"
    break;

  case 408: /* end_cond: '}'  */
#line 3205 "language.yacc"
        { yyerror("Missing ')'."); }
#line 8453 "y.tab.c"
    break;

  case 409: /* end_cond: "end of file"  */
#line 3207 "language.yacc"
  {
    yyerror("Missing ')'.");
    yyerror("Unexpected end of file.");
  }
#line 8462 "y.tab.c"
    break;

  case 410: /* optional_else_part: %empty  */
#line 3213 "language.yacc"
                    { (yyval.n)=0; }
#line 8468 "y.tab.c"
    break;

  case 411: /* optional_else_part: "else" statement  */
#line 3214 "language.yacc"
                       { (yyval.n)=(yyvsp[0].n); }
#line 8474 "y.tab.c"
    break;

  case 412: /* safe_lvalue: lvalue  */
#line 3218 "language.yacc"
  {
    if (!(THIS_COMPILATION->lex.pragmas & ID_STRICT_TYPES) && (yyvsp[0].n)) {
      mark_lvalue_as_used((yyvsp[0].n));
    }
  }
#line 8484 "y.tab.c"
    break;

  case 413: /* safe_lvalue: error  */
#line 3223 "language.yacc"
          { (yyval.n)=0; }
#line 8490 "y.tab.c"
    break;

  case 415: /* safe_assignment_expr: "end of file"  */
#line 3227 "language.yacc"
                { yyerror("Unexpected end of file."); (yyval.n)=0; }
#line 8496 "y.tab.c"
    break;

  case 416: /* safe_assignment_expr: error  */
#line 3228 "language.yacc"
          { (yyval.n)=0; }
#line 8502 "y.tab.c"
    break;

  case 417: /* foreach_optional_lvalue: %empty  */
#line 3232 "language.yacc"
                                     { (yyval.n)=0; }
#line 8508 "y.tab.c"
    break;

  case 419: /* foreach_lvalues: ',' safe_lvalue  */
#line 3236 "language.yacc"
                                  { (yyval.n)=(yyvsp[0].n); }
#line 8514 "y.tab.c"
    break;

  case 420: /* foreach_lvalues: ';' foreach_optional_lvalue ';' foreach_optional_lvalue  */
#line 3238 "language.yacc"
  { (yyval.n)=mknode(':',(yyvsp[-2].n),(yyvsp[0].n)); }
#line 8520 "y.tab.c"
    break;

  case 421: /* $@40: %empty  */
#line 3243 "language.yacc"
  {
  }
#line 8527 "y.tab.c"
    break;

  case 422: /* foreach: "foreach" save_block_level save_locals line_number_info '(' assignment_expr foreach_lvalues end_cond $@40 statement  */
#line 3246 "language.yacc"
  {
    if ((yyvsp[-3].n)) {
      (yyval.n)=mknode(F_FOREACH,
		mknode(F_FOREACH_VAL_LVAL,(yyvsp[-4].n),(yyvsp[-3].n)),
		(yyvsp[0].n));
    } else {
      /* Error in lvalue */
      (yyval.n)=mknode(F_COMMA_EXPR, mkcastnode(void_type_string, (yyvsp[-4].n)), (yyvsp[0].n));
    }
    COPY_LINE_NUMBER_INFO((yyval.n), (yyvsp[-6].n));
    free_node((yyvsp[-6].n));
    (yyval.n) = pop_local_variables((yyvsp[-7].number), (yyval.n));
    Pike_compiler->compiler_frame->last_block_level = (yyvsp[-8].number);
    Pike_compiler->compiler_frame->opt_flags |= OPT_CUSTOM_LABELS;
  }
#line 8547 "y.tab.c"
    break;

  case 423: /* do: "do" line_number_info statement "while" '(' safe_init_expr end_cond expected_semicolon  */
#line 3265 "language.yacc"
  {
    (yyval.n)=mknode(F_DO,(yyvsp[-2].n),(yyvsp[-5].n));
    COPY_LINE_NUMBER_INFO((yyval.n), (yyvsp[-6].n));
    free_node ((yyvsp[-6].n));
    Pike_compiler->compiler_frame->opt_flags |= OPT_CUSTOM_LABELS;
  }
#line 8558 "y.tab.c"
    break;

  case 424: /* do: "do" line_number_info statement "while" "end of file"  */
#line 3272 "language.yacc"
  {
    free_node ((yyvsp[-3].n));
    (yyval.n)=0;
    yyerror("Missing '(' in do-while loop.");
    yyerror("Unexpected end of file.");
  }
#line 8569 "y.tab.c"
    break;

  case 425: /* do: "do" line_number_info statement "end of file"  */
#line 3279 "language.yacc"
  {
    free_node ((yyvsp[-2].n));
    (yyval.n)=0;
    yyerror("Missing 'while' in do-while loop.");
    yyerror("Unexpected end of file.");
  }
#line 8580 "y.tab.c"
    break;

  case 427: /* expected_semicolon: "end of file"  */
#line 3289 "language.yacc"
  {
    yyerror("Missing ';'.");
    yyerror("Unexpected end of file.");
  }
#line 8589 "y.tab.c"
    break;

  case 428: /* for: "for" save_block_level save_locals line_number_info '(' optional_void_expr expected_semicolon for_expr expected_semicolon optional_void_expr end_cond statement  */
#line 3298 "language.yacc"
  {
    (yyval.n)=mknode(F_COMMA_EXPR, mkcastnode(void_type_string, (yyvsp[-6].n)),
	      mknode(F_FOR,(yyvsp[-4].n),mknode(':',(yyvsp[0].n),(yyvsp[-2].n))));
    COPY_LINE_NUMBER_INFO((yyval.n), (yyvsp[-8].n));
    free_node((yyvsp[-8].n));
    (yyval.n) = pop_local_variables((yyvsp[-9].number), (yyval.n));
    Pike_compiler->compiler_frame->last_block_level = (yyvsp[-10].number);
    Pike_compiler->compiler_frame->opt_flags |= OPT_CUSTOM_LABELS;
  }
#line 8603 "y.tab.c"
    break;

  case 429: /* while: "while" save_block_level save_locals line_number_info '(' safe_init_expr end_cond statement  */
#line 3311 "language.yacc"
  {
    (yyval.n)=mknode(F_FOR,(yyvsp[-2].n),mknode(':',(yyvsp[0].n),NULL));
    COPY_LINE_NUMBER_INFO((yyval.n), (yyvsp[-4].n));
    free_node((yyvsp[-4].n));
    (yyval.n) = pop_local_variables((yyvsp[-5].number), (yyval.n));
    Pike_compiler->compiler_frame->last_block_level = (yyvsp[-6].number);
    Pike_compiler->compiler_frame->opt_flags |= OPT_CUSTOM_LABELS;
  }
#line 8616 "y.tab.c"
    break;

  case 430: /* for_expr: %empty  */
#line 3321 "language.yacc"
                      { (yyval.n)=mkintnode(1); }
#line 8622 "y.tab.c"
    break;

  case 432: /* switch: "switch" save_block_level save_locals line_number_info '(' safe_init_expr end_cond statement  */
#line 3327 "language.yacc"
  {
    (yyval.n)=mknode(F_SWITCH,(yyvsp[-2].n),(yyvsp[0].n));
    COPY_LINE_NUMBER_INFO((yyval.n), (yyvsp[-4].n));
    free_node((yyvsp[-4].n));
    (yyval.n) = pop_local_variables((yyvsp[-5].number), (yyval.n));
    Pike_compiler->compiler_frame->last_block_level = (yyvsp[-6].number);
  }
#line 8634 "y.tab.c"
    break;

  case 433: /* case: "case" safe_init_expr expected_colon  */
#line 3337 "language.yacc"
  {
    (yyval.n)=mknode(F_CASE,(yyvsp[-1].n),0);
  }
#line 8642 "y.tab.c"
    break;

  case 434: /* case: "case" safe_init_expr expected_dot_dot optional_init_expr expected_colon  */
#line 3341 "language.yacc"
  {
     (yyval.n)=mknode(F_CASE_RANGE,(yyvsp[-3].n),(yyvsp[-1].n));
  }
#line 8650 "y.tab.c"
    break;

  case 435: /* case: "case" expected_dot_dot safe_init_expr expected_colon  */
#line 3345 "language.yacc"
  {
     (yyval.n)=mknode(F_CASE_RANGE,0,(yyvsp[-1].n));
  }
#line 8658 "y.tab.c"
    break;

  case 437: /* expected_colon: ';'  */
#line 3352 "language.yacc"
  {
    yyerror("Missing ':'.");
  }
#line 8666 "y.tab.c"
    break;

  case 438: /* expected_colon: '}'  */
#line 3356 "language.yacc"
  {
    yyerror("Missing ':'.");
  }
#line 8674 "y.tab.c"
    break;

  case 439: /* expected_colon: "end of file"  */
#line 3360 "language.yacc"
  {
    yyerror("Missing ':'.");
    yyerror("Unexpected end of file.");
  }
#line 8683 "y.tab.c"
    break;

  case 440: /* optional_continue: %empty  */
#line 3366 "language.yacc"
                   { (yyval.number) = 0; }
#line 8689 "y.tab.c"
    break;

  case 441: /* optional_continue: "continue"  */
#line 3367 "language.yacc"
                 { (yyval.number) = 1; }
#line 8695 "y.tab.c"
    break;

  case 442: /* optional_continue: "break"  */
#line 3368 "language.yacc"
              { (yyval.number) = 0; }
#line 8701 "y.tab.c"
    break;

  case 443: /* return: optional_continue "return" expected_semicolon  */
#line 3372 "language.yacc"
  {
    if(!match_types(Pike_compiler->compiler_frame->current_return_type,
		    void_type_string))
    {
      yytype_error("Must return a value for a non-void function.",
		   Pike_compiler->compiler_frame->current_return_type,
		   void_type_string, 0);
    }
    (yyval.n) = mknode(F_RETURN, mkintnode(0), mkintnode((yyvsp[-2].number)));
  }
#line 8716 "y.tab.c"
    break;

  case 444: /* return: optional_continue "return" safe_init_expr expected_semicolon  */
#line 3383 "language.yacc"
  {
    if (!(yyvsp[-1].n) ||
	!((yyvsp[-1].n)->tree_info & (OPT_EXTERNAL_DEPEND|OPT_SIDE_EFFECT|OPT_APPLY)) ||
	check_tailrecursion()) {
      (yyval.n) = mknode(F_RETURN, (yyvsp[-1].n), mkintnode((yyvsp[-3].number)));
    } else {
      /* The expression might be doing something that depends on
       * us holding eg a Thread.MutexKey.
       */
      (yyval.n) = mknode(F_VOLATILE_RETURN, (yyvsp[-1].n), mkintnode((yyvsp[-3].number)));
    }
  }
#line 8733 "y.tab.c"
    break;

  case 446: /* splice_expr: '@' assignment_expr  */
#line 3399 "language.yacc"
                            { (yyval.n)=mknode(F_PUSH_ARRAY,(yyvsp[0].n),0); }
#line 8739 "y.tab.c"
    break;

  case 447: /* optional_comma: %empty  */
#line 3401 "language.yacc"
                { (yyval.number)=0; }
#line 8745 "y.tab.c"
    break;

  case 448: /* optional_comma: ','  */
#line 3401 "language.yacc"
                                { (yyval.number)=1; }
#line 8751 "y.tab.c"
    break;

  case 449: /* expr_list: %empty  */
#line 3403 "language.yacc"
           { (yyval.n)=0; }
#line 8757 "y.tab.c"
    break;

  case 452: /* expr_list2: expr_list2 ',' splice_expr  */
#line 3409 "language.yacc"
                               { (yyval.n)=mknode(F_ARG_LIST,(yyvsp[-2].n),(yyvsp[0].n)); }
#line 8763 "y.tab.c"
    break;

  case 453: /* m_expr_list: %empty  */
#line 3412 "language.yacc"
             { (yyval.n)=0; }
#line 8769 "y.tab.c"
    break;

  case 456: /* m_expr_list2: m_expr_list2 ',' assoc_pair  */
#line 3418 "language.yacc"
  {
    if ((yyvsp[0].n)) {
      (yyval.n)=mknode(F_ARG_LIST,(yyvsp[-2].n),(yyvsp[0].n));
    } else {
      /* Error in assoc_pair */
      (yyval.n)=(yyvsp[-2].n);
    }
  }
#line 8782 "y.tab.c"
    break;

  case 458: /* assoc_pair: assignment_expr expected_colon assignment_expr  */
#line 3430 "language.yacc"
  {
    (yyval.n)=mknode(F_ARG_LIST,(yyvsp[-2].n),(yyvsp[0].n));
  }
#line 8790 "y.tab.c"
    break;

  case 459: /* assoc_pair: assignment_expr expected_colon error  */
#line 3433 "language.yacc"
                                         { free_node((yyvsp[-2].n)); (yyval.n)=0; }
#line 8796 "y.tab.c"
    break;

  case 462: /* literal_expr: "float literal"  */
#line 3438 "language.yacc"
              { (yyval.n)=mkfloatnode((FLOAT_TYPE)(yyvsp[0].fnum)); }
#line 8802 "y.tab.c"
    break;

  case 463: /* literal_expr: open_paren_with_line_info '{' expr_list close_brace_or_missing ')'  */
#line 3440 "language.yacc"
    {
      /* FIXME: May eat lots of stack; cf Standards.FIPS10_4.divisions */
      (yyval.n)=mkefuncallnode("aggregate",(yyvsp[-2].n));
      COPY_LINE_NUMBER_INFO((yyval.n), (yyvsp[-4].n));
      free_node ((yyvsp[-4].n));
    }
#line 8813 "y.tab.c"
    break;

  case 464: /* literal_expr: open_paren_with_line_info open_bracket_with_line_info m_expr_list close_bracket_or_missing ')'  */
#line 3449 "language.yacc"
    {
      /* FIXME: May eat lots of stack; cf Standards.FIPS10_4.divisions */
      (yyval.n)=mkefuncallnode("aggregate_mapping",(yyvsp[-2].n));
      COPY_LINE_NUMBER_INFO((yyval.n), (yyvsp[-4].n));
      free_node ((yyvsp[-4].n));
      free_node ((yyvsp[-3].n));
    }
#line 8825 "y.tab.c"
    break;

  case 465: /* literal_expr: "(<" line_number_info expr_list ">)"  */
#line 3457 "language.yacc"
    {
      /* FIXME: May eat lots of stack; cf Standards.FIPS10_4.divisions */
      (yyval.n)=mkefuncallnode("aggregate_multiset",(yyvsp[-1].n));
      COPY_LINE_NUMBER_INFO((yyval.n), (yyvsp[-2].n));
      free_node ((yyvsp[-2].n));
    }
#line 8836 "y.tab.c"
    break;

  case 466: /* literal_expr: "(<" line_number_info expr_list ')'  */
#line 3464 "language.yacc"
    {
      yyerror("Missing '>'.");
      (yyval.n)=mkefuncallnode("aggregate_multiset",(yyvsp[-1].n));
      COPY_LINE_NUMBER_INFO((yyval.n), (yyvsp[-2].n));
      free_node ((yyvsp[-2].n));
    }
#line 8847 "y.tab.c"
    break;

  case 467: /* literal_expr: "(<" line_number_info error ">)"  */
#line 3470 "language.yacc"
                                                               { (yyval.n)=(yyvsp[-2].n); yyerrok; }
#line 8853 "y.tab.c"
    break;

  case 468: /* literal_expr: "(<" line_number_info error ')'  */
#line 3471 "language.yacc"
                                                  {
    yyerror("Missing '>'.");
    (yyval.n)=(yyvsp[-2].n); yyerrok;
  }
#line 8862 "y.tab.c"
    break;

  case 469: /* literal_expr: "(<" line_number_info error "end of file"  */
#line 3476 "language.yacc"
  {
    (yyval.n)=(yyvsp[-2].n); yyerror("Missing '>)'.");
    yyerror("Unexpected end of file.");
  }
#line 8871 "y.tab.c"
    break;

  case 470: /* literal_expr: "(<" line_number_info error ';'  */
#line 3480 "language.yacc"
                                                  { (yyval.n)=(yyvsp[-2].n); yyerror("Missing '>)'."); }
#line 8877 "y.tab.c"
    break;

  case 471: /* literal_expr: "(<" line_number_info error '}'  */
#line 3481 "language.yacc"
                                                  { (yyval.n)=(yyvsp[-2].n); yyerror("Missing '>)'."); }
#line 8883 "y.tab.c"
    break;

  case 473: /* unqualified_id_expr: unqualified_id_expr '.' "identifier"  */
#line 3486 "language.yacc"
  {
    (yyval.n) = index_node((yyvsp[-2].n), (yyvsp[0].n)->u.sval.u.string);
    free_node((yyvsp[-2].n));
    if(Pike_compiler->last_identifier) free_string(Pike_compiler->last_identifier);
    copy_shared_string(Pike_compiler->last_identifier, (yyvsp[0].n)->u.sval.u.string);
    free_node((yyvsp[0].n));
  }
#line 8895 "y.tab.c"
    break;

  case 474: /* unqualified_id_expr: unqualified_id_expr '.' bad_identifier  */
#line 3493 "language.yacc"
                                           {}
#line 8901 "y.tab.c"
    break;

  case 475: /* qualified_ident: "predef" "::" "identifier"  */
#line 3498 "language.yacc"
  {
    struct compilation *c = THIS_COMPILATION;
    node *tmp2;

    if(Pike_compiler->last_identifier)
      free_string(Pike_compiler->last_identifier);
    copy_shared_string(Pike_compiler->last_identifier, (yyvsp[0].n)->u.sval.u.string);

    tmp2 = mkconstantsvaluenode(&c->default_module);
    set_node_name(tmp2, predef_scope_string);

    (yyval.n) = index_node(tmp2, (yyvsp[0].n)->u.sval.u.string);
    if(!(yyval.n)->name)
      add_ref( (yyval.n)->name=(yyvsp[0].n)->u.sval.u.string );
    free_node(tmp2);
    free_node((yyvsp[0].n));
  }
#line 8923 "y.tab.c"
    break;

  case 476: /* qualified_ident: "predef" "::" bad_identifier  */
#line 3516 "language.yacc"
  {
    (yyval.n)=0;
  }
#line 8931 "y.tab.c"
    break;

  case 477: /* qualified_ident: "version prefix" "::" "identifier"  */
#line 3520 "language.yacc"
  {
    (yyval.n) = find_versioned_identifier((yyvsp[0].n)->u.sval.u.string,
                                   (yyvsp[-2].n)->u.integer.a, (yyvsp[-2].n)->u.integer.b);
    free_node((yyvsp[-2].n));
    free_node((yyvsp[0].n));
  }
#line 8942 "y.tab.c"
    break;

  case 478: /* qualified_ident: "version prefix" "::" bad_identifier  */
#line 3527 "language.yacc"
  {
    free_node((yyvsp[-2].n));
    (yyval.n)=0;
  }
#line 8951 "y.tab.c"
    break;

  case 479: /* qualified_ident: "continue" "::" "identifier"  */
#line 3532 "language.yacc"
  {
    if ((yyvsp[0].n)->u.sval.u.string != this_function_string) {
      yyerror("Invalid use of continue::-scope.");
      (yyval.n) = 0;
    } else {
      (yyval.n) = program_magic_identifier(Pike_compiler, 0, INHERIT_GENERATOR,
                                    this_function_string, 1);
    }
    free_node((yyvsp[0].n));
  }
#line 8966 "y.tab.c"
    break;

  case 480: /* qualified_ident: inherit_specifier "identifier"  */
#line 3543 "language.yacc"
  {
    if(Pike_compiler->last_identifier) free_string(Pike_compiler->last_identifier);
    copy_shared_string(Pike_compiler->last_identifier, (yyvsp[0].n)->u.sval.u.string);

    (yyval.n) = find_inherited_identifier(inherit_state, inherit_depth, (yyvsp[-1].number),
                                   Pike_compiler->last_identifier);
    if (!(yyval.n)) {
      if ((Pike_compiler->flags & COMPILATION_FORCE_RESOLVE) ||
          (Pike_compiler->compiler_pass == COMPILER_PASS_LAST)) {
        if (((yyvsp[-1].number) >= 0) && inherit_state->new_program &&
            inherit_state->new_program->inherits[(yyvsp[-1].number)].name) {
          my_yyerror("Undefined identifier %pS::%pS.",
                     inherit_state->new_program->inherits[(yyvsp[-1].number)].name,
                     Pike_compiler->last_identifier);
        } else {
          my_yyerror("Undefined identifier %pS.",
                     Pike_compiler->last_identifier);
        }
        (yyval.n)=0;
      }
      else
        (yyval.n)=mknode(F_UNDEFINED,0,0);
    }

    free_node((yyvsp[0].n));
  }
#line 8997 "y.tab.c"
    break;

  case 481: /* qualified_ident: inherit_specifier bad_identifier  */
#line 3569 "language.yacc"
                                     { (yyval.n)=0; }
#line 9003 "y.tab.c"
    break;

  case 482: /* qualified_ident: inherit_specifier error  */
#line 3570 "language.yacc"
                            { (yyval.n)=0; }
#line 9009 "y.tab.c"
    break;

  case 483: /* qualified_ident: "::" "identifier"  */
#line 3572 "language.yacc"
  {
    if(Pike_compiler->last_identifier) {
      free_string(Pike_compiler->last_identifier);
    }
    copy_shared_string(Pike_compiler->last_identifier, (yyvsp[0].n)->u.sval.u.string);

    (yyval.n) = find_inherited_identifier(Pike_compiler, 0, INHERIT_ALL,
                                   Pike_compiler->last_identifier);
    if(!(yyval.n))
    {
      if (Pike_compiler->compiler_pass == COMPILER_PASS_LAST) {
        my_yyerror("Undefined identifier ::%pS.", (yyvsp[0].n)->u.sval.u.string);
      }
      (yyval.n)=mkintnode(0);
    }
    free_node((yyvsp[0].n));
  }
#line 9031 "y.tab.c"
    break;

  case 484: /* qualified_ident: "::" bad_identifier  */
#line 3590 "language.yacc"
  {
    (yyval.n)=0;
  }
#line 9039 "y.tab.c"
    break;

  case 486: /* qualified_id_expr: qualified_id_expr '.' "identifier"  */
#line 3597 "language.yacc"
  {
    (yyval.n) = index_node((yyvsp[-2].n), (yyvsp[0].n)->u.sval.u.string);
    free_node((yyvsp[-2].n));
    if(Pike_compiler->last_identifier) free_string(Pike_compiler->last_identifier);
    copy_shared_string(Pike_compiler->last_identifier, (yyvsp[0].n)->u.sval.u.string);
    free_node((yyvsp[0].n));
  }
#line 9051 "y.tab.c"
    break;

  case 487: /* qualified_id_expr: qualified_id_expr '.' bad_identifier  */
#line 3604 "language.yacc"
                                         {}
#line 9057 "y.tab.c"
    break;

  case 488: /* id_expr: unqualified_id_expr opt_generic_bindings  */
#line 3608 "language.yacc"
  {
    if ((yyvsp[0].n)) {
      (yyval.n) = mknode(F_BIND_GENERICS, (yyvsp[-1].n), (yyvsp[0].n));
    } else {
      (yyval.n) = (yyvsp[-1].n);
    }
  }
#line 9069 "y.tab.c"
    break;

  case 489: /* id_expr: qualified_id_expr opt_generic_bindings  */
#line 3616 "language.yacc"
  {
    if ((yyvsp[0].n)) {
      (yyval.n) = mknode(F_BIND_GENERICS, (yyvsp[-1].n), (yyvsp[0].n));
    } else {
      (yyval.n) = (yyvsp[-1].n);
    }
  }
#line 9081 "y.tab.c"
    break;

  case 490: /* safe_chain_var: %empty  */
#line 3627 "language.yacc"
  {
    node *n = (yyvsp[0].n);
    if (!n) {
      /* Prior syntax error. */
      (yyval.n) = NULL;
    } else if ((n->token == F_LOCAL) ||
               (n->token == F_LOCAL_INDIRECT) ||
               (n->token == F_EXTERNAL)) {
      /* Reuse the variable.
       *
       * NB: F_EXTERNAL is safe since we know that it is not a getter/setter.
       */
      (yyval.n) = copy_node(n);
    } else {
      struct pike_type *t;
      int temp;

      fix_type_field(n);
      t = n->type;
      if (!t) t = mixed_type_string;

      add_ref(t);
      temp = add_local_name(empty_pike_string, t, 0);
      Pike_compiler->compiler_frame->local_names[temp].flags |=
        LOCAL_VAR_IS_USED;
      (yyval.n) = mklocalnode(temp, 0);
      (yyvsp[0].n) = n = mknode(F_ASSIGN, copy_node((yyval.n)), n);
    }
  }
#line 9115 "y.tab.c"
    break;

  case 491: /* safe_chain_expr: "[?" line_number_info assignment_expr ']'  */
#line 3663 "language.yacc"
  {
    /* A[?X] */
    (yyval.n) = mknode(F_INDEX, copy_node((yyvsp[-4].n)), (yyvsp[-1].n));
    COPY_LINE_NUMBER_INFO((yyval.n), (yyvsp[-2].n));
    free_node ((yyvsp[-2].n));
  }
#line 9126 "y.tab.c"
    break;

  case 492: /* safe_chain_expr: "[?" line_number_info range_bound expected_dot_dot range_bound ']'  */
#line 3671 "language.yacc"
  {
    /* A[?X..Y] */
    node *range = mknode(':', (yyvsp[-3].n), (yyvsp[-1].n));
    (yyval.n) = mknode(F_RANGE, copy_node((yyvsp[-6].n)), range);
    COPY_LINE_NUMBER_INFO((yyval.n), (yyvsp[-4].n));
    free_node((yyvsp[-4].n));
  }
#line 9138 "y.tab.c"
    break;

  case 493: /* safe_chain_expr: "->?" line_number_info magic_identifier  */
#line 3679 "language.yacc"
  {
    /* A->?B */
    (yyval.n) = mknode(F_ARROW, copy_node((yyvsp[-3].n)), (yyvsp[0].n));
    COPY_LINE_NUMBER_INFO((yyval.n), (yyvsp[-1].n));
    free_node((yyvsp[-1].n));
  }
#line 9149 "y.tab.c"
    break;

  case 494: /* safe_chain_expr: safe_apply_with_line_info expr_list ')' optional_block  */
#line 3686 "language.yacc"
  {
    /* A(?B...) */
    (yyval.n) = mkapplynode(copy_node((yyvsp[-4].n)), mknode(F_ARG_LIST, (yyvsp[-2].n), (yyvsp[0].n)));
    COPY_LINE_NUMBER_INFO((yyval.n), (yyvsp[-3].n));
    free_node((yyvsp[-3].n));
  }
#line 9160 "y.tab.c"
    break;

  case 495: /* safe_chain_expr: safe_chain_expr open_bracket_with_line_info assignment_expr ']'  */
#line 3693 "language.yacc"
  {
    /* safe_chain_expr[X] */
    (yyval.n) = mknode(F_INDEX, (yyvsp[-3].n), (yyvsp[-1].n));
    COPY_LINE_NUMBER_INFO((yyval.n), (yyvsp[-2].n));
    free_node ((yyvsp[-2].n));
  }
#line 9171 "y.tab.c"
    break;

  case 496: /* safe_chain_expr: safe_chain_expr open_bracket_with_line_info range_bound expected_dot_dot range_bound ']'  */
#line 3701 "language.yacc"
  {
    /* safe_chain_expr[X..Y] */
    node *range = mknode(':', (yyvsp[-3].n), (yyvsp[-1].n));
    (yyval.n) = mknode(F_RANGE, (yyvsp[-5].n), range);
    COPY_LINE_NUMBER_INFO((yyval.n), (yyvsp[-4].n));
    free_node((yyvsp[-4].n));
  }
#line 9183 "y.tab.c"
    break;

  case 497: /* safe_chain_expr: safe_chain_expr "->" line_number_info magic_identifier  */
#line 3709 "language.yacc"
  {
    /* safe_chain_expr->?B */
    (yyval.n) = mknode(F_ARROW, (yyvsp[-3].n), (yyvsp[0].n));
    COPY_LINE_NUMBER_INFO((yyval.n), (yyvsp[-1].n));
    free_node((yyvsp[-1].n));
  }
#line 9194 "y.tab.c"
    break;

  case 498: /* safe_chain_expr: safe_chain_expr open_paren_with_line_info expr_list ')' optional_block  */
#line 3716 "language.yacc"
  {
    /* safe_chain_expr(B...) */
    (yyval.n) = mkapplynode((yyvsp[-4].n), mknode(F_ARG_LIST, (yyvsp[-2].n), (yyvsp[0].n)));
    COPY_LINE_NUMBER_INFO((yyval.n), (yyvsp[-3].n));
    free_node((yyvsp[-3].n));
  }
#line 9205 "y.tab.c"
    break;

  case 504: /* primary_expr: static_assertion  */
#line 3729 "language.yacc"
                     { (yyval.n) = mknewintnode(0); }
#line 9211 "y.tab.c"
    break;

  case 506: /* primary_expr: implicit_modifiers anon_class  */
#line 3731 "language.yacc"
                                  { (yyval.n) = (yyvsp[0].n); }
#line 9217 "y.tab.c"
    break;

  case 507: /* primary_expr: implicit_modifiers enum  */
#line 3732 "language.yacc"
                            { (yyval.n) = (yyvsp[0].n); }
#line 9223 "y.tab.c"
    break;

  case 509: /* primary_expr: primary_expr '.' line_number_info "identifier"  */
#line 3735 "language.yacc"
  {
    (yyval.n) = index_node((yyvsp[-3].n), (yyvsp[0].n)->u.sval.u.string);
    COPY_LINE_NUMBER_INFO((yyval.n), (yyvsp[-1].n));
    free_node ((yyvsp[-3].n));
    free_node ((yyvsp[-1].n));
    free_node ((yyvsp[0].n));
  }
#line 9235 "y.tab.c"
    break;

  case 510: /* primary_expr: postfix_expr open_bracket_with_line_info '*' ']'  */
#line 3743 "language.yacc"
  {
    (yyval.n)=mknode(F_AUTO_MAP_MARKER, (yyvsp[-3].n), 0);
    COPY_LINE_NUMBER_INFO((yyval.n), (yyvsp[-2].n));
    free_node ((yyvsp[-2].n));
  }
#line 9245 "y.tab.c"
    break;

  case 511: /* primary_expr: postfix_expr open_bracket_with_line_info assignment_expr ']'  */
#line 3749 "language.yacc"
  {
    (yyval.n)=mknode(F_INDEX,(yyvsp[-3].n),(yyvsp[-1].n));
    COPY_LINE_NUMBER_INFO((yyval.n), (yyvsp[-2].n));
    free_node ((yyvsp[-2].n));
  }
#line 9255 "y.tab.c"
    break;

  case 512: /* primary_expr: postfix_expr open_bracket_with_line_info range_bound expected_dot_dot range_bound ']'  */
#line 3756 "language.yacc"
  {
    (yyval.n)=mknode(F_RANGE,(yyvsp[-5].n),mknode(':',(yyvsp[-3].n),(yyvsp[-1].n)));
    COPY_LINE_NUMBER_INFO((yyval.n), (yyvsp[-4].n));
    free_node ((yyvsp[-4].n));
  }
#line 9265 "y.tab.c"
    break;

  case 513: /* primary_expr: postfix_expr open_bracket_with_line_info error ']'  */
#line 3762 "language.yacc"
  {
    (yyval.n)=(yyvsp[-3].n);
    free_node ((yyvsp[-2].n));
    yyerrok;
  }
#line 9275 "y.tab.c"
    break;

  case 514: /* primary_expr: postfix_expr open_bracket_with_line_info error "end of file"  */
#line 3768 "language.yacc"
  {
    (yyval.n)=(yyvsp[-3].n); yyerror("Missing ']'.");
    yyerror("Unexpected end of file.");
    free_node ((yyvsp[-2].n));
  }
#line 9285 "y.tab.c"
    break;

  case 515: /* primary_expr: postfix_expr open_bracket_with_line_info error ';'  */
#line 3774 "language.yacc"
    {(yyval.n)=(yyvsp[-3].n); yyerror("Missing ']'."); free_node ((yyvsp[-2].n));}
#line 9291 "y.tab.c"
    break;

  case 516: /* primary_expr: postfix_expr open_bracket_with_line_info error '}'  */
#line 3776 "language.yacc"
    {(yyval.n)=(yyvsp[-3].n); yyerror("Missing ']'."); free_node ((yyvsp[-2].n));}
#line 9297 "y.tab.c"
    break;

  case 517: /* primary_expr: postfix_expr open_bracket_with_line_info error ')'  */
#line 3778 "language.yacc"
    {(yyval.n)=(yyvsp[-3].n); yyerror("Missing ']'."); free_node ((yyvsp[-2].n));}
#line 9303 "y.tab.c"
    break;

  case 518: /* primary_expr: open_paren_with_line_info comma_expr ')'  */
#line 3780 "language.yacc"
    {
      (yyval.n)=(yyvsp[-1].n);
      if ((yyval.n)) {
        COPY_LINE_NUMBER_INFO((yyval.n), (yyvsp[-2].n));
      }
      free_node ((yyvsp[-2].n));
    }
#line 9315 "y.tab.c"
    break;

  case 519: /* primary_expr: open_paren_with_line_info error ')'  */
#line 3787 "language.yacc"
                                        { (yyval.n)=(yyvsp[-2].n); yyerrok; }
#line 9321 "y.tab.c"
    break;

  case 520: /* primary_expr: open_paren_with_line_info error "end of file"  */
#line 3789 "language.yacc"
  {
    (yyval.n)=(yyvsp[-2].n); yyerror("Missing ')'.");
    yyerror("Unexpected end of file.");
  }
#line 9330 "y.tab.c"
    break;

  case 521: /* primary_expr: open_paren_with_line_info error ';'  */
#line 3793 "language.yacc"
                                        { (yyval.n)=(yyvsp[-2].n); yyerror("Missing ')'."); }
#line 9336 "y.tab.c"
    break;

  case 522: /* primary_expr: open_paren_with_line_info error '}'  */
#line 3794 "language.yacc"
                                        { (yyval.n)=(yyvsp[-2].n); yyerror("Missing ')'."); }
#line 9342 "y.tab.c"
    break;

  case 523: /* primary_expr: postfix_expr "->" line_number_info magic_identifier  */
#line 3796 "language.yacc"
  {
    (yyval.n)=mknode(F_ARROW,(yyvsp[-3].n),(yyvsp[0].n));
    COPY_LINE_NUMBER_INFO((yyval.n), (yyvsp[-1].n));
    free_node ((yyvsp[-1].n));
  }
#line 9352 "y.tab.c"
    break;

  case 524: /* primary_expr: postfix_expr "->" line_number_info error  */
#line 3801 "language.yacc"
                                                  {(yyval.n)=(yyvsp[-3].n); free_node ((yyvsp[-1].n));}
#line 9358 "y.tab.c"
    break;

  case 526: /* postfix_expr: primary_expr opt_generic_bindings  */
#line 3806 "language.yacc"
  {
    if ((yyvsp[0].n)) {
      if ((yyvsp[-1].n) && ((yyvsp[-1].n)->token == F_BIND_GENERICS)) {
        yyerror("Multiple bindings specified.");
      }
      (yyval.n) = mknode(F_BIND_GENERICS, (yyvsp[-1].n), (yyvsp[0].n));
    } else {
      (yyval.n) = (yyvsp[-1].n);
    }
  }
#line 9373 "y.tab.c"
    break;

  case 527: /* postfix_expr: bad_expr_ident  */
#line 3817 "language.yacc"
  {
    (yyval.n) = mknewintnode(0);
  }
#line 9381 "y.tab.c"
    break;

  case 528: /* postfix_expr: postfix_expr "++"  */
#line 3820 "language.yacc"
                         { (yyval.n) = mknode(F_POST_INC, (yyvsp[-1].n), mkintnode(1)); }
#line 9387 "y.tab.c"
    break;

  case 529: /* postfix_expr: postfix_expr "--"  */
#line 3821 "language.yacc"
                         { (yyval.n) = mknode(F_POST_DEC, (yyvsp[-1].n), mkintnode(1)); }
#line 9393 "y.tab.c"
    break;

  case 531: /* chain_expr: chain_expr safe_chain_var safe_chain_expr  */
#line 3826 "language.yacc"
  {
    /* expr SAFE_OP chain ==> ((TMPVAR = expr) && (TMPVAR chain)) */
    if ((yyvsp[-1].n)) {
      (yyval.n) = mknode(F_LAND, (yyvsp[-2].n), (yyvsp[0].n));
      if ((yyvsp[-1].n) != (yyvsp[-2].n)) {
        /* safe_chain_var allocated a local variable. */
        (yyval.n) = pop_local_variables((yyvsp[-1].n)->u.integer.a, (yyval.n));
      }
      free_node((yyvsp[-1].n));
    } else {
      (yyval.n) = (yyvsp[-2].n);
      free_node((yyvsp[0].n));
    }
  }
#line 9412 "y.tab.c"
    break;

  case 533: /* prefix_expr: "++" chain_expr  */
#line 3843 "language.yacc"
                       { (yyval.n) = mknode(F_INC, (yyvsp[0].n), mkintnode(1)); }
#line 9418 "y.tab.c"
    break;

  case 534: /* prefix_expr: "--" chain_expr  */
#line 3844 "language.yacc"
                       { (yyval.n) = mknode(F_DEC, (yyvsp[0].n), mkintnode(1)); }
#line 9424 "y.tab.c"
    break;

  case 536: /* pow_expr: prefix_expr "**" pow_expr  */
#line 3848 "language.yacc"
                                 { (yyval.n)=mkopernode("`**",(yyvsp[-2].n),(yyvsp[0].n)); }
#line 9430 "y.tab.c"
    break;

  case 539: /* unary_expr: "!" cast_expr  */
#line 3853 "language.yacc"
                      { (yyval.n) = mkopernode("`!", (yyvsp[0].n), 0); }
#line 9436 "y.tab.c"
    break;

  case 540: /* unary_expr: '+' cast_expr  */
#line 3854 "language.yacc"
                  { (yyval.n) = (yyvsp[0].n); }
#line 9442 "y.tab.c"
    break;

  case 541: /* unary_expr: '~' cast_expr  */
#line 3856 "language.yacc"
  {
    if ((yyvsp[0].n) && ((yyvsp[0].n)->token == F_CONSTANT) && (TYPEOF((yyvsp[0].n)->u.sval) == T_INT)) {
      (yyval.n) = mkintnode(~((yyvsp[0].n)->u.sval.u.integer));
      free_node((yyvsp[0].n));
    } else {
      (yyval.n) = mkopernode("`~", (yyvsp[0].n), 0);
    }
  }
#line 9455 "y.tab.c"
    break;

  case 542: /* unary_expr: '-' cast_expr  */
#line 3865 "language.yacc"
  {
    if ((yyvsp[0].n) && ((yyvsp[0].n)->token == F_CONSTANT) && (TYPEOF((yyvsp[0].n)->u.sval) == T_INT) &&
        !INT_TYPE_NEG_OVERFLOW((yyvsp[0].n)->u.sval.u.integer)) {
      (yyval.n) = mkintnode(-((yyvsp[0].n)->u.sval.u.integer));
      free_node((yyvsp[0].n));
    } else {
      (yyval.n)=mkopernode("`-", (yyvsp[0].n), 0);
    }
  }
#line 9469 "y.tab.c"
    break;

  case 544: /* cast_expr: cast cast_expr  */
#line 3878 "language.yacc"
  {
    (yyval.n) = mkcastnode((yyvsp[-1].n)->u.sval.u.type, (yyvsp[0].n));
    free_node((yyvsp[-1].n));
  }
#line 9478 "y.tab.c"
    break;

  case 545: /* cast_expr: soft_cast cast_expr  */
#line 3883 "language.yacc"
  {
    (yyval.n) = mksoftcastnode((yyvsp[-1].n)->u.sval.u.type, (yyvsp[0].n));
    free_node((yyvsp[-1].n));
  }
#line 9487 "y.tab.c"
    break;

  case 547: /* mul_expr: mul_expr '*' cast_expr  */
#line 3890 "language.yacc"
                           { (yyval.n)=mkopernode("`*",(yyvsp[-2].n),(yyvsp[0].n)); }
#line 9493 "y.tab.c"
    break;

  case 548: /* mul_expr: mul_expr '%' cast_expr  */
#line 3891 "language.yacc"
                           { (yyval.n)=mkopernode("`%",(yyvsp[-2].n),(yyvsp[0].n)); }
#line 9499 "y.tab.c"
    break;

  case 549: /* mul_expr: mul_expr '/' cast_expr  */
#line 3892 "language.yacc"
                           { (yyval.n)=mkopernode("`/",(yyvsp[-2].n),(yyvsp[0].n)); }
#line 9505 "y.tab.c"
    break;

  case 554: /* add_expr: add_expr '+' mul_expr  */
#line 3899 "language.yacc"
                          { (yyval.n) = mkopernode("`+", (yyvsp[-2].n), (yyvsp[0].n)); }
#line 9511 "y.tab.c"
    break;

  case 555: /* add_expr: add_expr '-' mul_expr  */
#line 3900 "language.yacc"
                          { (yyval.n) = mkopernode("`-", (yyvsp[-2].n), (yyvsp[0].n)); }
#line 9517 "y.tab.c"
    break;

  case 559: /* shift_expr: shift_expr "<<" add_expr  */
#line 3906 "language.yacc"
                                { (yyval.n) = mkopernode("`<<", (yyvsp[-2].n), (yyvsp[0].n)); }
#line 9523 "y.tab.c"
    break;

  case 560: /* shift_expr: shift_expr ">>" add_expr  */
#line 3907 "language.yacc"
                                { (yyval.n) = mkopernode("`>>", (yyvsp[-2].n), (yyvsp[0].n)); }
#line 9529 "y.tab.c"
    break;

  case 564: /* rel_expr: rel_expr '>' shift_expr  */
#line 3913 "language.yacc"
                               { (yyval.n) = mkopernode("`>", (yyvsp[-2].n), (yyvsp[0].n)); }
#line 9535 "y.tab.c"
    break;

  case 565: /* rel_expr: rel_expr ">=" shift_expr  */
#line 3914 "language.yacc"
                               { (yyval.n) = mkopernode("`>=", (yyvsp[-2].n), (yyvsp[0].n)); }
#line 9541 "y.tab.c"
    break;

  case 566: /* rel_expr: rel_expr '<' shift_expr  */
#line 3915 "language.yacc"
                               { (yyval.n) = mkopernode("`<", (yyvsp[-2].n), (yyvsp[0].n)); }
#line 9547 "y.tab.c"
    break;

  case 567: /* rel_expr: rel_expr "<=" shift_expr  */
#line 3916 "language.yacc"
                               { (yyval.n) = mkopernode("`<=", (yyvsp[-2].n), (yyvsp[0].n)); }
#line 9553 "y.tab.c"
    break;

  case 573: /* eq_expr: eq_expr "==" rel_expr  */
#line 3924 "language.yacc"
                            { (yyval.n) = mkopernode("`==", (yyvsp[-2].n), (yyvsp[0].n)); }
#line 9559 "y.tab.c"
    break;

  case 574: /* eq_expr: eq_expr "!=" rel_expr  */
#line 3925 "language.yacc"
                            { (yyval.n) = mkopernode("`!=", (yyvsp[-2].n), (yyvsp[0].n)); }
#line 9565 "y.tab.c"
    break;

  case 578: /* and_expr: and_expr '&' eq_expr  */
#line 3931 "language.yacc"
                         { (yyval.n) = mkopernode("`&",(yyvsp[-2].n),(yyvsp[0].n)); }
#line 9571 "y.tab.c"
    break;

  case 581: /* xor_expr: xor_expr '^' and_expr  */
#line 3936 "language.yacc"
                          { (yyval.n) = mkopernode("`^", (yyvsp[-2].n), (yyvsp[0].n)); }
#line 9577 "y.tab.c"
    break;

  case 584: /* or_expr: or_expr '|' xor_expr  */
#line 3941 "language.yacc"
                         { (yyval.n) = mkopernode("`|", (yyvsp[-2].n), (yyvsp[0].n)); }
#line 9583 "y.tab.c"
    break;

  case 587: /* land_expr: land_expr "&&" or_expr  */
#line 3946 "language.yacc"
                               { (yyval.n) = mknode(F_LAND, (yyvsp[-2].n), (yyvsp[0].n)); }
#line 9589 "y.tab.c"
    break;

  case 590: /* lor_expr: lor_expr "||" land_expr  */
#line 3951 "language.yacc"
                               { (yyval.n) = mknode(F_LOR,(yyvsp[-2].n),(yyvsp[0].n)); }
#line 9595 "y.tab.c"
    break;

  case 593: /* cond_expr: lor_expr '?' comma_expr ':' assignment_expr  */
#line 3957 "language.yacc"
  {
    (yyval.n) = mknode('?', (yyvsp[-4].n), mknode(':', (yyvsp[-2].n), (yyvsp[0].n)));
  }
#line 9603 "y.tab.c"
    break;

  case 595: /* assignment_expr: lor_expr assign assignment_expr  */
#line 3963 "language.yacc"
                                     { (yyval.n)=mknode((yyvsp[-1].number),(yyvsp[-2].n),(yyvsp[0].n)); }
#line 9609 "y.tab.c"
    break;

  case 596: /* assignment_expr: lor_expr assign error  */
#line 3964 "language.yacc"
                          { (yyval.n)=(yyvsp[-2].n); reset_type_stack(); yyerrok; }
#line 9615 "y.tab.c"
    break;

  case 597: /* assignment_expr: open_bracket_with_line_info low_lvalue_list ']' low_assign assignment_expr  */
#line 3966 "language.yacc"
  {
    if (!(THIS_COMPILATION->lex.pragmas & ID_STRICT_TYPES)) {
      mark_lvalues_as_used((yyvsp[-3].n));
    }
    (yyval.n)=mknode((yyvsp[-1].number),mknode(F_ARRAY_LVALUE,(yyvsp[-3].n),0),(yyvsp[0].n));
    COPY_LINE_NUMBER_INFO((yyval.n), (yyvsp[-4].n));
    free_node ((yyvsp[-4].n));
  }
#line 9628 "y.tab.c"
    break;

  case 598: /* assignment_expr: open_bracket_with_line_info low_lvalue_list ']' error  */
#line 3975 "language.yacc"
    {
      (yyval.n)=(yyvsp[-2].n); free_node ((yyvsp[-3].n)); reset_type_stack(); yyerrok;
    }
#line 9636 "y.tab.c"
    break;

  case 599: /* low_assign: '='  */
#line 3981 "language.yacc"
                { (yyval.number)=F_ASSIGN; }
#line 9642 "y.tab.c"
    break;

  case 601: /* assign: "&="  */
#line 3984 "language.yacc"
               { (yyval.number)=F_AND_EQ; }
#line 9648 "y.tab.c"
    break;

  case 602: /* assign: "|="  */
#line 3985 "language.yacc"
               { (yyval.number)=F_OR_EQ; }
#line 9654 "y.tab.c"
    break;

  case 603: /* assign: "^="  */
#line 3986 "language.yacc"
               { (yyval.number)=F_XOR_EQ; }
#line 9660 "y.tab.c"
    break;

  case 604: /* assign: "<<="  */
#line 3987 "language.yacc"
               { (yyval.number)=F_LSH_EQ; }
#line 9666 "y.tab.c"
    break;

  case 605: /* assign: ">>="  */
#line 3988 "language.yacc"
               { (yyval.number)=F_RSH_EQ; }
#line 9672 "y.tab.c"
    break;

  case 606: /* assign: "+="  */
#line 3989 "language.yacc"
               { (yyval.number)=F_ADD_EQ; }
#line 9678 "y.tab.c"
    break;

  case 607: /* assign: "-="  */
#line 3990 "language.yacc"
               { (yyval.number)=F_SUB_EQ; }
#line 9684 "y.tab.c"
    break;

  case 608: /* assign: "*="  */
#line 3991 "language.yacc"
               { (yyval.number)=F_MULT_EQ; }
#line 9690 "y.tab.c"
    break;

  case 609: /* assign: "**="  */
#line 3992 "language.yacc"
               { (yyval.number)=F_POW_EQ; }
#line 9696 "y.tab.c"
    break;

  case 610: /* assign: "%="  */
#line 3993 "language.yacc"
               { (yyval.number)=F_MOD_EQ; }
#line 9702 "y.tab.c"
    break;

  case 611: /* assign: "/="  */
#line 3994 "language.yacc"
               { (yyval.number)=F_DIV_EQ; }
#line 9708 "y.tab.c"
    break;

  case 612: /* assign: "?="  */
#line 3995 "language.yacc"
                       { (yyval.number)=F_ATOMIC_GET_SET; }
#line 9714 "y.tab.c"
    break;

  case 614: /* comma_expr: comma_expr ',' assignment_expr  */
#line 4000 "language.yacc"
  {
    (yyval.n) = mknode(F_COMMA_EXPR, mkcastnode(void_type_string, (yyvsp[-2].n)), (yyvsp[0].n));
  }
#line 9722 "y.tab.c"
    break;

  case 616: /* init_expr: simple_type2 local_name_list  */
#line 4006 "language.yacc"
                                 { (yyval.n)=(yyvsp[0].n); }
#line 9728 "y.tab.c"
    break;

  case 618: /* safe_init_expr: error  */
#line 4010 "language.yacc"
          { (yyval.n)=0; }
#line 9734 "y.tab.c"
    break;

  case 619: /* optional_init_expr: %empty  */
#line 4013 "language.yacc"
                                { (yyval.n)=0; }
#line 9740 "y.tab.c"
    break;

  case 621: /* void_expr: init_expr  */
#line 4017 "language.yacc"
                     { (yyval.n) = mkcastnode(void_type_string, (yyvsp[0].n)); }
#line 9746 "y.tab.c"
    break;

  case 622: /* optional_void_expr: %empty  */
#line 4019 "language.yacc"
                                { (yyval.n)=0; }
#line 9752 "y.tab.c"
    break;

  case 624: /* optional_void_expr: error  */
#line 4021 "language.yacc"
          { (yyval.n)=0; }
#line 9758 "y.tab.c"
    break;

  case 625: /* optional_block: %empty  */
#line 4043 "language.yacc"
                            { (yyval.n)=0; }
#line 9764 "y.tab.c"
    break;

  case 626: /* @41: %empty  */
#line 4047 "language.yacc"
  {
    /* block code */
    (yyvsp[-2].number)=Pike_compiler->num_used_modules;
    (yyval.number)=Pike_compiler->compiler_frame->current_number_of_locals;

    /* Declare the argument variable.
     *
     * NB: The code in the next block knows that this variable
     *     will be variable  #0.
     */
    push_type(T_MIXED);
    push_unlimited_array_type(T_ARRAY);
    add_local_name(args_string, compiler_pop_type(), 0);
    bind_local(NULL, 0);
  }
#line 9784 "y.tab.c"
    break;

  case 627: /* optional_block: '{' line_number_info start_lambda @41 statements end_block  */
#line 4063 "language.yacc"
  {
    struct pike_type *type;
    int f/*, e */;
    struct pike_string *name;
    struct compilation *c = THIS_COMPILATION;
    struct pike_string *save_file = c->lex.current_file;
    int save_line = c->lex.current_line;

    /* Don't warn about the argument if unused. */
    Pike_compiler->compiler_frame->local_names[0].flags |= LOCAL_VAR_IS_USED;

    c->lex.current_file = (yyvsp[-4].n)->current_file;
    c->lex.current_line = (yyvsp[-4].n)->line_number;

    /* block code */
    unuse_modules(Pike_compiler->num_used_modules - (yyvsp[-5].number));
    (yyvsp[-1].n) = pop_local_variables((yyvsp[-2].number), (yyvsp[-1].n));

    debug_malloc_touch((yyvsp[-1].n));
    (yyvsp[-1].n)=mknode(F_COMMA_EXPR,(yyvsp[-1].n),mknode(F_RETURN,mkintnode(0),0));

    if (Pike_compiler->compiler_pass != COMPILER_PASS_FIRST) {
      /* Doing this in pass 1 might induce too strict checks on types
       * in cases where we got placeholders. */
      type=find_return_type((yyvsp[-1].n));
      if (type) {
	push_finished_type(type);
	free_type(type);
      } else {
	yywarning("Failed to determine return type for implicit lambda.");
	push_type(T_ZERO);
      }
    } else {
      /* Tentative return type. */
      push_type(T_MIXED);
    }

    /* Any extra args are available in __ARGS__, but allow
     * the user to ignore them implicitly if not used.
     */
    push_type(T_MIXED);
    push_type(T_MANY);

    type=compiler_pop_type();

    name = get_new_name(NULL);

#ifdef LAMBDA_DEBUG
    fprintf(stderr, "%d: IMPLICIT LAMBDA: %s 0x%08lx 0x%08lx\n",
	    Pike_compiler->compiler_pass, name->str,
	    (long)Pike_compiler->new_program->id,
	    Pike_compiler->local_class_counter-1);
#endif /* LAMBDA_DEBUG */

    f=dooptcode(name,
		(yyvsp[-1].n),
		type,
		ID_PROTECTED | ID_PRIVATE | ID_INLINE | ID_USED);

    if(Pike_compiler->compiler_frame->lexical_scope & SCOPE_SCOPED) {
      (yyval.n) = mktrampolinenode(f,Pike_compiler->compiler_frame->previous);
    } else {
      (yyval.n) = mkidentifiernode(f);
    }

    c->lex.current_line = save_line;
    c->lex.current_file = save_file;
    free_node ((yyvsp[-4].n));
    free_string(name);
    free_type(type);
#ifdef PIKE_DEBUG
    if (Pike_compiler->compiler_frame != (yyvsp[-3].ptr)) {
      Pike_fatal("Lost track of compiler_frame!\n"
		 "  Got: %p (Expected: %p) Previous: %p\n",
		 Pike_compiler->compiler_frame, (yyvsp[-3].ptr),
		 Pike_compiler->compiler_frame->previous);
    }
#endif
    pop_compiler_frame();
  }
#line 9869 "y.tab.c"
    break;

  case 628: /* apply: postfix_expr open_paren_with_line_info expr_list ')' optional_block  */
#line 4147 "language.yacc"
  {
    (yyval.n) = mkapplynode((yyvsp[-4].n), mknode(F_ARG_LIST, (yyvsp[-2].n), (yyvsp[0].n)));
    COPY_LINE_NUMBER_INFO((yyval.n), (yyvsp[-3].n));
    free_node ((yyvsp[-3].n));
  }
#line 9879 "y.tab.c"
    break;

  case 629: /* apply: postfix_expr open_paren_or_safe_apply_with_line_info error ')' optional_block  */
#line 4153 "language.yacc"
  {
    (yyval.n)=mkapplynode((yyvsp[-4].n), (yyvsp[0].n));
    free_node ((yyvsp[-3].n));
    yyerrok;
  }
#line 9889 "y.tab.c"
    break;

  case 630: /* apply: postfix_expr open_paren_or_safe_apply_with_line_info error "end of file"  */
#line 4159 "language.yacc"
  {
    yyerror("Missing ')'.");
    yyerror("Unexpected end of file.");
    (yyval.n)=mkapplynode((yyvsp[-3].n), NULL);
    free_node ((yyvsp[-2].n));
  }
#line 9900 "y.tab.c"
    break;

  case 631: /* apply: postfix_expr open_paren_or_safe_apply_with_line_info error ';'  */
#line 4166 "language.yacc"
  {
    yyerror("Missing ')'.");
    (yyval.n)=mkapplynode((yyvsp[-3].n), NULL);
    free_node ((yyvsp[-2].n));
  }
#line 9910 "y.tab.c"
    break;

  case 632: /* apply: postfix_expr open_paren_or_safe_apply_with_line_info error '}'  */
#line 4172 "language.yacc"
  {
    yyerror("Missing ')'.");
    (yyval.n)=mkapplynode((yyvsp[-3].n), NULL);
    free_node ((yyvsp[-2].n));
  }
#line 9920 "y.tab.c"
    break;

  case 633: /* implicit_modifiers: %empty  */
#line 4180 "language.yacc"
  {
    free_node(Pike_compiler->current_annotations);
    Pike_compiler->current_annotations = NULL;
    (yyval.number) = Pike_compiler->current_modifiers = ID_PROTECTED|ID_INLINE|ID_PRIVATE |
      (THIS_COMPILATION->lex.pragmas & ID_MODIFIER_MASK);
  }
#line 9931 "y.tab.c"
    break;

  case 636: /* inherit_specifier: string_or_identifier "::"  */
#line 4199 "language.yacc"
  {
    struct compilation *c = THIS_COMPILATION;
    struct program_state *state = Pike_compiler;
    int depth;
    int e = INHERIT_ALL;

    inherit_state = NULL;
    inherit_depth = 0;

    /* NB: The heuristics here are a bit strange
     *     (all to make it as backward compatible as possible).
     *
     *     The priority order is as follows:
     *
     *     1: Direct inherits in the current class.
     *
     *     2: The name of the current class.
     *
     *     3: 1 & 2 recursively for surrounding parent classes.
     *
     *     4: Indirect inherits in the current class.
     *
     *     5: 4 recursively for surrounding parent classes.
     *
     *     6: this & this_program.
     *
     * Note that a deep inherit in the current class trumphs
     * a not so deep inherit in a parent class (but not a
     * direct inherit in a parent class). To select the deep
     * inherit in the parent class in this case, prefix it
     * with the name of the parent class.
     */
    for (depth = 0;; depth++, state = state->previous) {
      int inh = find_inherit(state->new_program, (yyvsp[-1].n)->u.sval.u.string);
      if (inh &&
	  (!inherit_state ||
	   (state->new_program->inherits[inh].inherit_level == 1))) {
	/* Found, and we've either not found anything earlier,
	 * or this is a direct inherit (and the previous
	 * wasn't since we didn't break out of the loop).
	 */
	e = inh;
	inherit_state = state;
	inherit_depth = depth;
	if (state->new_program->inherits[inh].inherit_level == 1) {
	  /* Name of direct inherit ==> Done. */
	  break;
	}
      }
      /* The top-level class does not have a name, so break here. */
      if (depth == c->compilation_depth) break;
      if (ID_FROM_INT (state->previous->new_program,
		       state->parent_identifier)->name ==
	  (yyvsp[-1].n)->u.sval.u.string) {
	/* Name of surrounding class ==> Done. */
	e = INHERIT_SELF;
	inherit_state = state;
	inherit_depth = depth;
	break;
      }
    }
    if (e < 0) {
      if (((yyvsp[-1].n)->u.sval.u.string != this_program_string) &&
	  ((yyvsp[-1].n)->u.sval.u.string != this_string)) {
        struct mapping *m;
        struct pike_string *str;
        my_yyerror("No inherit or surrounding class %pS.",
                   (yyvsp[-1].n)->u.sval.u.string);
        push_mapping(m = allocate_mapping(state->new_program->num_inherits));
        state = Pike_compiler;
        for (depth = 0;; depth++, state = state->previous) {
          struct program *p = state->new_program;
          for (e = p->num_inherits; --e;) {	/* NB: Skip inherit #0! */
            if ((str = p->inherits[e].name)) {
              struct svalue s;
              SET_SVAL(s, T_STRING, 0, string, str);
              low_mapping_insert(m, &s, &s, 0);
            }
          }
          /* The top-level class does not have a name, so break here. */
          if (depth == c->compilation_depth) break;
          if ((str = ID_FROM_INT(state->previous->new_program,
                                 state->parent_identifier)->name)) {
            struct svalue s;
            SET_SVAL(s, T_STRING, 0, string, str);
            low_mapping_insert(m, &s, &s, 0);
          }
        }
        f_indices(1);
        f_sort(1);
        push_text(", ");
        f_multiply(2);
        str = Pike_sp[-1].u.string;
        if (str->len) {
          my_yyerror("Expected one of %pS.", str);
        }
        pop_stack();
      }

      inherit_state = Pike_compiler;
      inherit_depth = 0;
      e = INHERIT_SELF;
    }
    free_node((yyvsp[-1].n));
    (yyval.number) = e;
  }
#line 10042 "y.tab.c"
    break;

  case 637: /* inherit_specifier: "local" "::"  */
#line 4306 "language.yacc"
  {
    inherit_state = Pike_compiler;
    inherit_depth = 0;
    (yyval.number) = INHERIT_LOCAL;
  }
#line 10052 "y.tab.c"
    break;

  case 638: /* inherit_specifier: "global" "::"  */
#line 4312 "language.yacc"
  {
    struct compilation *c = THIS_COMPILATION;
    inherit_state = Pike_compiler;
    for (inherit_depth = 0; inherit_depth < c->compilation_depth;
	 inherit_depth++, inherit_state = inherit_state->previous) {}
    (yyval.number) = INHERIT_GLOBAL;
  }
#line 10064 "y.tab.c"
    break;

  case 639: /* inherit_specifier: inherit_specifier "local" "::"  */
#line 4320 "language.yacc"
  {
    if ((yyvsp[-2].number) > 0) {
      yywarning("local:: references to inherited symbols is a noop.");
      (yyval.number) = (yyvsp[-2].number);
    } else {
      (yyval.number) = INHERIT_LOCAL;
    }
  }
#line 10077 "y.tab.c"
    break;

  case 640: /* inherit_specifier: inherit_specifier "identifier" "::"  */
#line 4329 "language.yacc"
  {
    int e = 0;
    if ((yyvsp[-2].number) < 0) {
      (yyvsp[-2].number) = INHERIT_SELF;
    }
#if 0
    /* FIXME: The inherit modifiers aren't kept. */
    if (!(inherit_state->new_program->inherits[(yyvsp[-2].number)].flags & ID_PRIVATE)) {
#endif /* 0 */
      e = find_inherit(inherit_state->new_program->inherits[(yyvsp[-2].number)].prog,
		       (yyvsp[-1].n)->u.sval.u.string);
#if 0
    }
#endif /* 0 */
    if (!e) {
      struct mapping *m;
      struct program *p;
      struct pike_string *str;

      if (inherit_state->new_program->inherits[(yyvsp[-2].number)].name) {
        my_yyerror("No such inherit %pS::%pS.",
		   inherit_state->new_program->inherits[(yyvsp[-2].number)].name,
		   (yyvsp[-1].n)->u.sval.u.string);
      } else {
        my_yyerror("No such inherit %pS.", (yyvsp[-1].n)->u.sval.u.string);
      }

      p = inherit_state->new_program->inherits[(yyvsp[-2].number)].prog;
      push_mapping(m = allocate_mapping(p->num_inherits));
      for (e = p->num_inherits; e--;) {	/* NB: Skip inherit #0! */
        if ((str = p->inherits[e].name)) {
          struct svalue s;
          SET_SVAL(s, T_STRING, 0, string, str);
          low_mapping_insert(m, &s, &s, 0);
        }
      }
      f_indices(1);
      f_sort(1);
      push_text(", ");
      f_multiply(2);
      str = Pike_sp[-1].u.string;
      if (str->len) {
        my_yyerror("Expected one of %pS.", str);
      }
      pop_stack();

      (yyval.number) = INHERIT_ALL;
    } else {
      /* We know stuff about the inherit structure... */
      (yyval.number) = e + (yyvsp[-2].number);
    }
    free_node((yyvsp[-1].n));
  }
#line 10135 "y.tab.c"
    break;

  case 641: /* inherit_specifier: inherit_specifier bad_inherit "::"  */
#line 4382 "language.yacc"
                                                  { (yyval.number) = INHERIT_ALL; }
#line 10141 "y.tab.c"
    break;

  case 642: /* low_id_expr: "identifier"  */
#line 4386 "language.yacc"
  {
    if(Pike_compiler->last_identifier) free_string(Pike_compiler->last_identifier);
    copy_shared_string(Pike_compiler->last_identifier, (yyvsp[0].n)->u.sval.u.string);

    if(((yyval.n)=lexical_islocal(Pike_compiler->last_identifier)))
    {
      /* done, nothing to do here */
    }else if(!((yyval.n)=find_module_identifier(Pike_compiler->last_identifier,1)) &&
	     !((yyval.n) = program_magic_identifier (Pike_compiler, 0, -1,
					      Pike_compiler->last_identifier, 0))) {
      if((Pike_compiler->flags & COMPILATION_FORCE_RESOLVE) ||
	 (Pike_compiler->compiler_pass == COMPILER_PASS_LAST)) {
        my_yyerror("Undefined identifier %pS.",
		   Pike_compiler->last_identifier);
	/* FIXME: Add this identifier as a constant in the current program to
	 *        avoid multiple reporting of the same identifier.
	 * NOTE: This should then only be done in the second pass.
	 */
	(yyval.n)=0;
      }else{
	(yyval.n)=mknode(F_UNDEFINED,0,0);
      }
    }

    set_node_name((yyval.n), (yyvsp[0].n)->name);
    free_node((yyvsp[0].n));
  }
#line 10173 "y.tab.c"
    break;

  case 643: /* low_id_expr: '.' "identifier"  */
#line 4414 "language.yacc"
  {
    push_constant_text("");
    if (call_handle_import()) {
      node *tmp=mkconstantsvaluenode(Pike_sp-1);
      set_node_name(tmp, empty_pike_string);
      pop_stack();

      (yyval.n) = index_node(tmp, (yyvsp[0].n)->u.sval.u.string);
      free_node(tmp);
    }
    else
      (yyval.n)=mknewintnode(0);
    if(Pike_compiler->last_identifier) free_string(Pike_compiler->last_identifier);
    copy_shared_string(Pike_compiler->last_identifier, (yyvsp[0].n)->u.sval.u.string);
    free_node((yyvsp[0].n));
  }
#line 10194 "y.tab.c"
    break;

  case 644: /* low_id_expr: "global" '.' "identifier"  */
#line 4431 "language.yacc"
  {
    (yyval.n) = resolve_identifier ((yyvsp[0].n)->u.sval.u.string);
    if(Pike_compiler->last_identifier) free_string(Pike_compiler->last_identifier);
    copy_shared_string(Pike_compiler->last_identifier, (yyvsp[0].n)->u.sval.u.string);
    free_node ((yyvsp[0].n));
  }
#line 10205 "y.tab.c"
    break;

  case 645: /* low_id_expr: "reserved identifier"  */
#line 4438 "language.yacc"
  {
    ref_push_string((yyvsp[0].n)->u.sval.u.string);
    low_yyreport(REPORT_ERROR, NULL, 0, parser_system_string,
		 1, "Unknown reserved symbol %s.");
    free_node((yyvsp[0].n));
    (yyval.n) = 0;
  }
#line 10217 "y.tab.c"
    break;

  case 646: /* range_bound: %empty  */
#line 4449 "language.yacc"
  {(yyval.n) = mknode (F_RANGE_OPEN, NULL, NULL);}
#line 10223 "y.tab.c"
    break;

  case 647: /* range_bound: init_expr  */
#line 4451 "language.yacc"
  {(yyval.n) = mknode (F_RANGE_FROM_BEG, (yyvsp[0].n), NULL);}
#line 10229 "y.tab.c"
    break;

  case 648: /* range_bound: '<' init_expr  */
#line 4453 "language.yacc"
  {(yyval.n) = mknode (F_RANGE_FROM_END, (yyvsp[0].n), NULL);}
#line 10235 "y.tab.c"
    break;

  case 649: /* range_bound: "end of file"  */
#line 4455 "language.yacc"
  {
    yyerror("Unexpected end of file.");
    (yyval.n) = mknode (F_RANGE_OPEN, NULL, NULL);
  }
#line 10244 "y.tab.c"
    break;

  case 650: /* range_bound: '<' "end of file"  */
#line 4460 "language.yacc"
  {
    yyerror("Unexpected end of file.");
    (yyval.n) = mknode (F_RANGE_OPEN, NULL, NULL);
  }
#line 10253 "y.tab.c"
    break;

  case 651: /* gauge: "gauge" catch_arg  */
#line 4467 "language.yacc"
  {
    (yyval.n)=mkopernode("`/",
		  mkopernode("`-",
			     mkopernode("`-",
					mkefuncallnode("gethrvtime",
						       mkintnode(1)),
					mknode(F_COMMA_EXPR,
					       mknode(F_POP_VALUE, (yyvsp[0].n), NULL),
					       mkefuncallnode("gethrvtime",
							      mkintnode(1)))),
			     NULL),
		  mkfloatnode((FLOAT_TYPE)1e9));
  }
#line 10271 "y.tab.c"
    break;

  case 652: /* typeof: "typeof" '(' assignment_expr ')'  */
#line 4482 "language.yacc"
  {
    (yyval.n) = mknode(F_TYPEOF, (yyvsp[-1].n), 0);
  }
#line 10279 "y.tab.c"
    break;

  case 653: /* typeof: "typeof" '(' error ')'  */
#line 4485 "language.yacc"
                             { (yyval.n)=0; yyerrok; }
#line 10285 "y.tab.c"
    break;

  case 654: /* typeof: "typeof" '(' error '}'  */
#line 4486 "language.yacc"
                             { (yyval.n)=0; yyerror("Missing ')'."); }
#line 10291 "y.tab.c"
    break;

  case 655: /* typeof: "typeof" '(' error "end of file"  */
#line 4488 "language.yacc"
  {
    (yyval.n)=0; yyerror("Missing ')'.");
    yyerror("Unexpected end of file.");
  }
#line 10300 "y.tab.c"
    break;

  case 656: /* typeof: "typeof" '(' error ';'  */
#line 4492 "language.yacc"
                             { (yyval.n)=0; yyerror("Missing ')'."); }
#line 10306 "y.tab.c"
    break;

  case 657: /* catch_arg: '(' init_expr ')'  */
#line 4495 "language.yacc"
                              { (yyval.n)=(yyvsp[-1].n); }
#line 10312 "y.tab.c"
    break;

  case 658: /* catch_arg: '(' error ')'  */
#line 4496 "language.yacc"
                  { (yyval.n)=0; yyerrok; }
#line 10318 "y.tab.c"
    break;

  case 659: /* catch_arg: '(' error "end of file"  */
#line 4498 "language.yacc"
  {
    (yyval.n)=0; yyerror("Missing ')'.");
    yyerror("Unexpected end of file.");
  }
#line 10327 "y.tab.c"
    break;

  case 660: /* catch_arg: '(' error '}'  */
#line 4502 "language.yacc"
                  { (yyval.n)=0; yyerror("Missing ')'."); }
#line 10333 "y.tab.c"
    break;

  case 661: /* catch_arg: '(' error ';'  */
#line 4503 "language.yacc"
                  { (yyval.n)=0; yyerror("Missing ')'."); }
#line 10339 "y.tab.c"
    break;

  case 663: /* catch_arg: error  */
#line 4505 "language.yacc"
          { (yyval.n)=0; yyerror("Bad expression for catch."); }
#line 10345 "y.tab.c"
    break;

  case 664: /* $@42: %empty  */
#line 4509 "language.yacc"
     {
       Pike_compiler->catch_level++;
     }
#line 10353 "y.tab.c"
    break;

  case 665: /* catch: "catch" $@42 catch_arg  */
#line 4513 "language.yacc"
     {
       (yyval.n)=mknode(F_CATCH,(yyvsp[0].n),NULL);
       Pike_compiler->catch_level--;
     }
#line 10362 "y.tab.c"
    break;

  case 666: /* sscanf: "sscanf" '(' assignment_expr ',' assignment_expr lvalue_list ')'  */
#line 4520 "language.yacc"
  {
    if ((yyvsp[-1].n) && !(THIS_COMPILATION->lex.pragmas & ID_STRICT_TYPES)) {
      mark_lvalues_as_used((yyvsp[-1].n));
    }
    if (TEST_COMPAT(8, 0)) {
      (yyval.n) = mknode(F_SSCANF_80, mknode(F_ARG_LIST, (yyvsp[-4].n), (yyvsp[-2].n)), (yyvsp[-1].n));
    } else {
      (yyval.n) = mknode(F_SSCANF, mknode(F_ARG_LIST, (yyvsp[-4].n), (yyvsp[-2].n)), (yyvsp[-1].n));
    }
  }
#line 10377 "y.tab.c"
    break;

  case 667: /* sscanf: "sscanf" '(' assignment_expr ',' assignment_expr error ')'  */
#line 4531 "language.yacc"
  {
    (yyval.n)=0;
    free_node((yyvsp[-4].n));
    free_node((yyvsp[-2].n));
    yyerrok;
  }
#line 10388 "y.tab.c"
    break;

  case 668: /* sscanf: "sscanf" '(' assignment_expr ',' assignment_expr error "end of file"  */
#line 4538 "language.yacc"
  {
    (yyval.n)=0;
    free_node((yyvsp[-4].n));
    free_node((yyvsp[-2].n));
    yyerror("Missing ')'.");
    yyerror("Unexpected end of file.");
  }
#line 10400 "y.tab.c"
    break;

  case 669: /* sscanf: "sscanf" '(' assignment_expr ',' assignment_expr error '}'  */
#line 4546 "language.yacc"
  {
    (yyval.n)=0;
    free_node((yyvsp[-4].n));
    free_node((yyvsp[-2].n));
    yyerror("Missing ')'.");
  }
#line 10411 "y.tab.c"
    break;

  case 670: /* sscanf: "sscanf" '(' assignment_expr ',' assignment_expr error ';'  */
#line 4553 "language.yacc"
  {
    (yyval.n)=0;
    free_node((yyvsp[-4].n));
    free_node((yyvsp[-2].n));
    yyerror("Missing ')'.");
  }
#line 10422 "y.tab.c"
    break;

  case 671: /* sscanf: "sscanf" '(' assignment_expr error ')'  */
#line 4560 "language.yacc"
  {
    (yyval.n)=0;
    free_node((yyvsp[-2].n));
    yyerrok;
  }
#line 10432 "y.tab.c"
    break;

  case 672: /* sscanf: "sscanf" '(' assignment_expr error "end of file"  */
#line 4566 "language.yacc"
  {
    (yyval.n)=0;
    free_node((yyvsp[-2].n));
    yyerror("Missing ')'.");
    yyerror("Unexpected end of file.");
  }
#line 10443 "y.tab.c"
    break;

  case 673: /* sscanf: "sscanf" '(' assignment_expr error '}'  */
#line 4573 "language.yacc"
  {
    (yyval.n)=0;
    free_node((yyvsp[-2].n));
    yyerror("Missing ')'.");
  }
#line 10453 "y.tab.c"
    break;

  case 674: /* sscanf: "sscanf" '(' assignment_expr error ';'  */
#line 4579 "language.yacc"
  {
    (yyval.n)=0;
    free_node((yyvsp[-2].n));
    yyerror("Missing ')'.");
  }
#line 10463 "y.tab.c"
    break;

  case 675: /* sscanf: "sscanf" '(' error ')'  */
#line 4584 "language.yacc"
                             { (yyval.n)=0; yyerrok; }
#line 10469 "y.tab.c"
    break;

  case 676: /* sscanf: "sscanf" '(' error "end of file"  */
#line 4586 "language.yacc"
  {
    (yyval.n)=0; yyerror("Missing ')'.");
    yyerror("Unexpected end of file.");
  }
#line 10478 "y.tab.c"
    break;

  case 677: /* sscanf: "sscanf" '(' error '}'  */
#line 4590 "language.yacc"
                             { (yyval.n)=0; yyerror("Missing ')'."); }
#line 10484 "y.tab.c"
    break;

  case 678: /* sscanf: "sscanf" '(' error ';'  */
#line 4591 "language.yacc"
                             { (yyval.n)=0; yyerror("Missing ')'."); }
#line 10490 "y.tab.c"
    break;

  case 679: /* lvalue: assignment_expr  */
#line 4595 "language.yacc"
  {
    (yyval.n) = make_default_lvalue((yyvsp[0].n));
  }
#line 10498 "y.tab.c"
    break;

  case 680: /* lvalue: open_bracket_with_line_info low_lvalue_list ']'  */
#line 4599 "language.yacc"
  {
    /* NB: The optional default value is handled by assignment_expr above. */
    (yyval.n) = mknode(F_ARRAY_LVALUE, (yyvsp[-1].n), 0);
    COPY_LINE_NUMBER_INFO((yyval.n), (yyvsp[-2].n));
    free_node((yyvsp[-2].n));
  }
#line 10509 "y.tab.c"
    break;

  case 681: /* lvalue: type2 "identifier" optional_default_value  */
#line 4606 "language.yacc"
  {
    int id = add_local_name((yyvsp[-1].n)->u.sval.u.string,compiler_pop_type(),0);
    /* Note: Variable intentionally not marked as used. */
    if (id >= 0) {
      (yyval.n) = mknode(F_CLEAR_LOCAL, mklocalnode(id, 0), NULL);
      if ((yyvsp[0].n)) {
        (yyval.n) = mknode(F_COMMA_EXPR, mkcastnode(void_type_string, (yyval.n)),
                    make_default_lvalue(mknode(F_ASSIGN,
                                               mklocalnode(id, 0),
                                               (yyvsp[0].n))));
      }
    } else {
      (yyval.n) = 0;
      free_node((yyvsp[0].n));
    }
    free_node((yyvsp[-1].n));
  }
#line 10531 "y.tab.c"
    break;

  case 682: /* low_lvalue_list: lvalue lvalue_list  */
#line 4627 "language.yacc"
  {
    (yyval.n)=mknode(F_LVALUE_LIST,(yyvsp[-1].n),(yyvsp[0].n));
  }
#line 10539 "y.tab.c"
    break;

  case 683: /* lvalue_list: %empty  */
#line 4632 "language.yacc"
                         { (yyval.n) = 0; }
#line 10545 "y.tab.c"
    break;

  case 684: /* lvalue_list: ',' lvalue lvalue_list  */
#line 4634 "language.yacc"
  {
    (yyval.n) = mknode(F_LVALUE_LIST,(yyvsp[-1].n),(yyvsp[0].n));
  }
#line 10553 "y.tab.c"
    break;

  case 686: /* string_segment: "__func__"  */
#line 4641 "language.yacc"
  {
    struct compiler_frame *f = Pike_compiler->compiler_frame;
    if (!f || (f->current_function_number < 0)) {
      (yyval.n) = mkstrnode(lfun_strings[LFUN___INIT]);
    } else {
      struct identifier *id =
	ID_FROM_INT(Pike_compiler->new_program, f->current_function_number);
      if (!id->name->size_shift) {
	int len;
	if ((len = strlen(id->name->str)) == id->name->len) {
	  /* Most common case. */
	  (yyval.n) = mkstrnode(id->name);
	} else {
	  struct pike_string *str =
	    make_shared_binary_string(id->name->str, len);
	  (yyval.n) = mkstrnode(str);
	  free_string(str);
	}
      } else {
	struct pike_string *str;
	struct array *split;
	MAKE_CONST_STRING(str, "\0");
	split = explode(id->name, str);
	(yyval.n) = mkstrnode(split->item->u.string);
	free_array(split);
      }
    }
  }
#line 10586 "y.tab.c"
    break;

  case 688: /* string: string string_segment  */
#line 4673 "language.yacc"
  {
    struct pike_string *a,*b;
    copy_shared_string(a,(yyvsp[-1].n)->u.sval.u.string);
    copy_shared_string(b,(yyvsp[0].n)->u.sval.u.string);
    free_node((yyvsp[-1].n));
    free_node((yyvsp[0].n));
    a=add_and_free_shared_strings(a,b);
    (yyval.n)=mkstrnode(a);
    free_string(a);
  }
#line 10601 "y.tab.c"
    break;

  case 690: /* string_constant: string_constant '+' string  */
#line 4687 "language.yacc"
  {
    struct pike_string *a,*b;
    copy_shared_string(a,(yyvsp[-2].n)->u.sval.u.string);
    copy_shared_string(b,(yyvsp[0].n)->u.sval.u.string);
    free_node((yyvsp[-2].n));
    free_node((yyvsp[0].n));
    a=add_and_free_shared_strings(a,b);
    (yyval.n)=mkstrnode(a);
    free_string(a);
  }
#line 10616 "y.tab.c"
    break;

  case 692: /* real_string_constant: real_string_constant "string literal"  */
#line 4702 "language.yacc"
  {
    struct pike_string *a,*b;
    copy_shared_string(a,(yyvsp[-1].n)->u.sval.u.string);
    copy_shared_string(b,(yyvsp[0].n)->u.sval.u.string);
    free_node((yyvsp[-1].n));
    free_node((yyvsp[0].n));
    a=add_and_free_shared_strings(a,b);
    (yyval.n)=mkstrnode(a);
    free_string(a);
  }
#line 10631 "y.tab.c"
    break;

  case 693: /* real_string_constant: real_string_constant '+' "string literal"  */
#line 4713 "language.yacc"
  {
    struct pike_string *a,*b;
    copy_shared_string(a,(yyvsp[-2].n)->u.sval.u.string);
    copy_shared_string(b,(yyvsp[0].n)->u.sval.u.string);
    free_node((yyvsp[-2].n));
    free_node((yyvsp[0].n));
    a=add_and_free_shared_strings(a,b);
    (yyval.n)=mkstrnode(a);
    free_string(a);
  }
#line 10646 "y.tab.c"
    break;

  case 695: /* bad_identifier: "local"  */
#line 4733 "language.yacc"
  { yyerror_reserved("local"); }
#line 10652 "y.tab.c"
    break;

  case 697: /* bad_inherit: "array"  */
#line 4738 "language.yacc"
  { yyerror_reserved("array"); }
#line 10658 "y.tab.c"
    break;

  case 698: /* bad_inherit: "__attribute__"  */
#line 4740 "language.yacc"
  { yyerror_reserved("__attribute__"); }
#line 10664 "y.tab.c"
    break;

  case 699: /* bad_inherit: "__deprecated__"  */
#line 4742 "language.yacc"
  { yyerror_reserved("__deprecated__"); }
#line 10670 "y.tab.c"
    break;

  case 700: /* bad_inherit: "__experimental__"  */
#line 4744 "language.yacc"
  { yyerror_reserved("__experimental__"); }
#line 10676 "y.tab.c"
    break;

  case 701: /* bad_inherit: "float"  */
#line 4746 "language.yacc"
  { yyerror_reserved("float");}
#line 10682 "y.tab.c"
    break;

  case 702: /* bad_inherit: "function"  */
#line 4748 "language.yacc"
  { yyerror_reserved("function");}
#line 10688 "y.tab.c"
    break;

  case 703: /* bad_inherit: "int"  */
#line 4750 "language.yacc"
  { yyerror_reserved("int"); }
#line 10694 "y.tab.c"
    break;

  case 704: /* bad_inherit: "mapping"  */
#line 4752 "language.yacc"
  { yyerror_reserved("mapping"); }
#line 10700 "y.tab.c"
    break;

  case 705: /* bad_inherit: "mixed"  */
#line 4754 "language.yacc"
  { yyerror_reserved("mixed"); }
#line 10706 "y.tab.c"
    break;

  case 706: /* bad_inherit: "multiset"  */
#line 4756 "language.yacc"
  { yyerror_reserved("multiset"); }
#line 10712 "y.tab.c"
    break;

  case 707: /* bad_inherit: "object"  */
#line 4758 "language.yacc"
  { yyerror_reserved("object"); }
#line 10718 "y.tab.c"
    break;

  case 708: /* bad_inherit: "program"  */
#line 4760 "language.yacc"
  { yyerror_reserved("program"); }
#line 10724 "y.tab.c"
    break;

  case 709: /* bad_inherit: "string"  */
#line 4762 "language.yacc"
  { yyerror_reserved("string"); }
#line 10730 "y.tab.c"
    break;

  case 710: /* bad_inherit: "__unknown__"  */
#line 4764 "language.yacc"
  { yyerror_reserved("__unknown__"); }
#line 10736 "y.tab.c"
    break;

  case 711: /* bad_inherit: "void"  */
#line 4766 "language.yacc"
  { yyerror_reserved("void"); }
#line 10742 "y.tab.c"
    break;

  case 713: /* bad_const_expr_ident: "break"  */
#line 4771 "language.yacc"
  { yyerror_reserved("break"); }
#line 10748 "y.tab.c"
    break;

  case 714: /* bad_const_expr_ident: "case"  */
#line 4773 "language.yacc"
  { yyerror_reserved("case"); }
#line 10754 "y.tab.c"
    break;

  case 715: /* bad_const_expr_ident: "catch"  */
#line 4775 "language.yacc"
  { yyerror_reserved("catch"); }
#line 10760 "y.tab.c"
    break;

  case 716: /* bad_const_expr_ident: "class"  */
#line 4777 "language.yacc"
  { yyerror_reserved("class"); }
#line 10766 "y.tab.c"
    break;

  case 717: /* bad_const_expr_ident: "continue"  */
#line 4779 "language.yacc"
  { yyerror_reserved("continue"); }
#line 10772 "y.tab.c"
    break;

  case 718: /* bad_const_expr_ident: "default"  */
#line 4781 "language.yacc"
  { yyerror_reserved("default"); }
#line 10778 "y.tab.c"
    break;

  case 719: /* bad_const_expr_ident: "do"  */
#line 4783 "language.yacc"
  { yyerror_reserved("do"); }
#line 10784 "y.tab.c"
    break;

  case 720: /* bad_const_expr_ident: "enum"  */
#line 4785 "language.yacc"
  { yyerror_reserved("enum"); }
#line 10790 "y.tab.c"
    break;

  case 721: /* bad_const_expr_ident: "for"  */
#line 4787 "language.yacc"
  { yyerror_reserved("for"); }
#line 10796 "y.tab.c"
    break;

  case 722: /* bad_const_expr_ident: "foreach"  */
#line 4789 "language.yacc"
  { yyerror_reserved("foreach"); }
#line 10802 "y.tab.c"
    break;

  case 723: /* bad_const_expr_ident: "__func__"  */
#line 4791 "language.yacc"
  { yyerror_reserved("__FUNCTION__");}
#line 10808 "y.tab.c"
    break;

  case 724: /* bad_const_expr_ident: "gauge"  */
#line 4793 "language.yacc"
  { yyerror_reserved("gauge"); }
#line 10814 "y.tab.c"
    break;

  case 725: /* bad_const_expr_ident: "if"  */
#line 4795 "language.yacc"
  { yyerror_reserved("if"); }
#line 10820 "y.tab.c"
    break;

  case 726: /* bad_const_expr_ident: "import"  */
#line 4797 "language.yacc"
  { yyerror_reserved("import"); }
#line 10826 "y.tab.c"
    break;

  case 727: /* bad_const_expr_ident: "lambda"  */
#line 4799 "language.yacc"
  { yyerror_reserved("lambda"); }
#line 10832 "y.tab.c"
    break;

  case 728: /* bad_const_expr_ident: "return"  */
#line 4801 "language.yacc"
  { yyerror_reserved("return"); }
#line 10838 "y.tab.c"
    break;

  case 729: /* bad_const_expr_ident: "sscanf"  */
#line 4803 "language.yacc"
  { yyerror_reserved("sscanf"); }
#line 10844 "y.tab.c"
    break;

  case 730: /* bad_const_expr_ident: "switch"  */
#line 4805 "language.yacc"
  { yyerror_reserved("switch"); }
#line 10850 "y.tab.c"
    break;

  case 731: /* bad_const_expr_ident: "typedef"  */
#line 4807 "language.yacc"
  { yyerror_reserved("typedef"); }
#line 10856 "y.tab.c"
    break;

  case 732: /* bad_const_expr_ident: "typeof"  */
#line 4809 "language.yacc"
  { yyerror_reserved("typeof"); }
#line 10862 "y.tab.c"
    break;

  case 733: /* bad_const_expr_ident: "reserved identifier"  */
#line 4811 "language.yacc"
  {
    ref_push_string((yyvsp[0].n)->u.sval.u.string);
    low_yyreport(REPORT_ERROR, NULL, 0, parser_system_string,
		 1, "Unknown reserved symbol %s.");
    free_node((yyvsp[0].n));
  }
#line 10873 "y.tab.c"
    break;

  case 734: /* bad_expr_ident: "inline"  */
#line 4821 "language.yacc"
  { yyerror_reserved("inline"); }
#line 10879 "y.tab.c"
    break;

  case 735: /* bad_expr_ident: "predef"  */
#line 4823 "language.yacc"
  { yyerror_reserved("predef"); }
#line 10885 "y.tab.c"
    break;

  case 736: /* bad_expr_ident: "private"  */
#line 4825 "language.yacc"
  { yyerror_reserved("private"); }
#line 10891 "y.tab.c"
    break;

  case 737: /* bad_expr_ident: "protected"  */
#line 4827 "language.yacc"
  { yyerror_reserved("protected"); }
#line 10897 "y.tab.c"
    break;

  case 738: /* bad_expr_ident: "public"  */
#line 4829 "language.yacc"
  { yyerror_reserved("public"); }
#line 10903 "y.tab.c"
    break;

  case 739: /* bad_expr_ident: "optional"  */
#line 4831 "language.yacc"
  { yyerror_reserved("optional"); }
#line 10909 "y.tab.c"
    break;

  case 740: /* bad_expr_ident: "variant"  */
#line 4833 "language.yacc"
  { yyerror_reserved("variant"); }
#line 10915 "y.tab.c"
    break;

  case 741: /* bad_expr_ident: "__weak__"  */
#line 4835 "language.yacc"
  { yyerror_reserved("__weak__"); }
#line 10921 "y.tab.c"
    break;

  case 742: /* bad_expr_ident: "static"  */
#line 4837 "language.yacc"
  { yyerror_reserved("static"); }
#line 10927 "y.tab.c"
    break;

  case 743: /* bad_expr_ident: "extern"  */
#line 4839 "language.yacc"
  { yyerror_reserved("extern"); }
#line 10933 "y.tab.c"
    break;

  case 744: /* bad_expr_ident: "final"  */
#line 4841 "language.yacc"
  { yyerror_reserved("final");}
#line 10939 "y.tab.c"
    break;

  case 745: /* bad_expr_ident: "else"  */
#line 4843 "language.yacc"
  { yyerror("else without if."); }
#line 10945 "y.tab.c"
    break;

  case 746: /* bad_expr_ident: "inherit"  */
#line 4845 "language.yacc"
  { yyerror_reserved("inherit"); }
#line 10951 "y.tab.c"
    break;


#line 10955 "y.tab.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (YY_("syntax error"));
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;


#if !defined yyoverflow
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturn;
#endif


/*-------------------------------------------------------.
| yyreturn -- parsing is finished, clean up and return.  |
`-------------------------------------------------------*/
yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif

  return yyresult;
}

#line 4858 "language.yacc"


static void yyerror_reserved(const char *keyword)
{
  my_yyerror("%s is a reserved word.", keyword);
}

static void compiler_add_generic(struct pike_string *name,
                                 struct pike_type *type,
                                 struct pike_type *default_type)
{
  struct pike_type *tmp = NULL;

  if (!type) {
    type = mixed_type_string;
  }
  if (!default_type) {
    default_type = type;
  } else {
    /* FIXME: Validate that default_type is a subset of type. */
  }

  /* Bump num_generics early to make sure that the
   * push_object_type() below gets PT_FLAG_GOBJECT set.
   *
   * Note that Pike_compiler->num_generics is kept from
   * earlier passes, so reset it here.
   */
  Pike_compiler->new_program->num_generics =
    ++Pike_compiler->num_generics;

  /* Update generic_types.
   *
   * Conventions:
   *
   *   A NULL generic_types means that it is an array of length
   *   num_generics containing only mixed_type_string.
   *
   *   A generic_types array shorter than num_generics is padded
   *   with mixed_type_string.
   */
  if (type != mixed_type_string) {
    if ((!Pike_compiler->generic_types) ||
        (Pike_compiler->generic_types->size < Pike_compiler->num_generics)) {
      int i;
      int cnt = Pike_compiler->num_generics - 1;
      if (Pike_compiler->generic_types) {
        /* NB: Steals one reference to avoid need to free it
         *     at the assignment below.
         */
        cnt -= Pike_compiler->generic_types->size;
        push_array(Pike_compiler->generic_types);
      }

      for (i = 0; i < cnt; i++) {
        ref_push_type_value(mixed_type_string);
      }

      ref_push_type_value(type);

      f_aggregate(cnt + 1);

      if (Pike_compiler->generic_types) {
        f_add(2);
      }

      add_ref(Pike_compiler->generic_types = Pike_sp[-1].u.array);
      pop_stack();
    } else {
      struct svalue * s = ITEM(Pike_compiler->generic_types) +
        (Pike_compiler->num_generics - 1);
      free_svalue(s);
      SET_SVAL(*s, PIKE_T_TYPE, 0, type, type);
      add_ref(type);
    }
  }

  /* Update generic_bindings.
   *
   * Conventions:
   *
   *   A NULL generic_bindings means that it is identical to
   *   the generic_types array.
   *
   *   A generic_bindings array shorter than num_generics is padded
   *   with entries from the generic_types array.
   */
  if (default_type != type) {
    tmp = and_pike_types(default_type, type);

    if (!tmp) {
      my_yyerror("Invalid default type for generic %pS.\n", name);
    } else {
      default_type = tmp;
    }
  }

  if ((default_type != type) ||
      (Pike_compiler->generic_bindings &&
       (Pike_compiler->num_generics <=
        Pike_compiler->generic_bindings->size))) {
    if (!Pike_compiler->generic_bindings && Pike_compiler->generic_types) {
      Pike_compiler->generic_bindings =
        copy_array(Pike_compiler->generic_types);
    }

    if (!Pike_compiler->generic_bindings ||
        (Pike_compiler->generic_bindings->size < Pike_compiler->num_generics)) {
      int i = 0;
      if (Pike_compiler->generic_bindings) {
        /* NB: Steals one reference.
         *
         *     So no need to free it at the assignment below.
         */
        i = Pike_compiler->generic_bindings->size;
        push_array(Pike_compiler->generic_bindings);
      }

      for (; i < Pike_compiler->num_generics - 1; i++) {
        if (Pike_compiler->generic_types &&
            (i < Pike_compiler->generic_types->size)) {
          ref_push_type_value(ITEM(Pike_compiler->generic_types)[i-1].u.type);
        } else {
          ref_push_type_value(mixed_type_string);
        }
      }

      ref_push_type_value(default_type);

      f_aggregate(Pike_compiler->num_generics -
                  (Pike_compiler->generic_bindings ?
                   Pike_compiler->generic_bindings->size : 0));

      if (Pike_compiler->generic_bindings) {
        f_add(2);
      }

      add_ref(Pike_compiler->generic_bindings = Pike_sp[-1].u.array);
      pop_stack();
    } else {
      struct svalue * s = ITEM(Pike_compiler->generic_bindings) +
        (Pike_compiler->num_generics - 1);
      free_svalue(s);
      SET_SVAL(*s, PIKE_T_TYPE, 0, type, default_type);
      add_ref(default_type);
    }
  }

  ref_push_string(name);

  if (Pike_compiler->new_program->num_generics <= 10) {
    /* Add a generic variable. */
    type_stack_mark();
    push_type('0' + (Pike_compiler->new_program->num_generics - 1));
    push_object_type(0, Pike_compiler->new_program->id);
    push_type(PIKE_T_GENERIC);
    push_type_value(pop_unfinished_type());
  } else {
    yyerror("Too many generic variables.");
    ref_push_type_value(type);
  }

  /* This does an import of the "module" ([ generic_name: generic_type ]).
   *
   * Note: We *could* reuse the same mapping for all the generics of
   *       a class, but that would require more complicated code and
   *       keeping track of the mapping, for a case that is uncommon.
   */
  f_aggregate_mapping(2);
  use_module(Pike_sp - 1);

  pop_stack();

  free_type(tmp);
}

static void compiler_define_implicit___create__(void)
{
  node *n = NULL;
  int e = Pike_compiler->num_create_args;
  struct pike_type *t;

  free_type(Pike_compiler->compiler_frame->current_return_type);
  Pike_compiler->compiler_frame->current_return_type = void_type_string;
  add_ref(void_type_string);

  type_stack_mark();
  push_type(T_VOID);

  if (e < 0) {
    e = - e - 1;
    push_finished_type(Pike_compiler->compiler_frame->local_names[e].def->type);
    if (pop_type_stack(T_ARRAY)) {
      compiler_discard_top_type();
    }

    if (Pike_compiler->compiler_pass == COMPILER_PASS_LAST) {
      /* FIXME: Should probably use some other flag. */
      if ((runtime_options & RUNTIME_CHECK_TYPES) &&
          (Pike_compiler->compiler_frame->local_names[e].def->type !=
           mixed_type_string)) {
        node *local_node;

        /* fprintf(stderr, "Creating soft cast node for local #%d\n", e);*/

        local_node = mkcastnode(mixed_type_string, mklocalnode(e, 0));

        /* NOTE: The cast to mixed above is needed to avoid generating
         *       compilation errors, as well as avoiding optimizations
         *       in mksoftcastnode().
         */
        n =
          mknode(F_COMMA_EXPR, n,
                 mksoftcastnode(Pike_compiler->compiler_frame->local_names[e].def->type,
                                local_node));
      }
    }
    n =
      mknode(F_COMMA_EXPR, n,
             mknode(F_POP_VALUE,
                    mknode(F_ASSIGN,
                           mkidentifiernode(e),
                           mklocalnode(e, 0)), NULL));
  } else {
    push_type(T_VOID);
  }
  push_type(T_MANY);

  while (e-- > 0) {
    /* NB: Currently there is no need to go indirectly via local_variables,
     *     as all create_args have been bound directly (there is no support
     *     for having them bound via F_ARRAY_LVALUE yet).
     */
    struct local_name *var = Pike_compiler->compiler_frame->local_names + e;

    push_finished_type(var->def->type);

    n =
      mknode(F_COMMA_EXPR,
             mknode(F_POP_VALUE,
                    mknode(F_ASSIGN,
                           mkidentifiernode(e),
                           mklocalnode(e, 0)), NULL),
             n);

    if (Pike_compiler->compiler_pass == COMPILER_PASS_LAST) {
      /* FIXME: Should probably use some other flag. */
      if ((runtime_options & RUNTIME_CHECK_TYPES) &&
          (var->def->type != mixed_type_string)) {
        node *local_node;

        /* fprintf(stderr, "Creating soft cast node for local #%d\n", e);*/

        local_node = mkcastnode(mixed_type_string, mklocalnode(e, 0));

        /* NOTE: The cast to mixed above is needed to avoid generating
         *       compilation errors, as well as avoiding optimizations
         *       in mksoftcastnode().
         */
        n =
          mknode(F_COMMA_EXPR,
                 mksoftcastnode(var->def->type, local_node),
                 n);
      }
    }

    /* NB: var->def->token is currently always F_LOCAL, but forward
     *     compat is trivial here, so.
     */
    if (var->init && (var->def->token == F_LOCAL)) {
      push_type(T_VOID);
      push_type(T_OR);
    }
    push_type(T_FUNCTION);

    n = mknode(F_COMMA_EXPR, set_default_value(e), n);
  }

  n = mknode(F_COMMA_EXPR, n,
             mknode(F_RETURN, mkintnode(0), NULL));

  t = pop_unfinished_type();

  define_function(lfun_strings[LFUN___CREATE__], t,
                  ID_PROTECTED|ID_LOCAL,
                  IDENTIFIER_PIKE_FUNCTION |
                  ((Pike_compiler->num_create_args < 0)?
                   IDENTIFIER_VARARGS:0),
                  0, OPT_EXTERNAL_DEPEND|OPT_SIDE_EFFECT);

  dooptcode(lfun_strings[LFUN___CREATE__], n, t, ID_PROTECTED|ID_LOCAL);

  free_type(t);
}

static void compiler_end_class(int has___create__, int parent_constant_id)
{
  struct program *p;

  /* Check if we have __create__() but no locally defined create(). */
  if (has___create__) {
    struct reference *ref = NULL;
    struct identifier *id = NULL;
    int ref_id;
    if (((ref_id = isidentifier(lfun_strings[LFUN_CREATE])) < 0) ||
        (ref = PTR_FROM_INT(Pike_compiler->new_program, ref_id))->inherit_offset ||
        ((id = ID_FROM_PTR(Pike_compiler->new_program, ref))->func.offset == -1)) {
      /* There is no create() or it is inherited or it is a prototype. */
      push_compiler_frame(SCOPE_LOCAL);

      ref_id = FIND_LFUN(Pike_compiler->new_program, LFUN___CREATE__);
      ref = PTR_FROM_INT(Pike_compiler->new_program, ref_id);
      id = ID_FROM_PTR(Pike_compiler->new_program, ref);

      ref_id = define_function(lfun_strings[LFUN_CREATE],
                               id->type, ref->id_flags,
                               id->identifier_flags, &id->func,
                               id->opt_flags);

      pop_compiler_frame();
    }
  }

  /* Update the type for the program constant,
   * since we may have a lfun::create().
   *
   * Do this before end_first_pass(), to keep
   * override_identifier() et al happy.
   */
  {
    struct identifier *i;
    struct svalue sv;
    SET_SVAL(sv, T_PROGRAM, 0, program, Pike_compiler->new_program);
    i = ID_FROM_INT(Pike_compiler->previous->new_program, parent_constant_id);
    free_type(i->type);
    i->type = get_type_of_svalue(&sv);
    if (Pike_compiler->new_program->flags & PROGRAM_CONSTANT) {
      /* Update, in case of @constant. */
      i->opt_flags = 0;
    }
  }

  if(Pike_compiler->compiler_pass != COMPILER_PASS_LAST)
    p=end_first_pass(0);
  else
    p=end_first_pass(1);

  /* fprintf(stderr, "LANGUAGE.YACC: ANON CLASS end\n"); */

  if(p) {
    free_program(p);
  } else if (!Pike_compiler->num_parse_error) {
    /* Make sure code in this class is aware that something went wrong. */
    Pike_compiler->num_parse_error = 1;
  }
}

static int compiler_declare_prototype(int modifiers,
                                      struct pike_string *identifier,
                                      int num_args, int num_create_args,
                                      int opt_flags)
{
  struct pike_type *type;
  int id, e, ee;
  struct identifier *i=0;

  /*
   * Construct the function type
   */
  if (modifiers & (ID_ASYNC|ID_GENERATOR)) {
    struct pike_string *name;
    int num_state_vars = 4;
    node *save_annotations = Pike_compiler->current_annotations;
    /* NB: Delay annotations, so that they can be attached to
     *     the "outer" function. Cf issue #10147.
     */
    Pike_compiler->current_annotations = NULL;

    if (modifiers & ID_ASYNC) {
      Pike_compiler->compiler_frame->generator_is_async = 1;

      /* NB: The inner function of an async function
       *     always returns void.
       */
      push_type(T_VOID);
    } else {
      push_finished_type(Pike_compiler->compiler_frame->current_return_type);
    }

    /* Adjust the type to be a function that returns
     * a function(mixed|void, function(mixed...:void)|void:X).
     */
    push_type(T_VOID);
    push_type(T_MANY);

    push_type(T_VOID);
    push_type(T_VOID);
    push_type(T_VOID);
    push_type(T_MIXED);
    push_type(T_OR);
    push_type(T_MANY);
    push_type(T_OR);
    push_type(T_FUNCTION);

    push_type(T_VOID);
    push_type(T_MIXED);
    push_type(T_OR);
    push_type(T_FUNCTION);

    /* Allocate a function id for the generator. */
    ref_push_string(identifier);
    push_constant_text("\0generator");
    f_add(2);

    Pike_compiler->compiler_frame->generator_fun =
      define_function(Pike_sp[-1].u.string,
                      peek_type_stack(),
                      ID_INLINE|ID_PROTECTED|ID_PRIVATE|ID_USED,
                      IDENTIFIER_PIKE_FUNCTION|IDENTIFIER_SCOPED,
                      NULL,
                      0);

    pop_stack();

    if (Pike_compiler->compiler_frame->generator_is_async) {
      /* An async function returns a Concurrent.Future(<X>).
       */
      compiler_discard_type();
      push_finished_type(Pike_compiler->compiler_frame->current_return_type);
      push_concurrent_future_wrapper();
    }

    /* NB: lambdas call this function twice in the last pass.
     *     Do not add the variables below twice.
     */
    if (Pike_compiler->compiler_frame->generator_local < 0) {
      /* Entry point variable. */
      add_ref(int_type_string);
      MAKE_CONST_STRING(name, "__generator_entry_point__");
      Pike_compiler->compiler_frame->generator_local =
        add_local_name(name, int_type_string, 0);

      /* Stack contents to restore. */
      add_ref(array_type_string);
      MAKE_CONST_STRING(name, "__generator_stack__");
      add_local_name(name, array_type_string, 0);

      /* Resumption argument. */
      add_ref(mixed_type_string);
      MAKE_CONST_STRING(name, "__generator_argument__");
      add_local_name(name, mixed_type_string, 0);

      /* Resumption callback. */
      add_ref(function_type_string);
      MAKE_CONST_STRING(name, "__generator_callback__");
      add_local_name(name, function_type_string, 0);

      if (Pike_compiler->compiler_frame->generator_is_async) {
        /* Result promise. */
        /* NB: object(Concurrent.Promise)(<X>) */
        add_ref(peek_type_stack());
        MAKE_CONST_STRING(name, "__async_promise__");
        add_local_name(name, peek_type_stack(), 0);
        num_state_vars++;
      }

      /* All of the above and the arguments are scoped. */
      for (e = 0;
           e < Pike_compiler->compiler_frame->generator_local + num_state_vars;
           e++) {
        /* Force local #e to be scoped. */
        node *n = mklocalnode(e, -1);
        if (e >= Pike_compiler->compiler_frame->generator_local) {
          /* Mark all generator locals as used. */
          mark_lvalue_as_used(n);
        }
        free_node(n);
      }
    }

    Pike_compiler->current_annotations = save_annotations;
  } else {
    push_finished_type(Pike_compiler->compiler_frame->current_return_type);
  }

  if (num_create_args && (Pike_compiler->num_create_args < 0) && num_args) {
    /* Do not allow further arguments if __create__() is varargs.
     *
     * NB: No need to complain that num_args != 0, as this should already
     *     have triggered a complaint when the corresponding variable
     *     was declared due to varargs being set.
     */
    num_args = 0;
  }
  e = num_create_args + num_args - 1;
  if(Pike_compiler->compiler_frame->varargs) {
    /* NB: This is set when either __create__() or create() has varargs. */
    struct local_name *var;
    ee = Pike_compiler->compiler_frame->local_variables[e] - 1;
    var = Pike_compiler->compiler_frame->local_names + ee;
    push_finished_type(var->def->type);
    e--;
    if (var->def->type->type != T_ARRAY) {
      yywarning("Varargs variable is not an array!! (Internal error)");
    } else {
      if (pop_type_stack(T_ARRAY)) {
        compiler_discard_top_type();
      }
    }
  } else {
    push_type(T_VOID);
  }
  push_type(T_MANY);
  for(; e >= num_create_args; e--) {
    struct local_name *var;
    ee = Pike_compiler->compiler_frame->local_variables[e] - 1;
    var = Pike_compiler->compiler_frame->local_names + ee;
    push_finished_type(var->def->type);
    if (var->init && (var->def->token == F_LOCAL)) {
      push_type(T_VOID);
      push_type(T_OR);
    }
    push_type(T_FUNCTION);
  }

  if (e >= 0) {
    /* __create__() arguments. */
    int i = FIND_LFUN(Pike_compiler->new_program, LFUN___CREATE__);
    struct identifier *id = ID_FROM_INT(Pike_compiler->new_program, i);
    struct pike_type *t = id->type;
    struct pike_type *trailer = compiler_pop_type();

    while (t && (t->type == T_FUNCTION)) {
      push_finished_type(t->car);
      t = t->cdr;
    }

    push_finished_type(trailer);
    free_type(trailer);

    t = id->type;

    while (t && (t->type == T_FUNCTION)) {
      push_reverse_type(T_FUNCTION);
      t = t->cdr;
    }
  }

  if (Pike_compiler->current_attributes) {
    node *n = Pike_compiler->current_attributes;
    while (n) {
      push_type_attribute(CDR(n)->u.sval.u.string);
      n = CAR(n);
    }
  }

  type = compiler_pop_type();
  /***/

#ifdef LAMBDA_DEBUG
  fprintf(stderr, "%d: LAMBDA: %s 0x%08lx 0x%08lx\n",
          Pike_compiler->compiler_pass, identifier->str,
          (long)Pike_compiler->new_program->id,
          Pike_compiler->local_class_counter-1);
#endif /* LAMBDA_DEBUG */

  if(Pike_compiler->compiler_pass != COMPILER_PASS_FIRST) {
    id = isidentifier(identifier);

    if (id < 0) {
      my_yyerror("Identifier %pS lost after first pass.", identifier);
    }
  }

  id = define_function(identifier,
                       type,
                       modifiers,
                       IDENTIFIER_PIKE_FUNCTION |
                       (Pike_compiler->compiler_frame->varargs?IDENTIFIER_VARARGS:0),
                       0,
                       opt_flags);

  Pike_compiler->compiler_frame->current_function_number=id;
  free_type(type);

  return id;
}

static void add_parent_local_function(struct pike_string *identifier, int id)
{
  struct identifier *i = ID_FROM_INT(Pike_compiler->new_program, id);
  node *n = NULL;

  if(i->identifier_flags & IDENTIFIER_SCOPED)
    n = mktrampolinenode(id, Pike_compiler->compiler_frame->previous);
  else
    n = mkidentifiernode(id);

  low_add_local_name(Pike_compiler->compiler_frame->previous,
                     identifier, NULL, n, NULL);
}

static int compiler_define_function(int modifiers,
                                    struct pike_string *identifier,
                                    struct pike_type *fun_type,
                                    node *block,
                                    int num_args, int num_create_args,
                                    int opt_flags)
{
  int e;
  if(block)
  {
    int f;
    node *check_args = NULL;
    struct compilation *c = THIS_COMPILATION;
    struct pike_string *save_file = c->lex.current_file;
    int save_line  = c->lex.current_line;
    int num_required_args = 0;
    struct identifier *i;
    c->lex.current_file = block->current_file;
    c->lex.current_line = block->line_number;

    if ((modifiers & ID_EXTERN) &&
        (Pike_compiler->compiler_pass == COMPILER_PASS_FIRST)) {
      yywarning("Extern declared function definition.");
    }

    if (Pike_compiler->compiler_frame->generator_fun != -1) {
      struct pike_type *generator_type;
      struct pike_string *name;
      int generator_stack_local;

      /* Generate the inner (ie restartable) function first. */

      name = ID_FROM_INT(Pike_compiler->new_program,
                         Pike_compiler->compiler_frame->generator_fun)->name;
      ref_push_string(name);

      generator_stack_local =
        Pike_compiler->compiler_frame->generator_local + 1;

      if (Pike_compiler->compiler_frame->generator_is_async) {
        /* The inner function of an async function always returns void. */
        push_type(T_VOID);

        /*
         * {
         *   __async_promise__->failure(catch {
         *       block;
         *     });
         *   return;
         * }
         *
         * Note that the block always has an F_RETURN at the end.
         *
         * Note also that the F_RETURN has a NULL value-expression
         * to avoid the implicit call of __async_promise__->success()
         * that docode adds.
         */
        block =
          mknode(F_COMMA_EXPR,
                 mkapplynode(mkarrownode(mklocalnode(generator_stack_local + 3, 0),
                                         "failure"),
                             mknode(F_ARG_LIST,
                                    mknode(F_CATCH, block, NULL),
                                    NULL)),
                 mknode(F_RETURN, NULL, NULL));
      } else if (Pike_compiler->compiler_pass == COMPILER_PASS_LAST &&
                 Pike_compiler->compiler_frame->current_return_type->type == PIKE_T_AUTO) {
        /* Change "auto" return type to actual return type. */
        push_finished_type(Pike_compiler->compiler_frame->current_return_type->car);
      } else {
        push_finished_type(Pike_compiler->compiler_frame->current_return_type);
      }

      /* Adjust the type to be a function that returns
       * a function(mixed|void, function(mixed...:void)|void:X).
       *
       * This is the type for the inner (restartable) function.
       */
      push_type(T_VOID);
      push_type(T_MANY);

      push_type(T_VOID);
      push_type(T_VOID);
      push_type(T_VOID);
      push_type(T_MIXED);
      push_type(T_OR);
      push_type(T_MANY);
      push_type(T_OR);
      push_type(T_FUNCTION);

      push_type(T_VOID);
      push_type(T_MIXED);
      push_type(T_OR);
      push_type(T_FUNCTION);

      generator_type = compiler_pop_type();
      f = dooptcode(Pike_sp[-1].u.string, block, generator_type,
                    ID_INLINE|ID_PROTECTED|ID_PRIVATE|ID_USED);
      pop_stack();

      /* Now it is time for the outer function. */
      Pike_compiler->compiler_frame->generator_local = -1;
      Pike_compiler->compiler_frame->generator_is_async = 0;
      /* Set the return type for the outer function. */
      free_type(Pike_compiler->compiler_frame->current_return_type);
      if (modifiers & ID_ASYNC) {
        free_type(generator_type);
        type_stack_mark();
        push_finished_type(Pike_compiler->compiler_frame->current_return_type);
        push_concurrent_future_wrapper();
        Pike_compiler->compiler_frame->current_return_type =
          pop_unfinished_type();
      } else {
        Pike_compiler->compiler_frame->current_return_type = generator_type;
      }
      if (modifiers & ID_ASYNC) {
        /*
         * {
         *   __generator_stack__ = aggregate();
         *   __async_promise__ = Concurrent.Promise(<T>)();
         *   mkgenerator(f)();
         *   return __async_promise__->future();
         * }
         */
        block = mknestednodes(F_COMMA_EXPR,
                              mknode(F_ASSIGN,
                                     mklocalnode(generator_stack_local, 0),
                                     mkefuncallnode("aggregate", NULL)),
                              mknode(F_ASSIGN,
                                     mklocalnode(generator_stack_local + 3, 0),
                                     mkapplynode(resolve_identifier(Concurrent_Promise_string),
                                                 mknode(F_ARG_LIST, NULL, NULL))),
                              mkapplynode(mkgeneratornode(f),
                                          mknode(F_ARG_LIST, NULL, NULL)),
                              mknode(F_RETURN,
                                     mkapplynode(mkarrownode(mklocalnode(generator_stack_local + 3, 0),
                                                             "future"),
                                                 mknode(F_ARG_LIST, NULL, NULL)),
                                     mkintnode(0)),
                              NULL);
      } else {
        /*
         * {
         *   __generator_stack__ = aggregate();
         *   return mkgenerator(f);
         * }
         */
        block = mknode(F_COMMA_EXPR,
                       mknode(F_ASSIGN, mklocalnode(generator_stack_local, 0),
                              mkefuncallnode("aggregate", NULL)),
                       mknode(F_RETURN, mkgeneratornode(f), NULL));
      }
    }

    for(e = num_create_args; e < num_create_args + num_args; e++)
    {
      int ee = Pike_compiler->compiler_frame->local_variables[e] - 1;
      struct local_name *var;
      var = Pike_compiler->compiler_frame->local_names + ee;
      if((!var->name || !var->name->len) &&
         !TEST_COMPAT(8, 0) &&
         (var->def->token == F_LOCAL) &&
         (!Pike_compiler->compiler_frame->varargs ||
          ((e+1) != num_create_args + num_args))) {
        /* Allow ending with ignored varargs.
         *
         * lambda(int a, int b, mixed ...) {...}
         *
         * NB: In Pike 8.0 and earlier lambdas and local functions
         *     did not require names for parameters.
         */
        my_yyerror("Missing name for argument %d.", e - num_create_args);
      } else {
        check_args = mknode(F_COMMA_EXPR, check_args, set_default_value(ee));

        if (Pike_compiler->compiler_pass == COMPILER_PASS_LAST) {
          /* FIXME: Should probably use some other flag. */
          if ((runtime_options & RUNTIME_CHECK_TYPES) &&
              (var->def->type != mixed_type_string)) {
            node *local_node;

            /* fprintf(stderr, "Creating soft cast node for local #%d\n", e);*/

            local_node = mkcastnode(mixed_type_string, mklocalnode(ee, 0));

            /* NOTE: The cast to mixed above is needed to avoid generating
             *       compilation errors, as well as avoiding optimizations
             *       in mksoftcastnode().
             */
            check_args =
              mknode(F_COMMA_EXPR, check_args,
                     mksoftcastnode(var->def->type, local_node));
          }
        }
      }
    }

    if (num_create_args) {
      /* Generate code that calls __create__(). */
      node *args = NULL;
      int ee;
      e = num_create_args;
      if (Pike_compiler->compiler_frame->varargs) {
        e--;
        ee = Pike_compiler->compiler_frame->local_variables[e] - 1;
        args = mknode(F_PUSH_ARRAY,
                      mklocalnode(ee, 0),
                      NULL);
      }
      while (e--) {
        ee = Pike_compiler->compiler_frame->local_variables[e] - 1;
        args = mknode(F_ARG_LIST, mklocalnode(ee, 0), args);
      }

      e = FIND_LFUN(Pike_compiler->new_program, LFUN___CREATE__);
      check_args =
        mknode(F_COMMA_EXPR,
               mknode(F_POP_VALUE,
                      mknode(F_APPLY,
                             mkidentifiernode(e),
                             args),
                      NULL),
               check_args);
    }

    {
      int l = block->line_number;
      struct pike_string *f = block->current_file;
      if (check_args) {
        /* Prepend the arg checking code. */
        block = mknode(F_COMMA_EXPR, mknode(F_POP_VALUE, check_args, NULL),
                       block);
      }
      c->lex.current_line = l;
      c->lex.current_file = f;
    }

    f = dooptcode(identifier, block, fun_type, modifiers);

    i = ID_FROM_INT(Pike_compiler->new_program, f);
    i->opt_flags = Pike_compiler->compiler_frame->opt_flags;

    /* FIXME: Is the following valid for generator and async functions? */
    if (Pike_compiler->compiler_pass == COMPILER_PASS_LAST &&
        Pike_compiler->compiler_frame->current_return_type->type == PIKE_T_AUTO)
    {
      /* Change "auto" return type to actual return type. */
      int ee;
      push_finished_type(Pike_compiler->compiler_frame->current_return_type->car);

      e = num_create_args + num_args - 1;
      if(Pike_compiler->compiler_frame->varargs &&
         (!num_create_args || (Pike_compiler->num_create_args >= 0)))
      {
        struct local_name *var;
        ee = Pike_compiler->compiler_frame->local_variables[e] - 1;
        var = Pike_compiler->compiler_frame->local_names + ee;
        push_finished_type(var->def->type);
        e--;
        if (pop_type_stack(T_ARRAY)) {
          compiler_discard_top_type();
        }
      }else{
        push_type(T_VOID);
      }
      push_type(T_MANY);
      for(; e>=0; e--)
      {
        struct local_name *var;
        ee = Pike_compiler->compiler_frame->local_variables[e] - 1;
        var = Pike_compiler->compiler_frame->local_names + ee;
        push_finished_type(var->def->type);
        if (var->init && (var->def->token == F_LOCAL)) {
          push_type(T_VOID);
          push_type(T_OR);
        }
        push_type(T_FUNCTION);
      }

      if (Pike_compiler->current_attributes)
      {
        node *n = Pike_compiler->current_attributes;
        while (n) {
          push_type_attribute(CDR(n)->u.sval.u.string);
          n = CAR(n);
        }
      }

      free_type( i->type );
      i->type = compiler_pop_type();
    }

#ifdef PIKE_DEBUG
    if(Pike_interpreter.recoveries &&
       ((Pike_sp - Pike_interpreter.evaluator_stack) <
        Pike_interpreter.recoveries->stack_pointer))
      Pike_fatal("Stack error (underflow)\n");

    if((Pike_compiler->compiler_pass == COMPILER_PASS_FIRST) &&
       (f != Pike_compiler->compiler_frame->current_function_number)) {
      pike_fprintf(stderr,
                   "define_function()/do_opt_code() failed for symbol %pq\n",
                   identifier);
      dump_program_desc(Pike_compiler->new_program);
      Pike_fatal("define_function screwed up! %d != %d\n",
                 f, Pike_compiler->compiler_frame->current_function_number);
    }
#endif

    c->lex.current_line = save_line;
    c->lex.current_file = save_file;

    return f;
  } else {
    /* Prototype; don't warn about unused arguments. */
    int ee;
    for (e = Pike_compiler->compiler_frame->current_number_of_locals; e--;) {
      ee = Pike_compiler->compiler_frame->local_variables[e] - 1;
      Pike_compiler->compiler_frame->local_names[ee].flags |= LOCAL_VAR_IS_USED;
    }
    if( Pike_compiler->compiler_frame->current_return_type->type == PIKE_T_AUTO )
      yyerror("'auto' return type not allowed for prototypes.");
    if (Pike_compiler->compiler_pass == COMPILER_PASS_FIRST) {
      for(e=0; e < num_create_args + num_args; e++)
      {
        node *init;
        ee = Pike_compiler->compiler_frame->local_variables[e] - 1;
        init = Pike_compiler->compiler_frame->local_names[ee].init;
        if (init) {
          low_yyreport(REPORT_WARNING, init->current_file, init->line_number,
                       parser_system_string, 0,
                       "Argument default values are not supported in prototypes.");
        }
      }
    }
  }

  return -1;
}

struct pike_string *get_new_name(struct pike_string *prefix)
{
  char buf[40];
  /* Generate a name for a global symbol... */
  sprintf(buf,"__lambda_%ld_%ld_line_%d",
	  (long)Pike_compiler->new_program->id,
	  (long)(Pike_compiler->local_class_counter++ & 0xffffffff), /* OSF/1 cc bug. */
	  (int) THIS_COMPILATION->lex.current_line);
  if (prefix) {
    struct string_builder sb;
    init_string_builder_alloc(&sb, prefix->len + strlen(buf) + 1,
			      prefix->size_shift);
    string_builder_shared_strcat(&sb, prefix);
    string_builder_putchar(&sb, 0);
    string_builder_strcat(&sb, buf);
    return finish_string_builder(&sb);
  }
  return make_shared_string(buf);
}


static int low_islocal(struct compiler_frame *f,
		       struct pike_string *str)
{
  int e;
  for(e=f->current_number_of_locals-1;e>=0;e--)
    if(f->local_names[e].name==str) {
      f->local_names[e].flags |= LOCAL_VAR_IS_USED;
      return e;
    }
  return -1;
}

int low_bind_local(struct compiler_frame *frame, node *n)
{
  int local_no;
  if (!frame) {
    frame = Pike_compiler->compiler_frame;
  }
  if (!n || (n->token != F_LOCAL_INDIRECT)) {
    if (n && (n->token == F_LOCAL) && (n->u.integer.b <= 0)) {
      return n->u.integer.a;
    }
    return -1;
  }

  local_no = n->u.integer.a;

  n->token = F_LOCAL;
  do {
    if ((n->u.integer.a = frame->next_local_offset++) >= MAX_LOCAL) {
      yyerror("Too many local variables.");
      n->u.integer.a = -1;
      return -1;
    }
  } while (frame->local_variables[n->u.integer.a]);
  frame->local_variables[n->u.integer.a] = local_no + 1;

  if (frame->next_local_offset > frame->max_number_of_locals) {
    frame->max_number_of_locals = frame->next_local_offset;
  }

  if (frame->generator_local != -1) {
    /* For generators all locals need to be scoped.
     *
     * NB: We do not need to mess with the frame flags,
     *     as that has already been done when
     *     generator_local was set.
     */
    n->u.integer.b = -1;
    frame->local_names[local_no].flags |= LOCAL_VAR_USED_IN_SCOPE;
    frame->local_shared[n->u.integer.a>>4] |= 1 << (n->u.integer.a & 0xf);
    if (frame->min_number_of_locals <= n->u.integer.a) {
      frame->min_number_of_locals = n->u.integer.a + 1;
    }
  }

  return n->u.integer.a;
}

int bind_local(struct compiler_frame *frame, int local_no)
{
  node *n;
  if (!frame) {
    frame = Pike_compiler->compiler_frame;
  }
  n = frame->local_names[local_no].def;
#ifdef PIKE_DEBUG
  if (!n) Pike_fatal("No def for local #%d!\n", local_no);
#endif
  return low_bind_local(frame, n);
}

void release_local(struct compiler_frame *frame, int var)
{
  if (!frame) {
    frame = Pike_compiler->compiler_frame;
  }
  frame->local_variables[var] = 0;
  if (frame->next_local_offset > var) {
    frame->next_local_offset = var;
  }
}

/* Add a local variable to the current function in frame.
 * NOTE: Steals a reference to each of type, def and init, but not to str.
 *
 * NB: type MUST be NULL if def is not NULL.
 */
int low_add_local_name(struct compiler_frame *frame,
		       struct pike_string *str,
		       struct pike_type *type,
		       node *def,
		       node *init)
{
  int var;

  if (!frame) {
    frame = Pike_compiler->compiler_frame;
  }

  if (str->len) {
    int tmp=low_islocal(frame,str);
    if(tmp>=0 && tmp >= frame->last_block_level)
    {
      struct local_name *l = frame->local_names + tmp;
      if (l->def) {
        my_yyerror("Duplicate local identifier %pS, "
                   "previous declaration on line %ld.",
                   str, (long)l->def->line_number);
      } else {
        my_yyerror("Duplicate local identifier %pS.", str);
      }
    }

    if(type == void_type_string)
    {
      my_yyerror("Local variable %pS is void.", str);
    }
  }

  debug_malloc_touch(def);
  debug_malloc_touch(init);
  debug_malloc_touch(type);
  debug_malloc_touch(str);
  /* NOTE: The number of locals can be 0..255 (not 256), due to
   *       the use of READ_INCR_BYTE() in apply_low.h.
   */
  do {
    var = frame->current_number_of_locals;

    if (var >= MAX_LOCAL-1)
    {
      my_yyerror("Too many local variables: no space for local variable %pS.",
                 str);
      free_type(type);
      if (def) free_node(def);
      if (init) free_node(init);
      return -1;
    }

    frame->current_number_of_locals++;
  } while (frame->local_names[var].def);

  if (var >= frame->max_number_of_locals) {
    frame->max_number_of_locals = var + 1;
  }

  if (type && pike_types_le(type, void_type_string, 0, 0)) {
    if (Pike_compiler->compiler_pass == COMPILER_PASS_LAST) {
      yywarning("Declaring local variable %pS with type void "
                "(converted to type zero).", str);
    }
  }

  frame->local_names[var].name = str;
  reference_shared_string(str);
  if (def) {
    frame->local_names[var].def = def;
#ifdef PIKE_DEBUG
    if (type) {
      Pike_fatal("Type specified for local alias!\n");
    }
#endif
  } else {
    frame->local_names[var].def = def = internal_mklocalnode(frame, var);
#ifdef PIKE_DEBUG
    if (frame->local_names[var].def->type) {
      Pike_fatal("Internal local already has a type!\n");
    }
#endif
    def->type = type;
  }
  set_node_name(def, str);
  if (type && (type->type == PIKE_T_AUTO)) {
    frame->local_names[var].def->node_info |= OPT_TYPE_NOT_FIXED;
  }
  frame->local_names[var].init = init;

  if (frame->generator_local != -1) {
    frame->local_names[var].flags = LOCAL_VAR_IS_USED | LOCAL_VAR_USED_IN_SCOPE;
  } else if (pike_types_le(void_type_string, type, 0, 0)) {
    /* Don't warn about unused voidable variables. */
    frame->local_names[var].flags = LOCAL_VAR_IS_USED;
  } else {
    frame->local_names[var].flags = 0;
  }

  return var;
}


/* argument must be a shared string */
/* Note that this function eats a reference to 'type' */
/* If init is nonzero, it also eats a ref to init */
int add_local_name(struct pike_string *str,
		   struct pike_type *type,
		   node *init)
{
  return low_add_local_name(NULL, str, type, NULL, init);
}

/* Note that this function eats a reference each to 'def' and 'init'. */
static void redefine_local(struct compiler_frame *frame, int var,
                           node *def, node *init)
{
  if (!frame) {
    frame = Pike_compiler->compiler_frame;
  }
#ifdef PIKE_DEBUG
  if ((var < 0) || (var >= frame->current_number_of_locals)) {
    Pike_fatal("No such local: $%d.\n", var);
  }
#endif
  if (def) {
    free_node(frame->local_names[var].def);
    frame->local_names[var].def = def;
  }
  if (init) {
    if (frame->local_names[var].init) {
      free_node(frame->local_names[var].init);
    }
    frame->local_names[var].init = init;
  }
}

/* Mark local variable as used. */
static void mark_lvalue_as_used(node *n)
{
  while (n) {
    switch(n->token) {
    case F_CLEAR_LOCAL:
      n = CAR(n);
      break;
    case F_LOCAL:
      if (n->u.integer.b <= 0) {
        int ee =
          Pike_compiler->compiler_frame->local_variables[n->u.integer.a] - 1;
        struct local_name *var =
          Pike_compiler->compiler_frame->local_names + ee;
        var->flags |= LOCAL_VAR_IS_USED;
      }
      return;
    case F_LOCAL_INDIRECT:
      Pike_compiler->compiler_frame->local_names[n->u.integer.a].flags |=
        LOCAL_VAR_IS_USED;
      return;
    case F_ARRAY_LVALUE:
      mark_lvalues_as_used(CAR(n));
      return;
    default:
      return;
    }
  }
}

/* Mark local variables declared in a multi-assign or sscanf expression
 * as used. */
static void mark_lvalues_as_used(node *n)
{
  while (n && (n->token == F_LVALUE_LIST)) {
    mark_lvalue_as_used(CAR(n));
    n = CDR(n);
  }
}

#if 0
/* Note that this function eats a reference to each of
 * 'type' and 'initializer', but not to 'name'.
 * Note also that 'initializer' may be NULL.
 */
static node *add_protected_variable(struct pike_string *name,
				    struct pike_type *type,
				    int depth,
				    node *initializer)
{
  struct compiler_frame *f = Pike_compiler->compiler_frame;
  int i;
  int id;
  node *n = NULL;

  if (initializer) {
    /* FIXME: We need to pop levels off local and external variables here. */
  }

  for(i = depth; f && i; i--) {
    f->lexical_scope |= SCOPE_SCOPED;
    f = f->previous;
  }
  if (!f) {
    int parent_depth = i;
    struct program_state *p = Pike_compiler;
    struct pike_string *tmp_name;
    while (i--) {
      if (!p->previous) {
	my_yyerror("Too many levels of protected (%d, max:%d).",
		   depth, depth - (i+1));
	parent_depth -= i+1;
	break;
      }
      p->new_program->flags |= PROGRAM_USES_PARENT;
      p = p->previous;
    }

    tmp_name = get_new_name(name);
    id = define_parent_variable(p, tmp_name, type,
				ID_PROTECTED|ID_PRIVATE|ID_INLINE);
    free_string(tmp_name);
    if (id >= 0) {
      if (def) {
	p->init_node =
	  mknode(F_COMMA_EXPR, Pike_compiler->init_node,
		 mkcastnode(void_type_string,
			    mknode(F_ASSIGN,
				   mkidentifiernode(id), initializer)));
	initializer = NULL;
      }
      n = mkexternalnode(id, parent_depth);
    }
  } else if (depth) {
    f->lexical_scope|=SCOPE_SCOPE_USED;
    tmp_name = get_new_name(name);
    id = low_add_local_name(f, tmp_name, type, NULL, NULL);
    free_string(tmp_name);
    if(f->min_number_of_locals < id+1)
      f->min_number_of_locals = id+1;
    if (initializer) {
      /* FIXME! */
      yyerror("Initializers not yet supported for protected variables with function scope.");
    }
    n = mklocalnode(id, depth);
  }
  id = low_add_local_name(NULL, name, type, n, NULL);
  if (id >= 0) {
    if (initializer) {
      return mknode(F_ASSIGN, mklocalnode(id,0), initializer);
    }
    return mklocalnode(id, 0);
  }
  if (initializer) {
    free_node(initializer);
  }
  return NULL;
}
#endif /* 0 */

int islocal(struct pike_string *str)
{
  return low_islocal(Pike_compiler->compiler_frame, str);
}

/* argument must be a shared string */
static node *lexical_islocal(struct pike_string *str)
{
  int e,depth=0;
  struct compiler_frame *f=Pike_compiler->compiler_frame;

  while(1)
  {
    for(e=f->current_number_of_locals-1;e>=0;e--)
    {
      if(f->local_names[e].name==str)
      {
        node *n;
	f->local_names[e].flags |= LOCAL_VAR_IS_USED;

        n = mklocalnode(e, depth);

        return n;
      }
    }
    if(!(f->lexical_scope & SCOPE_LOCAL)) return 0;
    depth++;
    f=f->previous;
  }
}

static node *safe_inc_enum(node *n)
{
  JMP_BUF recovery;
  node *ret;
  STACK_LEVEL_START(0);

  if (SETJMP(recovery)) {
    handle_compile_exception ("Bad implicit enum value (failed to add 1).");
    push_int(0);
  } else {
    if (n->token != F_CONSTANT) Pike_fatal("Bad node to safe_inc_enum().\n");
    push_svalue(&n->u.sval);
    push_int(1);
    f_add(2);
  }
  UNSETJMP(recovery);
  STACK_LEVEL_DONE(1);
  free_node(n);
  ret = mkconstantsvaluenode(Pike_sp-1);
  pop_stack();
  return ret;
}

static void safe_index(void)
{
  JMP_BUF tmp;
  STACK_LEVEL_START(2);
  if (SETJMP_SP(tmp, 2)) {
    push_undefined();
  } else {
    f_index(2);
  }
  STACK_LEVEL_DONE(1);
  UNSETJMP(tmp);
}

static node *find_versioned_identifier(struct pike_string *identifier,
				       int major, int minor)
{
  struct compilation *c = THIS_COMPILATION;
  int old_major = Pike_compiler->compat_major;
  int old_minor = Pike_compiler->compat_minor;
  struct svalue *efun = NULL;
  node *res;

  change_compiler_compatibility(major, minor);

  if(Pike_compiler->last_identifier)
    free_string(Pike_compiler->last_identifier);
  copy_shared_string(Pike_compiler->last_identifier, identifier);

  /* Check predef:: first, and then the modules. */

  res = NULL;
  if (TYPEOF(c->default_module) == T_MAPPING) {
    if ((efun = low_mapping_string_lookup(c->default_module.u.mapping,
					  identifier)))
      res = mkconstantsvaluenode(efun);
  }
  else if (TYPEOF(c->default_module) != T_INT) {
    push_svalue(&c->default_module);
    ref_push_string(identifier);
    safe_index();
    if (!IS_UNDEFINED(Pike_sp - 1))
      res = mkconstantsvaluenode(Pike_sp - 1);
    pop_stack();
  }

  if (!res && !(res = resolve_identifier(identifier))) {
    if((Pike_compiler->flags & COMPILATION_FORCE_RESOLVE) ||
       (Pike_compiler->compiler_pass == COMPILER_PASS_LAST)) {
      my_yyerror("Undefined identifier %d.%d::%pS.",
		 major, minor, identifier);
    }else{
      res = mknode(F_UNDEFINED, 0, 0);
    }
  }

  if (res) {
    push_int(major);
    push_text(".");
    push_int(minor);
    push_text("::");
    ref_push_string(identifier);
    f_add(5);
    set_node_name(res, Pike_sp[-1].u.string);
    pop_stack();
  }

  change_compiler_compatibility(old_major, old_minor);

  return res;
}

static node *set_default_value(int e)
{
  node *init = Pike_compiler->compiler_frame->local_names[e].init;
  struct pike_type *type = Pike_compiler->compiler_frame->local_names[e].def->type;
  struct pike_string *name = Pike_compiler->compiler_frame->local_names[e].name;

  if (!init) return NULL;

  add_ref(init);

  if (Pike_compiler->compiler_frame->local_names[e].def->token != F_LOCAL) {
    /* Unconditional initializer.
     *
     * NB: No need to check for F_LOCAL_INDIRECT, as this code is
     *     currently only run for function arguments, ad they are
     *     always bound.
     *
     * $e = init;
     */
    return mknode(F_POP_VALUE,
                  mknode(F_ASSIGN,
                         mklocalnode(e, 0),
                         init), NULL);
  }

  if (type->flags & PT_FLAG_VOIDABLE) {
    if (Pike_compiler->compiler_pass == COMPILER_PASS_LAST) {
      yytype_report(REPORT_WARNING,
                    NULL, 0, NULL,
                    NULL, 0, type,
                    0, "Extraneous void in type for variable with default %pS.",
                    name);
    }
  }

  if (type->flags & PT_FLAG_NULLABLE) {
    /* if (undefinedp($e)) { $e = init; } */
    return mknode(F_POP_VALUE,
		  mknode(F_LAND,
			 mkefuncallnode("undefinedp",
					mklocalnode(e, 0)),
			 mknode(F_ASSIGN,
				mklocalnode(e, 0),
				init)), NULL);
  }

  /* if (!$e) { $e = init; } */
  return mknode(F_POP_VALUE,
		mknode(F_LOR,
		       mklocalnode(e, 0),
		       mknode(F_ASSIGN,
			      mklocalnode(e, 0),
			      init)), NULL);
}

static int call_handle_import(void)
{
  if (safe_apply_low2(Pike_fp->current_object,
                      PC_HANDLE_IMPORT_FUN_NUM
                      + Pike_fp->context->identifier_level, 1, NULL)) {
    if ((1 << TYPEOF(Pike_sp[-1])) &
	(BIT_MAPPING|BIT_OBJECT|BIT_PROGRAM|BIT_ZERO)) {
      if (SAFE_IS_ZERO(Pike_sp - 1)) {
	pop_stack();
	push_int(0);
      }
      if (TYPEOF(Pike_sp[-1]) != T_INT) return 1;

      pop_stack();
      my_yyerror("Couldn't find module to import.");
      return 0;
    }
    my_yyerror("Invalid return value from handle_import: %pO", Pike_sp-1);
    pop_stack();
    return 0;
  }
  handle_compile_exception ("Error finding module to import");
  pop_stack();

  return 0;
}

/* Set compiler_frame->current_type from the type stack. */
static void update_current_type(void)
{
  if (TEST_COMPAT(8,0)) {
    struct pike_type *t = peek_type_stack();
    if (!t || (t->type != PIKE_T_AUTO)) {
      /* Implicit zero */
      push_type(PIKE_T_ZERO);
      push_type(T_OR);
    }
  }
  if(Pike_compiler->compiler_frame->current_type)
    free_type(Pike_compiler->compiler_frame->current_type);
  Pike_compiler->compiler_frame->current_type = compiler_pop_type();
}
