/* Haiku/BeOS error codes and error base offsets. */
#ifdef B_ALREADY_RUNNING
ADD_ERRNO(B_ALREADY_RUNNING, "B_ALREADY_RUNNING", "Already running")
#endif /* B_ALREADY_RUNNING */
#ifdef B_AMBIGUOUS_APP_LAUNCH
ADD_ERRNO(B_AMBIGUOUS_APP_LAUNCH, "B_AMBIGUOUS_APP_LAUNCH", "Ambiguous app launch")
#endif /* B_AMBIGUOUS_APP_LAUNCH */
#ifdef B_APP_ERROR_BASE
ADD_ERRNO(B_APP_ERROR_BASE, "B_APP_ERROR_BASE", "")
#endif /* B_APP_ERROR_BASE */
#ifdef B_BAD_ADDRESS
ADD_ERRNO(B_BAD_ADDRESS, "B_BAD_ADDRESS", "Bad address")
#endif /* B_BAD_ADDRESS */
#ifdef B_BAD_DATA
ADD_ERRNO(B_BAD_DATA, "B_BAD_DATA", "Bad data")
#endif /* B_BAD_DATA */
#ifdef B_BAD_HANDLER
ADD_ERRNO(B_BAD_HANDLER, "B_BAD_HANDLER", "Bad handler")
#endif /* B_BAD_HANDLER */
#ifdef B_BAD_IMAGE_ID
ADD_ERRNO(B_BAD_IMAGE_ID, "B_BAD_IMAGE_ID", "Bad image ID")
#endif /* B_BAD_IMAGE_ID */
#ifdef B_BAD_INDEX
ADD_ERRNO(B_BAD_INDEX, "B_BAD_INDEX", "Index not in range for the data set")
#endif /* B_BAD_INDEX */
#ifdef B_BAD_MIME_SNIFFER_RULE
ADD_ERRNO(B_BAD_MIME_SNIFFER_RULE, "B_BAD_MIME_SNIFFER_RULE", "Bad sniffer rule")
#endif /* B_BAD_MIME_SNIFFER_RULE */
#ifdef B_BAD_PORT_ID
ADD_ERRNO(B_BAD_PORT_ID, "B_BAD_PORT_ID", "Bad port ID")
#endif /* B_BAD_PORT_ID */
#ifdef B_BAD_REPLY
ADD_ERRNO(B_BAD_REPLY, "B_BAD_REPLY", "Invalid or unwanted reply")
#endif /* B_BAD_REPLY */
#ifdef B_BAD_SCRIPT_SYNTAX
ADD_ERRNO(B_BAD_SCRIPT_SYNTAX, "B_BAD_SCRIPT_SYNTAX", "Bad script syntax")
#endif /* B_BAD_SCRIPT_SYNTAX */
#ifdef B_BAD_SEM_ID
ADD_ERRNO(B_BAD_SEM_ID, "B_BAD_SEM_ID", "Bad semaphore ID")
#endif /* B_BAD_SEM_ID */
#ifdef B_BAD_SUBSCRIBER
ADD_ERRNO(B_BAD_SUBSCRIBER, "B_BAD_SUBSCRIBER", "Bad subscriber")
#endif /* B_BAD_SUBSCRIBER */
#ifdef B_BAD_TEAM_ID
ADD_ERRNO(B_BAD_TEAM_ID, "B_BAD_TEAM_ID", "Operation on invalid team")
#endif /* B_BAD_TEAM_ID */
#ifdef B_BAD_THREAD_ID
ADD_ERRNO(B_BAD_THREAD_ID, "B_BAD_THREAD_ID", "Bad thread ID")
#endif /* B_BAD_THREAD_ID */
#ifdef B_BAD_THREAD_STATE
ADD_ERRNO(B_BAD_THREAD_STATE, "B_BAD_THREAD_STATE", "Thread is in inappropriate state")
#endif /* B_BAD_THREAD_STATE */
#ifdef B_BAD_TYPE
ADD_ERRNO(B_BAD_TYPE, "B_BAD_TYPE", "Bad argument type passed to function")
#endif /* B_BAD_TYPE */
#ifdef B_BAD_VALUE
ADD_ERRNO(B_BAD_VALUE, "B_BAD_VALUE", "Invalid argument")
#endif /* B_BAD_VALUE */
#ifdef B_BUFFER_NOT_AVAILABLE
ADD_ERRNO(B_BUFFER_NOT_AVAILABLE, "B_BUFFER_NOT_AVAILABLE", "Buffer not available")
#endif /* B_BUFFER_NOT_AVAILABLE */
#ifdef B_BUFFER_OVERFLOW
ADD_ERRNO(B_BUFFER_OVERFLOW, "B_BUFFER_OVERFLOW", "Value too large for defined type")
#endif /* B_BUFFER_OVERFLOW */
#ifdef B_BUSTED_PIPE
ADD_ERRNO(B_BUSTED_PIPE, "B_BUSTED_PIPE", "Broken pipe")
#endif /* B_BUSTED_PIPE */
#ifdef B_BUSY
ADD_ERRNO(B_BUSY, "B_BUSY", "Device/File/Resource busy")
#endif /* B_BUSY */
#ifdef B_CANCELED
ADD_ERRNO(B_CANCELED, "B_CANCELED", "Operation canceled")
#endif /* B_CANCELED */
#ifdef B_CROSS_DEVICE_LINK
ADD_ERRNO(B_CROSS_DEVICE_LINK, "B_CROSS_DEVICE_LINK", "Cross-device link")
#endif /* B_CROSS_DEVICE_LINK */
#ifdef B_DEBUGGER_ALREADY_INSTALLED
ADD_ERRNO(B_DEBUGGER_ALREADY_INSTALLED, "B_DEBUGGER_ALREADY_INSTALLED", "Debugger already installed for this team")
#endif /* B_DEBUGGER_ALREADY_INSTALLED */
#ifdef B_DEVICE_ERROR_BASE
ADD_ERRNO(B_DEVICE_ERROR_BASE, "B_DEVICE_ERROR_BASE", "")
#endif /* B_DEVICE_ERROR_BASE */
#ifdef B_DEVICE_FULL
ADD_ERRNO(B_DEVICE_FULL, "B_DEVICE_FULL", "No space left on device")
#endif /* B_DEVICE_FULL */
#ifdef B_DEVICE_NOT_FOUND
ADD_ERRNO(B_DEVICE_NOT_FOUND, "B_DEVICE_NOT_FOUND", "No such device")
#endif /* B_DEVICE_NOT_FOUND */
#ifdef B_DEV_BAD_DRIVE_NUM
ADD_ERRNO(B_DEV_BAD_DRIVE_NUM, "B_DEV_BAD_DRIVE_NUM", "Bad drive number")
#endif /* B_DEV_BAD_DRIVE_NUM */
#ifdef B_DEV_BAD_PID
ADD_ERRNO(B_DEV_BAD_PID, "B_DEV_BAD_PID", "Bad device PID")
#endif /* B_DEV_BAD_PID */
#ifdef B_DEV_CONFIGURATION_ERROR
ADD_ERRNO(B_DEV_CONFIGURATION_ERROR, "B_DEV_CONFIGURATION_ERROR", "Configuration error")
#endif /* B_DEV_CONFIGURATION_ERROR */
#ifdef B_DEV_CRC_ERROR
ADD_ERRNO(B_DEV_CRC_ERROR, "B_DEV_CRC_ERROR", "Device check-sum error")
#endif /* B_DEV_CRC_ERROR */
#ifdef B_DEV_DATA_OVERRUN
ADD_ERRNO(B_DEV_DATA_OVERRUN, "B_DEV_DATA_OVERRUN", "Device data overrun")
#endif /* B_DEV_DATA_OVERRUN */
#ifdef B_DEV_DATA_UNDERRUN
ADD_ERRNO(B_DEV_DATA_UNDERRUN, "B_DEV_DATA_UNDERRUN", "Device data underrun")
#endif /* B_DEV_DATA_UNDERRUN */
#ifdef B_DEV_DISABLED_BY_USER
ADD_ERRNO(B_DEV_DISABLED_BY_USER, "B_DEV_DISABLED_BY_USER", "Disabled by user")
#endif /* B_DEV_DISABLED_BY_USER */
#ifdef B_DEV_DOOR_OPEN
ADD_ERRNO(B_DEV_DOOR_OPEN, "B_DEV_DOOR_OPEN", "Drive door open")
#endif /* B_DEV_DOOR_OPEN */
#ifdef B_DEV_FIFO_OVERRUN
ADD_ERRNO(B_DEV_FIFO_OVERRUN, "B_DEV_FIFO_OVERRUN", "Device FIFO overrun")
#endif /* B_DEV_FIFO_OVERRUN */
#ifdef B_DEV_FIFO_UNDERRUN
ADD_ERRNO(B_DEV_FIFO_UNDERRUN, "B_DEV_FIFO_UNDERRUN", "Device FIFO underrun")
#endif /* B_DEV_FIFO_UNDERRUN */
#ifdef B_DEV_FORMAT_ERROR
ADD_ERRNO(B_DEV_FORMAT_ERROR, "B_DEV_FORMAT_ERROR", "Device format error")
#endif /* B_DEV_FORMAT_ERROR */
#ifdef B_DEV_ID_ERROR
ADD_ERRNO(B_DEV_ID_ERROR, "B_DEV_ID_ERROR", "Device ID error")
#endif /* B_DEV_ID_ERROR */
#ifdef B_DEV_INVALID_IOCTL
ADD_ERRNO(B_DEV_INVALID_IOCTL, "B_DEV_INVALID_IOCTL", "Invalid device ioctl")
#endif /* B_DEV_INVALID_IOCTL */
#ifdef B_DEV_INVALID_PIPE
ADD_ERRNO(B_DEV_INVALID_PIPE, "B_DEV_INVALID_PIPE", "Invalid device pipe")
#endif /* B_DEV_INVALID_PIPE */
#ifdef B_DEV_MEDIA_CHANGED
ADD_ERRNO(B_DEV_MEDIA_CHANGED, "B_DEV_MEDIA_CHANGED", "Device media changed")
#endif /* B_DEV_MEDIA_CHANGED */
#ifdef B_DEV_MEDIA_CHANGE_REQUESTED
ADD_ERRNO(B_DEV_MEDIA_CHANGE_REQUESTED, "B_DEV_MEDIA_CHANGE_REQUESTED", "Device media change requested")
#endif /* B_DEV_MEDIA_CHANGE_REQUESTED */
#ifdef B_DEV_MULTIPLE_ERRORS
ADD_ERRNO(B_DEV_MULTIPLE_ERRORS, "B_DEV_MULTIPLE_ERRORS", "Multiple device errors")
#endif /* B_DEV_MULTIPLE_ERRORS */
#ifdef B_DEV_NOT_READY
ADD_ERRNO(B_DEV_NOT_READY, "B_DEV_NOT_READY", "Device not ready")
#endif /* B_DEV_NOT_READY */
#ifdef B_DEV_NO_MEDIA
ADD_ERRNO(B_DEV_NO_MEDIA, "B_DEV_NO_MEDIA", "No media present")
#endif /* B_DEV_NO_MEDIA */
#ifdef B_DEV_NO_MEMORY
ADD_ERRNO(B_DEV_NO_MEMORY, "B_DEV_NO_MEMORY", "No device memory")
#endif /* B_DEV_NO_MEMORY */
#ifdef B_DEV_PENDING
ADD_ERRNO(B_DEV_PENDING, "B_DEV_PENDING", "Device pending")
#endif /* B_DEV_PENDING */
#ifdef B_DEV_READ_ERROR
ADD_ERRNO(B_DEV_READ_ERROR, "B_DEV_READ_ERROR", "Device read error")
#endif /* B_DEV_READ_ERROR */
#ifdef B_DEV_RECALIBRATE_ERROR
ADD_ERRNO(B_DEV_RECALIBRATE_ERROR, "B_DEV_RECALIBRATE_ERROR", "Device recalibrate error")
#endif /* B_DEV_RECALIBRATE_ERROR */
#ifdef B_DEV_RESOURCE_CONFLICT
ADD_ERRNO(B_DEV_RESOURCE_CONFLICT, "B_DEV_RESOURCE_CONFLICT", "Resource conflict")
#endif /* B_DEV_RESOURCE_CONFLICT */
#ifdef B_DEV_SEEK_ERROR
ADD_ERRNO(B_DEV_SEEK_ERROR, "B_DEV_SEEK_ERROR", "Device seek error")
#endif /* B_DEV_SEEK_ERROR */
#ifdef B_DEV_STALLED
ADD_ERRNO(B_DEV_STALLED, "B_DEV_STALLED", "Device stalled")
#endif /* B_DEV_STALLED */
#ifdef B_DEV_TIMEOUT
ADD_ERRNO(B_DEV_TIMEOUT, "B_DEV_TIMEOUT", "Device timeout")
#endif /* B_DEV_TIMEOUT */
#ifdef B_DEV_TOO_LATE
ADD_ERRNO(B_DEV_TOO_LATE, "B_DEV_TOO_LATE", "Device too late")
#endif /* B_DEV_TOO_LATE */
#ifdef B_DEV_UNEXPECTED_PID
ADD_ERRNO(B_DEV_UNEXPECTED_PID, "B_DEV_UNEXPECTED_PID", "Unexpected device PID")
#endif /* B_DEV_UNEXPECTED_PID */
#ifdef B_DEV_UNREADABLE
ADD_ERRNO(B_DEV_UNREADABLE, "B_DEV_UNREADABLE", "Device unreadable")
#endif /* B_DEV_UNREADABLE */
#ifdef B_DEV_WRITE_ERROR
ADD_ERRNO(B_DEV_WRITE_ERROR, "B_DEV_WRITE_ERROR", "Device write error")
#endif /* B_DEV_WRITE_ERROR */
#ifdef B_DIRECTORY_NOT_EMPTY
ADD_ERRNO(B_DIRECTORY_NOT_EMPTY, "B_DIRECTORY_NOT_EMPTY", "Directory not empty")
#endif /* B_DIRECTORY_NOT_EMPTY */
#ifdef B_DONT_DO_THAT
ADD_ERRNO(B_DONT_DO_THAT, "B_DONT_DO_THAT", "No, really don't do that")
#endif /* B_DONT_DO_THAT */
#ifdef B_DUPLICATE_REPLY
ADD_ERRNO(B_DUPLICATE_REPLY, "B_DUPLICATE_REPLY", "Duplicate reply")
#endif /* B_DUPLICATE_REPLY */
#ifdef B_ENTRY_NOT_FOUND
ADD_ERRNO(B_ENTRY_NOT_FOUND, "B_ENTRY_NOT_FOUND", "No such file or directory")
#endif /* B_ENTRY_NOT_FOUND */
#ifdef B_ERROR
ADD_ERRNO(B_ERROR, "B_ERROR", "General system error")
#endif /* B_ERROR */
#ifdef B_ERRORS_END
ADD_ERRNO(B_ERRORS_END, "B_ERRORS_END", "")
#endif /* B_ERRORS_END */
#ifdef B_FILE_ERROR
ADD_ERRNO(B_FILE_ERROR, "B_FILE_ERROR", "Bad file descriptor")
#endif /* B_FILE_ERROR */
#ifdef B_FILE_EXISTS
ADD_ERRNO(B_FILE_EXISTS, "B_FILE_EXISTS", "File or Directory already exists")
#endif /* B_FILE_EXISTS */
#ifdef B_FILE_NOT_FOUND
ADD_ERRNO(B_FILE_NOT_FOUND, "B_FILE_NOT_FOUND", "No such file or directory")
#endif /* B_FILE_NOT_FOUND */
#ifdef B_FILE_TOO_LARGE
ADD_ERRNO(B_FILE_TOO_LARGE, "B_FILE_TOO_LARGE", "File too large")
#endif /* B_FILE_TOO_LARGE */
#ifdef B_GENERAL_ERROR_BASE
ADD_ERRNO(B_GENERAL_ERROR_BASE, "B_GENERAL_ERROR_BASE", "")
#endif /* B_GENERAL_ERROR_BASE */
#ifdef B_ILLEGAL_DATA
ADD_ERRNO(B_ILLEGAL_DATA, "B_ILLEGAL_DATA", "Illegal data")
#endif /* B_ILLEGAL_DATA */
#ifdef B_INTERFACE_ERROR_BASE
ADD_ERRNO(B_INTERFACE_ERROR_BASE, "B_INTERFACE_ERROR_BASE", "")
#endif /* B_INTERFACE_ERROR_BASE */
#ifdef B_INTERRUPTED
ADD_ERRNO(B_INTERRUPTED, "B_INTERRUPTED", "Interrupted system call")
#endif /* B_INTERRUPTED */
#ifdef B_IO_ERROR
ADD_ERRNO(B_IO_ERROR, "B_IO_ERROR", "I/O error")
#endif /* B_IO_ERROR */
#ifdef B_IS_A_DIRECTORY
ADD_ERRNO(B_IS_A_DIRECTORY, "B_IS_A_DIRECTORY", "Is a directory")
#endif /* B_IS_A_DIRECTORY */
#ifdef B_LAST_BUFFER_ERROR
ADD_ERRNO(B_LAST_BUFFER_ERROR, "B_LAST_BUFFER_ERROR", "Last buffer")
#endif /* B_LAST_BUFFER_ERROR */
#ifdef B_LAUNCH_FAILED
ADD_ERRNO(B_LAUNCH_FAILED, "B_LAUNCH_FAILED", "Launch failed")
#endif /* B_LAUNCH_FAILED */
#ifdef B_LAUNCH_FAILED_APP_IN_TRASH
ADD_ERRNO(B_LAUNCH_FAILED_APP_IN_TRASH, "B_LAUNCH_FAILED_APP_IN_TRASH", "Application is in the trash")
#endif /* B_LAUNCH_FAILED_APP_IN_TRASH */
#ifdef B_LAUNCH_FAILED_APP_NOT_FOUND
ADD_ERRNO(B_LAUNCH_FAILED_APP_NOT_FOUND, "B_LAUNCH_FAILED_APP_NOT_FOUND", "Application could not be found")
#endif /* B_LAUNCH_FAILED_APP_NOT_FOUND */
#ifdef B_LAUNCH_FAILED_EXECUTABLE
ADD_ERRNO(B_LAUNCH_FAILED_EXECUTABLE, "B_LAUNCH_FAILED_EXECUTABLE", "File is mistakenly marked as executable")
#endif /* B_LAUNCH_FAILED_EXECUTABLE */
#ifdef B_LAUNCH_FAILED_FILES_APP_NOT_FOUND
ADD_ERRNO(B_LAUNCH_FAILED_FILES_APP_NOT_FOUND, "B_LAUNCH_FAILED_FILES_APP_NOT_FOUND", "This file has a preferred app, but it could not be found")
#endif /* B_LAUNCH_FAILED_FILES_APP_NOT_FOUND */
#ifdef B_LAUNCH_FAILED_NO_PREFERRED_APP
ADD_ERRNO(B_LAUNCH_FAILED_NO_PREFERRED_APP, "B_LAUNCH_FAILED_NO_PREFERRED_APP", "There is no preferred application for this type of file")
#endif /* B_LAUNCH_FAILED_NO_PREFERRED_APP */
#ifdef B_LAUNCH_FAILED_NO_RESOLVE_LINK
ADD_ERRNO(B_LAUNCH_FAILED_NO_RESOLVE_LINK, "B_LAUNCH_FAILED_NO_RESOLVE_LINK", "Could not resolve a link")
#endif /* B_LAUNCH_FAILED_NO_RESOLVE_LINK */
#ifdef B_LEGACY_EXECUTABLE
ADD_ERRNO(B_LEGACY_EXECUTABLE, "B_LEGACY_EXECUTABLE", "Unsupported legacy executable")
#endif /* B_LEGACY_EXECUTABLE */
#ifdef B_LINK_LIMIT
ADD_ERRNO(B_LINK_LIMIT, "B_LINK_LIMIT", "Too many symbolic links")
#endif /* B_LINK_LIMIT */
#ifdef B_MAIL_ACCESS_ERROR
ADD_ERRNO(B_MAIL_ACCESS_ERROR, "B_MAIL_ACCESS_ERROR", "Mail access error")
#endif /* B_MAIL_ACCESS_ERROR */
#ifdef B_MAIL_ERROR_BASE
ADD_ERRNO(B_MAIL_ERROR_BASE, "B_MAIL_ERROR_BASE", "")
#endif /* B_MAIL_ERROR_BASE */
#ifdef B_MAIL_INVALID_MAIL
ADD_ERRNO(B_MAIL_INVALID_MAIL, "B_MAIL_INVALID_MAIL", "Invalid mail")
#endif /* B_MAIL_INVALID_MAIL */
#ifdef B_MAIL_NO_DAEMON
ADD_ERRNO(B_MAIL_NO_DAEMON, "B_MAIL_NO_DAEMON", "No mail daemon")
#endif /* B_MAIL_NO_DAEMON */
#ifdef B_MAIL_NO_RECIPIENT
ADD_ERRNO(B_MAIL_NO_RECIPIENT, "B_MAIL_NO_RECIPIENT", "No mail recipient")
#endif /* B_MAIL_NO_RECIPIENT */
#ifdef B_MAIL_UNKNOWN_FIELD
ADD_ERRNO(B_MAIL_UNKNOWN_FIELD, "B_MAIL_UNKNOWN_FIELD", "Unknown mail field")
#endif /* B_MAIL_UNKNOWN_FIELD */
#ifdef B_MAIL_UNKNOWN_HOST
ADD_ERRNO(B_MAIL_UNKNOWN_HOST, "B_MAIL_UNKNOWN_HOST", "Mail unknown host")
#endif /* B_MAIL_UNKNOWN_HOST */
#ifdef B_MAIL_UNKNOWN_USER
ADD_ERRNO(B_MAIL_UNKNOWN_USER, "B_MAIL_UNKNOWN_USER", "Unknown mail user")
#endif /* B_MAIL_UNKNOWN_USER */
#ifdef B_MAIL_WRONG_PASSWORD
ADD_ERRNO(B_MAIL_WRONG_PASSWORD, "B_MAIL_WRONG_PASSWORD", "Wrong password (mail)")
#endif /* B_MAIL_WRONG_PASSWORD */
#ifdef B_MEDIA_ADDON_DISABLED
ADD_ERRNO(B_MEDIA_ADDON_DISABLED, "B_MEDIA_ADDON_DISABLED", "Media addon disabled")
#endif /* B_MEDIA_ADDON_DISABLED */
#ifdef B_MEDIA_ADDON_FAILED
ADD_ERRNO(B_MEDIA_ADDON_FAILED, "B_MEDIA_ADDON_FAILED", "Media addon failed")
#endif /* B_MEDIA_ADDON_FAILED */
#ifdef B_MEDIA_ADDON_RESTRICTED
ADD_ERRNO(B_MEDIA_ADDON_RESTRICTED, "B_MEDIA_ADDON_RESTRICTED", "Media addon restricted")
#endif /* B_MEDIA_ADDON_RESTRICTED */
#ifdef B_MEDIA_ALREADY_CONNECTED
ADD_ERRNO(B_MEDIA_ALREADY_CONNECTED, "B_MEDIA_ALREADY_CONNECTED", "Already connected")
#endif /* B_MEDIA_ALREADY_CONNECTED */
#ifdef B_MEDIA_APP_ALREADY_REGISTERED
ADD_ERRNO(B_MEDIA_APP_ALREADY_REGISTERED, "B_MEDIA_APP_ALREADY_REGISTERED", "Application already registered")
#endif /* B_MEDIA_APP_ALREADY_REGISTERED */
#ifdef B_MEDIA_APP_NOT_REGISTERED
ADD_ERRNO(B_MEDIA_APP_NOT_REGISTERED, "B_MEDIA_APP_NOT_REGISTERED", "Application not registered")
#endif /* B_MEDIA_APP_NOT_REGISTERED */
#ifdef B_MEDIA_BAD_BUFFER
ADD_ERRNO(B_MEDIA_BAD_BUFFER, "B_MEDIA_BAD_BUFFER", "Bad buffer")
#endif /* B_MEDIA_BAD_BUFFER */
#ifdef B_MEDIA_BAD_CLIP_FORMAT
ADD_ERRNO(B_MEDIA_BAD_CLIP_FORMAT, "B_MEDIA_BAD_CLIP_FORMAT", "Bad clipping format")
#endif /* B_MEDIA_BAD_CLIP_FORMAT */
#ifdef B_MEDIA_BAD_DESTINATION
ADD_ERRNO(B_MEDIA_BAD_DESTINATION, "B_MEDIA_BAD_DESTINATION", "Bad destination")
#endif /* B_MEDIA_BAD_DESTINATION */
#ifdef B_MEDIA_BAD_FORMAT
ADD_ERRNO(B_MEDIA_BAD_FORMAT, "B_MEDIA_BAD_FORMAT", "Bad media format")
#endif /* B_MEDIA_BAD_FORMAT */
#ifdef B_MEDIA_BAD_NODE
ADD_ERRNO(B_MEDIA_BAD_NODE, "B_MEDIA_BAD_NODE", "Bad media node")
#endif /* B_MEDIA_BAD_NODE */
#ifdef B_MEDIA_BAD_SOURCE
ADD_ERRNO(B_MEDIA_BAD_SOURCE, "B_MEDIA_BAD_SOURCE", "Bad source")
#endif /* B_MEDIA_BAD_SOURCE */
#ifdef B_MEDIA_BUFFERS_NOT_RECLAIMED
ADD_ERRNO(B_MEDIA_BUFFERS_NOT_RECLAIMED, "B_MEDIA_BUFFERS_NOT_RECLAIMED", "Buffers not reclaimed")
#endif /* B_MEDIA_BUFFERS_NOT_RECLAIMED */
#ifdef B_MEDIA_BUFFER_ALREADY_EXISTS
ADD_ERRNO(B_MEDIA_BUFFER_ALREADY_EXISTS, "B_MEDIA_BUFFER_ALREADY_EXISTS", "Buffer already exists")
#endif /* B_MEDIA_BUFFER_ALREADY_EXISTS */
#ifdef B_MEDIA_CANNOT_CHANGE_RUN_MODE
ADD_ERRNO(B_MEDIA_CANNOT_CHANGE_RUN_MODE, "B_MEDIA_CANNOT_CHANGE_RUN_MODE", "Cannot change run mode")
#endif /* B_MEDIA_CANNOT_CHANGE_RUN_MODE */
#ifdef B_MEDIA_CANNOT_RECLAIM_BUFFERS
ADD_ERRNO(B_MEDIA_CANNOT_RECLAIM_BUFFERS, "B_MEDIA_CANNOT_RECLAIM_BUFFERS", "Cannot reclaim buffers")
#endif /* B_MEDIA_CANNOT_RECLAIM_BUFFERS */
#ifdef B_MEDIA_CANNOT_SEEK
ADD_ERRNO(B_MEDIA_CANNOT_SEEK, "B_MEDIA_CANNOT_SEEK", "Cannot seek")
#endif /* B_MEDIA_CANNOT_SEEK */
#ifdef B_MEDIA_CHANGE_IN_PROGRESS
ADD_ERRNO(B_MEDIA_CHANGE_IN_PROGRESS, "B_MEDIA_CHANGE_IN_PROGRESS", "Change in progress")
#endif /* B_MEDIA_CHANGE_IN_PROGRESS */
#ifdef B_MEDIA_DUPLICATE_FORMAT
ADD_ERRNO(B_MEDIA_DUPLICATE_FORMAT, "B_MEDIA_DUPLICATE_FORMAT", "Duplicate format")
#endif /* B_MEDIA_DUPLICATE_FORMAT */
#ifdef B_MEDIA_ERROR_BASE
ADD_ERRNO(B_MEDIA_ERROR_BASE, "B_MEDIA_ERROR_BASE", "")
#endif /* B_MEDIA_ERROR_BASE */
#ifdef B_MEDIA_NODE_ALREADY_EXISTS
ADD_ERRNO(B_MEDIA_NODE_ALREADY_EXISTS, "B_MEDIA_NODE_ALREADY_EXISTS", "Media node already exists")
#endif /* B_MEDIA_NODE_ALREADY_EXISTS */
#ifdef B_MEDIA_NODE_BUSY
ADD_ERRNO(B_MEDIA_NODE_BUSY, "B_MEDIA_NODE_BUSY", "Media node busy")
#endif /* B_MEDIA_NODE_BUSY */
#ifdef B_MEDIA_NOT_CONNECTED
ADD_ERRNO(B_MEDIA_NOT_CONNECTED, "B_MEDIA_NOT_CONNECTED", "Not connected")
#endif /* B_MEDIA_NOT_CONNECTED */
#ifdef B_MEDIA_NO_HANDLER
ADD_ERRNO(B_MEDIA_NO_HANDLER, "B_MEDIA_NO_HANDLER", "No handler")
#endif /* B_MEDIA_NO_HANDLER */
#ifdef B_MEDIA_REALTIME_DISABLED
ADD_ERRNO(B_MEDIA_REALTIME_DISABLED, "B_MEDIA_REALTIME_DISABLED", "Realtime disabled")
#endif /* B_MEDIA_REALTIME_DISABLED */
#ifdef B_MEDIA_REALTIME_UNAVAILABLE
ADD_ERRNO(B_MEDIA_REALTIME_UNAVAILABLE, "B_MEDIA_REALTIME_UNAVAILABLE", "Realtime unavailable")
#endif /* B_MEDIA_REALTIME_UNAVAILABLE */
#ifdef B_MEDIA_STALE_CHANGE_COUNT
ADD_ERRNO(B_MEDIA_STALE_CHANGE_COUNT, "B_MEDIA_STALE_CHANGE_COUNT", "Stale change count")
#endif /* B_MEDIA_STALE_CHANGE_COUNT */
#ifdef B_MEDIA_SYSTEM_FAILURE
ADD_ERRNO(B_MEDIA_SYSTEM_FAILURE, "B_MEDIA_SYSTEM_FAILURE", "System failure")
#endif /* B_MEDIA_SYSTEM_FAILURE */
#ifdef B_MEDIA_TIME_SOURCE_BUSY
ADD_ERRNO(B_MEDIA_TIME_SOURCE_BUSY, "B_MEDIA_TIME_SOURCE_BUSY", "Time source busy")
#endif /* B_MEDIA_TIME_SOURCE_BUSY */
#ifdef B_MEDIA_TIME_SOURCE_STOPPED
ADD_ERRNO(B_MEDIA_TIME_SOURCE_STOPPED, "B_MEDIA_TIME_SOURCE_STOPPED", "Time source stopped")
#endif /* B_MEDIA_TIME_SOURCE_STOPPED */
#ifdef B_MEDIA_TOO_MANY_BUFFERS
ADD_ERRNO(B_MEDIA_TOO_MANY_BUFFERS, "B_MEDIA_TOO_MANY_BUFFERS", "Too many buffers")
#endif /* B_MEDIA_TOO_MANY_BUFFERS */
#ifdef B_MEDIA_TOO_MANY_NODES
ADD_ERRNO(B_MEDIA_TOO_MANY_NODES, "B_MEDIA_TOO_MANY_NODES", "Too many nodes")
#endif /* B_MEDIA_TOO_MANY_NODES */
#ifdef B_MESSAGE_TO_SELF
ADD_ERRNO(B_MESSAGE_TO_SELF, "B_MESSAGE_TO_SELF", "Can't send message to self")
#endif /* B_MESSAGE_TO_SELF */
#ifdef B_MIDI_ERROR_BASE
ADD_ERRNO(B_MIDI_ERROR_BASE, "B_MIDI_ERROR_BASE", "")
#endif /* B_MIDI_ERROR_BASE */
#ifdef B_MISMATCHED_VALUES
ADD_ERRNO(B_MISMATCHED_VALUES, "B_MISMATCHED_VALUES", "Mismatched values passed to function")
#endif /* B_MISMATCHED_VALUES */
#ifdef B_MISSING_LIBRARY
ADD_ERRNO(B_MISSING_LIBRARY, "B_MISSING_LIBRARY", "Missing library")
#endif /* B_MISSING_LIBRARY */
#ifdef B_MISSING_SYMBOL
ADD_ERRNO(B_MISSING_SYMBOL, "B_MISSING_SYMBOL", "Symbol not found")
#endif /* B_MISSING_SYMBOL */
#ifdef B_NAME_IN_USE
ADD_ERRNO(B_NAME_IN_USE, "B_NAME_IN_USE", "Name in use")
#endif /* B_NAME_IN_USE */
#ifdef B_NAME_NOT_FOUND
ADD_ERRNO(B_NAME_NOT_FOUND, "B_NAME_NOT_FOUND", "Name not found")
#endif /* B_NAME_NOT_FOUND */
#ifdef B_NAME_TOO_LONG
ADD_ERRNO(B_NAME_TOO_LONG, "B_NAME_TOO_LONG", "File name too long")
#endif /* B_NAME_TOO_LONG */
#ifdef B_NOT_ALLOWED
ADD_ERRNO(B_NOT_ALLOWED, "B_NOT_ALLOWED", "Operation not allowed")
#endif /* B_NOT_ALLOWED */
#ifdef B_NOT_AN_EXECUTABLE
ADD_ERRNO(B_NOT_AN_EXECUTABLE, "B_NOT_AN_EXECUTABLE", "Not an executable")
#endif /* B_NOT_AN_EXECUTABLE */
#ifdef B_NOT_A_DIRECTORY
ADD_ERRNO(B_NOT_A_DIRECTORY, "B_NOT_A_DIRECTORY", "Not a directory")
#endif /* B_NOT_A_DIRECTORY */
#ifdef B_NOT_A_MESSAGE
ADD_ERRNO(B_NOT_A_MESSAGE, "B_NOT_A_MESSAGE", "Data is not a message")
#endif /* B_NOT_A_MESSAGE */
#ifdef B_NOT_INITIALIZED
ADD_ERRNO(B_NOT_INITIALIZED, "B_NOT_INITIALIZED", "Initialization failed")
#endif /* B_NOT_INITIALIZED */
#ifdef B_NOT_SUPPORTED
ADD_ERRNO(B_NOT_SUPPORTED, "B_NOT_SUPPORTED", "Operation not supported")
#endif /* B_NOT_SUPPORTED */
#ifdef B_NO_ERROR
ADD_ERRNO(B_NO_ERROR, "B_NO_ERROR", "No error")
#endif /* B_NO_ERROR */
#ifdef B_NO_INIT
ADD_ERRNO(B_NO_INIT, "B_NO_INIT", "Initialization failed")
#endif /* B_NO_INIT */
#ifdef B_NO_MEMORY
ADD_ERRNO(B_NO_MEMORY, "B_NO_MEMORY", "Out of memory")
#endif /* B_NO_MEMORY */
#ifdef B_NO_MORE_FDS
ADD_ERRNO(B_NO_MORE_FDS, "B_NO_MORE_FDS", "Too many open files")
#endif /* B_NO_MORE_FDS */
#ifdef B_NO_MORE_PORTS
ADD_ERRNO(B_NO_MORE_PORTS, "B_NO_MORE_PORTS", "No more ports available")
#endif /* B_NO_MORE_PORTS */
#ifdef B_NO_MORE_SEMS
ADD_ERRNO(B_NO_MORE_SEMS, "B_NO_MORE_SEMS", "No more semaphores")
#endif /* B_NO_MORE_SEMS */
#ifdef B_NO_MORE_TEAMS
ADD_ERRNO(B_NO_MORE_TEAMS, "B_NO_MORE_TEAMS", "No more teams")
#endif /* B_NO_MORE_TEAMS */
#ifdef B_NO_MORE_THREADS
ADD_ERRNO(B_NO_MORE_THREADS, "B_NO_MORE_THREADS", "No more threads")
#endif /* B_NO_MORE_THREADS */
#ifdef B_NO_PRINT_SERVER
ADD_ERRNO(B_NO_PRINT_SERVER, "B_NO_PRINT_SERVER", "No print server")
#endif /* B_NO_PRINT_SERVER */
#ifdef B_NO_TRANSLATOR
ADD_ERRNO(B_NO_TRANSLATOR, "B_NO_TRANSLATOR", "No translator found")
#endif /* B_NO_TRANSLATOR */
#ifdef B_OK
ADD_ERRNO(B_OK, "B_OK", "No error")
#endif /* B_OK */
#ifdef B_OS_ERROR_BASE
ADD_ERRNO(B_OS_ERROR_BASE, "B_OS_ERROR_BASE", "")
#endif /* B_OS_ERROR_BASE */
#ifdef B_PARTIAL_READ
ADD_ERRNO(B_PARTIAL_READ, "B_PARTIAL_READ", "Data read partially")
#endif /* B_PARTIAL_READ */
#ifdef B_PARTIAL_WRITE
ADD_ERRNO(B_PARTIAL_WRITE, "B_PARTIAL_WRITE", "Data written partially")
#endif /* B_PARTIAL_WRITE */
#ifdef B_PARTITION_TOO_SMALL
ADD_ERRNO(B_PARTITION_TOO_SMALL, "B_PARTITION_TOO_SMALL", "Partition too small to contain filesystem")
#endif /* B_PARTITION_TOO_SMALL */
#ifdef B_PERMISSION_DENIED
ADD_ERRNO(B_PERMISSION_DENIED, "B_PERMISSION_DENIED", "Permission denied")
#endif /* B_PERMISSION_DENIED */
#ifdef B_POSIX_ERROR_BASE
ADD_ERRNO(B_POSIX_ERROR_BASE, "B_POSIX_ERROR_BASE", "")
#endif /* B_POSIX_ERROR_BASE */
#ifdef B_PRINT_ERROR_BASE
ADD_ERRNO(B_PRINT_ERROR_BASE, "B_PRINT_ERROR_BASE", "")
#endif /* B_PRINT_ERROR_BASE */
#ifdef B_READ_ONLY_DEVICE
ADD_ERRNO(B_READ_ONLY_DEVICE, "B_READ_ONLY_DEVICE", "Read-only file system")
#endif /* B_READ_ONLY_DEVICE */
#ifdef B_RESOURCE_NOT_FOUND
ADD_ERRNO(B_RESOURCE_NOT_FOUND, "B_RESOURCE_NOT_FOUND", "Resource not found")
#endif /* B_RESOURCE_NOT_FOUND */
#ifdef B_RESOURCE_UNAVAILABLE
ADD_ERRNO(B_RESOURCE_UNAVAILABLE, "B_RESOURCE_UNAVAILABLE", "Resource unavailable")
#endif /* B_RESOURCE_UNAVAILABLE */
#ifdef B_RESULT_NOT_REPRESENTABLE
ADD_ERRNO(B_RESULT_NOT_REPRESENTABLE, "B_RESULT_NOT_REPRESENTABLE", "Range Error")
#endif /* B_RESULT_NOT_REPRESENTABLE */
#ifdef B_SERVER_NOT_FOUND
ADD_ERRNO(B_SERVER_NOT_FOUND, "B_SERVER_NOT_FOUND", "Server not found")
#endif /* B_SERVER_NOT_FOUND */
#ifdef B_SHUTDOWN_CANCELLED
ADD_ERRNO(B_SHUTDOWN_CANCELLED, "B_SHUTDOWN_CANCELLED", "System shutdown cancelled")
#endif /* B_SHUTDOWN_CANCELLED */
#ifdef B_SHUTTING_DOWN
ADD_ERRNO(B_SHUTTING_DOWN, "B_SHUTTING_DOWN", "System shutting down")
#endif /* B_SHUTTING_DOWN */
#ifdef B_STORAGE_ERROR_BASE
ADD_ERRNO(B_STORAGE_ERROR_BASE, "B_STORAGE_ERROR_BASE", "")
#endif /* B_STORAGE_ERROR_BASE */
#ifdef B_STREAM_NOT_FOUND
ADD_ERRNO(B_STREAM_NOT_FOUND, "B_STREAM_NOT_FOUND", "Stream not found")
#endif /* B_STREAM_NOT_FOUND */
#ifdef B_SUBSCRIBER_NOT_ENTERED
ADD_ERRNO(B_SUBSCRIBER_NOT_ENTERED, "B_SUBSCRIBER_NOT_ENTERED", "Subscriber not entered")
#endif /* B_SUBSCRIBER_NOT_ENTERED */
#ifdef B_TIMED_OUT
ADD_ERRNO(B_TIMED_OUT, "B_TIMED_OUT", "Operation timed out")
#endif /* B_TIMED_OUT */
#ifdef B_TOO_MANY_ARGS
ADD_ERRNO(B_TOO_MANY_ARGS, "B_TOO_MANY_ARGS", "Argument too big")
#endif /* B_TOO_MANY_ARGS */
#ifdef B_TRANSLATION_BASE_ERROR
ADD_ERRNO(B_TRANSLATION_BASE_ERROR, "B_TRANSLATION_BASE_ERROR", "")
#endif /* B_TRANSLATION_BASE_ERROR */
#ifdef B_TRANSLATION_ERROR_BASE
ADD_ERRNO(B_TRANSLATION_ERROR_BASE, "B_TRANSLATION_ERROR_BASE", "")
#endif /* B_TRANSLATION_ERROR_BASE */
#ifdef B_UNKNOWN_EXECUTABLE
ADD_ERRNO(B_UNKNOWN_EXECUTABLE, "B_UNKNOWN_EXECUTABLE", "Unknown executable format")
#endif /* B_UNKNOWN_EXECUTABLE */
#ifdef B_UNKNOWN_MIME_TYPE
ADD_ERRNO(B_UNKNOWN_MIME_TYPE, "B_UNKNOWN_MIME_TYPE", "Unknown MIME type")
#endif /* B_UNKNOWN_MIME_TYPE */
#ifdef B_UNSUPPORTED
ADD_ERRNO(B_UNSUPPORTED, "B_UNSUPPORTED", "Operation not supported")
#endif /* B_UNSUPPORTED */
#ifdef B_WOULD_BLOCK
ADD_ERRNO(B_WOULD_BLOCK, "B_WOULD_BLOCK", "Operation would block")
#endif /* B_WOULD_BLOCK */

/* GNU/Hurd errors. */
#ifdef ED_ALREADY_OPEN
ADD_ERRNO(ED_ALREADY_OPEN, "ED_ALREADY_OPEN", "")
#endif /* ED_ALREADY_OPEN */
#ifdef WSAED_ALREADY_OPEN
#ifndef ED_ALREADY_OPEN
ADD_ERRNO(WSAED_ALREADY_OPEN, "ED_ALREADY_OPEN", "")
#endif /* WSAED_ALREADY_OPEN && !ED_ALREADY_OPEN */
ADD_ERRNO(WSAED_ALREADY_OPEN, "WSAED_ALREADY_OPEN", "")
#endif /* WSAED_ALREADY_OPEN */
#ifdef ED_DEVICE_DOWN
ADD_ERRNO(ED_DEVICE_DOWN, "ED_DEVICE_DOWN", "")
#endif /* ED_DEVICE_DOWN */
#ifdef WSAED_DEVICE_DOWN
#ifndef ED_DEVICE_DOWN
ADD_ERRNO(WSAED_DEVICE_DOWN, "ED_DEVICE_DOWN", "")
#endif /* WSAED_DEVICE_DOWN && !ED_DEVICE_DOWN */
ADD_ERRNO(WSAED_DEVICE_DOWN, "WSAED_DEVICE_DOWN", "")
#endif /* WSAED_DEVICE_DOWN */
#ifdef ED_INVALID_OPERATION
ADD_ERRNO(ED_INVALID_OPERATION, "ED_INVALID_OPERATION", "")
#endif /* ED_INVALID_OPERATION */
#ifdef WSAED_INVALID_OPERATION
#ifndef ED_INVALID_OPERATION
ADD_ERRNO(WSAED_INVALID_OPERATION, "ED_INVALID_OPERATION", "")
#endif /* WSAED_INVALID_OPERATION && !ED_INVALID_OPERATION */
ADD_ERRNO(WSAED_INVALID_OPERATION, "WSAED_INVALID_OPERATION", "")
#endif /* WSAED_INVALID_OPERATION */
#ifdef ED_INVALID_RECNUM
ADD_ERRNO(ED_INVALID_RECNUM, "ED_INVALID_RECNUM", "")
#endif /* ED_INVALID_RECNUM */
#ifdef WSAED_INVALID_RECNUM
#ifndef ED_INVALID_RECNUM
ADD_ERRNO(WSAED_INVALID_RECNUM, "ED_INVALID_RECNUM", "")
#endif /* WSAED_INVALID_RECNUM && !ED_INVALID_RECNUM */
ADD_ERRNO(WSAED_INVALID_RECNUM, "WSAED_INVALID_RECNUM", "")
#endif /* WSAED_INVALID_RECNUM */
#ifdef ED_INVALID_SIZE
ADD_ERRNO(ED_INVALID_SIZE, "ED_INVALID_SIZE", "")
#endif /* ED_INVALID_SIZE */
#ifdef WSAED_INVALID_SIZE
#ifndef ED_INVALID_SIZE
ADD_ERRNO(WSAED_INVALID_SIZE, "ED_INVALID_SIZE", "")
#endif /* WSAED_INVALID_SIZE && !ED_INVALID_SIZE */
ADD_ERRNO(WSAED_INVALID_SIZE, "WSAED_INVALID_SIZE", "")
#endif /* WSAED_INVALID_SIZE */
#ifdef ED_IO_ERROR
ADD_ERRNO(ED_IO_ERROR, "ED_IO_ERROR", "")
#endif /* ED_IO_ERROR */
#ifdef WSAED_IO_ERROR
#ifndef ED_IO_ERROR
ADD_ERRNO(WSAED_IO_ERROR, "ED_IO_ERROR", "")
#endif /* WSAED_IO_ERROR && !ED_IO_ERROR */
ADD_ERRNO(WSAED_IO_ERROR, "WSAED_IO_ERROR", "")
#endif /* WSAED_IO_ERROR */
#ifdef ED_NO_MEMORY
ADD_ERRNO(ED_NO_MEMORY, "ED_NO_MEMORY", "")
#endif /* ED_NO_MEMORY */
#ifdef WSAED_NO_MEMORY
#ifndef ED_NO_MEMORY
ADD_ERRNO(WSAED_NO_MEMORY, "ED_NO_MEMORY", "")
#endif /* WSAED_NO_MEMORY && !ED_NO_MEMORY */
ADD_ERRNO(WSAED_NO_MEMORY, "WSAED_NO_MEMORY", "")
#endif /* WSAED_NO_MEMORY */
#ifdef ED_NO_SUCH_DEVICE
ADD_ERRNO(ED_NO_SUCH_DEVICE, "ED_NO_SUCH_DEVICE", "")
#endif /* ED_NO_SUCH_DEVICE */
#ifdef WSAED_NO_SUCH_DEVICE
#ifndef ED_NO_SUCH_DEVICE
ADD_ERRNO(WSAED_NO_SUCH_DEVICE, "ED_NO_SUCH_DEVICE", "")
#endif /* WSAED_NO_SUCH_DEVICE && !ED_NO_SUCH_DEVICE */
ADD_ERRNO(WSAED_NO_SUCH_DEVICE, "WSAED_NO_SUCH_DEVICE", "")
#endif /* WSAED_NO_SUCH_DEVICE */
#ifdef ED_READ_ONLY
ADD_ERRNO(ED_READ_ONLY, "ED_READ_ONLY", "")
#endif /* ED_READ_ONLY */
#ifdef WSAED_READ_ONLY
#ifndef ED_READ_ONLY
ADD_ERRNO(WSAED_READ_ONLY, "ED_READ_ONLY", "")
#endif /* WSAED_READ_ONLY && !ED_READ_ONLY */
ADD_ERRNO(WSAED_READ_ONLY, "WSAED_READ_ONLY", "")
#endif /* WSAED_READ_ONLY */
#ifdef ED_WOULD_BLOCK
ADD_ERRNO(ED_WOULD_BLOCK, "ED_WOULD_BLOCK", "")
#endif /* ED_WOULD_BLOCK */
#ifdef WSAED_WOULD_BLOCK
#ifndef ED_WOULD_BLOCK
ADD_ERRNO(WSAED_WOULD_BLOCK, "ED_WOULD_BLOCK", "")
#endif /* WSAED_WOULD_BLOCK && !ED_WOULD_BLOCK */
ADD_ERRNO(WSAED_WOULD_BLOCK, "WSAED_WOULD_BLOCK", "")
#endif /* WSAED_WOULD_BLOCK */
#ifdef EKERN_ABORTED
ADD_ERRNO(EKERN_ABORTED, "EKERN_ABORTED", "")
#endif /* EKERN_ABORTED */
#ifdef WSAEKERN_ABORTED
#ifndef EKERN_ABORTED
ADD_ERRNO(WSAEKERN_ABORTED, "EKERN_ABORTED", "")
#endif /* WSAEKERN_ABORTED && !EKERN_ABORTED */
ADD_ERRNO(WSAEKERN_ABORTED, "WSAEKERN_ABORTED", "")
#endif /* WSAEKERN_ABORTED */
#ifdef EKERN_FAILURE
ADD_ERRNO(EKERN_FAILURE, "EKERN_FAILURE", "")
#endif /* EKERN_FAILURE */
#ifdef WSAEKERN_FAILURE
#ifndef EKERN_FAILURE
ADD_ERRNO(WSAEKERN_FAILURE, "EKERN_FAILURE", "")
#endif /* WSAEKERN_FAILURE && !EKERN_FAILURE */
ADD_ERRNO(WSAEKERN_FAILURE, "WSAEKERN_FAILURE", "")
#endif /* WSAEKERN_FAILURE */
#ifdef EKERN_INTERRUPTED
ADD_ERRNO(EKERN_INTERRUPTED, "EKERN_INTERRUPTED", "")
#endif /* EKERN_INTERRUPTED */
#ifdef WSAEKERN_INTERRUPTED
#ifndef EKERN_INTERRUPTED
ADD_ERRNO(WSAEKERN_INTERRUPTED, "EKERN_INTERRUPTED", "")
#endif /* WSAEKERN_INTERRUPTED && !EKERN_INTERRUPTED */
ADD_ERRNO(WSAEKERN_INTERRUPTED, "WSAEKERN_INTERRUPTED", "")
#endif /* WSAEKERN_INTERRUPTED */
#ifdef EKERN_INVALID_ADDRESS
ADD_ERRNO(EKERN_INVALID_ADDRESS, "EKERN_INVALID_ADDRESS", "")
#endif /* EKERN_INVALID_ADDRESS */
#ifdef WSAEKERN_INVALID_ADDRESS
#ifndef EKERN_INVALID_ADDRESS
ADD_ERRNO(WSAEKERN_INVALID_ADDRESS, "EKERN_INVALID_ADDRESS", "")
#endif /* WSAEKERN_INVALID_ADDRESS && !EKERN_INVALID_ADDRESS */
ADD_ERRNO(WSAEKERN_INVALID_ADDRESS, "WSAEKERN_INVALID_ADDRESS", "")
#endif /* WSAEKERN_INVALID_ADDRESS */
#ifdef EKERN_INVALID_ARGUMENT
ADD_ERRNO(EKERN_INVALID_ARGUMENT, "EKERN_INVALID_ARGUMENT", "")
#endif /* EKERN_INVALID_ARGUMENT */
#ifdef WSAEKERN_INVALID_ARGUMENT
#ifndef EKERN_INVALID_ARGUMENT
ADD_ERRNO(WSAEKERN_INVALID_ARGUMENT, "EKERN_INVALID_ARGUMENT", "")
#endif /* WSAEKERN_INVALID_ARGUMENT && !EKERN_INVALID_ARGUMENT */
ADD_ERRNO(WSAEKERN_INVALID_ARGUMENT, "WSAEKERN_INVALID_ARGUMENT", "")
#endif /* WSAEKERN_INVALID_ARGUMENT */
#ifdef EKERN_INVALID_CAPABILITY
ADD_ERRNO(EKERN_INVALID_CAPABILITY, "EKERN_INVALID_CAPABILITY", "")
#endif /* EKERN_INVALID_CAPABILITY */
#ifdef WSAEKERN_INVALID_CAPABILITY
#ifndef EKERN_INVALID_CAPABILITY
ADD_ERRNO(WSAEKERN_INVALID_CAPABILITY, "EKERN_INVALID_CAPABILITY", "")
#endif /* WSAEKERN_INVALID_CAPABILITY && !EKERN_INVALID_CAPABILITY */
ADD_ERRNO(WSAEKERN_INVALID_CAPABILITY, "WSAEKERN_INVALID_CAPABILITY", "")
#endif /* WSAEKERN_INVALID_CAPABILITY */
#ifdef EKERN_INVALID_HOST
ADD_ERRNO(EKERN_INVALID_HOST, "EKERN_INVALID_HOST", "")
#endif /* EKERN_INVALID_HOST */
#ifdef WSAEKERN_INVALID_HOST
#ifndef EKERN_INVALID_HOST
ADD_ERRNO(WSAEKERN_INVALID_HOST, "EKERN_INVALID_HOST", "")
#endif /* WSAEKERN_INVALID_HOST && !EKERN_INVALID_HOST */
ADD_ERRNO(WSAEKERN_INVALID_HOST, "WSAEKERN_INVALID_HOST", "")
#endif /* WSAEKERN_INVALID_HOST */
#ifdef EKERN_INVALID_NAME
ADD_ERRNO(EKERN_INVALID_NAME, "EKERN_INVALID_NAME", "")
#endif /* EKERN_INVALID_NAME */
#ifdef WSAEKERN_INVALID_NAME
#ifndef EKERN_INVALID_NAME
ADD_ERRNO(WSAEKERN_INVALID_NAME, "EKERN_INVALID_NAME", "")
#endif /* WSAEKERN_INVALID_NAME && !EKERN_INVALID_NAME */
ADD_ERRNO(WSAEKERN_INVALID_NAME, "WSAEKERN_INVALID_NAME", "")
#endif /* WSAEKERN_INVALID_NAME */
#ifdef EKERN_INVALID_RIGHT
ADD_ERRNO(EKERN_INVALID_RIGHT, "EKERN_INVALID_RIGHT", "")
#endif /* EKERN_INVALID_RIGHT */
#ifdef WSAEKERN_INVALID_RIGHT
#ifndef EKERN_INVALID_RIGHT
ADD_ERRNO(WSAEKERN_INVALID_RIGHT, "EKERN_INVALID_RIGHT", "")
#endif /* WSAEKERN_INVALID_RIGHT && !EKERN_INVALID_RIGHT */
ADD_ERRNO(WSAEKERN_INVALID_RIGHT, "WSAEKERN_INVALID_RIGHT", "")
#endif /* WSAEKERN_INVALID_RIGHT */
#ifdef EKERN_INVALID_TASK
ADD_ERRNO(EKERN_INVALID_TASK, "EKERN_INVALID_TASK", "")
#endif /* EKERN_INVALID_TASK */
#ifdef WSAEKERN_INVALID_TASK
#ifndef EKERN_INVALID_TASK
ADD_ERRNO(WSAEKERN_INVALID_TASK, "EKERN_INVALID_TASK", "")
#endif /* WSAEKERN_INVALID_TASK && !EKERN_INVALID_TASK */
ADD_ERRNO(WSAEKERN_INVALID_TASK, "WSAEKERN_INVALID_TASK", "")
#endif /* WSAEKERN_INVALID_TASK */
#ifdef EKERN_INVALID_VALUE
ADD_ERRNO(EKERN_INVALID_VALUE, "EKERN_INVALID_VALUE", "")
#endif /* EKERN_INVALID_VALUE */
#ifdef WSAEKERN_INVALID_VALUE
#ifndef EKERN_INVALID_VALUE
ADD_ERRNO(WSAEKERN_INVALID_VALUE, "EKERN_INVALID_VALUE", "")
#endif /* WSAEKERN_INVALID_VALUE && !EKERN_INVALID_VALUE */
ADD_ERRNO(WSAEKERN_INVALID_VALUE, "WSAEKERN_INVALID_VALUE", "")
#endif /* WSAEKERN_INVALID_VALUE */
#ifdef EKERN_MEMORY_ERROR
ADD_ERRNO(EKERN_MEMORY_ERROR, "EKERN_MEMORY_ERROR", "")
#endif /* EKERN_MEMORY_ERROR */
#ifdef WSAEKERN_MEMORY_ERROR
#ifndef EKERN_MEMORY_ERROR
ADD_ERRNO(WSAEKERN_MEMORY_ERROR, "EKERN_MEMORY_ERROR", "")
#endif /* WSAEKERN_MEMORY_ERROR && !EKERN_MEMORY_ERROR */
ADD_ERRNO(WSAEKERN_MEMORY_ERROR, "WSAEKERN_MEMORY_ERROR", "")
#endif /* WSAEKERN_MEMORY_ERROR */
#ifdef EKERN_MEMORY_FAILURE
ADD_ERRNO(EKERN_MEMORY_FAILURE, "EKERN_MEMORY_FAILURE", "")
#endif /* EKERN_MEMORY_FAILURE */
#ifdef WSAEKERN_MEMORY_FAILURE
#ifndef EKERN_MEMORY_FAILURE
ADD_ERRNO(WSAEKERN_MEMORY_FAILURE, "EKERN_MEMORY_FAILURE", "")
#endif /* WSAEKERN_MEMORY_FAILURE && !EKERN_MEMORY_FAILURE */
ADD_ERRNO(WSAEKERN_MEMORY_FAILURE, "WSAEKERN_MEMORY_FAILURE", "")
#endif /* WSAEKERN_MEMORY_FAILURE */
#ifdef EKERN_NAME_EXISTS
ADD_ERRNO(EKERN_NAME_EXISTS, "EKERN_NAME_EXISTS", "")
#endif /* EKERN_NAME_EXISTS */
#ifdef WSAEKERN_NAME_EXISTS
#ifndef EKERN_NAME_EXISTS
ADD_ERRNO(WSAEKERN_NAME_EXISTS, "EKERN_NAME_EXISTS", "")
#endif /* WSAEKERN_NAME_EXISTS && !EKERN_NAME_EXISTS */
ADD_ERRNO(WSAEKERN_NAME_EXISTS, "WSAEKERN_NAME_EXISTS", "")
#endif /* WSAEKERN_NAME_EXISTS */
#ifdef EKERN_NOT_IN_SET
ADD_ERRNO(EKERN_NOT_IN_SET, "EKERN_NOT_IN_SET", "")
#endif /* EKERN_NOT_IN_SET */
#ifdef WSAEKERN_NOT_IN_SET
#ifndef EKERN_NOT_IN_SET
ADD_ERRNO(WSAEKERN_NOT_IN_SET, "EKERN_NOT_IN_SET", "")
#endif /* WSAEKERN_NOT_IN_SET && !EKERN_NOT_IN_SET */
ADD_ERRNO(WSAEKERN_NOT_IN_SET, "WSAEKERN_NOT_IN_SET", "")
#endif /* WSAEKERN_NOT_IN_SET */
#ifdef EKERN_NOT_RECEIVER
ADD_ERRNO(EKERN_NOT_RECEIVER, "EKERN_NOT_RECEIVER", "")
#endif /* EKERN_NOT_RECEIVER */
#ifdef WSAEKERN_NOT_RECEIVER
#ifndef EKERN_NOT_RECEIVER
ADD_ERRNO(WSAEKERN_NOT_RECEIVER, "EKERN_NOT_RECEIVER", "")
#endif /* WSAEKERN_NOT_RECEIVER && !EKERN_NOT_RECEIVER */
ADD_ERRNO(WSAEKERN_NOT_RECEIVER, "WSAEKERN_NOT_RECEIVER", "")
#endif /* WSAEKERN_NOT_RECEIVER */
#ifdef EKERN_NO_ACCESS
ADD_ERRNO(EKERN_NO_ACCESS, "EKERN_NO_ACCESS", "")
#endif /* EKERN_NO_ACCESS */
#ifdef WSAEKERN_NO_ACCESS
#ifndef EKERN_NO_ACCESS
ADD_ERRNO(WSAEKERN_NO_ACCESS, "EKERN_NO_ACCESS", "")
#endif /* WSAEKERN_NO_ACCESS && !EKERN_NO_ACCESS */
ADD_ERRNO(WSAEKERN_NO_ACCESS, "WSAEKERN_NO_ACCESS", "")
#endif /* WSAEKERN_NO_ACCESS */
#ifdef EKERN_NO_SPACE
ADD_ERRNO(EKERN_NO_SPACE, "EKERN_NO_SPACE", "")
#endif /* EKERN_NO_SPACE */
#ifdef WSAEKERN_NO_SPACE
#ifndef EKERN_NO_SPACE
ADD_ERRNO(WSAEKERN_NO_SPACE, "EKERN_NO_SPACE", "")
#endif /* WSAEKERN_NO_SPACE && !EKERN_NO_SPACE */
ADD_ERRNO(WSAEKERN_NO_SPACE, "WSAEKERN_NO_SPACE", "")
#endif /* WSAEKERN_NO_SPACE */
#ifdef EKERN_PROTECTION_FAILURE
ADD_ERRNO(EKERN_PROTECTION_FAILURE, "EKERN_PROTECTION_FAILURE", "")
#endif /* EKERN_PROTECTION_FAILURE */
#ifdef WSAEKERN_PROTECTION_FAILURE
#ifndef EKERN_PROTECTION_FAILURE
ADD_ERRNO(WSAEKERN_PROTECTION_FAILURE, "EKERN_PROTECTION_FAILURE", "")
#endif /* WSAEKERN_PROTECTION_FAILURE && !EKERN_PROTECTION_FAILURE */
ADD_ERRNO(WSAEKERN_PROTECTION_FAILURE, "WSAEKERN_PROTECTION_FAILURE", "")
#endif /* WSAEKERN_PROTECTION_FAILURE */
#ifdef EKERN_RESOURCE_SHORTAGE
ADD_ERRNO(EKERN_RESOURCE_SHORTAGE, "EKERN_RESOURCE_SHORTAGE", "")
#endif /* EKERN_RESOURCE_SHORTAGE */
#ifdef WSAEKERN_RESOURCE_SHORTAGE
#ifndef EKERN_RESOURCE_SHORTAGE
ADD_ERRNO(WSAEKERN_RESOURCE_SHORTAGE, "EKERN_RESOURCE_SHORTAGE", "")
#endif /* WSAEKERN_RESOURCE_SHORTAGE && !EKERN_RESOURCE_SHORTAGE */
ADD_ERRNO(WSAEKERN_RESOURCE_SHORTAGE, "WSAEKERN_RESOURCE_SHORTAGE", "")
#endif /* WSAEKERN_RESOURCE_SHORTAGE */
#ifdef EKERN_RIGHT_EXISTS
ADD_ERRNO(EKERN_RIGHT_EXISTS, "EKERN_RIGHT_EXISTS", "")
#endif /* EKERN_RIGHT_EXISTS */
#ifdef WSAEKERN_RIGHT_EXISTS
#ifndef EKERN_RIGHT_EXISTS
ADD_ERRNO(WSAEKERN_RIGHT_EXISTS, "EKERN_RIGHT_EXISTS", "")
#endif /* WSAEKERN_RIGHT_EXISTS && !EKERN_RIGHT_EXISTS */
ADD_ERRNO(WSAEKERN_RIGHT_EXISTS, "WSAEKERN_RIGHT_EXISTS", "")
#endif /* WSAEKERN_RIGHT_EXISTS */
#ifdef EKERN_TERMINATED
ADD_ERRNO(EKERN_TERMINATED, "EKERN_TERMINATED", "")
#endif /* EKERN_TERMINATED */
#ifdef WSAEKERN_TERMINATED
#ifndef EKERN_TERMINATED
ADD_ERRNO(WSAEKERN_TERMINATED, "EKERN_TERMINATED", "")
#endif /* WSAEKERN_TERMINATED && !EKERN_TERMINATED */
ADD_ERRNO(WSAEKERN_TERMINATED, "WSAEKERN_TERMINATED", "")
#endif /* WSAEKERN_TERMINATED */
#ifdef EKERN_TIMEDOUT
ADD_ERRNO(EKERN_TIMEDOUT, "EKERN_TIMEDOUT", "")
#endif /* EKERN_TIMEDOUT */
#ifdef WSAEKERN_TIMEDOUT
#ifndef EKERN_TIMEDOUT
ADD_ERRNO(WSAEKERN_TIMEDOUT, "EKERN_TIMEDOUT", "")
#endif /* WSAEKERN_TIMEDOUT && !EKERN_TIMEDOUT */
ADD_ERRNO(WSAEKERN_TIMEDOUT, "WSAEKERN_TIMEDOUT", "")
#endif /* WSAEKERN_TIMEDOUT */
#ifdef EKERN_UREFS_OVERFLOW
ADD_ERRNO(EKERN_UREFS_OVERFLOW, "EKERN_UREFS_OVERFLOW", "")
#endif /* EKERN_UREFS_OVERFLOW */
#ifdef WSAEKERN_UREFS_OVERFLOW
#ifndef EKERN_UREFS_OVERFLOW
ADD_ERRNO(WSAEKERN_UREFS_OVERFLOW, "EKERN_UREFS_OVERFLOW", "")
#endif /* WSAEKERN_UREFS_OVERFLOW && !EKERN_UREFS_OVERFLOW */
ADD_ERRNO(WSAEKERN_UREFS_OVERFLOW, "WSAEKERN_UREFS_OVERFLOW", "")
#endif /* WSAEKERN_UREFS_OVERFLOW */
#ifdef EKERN_WRITE_PROTECTION_FAILURE
ADD_ERRNO(EKERN_WRITE_PROTECTION_FAILURE, "EKERN_WRITE_PROTECTION_FAILURE", "")
#endif /* EKERN_WRITE_PROTECTION_FAILURE */
#ifdef WSAEKERN_WRITE_PROTECTION_FAILURE
#ifndef EKERN_WRITE_PROTECTION_FAILURE
ADD_ERRNO(WSAEKERN_WRITE_PROTECTION_FAILURE, "EKERN_WRITE_PROTECTION_FAILURE", "")
#endif /* WSAEKERN_WRITE_PROTECTION_FAILURE && !EKERN_WRITE_PROTECTION_FAILURE */
ADD_ERRNO(WSAEKERN_WRITE_PROTECTION_FAILURE, "WSAEKERN_WRITE_PROTECTION_FAILURE", "")
#endif /* WSAEKERN_WRITE_PROTECTION_FAILURE */
#ifdef EMACH_RCV_BODY_ERROR
ADD_ERRNO(EMACH_RCV_BODY_ERROR, "EMACH_RCV_BODY_ERROR", "")
#endif /* EMACH_RCV_BODY_ERROR */
#ifdef WSAEMACH_RCV_BODY_ERROR
#ifndef EMACH_RCV_BODY_ERROR
ADD_ERRNO(WSAEMACH_RCV_BODY_ERROR, "EMACH_RCV_BODY_ERROR", "")
#endif /* WSAEMACH_RCV_BODY_ERROR && !EMACH_RCV_BODY_ERROR */
ADD_ERRNO(WSAEMACH_RCV_BODY_ERROR, "WSAEMACH_RCV_BODY_ERROR", "")
#endif /* WSAEMACH_RCV_BODY_ERROR */
#ifdef EMACH_RCV_HEADER_ERROR
ADD_ERRNO(EMACH_RCV_HEADER_ERROR, "EMACH_RCV_HEADER_ERROR", "")
#endif /* EMACH_RCV_HEADER_ERROR */
#ifdef WSAEMACH_RCV_HEADER_ERROR
#ifndef EMACH_RCV_HEADER_ERROR
ADD_ERRNO(WSAEMACH_RCV_HEADER_ERROR, "EMACH_RCV_HEADER_ERROR", "")
#endif /* WSAEMACH_RCV_HEADER_ERROR && !EMACH_RCV_HEADER_ERROR */
ADD_ERRNO(WSAEMACH_RCV_HEADER_ERROR, "WSAEMACH_RCV_HEADER_ERROR", "")
#endif /* WSAEMACH_RCV_HEADER_ERROR */
#ifdef EMACH_RCV_INTERRUPTED
ADD_ERRNO(EMACH_RCV_INTERRUPTED, "EMACH_RCV_INTERRUPTED", "")
#endif /* EMACH_RCV_INTERRUPTED */
#ifdef WSAEMACH_RCV_INTERRUPTED
#ifndef EMACH_RCV_INTERRUPTED
ADD_ERRNO(WSAEMACH_RCV_INTERRUPTED, "EMACH_RCV_INTERRUPTED", "")
#endif /* WSAEMACH_RCV_INTERRUPTED && !EMACH_RCV_INTERRUPTED */
ADD_ERRNO(WSAEMACH_RCV_INTERRUPTED, "WSAEMACH_RCV_INTERRUPTED", "")
#endif /* WSAEMACH_RCV_INTERRUPTED */
#ifdef EMACH_RCV_INVALID_DATA
ADD_ERRNO(EMACH_RCV_INVALID_DATA, "EMACH_RCV_INVALID_DATA", "")
#endif /* EMACH_RCV_INVALID_DATA */
#ifdef WSAEMACH_RCV_INVALID_DATA
#ifndef EMACH_RCV_INVALID_DATA
ADD_ERRNO(WSAEMACH_RCV_INVALID_DATA, "EMACH_RCV_INVALID_DATA", "")
#endif /* WSAEMACH_RCV_INVALID_DATA && !EMACH_RCV_INVALID_DATA */
ADD_ERRNO(WSAEMACH_RCV_INVALID_DATA, "WSAEMACH_RCV_INVALID_DATA", "")
#endif /* WSAEMACH_RCV_INVALID_DATA */
#ifdef EMACH_RCV_INVALID_NAME
ADD_ERRNO(EMACH_RCV_INVALID_NAME, "EMACH_RCV_INVALID_NAME", "")
#endif /* EMACH_RCV_INVALID_NAME */
#ifdef WSAEMACH_RCV_INVALID_NAME
#ifndef EMACH_RCV_INVALID_NAME
ADD_ERRNO(WSAEMACH_RCV_INVALID_NAME, "EMACH_RCV_INVALID_NAME", "")
#endif /* WSAEMACH_RCV_INVALID_NAME && !EMACH_RCV_INVALID_NAME */
ADD_ERRNO(WSAEMACH_RCV_INVALID_NAME, "WSAEMACH_RCV_INVALID_NAME", "")
#endif /* WSAEMACH_RCV_INVALID_NAME */
#ifdef EMACH_RCV_INVALID_NOTIFY
ADD_ERRNO(EMACH_RCV_INVALID_NOTIFY, "EMACH_RCV_INVALID_NOTIFY", "")
#endif /* EMACH_RCV_INVALID_NOTIFY */
#ifdef WSAEMACH_RCV_INVALID_NOTIFY
#ifndef EMACH_RCV_INVALID_NOTIFY
ADD_ERRNO(WSAEMACH_RCV_INVALID_NOTIFY, "EMACH_RCV_INVALID_NOTIFY", "")
#endif /* WSAEMACH_RCV_INVALID_NOTIFY && !EMACH_RCV_INVALID_NOTIFY */
ADD_ERRNO(WSAEMACH_RCV_INVALID_NOTIFY, "WSAEMACH_RCV_INVALID_NOTIFY", "")
#endif /* WSAEMACH_RCV_INVALID_NOTIFY */
#ifdef EMACH_RCV_IN_PROGRESS
ADD_ERRNO(EMACH_RCV_IN_PROGRESS, "EMACH_RCV_IN_PROGRESS", "")
#endif /* EMACH_RCV_IN_PROGRESS */
#ifdef WSAEMACH_RCV_IN_PROGRESS
#ifndef EMACH_RCV_IN_PROGRESS
ADD_ERRNO(WSAEMACH_RCV_IN_PROGRESS, "EMACH_RCV_IN_PROGRESS", "")
#endif /* WSAEMACH_RCV_IN_PROGRESS && !EMACH_RCV_IN_PROGRESS */
ADD_ERRNO(WSAEMACH_RCV_IN_PROGRESS, "WSAEMACH_RCV_IN_PROGRESS", "")
#endif /* WSAEMACH_RCV_IN_PROGRESS */
#ifdef EMACH_RCV_IN_SET
ADD_ERRNO(EMACH_RCV_IN_SET, "EMACH_RCV_IN_SET", "")
#endif /* EMACH_RCV_IN_SET */
#ifdef WSAEMACH_RCV_IN_SET
#ifndef EMACH_RCV_IN_SET
ADD_ERRNO(WSAEMACH_RCV_IN_SET, "EMACH_RCV_IN_SET", "")
#endif /* WSAEMACH_RCV_IN_SET && !EMACH_RCV_IN_SET */
ADD_ERRNO(WSAEMACH_RCV_IN_SET, "WSAEMACH_RCV_IN_SET", "")
#endif /* WSAEMACH_RCV_IN_SET */
#ifdef EMACH_RCV_PORT_CHANGED
ADD_ERRNO(EMACH_RCV_PORT_CHANGED, "EMACH_RCV_PORT_CHANGED", "")
#endif /* EMACH_RCV_PORT_CHANGED */
#ifdef WSAEMACH_RCV_PORT_CHANGED
#ifndef EMACH_RCV_PORT_CHANGED
ADD_ERRNO(WSAEMACH_RCV_PORT_CHANGED, "EMACH_RCV_PORT_CHANGED", "")
#endif /* WSAEMACH_RCV_PORT_CHANGED && !EMACH_RCV_PORT_CHANGED */
ADD_ERRNO(WSAEMACH_RCV_PORT_CHANGED, "WSAEMACH_RCV_PORT_CHANGED", "")
#endif /* WSAEMACH_RCV_PORT_CHANGED */
#ifdef EMACH_RCV_PORT_DIED
ADD_ERRNO(EMACH_RCV_PORT_DIED, "EMACH_RCV_PORT_DIED", "")
#endif /* EMACH_RCV_PORT_DIED */
#ifdef WSAEMACH_RCV_PORT_DIED
#ifndef EMACH_RCV_PORT_DIED
ADD_ERRNO(WSAEMACH_RCV_PORT_DIED, "EMACH_RCV_PORT_DIED", "")
#endif /* WSAEMACH_RCV_PORT_DIED && !EMACH_RCV_PORT_DIED */
ADD_ERRNO(WSAEMACH_RCV_PORT_DIED, "WSAEMACH_RCV_PORT_DIED", "")
#endif /* WSAEMACH_RCV_PORT_DIED */
#ifdef EMACH_RCV_TIMED_OUT
ADD_ERRNO(EMACH_RCV_TIMED_OUT, "EMACH_RCV_TIMED_OUT", "")
#endif /* EMACH_RCV_TIMED_OUT */
#ifdef WSAEMACH_RCV_TIMED_OUT
#ifndef EMACH_RCV_TIMED_OUT
ADD_ERRNO(WSAEMACH_RCV_TIMED_OUT, "EMACH_RCV_TIMED_OUT", "")
#endif /* WSAEMACH_RCV_TIMED_OUT && !EMACH_RCV_TIMED_OUT */
ADD_ERRNO(WSAEMACH_RCV_TIMED_OUT, "WSAEMACH_RCV_TIMED_OUT", "")
#endif /* WSAEMACH_RCV_TIMED_OUT */
#ifdef EMACH_RCV_TOO_LARGE
ADD_ERRNO(EMACH_RCV_TOO_LARGE, "EMACH_RCV_TOO_LARGE", "")
#endif /* EMACH_RCV_TOO_LARGE */
#ifdef WSAEMACH_RCV_TOO_LARGE
#ifndef EMACH_RCV_TOO_LARGE
ADD_ERRNO(WSAEMACH_RCV_TOO_LARGE, "EMACH_RCV_TOO_LARGE", "")
#endif /* WSAEMACH_RCV_TOO_LARGE && !EMACH_RCV_TOO_LARGE */
ADD_ERRNO(WSAEMACH_RCV_TOO_LARGE, "WSAEMACH_RCV_TOO_LARGE", "")
#endif /* WSAEMACH_RCV_TOO_LARGE */
#ifdef EMACH_SEND_INTERRUPTED
ADD_ERRNO(EMACH_SEND_INTERRUPTED, "EMACH_SEND_INTERRUPTED", "")
#endif /* EMACH_SEND_INTERRUPTED */
#ifdef WSAEMACH_SEND_INTERRUPTED
#ifndef EMACH_SEND_INTERRUPTED
ADD_ERRNO(WSAEMACH_SEND_INTERRUPTED, "EMACH_SEND_INTERRUPTED", "")
#endif /* WSAEMACH_SEND_INTERRUPTED && !EMACH_SEND_INTERRUPTED */
ADD_ERRNO(WSAEMACH_SEND_INTERRUPTED, "WSAEMACH_SEND_INTERRUPTED", "")
#endif /* WSAEMACH_SEND_INTERRUPTED */
#ifdef EMACH_SEND_INVALID_DATA
ADD_ERRNO(EMACH_SEND_INVALID_DATA, "EMACH_SEND_INVALID_DATA", "")
#endif /* EMACH_SEND_INVALID_DATA */
#ifdef WSAEMACH_SEND_INVALID_DATA
#ifndef EMACH_SEND_INVALID_DATA
ADD_ERRNO(WSAEMACH_SEND_INVALID_DATA, "EMACH_SEND_INVALID_DATA", "")
#endif /* WSAEMACH_SEND_INVALID_DATA && !EMACH_SEND_INVALID_DATA */
ADD_ERRNO(WSAEMACH_SEND_INVALID_DATA, "WSAEMACH_SEND_INVALID_DATA", "")
#endif /* WSAEMACH_SEND_INVALID_DATA */
#ifdef EMACH_SEND_INVALID_DEST
ADD_ERRNO(EMACH_SEND_INVALID_DEST, "EMACH_SEND_INVALID_DEST", "")
#endif /* EMACH_SEND_INVALID_DEST */
#ifdef WSAEMACH_SEND_INVALID_DEST
#ifndef EMACH_SEND_INVALID_DEST
ADD_ERRNO(WSAEMACH_SEND_INVALID_DEST, "EMACH_SEND_INVALID_DEST", "")
#endif /* WSAEMACH_SEND_INVALID_DEST && !EMACH_SEND_INVALID_DEST */
ADD_ERRNO(WSAEMACH_SEND_INVALID_DEST, "WSAEMACH_SEND_INVALID_DEST", "")
#endif /* WSAEMACH_SEND_INVALID_DEST */
#ifdef EMACH_SEND_INVALID_HEADER
ADD_ERRNO(EMACH_SEND_INVALID_HEADER, "EMACH_SEND_INVALID_HEADER", "")
#endif /* EMACH_SEND_INVALID_HEADER */
#ifdef WSAEMACH_SEND_INVALID_HEADER
#ifndef EMACH_SEND_INVALID_HEADER
ADD_ERRNO(WSAEMACH_SEND_INVALID_HEADER, "EMACH_SEND_INVALID_HEADER", "")
#endif /* WSAEMACH_SEND_INVALID_HEADER && !EMACH_SEND_INVALID_HEADER */
ADD_ERRNO(WSAEMACH_SEND_INVALID_HEADER, "WSAEMACH_SEND_INVALID_HEADER", "")
#endif /* WSAEMACH_SEND_INVALID_HEADER */
#ifdef EMACH_SEND_INVALID_MEMORY
ADD_ERRNO(EMACH_SEND_INVALID_MEMORY, "EMACH_SEND_INVALID_MEMORY", "")
#endif /* EMACH_SEND_INVALID_MEMORY */
#ifdef WSAEMACH_SEND_INVALID_MEMORY
#ifndef EMACH_SEND_INVALID_MEMORY
ADD_ERRNO(WSAEMACH_SEND_INVALID_MEMORY, "EMACH_SEND_INVALID_MEMORY", "")
#endif /* WSAEMACH_SEND_INVALID_MEMORY && !EMACH_SEND_INVALID_MEMORY */
ADD_ERRNO(WSAEMACH_SEND_INVALID_MEMORY, "WSAEMACH_SEND_INVALID_MEMORY", "")
#endif /* WSAEMACH_SEND_INVALID_MEMORY */
#ifdef EMACH_SEND_INVALID_NOTIYF
ADD_ERRNO(EMACH_SEND_INVALID_NOTIYF, "EMACH_SEND_INVALID_NOTIYF", "")
#endif /* EMACH_SEND_INVALID_NOTIYF */
#ifdef WSAEMACH_SEND_INVALID_NOTIYF
#ifndef EMACH_SEND_INVALID_NOTIYF
ADD_ERRNO(WSAEMACH_SEND_INVALID_NOTIYF, "EMACH_SEND_INVALID_NOTIYF", "")
#endif /* WSAEMACH_SEND_INVALID_NOTIYF && !EMACH_SEND_INVALID_NOTIYF */
ADD_ERRNO(WSAEMACH_SEND_INVALID_NOTIYF, "WSAEMACH_SEND_INVALID_NOTIYF", "")
#endif /* WSAEMACH_SEND_INVALID_NOTIYF */
#ifdef EMACH_SEND_INVALID_REPLY
ADD_ERRNO(EMACH_SEND_INVALID_REPLY, "EMACH_SEND_INVALID_REPLY", "")
#endif /* EMACH_SEND_INVALID_REPLY */
#ifdef WSAEMACH_SEND_INVALID_REPLY
#ifndef EMACH_SEND_INVALID_REPLY
ADD_ERRNO(WSAEMACH_SEND_INVALID_REPLY, "EMACH_SEND_INVALID_REPLY", "")
#endif /* WSAEMACH_SEND_INVALID_REPLY && !EMACH_SEND_INVALID_REPLY */
ADD_ERRNO(WSAEMACH_SEND_INVALID_REPLY, "WSAEMACH_SEND_INVALID_REPLY", "")
#endif /* WSAEMACH_SEND_INVALID_REPLY */
#ifdef EMACH_SEND_INVALID_RIGHT
ADD_ERRNO(EMACH_SEND_INVALID_RIGHT, "EMACH_SEND_INVALID_RIGHT", "")
#endif /* EMACH_SEND_INVALID_RIGHT */
#ifdef WSAEMACH_SEND_INVALID_RIGHT
#ifndef EMACH_SEND_INVALID_RIGHT
ADD_ERRNO(WSAEMACH_SEND_INVALID_RIGHT, "EMACH_SEND_INVALID_RIGHT", "")
#endif /* WSAEMACH_SEND_INVALID_RIGHT && !EMACH_SEND_INVALID_RIGHT */
ADD_ERRNO(WSAEMACH_SEND_INVALID_RIGHT, "WSAEMACH_SEND_INVALID_RIGHT", "")
#endif /* WSAEMACH_SEND_INVALID_RIGHT */
#ifdef EMACH_SEND_INVALID_TYPE
ADD_ERRNO(EMACH_SEND_INVALID_TYPE, "EMACH_SEND_INVALID_TYPE", "")
#endif /* EMACH_SEND_INVALID_TYPE */
#ifdef WSAEMACH_SEND_INVALID_TYPE
#ifndef EMACH_SEND_INVALID_TYPE
ADD_ERRNO(WSAEMACH_SEND_INVALID_TYPE, "EMACH_SEND_INVALID_TYPE", "")
#endif /* WSAEMACH_SEND_INVALID_TYPE && !EMACH_SEND_INVALID_TYPE */
ADD_ERRNO(WSAEMACH_SEND_INVALID_TYPE, "WSAEMACH_SEND_INVALID_TYPE", "")
#endif /* WSAEMACH_SEND_INVALID_TYPE */
#ifdef EMACH_SEND_IN_PROGRESS
ADD_ERRNO(EMACH_SEND_IN_PROGRESS, "EMACH_SEND_IN_PROGRESS", "")
#endif /* EMACH_SEND_IN_PROGRESS */
#ifdef WSAEMACH_SEND_IN_PROGRESS
#ifndef EMACH_SEND_IN_PROGRESS
ADD_ERRNO(WSAEMACH_SEND_IN_PROGRESS, "EMACH_SEND_IN_PROGRESS", "")
#endif /* WSAEMACH_SEND_IN_PROGRESS && !EMACH_SEND_IN_PROGRESS */
ADD_ERRNO(WSAEMACH_SEND_IN_PROGRESS, "WSAEMACH_SEND_IN_PROGRESS", "")
#endif /* WSAEMACH_SEND_IN_PROGRESS */
#ifdef EMACH_SEND_MSG_TOO_SMALL
ADD_ERRNO(EMACH_SEND_MSG_TOO_SMALL, "EMACH_SEND_MSG_TOO_SMALL", "")
#endif /* EMACH_SEND_MSG_TOO_SMALL */
#ifdef WSAEMACH_SEND_MSG_TOO_SMALL
#ifndef EMACH_SEND_MSG_TOO_SMALL
ADD_ERRNO(WSAEMACH_SEND_MSG_TOO_SMALL, "EMACH_SEND_MSG_TOO_SMALL", "")
#endif /* WSAEMACH_SEND_MSG_TOO_SMALL && !EMACH_SEND_MSG_TOO_SMALL */
ADD_ERRNO(WSAEMACH_SEND_MSG_TOO_SMALL, "WSAEMACH_SEND_MSG_TOO_SMALL", "")
#endif /* WSAEMACH_SEND_MSG_TOO_SMALL */
#ifdef EMACH_SEND_NOTIFY_IN_PROGRESS
ADD_ERRNO(EMACH_SEND_NOTIFY_IN_PROGRESS, "EMACH_SEND_NOTIFY_IN_PROGRESS", "")
#endif /* EMACH_SEND_NOTIFY_IN_PROGRESS */
#ifdef WSAEMACH_SEND_NOTIFY_IN_PROGRESS
#ifndef EMACH_SEND_NOTIFY_IN_PROGRESS
ADD_ERRNO(WSAEMACH_SEND_NOTIFY_IN_PROGRESS, "EMACH_SEND_NOTIFY_IN_PROGRESS", "")
#endif /* WSAEMACH_SEND_NOTIFY_IN_PROGRESS && !EMACH_SEND_NOTIFY_IN_PROGRESS */
ADD_ERRNO(WSAEMACH_SEND_NOTIFY_IN_PROGRESS, "WSAEMACH_SEND_NOTIFY_IN_PROGRESS", "")
#endif /* WSAEMACH_SEND_NOTIFY_IN_PROGRESS */
#ifdef EMACH_SEND_NO_BUFFER
ADD_ERRNO(EMACH_SEND_NO_BUFFER, "EMACH_SEND_NO_BUFFER", "")
#endif /* EMACH_SEND_NO_BUFFER */
#ifdef WSAEMACH_SEND_NO_BUFFER
#ifndef EMACH_SEND_NO_BUFFER
ADD_ERRNO(WSAEMACH_SEND_NO_BUFFER, "EMACH_SEND_NO_BUFFER", "")
#endif /* WSAEMACH_SEND_NO_BUFFER && !EMACH_SEND_NO_BUFFER */
ADD_ERRNO(WSAEMACH_SEND_NO_BUFFER, "WSAEMACH_SEND_NO_BUFFER", "")
#endif /* WSAEMACH_SEND_NO_BUFFER */
#ifdef EMACH_SEND_NO_NOTIFY
ADD_ERRNO(EMACH_SEND_NO_NOTIFY, "EMACH_SEND_NO_NOTIFY", "")
#endif /* EMACH_SEND_NO_NOTIFY */
#ifdef WSAEMACH_SEND_NO_NOTIFY
#ifndef EMACH_SEND_NO_NOTIFY
ADD_ERRNO(WSAEMACH_SEND_NO_NOTIFY, "EMACH_SEND_NO_NOTIFY", "")
#endif /* WSAEMACH_SEND_NO_NOTIFY && !EMACH_SEND_NO_NOTIFY */
ADD_ERRNO(WSAEMACH_SEND_NO_NOTIFY, "WSAEMACH_SEND_NO_NOTIFY", "")
#endif /* WSAEMACH_SEND_NO_NOTIFY */
#ifdef EMACH_SEND_TIMED_OUT
ADD_ERRNO(EMACH_SEND_TIMED_OUT, "EMACH_SEND_TIMED_OUT", "")
#endif /* EMACH_SEND_TIMED_OUT */
#ifdef WSAEMACH_SEND_TIMED_OUT
#ifndef EMACH_SEND_TIMED_OUT
ADD_ERRNO(WSAEMACH_SEND_TIMED_OUT, "EMACH_SEND_TIMED_OUT", "")
#endif /* WSAEMACH_SEND_TIMED_OUT && !EMACH_SEND_TIMED_OUT */
ADD_ERRNO(WSAEMACH_SEND_TIMED_OUT, "WSAEMACH_SEND_TIMED_OUT", "")
#endif /* WSAEMACH_SEND_TIMED_OUT */
#ifdef EMACH_SEND_WILL_NOTIFY
ADD_ERRNO(EMACH_SEND_WILL_NOTIFY, "EMACH_SEND_WILL_NOTIFY", "")
#endif /* EMACH_SEND_WILL_NOTIFY */
#ifdef WSAEMACH_SEND_WILL_NOTIFY
#ifndef EMACH_SEND_WILL_NOTIFY
ADD_ERRNO(WSAEMACH_SEND_WILL_NOTIFY, "EMACH_SEND_WILL_NOTIFY", "")
#endif /* WSAEMACH_SEND_WILL_NOTIFY && !EMACH_SEND_WILL_NOTIFY */
ADD_ERRNO(WSAEMACH_SEND_WILL_NOTIFY, "WSAEMACH_SEND_WILL_NOTIFY", "")
#endif /* WSAEMACH_SEND_WILL_NOTIFY */
#ifdef EMIG_ARRAY_TOO_LARGE
ADD_ERRNO(EMIG_ARRAY_TOO_LARGE, "EMIG_ARRAY_TOO_LARGE", "")
#endif /* EMIG_ARRAY_TOO_LARGE */
#ifdef WSAEMIG_ARRAY_TOO_LARGE
#ifndef EMIG_ARRAY_TOO_LARGE
ADD_ERRNO(WSAEMIG_ARRAY_TOO_LARGE, "EMIG_ARRAY_TOO_LARGE", "")
#endif /* WSAEMIG_ARRAY_TOO_LARGE && !EMIG_ARRAY_TOO_LARGE */
ADD_ERRNO(WSAEMIG_ARRAY_TOO_LARGE, "WSAEMIG_ARRAY_TOO_LARGE", "")
#endif /* WSAEMIG_ARRAY_TOO_LARGE */
#ifdef EMIG_BAD_ARGUMENTS
ADD_ERRNO(EMIG_BAD_ARGUMENTS, "EMIG_BAD_ARGUMENTS", "")
#endif /* EMIG_BAD_ARGUMENTS */
#ifdef WSAEMIG_BAD_ARGUMENTS
#ifndef EMIG_BAD_ARGUMENTS
ADD_ERRNO(WSAEMIG_BAD_ARGUMENTS, "EMIG_BAD_ARGUMENTS", "")
#endif /* WSAEMIG_BAD_ARGUMENTS && !EMIG_BAD_ARGUMENTS */
ADD_ERRNO(WSAEMIG_BAD_ARGUMENTS, "WSAEMIG_BAD_ARGUMENTS", "")
#endif /* WSAEMIG_BAD_ARGUMENTS */
#ifdef EMIG_BAD_ID
ADD_ERRNO(EMIG_BAD_ID, "EMIG_BAD_ID", "")
#endif /* EMIG_BAD_ID */
#ifdef WSAEMIG_BAD_ID
#ifndef EMIG_BAD_ID
ADD_ERRNO(WSAEMIG_BAD_ID, "EMIG_BAD_ID", "")
#endif /* WSAEMIG_BAD_ID && !EMIG_BAD_ID */
ADD_ERRNO(WSAEMIG_BAD_ID, "WSAEMIG_BAD_ID", "")
#endif /* WSAEMIG_BAD_ID */
#ifdef EMIG_DESTROY_REQUEST
ADD_ERRNO(EMIG_DESTROY_REQUEST, "EMIG_DESTROY_REQUEST", "")
#endif /* EMIG_DESTROY_REQUEST */
#ifdef WSAEMIG_DESTROY_REQUEST
#ifndef EMIG_DESTROY_REQUEST
ADD_ERRNO(WSAEMIG_DESTROY_REQUEST, "EMIG_DESTROY_REQUEST", "")
#endif /* WSAEMIG_DESTROY_REQUEST && !EMIG_DESTROY_REQUEST */
ADD_ERRNO(WSAEMIG_DESTROY_REQUEST, "WSAEMIG_DESTROY_REQUEST", "")
#endif /* WSAEMIG_DESTROY_REQUEST */
#ifdef EMIG_EXCEPTION
ADD_ERRNO(EMIG_EXCEPTION, "EMIG_EXCEPTION", "")
#endif /* EMIG_EXCEPTION */
#ifdef WSAEMIG_EXCEPTION
#ifndef EMIG_EXCEPTION
ADD_ERRNO(WSAEMIG_EXCEPTION, "EMIG_EXCEPTION", "")
#endif /* WSAEMIG_EXCEPTION && !EMIG_EXCEPTION */
ADD_ERRNO(WSAEMIG_EXCEPTION, "WSAEMIG_EXCEPTION", "")
#endif /* WSAEMIG_EXCEPTION */
#ifdef EMIG_NO_REPLY
ADD_ERRNO(EMIG_NO_REPLY, "EMIG_NO_REPLY", "")
#endif /* EMIG_NO_REPLY */
#ifdef WSAEMIG_NO_REPLY
#ifndef EMIG_NO_REPLY
ADD_ERRNO(WSAEMIG_NO_REPLY, "EMIG_NO_REPLY", "")
#endif /* WSAEMIG_NO_REPLY && !EMIG_NO_REPLY */
ADD_ERRNO(WSAEMIG_NO_REPLY, "WSAEMIG_NO_REPLY", "")
#endif /* WSAEMIG_NO_REPLY */
#ifdef EMIG_REMOTE_ERROR
ADD_ERRNO(EMIG_REMOTE_ERROR, "EMIG_REMOTE_ERROR", "")
#endif /* EMIG_REMOTE_ERROR */
#ifdef WSAEMIG_REMOTE_ERROR
#ifndef EMIG_REMOTE_ERROR
ADD_ERRNO(WSAEMIG_REMOTE_ERROR, "EMIG_REMOTE_ERROR", "")
#endif /* WSAEMIG_REMOTE_ERROR && !EMIG_REMOTE_ERROR */
ADD_ERRNO(WSAEMIG_REMOTE_ERROR, "WSAEMIG_REMOTE_ERROR", "")
#endif /* WSAEMIG_REMOTE_ERROR */
#ifdef EMIG_REPLY_MISMATCH
ADD_ERRNO(EMIG_REPLY_MISMATCH, "EMIG_REPLY_MISMATCH", "")
#endif /* EMIG_REPLY_MISMATCH */
#ifdef WSAEMIG_REPLY_MISMATCH
#ifndef EMIG_REPLY_MISMATCH
ADD_ERRNO(WSAEMIG_REPLY_MISMATCH, "EMIG_REPLY_MISMATCH", "")
#endif /* WSAEMIG_REPLY_MISMATCH && !EMIG_REPLY_MISMATCH */
ADD_ERRNO(WSAEMIG_REPLY_MISMATCH, "WSAEMIG_REPLY_MISMATCH", "")
#endif /* WSAEMIG_REPLY_MISMATCH */
#ifdef EMIG_SERVER_DIED
ADD_ERRNO(EMIG_SERVER_DIED, "EMIG_SERVER_DIED", "")
#endif /* EMIG_SERVER_DIED */
#ifdef WSAEMIG_SERVER_DIED
#ifndef EMIG_SERVER_DIED
ADD_ERRNO(WSAEMIG_SERVER_DIED, "EMIG_SERVER_DIED", "")
#endif /* WSAEMIG_SERVER_DIED && !EMIG_SERVER_DIED */
ADD_ERRNO(WSAEMIG_SERVER_DIED, "WSAEMIG_SERVER_DIED", "")
#endif /* WSAEMIG_SERVER_DIED */
#ifdef EMIG_TYPE_ERROR
ADD_ERRNO(EMIG_TYPE_ERROR, "EMIG_TYPE_ERROR", "")
#endif /* EMIG_TYPE_ERROR */
#ifdef WSAEMIG_TYPE_ERROR
#ifndef EMIG_TYPE_ERROR
ADD_ERRNO(WSAEMIG_TYPE_ERROR, "EMIG_TYPE_ERROR", "")
#endif /* WSAEMIG_TYPE_ERROR && !EMIG_TYPE_ERROR */
ADD_ERRNO(WSAEMIG_TYPE_ERROR, "WSAEMIG_TYPE_ERROR", "")
#endif /* WSAEMIG_TYPE_ERROR */

/* C, POSIX and various UNIX errors. */
#ifdef E2BIG
ADD_ERRNO(E2BIG, "E2BIG", "Argument list too long")
#endif /* E2BIG */
#ifdef WSAE2BIG
#ifndef E2BIG
ADD_ERRNO(WSAE2BIG, "E2BIG", "Argument list too long")
#endif /* WSAE2BIG && !E2BIG */
ADD_ERRNO(WSAE2BIG, "WSAE2BIG", "Argument list too long")
#endif /* WSAE2BIG */
#ifdef EACCES
ADD_ERRNO(EACCES, "EACCES", "Permission denied")
#endif /* EACCES */
#ifdef WSAEACCES
#ifndef EACCES
ADD_ERRNO(WSAEACCES, "EACCES", "Permission denied")
#endif /* WSAEACCES && !EACCES */
ADD_ERRNO(WSAEACCES, "WSAEACCES", "Permission denied")
#endif /* WSAEACCES */
#ifdef EADDRINUSE
ADD_ERRNO(EADDRINUSE, "EADDRINUSE", "Address already in use")
#endif /* EADDRINUSE */
#ifdef WSAEADDRINUSE
#ifndef EADDRINUSE
ADD_ERRNO(WSAEADDRINUSE, "EADDRINUSE", "Address already in use")
#endif /* WSAEADDRINUSE && !EADDRINUSE */
ADD_ERRNO(WSAEADDRINUSE, "WSAEADDRINUSE", "Address already in use")
#endif /* WSAEADDRINUSE */
#ifdef EADDRNOTAVAIL
ADD_ERRNO(EADDRNOTAVAIL, "EADDRNOTAVAIL", "Cannot assign requested address")
#endif /* EADDRNOTAVAIL */
#ifdef WSAEADDRNOTAVAIL
#ifndef EADDRNOTAVAIL
ADD_ERRNO(WSAEADDRNOTAVAIL, "EADDRNOTAVAIL", "Cannot assign requested address")
#endif /* WSAEADDRNOTAVAIL && !EADDRNOTAVAIL */
ADD_ERRNO(WSAEADDRNOTAVAIL, "WSAEADDRNOTAVAIL", "Cannot assign requested address")
#endif /* WSAEADDRNOTAVAIL */
#ifdef EADV
ADD_ERRNO(EADV, "EADV", "Advertise error")
#endif /* EADV */
#ifdef WSAEADV
#ifndef EADV
ADD_ERRNO(WSAEADV, "EADV", "Advertise error")
#endif /* WSAEADV && !EADV */
ADD_ERRNO(WSAEADV, "WSAEADV", "Advertise error")
#endif /* WSAEADV */
#ifdef EAFNOSUPPORT
ADD_ERRNO(EAFNOSUPPORT, "EAFNOSUPPORT", "Address family not supported by protocol")
#endif /* EAFNOSUPPORT */
#ifdef WSAEAFNOSUPPORT
#ifndef EAFNOSUPPORT
ADD_ERRNO(WSAEAFNOSUPPORT, "EAFNOSUPPORT", "Address family not supported by protocol")
#endif /* WSAEAFNOSUPPORT && !EAFNOSUPPORT */
ADD_ERRNO(WSAEAFNOSUPPORT, "WSAEAFNOSUPPORT", "Address family not supported by protocol")
#endif /* WSAEAFNOSUPPORT */
#ifdef EAGAIN
ADD_ERRNO(EAGAIN, "EAGAIN", "Try again")
#endif /* EAGAIN */
#ifdef WSAEAGAIN
#ifndef EAGAIN
ADD_ERRNO(WSAEAGAIN, "EAGAIN", "Try again")
#endif /* WSAEAGAIN && !EAGAIN */
ADD_ERRNO(WSAEAGAIN, "WSAEAGAIN", "Try again")
#endif /* WSAEAGAIN */
#ifdef EAIO
ADD_ERRNO(EAIO, "EAIO", "Internal AIO operation complete")
#endif /* EAIO */
#ifdef WSAEAIO
#ifndef EAIO
ADD_ERRNO(WSAEAIO, "EAIO", "Internal AIO operation complete")
#endif /* WSAEAIO && !EAIO */
ADD_ERRNO(WSAEAIO, "WSAEAIO", "Internal AIO operation complete")
#endif /* WSAEAIO */
#ifdef EALREADY
ADD_ERRNO(EALREADY, "EALREADY", "Operation already in progress")
#endif /* EALREADY */
#ifdef WSAEALREADY
#ifndef EALREADY
ADD_ERRNO(WSAEALREADY, "EALREADY", "Operation already in progress")
#endif /* WSAEALREADY && !EALREADY */
ADD_ERRNO(WSAEALREADY, "WSAEALREADY", "Operation already in progress")
#endif /* WSAEALREADY */
#ifdef EAUTH
ADD_ERRNO(EAUTH, "EAUTH", "Authentication error")
#endif /* EAUTH */
#ifdef WSAEAUTH
#ifndef EAUTH
ADD_ERRNO(WSAEAUTH, "EAUTH", "Authentication error")
#endif /* WSAEAUTH && !EAUTH */
ADD_ERRNO(WSAEAUTH, "WSAEAUTH", "Authentication error")
#endif /* WSAEAUTH */
#ifdef EBACKGROUND
ADD_ERRNO(EBACKGROUND, "EBACKGROUND", "")
#endif /* EBACKGROUND */
#ifdef WSAEBACKGROUND
#ifndef EBACKGROUND
ADD_ERRNO(WSAEBACKGROUND, "EBACKGROUND", "")
#endif /* WSAEBACKGROUND && !EBACKGROUND */
ADD_ERRNO(WSAEBACKGROUND, "WSAEBACKGROUND", "")
#endif /* WSAEBACKGROUND */
#ifdef EBADARCH
ADD_ERRNO(EBADARCH, "EBADARCH", "Bad CPU type in executable")
#endif /* EBADARCH */
#ifdef WSAEBADARCH
#ifndef EBADARCH
ADD_ERRNO(WSAEBADARCH, "EBADARCH", "Bad CPU type in executable")
#endif /* WSAEBADARCH && !EBADARCH */
ADD_ERRNO(WSAEBADARCH, "WSAEBADARCH", "Bad CPU type in executable")
#endif /* WSAEBADARCH */
#ifdef EBADCALL
ADD_ERRNO(EBADCALL, "EBADCALL", "Illegal system call number (Minix)")
#endif /* EBADCALL */
#ifdef WSAEBADCALL
#ifndef EBADCALL
ADD_ERRNO(WSAEBADCALL, "EBADCALL", "Illegal system call number (Minix)")
#endif /* WSAEBADCALL && !EBADCALL */
ADD_ERRNO(WSAEBADCALL, "WSAEBADCALL", "Illegal system call number (Minix)")
#endif /* WSAEBADCALL */
#ifdef EBADCPU
ADD_ERRNO(EBADCPU, "EBADCPU", "Invalid CPU (Minix)")
#endif /* EBADCPU */
#ifdef WSAEBADCPU
#ifndef EBADCPU
ADD_ERRNO(WSAEBADCPU, "EBADCPU", "Invalid CPU (Minix)")
#endif /* WSAEBADCPU && !EBADCPU */
ADD_ERRNO(WSAEBADCPU, "WSAEBADCPU", "Invalid CPU (Minix)")
#endif /* WSAEBADCPU */
#ifdef EBADE
ADD_ERRNO(EBADE, "EBADE", "Invalid exchange")
#endif /* EBADE */
#ifdef WSAEBADE
#ifndef EBADE
ADD_ERRNO(WSAEBADE, "EBADE", "Invalid exchange")
#endif /* WSAEBADE && !EBADE */
ADD_ERRNO(WSAEBADE, "WSAEBADE", "Invalid exchange")
#endif /* WSAEBADE */
#ifdef EBADDEST
ADD_ERRNO(EBADDEST, "EBADDEST", "Not a valid destination address (Minix)")
#endif /* EBADDEST */
#ifdef WSAEBADDEST
#ifndef EBADDEST
ADD_ERRNO(WSAEBADDEST, "EBADDEST", "Not a valid destination address (Minix)")
#endif /* WSAEBADDEST && !EBADDEST */
ADD_ERRNO(WSAEBADDEST, "WSAEBADDEST", "Not a valid destination address (Minix)")
#endif /* WSAEBADDEST */
#ifdef EBADEPT
ADD_ERRNO(EBADEPT, "EBADEPT", "Invalid endpoint in OoQ message (Minix)")
#endif /* EBADEPT */
#ifdef WSAEBADEPT
#ifndef EBADEPT
ADD_ERRNO(WSAEBADEPT, "EBADEPT", "Invalid endpoint in OoQ message (Minix)")
#endif /* WSAEBADEPT && !EBADEPT */
ADD_ERRNO(WSAEBADEPT, "WSAEBADEPT", "Invalid endpoint in OoQ message (Minix)")
#endif /* WSAEBADEPT */
#ifdef EBADEXEC
ADD_ERRNO(EBADEXEC, "EBADEXEC", "Bad executable")
#endif /* EBADEXEC */
#ifdef WSAEBADEXEC
#ifndef EBADEXEC
ADD_ERRNO(WSAEBADEXEC, "EBADEXEC", "Bad executable")
#endif /* WSAEBADEXEC && !EBADEXEC */
ADD_ERRNO(WSAEBADEXEC, "WSAEBADEXEC", "Bad executable")
#endif /* WSAEBADEXEC */
#ifdef EBADF
ADD_ERRNO(EBADF, "EBADF", "Bad file number")
#endif /* EBADF */
#ifdef WSAEBADF
#ifndef EBADF
ADD_ERRNO(WSAEBADF, "EBADF", "Bad file number")
#endif /* WSAEBADF && !EBADF */
ADD_ERRNO(WSAEBADF, "WSAEBADF", "Bad file number")
#endif /* WSAEBADF */
#ifdef EBADFD
ADD_ERRNO(EBADFD, "EBADFD", "File descriptor invalid for this operation")
#endif /* EBADFD */
#ifdef WSAEBADFD
#ifndef EBADFD
ADD_ERRNO(WSAEBADFD, "EBADFD", "File descriptor invalid for this operation")
#endif /* WSAEBADFD && !EBADFD */
ADD_ERRNO(WSAEBADFD, "WSAEBADFD", "File descriptor invalid for this operation")
#endif /* WSAEBADFD */
#ifdef EBADFILT
ADD_ERRNO(EBADFILT, "EBADFILT", "")
#endif /* EBADFILT */
#ifdef WSAEBADFILT
#ifndef EBADFILT
ADD_ERRNO(WSAEBADFILT, "EBADFILT", "")
#endif /* WSAEBADFILT && !EBADFILT */
ADD_ERRNO(WSAEBADFILT, "WSAEBADFILT", "")
#endif /* WSAEBADFILT */
#ifdef EBADFSYS
ADD_ERRNO(EBADFSYS, "EBADFSYS", "Corrupted file system detected")
#endif /* EBADFSYS */
#ifdef WSAEBADFSYS
#ifndef EBADFSYS
ADD_ERRNO(WSAEBADFSYS, "EBADFSYS", "Corrupted file system detected")
#endif /* WSAEBADFSYS && !EBADFSYS */
ADD_ERRNO(WSAEBADFSYS, "WSAEBADFSYS", "Corrupted file system detected")
#endif /* WSAEBADFSYS */
#ifdef EBADIOCTL
ADD_ERRNO(EBADIOCTL, "EBADIOCTL", "Illegal ioctl for device (Minix)")
#endif /* EBADIOCTL */
#ifdef WSAEBADIOCTL
#ifndef EBADIOCTL
ADD_ERRNO(WSAEBADIOCTL, "EBADIOCTL", "Illegal ioctl for device (Minix)")
#endif /* WSAEBADIOCTL && !EBADIOCTL */
ADD_ERRNO(WSAEBADIOCTL, "WSAEBADIOCTL", "Illegal ioctl for device (Minix)")
#endif /* WSAEBADIOCTL */
#ifdef EBADMACHO
ADD_ERRNO(EBADMACHO, "EBADMACHO", "Malformed Macho file")
#endif /* EBADMACHO */
#ifdef WSAEBADMACHO
#ifndef EBADMACHO
ADD_ERRNO(WSAEBADMACHO, "EBADMACHO", "Malformed Macho file")
#endif /* WSAEBADMACHO && !EBADMACHO */
ADD_ERRNO(WSAEBADMACHO, "WSAEBADMACHO", "Malformed Macho file")
#endif /* WSAEBADMACHO */
#ifdef EBADMODE
ADD_ERRNO(EBADMODE, "EBADMODE", "Bad mode in ioctl (Minix)")
#endif /* EBADMODE */
#ifdef WSAEBADMODE
#ifndef EBADMODE
ADD_ERRNO(WSAEBADMODE, "EBADMODE", "Bad mode in ioctl (Minix)")
#endif /* WSAEBADMODE && !EBADMODE */
ADD_ERRNO(WSAEBADMODE, "WSAEBADMODE", "Bad mode in ioctl (Minix)")
#endif /* WSAEBADMODE */
#ifdef EBADMSG
ADD_ERRNO(EBADMSG, "EBADMSG", "Not a data message")
#endif /* EBADMSG */
#ifdef WSAEBADMSG
#ifndef EBADMSG
ADD_ERRNO(WSAEBADMSG, "EBADMSG", "Not a data message")
#endif /* WSAEBADMSG && !EBADMSG */
ADD_ERRNO(WSAEBADMSG, "WSAEBADMSG", "Not a data message")
#endif /* WSAEBADMSG */
#ifdef EBADR
ADD_ERRNO(EBADR, "EBADR", "Invalid request descriptor")
#endif /* EBADR */
#ifdef WSAEBADR
#ifndef EBADR
ADD_ERRNO(WSAEBADR, "EBADR", "Invalid request descriptor")
#endif /* WSAEBADR && !EBADR */
ADD_ERRNO(WSAEBADR, "WSAEBADR", "Invalid request descriptor")
#endif /* WSAEBADR */
#ifdef EBADREQUEST
ADD_ERRNO(EBADREQUEST, "EBADREQUEST", "Destination cannot handle request (Minix)")
#endif /* EBADREQUEST */
#ifdef WSAEBADREQUEST
#ifndef EBADREQUEST
ADD_ERRNO(WSAEBADREQUEST, "EBADREQUEST", "Destination cannot handle request (Minix)")
#endif /* WSAEBADREQUEST && !EBADREQUEST */
ADD_ERRNO(WSAEBADREQUEST, "WSAEBADREQUEST", "Destination cannot handle request (Minix)")
#endif /* WSAEBADREQUEST */
#ifdef EBADRPC
ADD_ERRNO(EBADRPC, "EBADRPC", "RPC struct is bad")
#endif /* EBADRPC */
#ifdef WSAEBADRPC
#ifndef EBADRPC
ADD_ERRNO(WSAEBADRPC, "EBADRPC", "RPC struct is bad")
#endif /* WSAEBADRPC && !EBADRPC */
ADD_ERRNO(WSAEBADRPC, "WSAEBADRPC", "RPC struct is bad")
#endif /* WSAEBADRPC */
#ifdef EBADRQC
ADD_ERRNO(EBADRQC, "EBADRQC", "Invalid request code")
#endif /* EBADRQC */
#ifdef WSAEBADRQC
#ifndef EBADRQC
ADD_ERRNO(WSAEBADRQC, "EBADRQC", "Invalid request code")
#endif /* WSAEBADRQC && !EBADRQC */
ADD_ERRNO(WSAEBADRQC, "WSAEBADRQC", "Invalid request code")
#endif /* WSAEBADRQC */
#ifdef EBADRSPEC
ADD_ERRNO(EBADRSPEC, "EBADRSPEC", "")
#endif /* EBADRSPEC */
#ifdef WSAEBADRSPEC
#ifndef EBADRSPEC
ADD_ERRNO(WSAEBADRSPEC, "EBADRSPEC", "")
#endif /* WSAEBADRSPEC && !EBADRSPEC */
ADD_ERRNO(WSAEBADRSPEC, "WSAEBADRSPEC", "")
#endif /* WSAEBADRSPEC */
#ifdef EBADSLT
ADD_ERRNO(EBADSLT, "EBADSLT", "Invalid slot")
#endif /* EBADSLT */
#ifdef WSAEBADSLT
#ifndef EBADSLT
ADD_ERRNO(WSAEBADSLT, "EBADSLT", "Invalid slot")
#endif /* WSAEBADSLT && !EBADSLT */
ADD_ERRNO(WSAEBADSLT, "WSAEBADSLT", "Invalid slot")
#endif /* WSAEBADSLT */
#ifdef EBADSRCDST
ADD_ERRNO(EBADSRCDST, "EBADSRCDST", "Bad source or destination process (Minix)")
#endif /* EBADSRCDST */
#ifdef WSAEBADSRCDST
#ifndef EBADSRCDST
ADD_ERRNO(WSAEBADSRCDST, "EBADSRCDST", "Bad source or destination process (Minix)")
#endif /* WSAEBADSRCDST && !EBADSRCDST */
ADD_ERRNO(WSAEBADSRCDST, "WSAEBADSRCDST", "Bad source or destination process (Minix)")
#endif /* WSAEBADSRCDST */
#ifdef EBADTSPEC
ADD_ERRNO(EBADTSPEC, "EBADTSPEC", "")
#endif /* EBADTSPEC */
#ifdef WSAEBADTSPEC
#ifndef EBADTSPEC
ADD_ERRNO(WSAEBADTSPEC, "EBADTSPEC", "")
#endif /* WSAEBADTSPEC && !EBADTSPEC */
ADD_ERRNO(WSAEBADTSPEC, "WSAEBADTSPEC", "")
#endif /* WSAEBADTSPEC */
#ifdef EBADVER
ADD_ERRNO(EBADVER, "EBADVER", "Version number mismatch for loadable kernel module")
#endif /* EBADVER */
#ifdef WSAEBADVER
#ifndef EBADVER
ADD_ERRNO(WSAEBADVER, "EBADVER", "Version number mismatch for loadable kernel module")
#endif /* WSAEBADVER && !EBADVER */
ADD_ERRNO(WSAEBADVER, "WSAEBADVER", "Version number mismatch for loadable kernel module")
#endif /* WSAEBADVER */
#ifdef EBDHDL
ADD_ERRNO(EBDHDL, "EBDHDL", "")
#endif /* EBDHDL */
#ifdef WSAEBDHDL
#ifndef EBDHDL
ADD_ERRNO(WSAEBDHDL, "EBDHDL", "")
#endif /* WSAEBDHDL && !EBDHDL */
ADD_ERRNO(WSAEBDHDL, "WSAEBDHDL", "")
#endif /* WSAEBDHDL */
#ifdef EBFONT
ADD_ERRNO(EBFONT, "EBFONT", "Bad font file format")
#endif /* EBFONT */
#ifdef WSAEBFONT
#ifndef EBFONT
ADD_ERRNO(WSAEBFONT, "EBFONT", "Bad font file format")
#endif /* WSAEBFONT && !EBFONT */
ADD_ERRNO(WSAEBFONT, "WSAEBFONT", "Bad font file format")
#endif /* WSAEBFONT */
#ifdef EBUFSIZE
ADD_ERRNO(EBUFSIZE, "EBUFSIZE", "")
#endif /* EBUFSIZE */
#ifdef WSAEBUFSIZE
#ifndef EBUFSIZE
ADD_ERRNO(WSAEBUFSIZE, "EBUFSIZE", "")
#endif /* WSAEBUFSIZE && !EBUFSIZE */
ADD_ERRNO(WSAEBUFSIZE, "WSAEBUFSIZE", "")
#endif /* WSAEBUFSIZE */
#ifdef EBUSY
ADD_ERRNO(EBUSY, "EBUSY", "Device or resource busy")
#endif /* EBUSY */
#ifdef WSAEBUSY
#ifndef EBUSY
ADD_ERRNO(WSAEBUSY, "EBUSY", "Device or resource busy")
#endif /* WSAEBUSY && !EBUSY */
ADD_ERRNO(WSAEBUSY, "WSAEBUSY", "Device or resource busy")
#endif /* WSAEBUSY */
#ifdef ECALLDENIED
ADD_ERRNO(ECALLDENIED, "ECALLDENIED", "No permission for system call (Minix)")
#endif /* ECALLDENIED */
#ifdef WSAECALLDENIED
#ifndef ECALLDENIED
ADD_ERRNO(WSAECALLDENIED, "ECALLDENIED", "No permission for system call (Minix)")
#endif /* WSAECALLDENIED && !ECALLDENIED */
ADD_ERRNO(WSAECALLDENIED, "WSAECALLDENIED", "No permission for system call (Minix)")
#endif /* WSAECALLDENIED */
#ifdef ECANCELED
ADD_ERRNO(ECANCELED, "ECANCELED", "Operation cancelled")
#endif /* ECANCELED */
#ifdef WSAECANCELED
#ifndef ECANCELED
ADD_ERRNO(WSAECANCELED, "ECANCELED", "Operation cancelled")
#endif /* WSAECANCELED && !ECANCELED */
ADD_ERRNO(WSAECANCELED, "WSAECANCELED", "Operation cancelled")
#endif /* WSAECANCELED */
#ifdef ECANTEXTENT
ADD_ERRNO(ECANTEXTENT, "ECANTEXTENT", "")
#endif /* ECANTEXTENT */
#ifdef WSAECANTEXTENT
#ifndef ECANTEXTENT
ADD_ERRNO(WSAECANTEXTENT, "ECANTEXTENT", "")
#endif /* WSAECANTEXTENT && !ECANTEXTENT */
ADD_ERRNO(WSAECANTEXTENT, "WSAECANTEXTENT", "")
#endif /* WSAECANTEXTENT */
#ifdef ECAPMODE
ADD_ERRNO(ECAPMODE, "ECAPMODE", "")
#endif /* ECAPMODE */
#ifdef WSAECAPMODE
#ifndef ECAPMODE
ADD_ERRNO(WSAECAPMODE, "ECAPMODE", "")
#endif /* WSAECAPMODE && !ECAPMODE */
ADD_ERRNO(WSAECAPMODE, "WSAECAPMODE", "")
#endif /* WSAECAPMODE */
#ifdef ECASECLASH
ADD_ERRNO(ECASECLASH, "ECASECLASH", "")
#endif /* ECASECLASH */
#ifdef WSAECASECLASH
#ifndef ECASECLASH
ADD_ERRNO(WSAECASECLASH, "ECASECLASH", "")
#endif /* WSAECASECLASH && !ECASECLASH */
ADD_ERRNO(WSAECASECLASH, "WSAECASECLASH", "")
#endif /* WSAECASECLASH */
#ifdef ECELLDOWN
ADD_ERRNO(ECELLDOWN, "ECELLDOWN", "")
#endif /* ECELLDOWN */
#ifdef WSAECELLDOWN
#ifndef ECELLDOWN
ADD_ERRNO(WSAECELLDOWN, "ECELLDOWN", "")
#endif /* WSAECELLDOWN && !ECELLDOWN */
ADD_ERRNO(WSAECELLDOWN, "WSAECELLDOWN", "")
#endif /* WSAECELLDOWN */
#ifdef ECHILD
ADD_ERRNO(ECHILD, "ECHILD", "No child processes")
#endif /* ECHILD */
#ifdef WSAECHILD
#ifndef ECHILD
ADD_ERRNO(WSAECHILD, "ECHILD", "No child processes")
#endif /* WSAECHILD && !ECHILD */
ADD_ERRNO(WSAECHILD, "WSAECHILD", "No child processes")
#endif /* WSAECHILD */
#ifdef ECHRNG
ADD_ERRNO(ECHRNG, "ECHRNG", "Channel number out of range")
#endif /* ECHRNG */
#ifdef WSAECHRNG
#ifndef ECHRNG
ADD_ERRNO(WSAECHRNG, "ECHRNG", "Channel number out of range")
#endif /* WSAECHRNG && !ECHRNG */
ADD_ERRNO(WSAECHRNG, "WSAECHRNG", "Channel number out of range")
#endif /* WSAECHRNG */
#ifdef ECKPT
ADD_ERRNO(ECKPT, "ECKPT", "POSIX checkpoint/restart error")
#endif /* ECKPT */
#ifdef WSAECKPT
#ifndef ECKPT
ADD_ERRNO(WSAECKPT, "ECKPT", "POSIX checkpoint/restart error")
#endif /* WSAECKPT && !ECKPT */
ADD_ERRNO(WSAECKPT, "WSAECKPT", "POSIX checkpoint/restart error")
#endif /* WSAECKPT */
#ifdef ECLOCKCPU
ADD_ERRNO(ECLOCKCPU, "ECLOCKCPU", "")
#endif /* ECLOCKCPU */
#ifdef WSAECLOCKCPU
#ifndef ECLOCKCPU
ADD_ERRNO(WSAECLOCKCPU, "ECLOCKCPU", "")
#endif /* WSAECLOCKCPU && !ECLOCKCPU */
ADD_ERRNO(WSAECLOCKCPU, "WSAECLOCKCPU", "")
#endif /* WSAECLOCKCPU */
#ifdef ECLONEME
ADD_ERRNO(ECLONEME, "ECLONEME", "Stream needs restart")
#endif /* ECLONEME */
#ifdef WSAECLONEME
#ifndef ECLONEME
ADD_ERRNO(WSAECLONEME, "ECLONEME", "Stream needs restart")
#endif /* WSAECLONEME && !ECLONEME */
ADD_ERRNO(WSAECLONEME, "WSAECLONEME", "Stream needs restart")
#endif /* WSAECLONEME */
#ifdef ECOMM
ADD_ERRNO(ECOMM, "ECOMM", "Communication error on send")
#endif /* ECOMM */
#ifdef WSAECOMM
#ifndef ECOMM
ADD_ERRNO(WSAECOMM, "ECOMM", "Communication error on send")
#endif /* WSAECOMM && !ECOMM */
ADD_ERRNO(WSAECOMM, "WSAECOMM", "Communication error on send")
#endif /* WSAECOMM */
#ifdef ECONFIG
ADD_ERRNO(ECONFIG, "ECONFIG", "Configurable kernel resource exhausted")
#endif /* ECONFIG */
#ifdef WSAECONFIG
#ifndef ECONFIG
ADD_ERRNO(WSAECONFIG, "ECONFIG", "Configurable kernel resource exhausted")
#endif /* WSAECONFIG && !ECONFIG */
ADD_ERRNO(WSAECONFIG, "WSAECONFIG", "Configurable kernel resource exhausted")
#endif /* WSAECONFIG */
#ifdef ECONNABORTED
ADD_ERRNO(ECONNABORTED, "ECONNABORTED", "Software caused connection abort")
#endif /* ECONNABORTED */
#ifdef WSAECONNABORTED
#ifndef ECONNABORTED
ADD_ERRNO(WSAECONNABORTED, "ECONNABORTED", "Software caused connection abort")
#endif /* WSAECONNABORTED && !ECONNABORTED */
ADD_ERRNO(WSAECONNABORTED, "WSAECONNABORTED", "Software caused connection abort")
#endif /* WSAECONNABORTED */
#ifdef ECONNREFUSED
ADD_ERRNO(ECONNREFUSED, "ECONNREFUSED", "Connection refused")
#endif /* ECONNREFUSED */
#ifdef WSAECONNREFUSED
#ifndef ECONNREFUSED
ADD_ERRNO(WSAECONNREFUSED, "ECONNREFUSED", "Connection refused")
#endif /* WSAECONNREFUSED && !ECONNREFUSED */
ADD_ERRNO(WSAECONNREFUSED, "WSAECONNREFUSED", "Connection refused")
#endif /* WSAECONNREFUSED */
#ifdef ECONNRESET
ADD_ERRNO(ECONNRESET, "ECONNRESET", "Connection reset by peer")
#endif /* ECONNRESET */
#ifdef WSAECONNRESET
#ifndef ECONNRESET
ADD_ERRNO(WSAECONNRESET, "ECONNRESET", "Connection reset by peer")
#endif /* WSAECONNRESET && !ECONNRESET */
ADD_ERRNO(WSAECONNRESET, "WSAECONNRESET", "Connection reset by peer")
#endif /* WSAECONNRESET */
#ifdef ECONTROLLER
ADD_ERRNO(ECONTROLLER, "ECONTROLLER", "")
#endif /* ECONTROLLER */
#ifdef WSAECONTROLLER
#ifndef ECONTROLLER
ADD_ERRNO(WSAECONTROLLER, "ECONTROLLER", "")
#endif /* WSAECONTROLLER && !ECONTROLLER */
ADD_ERRNO(WSAECONTROLLER, "WSAECONTROLLER", "")
#endif /* WSAECONTROLLER */
#ifdef ECORRUPT
ADD_ERRNO(ECORRUPT, "ECORRUPT", "Invalid file system control data")
#endif /* ECORRUPT */
#ifdef WSAECORRUPT
#ifndef ECORRUPT
ADD_ERRNO(WSAECORRUPT, "ECORRUPT", "Invalid file system control data")
#endif /* WSAECORRUPT && !ECORRUPT */
ADD_ERRNO(WSAECORRUPT, "WSAECORRUPT", "Invalid file system control data")
#endif /* WSAECORRUPT */
#ifdef ECTRLTERM
ADD_ERRNO(ECTRLTERM, "ECTRLTERM", "Remap to controlling terminal")
#endif /* ECTRLTERM */
#ifdef WSAECTRLTERM
#ifndef ECTRLTERM
ADD_ERRNO(WSAECTRLTERM, "ECTRLTERM", "Remap to controlling terminal")
#endif /* WSAECTRLTERM && !ECTRLTERM */
ADD_ERRNO(WSAECTRLTERM, "WSAECTRLTERM", "Remap to controlling terminal")
#endif /* WSAECTRLTERM */
#ifdef ED
ADD_ERRNO(ED, "ED", "")
#endif /* ED */
#ifdef WSAED
#ifndef ED
ADD_ERRNO(WSAED, "ED", "")
#endif /* WSAED && !ED */
ADD_ERRNO(WSAED, "WSAED", "")
#endif /* WSAED */
#ifdef EDEADEPT
ADD_ERRNO(EDEADEPT, "EDEADEPT", "Bad kernel endpoint (Minix)")
#endif /* EDEADEPT */
#ifdef WSAEDEADEPT
#ifndef EDEADEPT
ADD_ERRNO(WSAEDEADEPT, "EDEADEPT", "Bad kernel endpoint (Minix)")
#endif /* WSAEDEADEPT && !EDEADEPT */
ADD_ERRNO(WSAEDEADEPT, "WSAEDEADEPT", "Bad kernel endpoint (Minix)")
#endif /* WSAEDEADEPT */
#ifdef EDEADLK
ADD_ERRNO(EDEADLK, "EDEADLK", "Resource deadlock would occur")
#endif /* EDEADLK */
#ifdef WSAEDEADLK
#ifndef EDEADLK
ADD_ERRNO(WSAEDEADLK, "EDEADLK", "Resource deadlock would occur")
#endif /* WSAEDEADLK && !EDEADLK */
ADD_ERRNO(WSAEDEADLK, "WSAEDEADLK", "Resource deadlock would occur")
#endif /* WSAEDEADLK */
#ifdef EDEADLOCK
ADD_ERRNO(EDEADLOCK, "EDEADLOCK", "Resource deadlock would occur")
#endif /* EDEADLOCK */
#ifdef WSAEDEADLOCK
#ifndef EDEADLOCK
ADD_ERRNO(WSAEDEADLOCK, "EDEADLOCK", "Resource deadlock would occur")
#endif /* WSAEDEADLOCK && !EDEADLOCK */
ADD_ERRNO(WSAEDEADLOCK, "WSAEDEADLOCK", "Resource deadlock would occur")
#endif /* WSAEDEADLOCK */
#ifdef EDEADSRCDST
ADD_ERRNO(EDEADSRCDST, "EDEADSRCDST", "Source or destination is not alive (Minix)")
#endif /* EDEADSRCDST */
#ifdef WSAEDEADSRCDST
#ifndef EDEADSRCDST
ADD_ERRNO(WSAEDEADSRCDST, "EDEADSRCDST", "Source or destination is not alive (Minix)")
#endif /* WSAEDEADSRCDST && !EDEADSRCDST */
ADD_ERRNO(WSAEDEADSRCDST, "WSAEDEADSRCDST", "Source or destination is not alive (Minix)")
#endif /* WSAEDEADSRCDST */
#ifdef EDELAY
ADD_ERRNO(EDELAY, "EDELAY", "")
#endif /* EDELAY */
#ifdef WSAEDELAY
#ifndef EDELAY
ADD_ERRNO(WSAEDELAY, "EDELAY", "")
#endif /* WSAEDELAY && !EDELAY */
ADD_ERRNO(WSAEDELAY, "WSAEDELAY", "")
#endif /* WSAEDELAY */
#ifdef EDESTADDREQ
ADD_ERRNO(EDESTADDREQ, "EDESTADDREQ", "Destination address required")
#endif /* EDESTADDREQ */
#ifdef WSAEDESTADDREQ
#ifndef EDESTADDREQ
ADD_ERRNO(WSAEDESTADDREQ, "EDESTADDREQ", "Destination address required")
#endif /* WSAEDESTADDREQ && !EDESTADDREQ */
ADD_ERRNO(WSAEDESTADDREQ, "WSAEDESTADDREQ", "Destination address required")
#endif /* WSAEDESTADDREQ */
#ifdef EDESTADDRREQ
ADD_ERRNO(EDESTADDRREQ, "EDESTADDRREQ", "Destination address required")
#endif /* EDESTADDRREQ */
#ifdef WSAEDESTADDRREQ
#ifndef EDESTADDRREQ
ADD_ERRNO(WSAEDESTADDRREQ, "EDESTADDRREQ", "Destination address required")
#endif /* WSAEDESTADDRREQ && !EDESTADDRREQ */
ADD_ERRNO(WSAEDESTADDRREQ, "WSAEDESTADDRREQ", "Destination address required")
#endif /* WSAEDESTADDRREQ */
#ifdef EDESTROYED
ADD_ERRNO(EDESTROYED, "EDESTROYED", "")
#endif /* EDESTROYED */
#ifdef WSAEDESTROYED
#ifndef EDESTROYED
ADD_ERRNO(WSAEDESTROYED, "EDESTROYED", "")
#endif /* WSAEDESTROYED && !EDESTROYED */
ADD_ERRNO(WSAEDESTROYED, "WSAEDESTROYED", "")
#endif /* WSAEDESTROYED */
#ifdef EDEVERR
ADD_ERRNO(EDEVERR, "EDEVERR", "Device error, e.g. paper out")
#endif /* EDEVERR */
#ifdef WSAEDEVERR
#ifndef EDEVERR
ADD_ERRNO(WSAEDEVERR, "EDEVERR", "Device error, e.g. paper out")
#endif /* WSAEDEVERR && !EDEVERR */
ADD_ERRNO(WSAEDEVERR, "WSAEDEVERR", "Device error, e.g. paper out")
#endif /* WSAEDEVERR */
#ifdef EDIED
ADD_ERRNO(EDIED, "EDIED", "")
#endif /* EDIED */
#ifdef WSAEDIED
#ifndef EDIED
ADD_ERRNO(WSAEDIED, "EDIED", "")
#endif /* WSAEDIED && !EDIED */
ADD_ERRNO(WSAEDIED, "WSAEDIED", "")
#endif /* WSAEDIED */
#ifdef EDIRCORRUPTED
ADD_ERRNO(EDIRCORRUPTED, "EDIRCORRUPTED", "")
#endif /* EDIRCORRUPTED */
#ifdef WSAEDIRCORRUPTED
#ifndef EDIRCORRUPTED
ADD_ERRNO(WSAEDIRCORRUPTED, "EDIRCORRUPTED", "")
#endif /* WSAEDIRCORRUPTED && !EDIRCORRUPTED */
ADD_ERRNO(WSAEDIRCORRUPTED, "WSAEDIRCORRUPTED", "")
#endif /* WSAEDIRCORRUPTED */
#ifdef EDIRIOCTL
ADD_ERRNO(EDIRIOCTL, "EDIRIOCTL", "")
#endif /* EDIRIOCTL */
#ifdef WSAEDIRIOCTL
#ifndef EDIRIOCTL
ADD_ERRNO(WSAEDIRIOCTL, "EDIRIOCTL", "")
#endif /* WSAEDIRIOCTL && !EDIRIOCTL */
ADD_ERRNO(WSAEDIRIOCTL, "WSAEDIRIOCTL", "")
#endif /* WSAEDIRIOCTL */
#ifdef EDIRTY
ADD_ERRNO(EDIRTY, "EDIRTY", "Mounting a dirty file system with out force")
#endif /* EDIRTY */
#ifdef WSAEDIRTY
#ifndef EDIRTY
ADD_ERRNO(WSAEDIRTY, "EDIRTY", "Mounting a dirty file system with out force")
#endif /* WSAEDIRTY && !EDIRTY */
ADD_ERRNO(WSAEDIRTY, "WSAEDIRTY", "Mounting a dirty file system with out force")
#endif /* WSAEDIRTY */
#ifdef EDISJOINT
ADD_ERRNO(EDISJOINT, "EDISJOINT", "")
#endif /* EDISJOINT */
#ifdef WSAEDISJOINT
#ifndef EDISJOINT
ADD_ERRNO(WSAEDISJOINT, "EDISJOINT", "")
#endif /* WSAEDISJOINT && !EDISJOINT */
ADD_ERRNO(WSAEDISJOINT, "WSAEDISJOINT", "")
#endif /* WSAEDISJOINT */
#ifdef EDIST
ADD_ERRNO(EDIST, "EDIST", "")
#endif /* EDIST */
#ifdef WSAEDIST
#ifndef EDIST
ADD_ERRNO(WSAEDIST, "EDIST", "")
#endif /* WSAEDIST && !EDIST */
ADD_ERRNO(WSAEDIST, "WSAEDIST", "")
#endif /* WSAEDIST */
#ifdef EDOM
ADD_ERRNO(EDOM, "EDOM", "Math argument out of domain of function")
#endif /* EDOM */
#ifdef WSAEDOM
#ifndef EDOM
ADD_ERRNO(WSAEDOM, "EDOM", "Math argument out of domain of function")
#endif /* WSAEDOM && !EDOM */
ADD_ERRNO(WSAEDOM, "WSAEDOM", "Math argument out of domain of function")
#endif /* WSAEDOM */
#ifdef EDONTREPLY
ADD_ERRNO(EDONTREPLY, "EDONTREPLY", "Pseudo-code: don't send a reply (Minix)")
#endif /* EDONTREPLY */
#ifdef WSAEDONTREPLY
#ifndef EDONTREPLY
ADD_ERRNO(WSAEDONTREPLY, "EDONTREPLY", "Pseudo-code: don't send a reply (Minix)")
#endif /* WSAEDONTREPLY && !EDONTREPLY */
ADD_ERRNO(WSAEDONTREPLY, "WSAEDONTREPLY", "Pseudo-code: don't send a reply (Minix)")
#endif /* WSAEDONTREPLY */
#ifdef EDOOFUS
ADD_ERRNO(EDOOFUS, "EDOOFUS", "Programming error")
#endif /* EDOOFUS */
#ifdef WSAEDOOFUS
#ifndef EDOOFUS
ADD_ERRNO(WSAEDOOFUS, "EDOOFUS", "Programming error")
#endif /* WSAEDOOFUS && !EDOOFUS */
ADD_ERRNO(WSAEDOOFUS, "WSAEDOOFUS", "Programming error")
#endif /* WSAEDOOFUS */
#ifdef EDOTDOT
ADD_ERRNO(EDOTDOT, "EDOTDOT", "RFC specific error")
#endif /* EDOTDOT */
#ifdef WSAEDOTDOT
#ifndef EDOTDOT
ADD_ERRNO(WSAEDOTDOT, "EDOTDOT", "RFC specific error")
#endif /* WSAEDOTDOT && !EDOTDOT */
ADD_ERRNO(WSAEDOTDOT, "WSAEDOTDOT", "RFC specific error")
#endif /* WSAEDOTDOT */
#ifdef EDQUOT
ADD_ERRNO(EDQUOT, "EDQUOT", "Disc quota exceeded")
#endif /* EDQUOT */
#ifdef WSAEDQUOT
#ifndef EDQUOT
ADD_ERRNO(WSAEDQUOT, "EDQUOT", "Disc quota exceeded")
#endif /* WSAEDQUOT && !EDQUOT */
ADD_ERRNO(WSAEDQUOT, "WSAEDQUOT", "Disc quota exceeded")
#endif /* WSAEDQUOT */
#ifdef EDSTDIED
ADD_ERRNO(EDSTDIED, "EDSTDIED", "Destination just died (Minix)")
#endif /* EDSTDIED */
#ifdef WSAEDSTDIED
#ifndef EDSTDIED
ADD_ERRNO(WSAEDSTDIED, "EDSTDIED", "Destination just died (Minix)")
#endif /* WSAEDSTDIED && !EDSTDIED */
ADD_ERRNO(WSAEDSTDIED, "WSAEDSTDIED", "Destination just died (Minix)")
#endif /* WSAEDSTDIED */
#ifdef EDSTNOTTCH
ADD_ERRNO(EDSTNOTTCH, "EDSTNOTTCH", "Destination not reachable (Minix)")
#endif /* EDSTNOTTCH */
#ifdef WSAEDSTNOTTCH
#ifndef EDSTNOTTCH
ADD_ERRNO(WSAEDSTNOTTCH, "EDSTNOTTCH", "Destination not reachable (Minix)")
#endif /* WSAEDSTNOTTCH && !EDSTNOTTCH */
ADD_ERRNO(WSAEDSTNOTTCH, "WSAEDSTNOTTCH", "Destination not reachable (Minix)")
#endif /* WSAEDSTNOTTCH */
#ifdef EDUPPKG
ADD_ERRNO(EDUPPKG, "EDUPPKG", "Duplicate package name on install")
#endif /* EDUPPKG */
#ifdef WSAEDUPPKG
#ifndef EDUPPKG
ADD_ERRNO(WSAEDUPPKG, "EDUPPKG", "Duplicate package name on install")
#endif /* WSAEDUPPKG && !EDUPPKG */
ADD_ERRNO(WSAEDUPPKG, "WSAEDUPPKG", "Duplicate package name on install")
#endif /* WSAEDUPPKG */
#ifdef EEMPTY
ADD_ERRNO(EEMPTY, "EEMPTY", "")
#endif /* EEMPTY */
#ifdef WSAEEMPTY
#ifndef EEMPTY
ADD_ERRNO(WSAEEMPTY, "EEMPTY", "")
#endif /* WSAEEMPTY && !EEMPTY */
ADD_ERRNO(WSAEEMPTY, "WSAEEMPTY", "")
#endif /* WSAEEMPTY */
#ifdef EEMULATE
ADD_ERRNO(EEMULATE, "EEMULATE", "")
#endif /* EEMULATE */
#ifdef WSAEEMULATE
#ifndef EEMULATE
ADD_ERRNO(WSAEEMULATE, "EEMULATE", "")
#endif /* WSAEEMULATE && !EEMULATE */
ADD_ERRNO(WSAEEMULATE, "WSAEEMULATE", "")
#endif /* WSAEEMULATE */
#ifdef EENDIAN
ADD_ERRNO(EENDIAN, "EENDIAN", "Endian not supported")
#endif /* EENDIAN */
#ifdef WSAEENDIAN
#ifndef EENDIAN
ADD_ERRNO(WSAEENDIAN, "EENDIAN", "Endian not supported")
#endif /* WSAEENDIAN && !EENDIAN */
ADD_ERRNO(WSAEENDIAN, "WSAEENDIAN", "Endian not supported")
#endif /* WSAEENDIAN */
#ifdef EENDOFMINOR
ADD_ERRNO(EENDOFMINOR, "EENDOFMINOR", "")
#endif /* EENDOFMINOR */
#ifdef WSAEENDOFMINOR
#ifndef EENDOFMINOR
ADD_ERRNO(WSAEENDOFMINOR, "EENDOFMINOR", "")
#endif /* WSAEENDOFMINOR && !EENDOFMINOR */
ADD_ERRNO(WSAEENDOFMINOR, "WSAEENDOFMINOR", "")
#endif /* WSAEENDOFMINOR */
#ifdef EENQUEUED
ADD_ERRNO(EENQUEUED, "EENQUEUED", "")
#endif /* EENQUEUED */
#ifdef WSAEENQUEUED
#ifndef EENQUEUED
ADD_ERRNO(WSAEENQUEUED, "EENQUEUED", "")
#endif /* WSAEENQUEUED && !EENQUEUED */
ADD_ERRNO(WSAEENQUEUED, "WSAEENQUEUED", "")
#endif /* WSAEENQUEUED */
#ifdef EEXIST
ADD_ERRNO(EEXIST, "EEXIST", "File exists")
#endif /* EEXIST */
#ifdef WSAEEXIST
#ifndef EEXIST
ADD_ERRNO(WSAEEXIST, "EEXIST", "File exists")
#endif /* WSAEEXIST && !EEXIST */
ADD_ERRNO(WSAEEXIST, "WSAEEXIST", "File exists")
#endif /* WSAEEXIST */
#ifdef EFAIL
ADD_ERRNO(EFAIL, "EFAIL", "Cannot start operation")
#endif /* EFAIL */
#ifdef WSAEFAIL
#ifndef EFAIL
ADD_ERRNO(WSAEFAIL, "EFAIL", "Cannot start operation")
#endif /* WSAEFAIL && !EFAIL */
ADD_ERRNO(WSAEFAIL, "WSAEFAIL", "Cannot start operation")
#endif /* WSAEFAIL */
#ifdef EFAULT
ADD_ERRNO(EFAULT, "EFAULT", "Bad address")
#endif /* EFAULT */
#ifdef WSAEFAULT
#ifndef EFAULT
ADD_ERRNO(WSAEFAULT, "EFAULT", "Bad address")
#endif /* WSAEFAULT && !EFAULT */
ADD_ERRNO(WSAEFAULT, "WSAEFAULT", "Bad address")
#endif /* WSAEFAULT */
#ifdef EFBIG
ADD_ERRNO(EFBIG, "EFBIG", "File too large")
#endif /* EFBIG */
#ifdef WSAEFBIG
#ifndef EFBIG
ADD_ERRNO(WSAEFBIG, "EFBIG", "File too large")
#endif /* WSAEFBIG && !EFBIG */
ADD_ERRNO(WSAEFBIG, "WSAEFBIG", "File too large")
#endif /* WSAEFBIG */
#ifdef EFORMAT
ADD_ERRNO(EFORMAT, "EFORMAT", "Unformatted media")
#endif /* EFORMAT */
#ifdef WSAEFORMAT
#ifndef EFORMAT
ADD_ERRNO(WSAEFORMAT, "EFORMAT", "Unformatted media")
#endif /* WSAEFORMAT && !EFORMAT */
ADD_ERRNO(WSAEFORMAT, "WSAEFORMAT", "Unformatted media")
#endif /* WSAEFORMAT */
#ifdef EFPOS
ADD_ERRNO(EFPOS, "EFPOS", "File position error")
#endif /* EFPOS */
#ifdef WSAEFPOS
#ifndef EFPOS
ADD_ERRNO(WSAEFPOS, "EFPOS", "File position error")
#endif /* WSAEFPOS && !EFPOS */
ADD_ERRNO(WSAEFPOS, "WSAEFPOS", "File position error")
#endif /* WSAEFPOS */
#ifdef EFSCORRUPTED
ADD_ERRNO(EFSCORRUPTED, "EFSCORRUPTED", "")
#endif /* EFSCORRUPTED */
#ifdef WSAEFSCORRUPTED
#ifndef EFSCORRUPTED
ADD_ERRNO(WSAEFSCORRUPTED, "EFSCORRUPTED", "")
#endif /* WSAEFSCORRUPTED && !EFSCORRUPTED */
ADD_ERRNO(WSAEFSCORRUPTED, "WSAEFSCORRUPTED", "")
#endif /* WSAEFSCORRUPTED */
#ifdef EFTYPE
ADD_ERRNO(EFTYPE, "EFTYPE", "Inappropriate file type or format")
#endif /* EFTYPE */
#ifdef WSAEFTYPE
#ifndef EFTYPE
ADD_ERRNO(WSAEFTYPE, "EFTYPE", "Inappropriate file type or format")
#endif /* WSAEFTYPE && !EFTYPE */
ADD_ERRNO(WSAEFTYPE, "WSAEFTYPE", "Inappropriate file type or format")
#endif /* WSAEFTYPE */
#ifdef EGENERIC
ADD_ERRNO(EGENERIC, "EGENERIC", "Generic error (Minix)")
#endif /* EGENERIC */
#ifdef WSAEGENERIC
#ifndef EGENERIC
ADD_ERRNO(WSAEGENERIC, "EGENERIC", "Generic error (Minix)")
#endif /* WSAEGENERIC && !EGENERIC */
ADD_ERRNO(WSAEGENERIC, "WSAEGENERIC", "Generic error (Minix)")
#endif /* WSAEGENERIC */
#ifdef EGRATIOUS
ADD_ERRNO(EGRATIOUS, "EGRATIOUS", "")
#endif /* EGRATIOUS */
#ifdef WSAEGRATIOUS
#ifndef EGRATIOUS
ADD_ERRNO(WSAEGRATIOUS, "EGRATIOUS", "")
#endif /* WSAEGRATIOUS && !EGRATIOUS */
ADD_ERRNO(WSAEGRATIOUS, "WSAEGRATIOUS", "")
#endif /* WSAEGRATIOUS */
#ifdef EGREGIOUS
ADD_ERRNO(EGREGIOUS, "EGREGIOUS", "")
#endif /* EGREGIOUS */
#ifdef WSAEGREGIOUS
#ifndef EGREGIOUS
ADD_ERRNO(WSAEGREGIOUS, "EGREGIOUS", "")
#endif /* WSAEGREGIOUS && !EGREGIOUS */
ADD_ERRNO(WSAEGREGIOUS, "WSAEGREGIOUS", "")
#endif /* WSAEGREGIOUS */
#ifdef EGROUPLOOP
ADD_ERRNO(EGROUPLOOP, "EGROUPLOOP", "")
#endif /* EGROUPLOOP */
#ifdef WSAEGROUPLOOP
#ifndef EGROUPLOOP
ADD_ERRNO(WSAEGROUPLOOP, "EGROUPLOOP", "")
#endif /* WSAEGROUPLOOP && !EGROUPLOOP */
ADD_ERRNO(WSAEGROUPLOOP, "WSAEGROUPLOOP", "")
#endif /* WSAEGROUPLOOP */
#ifdef EHOSTDOWN
ADD_ERRNO(EHOSTDOWN, "EHOSTDOWN", "Host is down")
#endif /* EHOSTDOWN */
#ifdef WSAEHOSTDOWN
#ifndef EHOSTDOWN
ADD_ERRNO(WSAEHOSTDOWN, "EHOSTDOWN", "Host is down")
#endif /* WSAEHOSTDOWN && !EHOSTDOWN */
ADD_ERRNO(WSAEHOSTDOWN, "WSAEHOSTDOWN", "Host is down")
#endif /* WSAEHOSTDOWN */
#ifdef EHOSTUNREACH
ADD_ERRNO(EHOSTUNREACH, "EHOSTUNREACH", "No route to host")
#endif /* EHOSTUNREACH */
#ifdef WSAEHOSTUNREACH
#ifndef EHOSTUNREACH
ADD_ERRNO(WSAEHOSTUNREACH, "EHOSTUNREACH", "No route to host")
#endif /* WSAEHOSTUNREACH && !EHOSTUNREACH */
ADD_ERRNO(WSAEHOSTUNREACH, "WSAEHOSTUNREACH", "No route to host")
#endif /* WSAEHOSTUNREACH */
#ifdef EHWPOISON
ADD_ERRNO(EHWPOISON, "EHWPOISON", "Memory page has hardware error")
#endif /* EHWPOISON */
#ifdef WSAEHWPOISON
#ifndef EHWPOISON
ADD_ERRNO(WSAEHWPOISON, "EHWPOISON", "Memory page has hardware error")
#endif /* WSAEHWPOISON && !EHWPOISON */
ADD_ERRNO(WSAEHWPOISON, "WSAEHWPOISON", "Memory page has hardware error")
#endif /* WSAEHWPOISON */
#ifdef EIDRM
ADD_ERRNO(EIDRM, "EIDRM", "Identifier removed")
#endif /* EIDRM */
#ifdef WSAEIDRM
#ifndef EIDRM
ADD_ERRNO(WSAEIDRM, "EIDRM", "Identifier removed")
#endif /* WSAEIDRM && !EIDRM */
ADD_ERRNO(WSAEIDRM, "WSAEIDRM", "Identifier removed")
#endif /* WSAEIDRM */
#ifdef EIEIO
ADD_ERRNO(EIEIO, "EIEIO", "")
#endif /* EIEIO */
#ifdef WSAEIEIO
#ifndef EIEIO
ADD_ERRNO(WSAEIEIO, "EIEIO", "")
#endif /* WSAEIEIO && !EIEIO */
ADD_ERRNO(WSAEIEIO, "WSAEIEIO", "")
#endif /* WSAEIEIO */
#ifdef EILSEQ
ADD_ERRNO(EILSEQ, "EILSEQ", "Invalid wide character")
#endif /* EILSEQ */
#ifdef WSAEILSEQ
#ifndef EILSEQ
ADD_ERRNO(WSAEILSEQ, "EILSEQ", "Invalid wide character")
#endif /* WSAEILSEQ && !EILSEQ */
ADD_ERRNO(WSAEILSEQ, "WSAEILSEQ", "Invalid wide character")
#endif /* WSAEILSEQ */
#ifdef EINIT
ADD_ERRNO(EINIT, "EINIT", "")
#endif /* EINIT */
#ifdef WSAEINIT
#ifndef EINIT
ADD_ERRNO(WSAEINIT, "EINIT", "")
#endif /* WSAEINIT && !EINIT */
ADD_ERRNO(WSAEINIT, "WSAEINIT", "")
#endif /* WSAEINIT */
#ifdef EINPROG
ADD_ERRNO(EINPROG, "EINPROG", "Operation (now) in progress")
#endif /* EINPROG */
#ifdef WSAEINPROG
#ifndef EINPROG
ADD_ERRNO(WSAEINPROG, "EINPROG", "Operation (now) in progress")
#endif /* WSAEINPROG && !EINPROG */
ADD_ERRNO(WSAEINPROG, "WSAEINPROG", "Operation (now) in progress")
#endif /* WSAEINPROG */
#ifdef EINPROGRESS
ADD_ERRNO(EINPROGRESS, "EINPROGRESS", "Operation now in progress")
#endif /* EINPROGRESS */
#ifdef WSAEINPROGRESS
#ifndef EINPROGRESS
ADD_ERRNO(WSAEINPROGRESS, "EINPROGRESS", "Operation now in progress")
#endif /* WSAEINPROGRESS && !EINPROGRESS */
ADD_ERRNO(WSAEINPROGRESS, "WSAEINPROGRESS", "Operation now in progress")
#endif /* WSAEINPROGRESS */
#ifdef EINTR
ADD_ERRNO(EINTR, "EINTR", "Interrupted system call")
#endif /* EINTR */
#ifdef WSAEINTR
#ifndef EINTR
ADD_ERRNO(WSAEINTR, "EINTR", "Interrupted system call")
#endif /* WSAEINTR && !EINTR */
ADD_ERRNO(WSAEINTR, "WSAEINTR", "Interrupted system call")
#endif /* WSAEINTR */
#ifdef EINVAL
ADD_ERRNO(EINVAL, "EINVAL", "Invalid argument")
#endif /* EINVAL */
#ifdef WSAEINVAL
#ifndef EINVAL
ADD_ERRNO(WSAEINVAL, "EINVAL", "Invalid argument")
#endif /* WSAEINVAL && !EINVAL */
ADD_ERRNO(WSAEINVAL, "WSAEINVAL", "Invalid argument")
#endif /* WSAEINVAL */
#ifdef EINVALMODE
ADD_ERRNO(EINVALMODE, "EINVALMODE", "")
#endif /* EINVALMODE */
#ifdef WSAEINVALMODE
#ifndef EINVALMODE
ADD_ERRNO(WSAEINVALMODE, "EINVALMODE", "")
#endif /* WSAEINVALMODE && !EINVALMODE */
ADD_ERRNO(WSAEINVALMODE, "WSAEINVALMODE", "")
#endif /* WSAEINVALMODE */
#ifdef EINVALSTATE
ADD_ERRNO(EINVALSTATE, "EINVALSTATE", "")
#endif /* EINVALSTATE */
#ifdef WSAEINVALSTATE
#ifndef EINVALSTATE
ADD_ERRNO(WSAEINVALSTATE, "EINVALSTATE", "")
#endif /* WSAEINVALSTATE && !EINVALSTATE */
ADD_ERRNO(WSAEINVALSTATE, "WSAEINVALSTATE", "")
#endif /* WSAEINVALSTATE */
#ifdef EINVALTIME
ADD_ERRNO(EINVALTIME, "EINVALTIME", "")
#endif /* EINVALTIME */
#ifdef WSAEINVALTIME
#ifndef EINVALTIME
ADD_ERRNO(WSAEINVALTIME, "EINVALTIME", "")
#endif /* WSAEINVALTIME && !EINVALTIME */
ADD_ERRNO(WSAEINVALTIME, "WSAEINVALTIME", "")
#endif /* WSAEINVALTIME */
#ifdef EIO
ADD_ERRNO(EIO, "EIO", "I/O error")
#endif /* EIO */
#ifdef WSAEIO
#ifndef EIO
ADD_ERRNO(WSAEIO, "EIO", "I/O error")
#endif /* WSAEIO && !EIO */
ADD_ERRNO(WSAEIO, "WSAEIO", "I/O error")
#endif /* WSAEIO */
#ifdef EIORESID
ADD_ERRNO(EIORESID, "EIORESID", "")
#endif /* EIORESID */
#ifdef WSAEIORESID
#ifndef EIORESID
ADD_ERRNO(WSAEIORESID, "EIORESID", "")
#endif /* WSAEIORESID && !EIORESID */
ADD_ERRNO(WSAEIORESID, "WSAEIORESID", "")
#endif /* WSAEIORESID */
#ifdef EISCONN
ADD_ERRNO(EISCONN, "EISCONN", "Transport endpoint is already connected")
#endif /* EISCONN */
#ifdef WSAEISCONN
#ifndef EISCONN
ADD_ERRNO(WSAEISCONN, "EISCONN", "Transport endpoint is already connected")
#endif /* WSAEISCONN && !EISCONN */
ADD_ERRNO(WSAEISCONN, "WSAEISCONN", "Transport endpoint is already connected")
#endif /* WSAEISCONN */
#ifdef EISDIR
ADD_ERRNO(EISDIR, "EISDIR", "Is a directory")
#endif /* EISDIR */
#ifdef WSAEISDIR
#ifndef EISDIR
ADD_ERRNO(WSAEISDIR, "EISDIR", "Is a directory")
#endif /* WSAEISDIR && !EISDIR */
ADD_ERRNO(WSAEISDIR, "WSAEISDIR", "Is a directory")
#endif /* WSAEISDIR */
#ifdef EISNAM
ADD_ERRNO(EISNAM, "EISNAM", "Is a named type file")
#endif /* EISNAM */
#ifdef WSAEISNAM
#ifndef EISNAM
ADD_ERRNO(WSAEISNAM, "EISNAM", "Is a named type file")
#endif /* WSAEISNAM && !EISNAM */
ADD_ERRNO(WSAEISNAM, "WSAEISNAM", "Is a named type file")
#endif /* WSAEISNAM */
#ifdef EJOINED
ADD_ERRNO(EJOINED, "EJOINED", "")
#endif /* EJOINED */
#ifdef WSAEJOINED
#ifndef EJOINED
ADD_ERRNO(WSAEJOINED, "EJOINED", "")
#endif /* WSAEJOINED && !EJOINED */
ADD_ERRNO(WSAEJOINED, "WSAEJOINED", "")
#endif /* WSAEJOINED */
#ifdef EJUSTRETURN
ADD_ERRNO(EJUSTRETURN, "EJUSTRETURN", "")
#endif /* EJUSTRETURN */
#ifdef WSAEJUSTRETURN
#ifndef EJUSTRETURN
ADD_ERRNO(WSAEJUSTRETURN, "EJUSTRETURN", "")
#endif /* WSAEJUSTRETURN && !EJUSTRETURN */
ADD_ERRNO(WSAEJUSTRETURN, "WSAEJUSTRETURN", "")
#endif /* WSAEJUSTRETURN */
#ifdef EKEYEXPIRED
ADD_ERRNO(EKEYEXPIRED, "EKEYEXPIRED", "Key has expired")
#endif /* EKEYEXPIRED */
#ifdef WSAEKEYEXPIRED
#ifndef EKEYEXPIRED
ADD_ERRNO(WSAEKEYEXPIRED, "EKEYEXPIRED", "Key has expired")
#endif /* WSAEKEYEXPIRED && !EKEYEXPIRED */
ADD_ERRNO(WSAEKEYEXPIRED, "WSAEKEYEXPIRED", "Key has expired")
#endif /* WSAEKEYEXPIRED */
#ifdef EKEYREJECTED
ADD_ERRNO(EKEYREJECTED, "EKEYREJECTED", "Key was rejected by service")
#endif /* EKEYREJECTED */
#ifdef WSAEKEYREJECTED
#ifndef EKEYREJECTED
ADD_ERRNO(WSAEKEYREJECTED, "EKEYREJECTED", "Key was rejected by service")
#endif /* WSAEKEYREJECTED && !EKEYREJECTED */
ADD_ERRNO(WSAEKEYREJECTED, "WSAEKEYREJECTED", "Key was rejected by service")
#endif /* WSAEKEYREJECTED */
#ifdef EKEYREVOKED
ADD_ERRNO(EKEYREVOKED, "EKEYREVOKED", "Key has been revoked")
#endif /* EKEYREVOKED */
#ifdef WSAEKEYREVOKED
#ifndef EKEYREVOKED
ADD_ERRNO(WSAEKEYREVOKED, "EKEYREVOKED", "Key has been revoked")
#endif /* WSAEKEYREVOKED && !EKEYREVOKED */
ADD_ERRNO(WSAEKEYREVOKED, "WSAEKEYREVOKED", "Key has been revoked")
#endif /* WSAEKEYREVOKED */
#ifdef EL2HLT
ADD_ERRNO(EL2HLT, "EL2HLT", "Level 2 halted")
#endif /* EL2HLT */
#ifdef WSAEL2HLT
#ifndef EL2HLT
ADD_ERRNO(WSAEL2HLT, "EL2HLT", "Level 2 halted")
#endif /* WSAEL2HLT && !EL2HLT */
ADD_ERRNO(WSAEL2HLT, "WSAEL2HLT", "Level 2 halted")
#endif /* WSAEL2HLT */
#ifdef EL2NSYNC
ADD_ERRNO(EL2NSYNC, "EL2NSYNC", "Level 2 not synchronized")
#endif /* EL2NSYNC */
#ifdef WSAEL2NSYNC
#ifndef EL2NSYNC
ADD_ERRNO(WSAEL2NSYNC, "EL2NSYNC", "Level 2 not synchronized")
#endif /* WSAEL2NSYNC && !EL2NSYNC */
ADD_ERRNO(WSAEL2NSYNC, "WSAEL2NSYNC", "Level 2 not synchronized")
#endif /* WSAEL2NSYNC */
#ifdef EL3HLT
ADD_ERRNO(EL3HLT, "EL3HLT", "Level 3 halted")
#endif /* EL3HLT */
#ifdef WSAEL3HLT
#ifndef EL3HLT
ADD_ERRNO(WSAEL3HLT, "EL3HLT", "Level 3 halted")
#endif /* WSAEL3HLT && !EL3HLT */
ADD_ERRNO(WSAEL3HLT, "WSAEL3HLT", "Level 3 halted")
#endif /* WSAEL3HLT */
#ifdef EL3RST
ADD_ERRNO(EL3RST, "EL3RST", "Level 3 reset")
#endif /* EL3RST */
#ifdef WSAEL3RST
#ifndef EL3RST
ADD_ERRNO(WSAEL3RST, "EL3RST", "Level 3 reset")
#endif /* WSAEL3RST && !EL3RST */
ADD_ERRNO(WSAEL3RST, "WSAEL3RST", "Level 3 reset")
#endif /* WSAEL3RST */
#ifdef ELBIN
ADD_ERRNO(ELBIN, "ELBIN", "")
#endif /* ELBIN */
#ifdef WSAELBIN
#ifndef ELBIN
ADD_ERRNO(WSAELBIN, "ELBIN", "")
#endif /* WSAELBIN && !ELBIN */
ADD_ERRNO(WSAELBIN, "WSAELBIN", "")
#endif /* WSAELBIN */
#ifdef ELIBACC
ADD_ERRNO(ELIBACC, "ELIBACC", "Can not access a needed shared library")
#endif /* ELIBACC */
#ifdef WSAELIBACC
#ifndef ELIBACC
ADD_ERRNO(WSAELIBACC, "ELIBACC", "Can not access a needed shared library")
#endif /* WSAELIBACC && !ELIBACC */
ADD_ERRNO(WSAELIBACC, "WSAELIBACC", "Can not access a needed shared library")
#endif /* WSAELIBACC */
#ifdef ELIBBAD
ADD_ERRNO(ELIBBAD, "ELIBBAD", "Accessing a corrupted shared library")
#endif /* ELIBBAD */
#ifdef WSAELIBBAD
#ifndef ELIBBAD
ADD_ERRNO(WSAELIBBAD, "ELIBBAD", "Accessing a corrupted shared library")
#endif /* WSAELIBBAD && !ELIBBAD */
ADD_ERRNO(WSAELIBBAD, "WSAELIBBAD", "Accessing a corrupted shared library")
#endif /* WSAELIBBAD */
#ifdef ELIBEXEC
ADD_ERRNO(ELIBEXEC, "ELIBEXEC", "Cannot exec a shared library directly")
#endif /* ELIBEXEC */
#ifdef WSAELIBEXEC
#ifndef ELIBEXEC
ADD_ERRNO(WSAELIBEXEC, "ELIBEXEC", "Cannot exec a shared library directly")
#endif /* WSAELIBEXEC && !ELIBEXEC */
ADD_ERRNO(WSAELIBEXEC, "WSAELIBEXEC", "Cannot exec a shared library directly")
#endif /* WSAELIBEXEC */
#ifdef ELIBMAX
ADD_ERRNO(ELIBMAX, "ELIBMAX", "Attempting to link in too many shared libraries")
#endif /* ELIBMAX */
#ifdef WSAELIBMAX
#ifndef ELIBMAX
ADD_ERRNO(WSAELIBMAX, "ELIBMAX", "Attempting to link in too many shared libraries")
#endif /* WSAELIBMAX && !ELIBMAX */
ADD_ERRNO(WSAELIBMAX, "WSAELIBMAX", "Attempting to link in too many shared libraries")
#endif /* WSAELIBMAX */
#ifdef ELIBSCN
ADD_ERRNO(ELIBSCN, "ELIBSCN", ".lib section in a.out corrupted")
#endif /* ELIBSCN */
#ifdef WSAELIBSCN
#ifndef ELIBSCN
ADD_ERRNO(WSAELIBSCN, "ELIBSCN", ".lib section in a.out corrupted")
#endif /* WSAELIBSCN && !ELIBSCN */
ADD_ERRNO(WSAELIBSCN, "WSAELIBSCN", ".lib section in a.out corrupted")
#endif /* WSAELIBSCN */
#ifdef ELNRNG
ADD_ERRNO(ELNRNG, "ELNRNG", "Link number out of range")
#endif /* ELNRNG */
#ifdef WSAELNRNG
#ifndef ELNRNG
ADD_ERRNO(WSAELNRNG, "ELNRNG", "Link number out of range")
#endif /* WSAELNRNG && !ELNRNG */
ADD_ERRNO(WSAELNRNG, "WSAELNRNG", "Link number out of range")
#endif /* WSAELNRNG */
#ifdef ELOCKED
ADD_ERRNO(ELOCKED, "ELOCKED", "Can't send message due to deadlock (Minix)")
#endif /* ELOCKED */
#ifdef WSAELOCKED
#ifndef ELOCKED
ADD_ERRNO(WSAELOCKED, "ELOCKED", "Can't send message due to deadlock (Minix)")
#endif /* WSAELOCKED && !ELOCKED */
ADD_ERRNO(WSAELOCKED, "WSAELOCKED", "Can't send message due to deadlock (Minix)")
#endif /* WSAELOCKED */
#ifdef ELOCKUNMAPPED
ADD_ERRNO(ELOCKUNMAPPED, "ELOCKUNMAPPED", "")
#endif /* ELOCKUNMAPPED */
#ifdef WSAELOCKUNMAPPED
#ifndef ELOCKUNMAPPED
ADD_ERRNO(WSAELOCKUNMAPPED, "ELOCKUNMAPPED", "")
#endif /* WSAELOCKUNMAPPED && !ELOCKUNMAPPED */
ADD_ERRNO(WSAELOCKUNMAPPED, "WSAELOCKUNMAPPED", "")
#endif /* WSAELOCKUNMAPPED */
#ifdef ELOGINLIM
ADD_ERRNO(ELOGINLIM, "ELOGINLIM", "")
#endif /* ELOGINLIM */
#ifdef WSAELOGINLIM
#ifndef ELOGINLIM
ADD_ERRNO(WSAELOGINLIM, "ELOGINLIM", "")
#endif /* WSAELOGINLIM && !ELOGINLIM */
ADD_ERRNO(WSAELOGINLIM, "WSAELOGINLIM", "")
#endif /* WSAELOGINLIM */
#ifdef ELOOP
ADD_ERRNO(ELOOP, "ELOOP", "Too many symbolic links encountered")
#endif /* ELOOP */
#ifdef WSAELOOP
#ifndef ELOOP
ADD_ERRNO(WSAELOOP, "ELOOP", "Too many symbolic links encountered")
#endif /* WSAELOOP && !ELOOP */
ADD_ERRNO(WSAELOOP, "WSAELOOP", "Too many symbolic links encountered")
#endif /* WSAELOOP */
#ifdef EMEDIA
ADD_ERRNO(EMEDIA, "EMEDIA", "Media surface error")
#endif /* EMEDIA */
#ifdef WSAEMEDIA
#ifndef EMEDIA
ADD_ERRNO(WSAEMEDIA, "EMEDIA", "Media surface error")
#endif /* WSAEMEDIA && !EMEDIA */
ADD_ERRNO(WSAEMEDIA, "WSAEMEDIA", "Media surface error")
#endif /* WSAEMEDIA */
#ifdef EMEDIUMTYPE
ADD_ERRNO(EMEDIUMTYPE, "EMEDIUMTYPE", "Wrong medium type")
#endif /* EMEDIUMTYPE */
#ifdef WSAEMEDIUMTYPE
#ifndef EMEDIUMTYPE
ADD_ERRNO(WSAEMEDIUMTYPE, "EMEDIUMTYPE", "Wrong medium type")
#endif /* WSAEMEDIUMTYPE && !EMEDIUMTYPE */
ADD_ERRNO(WSAEMEDIUMTYPE, "WSAEMEDIUMTYPE", "Wrong medium type")
#endif /* WSAEMEDIUMTYPE */
#ifdef EMEMRETRY
ADD_ERRNO(EMEMRETRY, "EMEMRETRY", "")
#endif /* EMEMRETRY */
#ifdef WSAEMEMRETRY
#ifndef EMEMRETRY
ADD_ERRNO(WSAEMEMRETRY, "EMEMRETRY", "")
#endif /* WSAEMEMRETRY && !EMEMRETRY */
ADD_ERRNO(WSAEMEMRETRY, "WSAEMEMRETRY", "")
#endif /* WSAEMEMRETRY */
#ifdef EMFILE
ADD_ERRNO(EMFILE, "EMFILE", "Too many open files")
#endif /* EMFILE */
#ifdef WSAEMFILE
#ifndef EMFILE
ADD_ERRNO(WSAEMFILE, "EMFILE", "Too many open files")
#endif /* WSAEMFILE && !EMFILE */
ADD_ERRNO(WSAEMFILE, "WSAEMFILE", "Too many open files")
#endif /* WSAEMFILE */
#ifdef EMIGRATED
ADD_ERRNO(EMIGRATED, "EMIGRATED", "")
#endif /* EMIGRATED */
#ifdef WSAEMIGRATED
#ifndef EMIGRATED
ADD_ERRNO(WSAEMIGRATED, "EMIGRATED", "")
#endif /* WSAEMIGRATED && !EMIGRATED */
ADD_ERRNO(WSAEMIGRATED, "WSAEMIGRATED", "")
#endif /* WSAEMIGRATED */
#ifdef EMIGRATING
ADD_ERRNO(EMIGRATING, "EMIGRATING", "")
#endif /* EMIGRATING */
#ifdef WSAEMIGRATING
#ifndef EMIGRATING
ADD_ERRNO(WSAEMIGRATING, "EMIGRATING", "")
#endif /* WSAEMIGRATING && !EMIGRATING */
ADD_ERRNO(WSAEMIGRATING, "WSAEMIGRATING", "")
#endif /* WSAEMIGRATING */
#ifdef EMLINK
ADD_ERRNO(EMLINK, "EMLINK", "Too many links")
#endif /* EMLINK */
#ifdef WSAEMLINK
#ifndef EMLINK
ADD_ERRNO(WSAEMLINK, "EMLINK", "Too many links")
#endif /* WSAEMLINK && !EMLINK */
ADD_ERRNO(WSAEMLINK, "WSAEMLINK", "Too many links")
#endif /* WSAEMLINK */
#ifdef EMORE
ADD_ERRNO(EMORE, "EMORE", "More to do, send message again")
#endif /* EMORE */
#ifdef WSAEMORE
#ifndef EMORE
ADD_ERRNO(WSAEMORE, "EMORE", "More to do, send message again")
#endif /* WSAEMORE && !EMORE */
ADD_ERRNO(WSAEMORE, "WSAEMORE", "More to do, send message again")
#endif /* WSAEMORE */
#ifdef EMSGSIZE
ADD_ERRNO(EMSGSIZE, "EMSGSIZE", "Message too long")
#endif /* EMSGSIZE */
#ifdef WSAEMSGSIZE
#ifndef EMSGSIZE
ADD_ERRNO(WSAEMSGSIZE, "EMSGSIZE", "Message too long")
#endif /* WSAEMSGSIZE && !EMSGSIZE */
ADD_ERRNO(WSAEMSGSIZE, "WSAEMSGSIZE", "Message too long")
#endif /* WSAEMSGSIZE */
#ifdef EMTIMERS
ADD_ERRNO(EMTIMERS, "EMTIMERS", "Too many timers")
#endif /* EMTIMERS */
#ifdef WSAEMTIMERS
#ifndef EMTIMERS
ADD_ERRNO(WSAEMTIMERS, "EMTIMERS", "Too many timers")
#endif /* WSAEMTIMERS && !EMTIMERS */
ADD_ERRNO(WSAEMTIMERS, "WSAEMTIMERS", "Too many timers")
#endif /* WSAEMTIMERS */
#ifdef EMULTIHOP
ADD_ERRNO(EMULTIHOP, "EMULTIHOP", "Multihop attempted")
#endif /* EMULTIHOP */
#ifdef WSAEMULTIHOP
#ifndef EMULTIHOP
ADD_ERRNO(WSAEMULTIHOP, "EMULTIHOP", "Multihop attempted")
#endif /* WSAEMULTIHOP && !EMULTIHOP */
ADD_ERRNO(WSAEMULTIHOP, "WSAEMULTIHOP", "Multihop attempted")
#endif /* WSAEMULTIHOP */
#ifdef EMUSTRUN
ADD_ERRNO(EMUSTRUN, "EMUSTRUN", "")
#endif /* EMUSTRUN */
#ifdef WSAEMUSTRUN
#ifndef EMUSTRUN
ADD_ERRNO(WSAEMUSTRUN, "EMUSTRUN", "")
#endif /* WSAEMUSTRUN && !EMUSTRUN */
ADD_ERRNO(WSAEMUSTRUN, "WSAEMUSTRUN", "")
#endif /* WSAEMUSTRUN */
#ifdef ENAMETOOLONG
ADD_ERRNO(ENAMETOOLONG, "ENAMETOOLONG", "File name too long")
#endif /* ENAMETOOLONG */
#ifdef WSAENAMETOOLONG
#ifndef ENAMETOOLONG
ADD_ERRNO(WSAENAMETOOLONG, "ENAMETOOLONG", "File name too long")
#endif /* WSAENAMETOOLONG && !ENAMETOOLONG */
ADD_ERRNO(WSAENAMETOOLONG, "WSAENAMETOOLONG", "File name too long")
#endif /* WSAENAMETOOLONG */
#ifdef ENAVAIL
ADD_ERRNO(ENAVAIL, "ENAVAIL", "No XENIX semaphores available")
#endif /* ENAVAIL */
#ifdef WSAENAVAIL
#ifndef ENAVAIL
ADD_ERRNO(WSAENAVAIL, "ENAVAIL", "No XENIX semaphores available")
#endif /* WSAENAVAIL && !ENAVAIL */
ADD_ERRNO(WSAENAVAIL, "WSAENAVAIL", "No XENIX semaphores available")
#endif /* WSAENAVAIL */
#ifdef ENEEDAUTH
ADD_ERRNO(ENEEDAUTH, "ENEEDAUTH", "Need authenticator")
#endif /* ENEEDAUTH */
#ifdef WSAENEEDAUTH
#ifndef ENEEDAUTH
ADD_ERRNO(WSAENEEDAUTH, "ENEEDAUTH", "Need authenticator")
#endif /* WSAENEEDAUTH && !ENEEDAUTH */
ADD_ERRNO(WSAENEEDAUTH, "WSAENEEDAUTH", "Need authenticator")
#endif /* WSAENEEDAUTH */
#ifdef ENETDOWN
ADD_ERRNO(ENETDOWN, "ENETDOWN", "Network is down")
#endif /* ENETDOWN */
#ifdef WSAENETDOWN
#ifndef ENETDOWN
ADD_ERRNO(WSAENETDOWN, "ENETDOWN", "Network is down")
#endif /* WSAENETDOWN && !ENETDOWN */
ADD_ERRNO(WSAENETDOWN, "WSAENETDOWN", "Network is down")
#endif /* WSAENETDOWN */
#ifdef ENETRESET
ADD_ERRNO(ENETRESET, "ENETRESET", "Network dropped connection because of reset")
#endif /* ENETRESET */
#ifdef WSAENETRESET
#ifndef ENETRESET
ADD_ERRNO(WSAENETRESET, "ENETRESET", "Network dropped connection because of reset")
#endif /* WSAENETRESET && !ENETRESET */
ADD_ERRNO(WSAENETRESET, "WSAENETRESET", "Network dropped connection because of reset")
#endif /* WSAENETRESET */
#ifdef ENETUNREACH
ADD_ERRNO(ENETUNREACH, "ENETUNREACH", "Network is unreachable")
#endif /* ENETUNREACH */
#ifdef WSAENETUNREACH
#ifndef ENETUNREACH
ADD_ERRNO(WSAENETUNREACH, "ENETUNREACH", "Network is unreachable")
#endif /* WSAENETUNREACH && !ENETUNREACH */
ADD_ERRNO(WSAENETUNREACH, "WSAENETUNREACH", "Network is unreachable")
#endif /* WSAENETUNREACH */
#ifdef ENFILE
ADD_ERRNO(ENFILE, "ENFILE", "File table overflow")
#endif /* ENFILE */
#ifdef WSAENFILE
#ifndef ENFILE
ADD_ERRNO(WSAENFILE, "ENFILE", "File table overflow")
#endif /* WSAENFILE && !ENFILE */
ADD_ERRNO(WSAENFILE, "WSAENFILE", "File table overflow")
#endif /* WSAENFILE */
#ifdef ENFSREMOTE
ADD_ERRNO(ENFSREMOTE, "ENFSREMOTE", "")
#endif /* ENFSREMOTE */
#ifdef WSAENFSREMOTE
#ifndef ENFSREMOTE
ADD_ERRNO(WSAENFSREMOTE, "ENFSREMOTE", "")
#endif /* WSAENFSREMOTE && !ENFSREMOTE */
ADD_ERRNO(WSAENFSREMOTE, "WSAENFSREMOTE", "")
#endif /* WSAENFSREMOTE */
#ifdef ENOANO
ADD_ERRNO(ENOANO, "ENOANO", "No anode")
#endif /* ENOANO */
#ifdef WSAENOANO
#ifndef ENOANO
ADD_ERRNO(WSAENOANO, "ENOANO", "No anode")
#endif /* WSAENOANO && !ENOANO */
ADD_ERRNO(WSAENOANO, "WSAENOANO", "No anode")
#endif /* WSAENOANO */
#ifdef ENOATTACH
ADD_ERRNO(ENOATTACH, "ENOATTACH", "")
#endif /* ENOATTACH */
#ifdef WSAENOATTACH
#ifndef ENOATTACH
ADD_ERRNO(WSAENOATTACH, "ENOATTACH", "")
#endif /* WSAENOATTACH && !ENOATTACH */
ADD_ERRNO(WSAENOATTACH, "WSAENOATTACH", "")
#endif /* WSAENOATTACH */
#ifdef ENOATTR
ADD_ERRNO(ENOATTR, "ENOATTR", "No attribute found")
#endif /* ENOATTR */
#ifdef WSAENOATTR
#ifndef ENOATTR
ADD_ERRNO(WSAENOATTR, "ENOATTR", "No attribute found")
#endif /* WSAENOATTR && !ENOATTR */
ADD_ERRNO(WSAENOATTR, "WSAENOATTR", "No attribute found")
#endif /* WSAENOATTR */
#ifdef ENOBWD
ADD_ERRNO(ENOBWD, "ENOBWD", "")
#endif /* ENOBWD */
#ifdef WSAENOBWD
#ifndef ENOBWD
ADD_ERRNO(WSAENOBWD, "ENOBWD", "")
#endif /* WSAENOBWD && !ENOBWD */
ADD_ERRNO(WSAENOBWD, "WSAENOBWD", "")
#endif /* WSAENOBWD */
#ifdef ENOBUFS
ADD_ERRNO(ENOBUFS, "ENOBUFS", "No buffer space available")
#endif /* ENOBUFS */
#ifdef WSAENOBUFS
#ifndef ENOBUFS
ADD_ERRNO(WSAENOBUFS, "ENOBUFS", "No buffer space available")
#endif /* WSAENOBUFS && !ENOBUFS */
ADD_ERRNO(WSAENOBUFS, "WSAENOBUFS", "No buffer space available")
#endif /* WSAENOBUFS */
#ifdef ENOCOFFEE
ADD_ERRNO(ENOCOFFEE, "ENOCOFFEE", "")
#endif /* ENOCOFFEE */
#ifdef WSAENOCOFFEE
#ifndef ENOCOFFEE
ADD_ERRNO(WSAENOCOFFEE, "ENOCOFFEE", "")
#endif /* WSAENOCOFFEE && !ENOCOFFEE */
ADD_ERRNO(WSAENOCOFFEE, "WSAENOCOFFEE", "")
#endif /* WSAENOCOFFEE */
#ifdef ENOCONN
ADD_ERRNO(ENOCONN, "ENOCONN", "No such connection (Minix)")
#endif /* ENOCONN */
#ifdef WSAENOCONN
#ifndef ENOCONN
ADD_ERRNO(WSAENOCONN, "ENOCONN", "No such connection (Minix)")
#endif /* WSAENOCONN && !ENOCONN */
ADD_ERRNO(WSAENOCONN, "WSAENOCONN", "No such connection (Minix)")
#endif /* WSAENOCONN */
#ifdef ENOCONNECT
ADD_ERRNO(ENOCONNECT, "ENOCONNECT", "No connection")
#endif /* ENOCONNECT */
#ifdef WSAENOCONNECT
#ifndef ENOCONNECT
ADD_ERRNO(WSAENOCONNECT, "ENOCONNECT", "No connection")
#endif /* WSAENOCONNECT && !ENOCONNECT */
ADD_ERRNO(WSAENOCONNECT, "WSAENOCONNECT", "No connection")
#endif /* WSAENOCONNECT */
#ifdef ENOCSI
ADD_ERRNO(ENOCSI, "ENOCSI", "No CSI structure available")
#endif /* ENOCSI */
#ifdef WSAENOCSI
#ifndef ENOCSI
ADD_ERRNO(WSAENOCSI, "ENOCSI", "No CSI structure available")
#endif /* WSAENOCSI && !ENOCSI */
ADD_ERRNO(WSAENOCSI, "WSAENOCSI", "No CSI structure available")
#endif /* WSAENOCSI */
#ifdef ENODATA
ADD_ERRNO(ENODATA, "ENODATA", "No data available on STREAM")
#endif /* ENODATA */
#ifdef WSAENODATA
#ifndef ENODATA
ADD_ERRNO(WSAENODATA, "ENODATA", "No data available on STREAM")
#endif /* WSAENODATA && !ENODATA */
ADD_ERRNO(WSAENODATA, "WSAENODATA", "No data available on STREAM")
#endif /* WSAENODATA */
#ifdef ENODEV
ADD_ERRNO(ENODEV, "ENODEV", "No such device")
#endif /* ENODEV */
#ifdef WSAENODEV
#ifndef ENODEV
ADD_ERRNO(WSAENODEV, "ENODEV", "No such device")
#endif /* WSAENODEV && !ENODEV */
ADD_ERRNO(WSAENODEV, "WSAENODEV", "No such device")
#endif /* WSAENODEV */
#ifdef ENOENT
ADD_ERRNO(ENOENT, "ENOENT", "No such file or directory")
#endif /* ENOENT */
#ifdef WSAENOENT
#ifndef ENOENT
ADD_ERRNO(WSAENOENT, "ENOENT", "No such file or directory")
#endif /* WSAENOENT && !ENOENT */
ADD_ERRNO(WSAENOENT, "WSAENOENT", "No such file or directory")
#endif /* WSAENOENT */
#ifdef ENOEXEC
ADD_ERRNO(ENOEXEC, "ENOEXEC", "Exec format error")
#endif /* ENOEXEC */
#ifdef WSAENOEXEC
#ifndef ENOEXEC
ADD_ERRNO(WSAENOEXEC, "ENOEXEC", "Exec format error")
#endif /* WSAENOEXEC && !ENOEXEC */
ADD_ERRNO(WSAENOEXEC, "WSAENOEXEC", "Exec format error")
#endif /* WSAENOEXEC */
#ifdef ENOEXIST
ADD_ERRNO(ENOEXIST, "ENOEXIST", "")
#endif /* ENOEXIST */
#ifdef WSAENOEXIST
#ifndef ENOEXIST
ADD_ERRNO(WSAENOEXIST, "ENOEXIST", "")
#endif /* WSAENOEXIST && !ENOEXIST */
ADD_ERRNO(WSAENOEXIST, "WSAENOEXIST", "")
#endif /* WSAENOEXIST */
#ifdef ENOINTRGROUP
ADD_ERRNO(ENOINTRGROUP, "ENOINTRGROUP", "")
#endif /* ENOINTRGROUP */
#ifdef WSAENOINTRGROUP
#ifndef ENOINTRGROUP
ADD_ERRNO(WSAENOINTRGROUP, "ENOINTRGROUP", "")
#endif /* WSAENOINTRGROUP && !ENOINTRGROUP */
ADD_ERRNO(WSAENOINTRGROUP, "WSAENOINTRGROUP", "")
#endif /* WSAENOINTRGROUP */
#ifdef ENOIOCTL
ADD_ERRNO(ENOIOCTL, "ENOIOCTL", "")
#endif /* ENOIOCTL */
#ifdef WSAENOIOCTL
#ifndef ENOIOCTL
ADD_ERRNO(WSAENOIOCTL, "ENOIOCTL", "")
#endif /* WSAENOIOCTL && !ENOIOCTL */
ADD_ERRNO(WSAENOIOCTL, "WSAENOIOCTL", "")
#endif /* WSAENOIOCTL */
#ifdef ENOIOCTLCMD
ADD_ERRNO(ENOIOCTLCMD, "ENOIOCTLCMD", "")
#endif /* ENOIOCTLCMD */
#ifdef WSAENOIOCTLCMD
#ifndef ENOIOCTLCMD
ADD_ERRNO(WSAENOIOCTLCMD, "ENOIOCTLCMD", "")
#endif /* WSAENOIOCTLCMD && !ENOIOCTLCMD */
ADD_ERRNO(WSAENOIOCTLCMD, "WSAENOIOCTLCMD", "")
#endif /* WSAENOIOCTLCMD */
#ifdef ENOKEY
ADD_ERRNO(ENOKEY, "ENOKEY", "Required key not available")
#endif /* ENOKEY */
#ifdef WSAENOKEY
#ifndef ENOKEY
ADD_ERRNO(WSAENOKEY, "ENOKEY", "Required key not available")
#endif /* WSAENOKEY && !ENOKEY */
ADD_ERRNO(WSAENOKEY, "WSAENOKEY", "Required key not available")
#endif /* WSAENOKEY */
#ifdef ENOLCK
ADD_ERRNO(ENOLCK, "ENOLCK", "No record locks available")
#endif /* ENOLCK */
#ifdef WSAENOLCK
#ifndef ENOLCK
ADD_ERRNO(WSAENOLCK, "ENOLCK", "No record locks available")
#endif /* WSAENOLCK && !ENOLCK */
ADD_ERRNO(WSAENOLCK, "WSAENOLCK", "No record locks available")
#endif /* WSAENOLCK */
#ifdef ENOLIC
ADD_ERRNO(ENOLIC, "ENOLIC", "No license")
#endif /* ENOLIC */
#ifdef WSAENOLIC
#ifndef ENOLIC
ADD_ERRNO(WSAENOLIC, "ENOLIC", "No license")
#endif /* WSAENOLIC && !ENOLIC */
ADD_ERRNO(WSAENOLIC, "WSAENOLIC", "No license")
#endif /* WSAENOLIC */
#ifdef ENOLIMFILE
ADD_ERRNO(ENOLIMFILE, "ENOLIMFILE", "")
#endif /* ENOLIMFILE */
#ifdef WSAENOLIMFILE
#ifndef ENOLIMFILE
ADD_ERRNO(WSAENOLIMFILE, "ENOLIMFILE", "")
#endif /* WSAENOLIMFILE && !ENOLIMFILE */
ADD_ERRNO(WSAENOLIMFILE, "WSAENOLIMFILE", "")
#endif /* WSAENOLIMFILE */
#ifdef ENOLINK
ADD_ERRNO(ENOLINK, "ENOLINK", "Link has been severed")
#endif /* ENOLINK */
#ifdef WSAENOLINK
#ifndef ENOLINK
ADD_ERRNO(WSAENOLINK, "ENOLINK", "Link has been severed")
#endif /* WSAENOLINK && !ENOLINK */
ADD_ERRNO(WSAENOLINK, "WSAENOLINK", "Link has been severed")
#endif /* WSAENOLINK */
#ifdef ENOLOAD
ADD_ERRNO(ENOLOAD, "ENOLOAD", "Cannot load required kernel module")
#endif /* ENOLOAD */
#ifdef WSAENOLOAD
#ifndef ENOLOAD
ADD_ERRNO(WSAENOLOAD, "ENOLOAD", "Cannot load required kernel module")
#endif /* WSAENOLOAD && !ENOLOAD */
ADD_ERRNO(WSAENOLOAD, "WSAENOLOAD", "Cannot load required kernel module")
#endif /* WSAENOLOAD */
#ifdef ENOLOGIN
ADD_ERRNO(ENOLOGIN, "ENOLOGIN", "")
#endif /* ENOLOGIN */
#ifdef WSAENOLOGIN
#ifndef ENOLOGIN
ADD_ERRNO(WSAENOLOGIN, "ENOLOGIN", "")
#endif /* WSAENOLOGIN && !ENOLOGIN */
ADD_ERRNO(WSAENOLOGIN, "WSAENOLOGIN", "")
#endif /* WSAENOLOGIN */
#ifdef ENOMATCH
ADD_ERRNO(ENOMATCH, "ENOMATCH", "Symbol matching given spec not found")
#endif /* ENOMATCH */
#ifdef WSAENOMATCH
#ifndef ENOMATCH
ADD_ERRNO(WSAENOMATCH, "ENOMATCH", "Symbol matching given spec not found")
#endif /* WSAENOMATCH && !ENOMATCH */
ADD_ERRNO(WSAENOMATCH, "WSAENOMATCH", "Symbol matching given spec not found")
#endif /* WSAENOMATCH */
#ifdef ENOMEDIUM
ADD_ERRNO(ENOMEDIUM, "ENOMEDIUM", "No medium found")
#endif /* ENOMEDIUM */
#ifdef WSAENOMEDIUM
#ifndef ENOMEDIUM
ADD_ERRNO(WSAENOMEDIUM, "ENOMEDIUM", "No medium found")
#endif /* WSAENOMEDIUM && !ENOMEDIUM */
ADD_ERRNO(WSAENOMEDIUM, "WSAENOMEDIUM", "No medium found")
#endif /* WSAENOMEDIUM */
#ifdef ENOMEM
ADD_ERRNO(ENOMEM, "ENOMEM", "Out of memory")
#endif /* ENOMEM */
#ifdef WSAENOMEM
#ifndef ENOMEM
ADD_ERRNO(WSAENOMEM, "ENOMEM", "Out of memory")
#endif /* WSAENOMEM && !ENOMEM */
ADD_ERRNO(WSAENOMEM, "WSAENOMEM", "Out of memory")
#endif /* WSAENOMEM */
#ifdef ENOMESSAGE
ADD_ERRNO(ENOMESSAGE, "ENOMESSAGE", "")
#endif /* ENOMESSAGE */
#ifdef WSAENOMESSAGE
#ifndef ENOMESSAGE
ADD_ERRNO(WSAENOMESSAGE, "ENOMESSAGE", "")
#endif /* WSAENOMESSAGE && !ENOMESSAGE */
ADD_ERRNO(WSAENOMESSAGE, "WSAENOMESSAGE", "")
#endif /* WSAENOMESSAGE */
#ifdef ENOMSG
ADD_ERRNO(ENOMSG, "ENOMSG", "No message of desired type")
#endif /* ENOMSG */
#ifdef WSAENOMSG
#ifndef ENOMSG
ADD_ERRNO(WSAENOMSG, "ENOMSG", "No message of desired type")
#endif /* WSAENOMSG && !ENOMSG */
ADD_ERRNO(WSAENOMSG, "WSAENOMSG", "No message of desired type")
#endif /* WSAENOMSG */
#ifdef ENONDP
ADD_ERRNO(ENONDP, "ENONDP", "Need an NDP (8087...) to run")
#endif /* ENONDP */
#ifdef WSAENONDP
#ifndef ENONDP
ADD_ERRNO(WSAENONDP, "ENONDP", "Need an NDP (8087...) to run")
#endif /* WSAENONDP && !ENONDP */
ADD_ERRNO(WSAENONDP, "WSAENONDP", "Need an NDP (8087...) to run")
#endif /* WSAENONDP */
#ifdef ENONET
ADD_ERRNO(ENONET, "ENONET", "Machine is not on the network")
#endif /* ENONET */
#ifdef WSAENONET
#ifndef ENONET
ADD_ERRNO(WSAENONET, "ENONET", "Machine is not on the network")
#endif /* WSAENONET && !ENONET */
ADD_ERRNO(WSAENONET, "WSAENONET", "Machine is not on the network")
#endif /* WSAENONET */
#ifdef ENOPKG
ADD_ERRNO(ENOPKG, "ENOPKG", "Package not installed")
#endif /* ENOPKG */
#ifdef WSAENOPKG
#ifndef ENOPKG
ADD_ERRNO(WSAENOPKG, "ENOPKG", "Package not installed")
#endif /* WSAENOPKG && !ENOPKG */
ADD_ERRNO(WSAENOPKG, "WSAENOPKG", "Package not installed")
#endif /* WSAENOPKG */
#ifdef ENOPOLICY
ADD_ERRNO(ENOPOLICY, "ENOPOLICY", "No such policy registered")
#endif /* ENOPOLICY */
#ifdef WSAENOPOLICY
#ifndef ENOPOLICY
ADD_ERRNO(WSAENOPOLICY, "ENOPOLICY", "No such policy registered")
#endif /* WSAENOPOLICY && !ENOPOLICY */
ADD_ERRNO(WSAENOPOLICY, "WSAENOPOLICY", "No such policy registered")
#endif /* WSAENOPOLICY */
#ifdef ENOPROC
ADD_ERRNO(ENOPROC, "ENOPROC", "")
#endif /* ENOPROC */
#ifdef WSAENOPROC
#ifndef ENOPROC
ADD_ERRNO(WSAENOPROC, "ENOPROC", "")
#endif /* WSAENOPROC && !ENOPROC */
ADD_ERRNO(WSAENOPROC, "WSAENOPROC", "")
#endif /* WSAENOPROC */
#ifdef ENOPROTOOPT
ADD_ERRNO(ENOPROTOOPT, "ENOPROTOOPT", "Protocol not available")
#endif /* ENOPROTOOPT */
#ifdef WSAENOPROTOOPT
#ifndef ENOPROTOOPT
ADD_ERRNO(WSAENOPROTOOPT, "ENOPROTOOPT", "Protocol not available")
#endif /* WSAENOPROTOOPT && !ENOPROTOOPT */
ADD_ERRNO(WSAENOPROTOOPT, "WSAENOPROTOOPT", "Protocol not available")
#endif /* WSAENOPROTOOPT */
#ifdef ENOREG
ADD_ERRNO(ENOREG, "ENOREG", "Cannot register required kernel module")
#endif /* ENOREG */
#ifdef WSAENOREG
#ifndef ENOREG
ADD_ERRNO(WSAENOREG, "ENOREG", "Cannot register required kernel module")
#endif /* WSAENOREG && !ENOREG */
ADD_ERRNO(WSAENOREG, "WSAENOREG", "Cannot register required kernel module")
#endif /* WSAENOREG */
#ifdef ENOREMOTE
ADD_ERRNO(ENOREMOTE, "ENOREMOTE", "Must be done on local machine")
#endif /* ENOREMOTE */
#ifdef WSAENOREMOTE
#ifndef ENOREMOTE
ADD_ERRNO(WSAENOREMOTE, "ENOREMOTE", "Must be done on local machine")
#endif /* WSAENOREMOTE && !ENOREMOTE */
ADD_ERRNO(WSAENOREMOTE, "WSAENOREMOTE", "Must be done on local machine")
#endif /* WSAENOREMOTE */
#ifdef ENOSERVICE
ADD_ERRNO(ENOSERVICE, "ENOSERVICE", "")
#endif /* ENOSERVICE */
#ifdef WSAENOSERVICE
#ifndef ENOSERVICE
ADD_ERRNO(WSAENOSERVICE, "ENOSERVICE", "")
#endif /* WSAENOSERVICE && !ENOSERVICE */
ADD_ERRNO(WSAENOSERVICE, "WSAENOSERVICE", "")
#endif /* WSAENOSERVICE */
#ifdef ENOSHARE
ADD_ERRNO(ENOSHARE, "ENOSHARE", "")
#endif /* ENOSHARE */
#ifdef WSAENOSHARE
#ifndef ENOSHARE
ADD_ERRNO(WSAENOSHARE, "ENOSHARE", "")
#endif /* WSAENOSHARE && !ENOSHARE */
ADD_ERRNO(WSAENOSHARE, "WSAENOSHARE", "")
#endif /* WSAENOSHARE */
#ifdef ENOSPC
ADD_ERRNO(ENOSPC, "ENOSPC", "No space left on device")
#endif /* ENOSPC */
#ifdef WSAENOSPC
#ifndef ENOSPC
ADD_ERRNO(WSAENOSPC, "ENOSPC", "No space left on device")
#endif /* WSAENOSPC && !ENOSPC */
ADD_ERRNO(WSAENOSPC, "WSAENOSPC", "No space left on device")
#endif /* WSAENOSPC */
#ifdef ENOSR
ADD_ERRNO(ENOSR, "ENOSR", "Out of STREAM resources")
#endif /* ENOSR */
#ifdef WSAENOSR
#ifndef ENOSR
ADD_ERRNO(WSAENOSR, "ENOSR", "Out of STREAM resources")
#endif /* WSAENOSR && !ENOSR */
ADD_ERRNO(WSAENOSR, "WSAENOSR", "Out of STREAM resources")
#endif /* WSAENOSR */
#ifdef ENOSTR
ADD_ERRNO(ENOSTR, "ENOSTR", "Device not a STREAM")
#endif /* ENOSTR */
#ifdef WSAENOSTR
#ifndef ENOSTR
ADD_ERRNO(WSAENOSTR, "ENOSTR", "Device not a STREAM")
#endif /* WSAENOSTR && !ENOSTR */
ADD_ERRNO(WSAENOSTR, "WSAENOSTR", "Device not a STREAM")
#endif /* WSAENOSTR */
#ifdef ENOSYM
ADD_ERRNO(ENOSYM, "ENOSYM", "Symbol does not exist in executable")
#endif /* ENOSYM */
#ifdef WSAENOSYM
#ifndef ENOSYM
ADD_ERRNO(WSAENOSYM, "ENOSYM", "Symbol does not exist in executable")
#endif /* WSAENOSYM && !ENOSYM */
ADD_ERRNO(WSAENOSYM, "WSAENOSYM", "Symbol does not exist in executable")
#endif /* WSAENOSYM */
#ifdef ENOSYS
ADD_ERRNO(ENOSYS, "ENOSYS", "Invalid system call number")
#endif /* ENOSYS */
#ifdef WSAENOSYS
#ifndef ENOSYS
ADD_ERRNO(WSAENOSYS, "ENOSYS", "Invalid system call number")
#endif /* WSAENOSYS && !ENOSYS */
ADD_ERRNO(WSAENOSYS, "WSAENOSYS", "Invalid system call number")
#endif /* WSAENOSYS */
#ifdef ENOTACTIVE
ADD_ERRNO(ENOTACTIVE, "ENOTACTIVE", "")
#endif /* ENOTACTIVE */
#ifdef WSAENOTACTIVE
#ifndef ENOTACTIVE
ADD_ERRNO(WSAENOTACTIVE, "ENOTACTIVE", "")
#endif /* WSAENOTACTIVE && !ENOTACTIVE */
ADD_ERRNO(WSAENOTACTIVE, "WSAENOTACTIVE", "")
#endif /* WSAENOTACTIVE */
#ifdef ENOTBLK
ADD_ERRNO(ENOTBLK, "ENOTBLK", "Block device required")
#endif /* ENOTBLK */
#ifdef WSAENOTBLK
#ifndef ENOTBLK
ADD_ERRNO(WSAENOTBLK, "ENOTBLK", "Block device required")
#endif /* WSAENOTBLK && !ENOTBLK */
ADD_ERRNO(WSAENOTBLK, "WSAENOTBLK", "Block device required")
#endif /* WSAENOTBLK */
#ifdef ENOTCAPABLE
ADD_ERRNO(ENOTCAPABLE, "ENOTCAPABLE", "")
#endif /* ENOTCAPABLE */
#ifdef WSAENOTCAPABLE
#ifndef ENOTCAPABLE
ADD_ERRNO(WSAENOTCAPABLE, "ENOTCAPABLE", "")
#endif /* WSAENOTCAPABLE && !ENOTCAPABLE */
ADD_ERRNO(WSAENOTCAPABLE, "WSAENOTCAPABLE", "")
#endif /* WSAENOTCAPABLE */
#ifdef ENOTCONN
ADD_ERRNO(ENOTCONN, "ENOTCONN", "Transport endpoint is not connected")
#endif /* ENOTCONN */
#ifdef WSAENOTCONN
#ifndef ENOTCONN
ADD_ERRNO(WSAENOTCONN, "ENOTCONN", "Transport endpoint is not connected")
#endif /* WSAENOTCONN && !ENOTCONN */
ADD_ERRNO(WSAENOTCONN, "WSAENOTCONN", "Transport endpoint is not connected")
#endif /* WSAENOTCONN */
#ifdef ENOTCONTROLLER
ADD_ERRNO(ENOTCONTROLLER, "ENOTCONTROLLER", "")
#endif /* ENOTCONTROLLER */
#ifdef WSAENOTCONTROLLER
#ifndef ENOTCONTROLLER
ADD_ERRNO(WSAENOTCONTROLLER, "ENOTCONTROLLER", "")
#endif /* WSAENOTCONTROLLER && !ENOTCONTROLLER */
ADD_ERRNO(WSAENOTCONTROLLER, "WSAENOTCONTROLLER", "")
#endif /* WSAENOTCONTROLLER */
#ifdef ENOTDIR
ADD_ERRNO(ENOTDIR, "ENOTDIR", "Not a directory")
#endif /* ENOTDIR */
#ifdef WSAENOTDIR
#ifndef ENOTDIR
ADD_ERRNO(WSAENOTDIR, "ENOTDIR", "Not a directory")
#endif /* WSAENOTDIR && !ENOTDIR */
ADD_ERRNO(WSAENOTDIR, "WSAENOTDIR", "Not a directory")
#endif /* WSAENOTDIR */
#ifdef ENOTEMPTY
ADD_ERRNO(ENOTEMPTY, "ENOTEMPTY", "Directory not empty")
#endif /* ENOTEMPTY */
#ifdef WSAENOTEMPTY
#ifndef ENOTEMPTY
ADD_ERRNO(WSAENOTEMPTY, "ENOTEMPTY", "Directory not empty")
#endif /* WSAENOTEMPTY && !ENOTEMPTY */
ADD_ERRNO(WSAENOTEMPTY, "WSAENOTEMPTY", "Directory not empty")
#endif /* WSAENOTEMPTY */
#ifdef ENOTENQUEUED
ADD_ERRNO(ENOTENQUEUED, "ENOTENQUEUED", "")
#endif /* ENOTENQUEUED */
#ifdef WSAENOTENQUEUED
#ifndef ENOTENQUEUED
ADD_ERRNO(WSAENOTENQUEUED, "ENOTENQUEUED", "")
#endif /* WSAENOTENQUEUED && !ENOTENQUEUED */
ADD_ERRNO(WSAENOTENQUEUED, "WSAENOTENQUEUED", "")
#endif /* WSAENOTENQUEUED */
#ifdef ENOTJOINED
ADD_ERRNO(ENOTJOINED, "ENOTJOINED", "")
#endif /* ENOTJOINED */
#ifdef WSAENOTJOINED
#ifndef ENOTJOINED
ADD_ERRNO(WSAENOTJOINED, "ENOTJOINED", "")
#endif /* WSAENOTJOINED && !ENOTJOINED */
ADD_ERRNO(WSAENOTJOINED, "WSAENOTJOINED", "")
#endif /* WSAENOTJOINED */
#ifdef ENOTNAM
ADD_ERRNO(ENOTNAM, "ENOTNAM", "Not a XENIX named type file")
#endif /* ENOTNAM */
#ifdef WSAENOTNAM
#ifndef ENOTNAM
ADD_ERRNO(WSAENOTNAM, "ENOTNAM", "Not a XENIX named type file")
#endif /* WSAENOTNAM && !ENOTNAM */
ADD_ERRNO(WSAENOTNAM, "WSAENOTNAM", "Not a XENIX named type file")
#endif /* WSAENOTNAM */
#ifdef ENOTREADY
ADD_ERRNO(ENOTREADY, "ENOTREADY", "Device not ready")
#endif /* ENOTREADY */
#ifdef WSAENOTREADY
#ifndef ENOTREADY
ADD_ERRNO(WSAENOTREADY, "ENOTREADY", "Device not ready")
#endif /* WSAENOTREADY && !ENOTREADY */
ADD_ERRNO(WSAENOTREADY, "WSAENOTREADY", "Device not ready")
#endif /* WSAENOTREADY */
#ifdef ENOTRECOVERABLE
ADD_ERRNO(ENOTRECOVERABLE, "ENOTRECOVERABLE", "State not recoverable")
#endif /* ENOTRECOVERABLE */
#ifdef WSAENOTRECOVERABLE
#ifndef ENOTRECOVERABLE
ADD_ERRNO(WSAENOTRECOVERABLE, "ENOTRECOVERABLE", "State not recoverable")
#endif /* WSAENOTRECOVERABLE && !ENOTRECOVERABLE */
ADD_ERRNO(WSAENOTRECOVERABLE, "WSAENOTRECOVERABLE", "State not recoverable")
#endif /* WSAENOTRECOVERABLE */
#ifdef ENOTRUST
ADD_ERRNO(ENOTRUST, "ENOTRUST", "Not a trusted program")
#endif /* ENOTRUST */
#ifdef WSAENOTRUST
#ifndef ENOTRUST
ADD_ERRNO(WSAENOTRUST, "ENOTRUST", "Not a trusted program")
#endif /* WSAENOTRUST && !ENOTRUST */
ADD_ERRNO(WSAENOTRUST, "WSAENOTRUST", "Not a trusted program")
#endif /* WSAENOTRUST */
#ifdef ENOTSOCK
ADD_ERRNO(ENOTSOCK, "ENOTSOCK", "Socket operation on non-socket")
#endif /* ENOTSOCK */
#ifdef WSAENOTSOCK
#ifndef ENOTSOCK
ADD_ERRNO(WSAENOTSOCK, "ENOTSOCK", "Socket operation on non-socket")
#endif /* WSAENOTSOCK && !ENOTSOCK */
ADD_ERRNO(WSAENOTSOCK, "WSAENOTSOCK", "Socket operation on non-socket")
#endif /* WSAENOTSOCK */
#ifdef ENOTSTOPPED
ADD_ERRNO(ENOTSTOPPED, "ENOTSTOPPED", "")
#endif /* ENOTSTOPPED */
#ifdef WSAENOTSTOPPED
#ifndef ENOTSTOPPED
ADD_ERRNO(WSAENOTSTOPPED, "ENOTSTOPPED", "")
#endif /* WSAENOTSTOPPED && !ENOTSTOPPED */
ADD_ERRNO(WSAENOTSTOPPED, "WSAENOTSTOPPED", "")
#endif /* WSAENOTSTOPPED */
#ifdef ENOTSUP
ADD_ERRNO(ENOTSUP, "ENOTSUP", "POSIX threads unsupported value")
#endif /* ENOTSUP */
#ifdef WSAENOTSUP
#ifndef ENOTSUP
ADD_ERRNO(WSAENOTSUP, "ENOTSUP", "POSIX threads unsupported value")
#endif /* WSAENOTSUP && !ENOTSUP */
ADD_ERRNO(WSAENOTSUP, "WSAENOTSUP", "POSIX threads unsupported value")
#endif /* WSAENOTSUP */
#ifdef ENOTTY
ADD_ERRNO(ENOTTY, "ENOTTY", "Inappropriate ioctl for device")
#endif /* ENOTTY */
#ifdef WSAENOTTY
#ifndef ENOTTY
ADD_ERRNO(WSAENOTTY, "ENOTTY", "Inappropriate ioctl for device")
#endif /* WSAENOTTY && !ENOTTY */
ADD_ERRNO(WSAENOTTY, "WSAENOTTY", "Inappropriate ioctl for device")
#endif /* WSAENOTTY */
#ifdef ENOTUNIQ
ADD_ERRNO(ENOTUNIQ, "ENOTUNIQ", "Name not unique on network")
#endif /* ENOTUNIQ */
#ifdef WSAENOTUNIQ
#ifndef ENOTUNIQ
ADD_ERRNO(WSAENOTUNIQ, "ENOTUNIQ", "Name not unique on network")
#endif /* WSAENOTUNIQ && !ENOTUNIQ */
ADD_ERRNO(WSAENOTUNIQ, "WSAENOTUNIQ", "Name not unique on network")
#endif /* WSAENOTUNIQ */
#ifdef ENOUNLD
ADD_ERRNO(ENOUNLD, "ENOUNLD", "Cannot unload kernel module")
#endif /* ENOUNLD */
#ifdef WSAENOUNLD
#ifndef ENOUNLD
ADD_ERRNO(WSAENOUNLD, "ENOUNLD", "Cannot unload kernel module")
#endif /* WSAENOUNLD && !ENOUNLD */
ADD_ERRNO(WSAENOUNLD, "WSAENOUNLD", "Cannot unload kernel module")
#endif /* WSAENOUNLD */
#ifdef ENOUNREG
ADD_ERRNO(ENOUNREG, "ENOUNREG", "Cannot unregister kernel module")
#endif /* ENOUNREG */
#ifdef WSAENOUNREG
#ifndef ENOUNREG
ADD_ERRNO(WSAENOUNREG, "ENOUNREG", "Cannot unregister kernel module")
#endif /* WSAENOUNREG && !ENOUNREG */
ADD_ERRNO(WSAENOUNREG, "WSAENOUNREG", "Cannot unregister kernel module")
#endif /* WSAENOUNREG */
#ifdef ENOURG
ADD_ERRNO(ENOURG, "ENOURG", "No urgent data present (Minix)")
#endif /* ENOURG */
#ifdef WSAENOURG
#ifndef ENOURG
ADD_ERRNO(WSAENOURG, "ENOURG", "No urgent data present (Minix)")
#endif /* WSAENOURG && !ENOURG */
ADD_ERRNO(WSAENOURG, "WSAENOURG", "No urgent data present (Minix)")
#endif /* WSAENOURG */
#ifdef ENXIO
ADD_ERRNO(ENXIO, "ENXIO", "No such device or address")
#endif /* ENXIO */
#ifdef WSAENXIO
#ifndef ENXIO
ADD_ERRNO(WSAENXIO, "ENXIO", "No such device or address")
#endif /* WSAENXIO && !ENXIO */
ADD_ERRNO(WSAENXIO, "WSAENXIO", "No such device or address")
#endif /* WSAENXIO */
#ifdef EOPCOMPLETE
ADD_ERRNO(EOPCOMPLETE, "EOPCOMPLETE", "Operation completed at server")
#endif /* EOPCOMPLETE */
#ifdef WSAEOPCOMPLETE
#ifndef EOPCOMPLETE
ADD_ERRNO(WSAEOPCOMPLETE, "EOPCOMPLETE", "Operation completed at server")
#endif /* WSAEOPCOMPLETE && !EOPCOMPLETE */
ADD_ERRNO(WSAEOPCOMPLETE, "WSAEOPCOMPLETE", "Operation completed at server")
#endif /* WSAEOPCOMPLETE */
#ifdef EOPNOTSUPP
ADD_ERRNO(EOPNOTSUPP, "EOPNOTSUPP", "Operation not supported on socket")
#endif /* EOPNOTSUPP */
#ifdef WSAEOPNOTSUPP
#ifndef EOPNOTSUPP
ADD_ERRNO(WSAEOPNOTSUPP, "EOPNOTSUPP", "Operation not supported on socket")
#endif /* WSAEOPNOTSUPP && !EOPNOTSUPP */
ADD_ERRNO(WSAEOPNOTSUPP, "WSAEOPNOTSUPP", "Operation not supported on socket")
#endif /* WSAEOPNOTSUPP */
#ifdef EOTHER
ADD_ERRNO(EOTHER, "EOTHER", "")
#endif /* EOTHER */
#ifdef WSAEOTHER
#ifndef EOTHER
ADD_ERRNO(WSAEOTHER, "EOTHER", "")
#endif /* WSAEOTHER && !EOTHER */
ADD_ERRNO(WSAEOTHER, "WSAEOTHER", "")
#endif /* WSAEOTHER */
#ifdef EOUTOFBUFS
ADD_ERRNO(EOUTOFBUFS, "EOUTOFBUFS", "Not enough buffers left (Minix)")
#endif /* EOUTOFBUFS */
#ifdef WSAEOUTOFBUFS
#ifndef EOUTOFBUFS
ADD_ERRNO(WSAEOUTOFBUFS, "EOUTOFBUFS", "Not enough buffers left (Minix)")
#endif /* WSAEOUTOFBUFS && !EOUTOFBUFS */
ADD_ERRNO(WSAEOUTOFBUFS, "WSAEOUTOFBUFS", "Not enough buffers left (Minix)")
#endif /* WSAEOUTOFBUFS */
#ifdef EOVERFLOW
ADD_ERRNO(EOVERFLOW, "EOVERFLOW", "Value too large for defined data type")
#endif /* EOVERFLOW */
#ifdef WSAEOVERFLOW
#ifndef EOVERFLOW
ADD_ERRNO(WSAEOVERFLOW, "EOVERFLOW", "Value too large for defined data type")
#endif /* WSAEOVERFLOW && !EOVERFLOW */
ADD_ERRNO(WSAEOVERFLOW, "WSAEOVERFLOW", "Value too large for defined data type")
#endif /* WSAEOVERFLOW */
#ifdef EOWNERDEAD
ADD_ERRNO(EOWNERDEAD, "EOWNERDEAD", "Previous owner died")
#endif /* EOWNERDEAD */
#ifdef WSAEOWNERDEAD
#ifndef EOWNERDEAD
ADD_ERRNO(WSAEOWNERDEAD, "EOWNERDEAD", "Previous owner died")
#endif /* WSAEOWNERDEAD && !EOWNERDEAD */
ADD_ERRNO(WSAEOWNERDEAD, "WSAEOWNERDEAD", "Previous owner died")
#endif /* WSAEOWNERDEAD */
#ifdef EPACKSIZE
ADD_ERRNO(EPACKSIZE, "EPACKSIZE", "Invalid packet size for some protocol (Minix)")
#endif /* EPACKSIZE */
#ifdef WSAEPACKSIZE
#ifndef EPACKSIZE
ADD_ERRNO(WSAEPACKSIZE, "EPACKSIZE", "Invalid packet size for some protocol (Minix)")
#endif /* WSAEPACKSIZE && !EPACKSIZE */
ADD_ERRNO(WSAEPACKSIZE, "WSAEPACKSIZE", "Invalid packet size for some protocol (Minix)")
#endif /* WSAEPACKSIZE */
#ifdef EPATHREMOTE
ADD_ERRNO(EPATHREMOTE, "EPATHREMOTE", "Pathname is remote")
#endif /* EPATHREMOTE */
#ifdef WSAEPATHREMOTE
#ifndef EPATHREMOTE
ADD_ERRNO(WSAEPATHREMOTE, "EPATHREMOTE", "Pathname is remote")
#endif /* WSAEPATHREMOTE && !EPATHREMOTE */
ADD_ERRNO(WSAEPATHREMOTE, "WSAEPATHREMOTE", "Pathname is remote")
#endif /* WSAEPATHREMOTE */
#ifdef EPERM
ADD_ERRNO(EPERM, "EPERM", "Operation not permitted")
#endif /* EPERM */
#ifdef WSAEPERM
#ifndef EPERM
ADD_ERRNO(WSAEPERM, "EPERM", "Operation not permitted")
#endif /* WSAEPERM && !EPERM */
ADD_ERRNO(WSAEPERM, "WSAEPERM", "Operation not permitted")
#endif /* WSAEPERM */
#ifdef EPFNOSUPPORT
ADD_ERRNO(EPFNOSUPPORT, "EPFNOSUPPORT", "Protocol family not supported")
#endif /* EPFNOSUPPORT */
#ifdef WSAEPFNOSUPPORT
#ifndef EPFNOSUPPORT
ADD_ERRNO(WSAEPFNOSUPPORT, "EPFNOSUPPORT", "Protocol family not supported")
#endif /* WSAEPFNOSUPPORT && !EPFNOSUPPORT */
ADD_ERRNO(WSAEPFNOSUPPORT, "WSAEPFNOSUPPORT", "Protocol family not supported")
#endif /* WSAEPFNOSUPPORT */
#ifdef EPIPE
ADD_ERRNO(EPIPE, "EPIPE", "Broken pipe")
#endif /* EPIPE */
#ifdef WSAEPIPE
#ifndef EPIPE
ADD_ERRNO(WSAEPIPE, "EPIPE", "Broken pipe")
#endif /* WSAEPIPE && !EPIPE */
ADD_ERRNO(WSAEPIPE, "WSAEPIPE", "Broken pipe")
#endif /* WSAEPIPE */
#ifdef EPOWERF
ADD_ERRNO(EPOWERF, "EPOWERF", "")
#endif /* EPOWERF */
#ifdef WSAEPOWERF
#ifndef EPOWERF
ADD_ERRNO(WSAEPOWERF, "EPOWERF", "")
#endif /* WSAEPOWERF && !EPOWERF */
ADD_ERRNO(WSAEPOWERF, "WSAEPOWERF", "")
#endif /* WSAEPOWERF */
#ifdef EPROCLIM
ADD_ERRNO(EPROCLIM, "EPROCLIM", "Too many processes")
#endif /* EPROCLIM */
#ifdef WSAEPROCLIM
#ifndef EPROCLIM
ADD_ERRNO(WSAEPROCLIM, "EPROCLIM", "Too many processes")
#endif /* WSAEPROCLIM && !EPROCLIM */
ADD_ERRNO(WSAEPROCLIM, "WSAEPROCLIM", "Too many processes")
#endif /* WSAEPROCLIM */
#ifdef EPROCUNAVAIL
ADD_ERRNO(EPROCUNAVAIL, "EPROCUNAVAIL", "Bad procedure for program")
#endif /* EPROCUNAVAIL */
#ifdef WSAEPROCUNAVAIL
#ifndef EPROCUNAVAIL
ADD_ERRNO(WSAEPROCUNAVAIL, "EPROCUNAVAIL", "Bad procedure for program")
#endif /* WSAEPROCUNAVAIL && !EPROCUNAVAIL */
ADD_ERRNO(WSAEPROCUNAVAIL, "WSAEPROCUNAVAIL", "Bad procedure for program")
#endif /* WSAEPROCUNAVAIL */
#ifdef EPROGMISMATCH
ADD_ERRNO(EPROGMISMATCH, "EPROGMISMATCH", "Program version wrong")
#endif /* EPROGMISMATCH */
#ifdef WSAEPROGMISMATCH
#ifndef EPROGMISMATCH
ADD_ERRNO(WSAEPROGMISMATCH, "EPROGMISMATCH", "Program version wrong")
#endif /* WSAEPROGMISMATCH && !EPROGMISMATCH */
ADD_ERRNO(WSAEPROGMISMATCH, "WSAEPROGMISMATCH", "Program version wrong")
#endif /* WSAEPROGMISMATCH */
#ifdef EPROGUNAVAIL
ADD_ERRNO(EPROGUNAVAIL, "EPROGUNAVAIL", "RPC program not available")
#endif /* EPROGUNAVAIL */
#ifdef WSAEPROGUNAVAIL
#ifndef EPROGUNAVAIL
ADD_ERRNO(WSAEPROGUNAVAIL, "EPROGUNAVAIL", "RPC program not available")
#endif /* WSAEPROGUNAVAIL && !EPROGUNAVAIL */
ADD_ERRNO(WSAEPROGUNAVAIL, "WSAEPROGUNAVAIL", "RPC program not available")
#endif /* WSAEPROGUNAVAIL */
#ifdef EPROTO
ADD_ERRNO(EPROTO, "EPROTO", "Protocol error")
#endif /* EPROTO */
#ifdef WSAEPROTO
#ifndef EPROTO
ADD_ERRNO(WSAEPROTO, "EPROTO", "Protocol error")
#endif /* WSAEPROTO && !EPROTO */
ADD_ERRNO(WSAEPROTO, "WSAEPROTO", "Protocol error")
#endif /* WSAEPROTO */
#ifdef EPROTONOSUPPORT
ADD_ERRNO(EPROTONOSUPPORT, "EPROTONOSUPPORT", "Protocol not supported")
#endif /* EPROTONOSUPPORT */
#ifdef WSAEPROTONOSUPPORT
#ifndef EPROTONOSUPPORT
ADD_ERRNO(WSAEPROTONOSUPPORT, "EPROTONOSUPPORT", "Protocol not supported")
#endif /* WSAEPROTONOSUPPORT && !EPROTONOSUPPORT */
ADD_ERRNO(WSAEPROTONOSUPPORT, "WSAEPROTONOSUPPORT", "Protocol not supported")
#endif /* WSAEPROTONOSUPPORT */
#ifdef EPROTOTYPE
ADD_ERRNO(EPROTOTYPE, "EPROTOTYPE", "Protocol wrong type for socket")
#endif /* EPROTOTYPE */
#ifdef WSAEPROTOTYPE
#ifndef EPROTOTYPE
ADD_ERRNO(WSAEPROTOTYPE, "EPROTOTYPE", "Protocol wrong type for socket")
#endif /* WSAEPROTOTYPE && !EPROTOTYPE */
ADD_ERRNO(WSAEPROTOTYPE, "WSAEPROTOTYPE", "Protocol wrong type for socket")
#endif /* WSAEPROTOTYPE */
#ifdef EPWROFF
ADD_ERRNO(EPWROFF, "EPWROFF", "Device power is off")
#endif /* EPWROFF */
#ifdef WSAEPWROFF
#ifndef EPWROFF
ADD_ERRNO(WSAEPWROFF, "EPWROFF", "Device power is off")
#endif /* WSAEPWROFF && !EPWROFF */
ADD_ERRNO(WSAEPWROFF, "WSAEPWROFF", "Device power is off")
#endif /* WSAEPWROFF */
#ifdef EQFULL
ADD_ERRNO(EQFULL, "EQFULL", "Interface output queue is full")
#endif /* EQFULL */
#ifdef WSAEQFULL
#ifndef EQFULL
ADD_ERRNO(WSAEQFULL, "EQFULL", "Interface output queue is full")
#endif /* WSAEQFULL && !EQFULL */
ADD_ERRNO(WSAEQFULL, "WSAEQFULL", "Interface output queue is full")
#endif /* WSAEQFULL */
#ifdef ERANGE
ADD_ERRNO(ERANGE, "ERANGE", "Math result not representable")
#endif /* ERANGE */
#ifdef WSAERANGE
#ifndef ERANGE
ADD_ERRNO(WSAERANGE, "ERANGE", "Math result not representable")
#endif /* WSAERANGE && !ERANGE */
ADD_ERRNO(WSAERANGE, "WSAERANGE", "Math result not representable")
#endif /* WSAERANGE */
#ifdef EREFUSED
ADD_ERRNO(EREFUSED, "EREFUSED", "Double define for NFS")
#endif /* EREFUSED */
#ifdef WSAEREFUSED
#ifndef EREFUSED
ADD_ERRNO(WSAEREFUSED, "EREFUSED", "Double define for NFS")
#endif /* WSAEREFUSED && !EREFUSED */
ADD_ERRNO(WSAEREFUSED, "WSAEREFUSED", "Double define for NFS")
#endif /* WSAEREFUSED */
#ifdef ERELOC
ADD_ERRNO(ERELOC, "ERELOC", "Object file error in loading kernel module")
#endif /* ERELOC */
#ifdef WSAERELOC
#ifndef ERELOC
ADD_ERRNO(WSAERELOC, "ERELOC", "Object file error in loading kernel module")
#endif /* WSAERELOC && !ERELOC */
ADD_ERRNO(WSAERELOC, "WSAERELOC", "Object file error in loading kernel module")
#endif /* WSAERELOC */
#ifdef ERELOCATED
ADD_ERRNO(ERELOCATED, "ERELOCATED", "")
#endif /* ERELOCATED */
#ifdef WSAERELOCATED
#ifndef ERELOCATED
ADD_ERRNO(WSAERELOCATED, "ERELOCATED", "")
#endif /* WSAERELOCATED && !ERELOCATED */
ADD_ERRNO(WSAERELOCATED, "WSAERELOCATED", "")
#endif /* WSAERELOCATED */
#ifdef ERELOOKUP
ADD_ERRNO(ERELOOKUP, "ERELOOKUP", "")
#endif /* ERELOOKUP */
#ifdef WSAERELOOKUP
#ifndef ERELOOKUP
ADD_ERRNO(WSAERELOOKUP, "ERELOOKUP", "")
#endif /* WSAERELOOKUP && !ERELOOKUP */
ADD_ERRNO(WSAERELOOKUP, "WSAERELOOKUP", "")
#endif /* WSAERELOOKUP */
#ifdef EREMCHG
ADD_ERRNO(EREMCHG, "EREMCHG", "Remote address changed")
#endif /* EREMCHG */
#ifdef WSAEREMCHG
#ifndef EREMCHG
ADD_ERRNO(WSAEREMCHG, "EREMCHG", "Remote address changed")
#endif /* WSAEREMCHG && !EREMCHG */
ADD_ERRNO(WSAEREMCHG, "WSAEREMCHG", "Remote address changed")
#endif /* WSAEREMCHG */
#ifdef EREMDEV
ADD_ERRNO(EREMDEV, "EREMDEV", "")
#endif /* EREMDEV */
#ifdef WSAEREMDEV
#ifndef EREMDEV
ADD_ERRNO(WSAEREMDEV, "EREMDEV", "")
#endif /* WSAEREMDEV && !EREMDEV */
ADD_ERRNO(WSAEREMDEV, "WSAEREMDEV", "")
#endif /* WSAEREMDEV */
#ifdef EREMOTE
ADD_ERRNO(EREMOTE, "EREMOTE", "Object is remote")
#endif /* EREMOTE */
#ifdef WSAEREMOTE
#ifndef EREMOTE
ADD_ERRNO(WSAEREMOTE, "EREMOTE", "Object is remote")
#endif /* WSAEREMOTE && !EREMOTE */
ADD_ERRNO(WSAEREMOTE, "WSAEREMOTE", "Object is remote")
#endif /* WSAEREMOTE */
#ifdef EREMOTEIO
ADD_ERRNO(EREMOTEIO, "EREMOTEIO", "Remote I/O error")
#endif /* EREMOTEIO */
#ifdef WSAEREMOTEIO
#ifndef EREMOTEIO
ADD_ERRNO(WSAEREMOTEIO, "EREMOTEIO", "Remote I/O error")
#endif /* WSAEREMOTEIO && !EREMOTEIO */
ADD_ERRNO(WSAEREMOTEIO, "WSAEREMOTEIO", "Remote I/O error")
#endif /* WSAEREMOTEIO */
#ifdef EREMOTERELEASE
ADD_ERRNO(EREMOTERELEASE, "EREMOTERELEASE", "Remote peer released connection")
#endif /* EREMOTERELEASE */
#ifdef WSAEREMOTERELEASE
#ifndef EREMOTERELEASE
ADD_ERRNO(WSAEREMOTERELEASE, "EREMOTERELEASE", "Remote peer released connection")
#endif /* WSAEREMOTERELEASE && !EREMOTERELEASE */
ADD_ERRNO(WSAEREMOTERELEASE, "WSAEREMOTERELEASE", "Remote peer released connection")
#endif /* WSAEREMOTERELEASE */
#ifdef ERESTART
ADD_ERRNO(ERESTART, "ERESTART", "Interrupted system call should be restarted")
#endif /* ERESTART */
#ifdef WSAERESTART
#ifndef ERESTART
ADD_ERRNO(WSAERESTART, "ERESTART", "Interrupted system call should be restarted")
#endif /* WSAERESTART && !ERESTART */
ADD_ERRNO(WSAERESTART, "WSAERESTART", "Interrupted system call should be restarted")
#endif /* WSAERESTART */
#ifdef ERESTARTNOHAND
ADD_ERRNO(ERESTARTNOHAND, "ERESTARTNOHAND", "")
#endif /* ERESTARTNOHAND */
#ifdef WSAERESTARTNOHAND
#ifndef ERESTARTNOHAND
ADD_ERRNO(WSAERESTARTNOHAND, "ERESTARTNOHAND", "")
#endif /* WSAERESTARTNOHAND && !ERESTARTNOHAND */
ADD_ERRNO(WSAERESTARTNOHAND, "WSAERESTARTNOHAND", "")
#endif /* WSAERESTARTNOHAND */
#ifdef ERESTARTNOINTR
ADD_ERRNO(ERESTARTNOINTR, "ERESTARTNOINTR", "")
#endif /* ERESTARTNOINTR */
#ifdef WSAERESTARTNOINTR
#ifndef ERESTARTNOINTR
ADD_ERRNO(WSAERESTARTNOINTR, "ERESTARTNOINTR", "")
#endif /* WSAERESTARTNOINTR && !ERESTARTNOINTR */
ADD_ERRNO(WSAERESTARTNOINTR, "WSAERESTARTNOINTR", "")
#endif /* WSAERESTARTNOINTR */
#ifdef ERESTARTSYS
ADD_ERRNO(ERESTARTSYS, "ERESTARTSYS", "")
#endif /* ERESTARTSYS */
#ifdef WSAERESTARTSYS
#ifndef ERESTARTSYS
ADD_ERRNO(WSAERESTARTSYS, "ERESTARTSYS", "")
#endif /* WSAERESTARTSYS && !ERESTARTSYS */
ADD_ERRNO(WSAERESTARTSYS, "WSAERESTARTSYS", "")
#endif /* WSAERESTARTSYS */
#ifdef ERFKILL
ADD_ERRNO(ERFKILL, "ERFKILL", "Operation not possible due to RF-kill")
#endif /* ERFKILL */
#ifdef WSAERFKILL
#ifndef ERFKILL
ADD_ERRNO(WSAERFKILL, "ERFKILL", "Operation not possible due to RF-kill")
#endif /* WSAERFKILL && !ERFKILL */
ADD_ERRNO(WSAERFKILL, "WSAERFKILL", "Operation not possible due to RF-kill")
#endif /* WSAERFKILL */
#ifdef EROFS
ADD_ERRNO(EROFS, "EROFS", "Read-only filesystem")
#endif /* EROFS */
#ifdef WSAEROFS
#ifndef EROFS
ADD_ERRNO(WSAEROFS, "EROFS", "Read-only filesystem")
#endif /* WSAEROFS && !EROFS */
ADD_ERRNO(WSAEROFS, "WSAEROFS", "Read-only filesystem")
#endif /* WSAEROFS */
#ifdef ERPCMISMATCH
ADD_ERRNO(ERPCMISMATCH, "ERPCMISMATCH", "RPC version wrong")
#endif /* ERPCMISMATCH */
#ifdef WSAERPCMISMATCH
#ifndef ERPCMISMATCH
ADD_ERRNO(WSAERPCMISMATCH, "ERPCMISMATCH", "RPC version wrong")
#endif /* WSAERPCMISMATCH && !ERPCMISMATCH */
ADD_ERRNO(WSAERPCMISMATCH, "WSAERPCMISMATCH", "RPC version wrong")
#endif /* WSAERPCMISMATCH */
#ifdef ERREMOTE
ADD_ERRNO(ERREMOTE, "ERREMOTE", "")
#endif /* ERREMOTE */
#ifdef WSAERREMOTE
#ifndef ERREMOTE
ADD_ERRNO(WSAERREMOTE, "ERREMOTE", "")
#endif /* WSAERREMOTE && !ERREMOTE */
ADD_ERRNO(WSAERREMOTE, "WSAERREMOTE", "")
#endif /* WSAERREMOTE */
#ifdef ESAD
ADD_ERRNO(ESAD, "ESAD", "Security authentication denied")
#endif /* ESAD */
#ifdef WSAESAD
#ifndef ESAD
ADD_ERRNO(WSAESAD, "ESAD", "Security authentication denied")
#endif /* WSAESAD && !ESAD */
ADD_ERRNO(WSAESAD, "WSAESAD", "Security authentication denied")
#endif /* WSAESAD */
#ifdef ESHLIBVERS
ADD_ERRNO(ESHLIBVERS, "ESHLIBVERS", "Shared library version mismatch")
#endif /* ESHLIBVERS */
#ifdef WSAESHLIBVERS
#ifndef ESHLIBVERS
ADD_ERRNO(WSAESHLIBVERS, "ESHLIBVERS", "Shared library version mismatch")
#endif /* WSAESHLIBVERS && !ESHLIBVERS */
ADD_ERRNO(WSAESHLIBVERS, "WSAESHLIBVERS", "Shared library version mismatch")
#endif /* WSAESHLIBVERS */
#ifdef ESHUTDOWN
ADD_ERRNO(ESHUTDOWN, "ESHUTDOWN", "Cannot send after socket shutdown")
#endif /* ESHUTDOWN */
#ifdef WSAESHUTDOWN
#ifndef ESHUTDOWN
ADD_ERRNO(WSAESHUTDOWN, "ESHUTDOWN", "Cannot send after socket shutdown")
#endif /* WSAESHUTDOWN && !ESHUTDOWN */
ADD_ERRNO(WSAESHUTDOWN, "WSAESHUTDOWN", "Cannot send after socket shutdown")
#endif /* WSAESHUTDOWN */
#ifdef ESIGPARM
ADD_ERRNO(ESIGPARM, "ESIGPARM", "Signal Error")
#endif /* ESIGPARM */
#ifdef WSAESIGPARM
#ifndef ESIGPARM
ADD_ERRNO(WSAESIGPARM, "ESIGPARM", "Signal Error")
#endif /* WSAESIGPARM && !ESIGPARM */
ADD_ERRNO(WSAESIGPARM, "WSAESIGPARM", "Signal Error")
#endif /* WSAESIGPARM */
#ifdef ESOCKTNOSUPPORT
ADD_ERRNO(ESOCKTNOSUPPORT, "ESOCKTNOSUPPORT", "Socket type not supported")
#endif /* ESOCKTNOSUPPORT */
#ifdef WSAESOCKTNOSUPPORT
#ifndef ESOCKTNOSUPPORT
ADD_ERRNO(WSAESOCKTNOSUPPORT, "ESOCKTNOSUPPORT", "Socket type not supported")
#endif /* WSAESOCKTNOSUPPORT && !ESOCKTNOSUPPORT */
ADD_ERRNO(WSAESOCKTNOSUPPORT, "WSAESOCKTNOSUPPORT", "Socket type not supported")
#endif /* WSAESOCKTNOSUPPORT */
#ifdef ESOFT
ADD_ERRNO(ESOFT, "ESOFT", "I/O completed, but needs relocation")
#endif /* ESOFT */
#ifdef WSAESOFT
#ifndef ESOFT
ADD_ERRNO(WSAESOFT, "ESOFT", "I/O completed, but needs relocation")
#endif /* WSAESOFT && !ESOFT */
ADD_ERRNO(WSAESOFT, "WSAESOFT", "I/O completed, but needs relocation")
#endif /* WSAESOFT */
#ifdef ESPIPE
ADD_ERRNO(ESPIPE, "ESPIPE", "Illegal seek")
#endif /* ESPIPE */
#ifdef WSAESPIPE
#ifndef ESPIPE
ADD_ERRNO(WSAESPIPE, "ESPIPE", "Illegal seek")
#endif /* WSAESPIPE && !ESPIPE */
ADD_ERRNO(WSAESPIPE, "WSAESPIPE", "Illegal seek")
#endif /* WSAESPIPE */
#ifdef ESRCDIED
ADD_ERRNO(ESRCDIED, "ESRCDIED", "Source just died (Minix)")
#endif /* ESRCDIED */
#ifdef WSAESRCDIED
#ifndef ESRCDIED
ADD_ERRNO(WSAESRCDIED, "ESRCDIED", "Source just died (Minix)")
#endif /* WSAESRCDIED && !ESRCDIED */
ADD_ERRNO(WSAESRCDIED, "WSAESRCDIED", "Source just died (Minix)")
#endif /* WSAESRCDIED */
#ifdef ESRCH
ADD_ERRNO(ESRCH, "ESRCH", "No such process")
#endif /* ESRCH */
#ifdef WSAESRCH
#ifndef ESRCH
ADD_ERRNO(WSAESRCH, "ESRCH", "No such process")
#endif /* WSAESRCH && !ESRCH */
ADD_ERRNO(WSAESRCH, "WSAESRCH", "No such process")
#endif /* WSAESRCH */
#ifdef ESRMNT
ADD_ERRNO(ESRMNT, "ESRMNT", "Srmount error")
#endif /* ESRMNT */
#ifdef WSAESRMNT
#ifndef ESRMNT
ADD_ERRNO(WSAESRMNT, "ESRMNT", "Srmount error")
#endif /* WSAESRMNT && !ESRMNT */
ADD_ERRNO(WSAESRMNT, "WSAESRMNT", "Srmount error")
#endif /* WSAESRMNT */
#ifdef ESRVRFAULT
ADD_ERRNO(ESRVRFAULT, "ESRVRFAULT", "Server fault on msg pass")
#endif /* ESRVRFAULT */
#ifdef WSAESRVRFAULT
#ifndef ESRVRFAULT
ADD_ERRNO(WSAESRVRFAULT, "ESRVRFAULT", "Server fault on msg pass")
#endif /* WSAESRVRFAULT && !ESRVRFAULT */
ADD_ERRNO(WSAESRVRFAULT, "WSAESRVRFAULT", "Server fault on msg pass")
#endif /* WSAESRVRFAULT */
#ifdef ESTALE
ADD_ERRNO(ESTALE, "ESTALE", "Stale file handle")
#endif /* ESTALE */
#ifdef WSAESTALE
#ifndef ESTALE
ADD_ERRNO(WSAESTALE, "ESTALE", "Stale file handle")
#endif /* WSAESTALE && !ESTALE */
ADD_ERRNO(WSAESTALE, "WSAESTALE", "Stale file handle")
#endif /* WSAESTALE */
#ifdef ESTRPIPE
ADD_ERRNO(ESTRPIPE, "ESTRPIPE", "Streams pipe error")
#endif /* ESTRPIPE */
#ifdef WSAESTRPIPE
#ifndef ESTRPIPE
ADD_ERRNO(WSAESTRPIPE, "ESTRPIPE", "Streams pipe error")
#endif /* WSAESTRPIPE && !ESTRPIPE */
ADD_ERRNO(WSAESTRPIPE, "WSAESTRPIPE", "Streams pipe error")
#endif /* WSAESTRPIPE */
#ifdef ESUCCESS
ADD_ERRNO(ESUCCESS, "ESUCCESS", "No error")
#endif /* ESUCCESS */
#ifdef WSAESUCCESS
#ifndef ESUCCESS
ADD_ERRNO(WSAESUCCESS, "ESUCCESS", "No error")
#endif /* WSAESUCCESS && !ESUCCESS */
ADD_ERRNO(WSAESUCCESS, "WSAESUCCESS", "No error")
#endif /* WSAESUCCESS */
#ifdef ESYSERROR
ADD_ERRNO(ESYSERROR, "ESYSERROR", "")
#endif /* ESYSERROR */
#ifdef WSAESYSERROR
#ifndef ESYSERROR
ADD_ERRNO(WSAESYSERROR, "ESYSERROR", "")
#endif /* WSAESYSERROR && !ESYSERROR */
ADD_ERRNO(WSAESYSERROR, "WSAESYSERROR", "")
#endif /* WSAESYSERROR */
#ifdef ETIME
ADD_ERRNO(ETIME, "ETIME", "STREAM timer expired")
#endif /* ETIME */
#ifdef WSAETIME
#ifndef ETIME
ADD_ERRNO(WSAETIME, "ETIME", "STREAM timer expired")
#endif /* WSAETIME && !ETIME */
ADD_ERRNO(WSAETIME, "WSAETIME", "STREAM timer expired")
#endif /* WSAETIME */
#ifdef ETIMEDOUT
ADD_ERRNO(ETIMEDOUT, "ETIMEDOUT", "Connection timed out")
#endif /* ETIMEDOUT */
#ifdef WSAETIMEDOUT
#ifndef ETIMEDOUT
ADD_ERRNO(WSAETIMEDOUT, "ETIMEDOUT", "Connection timed out")
#endif /* WSAETIMEDOUT && !ETIMEDOUT */
ADD_ERRNO(WSAETIMEDOUT, "WSAETIMEDOUT", "Connection timed out")
#endif /* WSAETIMEDOUT */
#ifdef ETOOMANYREFS
ADD_ERRNO(ETOOMANYREFS, "ETOOMANYREFS", "Too many references: cannot splice")
#endif /* ETOOMANYREFS */
#ifdef WSAETOOMANYREFS
#ifndef ETOOMANYREFS
ADD_ERRNO(WSAETOOMANYREFS, "ETOOMANYREFS", "Too many references: cannot splice")
#endif /* WSAETOOMANYREFS && !ETOOMANYREFS */
ADD_ERRNO(WSAETOOMANYREFS, "WSAETOOMANYREFS", "Too many references: cannot splice")
#endif /* WSAETOOMANYREFS */
#ifdef ETRAPDENIED
ADD_ERRNO(ETRAPDENIED, "ETRAPDENIED", "IPC trap not allowed (Minix)")
#endif /* ETRAPDENIED */
#ifdef WSAETRAPDENIED
#ifndef ETRAPDENIED
ADD_ERRNO(WSAETRAPDENIED, "ETRAPDENIED", "IPC trap not allowed (Minix)")
#endif /* WSAETRAPDENIED && !ETRAPDENIED */
ADD_ERRNO(WSAETRAPDENIED, "WSAETRAPDENIED", "IPC trap not allowed (Minix)")
#endif /* WSAETRAPDENIED */
#ifdef ETXTBSY
ADD_ERRNO(ETXTBSY, "ETXTBSY", "Text file busy")
#endif /* ETXTBSY */
#ifdef WSAETXTBSY
#ifndef ETXTBSY
ADD_ERRNO(WSAETXTBSY, "ETXTBSY", "Text file busy")
#endif /* WSAETXTBSY && !ETXTBSY */
ADD_ERRNO(WSAETXTBSY, "WSAETXTBSY", "Text file busy")
#endif /* WSAETXTBSY */
#ifdef EUCLEAN
ADD_ERRNO(EUCLEAN, "EUCLEAN", "Structure needs cleaning")
#endif /* EUCLEAN */
#ifdef WSAEUCLEAN
#ifndef EUCLEAN
ADD_ERRNO(WSAEUCLEAN, "EUCLEAN", "Structure needs cleaning")
#endif /* WSAEUCLEAN && !EUCLEAN */
ADD_ERRNO(WSAEUCLEAN, "WSAEUCLEAN", "Structure needs cleaning")
#endif /* WSAEUCLEAN */
#ifdef EUNATCH
ADD_ERRNO(EUNATCH, "EUNATCH", "Protocol driver not attached")
#endif /* EUNATCH */
#ifdef WSAEUNATCH
#ifndef EUNATCH
ADD_ERRNO(WSAEUNATCH, "EUNATCH", "Protocol driver not attached")
#endif /* WSAEUNATCH && !EUNATCH */
ADD_ERRNO(WSAEUNATCH, "WSAEUNATCH", "Protocol driver not attached")
#endif /* WSAEUNATCH */
#ifdef EURG
ADD_ERRNO(EURG, "EURG", "Urgent data present (Minix)")
#endif /* EURG */
#ifdef WSAEURG
#ifndef EURG
ADD_ERRNO(WSAEURG, "EURG", "Urgent data present (Minix)")
#endif /* WSAEURG && !EURG */
ADD_ERRNO(WSAEURG, "WSAEURG", "Urgent data present (Minix)")
#endif /* WSAEURG */
#ifdef EUSERS
ADD_ERRNO(EUSERS, "EUSERS", "Too many users")
#endif /* EUSERS */
#ifdef WSAEUSERS
#ifndef EUSERS
ADD_ERRNO(WSAEUSERS, "EUSERS", "Too many users")
#endif /* WSAEUSERS && !EUSERS */
ADD_ERRNO(WSAEUSERS, "WSAEUSERS", "Too many users")
#endif /* WSAEUSERS */
#ifdef EVERSION
ADD_ERRNO(EVERSION, "EVERSION", "Version number mismatch")
#endif /* EVERSION */
#ifdef WSAEVERSION
#ifndef EVERSION
ADD_ERRNO(WSAEVERSION, "EVERSION", "Version number mismatch")
#endif /* WSAEVERSION && !EVERSION */
ADD_ERRNO(WSAEVERSION, "WSAEVERSION", "Version number mismatch")
#endif /* WSAEVERSION */
#ifdef EWOULDBLOCK
ADD_ERRNO(EWOULDBLOCK, "EWOULDBLOCK", "Operation would block")
#endif /* EWOULDBLOCK */
#ifdef WSAEWOULDBLOCK
#ifndef EWOULDBLOCK
ADD_ERRNO(WSAEWOULDBLOCK, "EWOULDBLOCK", "Operation would block")
#endif /* WSAEWOULDBLOCK && !EWOULDBLOCK */
ADD_ERRNO(WSAEWOULDBLOCK, "WSAEWOULDBLOCK", "Operation would block")
#endif /* WSAEWOULDBLOCK */
#ifdef EWRONGFS
ADD_ERRNO(EWRONGFS, "EWRONGFS", "")
#endif /* EWRONGFS */
#ifdef WSAEWRONGFS
#ifndef EWRONGFS
ADD_ERRNO(WSAEWRONGFS, "EWRONGFS", "")
#endif /* WSAEWRONGFS && !EWRONGFS */
ADD_ERRNO(WSAEWRONGFS, "WSAEWRONGFS", "")
#endif /* WSAEWRONGFS */
#ifdef EWRPROTECT
ADD_ERRNO(EWRPROTECT, "EWRPROTECT", "Write-protected media")
#endif /* EWRPROTECT */
#ifdef WSAEWRPROTECT
#ifndef EWRPROTECT
ADD_ERRNO(WSAEWRPROTECT, "EWRPROTECT", "Write-protected media")
#endif /* WSAEWRPROTECT && !EWRPROTECT */
ADD_ERRNO(WSAEWRPROTECT, "WSAEWRPROTECT", "Write-protected media")
#endif /* WSAEWRPROTECT */
#ifdef EXDEV
ADD_ERRNO(EXDEV, "EXDEV", "Cross-device link")
#endif /* EXDEV */
#ifdef WSAEXDEV
#ifndef EXDEV
ADD_ERRNO(WSAEXDEV, "EXDEV", "Cross-device link")
#endif /* WSAEXDEV && !EXDEV */
ADD_ERRNO(WSAEXDEV, "WSAEXDEV", "Cross-device link")
#endif /* WSAEXDEV */
#ifdef EXFULL
ADD_ERRNO(EXFULL, "EXFULL", "Exchange full")
#endif /* EXFULL */
#ifdef WSAEXFULL
#ifndef EXFULL
ADD_ERRNO(WSAEXFULL, "EXFULL", "Exchange full")
#endif /* WSAEXFULL && !EXFULL */
ADD_ERRNO(WSAEXFULL, "WSAEXFULL", "Exchange full")
#endif /* WSAEXFULL */

/* Endmarkers: */
#ifdef ELAST
ADD_ERRNO(ELAST, "ELAST", "")
#endif /* ELAST */
#ifdef WSAELAST
#ifndef ELAST
ADD_ERRNO(WSAELAST, "ELAST", "")
#endif /* WSAELAST && !ELAST */
ADD_ERRNO(WSAELAST, "WSAELAST", "")
#endif /* WSAELAST */
#ifdef LASTERRNO
ADD_ERRNO(LASTERRNO, "LASTERRNO", "")
#endif /* LASTERRNO */
